#include "string"
namespace gbe {
std::string ocl_stdlib_str = 
"/*\n"
" * Copyright © 2012 Intel Corporation\n"
" *\n"
" * This library is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2 of the License, or (at your option) any later version.\n"
" *\n"
" * This library is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with this library. If not, see <http://www.gnu.org/licenses/>.\n"
" *\n"
" * Author: Benjamin Segovia <benjamin.segovia@intel.com>\n"
" */\n"
"\n"
"#ifndef __GEN_OCL_STDLIB_H__\n"
"#define __GEN_OCL_STDLIB_H__\n"
"\n"
"#define INLINE inline __attribute__((always_inline))\n"
"#define OVERLOADABLE __attribute__((overloadable))\n"
"#define PURE __attribute__((pure))\n"
"#define CONST __attribute__((const))\n"
"#define INLINE_OVERLOADABLE inline __attribute__((overloadable,always_inline))\n"
"// FIXME, clang's opencl FE doesn't support static.\n"
"#define static\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL built-in scalar data types\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"typedef unsigned char uchar;\n"
"typedef unsigned short ushort;\n"
"typedef unsigned int uint;\n"
"typedef unsigned long ulong;\n"
"typedef __typeof__(sizeof(int)) size_t;\n"
"typedef __typeof__((int *)0-(int *)0) ptrdiff_t;\n"
"typedef signed int intptr_t;\n"
"typedef unsigned int uintptr_t;\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL address space\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// These are built-ins in LLVM 3.3.\n"
"#if 100*__clang_major__ + __clang_minor__ <= 302\n"
"#define __private __attribute__((address_space(0)))\n"
"#define __global __attribute__((address_space(1)))\n"
"#define __constant __attribute__((address_space(2)))\n"
"#define __local __attribute__((address_space(3)))\n"
"#define global __global\n"
"#define local __local\n"
"#define constant __constant\n"
"#define private __private\n"
"#endif\n"
"\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL built-in vector data types\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"#define DEF(type) typedef type type##2 __attribute__((ext_vector_type(2)));\\\n"
"                  typedef type type##3 __attribute__((ext_vector_type(3)));\\\n"
"                  typedef type type##4 __attribute__((ext_vector_type(4)));\\\n"
"                  typedef type type##8 __attribute__((ext_vector_type(8)));\\\n"
"                  typedef type type##16 __attribute__((ext_vector_type(16)));\n"
"DEF(char);\n"
"DEF(uchar);\n"
"DEF(short);\n"
"DEF(ushort);\n"
"DEF(int);\n"
"DEF(uint);\n"
"DEF(long);\n"
"DEF(ulong);\n"
"DEF(float);\n"
"DEF(double);\n"
"#undef DEF\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL other built-in data types\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// FIXME:\n"
"// This is a transitional hack to bypass the LLVM 3.3 built-in types.\n"
"// See the Khronos SPIR specification for handling of these types.\n"
"#define __texture __attribute__((address_space(4)))\n"
"struct _image1d_t;\n"
"typedef __texture struct _image1d_t* __image1d_t;\n"
"struct _image1d_buffer_t;\n"
"typedef __texture struct _image1d_buffer_t* __image1d_buffer_t;\n"
"struct _image1d_array_t;\n"
"typedef __texture struct _image1d_array_t* __image1d_array_t;\n"
"struct _image2d_t;\n"
"typedef __texture struct _image2d_t* __image2d_t;\n"
"struct _image2d_array_t;\n"
"typedef __texture struct _image2d_array_t* __image2d_array_t;\n"
"struct _image3d_t;\n"
"typedef __texture struct _image3d_t* __image3d_t;\n"
"typedef const ushort __sampler_t;\n"
"typedef size_t __event_t;\n"
"#define image1d_t __image1d_t\n"
"#define image1d_buffer_t __image1d_buffer_t\n"
"#define image1d_array_t __image1d_array_t\n"
"#define image2d_t __image2d_t\n"
"#define image2d_array_t __image2d_array_t\n"
"#define image3d_t __image3d_t\n"
"#define sampler_t __sampler_t\n"
"#define event_t __event_t\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL conversions & type casting\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"\n"
"// ##BEGIN_AS##\n"
"union _type_cast_1_b {\n"
"  char _char;\n"
"  uchar _uchar;\n"
"};\n"
"\n"
"INLINE OVERLOADABLE uchar as_uchar(char v) {\n"
"  union _type_cast_1_b u;\n"
"  u._char = v;\n"
"  return u._uchar;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char as_char(uchar v) {\n"
"  union _type_cast_1_b u;\n"
"  u._uchar = v;\n"
"  return u._char;\n"
"}\n"
"\n"
"union _type_cast_2_b {\n"
"  short _short;\n"
"  ushort _ushort;\n"
"  char2 _char2;\n"
"  uchar2 _uchar2;\n"
"};\n"
"\n"
"INLINE OVERLOADABLE ushort as_ushort(short v) {\n"
"  union _type_cast_2_b u;\n"
"  u._short = v;\n"
"  return u._ushort;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 as_char2(short v) {\n"
"  union _type_cast_2_b u;\n"
"  u._short = v;\n"
"  return u._char2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 as_uchar2(short v) {\n"
"  union _type_cast_2_b u;\n"
"  u._short = v;\n"
"  return u._uchar2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short as_short(ushort v) {\n"
"  union _type_cast_2_b u;\n"
"  u._ushort = v;\n"
"  return u._short;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 as_char2(ushort v) {\n"
"  union _type_cast_2_b u;\n"
"  u._ushort = v;\n"
"  return u._char2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 as_uchar2(ushort v) {\n"
"  union _type_cast_2_b u;\n"
"  u._ushort = v;\n"
"  return u._uchar2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short as_short(char2 v) {\n"
"  union _type_cast_2_b u;\n"
"  u._char2 = v;\n"
"  return u._short;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort as_ushort(char2 v) {\n"
"  union _type_cast_2_b u;\n"
"  u._char2 = v;\n"
"  return u._ushort;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 as_uchar2(char2 v) {\n"
"  union _type_cast_2_b u;\n"
"  u._char2 = v;\n"
"  return u._uchar2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short as_short(uchar2 v) {\n"
"  union _type_cast_2_b u;\n"
"  u._uchar2 = v;\n"
"  return u._short;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort as_ushort(uchar2 v) {\n"
"  union _type_cast_2_b u;\n"
"  u._uchar2 = v;\n"
"  return u._ushort;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 as_char2(uchar2 v) {\n"
"  union _type_cast_2_b u;\n"
"  u._uchar2 = v;\n"
"  return u._char2;\n"
"}\n"
"\n"
"union _type_cast_4_b {\n"
"  int _int;\n"
"  uint _uint;\n"
"  short2 _short2;\n"
"  ushort2 _ushort2;\n"
"  char3 _char3;\n"
"  char4 _char4;\n"
"  uchar3 _uchar3;\n"
"  uchar4 _uchar4;\n"
"  float _float;\n"
"};\n"
"\n"
"INLINE OVERLOADABLE uint as_uint(int v) {\n"
"  union _type_cast_4_b u;\n"
"  u._int = v;\n"
"  return u._uint;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 as_short2(int v) {\n"
"  union _type_cast_4_b u;\n"
"  u._int = v;\n"
"  return u._short2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 as_ushort2(int v) {\n"
"  union _type_cast_4_b u;\n"
"  u._int = v;\n"
"  return u._ushort2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 as_char3(int v) {\n"
"  union _type_cast_4_b u;\n"
"  u._int = v;\n"
"  return u._char3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 as_char4(int v) {\n"
"  union _type_cast_4_b u;\n"
"  u._int = v;\n"
"  return u._char4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 as_uchar3(int v) {\n"
"  union _type_cast_4_b u;\n"
"  u._int = v;\n"
"  return u._uchar3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 as_uchar4(int v) {\n"
"  union _type_cast_4_b u;\n"
"  u._int = v;\n"
"  return u._uchar4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float as_float(int v) {\n"
"  union _type_cast_4_b u;\n"
"  u._int = v;\n"
"  return u._float;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int as_int(uint v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uint = v;\n"
"  return u._int;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 as_short2(uint v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uint = v;\n"
"  return u._short2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 as_ushort2(uint v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uint = v;\n"
"  return u._ushort2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 as_char3(uint v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uint = v;\n"
"  return u._char3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 as_char4(uint v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uint = v;\n"
"  return u._char4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 as_uchar3(uint v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uint = v;\n"
"  return u._uchar3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 as_uchar4(uint v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uint = v;\n"
"  return u._uchar4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float as_float(uint v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uint = v;\n"
"  return u._float;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int as_int(short2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._short2 = v;\n"
"  return u._int;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint as_uint(short2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._short2 = v;\n"
"  return u._uint;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 as_ushort2(short2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._short2 = v;\n"
"  return u._ushort2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 as_char3(short2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._short2 = v;\n"
"  return u._char3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 as_char4(short2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._short2 = v;\n"
"  return u._char4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 as_uchar3(short2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._short2 = v;\n"
"  return u._uchar3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 as_uchar4(short2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._short2 = v;\n"
"  return u._uchar4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float as_float(short2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._short2 = v;\n"
"  return u._float;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int as_int(ushort2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._ushort2 = v;\n"
"  return u._int;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint as_uint(ushort2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._ushort2 = v;\n"
"  return u._uint;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 as_short2(ushort2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._ushort2 = v;\n"
"  return u._short2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 as_char3(ushort2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._ushort2 = v;\n"
"  return u._char3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 as_char4(ushort2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._ushort2 = v;\n"
"  return u._char4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 as_uchar3(ushort2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._ushort2 = v;\n"
"  return u._uchar3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 as_uchar4(ushort2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._ushort2 = v;\n"
"  return u._uchar4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float as_float(ushort2 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._ushort2 = v;\n"
"  return u._float;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int as_int(char3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char3 = v;\n"
"  return u._int;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint as_uint(char3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char3 = v;\n"
"  return u._uint;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 as_short2(char3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char3 = v;\n"
"  return u._short2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 as_ushort2(char3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char3 = v;\n"
"  return u._ushort2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 as_uchar3(char3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char3 = v;\n"
"  return u._uchar3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 as_uchar4(char3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char3 = v;\n"
"  return u._uchar4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float as_float(char3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char3 = v;\n"
"  return u._float;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int as_int(char4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char4 = v;\n"
"  return u._int;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint as_uint(char4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char4 = v;\n"
"  return u._uint;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 as_short2(char4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char4 = v;\n"
"  return u._short2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 as_ushort2(char4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char4 = v;\n"
"  return u._ushort2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 as_uchar3(char4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char4 = v;\n"
"  return u._uchar3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 as_uchar4(char4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char4 = v;\n"
"  return u._uchar4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float as_float(char4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._char4 = v;\n"
"  return u._float;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int as_int(uchar3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar3 = v;\n"
"  return u._int;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint as_uint(uchar3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar3 = v;\n"
"  return u._uint;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 as_short2(uchar3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar3 = v;\n"
"  return u._short2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 as_ushort2(uchar3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar3 = v;\n"
"  return u._ushort2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 as_char3(uchar3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar3 = v;\n"
"  return u._char3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 as_char4(uchar3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar3 = v;\n"
"  return u._char4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float as_float(uchar3 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar3 = v;\n"
"  return u._float;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int as_int(uchar4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar4 = v;\n"
"  return u._int;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint as_uint(uchar4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar4 = v;\n"
"  return u._uint;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 as_short2(uchar4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar4 = v;\n"
"  return u._short2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 as_ushort2(uchar4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar4 = v;\n"
"  return u._ushort2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 as_char3(uchar4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar4 = v;\n"
"  return u._char3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 as_char4(uchar4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar4 = v;\n"
"  return u._char4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float as_float(uchar4 v) {\n"
"  union _type_cast_4_b u;\n"
"  u._uchar4 = v;\n"
"  return u._float;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int as_int(float v) {\n"
"  union _type_cast_4_b u;\n"
"  u._float = v;\n"
"  return u._int;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint as_uint(float v) {\n"
"  union _type_cast_4_b u;\n"
"  u._float = v;\n"
"  return u._uint;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 as_short2(float v) {\n"
"  union _type_cast_4_b u;\n"
"  u._float = v;\n"
"  return u._short2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 as_ushort2(float v) {\n"
"  union _type_cast_4_b u;\n"
"  u._float = v;\n"
"  return u._ushort2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 as_char3(float v) {\n"
"  union _type_cast_4_b u;\n"
"  u._float = v;\n"
"  return u._char3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 as_char4(float v) {\n"
"  union _type_cast_4_b u;\n"
"  u._float = v;\n"
"  return u._char4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 as_uchar3(float v) {\n"
"  union _type_cast_4_b u;\n"
"  u._float = v;\n"
"  return u._uchar3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 as_uchar4(float v) {\n"
"  union _type_cast_4_b u;\n"
"  u._float = v;\n"
"  return u._uchar4;\n"
"}\n"
"\n"
"union _type_cast_8_b {\n"
"  long _long;\n"
"  ulong _ulong;\n"
"  int2 _int2;\n"
"  uint2 _uint2;\n"
"  short3 _short3;\n"
"  short4 _short4;\n"
"  ushort3 _ushort3;\n"
"  ushort4 _ushort4;\n"
"  char8 _char8;\n"
"  uchar8 _uchar8;\n"
"  double _double;\n"
"  float2 _float2;\n"
"};\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(long v) {\n"
"  union _type_cast_8_b u;\n"
"  u._long = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(ulong v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ulong = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(int2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._int2 = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(uint2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uint2 = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(short3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short3 = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(short4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._short4 = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(ushort3 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort3 = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(ushort4 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._ushort4 = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(char8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._char8 = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(uchar8 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._uchar8 = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 as_float2(double v) {\n"
"  union _type_cast_8_b u;\n"
"  u._double = v;\n"
"  return u._float2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long as_long(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._long;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong as_ulong(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._ulong;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 as_int2(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._int2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 as_uint2(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._uint2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 as_short3(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._short3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 as_short4(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._short4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 as_ushort3(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._ushort3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 as_ushort4(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._ushort4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 as_char8(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._char8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 as_uchar8(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._uchar8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double as_double(float2 v) {\n"
"  union _type_cast_8_b u;\n"
"  u._float2 = v;\n"
"  return u._double;\n"
"}\n"
"\n"
"union _type_cast_16_b {\n"
"  long2 _long2;\n"
"  ulong2 _ulong2;\n"
"  int3 _int3;\n"
"  int4 _int4;\n"
"  uint3 _uint3;\n"
"  uint4 _uint4;\n"
"  short8 _short8;\n"
"  ushort8 _ushort8;\n"
"  char16 _char16;\n"
"  uchar16 _uchar16;\n"
"  double2 _double2;\n"
"  float3 _float3;\n"
"  float4 _float4;\n"
"};\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(long2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._long2 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(ulong2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ulong2 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(int3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int3 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(int4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._int4 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(uint3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint3 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(uint4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uint4 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(short8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._short8 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(ushort8 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._ushort8 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(char16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._char16 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(uchar16 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._uchar16 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 as_float3(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._float3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 as_float4(double2 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._double2 = v;\n"
"  return u._float4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(float3 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float3 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 as_long2(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._long2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 as_ulong2(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._ulong2;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 as_int3(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._int3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 as_int4(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._int4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 as_uint3(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._uint3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 as_uint4(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._uint4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 as_short8(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._short8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 as_ushort8(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._ushort8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 as_char16(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._char16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 as_uchar16(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._uchar16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 as_double2(float4 v) {\n"
"  union _type_cast_16_b u;\n"
"  u._float4 = v;\n"
"  return u._double2;\n"
"}\n"
"\n"
"union _type_cast_32_b {\n"
"  long3 _long3;\n"
"  long4 _long4;\n"
"  ulong3 _ulong3;\n"
"  ulong4 _ulong4;\n"
"  int8 _int8;\n"
"  uint8 _uint8;\n"
"  short16 _short16;\n"
"  ushort16 _ushort16;\n"
"  double3 _double3;\n"
"  double4 _double4;\n"
"  float8 _float8;\n"
"};\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(long3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long3 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(long4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._long4 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(ulong3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong3 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(ulong4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ulong4 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(int8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._int8 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(uint8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._uint8 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(short16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._short16 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(ushort16 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._ushort16 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(double3 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double3 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 as_float8(double4 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._double4 = v;\n"
"  return u._float8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 as_long3(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._long3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 as_long4(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._long4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 as_ulong3(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._ulong3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 as_ulong4(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._ulong4;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 as_int8(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._int8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 as_uint8(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._uint8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 as_short16(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._short16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 as_ushort16(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._ushort16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 as_double3(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._double3;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 as_double4(float8 v) {\n"
"  union _type_cast_32_b u;\n"
"  u._float8 = v;\n"
"  return u._double4;\n"
"}\n"
"\n"
"union _type_cast_64_b {\n"
"  long8 _long8;\n"
"  ulong8 _ulong8;\n"
"  int16 _int16;\n"
"  uint16 _uint16;\n"
"  double8 _double8;\n"
"  float16 _float16;\n"
"};\n"
"\n"
"INLINE OVERLOADABLE ulong8 as_ulong8(long8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._long8 = v;\n"
"  return u._ulong8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 as_int16(long8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._long8 = v;\n"
"  return u._int16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 as_uint16(long8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._long8 = v;\n"
"  return u._uint16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 as_double8(long8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._long8 = v;\n"
"  return u._double8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 as_float16(long8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._long8 = v;\n"
"  return u._float16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 as_long8(ulong8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._ulong8 = v;\n"
"  return u._long8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 as_int16(ulong8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._ulong8 = v;\n"
"  return u._int16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 as_uint16(ulong8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._ulong8 = v;\n"
"  return u._uint16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 as_double8(ulong8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._ulong8 = v;\n"
"  return u._double8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 as_float16(ulong8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._ulong8 = v;\n"
"  return u._float16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 as_long8(int16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._int16 = v;\n"
"  return u._long8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 as_ulong8(int16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._int16 = v;\n"
"  return u._ulong8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 as_uint16(int16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._int16 = v;\n"
"  return u._uint16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 as_double8(int16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._int16 = v;\n"
"  return u._double8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 as_float16(int16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._int16 = v;\n"
"  return u._float16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 as_long8(uint16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._uint16 = v;\n"
"  return u._long8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 as_ulong8(uint16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._uint16 = v;\n"
"  return u._ulong8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 as_int16(uint16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._uint16 = v;\n"
"  return u._int16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 as_double8(uint16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._uint16 = v;\n"
"  return u._double8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 as_float16(uint16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._uint16 = v;\n"
"  return u._float16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 as_long8(double8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._double8 = v;\n"
"  return u._long8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 as_ulong8(double8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._double8 = v;\n"
"  return u._ulong8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 as_int16(double8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._double8 = v;\n"
"  return u._int16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 as_uint16(double8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._double8 = v;\n"
"  return u._uint16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 as_float16(double8 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._double8 = v;\n"
"  return u._float16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 as_long8(float16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._float16 = v;\n"
"  return u._long8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 as_ulong8(float16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._float16 = v;\n"
"  return u._ulong8;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 as_int16(float16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._float16 = v;\n"
"  return u._int16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 as_uint16(float16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._float16 = v;\n"
"  return u._uint16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 as_double8(float16 v) {\n"
"  union _type_cast_64_b u;\n"
"  u._float16 = v;\n"
"  return u._double8;\n"
"}\n"
"\n"
"union _type_cast_128_b {\n"
"  long16 _long16;\n"
"  ulong16 _ulong16;\n"
"  double16 _double16;\n"
"};\n"
"\n"
"INLINE OVERLOADABLE ulong16 as_ulong16(long16 v) {\n"
"  union _type_cast_128_b u;\n"
"  u._long16 = v;\n"
"  return u._ulong16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 as_double16(long16 v) {\n"
"  union _type_cast_128_b u;\n"
"  u._long16 = v;\n"
"  return u._double16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 as_long16(ulong16 v) {\n"
"  union _type_cast_128_b u;\n"
"  u._ulong16 = v;\n"
"  return u._long16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 as_double16(ulong16 v) {\n"
"  union _type_cast_128_b u;\n"
"  u._ulong16 = v;\n"
"  return u._double16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 as_long16(double16 v) {\n"
"  union _type_cast_128_b u;\n"
"  u._double16 = v;\n"
"  return u._long16;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 as_ulong16(double16 v) {\n"
"  union _type_cast_128_b u;\n"
"  u._double16 = v;\n"
"  return u._ulong16;\n"
"}\n"
"\n"
"// ##END_AS##\n"
"\n"
"// ##BEGIN_CONVERT##\n"
"INLINE OVERLOADABLE long convert_long(long v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(long v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(long v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(long v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(long v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(long v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(long v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(long v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(long v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(long v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(ulong v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(ulong v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(ulong v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(ulong v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(ulong v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(ulong v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(ulong v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(ulong v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(ulong v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(ulong v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(int v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(int v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(int v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(int v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(int v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(int v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(int v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(int v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(int v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(int v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(uint v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(uint v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(uint v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(uint v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(uint v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(uint v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(uint v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(uint v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(uint v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(uint v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(short v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(short v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(short v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(short v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(short v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(short v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(short v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(short v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(short v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(short v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(ushort v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(ushort v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(ushort v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(ushort v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(ushort v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(ushort v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(ushort v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(ushort v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(ushort v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(ushort v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(char v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(char v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(char v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(char v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(char v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(char v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(char v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(char v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(char v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(char v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(uchar v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(uchar v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(uchar v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(uchar v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(uchar v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(uchar v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(uchar v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(uchar v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(uchar v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(uchar v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(double v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(double v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(double v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(double v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(double v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(double v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(double v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(double v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(double v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(double v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long convert_long(float v) {\n"
"  return (long)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong convert_ulong(float v) {\n"
"  return (ulong)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int convert_int(float v) {\n"
"  return (int)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint convert_uint(float v) {\n"
"  return (uint)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short convert_short(float v) {\n"
"  return (short)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort convert_ushort(float v) {\n"
"  return (ushort)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char convert_char(float v) {\n"
"  return (char)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar convert_uchar(float v) {\n"
"  return (uchar)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double convert_double(float v) {\n"
"  return (double)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float convert_float(float v) {\n"
"  return (float)v;\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(long2 v) { return v; }\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(long2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(long2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(long2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(long2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(long2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(long2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(long2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(long2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(long2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(ulong2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(ulong2 v) { return v; }\n"
"INLINE OVERLOADABLE int2 convert_int2(ulong2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(ulong2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(ulong2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(ulong2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(ulong2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(ulong2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(ulong2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(ulong2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(int2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(int2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(int2 v) { return v; }\n"
"INLINE OVERLOADABLE uint2 convert_uint2(int2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(int2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(int2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(int2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(int2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(int2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(int2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(uint2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(uint2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(uint2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(uint2 v) { return v; }\n"
"INLINE OVERLOADABLE short2 convert_short2(uint2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(uint2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(uint2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(uint2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(uint2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(uint2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(short2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(short2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(short2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(short2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(short2 v) { return v; }\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(short2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(short2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(short2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(short2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(short2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(ushort2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(ushort2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(ushort2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(ushort2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(ushort2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(ushort2 v) { return v; }\n"
"INLINE OVERLOADABLE char2 convert_char2(ushort2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(ushort2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(ushort2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(ushort2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(char2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(char2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(char2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(char2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(char2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(char2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(char2 v) { return v; }\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(char2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(char2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(char2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(uchar2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(uchar2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(uchar2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(uchar2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(uchar2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(uchar2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(uchar2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(uchar2 v) { return v; }\n"
"INLINE OVERLOADABLE double2 convert_double2(uchar2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(uchar2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(double2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(double2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(double2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(double2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(double2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(double2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(double2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(double2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(double2 v) { return v; }\n"
"INLINE OVERLOADABLE float2 convert_float2(double2 v) {\n"
"  return (float2)((float)(v.s0), (float)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2(float2 v) {\n"
"  return (long2)((long)(v.s0), (long)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2(float2 v) {\n"
"  return (ulong2)((ulong)(v.s0), (ulong)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2(float2 v) {\n"
"  return (int2)((int)(v.s0), (int)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2(float2 v) {\n"
"  return (uint2)((uint)(v.s0), (uint)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2(float2 v) {\n"
"  return (short2)((short)(v.s0), (short)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2(float2 v) {\n"
"  return (ushort2)((ushort)(v.s0), (ushort)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2(float2 v) {\n"
"  return (char2)((char)(v.s0), (char)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2(float2 v) {\n"
"  return (uchar2)((uchar)(v.s0), (uchar)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double2 convert_double2(float2 v) {\n"
"  return (double2)((double)(v.s0), (double)(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2(float2 v) { return v; }\n"
"INLINE OVERLOADABLE long3 convert_long3(long3 v) { return v; }\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(long3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(long3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(long3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(long3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(long3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(long3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(long3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(long3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(long3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(ulong3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(ulong3 v) { return v; }\n"
"INLINE OVERLOADABLE int3 convert_int3(ulong3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(ulong3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(ulong3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(ulong3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(ulong3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(ulong3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(ulong3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(ulong3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(int3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(int3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(int3 v) { return v; }\n"
"INLINE OVERLOADABLE uint3 convert_uint3(int3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(int3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(int3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(int3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(int3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(int3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(int3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(uint3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(uint3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(uint3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(uint3 v) { return v; }\n"
"INLINE OVERLOADABLE short3 convert_short3(uint3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(uint3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(uint3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(uint3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(uint3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(uint3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(short3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(short3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(short3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(short3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(short3 v) { return v; }\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(short3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(short3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(short3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(short3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(short3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(ushort3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(ushort3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(ushort3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(ushort3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(ushort3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(ushort3 v) { return v; }\n"
"INLINE OVERLOADABLE char3 convert_char3(ushort3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(ushort3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(ushort3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(ushort3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(char3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(char3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(char3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(char3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(char3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(char3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(char3 v) { return v; }\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(char3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(char3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(char3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(uchar3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(uchar3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(uchar3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(uchar3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(uchar3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(uchar3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(uchar3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(uchar3 v) { return v; }\n"
"INLINE OVERLOADABLE double3 convert_double3(uchar3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(uchar3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(double3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(double3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(double3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(double3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(double3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(double3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(double3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(double3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(double3 v) { return v; }\n"
"INLINE OVERLOADABLE float3 convert_float3(double3 v) {\n"
"  return (float3)((float)(v.s0), (float)(v.s1), (float)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3(float3 v) {\n"
"  return (long3)((long)(v.s0), (long)(v.s1), (long)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3(float3 v) {\n"
"  return (ulong3)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3(float3 v) {\n"
"  return (int3)((int)(v.s0), (int)(v.s1), (int)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3(float3 v) {\n"
"  return (uint3)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3(float3 v) {\n"
"  return (short3)((short)(v.s0), (short)(v.s1), (short)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3(float3 v) {\n"
"  return (ushort3)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3(float3 v) {\n"
"  return (char3)((char)(v.s0), (char)(v.s1), (char)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3(float3 v) {\n"
"  return (uchar3)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double3 convert_double3(float3 v) {\n"
"  return (double3)((double)(v.s0), (double)(v.s1), (double)(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3(float3 v) { return v; }\n"
"INLINE OVERLOADABLE long4 convert_long4(long4 v) { return v; }\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(long4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(long4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(long4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(long4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(long4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(long4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(long4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(long4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(long4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(ulong4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(ulong4 v) { return v; }\n"
"INLINE OVERLOADABLE int4 convert_int4(ulong4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(ulong4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(ulong4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(ulong4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(ulong4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(ulong4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(ulong4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(ulong4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(int4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(int4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(int4 v) { return v; }\n"
"INLINE OVERLOADABLE uint4 convert_uint4(int4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(int4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(int4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(int4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(int4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(int4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(int4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(uint4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(uint4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(uint4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(uint4 v) { return v; }\n"
"INLINE OVERLOADABLE short4 convert_short4(uint4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(uint4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(uint4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(uint4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(uint4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(uint4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(short4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(short4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(short4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(short4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(short4 v) { return v; }\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(short4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(short4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(short4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(short4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(short4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(ushort4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(ushort4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(ushort4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(ushort4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(ushort4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(ushort4 v) { return v; }\n"
"INLINE OVERLOADABLE char4 convert_char4(ushort4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(ushort4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(ushort4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(ushort4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(char4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(char4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(char4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(char4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(char4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(char4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(char4 v) { return v; }\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(char4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(char4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(char4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(uchar4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(uchar4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(uchar4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(uchar4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(uchar4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(uchar4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(uchar4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(uchar4 v) { return v; }\n"
"INLINE OVERLOADABLE double4 convert_double4(uchar4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(uchar4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(double4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(double4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(double4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(double4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(double4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(double4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(double4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(double4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(double4 v) { return v; }\n"
"INLINE OVERLOADABLE float4 convert_float4(double4 v) {\n"
"  return (float4)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4(float4 v) {\n"
"  return (long4)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4(float4 v) {\n"
"  return (ulong4)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4(float4 v) {\n"
"  return (int4)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4(float4 v) {\n"
"  return (uint4)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4(float4 v) {\n"
"  return (short4)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4(float4 v) {\n"
"  return (ushort4)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4(float4 v) {\n"
"  return (char4)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4(float4 v) {\n"
"  return (uchar4)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double4 convert_double4(float4 v) {\n"
"  return (double4)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4(float4 v) { return v; }\n"
"INLINE OVERLOADABLE long8 convert_long8(long8 v) { return v; }\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(long8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(long8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(long8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(long8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(long8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(long8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(long8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(long8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(long8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(ulong8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(ulong8 v) { return v; }\n"
"INLINE OVERLOADABLE int8 convert_int8(ulong8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(ulong8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(ulong8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(ulong8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(ulong8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(ulong8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(ulong8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(ulong8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(int8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(int8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(int8 v) { return v; }\n"
"INLINE OVERLOADABLE uint8 convert_uint8(int8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(int8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(int8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(int8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(int8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(int8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(int8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(uint8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(uint8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(uint8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(uint8 v) { return v; }\n"
"INLINE OVERLOADABLE short8 convert_short8(uint8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(uint8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(uint8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(uint8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(uint8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(uint8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(short8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(short8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(short8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(short8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(short8 v) { return v; }\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(short8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(short8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(short8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(short8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(short8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(ushort8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(ushort8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(ushort8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(ushort8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(ushort8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(ushort8 v) { return v; }\n"
"INLINE OVERLOADABLE char8 convert_char8(ushort8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(ushort8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(ushort8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(ushort8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(char8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(char8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(char8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(char8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(char8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(char8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(char8 v) { return v; }\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(char8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(char8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(char8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(uchar8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(uchar8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(uchar8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(uchar8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(uchar8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(uchar8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(uchar8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(uchar8 v) { return v; }\n"
"INLINE OVERLOADABLE double8 convert_double8(uchar8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(uchar8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(double8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(double8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(double8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(double8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(double8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(double8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(double8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(double8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(double8 v) { return v; }\n"
"INLINE OVERLOADABLE float8 convert_float8(double8 v) {\n"
"  return (float8)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8(float8 v) {\n"
"  return (long8)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8(float8 v) {\n"
"  return (ulong8)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8(float8 v) {\n"
"  return (int8)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8(float8 v) {\n"
"  return (uint8)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8(float8 v) {\n"
"  return (short8)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8(float8 v) {\n"
"  return (ushort8)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8(float8 v) {\n"
"  return (char8)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8(float8 v) {\n"
"  return (uchar8)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double8 convert_double8(float8 v) {\n"
"  return (double8)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8(float8 v) { return v; }\n"
"INLINE OVERLOADABLE long16 convert_long16(long16 v) { return v; }\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(long16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(long16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(long16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(long16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(long16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(long16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(long16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(long16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(long16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(ulong16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(ulong16 v) { return v; }\n"
"INLINE OVERLOADABLE int16 convert_int16(ulong16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(ulong16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(ulong16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(ulong16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(ulong16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(ulong16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(ulong16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(ulong16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(int16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(int16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(int16 v) { return v; }\n"
"INLINE OVERLOADABLE uint16 convert_uint16(int16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(int16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(int16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(int16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(int16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(int16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(int16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(uint16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(uint16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(uint16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(uint16 v) { return v; }\n"
"INLINE OVERLOADABLE short16 convert_short16(uint16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(uint16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(uint16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(uint16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(uint16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(uint16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(short16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(short16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(short16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(short16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(short16 v) { return v; }\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(short16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(short16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(short16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(short16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(short16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(ushort16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(ushort16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(ushort16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(ushort16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(ushort16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(ushort16 v) { return v; }\n"
"INLINE OVERLOADABLE char16 convert_char16(ushort16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(ushort16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(ushort16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(ushort16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(char16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(char16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(char16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(char16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(char16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(char16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(char16 v) { return v; }\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(char16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(char16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(char16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(uchar16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(uchar16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(uchar16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(uchar16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(uchar16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(uchar16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(uchar16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(uchar16 v) { return v; }\n"
"INLINE OVERLOADABLE double16 convert_double16(uchar16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(uchar16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(double16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(double16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(double16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(double16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(double16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(double16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(double16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(double16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(double16 v) { return v; }\n"
"INLINE OVERLOADABLE float16 convert_float16(double16 v) {\n"
"  return (float16)((float)(v.s0), (float)(v.s1), (float)(v.s2), (float)(v.s3), (float)(v.s4), (float)(v.s5), (float)(v.s6), (float)(v.s7), (float)(v.s8), (float)(v.s9), (float)(v.sA), (float)(v.sB), (float)(v.sC), (float)(v.sD), (float)(v.sE), (float)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16(float16 v) {\n"
"  return (long16)((long)(v.s0), (long)(v.s1), (long)(v.s2), (long)(v.s3), (long)(v.s4), (long)(v.s5), (long)(v.s6), (long)(v.s7), (long)(v.s8), (long)(v.s9), (long)(v.sA), (long)(v.sB), (long)(v.sC), (long)(v.sD), (long)(v.sE), (long)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16(float16 v) {\n"
"  return (ulong16)((ulong)(v.s0), (ulong)(v.s1), (ulong)(v.s2), (ulong)(v.s3), (ulong)(v.s4), (ulong)(v.s5), (ulong)(v.s6), (ulong)(v.s7), (ulong)(v.s8), (ulong)(v.s9), (ulong)(v.sA), (ulong)(v.sB), (ulong)(v.sC), (ulong)(v.sD), (ulong)(v.sE), (ulong)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16(float16 v) {\n"
"  return (int16)((int)(v.s0), (int)(v.s1), (int)(v.s2), (int)(v.s3), (int)(v.s4), (int)(v.s5), (int)(v.s6), (int)(v.s7), (int)(v.s8), (int)(v.s9), (int)(v.sA), (int)(v.sB), (int)(v.sC), (int)(v.sD), (int)(v.sE), (int)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16(float16 v) {\n"
"  return (uint16)((uint)(v.s0), (uint)(v.s1), (uint)(v.s2), (uint)(v.s3), (uint)(v.s4), (uint)(v.s5), (uint)(v.s6), (uint)(v.s7), (uint)(v.s8), (uint)(v.s9), (uint)(v.sA), (uint)(v.sB), (uint)(v.sC), (uint)(v.sD), (uint)(v.sE), (uint)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16(float16 v) {\n"
"  return (short16)((short)(v.s0), (short)(v.s1), (short)(v.s2), (short)(v.s3), (short)(v.s4), (short)(v.s5), (short)(v.s6), (short)(v.s7), (short)(v.s8), (short)(v.s9), (short)(v.sA), (short)(v.sB), (short)(v.sC), (short)(v.sD), (short)(v.sE), (short)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16(float16 v) {\n"
"  return (ushort16)((ushort)(v.s0), (ushort)(v.s1), (ushort)(v.s2), (ushort)(v.s3), (ushort)(v.s4), (ushort)(v.s5), (ushort)(v.s6), (ushort)(v.s7), (ushort)(v.s8), (ushort)(v.s9), (ushort)(v.sA), (ushort)(v.sB), (ushort)(v.sC), (ushort)(v.sD), (ushort)(v.sE), (ushort)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16(float16 v) {\n"
"  return (char16)((char)(v.s0), (char)(v.s1), (char)(v.s2), (char)(v.s3), (char)(v.s4), (char)(v.s5), (char)(v.s6), (char)(v.s7), (char)(v.s8), (char)(v.s9), (char)(v.sA), (char)(v.sB), (char)(v.sC), (char)(v.sD), (char)(v.sE), (char)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16(float16 v) {\n"
"  return (uchar16)((uchar)(v.s0), (uchar)(v.s1), (uchar)(v.s2), (uchar)(v.s3), (uchar)(v.s4), (uchar)(v.s5), (uchar)(v.s6), (uchar)(v.s7), (uchar)(v.s8), (uchar)(v.s9), (uchar)(v.sA), (uchar)(v.sB), (uchar)(v.sC), (uchar)(v.sD), (uchar)(v.sE), (uchar)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE double16 convert_double16(float16 v) {\n"
"  return (double16)((double)(v.s0), (double)(v.s1), (double)(v.s2), (double)(v.s3), (double)(v.s4), (double)(v.s5), (double)(v.s6), (double)(v.s7), (double)(v.s8), (double)(v.s9), (double)(v.sA), (double)(v.sB), (double)(v.sC), (double)(v.sD), (double)(v.sE), (double)(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16(float16 v) { return v; }\n"
"\n"
"#define DEF(DSTTYPE, SRCTYPE) \\\n"
"  OVERLOADABLE DSTTYPE convert_ ## DSTTYPE ## _sat(SRCTYPE x);\n"
"DEF(char, uchar);\n"
"DEF(char, short);\n"
"DEF(char, ushort);\n"
"DEF(char, int);\n"
"DEF(char, uint);\n"
"DEF(char, float);\n"
"DEF(uchar, char);\n"
"DEF(uchar, short);\n"
"DEF(uchar, ushort);\n"
"DEF(uchar, int);\n"
"DEF(uchar, uint);\n"
"DEF(uchar, float);\n"
"DEF(short, ushort);\n"
"DEF(short, int);\n"
"DEF(short, uint);\n"
"DEF(short, float);\n"
"DEF(ushort, short);\n"
"DEF(ushort, int);\n"
"DEF(ushort, uint);\n"
"DEF(ushort, float);\n"
"DEF(int, uint);\n"
"DEF(int, float);\n"
"DEF(uint, int);\n"
"DEF(uint, float);\n"
"#undef DEF\n"
"\n"
"#define DEF(DSTTYPE, SRCTYPE, MIN, MAX) \\\n"
"  INLINE_OVERLOADABLE DSTTYPE convert_ ## DSTTYPE ## _sat(SRCTYPE x) { \\\n"
"    return x >= MAX ? (DSTTYPE)MAX : x <= MIN ? (DSTTYPE)MIN : x; \\\n"
"  }\n"
"DEF(char, long, -128, 127);\n"
"DEF(uchar, long, 0, 255);\n"
"DEF(short, long, -32768, 32767);\n"
"DEF(ushort, long, 0, 65535);\n"
"DEF(int, long, -0x7fffffff-1, 0x7fffffff);\n"
"DEF(uint, long, 0, 0xffffffffu);\n"
"DEF(long, float, -9.223372036854776e+18f, 9.223372036854776e+18f);\n"
"DEF(ulong, float, 0, 1.8446744073709552e+19f);\n"
"#undef DEF\n"
"\n"
"#define DEF(DSTTYPE, SRCTYPE, MAX) \\\n"
"  INLINE_OVERLOADABLE DSTTYPE convert_ ## DSTTYPE ## _sat(SRCTYPE x) { \\\n"
"    return x >= MAX ? (DSTTYPE)MAX : x; \\\n"
"  }\n"
"DEF(char, ulong, 127);\n"
"DEF(uchar, ulong, 255);\n"
"DEF(short, ulong, 32767);\n"
"DEF(ushort, ulong, 65535);\n"
"DEF(int, ulong, 0x7fffffff);\n"
"DEF(uint, ulong, 0xffffffffu);\n"
"#undef DEF\n"
"\n"
"INLINE_OVERLOADABLE long convert_long_sat(ulong x) {\n"
"  ulong MAX = 0x7ffffffffffffffful;\n"
"  return x >= MAX ? MAX : x;\n"
"}\n"
"\n"
"#define DEF(DSTTYPE, SRCTYPE) \\\n"
"  INLINE_OVERLOADABLE DSTTYPE convert_ ## DSTTYPE ## _sat(SRCTYPE x) { \\\n"
"    return x <= 0 ? 0 : x; \\\n"
"  }\n"
"DEF(ushort, char);\n"
"DEF(uint, char);\n"
"DEF(uint, short);\n"
"DEF(ulong, char);\n"
"DEF(ulong, short);\n"
"DEF(ulong, int);\n"
"DEF(ulong, long);\n"
"#undef DEF\n"
"\n"
"#define DEF(DSTTYPE, SRCTYPE) \\\n"
"  INLINE_OVERLOADABLE DSTTYPE convert_ ## DSTTYPE ## _sat(SRCTYPE x) { \\\n"
"    return x; \\\n"
"  }\n"
"DEF(char, char);\n"
"DEF(uchar, uchar);\n"
"DEF(short, char);\n"
"DEF(short, uchar);\n"
"DEF(short, short);\n"
"DEF(ushort, uchar);\n"
"DEF(ushort, ushort);\n"
"DEF(int, char);\n"
"DEF(int, uchar);\n"
"DEF(int, short);\n"
"DEF(int, ushort);\n"
"DEF(int, int);\n"
"DEF(uint, uchar);\n"
"DEF(uint, ushort);\n"
"DEF(uint, uint);\n"
"DEF(long, char);\n"
"DEF(long, uchar);\n"
"DEF(long, short);\n"
"DEF(long, ushort);\n"
"DEF(long, int);\n"
"DEF(long, uint);\n"
"DEF(long, long);\n"
"DEF(ulong, uchar);\n"
"DEF(ulong, ushort);\n"
"DEF(ulong, uint);\n"
"DEF(ulong, ulong);\n"
"#undef DEF\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(long2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(long2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(long2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(long2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(long2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(long2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(long2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(long2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(ulong2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(ulong2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(ulong2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(ulong2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(ulong2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(int2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(int2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(int2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(int2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(int2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(int2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(int2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(int2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(uint2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(uint2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(uint2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(uint2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(uint2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(uint2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(uint2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(uint2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(short2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(short2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(short2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(short2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(short2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(short2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(short2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(short2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(ushort2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(ushort2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(ushort2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(ushort2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(ushort2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(char2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(char2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(char2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(char2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(char2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(char2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(char2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(char2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(uchar2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(uchar2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(uchar2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(uchar2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(uchar2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat(float2 v) {\n"
"  return (long2)(convert_long_sat(v.s0), convert_long_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat(float2 v) {\n"
"  return (ulong2)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat(float2 v) {\n"
"  return (int2)(convert_int_sat(v.s0), convert_int_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat(float2 v) {\n"
"  return (uint2)(convert_uint_sat(v.s0), convert_uint_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat(float2 v) {\n"
"  return (short2)(convert_short_sat(v.s0), convert_short_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat(float2 v) {\n"
"  return (ushort2)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat(float2 v) {\n"
"  return (char2)(convert_char_sat(v.s0), convert_char_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat(float2 v) {\n"
"  return (uchar2)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(long3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(long3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(long3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(long3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(long3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(long3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(long3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(long3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(ulong3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(ulong3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(ulong3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(ulong3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(ulong3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(int3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(int3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(int3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(int3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(int3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(int3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(int3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(int3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(uint3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(uint3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(uint3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(uint3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(uint3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(uint3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(uint3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(uint3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(short3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(short3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(short3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(short3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(short3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(short3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(short3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(short3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(ushort3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(ushort3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(ushort3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(ushort3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(ushort3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(char3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(char3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(char3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(char3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(char3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(char3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(char3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(char3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(uchar3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(uchar3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(uchar3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(uchar3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(uchar3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat(float3 v) {\n"
"  return (long3)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat(float3 v) {\n"
"  return (ulong3)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat(float3 v) {\n"
"  return (int3)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat(float3 v) {\n"
"  return (uint3)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat(float3 v) {\n"
"  return (short3)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat(float3 v) {\n"
"  return (ushort3)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat(float3 v) {\n"
"  return (char3)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat(float3 v) {\n"
"  return (uchar3)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(long4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(long4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(long4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(long4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(long4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(long4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(long4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(long4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(ulong4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(ulong4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(ulong4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(ulong4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(ulong4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(int4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(int4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(int4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(int4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(int4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(int4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(int4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(int4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(uint4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(uint4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(uint4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(uint4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(uint4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(uint4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(uint4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(uint4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(short4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(short4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(short4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(short4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(short4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(short4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(short4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(short4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(ushort4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(ushort4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(ushort4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(ushort4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(ushort4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(char4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(char4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(char4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(char4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(char4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(char4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(char4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(char4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(uchar4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(uchar4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(uchar4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(uchar4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(uchar4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat(float4 v) {\n"
"  return (long4)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat(float4 v) {\n"
"  return (ulong4)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat(float4 v) {\n"
"  return (int4)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat(float4 v) {\n"
"  return (uint4)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat(float4 v) {\n"
"  return (short4)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat(float4 v) {\n"
"  return (ushort4)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat(float4 v) {\n"
"  return (char4)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat(float4 v) {\n"
"  return (uchar4)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(long8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(long8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(long8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(long8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(long8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(long8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(long8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(long8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(ulong8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(ulong8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(ulong8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(ulong8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(ulong8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(int8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(int8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(int8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(int8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(int8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(int8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(int8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(int8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(uint8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(uint8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(uint8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(uint8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(uint8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(uint8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(uint8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(uint8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(short8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(short8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(short8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(short8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(short8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(short8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(short8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(short8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(ushort8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(ushort8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(ushort8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(ushort8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(ushort8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(char8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(char8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(char8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(char8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(char8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(char8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(char8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(char8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(uchar8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(uchar8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(uchar8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(uchar8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(uchar8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat(float8 v) {\n"
"  return (long8)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat(float8 v) {\n"
"  return (ulong8)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat(float8 v) {\n"
"  return (int8)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat(float8 v) {\n"
"  return (uint8)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat(float8 v) {\n"
"  return (short8)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat(float8 v) {\n"
"  return (ushort8)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat(float8 v) {\n"
"  return (char8)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat(float8 v) {\n"
"  return (uchar8)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(long16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(long16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(long16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(long16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(long16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(long16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(long16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(long16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(ulong16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(ulong16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(ulong16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(ulong16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(ulong16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(int16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(int16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(int16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(int16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(int16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(int16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(int16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(int16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(uint16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(uint16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(uint16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(uint16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(uint16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(uint16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(uint16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(uint16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(short16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(short16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(short16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(short16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(short16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(short16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(short16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(short16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(ushort16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(ushort16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(ushort16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(ushort16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(ushort16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(char16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(char16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(char16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(char16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(char16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(char16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(char16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(char16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(uchar16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(uchar16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(uchar16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(uchar16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(uchar16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat(float16 v) {\n"
"  return (long16)(convert_long_sat(v.s0), convert_long_sat(v.s1), convert_long_sat(v.s2), convert_long_sat(v.s3), convert_long_sat(v.s4), convert_long_sat(v.s5), convert_long_sat(v.s6), convert_long_sat(v.s7), convert_long_sat(v.s8), convert_long_sat(v.s9), convert_long_sat(v.sA), convert_long_sat(v.sB), convert_long_sat(v.sC), convert_long_sat(v.sD), convert_long_sat(v.sE), convert_long_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat(float16 v) {\n"
"  return (ulong16)(convert_ulong_sat(v.s0), convert_ulong_sat(v.s1), convert_ulong_sat(v.s2), convert_ulong_sat(v.s3), convert_ulong_sat(v.s4), convert_ulong_sat(v.s5), convert_ulong_sat(v.s6), convert_ulong_sat(v.s7), convert_ulong_sat(v.s8), convert_ulong_sat(v.s9), convert_ulong_sat(v.sA), convert_ulong_sat(v.sB), convert_ulong_sat(v.sC), convert_ulong_sat(v.sD), convert_ulong_sat(v.sE), convert_ulong_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat(float16 v) {\n"
"  return (int16)(convert_int_sat(v.s0), convert_int_sat(v.s1), convert_int_sat(v.s2), convert_int_sat(v.s3), convert_int_sat(v.s4), convert_int_sat(v.s5), convert_int_sat(v.s6), convert_int_sat(v.s7), convert_int_sat(v.s8), convert_int_sat(v.s9), convert_int_sat(v.sA), convert_int_sat(v.sB), convert_int_sat(v.sC), convert_int_sat(v.sD), convert_int_sat(v.sE), convert_int_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat(float16 v) {\n"
"  return (uint16)(convert_uint_sat(v.s0), convert_uint_sat(v.s1), convert_uint_sat(v.s2), convert_uint_sat(v.s3), convert_uint_sat(v.s4), convert_uint_sat(v.s5), convert_uint_sat(v.s6), convert_uint_sat(v.s7), convert_uint_sat(v.s8), convert_uint_sat(v.s9), convert_uint_sat(v.sA), convert_uint_sat(v.sB), convert_uint_sat(v.sC), convert_uint_sat(v.sD), convert_uint_sat(v.sE), convert_uint_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat(float16 v) {\n"
"  return (short16)(convert_short_sat(v.s0), convert_short_sat(v.s1), convert_short_sat(v.s2), convert_short_sat(v.s3), convert_short_sat(v.s4), convert_short_sat(v.s5), convert_short_sat(v.s6), convert_short_sat(v.s7), convert_short_sat(v.s8), convert_short_sat(v.s9), convert_short_sat(v.sA), convert_short_sat(v.sB), convert_short_sat(v.sC), convert_short_sat(v.sD), convert_short_sat(v.sE), convert_short_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat(float16 v) {\n"
"  return (ushort16)(convert_ushort_sat(v.s0), convert_ushort_sat(v.s1), convert_ushort_sat(v.s2), convert_ushort_sat(v.s3), convert_ushort_sat(v.s4), convert_ushort_sat(v.s5), convert_ushort_sat(v.s6), convert_ushort_sat(v.s7), convert_ushort_sat(v.s8), convert_ushort_sat(v.s9), convert_ushort_sat(v.sA), convert_ushort_sat(v.sB), convert_ushort_sat(v.sC), convert_ushort_sat(v.sD), convert_ushort_sat(v.sE), convert_ushort_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat(float16 v) {\n"
"  return (char16)(convert_char_sat(v.s0), convert_char_sat(v.s1), convert_char_sat(v.s2), convert_char_sat(v.s3), convert_char_sat(v.s4), convert_char_sat(v.s5), convert_char_sat(v.s6), convert_char_sat(v.s7), convert_char_sat(v.s8), convert_char_sat(v.s9), convert_char_sat(v.sA), convert_char_sat(v.sB), convert_char_sat(v.sC), convert_char_sat(v.sD), convert_char_sat(v.sE), convert_char_sat(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat(float16 v) {\n"
"  return (uchar16)(convert_uchar_sat(v.s0), convert_uchar_sat(v.s1), convert_uchar_sat(v.s2), convert_uchar_sat(v.s3), convert_uchar_sat(v.s4), convert_uchar_sat(v.s5), convert_uchar_sat(v.s6), convert_uchar_sat(v.s7), convert_uchar_sat(v.s8), convert_uchar_sat(v.s9), convert_uchar_sat(v.sA), convert_uchar_sat(v.sB), convert_uchar_sat(v.sC), convert_uchar_sat(v.sD), convert_uchar_sat(v.sE), convert_uchar_sat(v.sF));\n"
"}\n"
"\n"
"\n"
"float __gen_ocl_rndz(float x);\n"
"float __gen_ocl_rnde(float x);\n"
"float __gen_ocl_rndu(float x);\n"
"float __gen_ocl_rndd(float x);\n"
"INLINE_OVERLOADABLE float __convert_float_rtz(long x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  long l = u.f;\n"
"  if((l > x && x > 0) || x >= 0x7fffffc000000000 ||\n"
"     (l < x && x < 0)) {\n"
"      u.u -= 1;\n"
"  }\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtp(long x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  long l = u.f;  //can not use u.f < x\n"
"  if(l < x && x < 0x7fffffc000000000) {\n"
"    if(x > 0)\n"
"      u.u = u.u + 1;\n"
"    else\n"
"      u.u = u.u - 1;\n"
"  }\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtn(long x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  long l = u.f;  //avoid overflow\n"
"  if(l > x || x >= 0x7fffffc000000000) {\n"
"    if(x > 0)\n"
"      u.u = u.u - 1;\n"
"    else\n"
"      u.u = u.u + 1;\n"
"  }\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtz(ulong x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  ulong l = u.f;\n"
"  if(l > x  || x >= 0xffffff8000000000)\n"
"      u.u -= 1;\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtp(ulong x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  ulong l = u.f;  //can not use u.f < x\n"
"  if(l < x && x < 0xffffff8000000000)\n"
"    u.u = u.u + 1;\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtn(ulong x)\n"
"{\n"
"  return __convert_float_rtz(x);\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtz(int x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  long i = u.f;\n"
"  if((i > x && x > 0) ||\n"
"     (i < x && x < 0)) {\n"
"      u.u -= 1;\n"
"  }\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtp(int x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  int i = u.f;\n"
"  if(i < x) {\n"
"    if(x > 0)\n"
"      u.u += 1;\n"
"    else\n"
"      u.u -= 1;\n"
"  }\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtn(int x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  long i = u.f;  //avoid overflow\n"
"  if(i > x) {\n"
"    if(x > 0)\n"
"      u.u = u.u - 1;\n"
"    else\n"
"      u.u = u.u + 1;\n"
"  }\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtz(uint x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  ulong i = u.f;\n"
"  if(i > x)\n"
"    u.u -= 1;\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtp(uint x)\n"
"{\n"
"  union {\n"
"    uint u;\n"
"    float f;\n"
"  } u;\n"
"  u.f = x;\n"
"  uint i = u.f;\n"
"  if(i < x)\n"
"    u.u += 1;\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __convert_float_rtn(uint x)\n"
"{\n"
"  return __convert_float_rtz(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE long convert_long_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rte(long x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(long x)\n"
"{ return __convert_float_rtz(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(long x)\n"
"{ return __convert_float_rtp(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(long x)\n"
"{ return __convert_float_rtn(x); }\n"
"INLINE_OVERLOADABLE long convert_long_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rte(ulong x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(ulong x)\n"
"{ return __convert_float_rtz(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(ulong x)\n"
"{ return __convert_float_rtp(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(ulong x)\n"
"{ return __convert_float_rtn(x); }\n"
"INLINE_OVERLOADABLE long convert_long_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rte(int x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(int x)\n"
"{ return __convert_float_rtz(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(int x)\n"
"{ return __convert_float_rtp(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(int x)\n"
"{ return __convert_float_rtn(x); }\n"
"INLINE_OVERLOADABLE long convert_long_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rte(uint x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(uint x)\n"
"{ return __convert_float_rtz(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(uint x)\n"
"{ return __convert_float_rtp(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(uint x)\n"
"{ return __convert_float_rtn(x); }\n"
"INLINE_OVERLOADABLE long convert_long_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rte(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(short x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rte(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(ushort x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rte(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(char x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rte(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(uchar x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE long convert_long_rte(float x)\n"
"{ return __gen_ocl_rnde(x); }\n"
"INLINE_OVERLOADABLE long convert_long_rtz(float x)\n"
"{ return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE long convert_long_rtp(float x)\n"
"{ return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE long convert_long_rtn(float x)\n"
"{ return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rte(float x)\n"
"{ return __gen_ocl_rnde(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtz(float x)\n"
"{ return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtp(float x)\n"
"{ return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_rtn(float x)\n"
"{ return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE int convert_int_rte(float x)\n"
"{ return __gen_ocl_rnde(x); }\n"
"INLINE_OVERLOADABLE int convert_int_rtz(float x)\n"
"{ return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE int convert_int_rtp(float x)\n"
"{ return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE int convert_int_rtn(float x)\n"
"{ return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_rte(float x)\n"
"{ return __gen_ocl_rnde(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtz(float x)\n"
"{ return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtp(float x)\n"
"{ return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_rtn(float x)\n"
"{ return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE short convert_short_rte(float x)\n"
"{ return __gen_ocl_rnde(x); }\n"
"INLINE_OVERLOADABLE short convert_short_rtz(float x)\n"
"{ return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE short convert_short_rtp(float x)\n"
"{ return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE short convert_short_rtn(float x)\n"
"{ return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rte(float x)\n"
"{ return __gen_ocl_rnde(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtz(float x)\n"
"{ return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtp(float x)\n"
"{ return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_rtn(float x)\n"
"{ return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE char convert_char_rte(float x)\n"
"{ return __gen_ocl_rnde(x); }\n"
"INLINE_OVERLOADABLE char convert_char_rtz(float x)\n"
"{ return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE char convert_char_rtp(float x)\n"
"{ return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE char convert_char_rtn(float x)\n"
"{ return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rte(float x)\n"
"{ return __gen_ocl_rnde(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtz(float x)\n"
"{ return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtp(float x)\n"
"{ return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_rtn(float x)\n"
"{ return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE float convert_float_rte(float x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtz(float x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtp(float x)\n"
"{ return x; }\n"
"INLINE_OVERLOADABLE float convert_float_rtn(float x)\n"
"{ return x; }\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(long2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(long2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(long2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(long2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(long2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(long2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(long2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(long2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(long2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(long2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(long2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(long2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(long2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(long2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(long2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(long2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(long2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(long2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(long2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(long2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(long2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(long2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(long2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(long2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(long2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(long2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(long2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(long2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(long2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(long2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(long2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(long2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(long2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(long2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(long2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(long2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(ulong2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(ulong2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(ulong2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(ulong2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(ulong2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(ulong2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(ulong2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(ulong2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(ulong2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(ulong2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(ulong2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(ulong2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(ulong2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(ulong2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(ulong2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(ulong2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(ulong2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(ulong2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(ulong2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(ulong2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(ulong2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(ulong2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(ulong2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(ulong2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(int2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(int2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(int2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(int2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(int2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(int2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(int2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(int2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(int2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(int2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(int2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(int2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(int2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(int2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(int2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(int2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(int2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(int2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(int2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(int2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(int2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(int2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(int2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(int2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(int2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(int2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(int2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(int2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(int2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(int2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(int2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(int2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(int2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(int2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(int2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(int2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(uint2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(uint2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(uint2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(uint2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(uint2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(uint2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(uint2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(uint2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(uint2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(uint2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(uint2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(uint2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(uint2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(uint2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(uint2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(uint2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(uint2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(uint2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(uint2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(uint2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(uint2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(uint2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(uint2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(uint2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(uint2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(uint2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(uint2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(uint2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(uint2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(uint2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(uint2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(uint2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(uint2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(uint2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(uint2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(uint2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(short2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(short2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(short2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(short2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(short2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(short2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(short2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(short2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(short2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(short2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(short2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(short2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(short2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(short2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(short2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(short2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(short2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(short2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(short2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(short2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(short2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(short2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(short2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(short2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(short2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(short2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(short2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(short2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(short2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(short2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(short2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(short2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(short2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(short2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(short2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(short2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(ushort2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(ushort2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(ushort2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(ushort2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(ushort2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(ushort2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(ushort2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(ushort2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(ushort2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(ushort2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(ushort2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(ushort2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(ushort2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(ushort2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(ushort2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(ushort2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(ushort2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(ushort2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(ushort2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(ushort2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(ushort2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(ushort2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(ushort2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(ushort2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(char2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(char2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(char2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(char2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(char2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(char2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(char2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(char2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(char2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(char2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(char2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(char2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(char2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(char2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(char2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(char2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(char2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(char2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(char2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(char2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(char2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(char2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(char2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(char2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(char2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(char2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(char2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(char2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(char2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(char2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(char2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(char2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(char2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(char2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(char2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(char2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(uchar2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(uchar2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(uchar2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(uchar2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(uchar2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(uchar2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(uchar2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(uchar2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(uchar2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(uchar2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(uchar2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(uchar2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(uchar2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(uchar2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(uchar2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(uchar2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(uchar2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(uchar2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(uchar2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(uchar2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(uchar2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(uchar2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(uchar2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(uchar2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rte(float2 v) {\n"
"  return (long2)(convert_long_rte(v.s0), convert_long_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtz(float2 v) {\n"
"  return (long2)(convert_long_rtz(v.s0), convert_long_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtp(float2 v) {\n"
"  return (long2)(convert_long_rtp(v.s0), convert_long_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_rtn(float2 v) {\n"
"  return (long2)(convert_long_rtn(v.s0), convert_long_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rte(float2 v) {\n"
"  return (ulong2)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtz(float2 v) {\n"
"  return (ulong2)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtp(float2 v) {\n"
"  return (ulong2)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_rtn(float2 v) {\n"
"  return (ulong2)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rte(float2 v) {\n"
"  return (int2)(convert_int_rte(v.s0), convert_int_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtz(float2 v) {\n"
"  return (int2)(convert_int_rtz(v.s0), convert_int_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtp(float2 v) {\n"
"  return (int2)(convert_int_rtp(v.s0), convert_int_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_rtn(float2 v) {\n"
"  return (int2)(convert_int_rtn(v.s0), convert_int_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rte(float2 v) {\n"
"  return (uint2)(convert_uint_rte(v.s0), convert_uint_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtz(float2 v) {\n"
"  return (uint2)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtp(float2 v) {\n"
"  return (uint2)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_rtn(float2 v) {\n"
"  return (uint2)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rte(float2 v) {\n"
"  return (short2)(convert_short_rte(v.s0), convert_short_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtz(float2 v) {\n"
"  return (short2)(convert_short_rtz(v.s0), convert_short_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtp(float2 v) {\n"
"  return (short2)(convert_short_rtp(v.s0), convert_short_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_rtn(float2 v) {\n"
"  return (short2)(convert_short_rtn(v.s0), convert_short_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rte(float2 v) {\n"
"  return (ushort2)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtz(float2 v) {\n"
"  return (ushort2)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtp(float2 v) {\n"
"  return (ushort2)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_rtn(float2 v) {\n"
"  return (ushort2)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rte(float2 v) {\n"
"  return (char2)(convert_char_rte(v.s0), convert_char_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtz(float2 v) {\n"
"  return (char2)(convert_char_rtz(v.s0), convert_char_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtp(float2 v) {\n"
"  return (char2)(convert_char_rtp(v.s0), convert_char_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_rtn(float2 v) {\n"
"  return (char2)(convert_char_rtn(v.s0), convert_char_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rte(float2 v) {\n"
"  return (uchar2)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtz(float2 v) {\n"
"  return (uchar2)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtp(float2 v) {\n"
"  return (uchar2)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_rtn(float2 v) {\n"
"  return (uchar2)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rte(float2 v) {\n"
"  return (float2)(convert_float_rte(v.s0), convert_float_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtz(float2 v) {\n"
"  return (float2)(convert_float_rtz(v.s0), convert_float_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtp(float2 v) {\n"
"  return (float2)(convert_float_rtp(v.s0), convert_float_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float2 convert_float2_rtn(float2 v) {\n"
"  return (float2)(convert_float_rtn(v.s0), convert_float_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(long3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(long3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(long3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(long3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(long3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(long3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(long3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(long3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(long3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(long3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(long3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(long3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(long3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(long3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(long3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(long3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(long3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(long3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(long3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(long3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(long3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(long3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(long3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(long3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(long3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(long3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(long3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(long3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(long3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(long3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(long3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(long3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(long3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(long3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(long3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(long3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(ulong3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(ulong3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(ulong3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(ulong3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(ulong3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(ulong3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(ulong3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(ulong3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(ulong3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(ulong3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(ulong3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(ulong3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(ulong3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(ulong3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(ulong3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(ulong3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(ulong3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(ulong3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(ulong3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(ulong3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(ulong3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(ulong3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(ulong3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(ulong3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(int3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(int3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(int3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(int3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(int3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(int3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(int3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(int3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(int3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(int3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(int3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(int3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(int3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(int3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(int3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(int3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(int3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(int3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(int3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(int3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(int3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(int3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(int3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(int3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(int3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(int3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(int3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(int3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(int3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(int3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(int3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(int3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(int3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(int3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(int3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(int3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(uint3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(uint3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(uint3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(uint3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(uint3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(uint3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(uint3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(uint3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(uint3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(uint3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(uint3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(uint3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(uint3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(uint3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(uint3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(uint3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(uint3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(uint3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(uint3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(uint3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(uint3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(uint3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(uint3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(uint3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(uint3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(uint3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(uint3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(uint3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(uint3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(uint3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(uint3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(uint3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(uint3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(uint3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(uint3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(uint3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(short3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(short3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(short3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(short3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(short3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(short3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(short3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(short3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(short3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(short3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(short3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(short3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(short3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(short3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(short3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(short3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(short3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(short3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(short3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(short3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(short3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(short3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(short3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(short3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(short3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(short3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(short3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(short3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(short3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(short3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(short3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(short3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(short3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(short3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(short3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(short3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(ushort3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(ushort3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(ushort3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(ushort3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(ushort3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(ushort3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(ushort3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(ushort3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(ushort3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(ushort3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(ushort3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(ushort3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(ushort3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(ushort3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(ushort3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(ushort3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(ushort3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(ushort3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(ushort3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(ushort3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(ushort3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(ushort3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(ushort3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(ushort3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(char3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(char3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(char3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(char3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(char3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(char3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(char3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(char3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(char3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(char3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(char3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(char3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(char3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(char3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(char3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(char3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(char3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(char3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(char3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(char3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(char3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(char3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(char3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(char3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(char3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(char3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(char3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(char3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(char3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(char3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(char3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(char3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(char3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(char3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(char3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(char3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(uchar3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(uchar3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(uchar3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(uchar3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(uchar3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(uchar3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(uchar3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(uchar3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(uchar3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(uchar3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(uchar3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(uchar3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(uchar3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(uchar3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(uchar3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(uchar3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(uchar3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(uchar3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(uchar3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(uchar3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(uchar3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(uchar3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(uchar3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(uchar3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rte(float3 v) {\n"
"  return (long3)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtz(float3 v) {\n"
"  return (long3)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtp(float3 v) {\n"
"  return (long3)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_rtn(float3 v) {\n"
"  return (long3)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rte(float3 v) {\n"
"  return (ulong3)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtz(float3 v) {\n"
"  return (ulong3)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtp(float3 v) {\n"
"  return (ulong3)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_rtn(float3 v) {\n"
"  return (ulong3)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rte(float3 v) {\n"
"  return (int3)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtz(float3 v) {\n"
"  return (int3)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtp(float3 v) {\n"
"  return (int3)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_rtn(float3 v) {\n"
"  return (int3)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rte(float3 v) {\n"
"  return (uint3)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtz(float3 v) {\n"
"  return (uint3)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtp(float3 v) {\n"
"  return (uint3)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_rtn(float3 v) {\n"
"  return (uint3)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rte(float3 v) {\n"
"  return (short3)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtz(float3 v) {\n"
"  return (short3)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtp(float3 v) {\n"
"  return (short3)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_rtn(float3 v) {\n"
"  return (short3)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rte(float3 v) {\n"
"  return (ushort3)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtz(float3 v) {\n"
"  return (ushort3)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtp(float3 v) {\n"
"  return (ushort3)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_rtn(float3 v) {\n"
"  return (ushort3)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rte(float3 v) {\n"
"  return (char3)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtz(float3 v) {\n"
"  return (char3)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtp(float3 v) {\n"
"  return (char3)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_rtn(float3 v) {\n"
"  return (char3)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rte(float3 v) {\n"
"  return (uchar3)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtz(float3 v) {\n"
"  return (uchar3)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtp(float3 v) {\n"
"  return (uchar3)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_rtn(float3 v) {\n"
"  return (uchar3)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rte(float3 v) {\n"
"  return (float3)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtz(float3 v) {\n"
"  return (float3)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtp(float3 v) {\n"
"  return (float3)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float3 convert_float3_rtn(float3 v) {\n"
"  return (float3)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(long4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(long4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(long4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(long4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(long4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(long4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(long4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(long4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(long4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(long4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(long4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(long4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(long4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(long4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(long4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(long4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(long4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(long4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(long4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(long4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(long4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(long4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(long4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(long4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(long4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(long4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(long4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(long4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(long4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(long4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(long4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(long4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(long4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(long4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(long4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(long4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(ulong4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(ulong4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(ulong4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(ulong4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(ulong4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(ulong4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(ulong4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(ulong4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(ulong4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(ulong4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(ulong4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(ulong4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(ulong4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(ulong4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(ulong4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(ulong4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(ulong4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(ulong4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(ulong4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(ulong4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(ulong4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(ulong4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(ulong4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(ulong4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(int4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(int4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(int4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(int4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(int4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(int4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(int4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(int4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(int4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(int4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(int4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(int4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(int4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(int4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(int4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(int4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(int4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(int4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(int4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(int4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(int4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(int4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(int4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(int4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(int4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(int4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(int4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(int4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(int4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(int4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(int4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(int4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(int4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(int4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(int4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(int4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(uint4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(uint4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(uint4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(uint4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(uint4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(uint4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(uint4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(uint4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(uint4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(uint4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(uint4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(uint4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(uint4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(uint4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(uint4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(uint4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(uint4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(uint4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(uint4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(uint4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(uint4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(uint4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(uint4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(uint4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(uint4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(uint4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(uint4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(uint4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(uint4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(uint4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(uint4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(uint4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(uint4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(uint4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(uint4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(uint4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(short4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(short4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(short4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(short4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(short4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(short4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(short4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(short4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(short4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(short4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(short4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(short4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(short4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(short4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(short4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(short4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(short4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(short4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(short4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(short4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(short4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(short4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(short4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(short4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(short4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(short4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(short4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(short4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(short4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(short4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(short4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(short4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(short4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(short4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(short4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(short4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(ushort4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(ushort4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(ushort4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(ushort4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(ushort4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(ushort4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(ushort4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(ushort4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(ushort4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(ushort4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(ushort4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(ushort4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(ushort4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(ushort4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(ushort4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(ushort4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(ushort4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(ushort4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(ushort4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(ushort4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(ushort4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(ushort4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(ushort4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(ushort4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(char4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(char4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(char4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(char4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(char4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(char4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(char4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(char4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(char4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(char4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(char4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(char4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(char4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(char4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(char4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(char4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(char4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(char4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(char4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(char4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(char4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(char4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(char4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(char4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(char4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(char4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(char4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(char4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(char4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(char4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(char4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(char4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(char4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(char4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(char4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(char4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(uchar4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(uchar4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(uchar4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(uchar4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(uchar4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(uchar4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(uchar4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(uchar4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(uchar4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(uchar4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(uchar4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(uchar4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(uchar4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(uchar4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(uchar4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(uchar4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(uchar4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(uchar4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(uchar4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(uchar4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(uchar4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(uchar4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(uchar4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(uchar4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rte(float4 v) {\n"
"  return (long4)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtz(float4 v) {\n"
"  return (long4)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtp(float4 v) {\n"
"  return (long4)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_rtn(float4 v) {\n"
"  return (long4)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rte(float4 v) {\n"
"  return (ulong4)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtz(float4 v) {\n"
"  return (ulong4)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtp(float4 v) {\n"
"  return (ulong4)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_rtn(float4 v) {\n"
"  return (ulong4)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rte(float4 v) {\n"
"  return (int4)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtz(float4 v) {\n"
"  return (int4)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtp(float4 v) {\n"
"  return (int4)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_rtn(float4 v) {\n"
"  return (int4)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rte(float4 v) {\n"
"  return (uint4)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtz(float4 v) {\n"
"  return (uint4)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtp(float4 v) {\n"
"  return (uint4)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_rtn(float4 v) {\n"
"  return (uint4)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rte(float4 v) {\n"
"  return (short4)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtz(float4 v) {\n"
"  return (short4)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtp(float4 v) {\n"
"  return (short4)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_rtn(float4 v) {\n"
"  return (short4)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rte(float4 v) {\n"
"  return (ushort4)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtz(float4 v) {\n"
"  return (ushort4)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtp(float4 v) {\n"
"  return (ushort4)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_rtn(float4 v) {\n"
"  return (ushort4)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rte(float4 v) {\n"
"  return (char4)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtz(float4 v) {\n"
"  return (char4)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtp(float4 v) {\n"
"  return (char4)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_rtn(float4 v) {\n"
"  return (char4)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rte(float4 v) {\n"
"  return (uchar4)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtz(float4 v) {\n"
"  return (uchar4)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtp(float4 v) {\n"
"  return (uchar4)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_rtn(float4 v) {\n"
"  return (uchar4)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rte(float4 v) {\n"
"  return (float4)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtz(float4 v) {\n"
"  return (float4)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtp(float4 v) {\n"
"  return (float4)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float4 convert_float4_rtn(float4 v) {\n"
"  return (float4)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(long8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(long8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(long8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(long8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(long8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(long8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(long8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(long8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(long8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(long8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(long8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(long8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(long8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(long8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(long8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(long8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(long8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(long8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(long8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(long8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(long8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(long8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(long8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(long8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(long8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(long8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(long8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(long8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(long8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(long8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(long8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(long8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(long8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(long8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(long8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(long8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(ulong8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(ulong8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(ulong8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(ulong8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(ulong8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(ulong8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(ulong8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(ulong8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(ulong8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(ulong8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(ulong8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(ulong8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(ulong8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(ulong8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(ulong8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(ulong8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(ulong8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(ulong8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(ulong8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(ulong8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(ulong8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(ulong8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(ulong8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(ulong8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(int8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(int8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(int8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(int8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(int8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(int8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(int8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(int8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(int8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(int8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(int8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(int8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(int8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(int8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(int8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(int8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(int8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(int8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(int8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(int8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(int8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(int8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(int8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(int8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(int8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(int8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(int8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(int8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(int8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(int8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(int8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(int8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(int8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(int8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(int8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(int8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(uint8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(uint8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(uint8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(uint8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(uint8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(uint8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(uint8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(uint8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(uint8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(uint8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(uint8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(uint8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(uint8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(uint8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(uint8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(uint8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(uint8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(uint8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(uint8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(uint8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(uint8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(uint8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(uint8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(uint8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(uint8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(uint8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(uint8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(uint8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(uint8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(uint8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(uint8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(uint8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(uint8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(uint8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(uint8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(uint8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(short8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(short8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(short8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(short8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(short8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(short8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(short8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(short8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(short8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(short8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(short8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(short8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(short8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(short8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(short8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(short8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(short8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(short8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(short8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(short8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(short8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(short8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(short8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(short8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(short8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(short8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(short8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(short8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(short8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(short8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(short8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(short8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(short8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(short8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(short8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(short8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(ushort8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(ushort8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(ushort8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(ushort8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(ushort8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(ushort8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(ushort8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(ushort8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(ushort8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(ushort8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(ushort8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(ushort8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(ushort8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(ushort8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(ushort8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(ushort8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(ushort8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(ushort8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(ushort8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(ushort8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(ushort8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(ushort8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(ushort8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(ushort8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(char8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(char8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(char8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(char8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(char8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(char8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(char8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(char8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(char8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(char8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(char8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(char8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(char8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(char8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(char8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(char8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(char8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(char8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(char8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(char8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(char8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(char8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(char8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(char8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(char8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(char8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(char8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(char8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(char8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(char8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(char8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(char8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(char8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(char8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(char8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(char8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(uchar8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(uchar8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(uchar8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(uchar8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(uchar8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(uchar8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(uchar8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(uchar8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(uchar8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(uchar8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(uchar8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(uchar8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(uchar8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(uchar8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(uchar8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(uchar8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(uchar8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(uchar8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(uchar8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(uchar8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(uchar8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(uchar8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(uchar8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(uchar8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rte(float8 v) {\n"
"  return (long8)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtz(float8 v) {\n"
"  return (long8)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtp(float8 v) {\n"
"  return (long8)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_rtn(float8 v) {\n"
"  return (long8)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rte(float8 v) {\n"
"  return (ulong8)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtz(float8 v) {\n"
"  return (ulong8)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtp(float8 v) {\n"
"  return (ulong8)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_rtn(float8 v) {\n"
"  return (ulong8)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rte(float8 v) {\n"
"  return (int8)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtz(float8 v) {\n"
"  return (int8)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtp(float8 v) {\n"
"  return (int8)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_rtn(float8 v) {\n"
"  return (int8)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rte(float8 v) {\n"
"  return (uint8)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtz(float8 v) {\n"
"  return (uint8)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtp(float8 v) {\n"
"  return (uint8)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_rtn(float8 v) {\n"
"  return (uint8)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rte(float8 v) {\n"
"  return (short8)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtz(float8 v) {\n"
"  return (short8)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtp(float8 v) {\n"
"  return (short8)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_rtn(float8 v) {\n"
"  return (short8)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rte(float8 v) {\n"
"  return (ushort8)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtz(float8 v) {\n"
"  return (ushort8)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtp(float8 v) {\n"
"  return (ushort8)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_rtn(float8 v) {\n"
"  return (ushort8)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rte(float8 v) {\n"
"  return (char8)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtz(float8 v) {\n"
"  return (char8)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtp(float8 v) {\n"
"  return (char8)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_rtn(float8 v) {\n"
"  return (char8)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rte(float8 v) {\n"
"  return (uchar8)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtz(float8 v) {\n"
"  return (uchar8)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtp(float8 v) {\n"
"  return (uchar8)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_rtn(float8 v) {\n"
"  return (uchar8)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rte(float8 v) {\n"
"  return (float8)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtz(float8 v) {\n"
"  return (float8)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtp(float8 v) {\n"
"  return (float8)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float8 convert_float8_rtn(float8 v) {\n"
"  return (float8)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(long16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(long16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(long16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(long16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(long16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(long16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(long16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(long16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(long16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(long16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(long16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(long16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(long16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(long16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(long16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(long16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(long16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(long16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(long16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(long16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(long16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(long16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(long16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(long16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(long16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(long16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(long16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(long16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(long16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(long16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(long16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(long16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(long16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(long16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(long16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(long16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(ulong16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(ulong16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(ulong16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(ulong16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(ulong16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(ulong16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(ulong16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(ulong16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(ulong16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(ulong16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(ulong16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(ulong16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(ulong16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(ulong16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(ulong16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(ulong16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(ulong16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(ulong16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(ulong16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(ulong16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(ulong16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(ulong16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(ulong16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(ulong16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(int16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(int16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(int16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(int16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(int16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(int16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(int16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(int16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(int16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(int16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(int16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(int16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(int16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(int16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(int16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(int16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(int16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(int16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(int16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(int16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(int16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(int16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(int16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(int16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(int16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(int16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(int16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(int16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(int16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(int16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(int16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(int16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(int16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(int16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(int16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(int16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(uint16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(uint16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(uint16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(uint16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(uint16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(uint16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(uint16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(uint16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(uint16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(uint16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(uint16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(uint16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(uint16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(uint16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(uint16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(uint16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(uint16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(uint16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(uint16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(uint16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(uint16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(uint16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(uint16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(uint16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(uint16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(uint16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(uint16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(uint16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(uint16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(uint16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(uint16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(uint16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(uint16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(uint16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(uint16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(uint16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(short16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(short16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(short16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(short16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(short16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(short16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(short16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(short16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(short16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(short16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(short16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(short16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(short16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(short16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(short16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(short16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(short16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(short16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(short16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(short16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(short16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(short16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(short16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(short16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(short16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(short16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(short16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(short16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(short16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(short16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(short16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(short16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(short16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(short16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(short16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(short16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(ushort16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(ushort16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(ushort16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(ushort16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(ushort16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(ushort16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(ushort16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(ushort16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(ushort16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(ushort16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(ushort16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(ushort16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(ushort16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(ushort16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(ushort16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(ushort16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(ushort16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(ushort16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(ushort16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(ushort16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(ushort16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(ushort16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(ushort16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(ushort16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(char16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(char16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(char16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(char16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(char16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(char16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(char16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(char16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(char16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(char16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(char16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(char16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(char16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(char16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(char16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(char16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(char16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(char16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(char16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(char16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(char16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(char16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(char16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(char16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(char16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(char16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(char16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(char16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(char16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(char16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(char16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(char16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(char16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(char16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(char16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(char16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(uchar16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(uchar16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(uchar16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(uchar16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(uchar16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(uchar16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(uchar16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(uchar16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(uchar16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(uchar16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(uchar16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(uchar16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(uchar16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(uchar16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(uchar16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(uchar16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(uchar16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(uchar16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(uchar16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(uchar16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(uchar16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(uchar16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(uchar16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(uchar16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rte(float16 v) {\n"
"  return (long16)(convert_long_rte(v.s0), convert_long_rte(v.s1), convert_long_rte(v.s2), convert_long_rte(v.s3), convert_long_rte(v.s4), convert_long_rte(v.s5), convert_long_rte(v.s6), convert_long_rte(v.s7), convert_long_rte(v.s8), convert_long_rte(v.s9), convert_long_rte(v.sA), convert_long_rte(v.sB), convert_long_rte(v.sC), convert_long_rte(v.sD), convert_long_rte(v.sE), convert_long_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtz(float16 v) {\n"
"  return (long16)(convert_long_rtz(v.s0), convert_long_rtz(v.s1), convert_long_rtz(v.s2), convert_long_rtz(v.s3), convert_long_rtz(v.s4), convert_long_rtz(v.s5), convert_long_rtz(v.s6), convert_long_rtz(v.s7), convert_long_rtz(v.s8), convert_long_rtz(v.s9), convert_long_rtz(v.sA), convert_long_rtz(v.sB), convert_long_rtz(v.sC), convert_long_rtz(v.sD), convert_long_rtz(v.sE), convert_long_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtp(float16 v) {\n"
"  return (long16)(convert_long_rtp(v.s0), convert_long_rtp(v.s1), convert_long_rtp(v.s2), convert_long_rtp(v.s3), convert_long_rtp(v.s4), convert_long_rtp(v.s5), convert_long_rtp(v.s6), convert_long_rtp(v.s7), convert_long_rtp(v.s8), convert_long_rtp(v.s9), convert_long_rtp(v.sA), convert_long_rtp(v.sB), convert_long_rtp(v.sC), convert_long_rtp(v.sD), convert_long_rtp(v.sE), convert_long_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_rtn(float16 v) {\n"
"  return (long16)(convert_long_rtn(v.s0), convert_long_rtn(v.s1), convert_long_rtn(v.s2), convert_long_rtn(v.s3), convert_long_rtn(v.s4), convert_long_rtn(v.s5), convert_long_rtn(v.s6), convert_long_rtn(v.s7), convert_long_rtn(v.s8), convert_long_rtn(v.s9), convert_long_rtn(v.sA), convert_long_rtn(v.sB), convert_long_rtn(v.sC), convert_long_rtn(v.sD), convert_long_rtn(v.sE), convert_long_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rte(float16 v) {\n"
"  return (ulong16)(convert_ulong_rte(v.s0), convert_ulong_rte(v.s1), convert_ulong_rte(v.s2), convert_ulong_rte(v.s3), convert_ulong_rte(v.s4), convert_ulong_rte(v.s5), convert_ulong_rte(v.s6), convert_ulong_rte(v.s7), convert_ulong_rte(v.s8), convert_ulong_rte(v.s9), convert_ulong_rte(v.sA), convert_ulong_rte(v.sB), convert_ulong_rte(v.sC), convert_ulong_rte(v.sD), convert_ulong_rte(v.sE), convert_ulong_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtz(float16 v) {\n"
"  return (ulong16)(convert_ulong_rtz(v.s0), convert_ulong_rtz(v.s1), convert_ulong_rtz(v.s2), convert_ulong_rtz(v.s3), convert_ulong_rtz(v.s4), convert_ulong_rtz(v.s5), convert_ulong_rtz(v.s6), convert_ulong_rtz(v.s7), convert_ulong_rtz(v.s8), convert_ulong_rtz(v.s9), convert_ulong_rtz(v.sA), convert_ulong_rtz(v.sB), convert_ulong_rtz(v.sC), convert_ulong_rtz(v.sD), convert_ulong_rtz(v.sE), convert_ulong_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtp(float16 v) {\n"
"  return (ulong16)(convert_ulong_rtp(v.s0), convert_ulong_rtp(v.s1), convert_ulong_rtp(v.s2), convert_ulong_rtp(v.s3), convert_ulong_rtp(v.s4), convert_ulong_rtp(v.s5), convert_ulong_rtp(v.s6), convert_ulong_rtp(v.s7), convert_ulong_rtp(v.s8), convert_ulong_rtp(v.s9), convert_ulong_rtp(v.sA), convert_ulong_rtp(v.sB), convert_ulong_rtp(v.sC), convert_ulong_rtp(v.sD), convert_ulong_rtp(v.sE), convert_ulong_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_rtn(float16 v) {\n"
"  return (ulong16)(convert_ulong_rtn(v.s0), convert_ulong_rtn(v.s1), convert_ulong_rtn(v.s2), convert_ulong_rtn(v.s3), convert_ulong_rtn(v.s4), convert_ulong_rtn(v.s5), convert_ulong_rtn(v.s6), convert_ulong_rtn(v.s7), convert_ulong_rtn(v.s8), convert_ulong_rtn(v.s9), convert_ulong_rtn(v.sA), convert_ulong_rtn(v.sB), convert_ulong_rtn(v.sC), convert_ulong_rtn(v.sD), convert_ulong_rtn(v.sE), convert_ulong_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rte(float16 v) {\n"
"  return (int16)(convert_int_rte(v.s0), convert_int_rte(v.s1), convert_int_rte(v.s2), convert_int_rte(v.s3), convert_int_rte(v.s4), convert_int_rte(v.s5), convert_int_rte(v.s6), convert_int_rte(v.s7), convert_int_rte(v.s8), convert_int_rte(v.s9), convert_int_rte(v.sA), convert_int_rte(v.sB), convert_int_rte(v.sC), convert_int_rte(v.sD), convert_int_rte(v.sE), convert_int_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtz(float16 v) {\n"
"  return (int16)(convert_int_rtz(v.s0), convert_int_rtz(v.s1), convert_int_rtz(v.s2), convert_int_rtz(v.s3), convert_int_rtz(v.s4), convert_int_rtz(v.s5), convert_int_rtz(v.s6), convert_int_rtz(v.s7), convert_int_rtz(v.s8), convert_int_rtz(v.s9), convert_int_rtz(v.sA), convert_int_rtz(v.sB), convert_int_rtz(v.sC), convert_int_rtz(v.sD), convert_int_rtz(v.sE), convert_int_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtp(float16 v) {\n"
"  return (int16)(convert_int_rtp(v.s0), convert_int_rtp(v.s1), convert_int_rtp(v.s2), convert_int_rtp(v.s3), convert_int_rtp(v.s4), convert_int_rtp(v.s5), convert_int_rtp(v.s6), convert_int_rtp(v.s7), convert_int_rtp(v.s8), convert_int_rtp(v.s9), convert_int_rtp(v.sA), convert_int_rtp(v.sB), convert_int_rtp(v.sC), convert_int_rtp(v.sD), convert_int_rtp(v.sE), convert_int_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_rtn(float16 v) {\n"
"  return (int16)(convert_int_rtn(v.s0), convert_int_rtn(v.s1), convert_int_rtn(v.s2), convert_int_rtn(v.s3), convert_int_rtn(v.s4), convert_int_rtn(v.s5), convert_int_rtn(v.s6), convert_int_rtn(v.s7), convert_int_rtn(v.s8), convert_int_rtn(v.s9), convert_int_rtn(v.sA), convert_int_rtn(v.sB), convert_int_rtn(v.sC), convert_int_rtn(v.sD), convert_int_rtn(v.sE), convert_int_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rte(float16 v) {\n"
"  return (uint16)(convert_uint_rte(v.s0), convert_uint_rte(v.s1), convert_uint_rte(v.s2), convert_uint_rte(v.s3), convert_uint_rte(v.s4), convert_uint_rte(v.s5), convert_uint_rte(v.s6), convert_uint_rte(v.s7), convert_uint_rte(v.s8), convert_uint_rte(v.s9), convert_uint_rte(v.sA), convert_uint_rte(v.sB), convert_uint_rte(v.sC), convert_uint_rte(v.sD), convert_uint_rte(v.sE), convert_uint_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtz(float16 v) {\n"
"  return (uint16)(convert_uint_rtz(v.s0), convert_uint_rtz(v.s1), convert_uint_rtz(v.s2), convert_uint_rtz(v.s3), convert_uint_rtz(v.s4), convert_uint_rtz(v.s5), convert_uint_rtz(v.s6), convert_uint_rtz(v.s7), convert_uint_rtz(v.s8), convert_uint_rtz(v.s9), convert_uint_rtz(v.sA), convert_uint_rtz(v.sB), convert_uint_rtz(v.sC), convert_uint_rtz(v.sD), convert_uint_rtz(v.sE), convert_uint_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtp(float16 v) {\n"
"  return (uint16)(convert_uint_rtp(v.s0), convert_uint_rtp(v.s1), convert_uint_rtp(v.s2), convert_uint_rtp(v.s3), convert_uint_rtp(v.s4), convert_uint_rtp(v.s5), convert_uint_rtp(v.s6), convert_uint_rtp(v.s7), convert_uint_rtp(v.s8), convert_uint_rtp(v.s9), convert_uint_rtp(v.sA), convert_uint_rtp(v.sB), convert_uint_rtp(v.sC), convert_uint_rtp(v.sD), convert_uint_rtp(v.sE), convert_uint_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_rtn(float16 v) {\n"
"  return (uint16)(convert_uint_rtn(v.s0), convert_uint_rtn(v.s1), convert_uint_rtn(v.s2), convert_uint_rtn(v.s3), convert_uint_rtn(v.s4), convert_uint_rtn(v.s5), convert_uint_rtn(v.s6), convert_uint_rtn(v.s7), convert_uint_rtn(v.s8), convert_uint_rtn(v.s9), convert_uint_rtn(v.sA), convert_uint_rtn(v.sB), convert_uint_rtn(v.sC), convert_uint_rtn(v.sD), convert_uint_rtn(v.sE), convert_uint_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rte(float16 v) {\n"
"  return (short16)(convert_short_rte(v.s0), convert_short_rte(v.s1), convert_short_rte(v.s2), convert_short_rte(v.s3), convert_short_rte(v.s4), convert_short_rte(v.s5), convert_short_rte(v.s6), convert_short_rte(v.s7), convert_short_rte(v.s8), convert_short_rte(v.s9), convert_short_rte(v.sA), convert_short_rte(v.sB), convert_short_rte(v.sC), convert_short_rte(v.sD), convert_short_rte(v.sE), convert_short_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtz(float16 v) {\n"
"  return (short16)(convert_short_rtz(v.s0), convert_short_rtz(v.s1), convert_short_rtz(v.s2), convert_short_rtz(v.s3), convert_short_rtz(v.s4), convert_short_rtz(v.s5), convert_short_rtz(v.s6), convert_short_rtz(v.s7), convert_short_rtz(v.s8), convert_short_rtz(v.s9), convert_short_rtz(v.sA), convert_short_rtz(v.sB), convert_short_rtz(v.sC), convert_short_rtz(v.sD), convert_short_rtz(v.sE), convert_short_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtp(float16 v) {\n"
"  return (short16)(convert_short_rtp(v.s0), convert_short_rtp(v.s1), convert_short_rtp(v.s2), convert_short_rtp(v.s3), convert_short_rtp(v.s4), convert_short_rtp(v.s5), convert_short_rtp(v.s6), convert_short_rtp(v.s7), convert_short_rtp(v.s8), convert_short_rtp(v.s9), convert_short_rtp(v.sA), convert_short_rtp(v.sB), convert_short_rtp(v.sC), convert_short_rtp(v.sD), convert_short_rtp(v.sE), convert_short_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_rtn(float16 v) {\n"
"  return (short16)(convert_short_rtn(v.s0), convert_short_rtn(v.s1), convert_short_rtn(v.s2), convert_short_rtn(v.s3), convert_short_rtn(v.s4), convert_short_rtn(v.s5), convert_short_rtn(v.s6), convert_short_rtn(v.s7), convert_short_rtn(v.s8), convert_short_rtn(v.s9), convert_short_rtn(v.sA), convert_short_rtn(v.sB), convert_short_rtn(v.sC), convert_short_rtn(v.sD), convert_short_rtn(v.sE), convert_short_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rte(float16 v) {\n"
"  return (ushort16)(convert_ushort_rte(v.s0), convert_ushort_rte(v.s1), convert_ushort_rte(v.s2), convert_ushort_rte(v.s3), convert_ushort_rte(v.s4), convert_ushort_rte(v.s5), convert_ushort_rte(v.s6), convert_ushort_rte(v.s7), convert_ushort_rte(v.s8), convert_ushort_rte(v.s9), convert_ushort_rte(v.sA), convert_ushort_rte(v.sB), convert_ushort_rte(v.sC), convert_ushort_rte(v.sD), convert_ushort_rte(v.sE), convert_ushort_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtz(float16 v) {\n"
"  return (ushort16)(convert_ushort_rtz(v.s0), convert_ushort_rtz(v.s1), convert_ushort_rtz(v.s2), convert_ushort_rtz(v.s3), convert_ushort_rtz(v.s4), convert_ushort_rtz(v.s5), convert_ushort_rtz(v.s6), convert_ushort_rtz(v.s7), convert_ushort_rtz(v.s8), convert_ushort_rtz(v.s9), convert_ushort_rtz(v.sA), convert_ushort_rtz(v.sB), convert_ushort_rtz(v.sC), convert_ushort_rtz(v.sD), convert_ushort_rtz(v.sE), convert_ushort_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtp(float16 v) {\n"
"  return (ushort16)(convert_ushort_rtp(v.s0), convert_ushort_rtp(v.s1), convert_ushort_rtp(v.s2), convert_ushort_rtp(v.s3), convert_ushort_rtp(v.s4), convert_ushort_rtp(v.s5), convert_ushort_rtp(v.s6), convert_ushort_rtp(v.s7), convert_ushort_rtp(v.s8), convert_ushort_rtp(v.s9), convert_ushort_rtp(v.sA), convert_ushort_rtp(v.sB), convert_ushort_rtp(v.sC), convert_ushort_rtp(v.sD), convert_ushort_rtp(v.sE), convert_ushort_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_rtn(float16 v) {\n"
"  return (ushort16)(convert_ushort_rtn(v.s0), convert_ushort_rtn(v.s1), convert_ushort_rtn(v.s2), convert_ushort_rtn(v.s3), convert_ushort_rtn(v.s4), convert_ushort_rtn(v.s5), convert_ushort_rtn(v.s6), convert_ushort_rtn(v.s7), convert_ushort_rtn(v.s8), convert_ushort_rtn(v.s9), convert_ushort_rtn(v.sA), convert_ushort_rtn(v.sB), convert_ushort_rtn(v.sC), convert_ushort_rtn(v.sD), convert_ushort_rtn(v.sE), convert_ushort_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rte(float16 v) {\n"
"  return (char16)(convert_char_rte(v.s0), convert_char_rte(v.s1), convert_char_rte(v.s2), convert_char_rte(v.s3), convert_char_rte(v.s4), convert_char_rte(v.s5), convert_char_rte(v.s6), convert_char_rte(v.s7), convert_char_rte(v.s8), convert_char_rte(v.s9), convert_char_rte(v.sA), convert_char_rte(v.sB), convert_char_rte(v.sC), convert_char_rte(v.sD), convert_char_rte(v.sE), convert_char_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtz(float16 v) {\n"
"  return (char16)(convert_char_rtz(v.s0), convert_char_rtz(v.s1), convert_char_rtz(v.s2), convert_char_rtz(v.s3), convert_char_rtz(v.s4), convert_char_rtz(v.s5), convert_char_rtz(v.s6), convert_char_rtz(v.s7), convert_char_rtz(v.s8), convert_char_rtz(v.s9), convert_char_rtz(v.sA), convert_char_rtz(v.sB), convert_char_rtz(v.sC), convert_char_rtz(v.sD), convert_char_rtz(v.sE), convert_char_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtp(float16 v) {\n"
"  return (char16)(convert_char_rtp(v.s0), convert_char_rtp(v.s1), convert_char_rtp(v.s2), convert_char_rtp(v.s3), convert_char_rtp(v.s4), convert_char_rtp(v.s5), convert_char_rtp(v.s6), convert_char_rtp(v.s7), convert_char_rtp(v.s8), convert_char_rtp(v.s9), convert_char_rtp(v.sA), convert_char_rtp(v.sB), convert_char_rtp(v.sC), convert_char_rtp(v.sD), convert_char_rtp(v.sE), convert_char_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_rtn(float16 v) {\n"
"  return (char16)(convert_char_rtn(v.s0), convert_char_rtn(v.s1), convert_char_rtn(v.s2), convert_char_rtn(v.s3), convert_char_rtn(v.s4), convert_char_rtn(v.s5), convert_char_rtn(v.s6), convert_char_rtn(v.s7), convert_char_rtn(v.s8), convert_char_rtn(v.s9), convert_char_rtn(v.sA), convert_char_rtn(v.sB), convert_char_rtn(v.sC), convert_char_rtn(v.sD), convert_char_rtn(v.sE), convert_char_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rte(float16 v) {\n"
"  return (uchar16)(convert_uchar_rte(v.s0), convert_uchar_rte(v.s1), convert_uchar_rte(v.s2), convert_uchar_rte(v.s3), convert_uchar_rte(v.s4), convert_uchar_rte(v.s5), convert_uchar_rte(v.s6), convert_uchar_rte(v.s7), convert_uchar_rte(v.s8), convert_uchar_rte(v.s9), convert_uchar_rte(v.sA), convert_uchar_rte(v.sB), convert_uchar_rte(v.sC), convert_uchar_rte(v.sD), convert_uchar_rte(v.sE), convert_uchar_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtz(float16 v) {\n"
"  return (uchar16)(convert_uchar_rtz(v.s0), convert_uchar_rtz(v.s1), convert_uchar_rtz(v.s2), convert_uchar_rtz(v.s3), convert_uchar_rtz(v.s4), convert_uchar_rtz(v.s5), convert_uchar_rtz(v.s6), convert_uchar_rtz(v.s7), convert_uchar_rtz(v.s8), convert_uchar_rtz(v.s9), convert_uchar_rtz(v.sA), convert_uchar_rtz(v.sB), convert_uchar_rtz(v.sC), convert_uchar_rtz(v.sD), convert_uchar_rtz(v.sE), convert_uchar_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtp(float16 v) {\n"
"  return (uchar16)(convert_uchar_rtp(v.s0), convert_uchar_rtp(v.s1), convert_uchar_rtp(v.s2), convert_uchar_rtp(v.s3), convert_uchar_rtp(v.s4), convert_uchar_rtp(v.s5), convert_uchar_rtp(v.s6), convert_uchar_rtp(v.s7), convert_uchar_rtp(v.s8), convert_uchar_rtp(v.s9), convert_uchar_rtp(v.sA), convert_uchar_rtp(v.sB), convert_uchar_rtp(v.sC), convert_uchar_rtp(v.sD), convert_uchar_rtp(v.sE), convert_uchar_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_rtn(float16 v) {\n"
"  return (uchar16)(convert_uchar_rtn(v.s0), convert_uchar_rtn(v.s1), convert_uchar_rtn(v.s2), convert_uchar_rtn(v.s3), convert_uchar_rtn(v.s4), convert_uchar_rtn(v.s5), convert_uchar_rtn(v.s6), convert_uchar_rtn(v.s7), convert_uchar_rtn(v.s8), convert_uchar_rtn(v.s9), convert_uchar_rtn(v.sA), convert_uchar_rtn(v.sB), convert_uchar_rtn(v.sC), convert_uchar_rtn(v.sD), convert_uchar_rtn(v.sE), convert_uchar_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rte(float16 v) {\n"
"  return (float16)(convert_float_rte(v.s0), convert_float_rte(v.s1), convert_float_rte(v.s2), convert_float_rte(v.s3), convert_float_rte(v.s4), convert_float_rte(v.s5), convert_float_rte(v.s6), convert_float_rte(v.s7), convert_float_rte(v.s8), convert_float_rte(v.s9), convert_float_rte(v.sA), convert_float_rte(v.sB), convert_float_rte(v.sC), convert_float_rte(v.sD), convert_float_rte(v.sE), convert_float_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtz(float16 v) {\n"
"  return (float16)(convert_float_rtz(v.s0), convert_float_rtz(v.s1), convert_float_rtz(v.s2), convert_float_rtz(v.s3), convert_float_rtz(v.s4), convert_float_rtz(v.s5), convert_float_rtz(v.s6), convert_float_rtz(v.s7), convert_float_rtz(v.s8), convert_float_rtz(v.s9), convert_float_rtz(v.sA), convert_float_rtz(v.sB), convert_float_rtz(v.sC), convert_float_rtz(v.sD), convert_float_rtz(v.sE), convert_float_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtp(float16 v) {\n"
"  return (float16)(convert_float_rtp(v.s0), convert_float_rtp(v.s1), convert_float_rtp(v.s2), convert_float_rtp(v.s3), convert_float_rtp(v.s4), convert_float_rtp(v.s5), convert_float_rtp(v.s6), convert_float_rtp(v.s7), convert_float_rtp(v.s8), convert_float_rtp(v.s9), convert_float_rtp(v.sA), convert_float_rtp(v.sB), convert_float_rtp(v.sC), convert_float_rtp(v.sD), convert_float_rtp(v.sE), convert_float_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE float16 convert_float16_rtn(float16 v) {\n"
"  return (float16)(convert_float_rtn(v.s0), convert_float_rtn(v.s1), convert_float_rtn(v.s2), convert_float_rtn(v.s3), convert_float_rtn(v.s4), convert_float_rtn(v.s5), convert_float_rtn(v.s6), convert_float_rtn(v.s7), convert_float_rtn(v.s8), convert_float_rtn(v.s9), convert_float_rtn(v.sA), convert_float_rtn(v.sB), convert_float_rtn(v.sC), convert_float_rtn(v.sD), convert_float_rtn(v.sE), convert_float_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(long x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(long x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(long x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(long x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(long x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(long x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(long x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(long x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(long x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(long x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(long x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(long x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(long x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(long x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(long x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(long x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(long x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(long x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(long x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(long x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(long x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(long x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(long x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(long x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(long x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(long x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(long x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(long x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(long x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(long x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(long x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(long x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(ulong x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(ulong x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(ulong x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(ulong x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(ulong x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(ulong x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(ulong x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(ulong x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(ulong x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(ulong x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(ulong x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(ulong x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(ulong x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(ulong x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(ulong x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(ulong x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(ulong x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(ulong x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(ulong x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(ulong x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(ulong x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(ulong x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(ulong x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(ulong x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(ulong x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(ulong x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(ulong x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(ulong x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(ulong x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(ulong x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(ulong x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(ulong x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(int x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(int x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(int x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(int x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(int x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(int x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(int x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(int x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(int x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(int x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(int x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(int x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(int x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(int x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(int x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(int x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(int x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(int x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(int x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(int x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(int x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(int x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(int x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(int x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(int x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(int x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(int x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(int x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(int x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(int x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(int x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(int x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(uint x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(uint x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(uint x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(uint x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(uint x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(uint x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(uint x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(uint x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(uint x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(uint x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(uint x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(uint x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(uint x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(uint x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(uint x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(uint x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(uint x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(uint x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(uint x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(uint x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(uint x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(uint x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(uint x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(uint x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(uint x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(uint x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(uint x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(uint x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(uint x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(uint x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(uint x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(uint x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(short x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(short x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(short x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(short x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(short x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(short x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(short x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(short x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(short x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(short x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(short x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(short x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(short x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(short x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(short x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(short x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(short x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(short x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(short x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(short x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(short x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(short x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(short x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(short x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(short x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(short x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(short x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(short x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(short x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(short x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(short x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(short x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(ushort x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(ushort x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(ushort x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(ushort x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(ushort x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(ushort x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(ushort x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(ushort x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(ushort x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(ushort x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(ushort x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(ushort x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(ushort x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(ushort x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(ushort x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(ushort x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(ushort x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(ushort x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(ushort x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(ushort x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(ushort x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(ushort x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(ushort x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(ushort x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(ushort x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(ushort x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(ushort x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(ushort x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(ushort x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(ushort x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(ushort x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(ushort x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(char x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(char x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(char x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(char x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(char x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(char x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(char x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(char x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(char x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(char x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(char x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(char x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(char x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(char x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(char x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(char x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(char x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(char x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(char x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(char x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(char x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(char x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(char x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(char x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(char x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(char x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(char x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(char x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(char x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(char x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(char x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(char x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(uchar x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(uchar x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(uchar x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(uchar x)\n"
"{ return convert_long_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(uchar x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(uchar x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(uchar x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(uchar x)\n"
"{ return convert_ulong_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(uchar x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(uchar x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(uchar x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(uchar x)\n"
"{ return convert_int_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(uchar x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(uchar x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(uchar x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(uchar x)\n"
"{ return convert_uint_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(uchar x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(uchar x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(uchar x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(uchar x)\n"
"{ return convert_short_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(uchar x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(uchar x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(uchar x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(uchar x)\n"
"{ return convert_ushort_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(uchar x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(uchar x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(uchar x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(uchar x)\n"
"{ return convert_char_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(uchar x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(uchar x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(uchar x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(uchar x)\n"
"{ return convert_uchar_sat(x); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rte(float x)\n"
"{ return convert_long_sat(__gen_ocl_rnde(x)); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtz(float x)\n"
"{ return convert_long_sat(__gen_ocl_rndz(x)); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtp(float x)\n"
"{ return convert_long_sat(__gen_ocl_rndu(x)); }\n"
"INLINE_OVERLOADABLE long convert_long_sat_rtn(float x)\n"
"{ return convert_long_sat(__gen_ocl_rndd(x)); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rte(float x)\n"
"{ return convert_ulong_sat(__gen_ocl_rnde(x)); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtz(float x)\n"
"{ return convert_ulong_sat(__gen_ocl_rndz(x)); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtp(float x)\n"
"{ return convert_ulong_sat(__gen_ocl_rndu(x)); }\n"
"INLINE_OVERLOADABLE ulong convert_ulong_sat_rtn(float x)\n"
"{ return convert_ulong_sat(__gen_ocl_rndd(x)); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rte(float x)\n"
"{ return convert_int_sat(__gen_ocl_rnde(x)); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtz(float x)\n"
"{ return convert_int_sat(__gen_ocl_rndz(x)); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtp(float x)\n"
"{ return convert_int_sat(__gen_ocl_rndu(x)); }\n"
"INLINE_OVERLOADABLE int convert_int_sat_rtn(float x)\n"
"{ return convert_int_sat(__gen_ocl_rndd(x)); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rte(float x)\n"
"{ return convert_uint_sat(__gen_ocl_rnde(x)); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtz(float x)\n"
"{ return convert_uint_sat(__gen_ocl_rndz(x)); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtp(float x)\n"
"{ return convert_uint_sat(__gen_ocl_rndu(x)); }\n"
"INLINE_OVERLOADABLE uint convert_uint_sat_rtn(float x)\n"
"{ return convert_uint_sat(__gen_ocl_rndd(x)); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rte(float x)\n"
"{ return convert_short_sat(__gen_ocl_rnde(x)); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtz(float x)\n"
"{ return convert_short_sat(__gen_ocl_rndz(x)); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtp(float x)\n"
"{ return convert_short_sat(__gen_ocl_rndu(x)); }\n"
"INLINE_OVERLOADABLE short convert_short_sat_rtn(float x)\n"
"{ return convert_short_sat(__gen_ocl_rndd(x)); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rte(float x)\n"
"{ return convert_ushort_sat(__gen_ocl_rnde(x)); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtz(float x)\n"
"{ return convert_ushort_sat(__gen_ocl_rndz(x)); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtp(float x)\n"
"{ return convert_ushort_sat(__gen_ocl_rndu(x)); }\n"
"INLINE_OVERLOADABLE ushort convert_ushort_sat_rtn(float x)\n"
"{ return convert_ushort_sat(__gen_ocl_rndd(x)); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rte(float x)\n"
"{ return convert_char_sat(__gen_ocl_rnde(x)); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtz(float x)\n"
"{ return convert_char_sat(__gen_ocl_rndz(x)); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtp(float x)\n"
"{ return convert_char_sat(__gen_ocl_rndu(x)); }\n"
"INLINE_OVERLOADABLE char convert_char_sat_rtn(float x)\n"
"{ return convert_char_sat(__gen_ocl_rndd(x)); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rte(float x)\n"
"{ return convert_uchar_sat(__gen_ocl_rnde(x)); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtz(float x)\n"
"{ return convert_uchar_sat(__gen_ocl_rndz(x)); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtp(float x)\n"
"{ return convert_uchar_sat(__gen_ocl_rndu(x)); }\n"
"INLINE_OVERLOADABLE uchar convert_uchar_sat_rtn(float x)\n"
"{ return convert_uchar_sat(__gen_ocl_rndd(x)); }\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(long2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(long2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(long2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(long2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(long2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(long2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(long2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(long2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(long2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(long2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(long2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(long2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(long2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(long2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(long2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(long2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(long2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(long2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(long2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(long2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(long2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(long2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(long2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(long2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(long2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(long2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(long2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(long2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(long2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(long2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(long2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(long2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(ulong2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(ulong2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(ulong2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(ulong2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(ulong2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(ulong2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(ulong2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(ulong2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(ulong2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(ulong2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(ulong2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(ulong2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(ulong2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(ulong2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(ulong2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(ulong2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(ulong2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(ulong2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(ulong2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(ulong2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(ulong2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(ulong2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(ulong2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(int2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(int2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(int2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(int2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(int2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(int2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(int2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(int2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(int2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(int2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(int2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(int2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(int2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(int2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(int2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(int2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(int2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(int2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(int2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(int2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(int2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(int2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(int2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(int2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(int2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(int2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(int2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(int2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(int2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(int2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(int2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(int2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(uint2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(uint2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(uint2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(uint2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(uint2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(uint2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(uint2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(uint2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(uint2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(uint2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(uint2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(uint2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(uint2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(uint2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(uint2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(uint2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(uint2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(uint2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(uint2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(uint2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(uint2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(uint2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(uint2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(uint2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(uint2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(uint2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(uint2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(uint2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(uint2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(uint2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(uint2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(uint2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(short2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(short2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(short2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(short2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(short2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(short2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(short2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(short2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(short2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(short2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(short2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(short2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(short2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(short2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(short2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(short2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(short2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(short2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(short2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(short2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(short2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(short2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(short2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(short2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(short2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(short2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(short2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(short2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(short2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(short2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(short2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(short2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(ushort2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(ushort2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(ushort2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(ushort2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(ushort2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(ushort2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(ushort2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(ushort2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(ushort2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(ushort2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(ushort2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(ushort2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(ushort2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(ushort2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(ushort2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(ushort2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(ushort2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(ushort2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(ushort2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(ushort2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(ushort2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(ushort2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(ushort2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(char2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(char2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(char2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(char2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(char2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(char2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(char2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(char2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(char2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(char2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(char2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(char2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(char2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(char2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(char2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(char2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(char2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(char2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(char2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(char2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(char2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(char2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(char2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(char2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(char2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(char2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(char2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(char2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(char2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(char2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(char2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(char2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(uchar2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(uchar2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(uchar2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(uchar2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(uchar2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(uchar2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(uchar2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(uchar2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(uchar2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(uchar2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(uchar2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(uchar2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(uchar2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(uchar2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(uchar2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(uchar2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(uchar2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(uchar2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(uchar2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(uchar2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(uchar2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(uchar2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(uchar2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rte(float2 v) {\n"
"  return (long2)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtz(float2 v) {\n"
"  return (long2)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtp(float2 v) {\n"
"  return (long2)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long2 convert_long2_sat_rtn(float2 v) {\n"
"  return (long2)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rte(float2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtz(float2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtp(float2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong2 convert_ulong2_sat_rtn(float2 v) {\n"
"  return (ulong2)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rte(float2 v) {\n"
"  return (int2)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtz(float2 v) {\n"
"  return (int2)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtp(float2 v) {\n"
"  return (int2)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int2 convert_int2_sat_rtn(float2 v) {\n"
"  return (int2)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rte(float2 v) {\n"
"  return (uint2)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtz(float2 v) {\n"
"  return (uint2)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtp(float2 v) {\n"
"  return (uint2)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint2 convert_uint2_sat_rtn(float2 v) {\n"
"  return (uint2)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rte(float2 v) {\n"
"  return (short2)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtz(float2 v) {\n"
"  return (short2)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtp(float2 v) {\n"
"  return (short2)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short2 convert_short2_sat_rtn(float2 v) {\n"
"  return (short2)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rte(float2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtz(float2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtp(float2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort2 convert_ushort2_sat_rtn(float2 v) {\n"
"  return (ushort2)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rte(float2 v) {\n"
"  return (char2)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtz(float2 v) {\n"
"  return (char2)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtp(float2 v) {\n"
"  return (char2)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char2 convert_char2_sat_rtn(float2 v) {\n"
"  return (char2)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rte(float2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtz(float2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtp(float2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar2 convert_uchar2_sat_rtn(float2 v) {\n"
"  return (uchar2)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(long3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(long3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(long3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(long3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(long3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(long3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(long3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(long3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(long3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(long3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(long3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(long3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(long3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(long3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(long3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(long3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(long3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(long3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(long3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(long3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(long3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(long3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(long3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(long3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(long3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(long3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(long3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(long3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(long3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(long3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(long3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(long3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(ulong3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(ulong3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(ulong3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(ulong3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(ulong3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(ulong3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(ulong3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(ulong3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(ulong3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(ulong3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(ulong3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(ulong3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(ulong3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(ulong3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(ulong3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(ulong3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(ulong3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(ulong3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(ulong3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(ulong3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(ulong3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(ulong3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(ulong3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(int3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(int3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(int3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(int3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(int3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(int3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(int3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(int3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(int3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(int3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(int3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(int3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(int3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(int3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(int3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(int3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(int3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(int3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(int3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(int3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(int3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(int3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(int3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(int3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(int3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(int3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(int3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(int3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(int3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(int3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(int3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(int3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(uint3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(uint3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(uint3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(uint3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(uint3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(uint3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(uint3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(uint3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(uint3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(uint3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(uint3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(uint3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(uint3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(uint3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(uint3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(uint3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(uint3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(uint3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(uint3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(uint3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(uint3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(uint3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(uint3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(uint3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(uint3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(uint3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(uint3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(uint3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(uint3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(uint3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(uint3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(uint3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(short3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(short3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(short3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(short3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(short3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(short3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(short3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(short3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(short3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(short3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(short3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(short3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(short3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(short3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(short3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(short3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(short3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(short3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(short3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(short3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(short3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(short3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(short3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(short3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(short3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(short3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(short3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(short3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(short3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(short3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(short3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(short3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(ushort3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(ushort3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(ushort3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(ushort3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(ushort3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(ushort3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(ushort3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(ushort3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(ushort3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(ushort3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(ushort3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(ushort3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(ushort3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(ushort3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(ushort3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(ushort3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(ushort3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(ushort3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(ushort3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(ushort3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(ushort3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(ushort3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(ushort3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(char3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(char3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(char3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(char3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(char3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(char3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(char3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(char3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(char3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(char3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(char3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(char3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(char3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(char3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(char3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(char3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(char3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(char3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(char3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(char3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(char3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(char3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(char3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(char3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(char3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(char3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(char3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(char3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(char3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(char3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(char3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(char3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(uchar3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(uchar3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(uchar3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(uchar3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(uchar3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(uchar3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(uchar3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(uchar3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(uchar3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(uchar3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(uchar3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(uchar3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(uchar3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(uchar3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(uchar3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(uchar3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(uchar3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(uchar3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(uchar3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(uchar3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(uchar3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(uchar3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(uchar3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rte(float3 v) {\n"
"  return (long3)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtz(float3 v) {\n"
"  return (long3)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtp(float3 v) {\n"
"  return (long3)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long3 convert_long3_sat_rtn(float3 v) {\n"
"  return (long3)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rte(float3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtz(float3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtp(float3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong3 convert_ulong3_sat_rtn(float3 v) {\n"
"  return (ulong3)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rte(float3 v) {\n"
"  return (int3)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtz(float3 v) {\n"
"  return (int3)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtp(float3 v) {\n"
"  return (int3)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int3 convert_int3_sat_rtn(float3 v) {\n"
"  return (int3)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rte(float3 v) {\n"
"  return (uint3)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtz(float3 v) {\n"
"  return (uint3)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtp(float3 v) {\n"
"  return (uint3)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint3 convert_uint3_sat_rtn(float3 v) {\n"
"  return (uint3)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rte(float3 v) {\n"
"  return (short3)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtz(float3 v) {\n"
"  return (short3)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtp(float3 v) {\n"
"  return (short3)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short3 convert_short3_sat_rtn(float3 v) {\n"
"  return (short3)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rte(float3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtz(float3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtp(float3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort3 convert_ushort3_sat_rtn(float3 v) {\n"
"  return (ushort3)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rte(float3 v) {\n"
"  return (char3)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtz(float3 v) {\n"
"  return (char3)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtp(float3 v) {\n"
"  return (char3)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char3 convert_char3_sat_rtn(float3 v) {\n"
"  return (char3)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rte(float3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtz(float3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtp(float3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar3 convert_uchar3_sat_rtn(float3 v) {\n"
"  return (uchar3)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(long4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(long4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(long4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(long4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(long4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(long4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(long4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(long4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(long4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(long4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(long4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(long4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(long4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(long4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(long4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(long4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(long4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(long4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(long4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(long4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(long4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(long4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(long4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(long4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(long4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(long4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(long4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(long4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(long4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(long4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(long4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(long4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(ulong4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(ulong4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(ulong4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(ulong4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(ulong4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(ulong4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(ulong4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(ulong4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(ulong4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(ulong4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(ulong4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(ulong4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(ulong4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(ulong4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(ulong4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(ulong4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(ulong4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(ulong4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(ulong4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(ulong4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(ulong4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(ulong4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(ulong4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(int4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(int4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(int4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(int4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(int4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(int4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(int4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(int4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(int4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(int4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(int4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(int4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(int4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(int4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(int4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(int4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(int4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(int4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(int4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(int4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(int4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(int4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(int4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(int4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(int4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(int4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(int4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(int4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(int4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(int4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(int4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(int4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(uint4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(uint4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(uint4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(uint4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(uint4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(uint4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(uint4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(uint4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(uint4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(uint4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(uint4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(uint4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(uint4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(uint4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(uint4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(uint4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(uint4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(uint4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(uint4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(uint4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(uint4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(uint4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(uint4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(uint4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(uint4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(uint4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(uint4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(uint4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(uint4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(uint4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(uint4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(uint4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(short4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(short4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(short4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(short4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(short4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(short4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(short4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(short4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(short4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(short4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(short4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(short4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(short4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(short4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(short4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(short4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(short4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(short4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(short4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(short4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(short4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(short4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(short4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(short4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(short4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(short4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(short4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(short4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(short4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(short4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(short4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(short4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(ushort4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(ushort4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(ushort4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(ushort4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(ushort4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(ushort4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(ushort4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(ushort4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(ushort4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(ushort4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(ushort4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(ushort4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(ushort4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(ushort4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(ushort4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(ushort4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(ushort4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(ushort4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(ushort4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(ushort4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(ushort4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(ushort4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(ushort4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(char4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(char4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(char4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(char4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(char4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(char4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(char4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(char4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(char4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(char4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(char4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(char4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(char4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(char4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(char4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(char4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(char4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(char4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(char4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(char4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(char4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(char4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(char4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(char4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(char4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(char4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(char4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(char4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(char4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(char4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(char4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(char4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(uchar4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(uchar4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(uchar4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(uchar4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(uchar4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(uchar4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(uchar4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(uchar4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(uchar4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(uchar4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(uchar4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(uchar4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(uchar4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(uchar4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(uchar4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(uchar4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(uchar4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(uchar4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(uchar4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(uchar4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(uchar4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(uchar4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(uchar4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rte(float4 v) {\n"
"  return (long4)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtz(float4 v) {\n"
"  return (long4)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtp(float4 v) {\n"
"  return (long4)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long4 convert_long4_sat_rtn(float4 v) {\n"
"  return (long4)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rte(float4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtz(float4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtp(float4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong4 convert_ulong4_sat_rtn(float4 v) {\n"
"  return (ulong4)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rte(float4 v) {\n"
"  return (int4)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtz(float4 v) {\n"
"  return (int4)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtp(float4 v) {\n"
"  return (int4)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int4 convert_int4_sat_rtn(float4 v) {\n"
"  return (int4)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rte(float4 v) {\n"
"  return (uint4)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtz(float4 v) {\n"
"  return (uint4)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtp(float4 v) {\n"
"  return (uint4)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint4 convert_uint4_sat_rtn(float4 v) {\n"
"  return (uint4)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rte(float4 v) {\n"
"  return (short4)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtz(float4 v) {\n"
"  return (short4)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtp(float4 v) {\n"
"  return (short4)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short4 convert_short4_sat_rtn(float4 v) {\n"
"  return (short4)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rte(float4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtz(float4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtp(float4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort4 convert_ushort4_sat_rtn(float4 v) {\n"
"  return (ushort4)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rte(float4 v) {\n"
"  return (char4)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtz(float4 v) {\n"
"  return (char4)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtp(float4 v) {\n"
"  return (char4)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char4 convert_char4_sat_rtn(float4 v) {\n"
"  return (char4)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rte(float4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtz(float4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtp(float4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar4 convert_uchar4_sat_rtn(float4 v) {\n"
"  return (uchar4)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(long8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(long8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(long8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(long8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(long8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(long8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(long8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(long8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(long8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(long8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(long8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(long8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(long8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(long8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(long8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(long8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(long8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(long8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(long8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(long8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(long8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(long8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(long8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(long8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(long8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(long8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(long8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(long8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(long8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(long8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(long8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(long8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(ulong8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(ulong8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(ulong8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(ulong8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(ulong8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(ulong8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(ulong8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(ulong8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(ulong8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(ulong8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(ulong8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(ulong8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(ulong8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(ulong8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(ulong8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(ulong8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(ulong8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(ulong8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(ulong8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(ulong8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(ulong8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(ulong8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(ulong8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(int8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(int8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(int8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(int8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(int8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(int8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(int8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(int8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(int8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(int8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(int8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(int8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(int8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(int8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(int8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(int8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(int8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(int8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(int8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(int8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(int8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(int8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(int8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(int8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(int8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(int8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(int8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(int8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(int8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(int8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(int8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(int8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(uint8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(uint8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(uint8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(uint8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(uint8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(uint8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(uint8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(uint8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(uint8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(uint8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(uint8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(uint8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(uint8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(uint8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(uint8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(uint8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(uint8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(uint8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(uint8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(uint8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(uint8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(uint8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(uint8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(uint8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(uint8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(uint8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(uint8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(uint8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(uint8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(uint8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(uint8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(uint8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(short8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(short8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(short8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(short8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(short8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(short8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(short8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(short8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(short8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(short8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(short8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(short8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(short8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(short8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(short8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(short8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(short8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(short8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(short8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(short8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(short8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(short8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(short8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(short8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(short8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(short8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(short8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(short8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(short8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(short8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(short8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(short8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(ushort8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(ushort8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(ushort8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(ushort8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(ushort8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(ushort8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(ushort8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(ushort8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(ushort8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(ushort8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(ushort8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(ushort8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(ushort8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(ushort8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(ushort8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(ushort8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(ushort8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(ushort8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(ushort8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(ushort8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(ushort8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(ushort8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(ushort8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(char8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(char8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(char8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(char8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(char8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(char8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(char8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(char8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(char8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(char8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(char8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(char8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(char8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(char8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(char8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(char8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(char8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(char8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(char8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(char8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(char8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(char8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(char8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(char8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(char8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(char8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(char8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(char8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(char8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(char8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(char8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(char8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(uchar8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(uchar8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(uchar8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(uchar8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(uchar8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(uchar8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(uchar8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(uchar8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(uchar8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(uchar8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(uchar8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(uchar8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(uchar8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(uchar8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(uchar8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(uchar8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(uchar8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(uchar8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(uchar8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(uchar8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(uchar8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(uchar8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(uchar8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rte(float8 v) {\n"
"  return (long8)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtz(float8 v) {\n"
"  return (long8)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtp(float8 v) {\n"
"  return (long8)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long8 convert_long8_sat_rtn(float8 v) {\n"
"  return (long8)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rte(float8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtz(float8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtp(float8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong8 convert_ulong8_sat_rtn(float8 v) {\n"
"  return (ulong8)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rte(float8 v) {\n"
"  return (int8)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtz(float8 v) {\n"
"  return (int8)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtp(float8 v) {\n"
"  return (int8)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int8 convert_int8_sat_rtn(float8 v) {\n"
"  return (int8)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rte(float8 v) {\n"
"  return (uint8)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtz(float8 v) {\n"
"  return (uint8)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtp(float8 v) {\n"
"  return (uint8)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint8 convert_uint8_sat_rtn(float8 v) {\n"
"  return (uint8)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rte(float8 v) {\n"
"  return (short8)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtz(float8 v) {\n"
"  return (short8)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtp(float8 v) {\n"
"  return (short8)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short8 convert_short8_sat_rtn(float8 v) {\n"
"  return (short8)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rte(float8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtz(float8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtp(float8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort8 convert_ushort8_sat_rtn(float8 v) {\n"
"  return (ushort8)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rte(float8 v) {\n"
"  return (char8)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtz(float8 v) {\n"
"  return (char8)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtp(float8 v) {\n"
"  return (char8)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char8 convert_char8_sat_rtn(float8 v) {\n"
"  return (char8)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rte(float8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtz(float8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtp(float8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar8 convert_uchar8_sat_rtn(float8 v) {\n"
"  return (uchar8)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(long16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(long16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(long16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(long16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(long16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(long16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(long16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(long16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(long16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(long16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(long16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(long16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(long16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(long16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(long16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(long16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(long16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(long16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(long16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(long16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(long16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(long16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(long16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(long16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(long16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(long16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(long16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(long16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(long16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(long16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(long16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(long16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(ulong16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(ulong16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(ulong16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(ulong16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(ulong16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(ulong16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(ulong16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(ulong16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(ulong16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(ulong16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(ulong16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(ulong16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(ulong16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(ulong16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(ulong16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(ulong16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(ulong16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(ulong16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(ulong16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(ulong16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(ulong16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(ulong16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(ulong16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(int16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(int16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(int16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(int16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(int16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(int16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(int16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(int16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(int16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(int16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(int16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(int16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(int16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(int16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(int16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(int16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(int16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(int16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(int16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(int16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(int16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(int16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(int16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(int16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(int16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(int16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(int16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(int16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(int16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(int16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(int16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(int16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(uint16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(uint16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(uint16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(uint16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(uint16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(uint16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(uint16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(uint16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(uint16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(uint16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(uint16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(uint16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(uint16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(uint16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(uint16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(uint16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(uint16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(uint16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(uint16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(uint16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(uint16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(uint16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(uint16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(uint16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(uint16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(uint16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(uint16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(uint16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(uint16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(uint16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(uint16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(uint16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(short16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(short16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(short16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(short16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(short16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(short16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(short16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(short16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(short16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(short16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(short16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(short16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(short16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(short16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(short16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(short16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(short16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(short16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(short16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(short16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(short16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(short16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(short16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(short16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(short16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(short16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(short16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(short16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(short16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(short16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(short16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(short16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(ushort16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(ushort16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(ushort16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(ushort16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(ushort16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(ushort16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(ushort16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(ushort16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(ushort16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(ushort16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(ushort16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(ushort16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(ushort16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(ushort16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(ushort16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(ushort16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(ushort16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(ushort16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(ushort16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(ushort16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(ushort16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(ushort16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(ushort16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(char16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(char16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(char16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(char16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(char16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(char16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(char16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(char16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(char16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(char16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(char16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(char16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(char16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(char16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(char16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(char16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(char16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(char16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(char16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(char16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(char16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(char16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(char16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(char16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(char16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(char16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(char16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(char16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(char16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(char16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(char16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(char16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(uchar16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(uchar16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(uchar16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(uchar16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(uchar16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(uchar16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(uchar16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(uchar16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(uchar16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(uchar16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(uchar16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(uchar16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(uchar16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(uchar16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(uchar16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(uchar16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(uchar16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(uchar16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(uchar16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(uchar16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(uchar16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(uchar16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(uchar16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rte(float16 v) {\n"
"  return (long16)(convert_long_sat_rte(v.s0), convert_long_sat_rte(v.s1), convert_long_sat_rte(v.s2), convert_long_sat_rte(v.s3), convert_long_sat_rte(v.s4), convert_long_sat_rte(v.s5), convert_long_sat_rte(v.s6), convert_long_sat_rte(v.s7), convert_long_sat_rte(v.s8), convert_long_sat_rte(v.s9), convert_long_sat_rte(v.sA), convert_long_sat_rte(v.sB), convert_long_sat_rte(v.sC), convert_long_sat_rte(v.sD), convert_long_sat_rte(v.sE), convert_long_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtz(float16 v) {\n"
"  return (long16)(convert_long_sat_rtz(v.s0), convert_long_sat_rtz(v.s1), convert_long_sat_rtz(v.s2), convert_long_sat_rtz(v.s3), convert_long_sat_rtz(v.s4), convert_long_sat_rtz(v.s5), convert_long_sat_rtz(v.s6), convert_long_sat_rtz(v.s7), convert_long_sat_rtz(v.s8), convert_long_sat_rtz(v.s9), convert_long_sat_rtz(v.sA), convert_long_sat_rtz(v.sB), convert_long_sat_rtz(v.sC), convert_long_sat_rtz(v.sD), convert_long_sat_rtz(v.sE), convert_long_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtp(float16 v) {\n"
"  return (long16)(convert_long_sat_rtp(v.s0), convert_long_sat_rtp(v.s1), convert_long_sat_rtp(v.s2), convert_long_sat_rtp(v.s3), convert_long_sat_rtp(v.s4), convert_long_sat_rtp(v.s5), convert_long_sat_rtp(v.s6), convert_long_sat_rtp(v.s7), convert_long_sat_rtp(v.s8), convert_long_sat_rtp(v.s9), convert_long_sat_rtp(v.sA), convert_long_sat_rtp(v.sB), convert_long_sat_rtp(v.sC), convert_long_sat_rtp(v.sD), convert_long_sat_rtp(v.sE), convert_long_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE long16 convert_long16_sat_rtn(float16 v) {\n"
"  return (long16)(convert_long_sat_rtn(v.s0), convert_long_sat_rtn(v.s1), convert_long_sat_rtn(v.s2), convert_long_sat_rtn(v.s3), convert_long_sat_rtn(v.s4), convert_long_sat_rtn(v.s5), convert_long_sat_rtn(v.s6), convert_long_sat_rtn(v.s7), convert_long_sat_rtn(v.s8), convert_long_sat_rtn(v.s9), convert_long_sat_rtn(v.sA), convert_long_sat_rtn(v.sB), convert_long_sat_rtn(v.sC), convert_long_sat_rtn(v.sD), convert_long_sat_rtn(v.sE), convert_long_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rte(float16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rte(v.s0), convert_ulong_sat_rte(v.s1), convert_ulong_sat_rte(v.s2), convert_ulong_sat_rte(v.s3), convert_ulong_sat_rte(v.s4), convert_ulong_sat_rte(v.s5), convert_ulong_sat_rte(v.s6), convert_ulong_sat_rte(v.s7), convert_ulong_sat_rte(v.s8), convert_ulong_sat_rte(v.s9), convert_ulong_sat_rte(v.sA), convert_ulong_sat_rte(v.sB), convert_ulong_sat_rte(v.sC), convert_ulong_sat_rte(v.sD), convert_ulong_sat_rte(v.sE), convert_ulong_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtz(float16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtz(v.s0), convert_ulong_sat_rtz(v.s1), convert_ulong_sat_rtz(v.s2), convert_ulong_sat_rtz(v.s3), convert_ulong_sat_rtz(v.s4), convert_ulong_sat_rtz(v.s5), convert_ulong_sat_rtz(v.s6), convert_ulong_sat_rtz(v.s7), convert_ulong_sat_rtz(v.s8), convert_ulong_sat_rtz(v.s9), convert_ulong_sat_rtz(v.sA), convert_ulong_sat_rtz(v.sB), convert_ulong_sat_rtz(v.sC), convert_ulong_sat_rtz(v.sD), convert_ulong_sat_rtz(v.sE), convert_ulong_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtp(float16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtp(v.s0), convert_ulong_sat_rtp(v.s1), convert_ulong_sat_rtp(v.s2), convert_ulong_sat_rtp(v.s3), convert_ulong_sat_rtp(v.s4), convert_ulong_sat_rtp(v.s5), convert_ulong_sat_rtp(v.s6), convert_ulong_sat_rtp(v.s7), convert_ulong_sat_rtp(v.s8), convert_ulong_sat_rtp(v.s9), convert_ulong_sat_rtp(v.sA), convert_ulong_sat_rtp(v.sB), convert_ulong_sat_rtp(v.sC), convert_ulong_sat_rtp(v.sD), convert_ulong_sat_rtp(v.sE), convert_ulong_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ulong16 convert_ulong16_sat_rtn(float16 v) {\n"
"  return (ulong16)(convert_ulong_sat_rtn(v.s0), convert_ulong_sat_rtn(v.s1), convert_ulong_sat_rtn(v.s2), convert_ulong_sat_rtn(v.s3), convert_ulong_sat_rtn(v.s4), convert_ulong_sat_rtn(v.s5), convert_ulong_sat_rtn(v.s6), convert_ulong_sat_rtn(v.s7), convert_ulong_sat_rtn(v.s8), convert_ulong_sat_rtn(v.s9), convert_ulong_sat_rtn(v.sA), convert_ulong_sat_rtn(v.sB), convert_ulong_sat_rtn(v.sC), convert_ulong_sat_rtn(v.sD), convert_ulong_sat_rtn(v.sE), convert_ulong_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rte(float16 v) {\n"
"  return (int16)(convert_int_sat_rte(v.s0), convert_int_sat_rte(v.s1), convert_int_sat_rte(v.s2), convert_int_sat_rte(v.s3), convert_int_sat_rte(v.s4), convert_int_sat_rte(v.s5), convert_int_sat_rte(v.s6), convert_int_sat_rte(v.s7), convert_int_sat_rte(v.s8), convert_int_sat_rte(v.s9), convert_int_sat_rte(v.sA), convert_int_sat_rte(v.sB), convert_int_sat_rte(v.sC), convert_int_sat_rte(v.sD), convert_int_sat_rte(v.sE), convert_int_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtz(float16 v) {\n"
"  return (int16)(convert_int_sat_rtz(v.s0), convert_int_sat_rtz(v.s1), convert_int_sat_rtz(v.s2), convert_int_sat_rtz(v.s3), convert_int_sat_rtz(v.s4), convert_int_sat_rtz(v.s5), convert_int_sat_rtz(v.s6), convert_int_sat_rtz(v.s7), convert_int_sat_rtz(v.s8), convert_int_sat_rtz(v.s9), convert_int_sat_rtz(v.sA), convert_int_sat_rtz(v.sB), convert_int_sat_rtz(v.sC), convert_int_sat_rtz(v.sD), convert_int_sat_rtz(v.sE), convert_int_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtp(float16 v) {\n"
"  return (int16)(convert_int_sat_rtp(v.s0), convert_int_sat_rtp(v.s1), convert_int_sat_rtp(v.s2), convert_int_sat_rtp(v.s3), convert_int_sat_rtp(v.s4), convert_int_sat_rtp(v.s5), convert_int_sat_rtp(v.s6), convert_int_sat_rtp(v.s7), convert_int_sat_rtp(v.s8), convert_int_sat_rtp(v.s9), convert_int_sat_rtp(v.sA), convert_int_sat_rtp(v.sB), convert_int_sat_rtp(v.sC), convert_int_sat_rtp(v.sD), convert_int_sat_rtp(v.sE), convert_int_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE int16 convert_int16_sat_rtn(float16 v) {\n"
"  return (int16)(convert_int_sat_rtn(v.s0), convert_int_sat_rtn(v.s1), convert_int_sat_rtn(v.s2), convert_int_sat_rtn(v.s3), convert_int_sat_rtn(v.s4), convert_int_sat_rtn(v.s5), convert_int_sat_rtn(v.s6), convert_int_sat_rtn(v.s7), convert_int_sat_rtn(v.s8), convert_int_sat_rtn(v.s9), convert_int_sat_rtn(v.sA), convert_int_sat_rtn(v.sB), convert_int_sat_rtn(v.sC), convert_int_sat_rtn(v.sD), convert_int_sat_rtn(v.sE), convert_int_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rte(float16 v) {\n"
"  return (uint16)(convert_uint_sat_rte(v.s0), convert_uint_sat_rte(v.s1), convert_uint_sat_rte(v.s2), convert_uint_sat_rte(v.s3), convert_uint_sat_rte(v.s4), convert_uint_sat_rte(v.s5), convert_uint_sat_rte(v.s6), convert_uint_sat_rte(v.s7), convert_uint_sat_rte(v.s8), convert_uint_sat_rte(v.s9), convert_uint_sat_rte(v.sA), convert_uint_sat_rte(v.sB), convert_uint_sat_rte(v.sC), convert_uint_sat_rte(v.sD), convert_uint_sat_rte(v.sE), convert_uint_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtz(float16 v) {\n"
"  return (uint16)(convert_uint_sat_rtz(v.s0), convert_uint_sat_rtz(v.s1), convert_uint_sat_rtz(v.s2), convert_uint_sat_rtz(v.s3), convert_uint_sat_rtz(v.s4), convert_uint_sat_rtz(v.s5), convert_uint_sat_rtz(v.s6), convert_uint_sat_rtz(v.s7), convert_uint_sat_rtz(v.s8), convert_uint_sat_rtz(v.s9), convert_uint_sat_rtz(v.sA), convert_uint_sat_rtz(v.sB), convert_uint_sat_rtz(v.sC), convert_uint_sat_rtz(v.sD), convert_uint_sat_rtz(v.sE), convert_uint_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtp(float16 v) {\n"
"  return (uint16)(convert_uint_sat_rtp(v.s0), convert_uint_sat_rtp(v.s1), convert_uint_sat_rtp(v.s2), convert_uint_sat_rtp(v.s3), convert_uint_sat_rtp(v.s4), convert_uint_sat_rtp(v.s5), convert_uint_sat_rtp(v.s6), convert_uint_sat_rtp(v.s7), convert_uint_sat_rtp(v.s8), convert_uint_sat_rtp(v.s9), convert_uint_sat_rtp(v.sA), convert_uint_sat_rtp(v.sB), convert_uint_sat_rtp(v.sC), convert_uint_sat_rtp(v.sD), convert_uint_sat_rtp(v.sE), convert_uint_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uint16 convert_uint16_sat_rtn(float16 v) {\n"
"  return (uint16)(convert_uint_sat_rtn(v.s0), convert_uint_sat_rtn(v.s1), convert_uint_sat_rtn(v.s2), convert_uint_sat_rtn(v.s3), convert_uint_sat_rtn(v.s4), convert_uint_sat_rtn(v.s5), convert_uint_sat_rtn(v.s6), convert_uint_sat_rtn(v.s7), convert_uint_sat_rtn(v.s8), convert_uint_sat_rtn(v.s9), convert_uint_sat_rtn(v.sA), convert_uint_sat_rtn(v.sB), convert_uint_sat_rtn(v.sC), convert_uint_sat_rtn(v.sD), convert_uint_sat_rtn(v.sE), convert_uint_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rte(float16 v) {\n"
"  return (short16)(convert_short_sat_rte(v.s0), convert_short_sat_rte(v.s1), convert_short_sat_rte(v.s2), convert_short_sat_rte(v.s3), convert_short_sat_rte(v.s4), convert_short_sat_rte(v.s5), convert_short_sat_rte(v.s6), convert_short_sat_rte(v.s7), convert_short_sat_rte(v.s8), convert_short_sat_rte(v.s9), convert_short_sat_rte(v.sA), convert_short_sat_rte(v.sB), convert_short_sat_rte(v.sC), convert_short_sat_rte(v.sD), convert_short_sat_rte(v.sE), convert_short_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtz(float16 v) {\n"
"  return (short16)(convert_short_sat_rtz(v.s0), convert_short_sat_rtz(v.s1), convert_short_sat_rtz(v.s2), convert_short_sat_rtz(v.s3), convert_short_sat_rtz(v.s4), convert_short_sat_rtz(v.s5), convert_short_sat_rtz(v.s6), convert_short_sat_rtz(v.s7), convert_short_sat_rtz(v.s8), convert_short_sat_rtz(v.s9), convert_short_sat_rtz(v.sA), convert_short_sat_rtz(v.sB), convert_short_sat_rtz(v.sC), convert_short_sat_rtz(v.sD), convert_short_sat_rtz(v.sE), convert_short_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtp(float16 v) {\n"
"  return (short16)(convert_short_sat_rtp(v.s0), convert_short_sat_rtp(v.s1), convert_short_sat_rtp(v.s2), convert_short_sat_rtp(v.s3), convert_short_sat_rtp(v.s4), convert_short_sat_rtp(v.s5), convert_short_sat_rtp(v.s6), convert_short_sat_rtp(v.s7), convert_short_sat_rtp(v.s8), convert_short_sat_rtp(v.s9), convert_short_sat_rtp(v.sA), convert_short_sat_rtp(v.sB), convert_short_sat_rtp(v.sC), convert_short_sat_rtp(v.sD), convert_short_sat_rtp(v.sE), convert_short_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE short16 convert_short16_sat_rtn(float16 v) {\n"
"  return (short16)(convert_short_sat_rtn(v.s0), convert_short_sat_rtn(v.s1), convert_short_sat_rtn(v.s2), convert_short_sat_rtn(v.s3), convert_short_sat_rtn(v.s4), convert_short_sat_rtn(v.s5), convert_short_sat_rtn(v.s6), convert_short_sat_rtn(v.s7), convert_short_sat_rtn(v.s8), convert_short_sat_rtn(v.s9), convert_short_sat_rtn(v.sA), convert_short_sat_rtn(v.sB), convert_short_sat_rtn(v.sC), convert_short_sat_rtn(v.sD), convert_short_sat_rtn(v.sE), convert_short_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rte(float16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rte(v.s0), convert_ushort_sat_rte(v.s1), convert_ushort_sat_rte(v.s2), convert_ushort_sat_rte(v.s3), convert_ushort_sat_rte(v.s4), convert_ushort_sat_rte(v.s5), convert_ushort_sat_rte(v.s6), convert_ushort_sat_rte(v.s7), convert_ushort_sat_rte(v.s8), convert_ushort_sat_rte(v.s9), convert_ushort_sat_rte(v.sA), convert_ushort_sat_rte(v.sB), convert_ushort_sat_rte(v.sC), convert_ushort_sat_rte(v.sD), convert_ushort_sat_rte(v.sE), convert_ushort_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtz(float16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtz(v.s0), convert_ushort_sat_rtz(v.s1), convert_ushort_sat_rtz(v.s2), convert_ushort_sat_rtz(v.s3), convert_ushort_sat_rtz(v.s4), convert_ushort_sat_rtz(v.s5), convert_ushort_sat_rtz(v.s6), convert_ushort_sat_rtz(v.s7), convert_ushort_sat_rtz(v.s8), convert_ushort_sat_rtz(v.s9), convert_ushort_sat_rtz(v.sA), convert_ushort_sat_rtz(v.sB), convert_ushort_sat_rtz(v.sC), convert_ushort_sat_rtz(v.sD), convert_ushort_sat_rtz(v.sE), convert_ushort_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtp(float16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtp(v.s0), convert_ushort_sat_rtp(v.s1), convert_ushort_sat_rtp(v.s2), convert_ushort_sat_rtp(v.s3), convert_ushort_sat_rtp(v.s4), convert_ushort_sat_rtp(v.s5), convert_ushort_sat_rtp(v.s6), convert_ushort_sat_rtp(v.s7), convert_ushort_sat_rtp(v.s8), convert_ushort_sat_rtp(v.s9), convert_ushort_sat_rtp(v.sA), convert_ushort_sat_rtp(v.sB), convert_ushort_sat_rtp(v.sC), convert_ushort_sat_rtp(v.sD), convert_ushort_sat_rtp(v.sE), convert_ushort_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE ushort16 convert_ushort16_sat_rtn(float16 v) {\n"
"  return (ushort16)(convert_ushort_sat_rtn(v.s0), convert_ushort_sat_rtn(v.s1), convert_ushort_sat_rtn(v.s2), convert_ushort_sat_rtn(v.s3), convert_ushort_sat_rtn(v.s4), convert_ushort_sat_rtn(v.s5), convert_ushort_sat_rtn(v.s6), convert_ushort_sat_rtn(v.s7), convert_ushort_sat_rtn(v.s8), convert_ushort_sat_rtn(v.s9), convert_ushort_sat_rtn(v.sA), convert_ushort_sat_rtn(v.sB), convert_ushort_sat_rtn(v.sC), convert_ushort_sat_rtn(v.sD), convert_ushort_sat_rtn(v.sE), convert_ushort_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rte(float16 v) {\n"
"  return (char16)(convert_char_sat_rte(v.s0), convert_char_sat_rte(v.s1), convert_char_sat_rte(v.s2), convert_char_sat_rte(v.s3), convert_char_sat_rte(v.s4), convert_char_sat_rte(v.s5), convert_char_sat_rte(v.s6), convert_char_sat_rte(v.s7), convert_char_sat_rte(v.s8), convert_char_sat_rte(v.s9), convert_char_sat_rte(v.sA), convert_char_sat_rte(v.sB), convert_char_sat_rte(v.sC), convert_char_sat_rte(v.sD), convert_char_sat_rte(v.sE), convert_char_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtz(float16 v) {\n"
"  return (char16)(convert_char_sat_rtz(v.s0), convert_char_sat_rtz(v.s1), convert_char_sat_rtz(v.s2), convert_char_sat_rtz(v.s3), convert_char_sat_rtz(v.s4), convert_char_sat_rtz(v.s5), convert_char_sat_rtz(v.s6), convert_char_sat_rtz(v.s7), convert_char_sat_rtz(v.s8), convert_char_sat_rtz(v.s9), convert_char_sat_rtz(v.sA), convert_char_sat_rtz(v.sB), convert_char_sat_rtz(v.sC), convert_char_sat_rtz(v.sD), convert_char_sat_rtz(v.sE), convert_char_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtp(float16 v) {\n"
"  return (char16)(convert_char_sat_rtp(v.s0), convert_char_sat_rtp(v.s1), convert_char_sat_rtp(v.s2), convert_char_sat_rtp(v.s3), convert_char_sat_rtp(v.s4), convert_char_sat_rtp(v.s5), convert_char_sat_rtp(v.s6), convert_char_sat_rtp(v.s7), convert_char_sat_rtp(v.s8), convert_char_sat_rtp(v.s9), convert_char_sat_rtp(v.sA), convert_char_sat_rtp(v.sB), convert_char_sat_rtp(v.sC), convert_char_sat_rtp(v.sD), convert_char_sat_rtp(v.sE), convert_char_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE char16 convert_char16_sat_rtn(float16 v) {\n"
"  return (char16)(convert_char_sat_rtn(v.s0), convert_char_sat_rtn(v.s1), convert_char_sat_rtn(v.s2), convert_char_sat_rtn(v.s3), convert_char_sat_rtn(v.s4), convert_char_sat_rtn(v.s5), convert_char_sat_rtn(v.s6), convert_char_sat_rtn(v.s7), convert_char_sat_rtn(v.s8), convert_char_sat_rtn(v.s9), convert_char_sat_rtn(v.sA), convert_char_sat_rtn(v.sB), convert_char_sat_rtn(v.sC), convert_char_sat_rtn(v.sD), convert_char_sat_rtn(v.sE), convert_char_sat_rtn(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rte(float16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rte(v.s0), convert_uchar_sat_rte(v.s1), convert_uchar_sat_rte(v.s2), convert_uchar_sat_rte(v.s3), convert_uchar_sat_rte(v.s4), convert_uchar_sat_rte(v.s5), convert_uchar_sat_rte(v.s6), convert_uchar_sat_rte(v.s7), convert_uchar_sat_rte(v.s8), convert_uchar_sat_rte(v.s9), convert_uchar_sat_rte(v.sA), convert_uchar_sat_rte(v.sB), convert_uchar_sat_rte(v.sC), convert_uchar_sat_rte(v.sD), convert_uchar_sat_rte(v.sE), convert_uchar_sat_rte(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtz(float16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtz(v.s0), convert_uchar_sat_rtz(v.s1), convert_uchar_sat_rtz(v.s2), convert_uchar_sat_rtz(v.s3), convert_uchar_sat_rtz(v.s4), convert_uchar_sat_rtz(v.s5), convert_uchar_sat_rtz(v.s6), convert_uchar_sat_rtz(v.s7), convert_uchar_sat_rtz(v.s8), convert_uchar_sat_rtz(v.s9), convert_uchar_sat_rtz(v.sA), convert_uchar_sat_rtz(v.sB), convert_uchar_sat_rtz(v.sC), convert_uchar_sat_rtz(v.sD), convert_uchar_sat_rtz(v.sE), convert_uchar_sat_rtz(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtp(float16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtp(v.s0), convert_uchar_sat_rtp(v.s1), convert_uchar_sat_rtp(v.s2), convert_uchar_sat_rtp(v.s3), convert_uchar_sat_rtp(v.s4), convert_uchar_sat_rtp(v.s5), convert_uchar_sat_rtp(v.s6), convert_uchar_sat_rtp(v.s7), convert_uchar_sat_rtp(v.s8), convert_uchar_sat_rtp(v.s9), convert_uchar_sat_rtp(v.sA), convert_uchar_sat_rtp(v.sB), convert_uchar_sat_rtp(v.sC), convert_uchar_sat_rtp(v.sD), convert_uchar_sat_rtp(v.sE), convert_uchar_sat_rtp(v.sF));\n"
"}\n"
"\n"
"INLINE OVERLOADABLE uchar16 convert_uchar16_sat_rtn(float16 v) {\n"
"  return (uchar16)(convert_uchar_sat_rtn(v.s0), convert_uchar_sat_rtn(v.s1), convert_uchar_sat_rtn(v.s2), convert_uchar_sat_rtn(v.s3), convert_uchar_sat_rtn(v.s4), convert_uchar_sat_rtn(v.s5), convert_uchar_sat_rtn(v.s6), convert_uchar_sat_rtn(v.s7), convert_uchar_sat_rtn(v.s8), convert_uchar_sat_rtn(v.s9), convert_uchar_sat_rtn(v.sA), convert_uchar_sat_rtn(v.sB), convert_uchar_sat_rtn(v.sC), convert_uchar_sat_rtn(v.sD), convert_uchar_sat_rtn(v.sE), convert_uchar_sat_rtn(v.sF));\n"
"}\n"
"\n"
"// ##END_CONVERT##\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL preprocessor directives & macros\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"#define __OPENCL_VERSION__ 110\n"
"#define __CL_VERSION_1_0__ 100\n"
"#define __CL_VERSION_1_1__ 110\n"
"#define __ENDIAN_LITTLE__ 1\n"
"#define __IMAGE_SUPPORT__ 1\n"
"#define __kernel_exec(X, TYPE) __kernel __attribute__((work_group_size_hint(X,1,1))) \\\n"
"                                        __attribute__((vec_type_hint(TYPE)))\n"
"#define kernel_exec(X, TYPE) __kernel_exec(X, TYPE)\n"
"#define cl_khr_global_int32_base_atomics\n"
"#define cl_khr_global_int32_extended_atomics\n"
"#define cl_khr_local_int32_base_atomics\n"
"#define cl_khr_local_int32_extended_atomics\n"
"#define cl_khr_byte_addressable_store\n"
"#define cl_khr_icd\n"
"#define cl_khr_gl_sharing\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL floating-point macros and pragmas\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"#define FLT_DIG 6\n"
"#define FLT_MANT_DIG 24\n"
"#define FLT_MAX_10_EXP +38\n"
"#define FLT_MAX_EXP +128\n"
"#define FLT_MIN_10_EXP -37\n"
"#define FLT_MIN_EXP -125\n"
"#define FLT_RADIX 2\n"
"#define FLT_ONE 1.0000000000e+00         /* 0x3F800000 */\n"
"#define FLT_MAX 0x1.fffffep127f\n"
"#define FLT_MIN 0x1.0p-126f\n"
"#define FLT_EPSILON 0x1.0p-23f\n"
"\n"
"#define MAXFLOAT     3.40282347e38F\n"
"INLINE_OVERLOADABLE float __ocl_inff(void) {\n"
"  union { uint u; float f; } u;\n"
"  u.u = 0x7F800000;\n"
"  return u.f;\n"
"}\n"
"INLINE_OVERLOADABLE float __ocl_nanf(void) {\n"
"  union { uint u; float f; } u;\n"
"  u.u = 0x7F800001;\n"
"  return u.f;\n"
"}\n"
"typedef union\n"
"{\n"
"  float value;\n"
"  uint  word;\n"
"} float_shape_type;\n"
"\n"
"/* Get a 32 bit int from a float.  */\n"
"#ifndef GEN_OCL_GET_FLOAT_WORD\n"
"# define GEN_OCL_GET_FLOAT_WORD(i,d)  \\\n"
"do {                                  \\\n"
"  float_shape_type gf_u;              \\\n"
"  gf_u.value = (d);                   \\\n"
"  (i) = gf_u.word;                    \\\n"
"} while (0)\n"
"#endif\n"
"/* Set a float from a 32 bit int.  */\n"
"#ifndef GEN_OCL_SET_FLOAT_WORD\n"
"# define GEN_OCL_SET_FLOAT_WORD(d,i)  \\\n"
"do {                                  \\\n"
"  float_shape_type sf_u;              \\\n"
"  sf_u.word = (i);                    \\\n"
"  (d) = sf_u.value;                   \\\n"
"} while (0)\n"
"#endif\n"
"\n"
"INLINE_OVERLOADABLE int __ocl_finitef (float x){\n"
"  unsigned ix;\n"
"  GEN_OCL_GET_FLOAT_WORD (ix, x);\n"
"  return (ix & 0x7fffffff) < 0x7f800000;\n"
"}\n"
"\n"
"#define HUGE_VALF    (__ocl_inff())\n"
"#define INFINITY     (__ocl_inff())\n"
"#define NAN          (__ocl_nanf())\n"
"#define M_E_F        2.718281828459045F\n"
"#define M_LOG2E_F    1.4426950408889634F\n"
"#define M_LOG10E_F   0.43429448190325176F\n"
"#define M_LN2_F      0.6931471805599453F\n"
"#define M_LN10_F     2.302585092994046F\n"
"#define M_PI_F       3.141592653589793F\n"
"#define M_PI_2_F     1.5707963267948966F\n"
"#define M_PI_4_F     0.7853981633974483F\n"
"#define M_1_PI_F     0.3183098861837907F\n"
"#define M_2_PI_F     0.6366197723675814F\n"
"#define M_2_SQRTPI_F 1.1283791670955126F\n"
"#define M_SQRT2_F    1.4142135623730951F\n"
"#define M_SQRT1_2_F  0.7071067811865476F\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL integer built-in macros\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"#define CHAR_BIT    8\n"
"#define CHAR_MAX    SCHAR_MAX\n"
"#define CHAR_MIN    SCHAR_MIN\n"
"#define INT_MAX     2147483647\n"
"#define INT_MIN     (-2147483647 - 1)\n"
"#define LONG_MAX    0x7fffffffffffffffL\n"
"#define LONG_MIN    (-0x7fffffffffffffffL - 1)\n"
"#define SCHAR_MAX   127\n"
"#define SCHAR_MIN   (-127 - 1)\n"
"#define SHRT_MAX    32767\n"
"#define SHRT_MIN    (-32767 - 1)\n"
"#define UCHAR_MAX   255\n"
"#define USHRT_MAX   65535\n"
"#define UINT_MAX    0xffffffff\n"
"#define ULONG_MAX   0xffffffffffffffffUL\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// OpenCL relational built-in functions\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"\n"
"int INLINE_OVERLOADABLE isequal(float x, float y) { return x == y; }\n"
"int INLINE_OVERLOADABLE isnotequal(float x, float y) { return x != y; }\n"
"int INLINE_OVERLOADABLE isgreater(float x, float y) { return x > y; }\n"
"int INLINE_OVERLOADABLE isgreaterequal(float x, float y) { return x >= y; }\n"
"int INLINE_OVERLOADABLE isless(float x, float y) { return x < y; }\n"
"int INLINE_OVERLOADABLE islessequal(float x, float y) { return x <= y; }\n"
"int INLINE_OVERLOADABLE islessgreater(float x, float y) { return (x < y) || (x > y); }\n"
"\n"
"#define SDEF(TYPE)                                                              \\\n"
"OVERLOADABLE TYPE ocl_sadd_sat(TYPE x, TYPE y);                          \\\n"
"OVERLOADABLE TYPE ocl_ssub_sat(TYPE x, TYPE y);                          \\\n"
"INLINE_OVERLOADABLE TYPE add_sat(TYPE x, TYPE y) { return ocl_sadd_sat(x, y); } \\\n"
"INLINE_OVERLOADABLE TYPE sub_sat(TYPE x, TYPE y) { return ocl_ssub_sat(x, y); }\n"
"SDEF(char);\n"
"SDEF(short);\n"
"#undef SDEF\n"
"OVERLOADABLE int ocl_sadd_sat(int x, int y);\n"
"INLINE_OVERLOADABLE int add_sat(int x, int y) { return ocl_sadd_sat(x, y); }\n"
"OVERLOADABLE int ocl_ssub_sat(int x, int y);\n"
"INLINE_OVERLOADABLE int sub_sat(int x, int y) {\n"
"  return (y == 0x80000000u) ? (x & 0x7FFFFFFF) : ocl_ssub_sat(x, y);\n"
"}\n"
"OVERLOADABLE long ocl_sadd_sat(long x, long y);\n"
"INLINE_OVERLOADABLE long add_sat(long x, long y) {\n"
"  union {long l; uint i[2];} ux, uy;\n"
"  ux.l = x;\n"
"  uy.l = y;\n"
"  if((ux.i[1] ^ uy.i[1]) & 0x80000000u)\n"
"    return x + y;\n"
"  return ocl_sadd_sat(x, y);\n"
"}\n"
"OVERLOADABLE long ocl_ssub_sat(long x, long y);\n"
"INLINE_OVERLOADABLE long sub_sat(long x, long y) {\n"
"  union {long l; uint i[2];} ux, uy;\n"
"  ux.l = x;\n"
"  uy.l = y;\n"
"  if((ux.i[1] ^ uy.i[1]) & 0x80000000u)\n"
"    return ocl_ssub_sat(x, y);\n"
"  return x - y;\n"
"}\n"
"#define UDEF(TYPE)                                                              \\\n"
"OVERLOADABLE TYPE ocl_uadd_sat(TYPE x, TYPE y);                          \\\n"
"OVERLOADABLE TYPE ocl_usub_sat(TYPE x, TYPE y);                          \\\n"
"INLINE_OVERLOADABLE TYPE add_sat(TYPE x, TYPE y) { return ocl_uadd_sat(x, y); } \\\n"
"INLINE_OVERLOADABLE TYPE sub_sat(TYPE x, TYPE y) { return ocl_usub_sat(x, y); }\n"
"UDEF(uchar);\n"
"UDEF(ushort);\n"
"UDEF(uint);\n"
"UDEF(ulong);\n"
"#undef UDEF\n"
"\n"
"INLINE_OVERLOADABLE int isfinite(float x) {\n"
"  union { uint u; float f; } u;\n"
"  u.f = x;\n"
"  return (u.u & 0x7FFFFFFF) < 0x7F800000;\n"
"}\n"
"INLINE_OVERLOADABLE int isinf(float x) {\n"
"  union { uint u; float f; } u;\n"
"  u.f = x;\n"
"  return (u.u & 0x7FFFFFFF) == 0x7F800000;\n"
"}\n"
"INLINE_OVERLOADABLE int isnan(float x) {\n"
"  return x != x;\n"
"}\n"
"INLINE_OVERLOADABLE int isnormal(float x) {\n"
"  union { uint u; float f; } u;\n"
"  u.f = x;\n"
"  u.u &= 0x7FFFFFFF;\n"
"  return (u.u < 0x7F800000) && (u.u >= 0x800000);\n"
"}\n"
"INLINE_OVERLOADABLE int isordered(float x, float y) { return isequal(x, x) && isequal(y, y); }\n"
"INLINE_OVERLOADABLE int isunordered(float x, float y) { return isnan(x) || isnan(y); }\n"
"INLINE_OVERLOADABLE int signbit(float x) {\n"
"  union { uint u; float f; } u;\n"
"  u.f = x;\n"
"  return u.u >> 31;\n"
"}\n"
"\n"
"#define DEC1(type) INLINE_OVERLOADABLE int any(type a) { return a<0; }\n"
"#define DEC2(type) INLINE_OVERLOADABLE int any(type a) { return a.s0<0 || a.s1<0; }\n"
"#define DEC3(type) INLINE_OVERLOADABLE int any(type a) { return a.s0<0 || a.s1<0 || a.s2<0; }\n"
"#define DEC4(type) INLINE_OVERLOADABLE int any(type a) { return a.s0<0 || a.s1<0 || a.s2<0 || a.s3<0; }\n"
"#define DEC8(type) INLINE_OVERLOADABLE int any(type a) { return a.s0<0 || a.s1<0 || a.s2<0 || a.s3<0 || a.s4<0 || a.s5<0 || a.s6<0 || a.s7<0; }\n"
"#define DEC16(type) INLINE_OVERLOADABLE int any(type a) { return a.s0<0 || a.s1<0 || a.s2<0 || a.s3<0 || a.s4<0 || a.s5<0 || a.s6<0 || a.s7<0 || a.s8<0 || a.s9<0 || a.sA<0 || a.sB<0 || a.sC<0 || a.sD<0 || a.sE<0 || a.sF<0; }\n"
"DEC1(char);\n"
"DEC1(short);\n"
"DEC1(int);\n"
"DEC1(long);\n"
"#define DEC(n) DEC##n(char##n); DEC##n(short##n); DEC##n(int##n); DEC##n(long##n);\n"
"DEC(2);\n"
"DEC(3);\n"
"DEC(4);\n"
"DEC(8);\n"
"DEC(16);\n"
"#undef DEC\n"
"#undef DEC1\n"
"#undef DEC2\n"
"#undef DEC3\n"
"#undef DEC4\n"
"#undef DEC8\n"
"#undef DEC16\n"
"#define DEC1(type) INLINE_OVERLOADABLE int all(type a) { return a<0; }\n"
"#define DEC2(type) INLINE_OVERLOADABLE int all(type a) { return a.s0<0 && a.s1<0; }\n"
"#define DEC3(type) INLINE_OVERLOADABLE int all(type a) { return a.s0<0 && a.s1<0 && a.s2<0; }\n"
"#define DEC4(type) INLINE_OVERLOADABLE int all(type a) { return a.s0<0 && a.s1<0 && a.s2<0 && a.s3<0; }\n"
"#define DEC8(type) INLINE_OVERLOADABLE int all(type a) { return a.s0<0 && a.s1<0 && a.s2<0 && a.s3<0 && a.s4<0 && a.s5<0 && a.s6<0 && a.s7<0; }\n"
"#define DEC16(type) INLINE_OVERLOADABLE int all(type a) { return a.s0<0 && a.s1<0 && a.s2<0 && a.s3<0 && a.s4<0 && a.s5<0 && a.s6<0 && a.s7<0 && a.s8<0 && a.s9<0 && a.sA<0 && a.sB<0 && a.sC<0 && a.sD<0 && a.sE<0 && a.sF<0; }\n"
"DEC1(char);\n"
"DEC1(short);\n"
"DEC1(int);\n"
"DEC1(long);\n"
"#define DEC(n) DEC##n(char##n); DEC##n(short##n); DEC##n(int##n); DEC##n(long##n);\n"
"DEC(2);\n"
"DEC(3);\n"
"DEC(4);\n"
"DEC(8);\n"
"DEC(16);\n"
"#undef DEC\n"
"#undef DEC1\n"
"#undef DEC2\n"
"#undef DEC3\n"
"#undef DEC4\n"
"#undef DEC8\n"
"#undef DEC16\n"
"\n"
"#define DEF(type) INLINE_OVERLOADABLE type bitselect(type a, type b, type c) { return (a & ~c) | (b & c); }\n"
"DEF(char); DEF(uchar); DEF(short); DEF(ushort); DEF(int); DEF(uint)\n"
"DEF(long); DEF(ulong)\n"
"#undef DEF\n"
"INLINE_OVERLOADABLE float bitselect(float a, float b, float c) {\n"
"  return as_float(bitselect(as_int(a), as_int(b), as_int(c)));\n"
"}\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Integer built-in functions\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"PURE CONST uint __gen_ocl_fbh(uint);\n"
"PURE CONST uint __gen_ocl_fbl(uint);\n"
"\n"
"INLINE_OVERLOADABLE char clz(char x) {\n"
"  if (x < 0)\n"
"    return 0;\n"
"  if (x == 0)\n"
"    return 8;\n"
"  return __gen_ocl_fbh(x) - 24;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE uchar clz(uchar x) {\n"
"  if (x == 0)\n"
"    return 8;\n"
"  return __gen_ocl_fbh(x) - 24;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE short clz(short x) {\n"
"  if (x < 0)\n"
"    return 0;\n"
"  if (x == 0)\n"
"    return 16;\n"
"  return __gen_ocl_fbh(x) - 16;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE ushort clz(ushort x) {\n"
"  if (x == 0)\n"
"    return 16;\n"
"  return __gen_ocl_fbh(x) - 16;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE int clz(int x) {\n"
"  if (x < 0)\n"
"    return 0;\n"
"  if (x == 0)\n"
"    return 32;\n"
"  return __gen_ocl_fbh(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE uint clz(uint x) {\n"
"  if (x == 0)\n"
"    return 32;\n"
"  return __gen_ocl_fbh(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE long clz(long x) {\n"
"  union { int i[2]; long x; } u;\n"
"  u.x = x;\n"
"  if (u.i[1] & 0x80000000u)\n"
"    return 0;\n"
"  if (u.i[1] == 0 && u.i[0] == 0)\n"
"    return 64;\n"
"  uint v = clz(u.i[1]);\n"
"  if(v == 32)\n"
"    v += clz(u.i[0]);\n"
"  return v;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE ulong clz(ulong x) {\n"
"  if (x == 0)\n"
"    return 64;\n"
"  union { uint i[2]; ulong x; } u;\n"
"  u.x = x;\n"
"  uint v = clz(u.i[1]);\n"
"  if(v == 32)\n"
"    v += clz(u.i[0]);\n"
"  return v;\n"
"}\n"
"\n"
"OVERLOADABLE int __gen_ocl_mul_hi(int x, int y);\n"
"OVERLOADABLE uint __gen_ocl_mul_hi(uint x, uint y);\n"
"OVERLOADABLE long __gen_ocl_mul_hi(long x, long y);\n"
"OVERLOADABLE ulong __gen_ocl_mul_hi(ulong x, ulong y);\n"
"INLINE_OVERLOADABLE char mul_hi(char x, char y) { return (x * y) >> 8; }\n"
"INLINE_OVERLOADABLE uchar mul_hi(uchar x, uchar y) { return (x * y) >> 8; }\n"
"INLINE_OVERLOADABLE short mul_hi(short x, short y) { return (x * y) >> 16; }\n"
"INLINE_OVERLOADABLE ushort mul_hi(ushort x, ushort y) { return (x * y) >> 16; }\n"
"INLINE_OVERLOADABLE int mul_hi(int x, int y) { return __gen_ocl_mul_hi(x, y); }\n"
"INLINE_OVERLOADABLE uint mul_hi(uint x, uint y) { return __gen_ocl_mul_hi(x, y); }\n"
"INLINE_OVERLOADABLE long mul_hi(long x, long y) {\n"
"  return __gen_ocl_mul_hi(x, y);\n"
"}\n"
"INLINE_OVERLOADABLE ulong mul_hi(ulong x, ulong y) {\n"
"  return __gen_ocl_mul_hi(x, y);\n"
"}\n"
"\n"
"#define DEF(type) INLINE_OVERLOADABLE type mad_hi(type a, type b, type c) { return mul_hi(a, b) + c; }\n"
"DEF(char)\n"
"DEF(uchar)\n"
"DEF(short)\n"
"DEF(ushort)\n"
"DEF(int)\n"
"DEF(uint)\n"
"DEF(long)\n"
"DEF(ulong)\n"
"#undef DEF\n"
"\n"
"INLINE_OVERLOADABLE int mul24(int a, int b) { return ((a << 8) >> 8) * ((b << 8) >> 8); }\n"
"INLINE_OVERLOADABLE uint mul24(uint a, uint b) { return (a & 0xFFFFFF) * (b & 0xFFFFFF); }\n"
"\n"
"INLINE_OVERLOADABLE int mad24(int a, int b, int c) { return mul24(a, b) + c; }\n"
"INLINE_OVERLOADABLE uint mad24(uint a, uint b, uint c) { return mul24(a, b) + c; }\n"
"\n"
"INLINE_OVERLOADABLE char mad_sat(char a, char b, char c) {\n"
"  int x = (int)a * (int)b + (int)c;\n"
"  if (x > 127)\n"
"    x = 127;\n"
"  if (x < -128)\n"
"    x = -128;\n"
"  return x;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE uchar mad_sat(uchar a, uchar b, uchar c) {\n"
"  uint x = (uint)a * (uint)b + (uint)c;\n"
"  if (x > 255)\n"
"    x = 255;\n"
"  return x;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE short mad_sat(short a, short b, short c) {\n"
"  int x = (int)a * (int)b + (int)c;\n"
"  if (x > 32767)\n"
"    x = 32767;\n"
"  if (x < -32768)\n"
"    x = -32768;\n"
"  return x;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE ushort mad_sat(ushort a, ushort b, ushort c) {\n"
"  uint x = (uint)a * (uint)b + (uint)c;\n"
"  if (x > 65535)\n"
"    x = 65535;\n"
"  return x;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE int mad_sat(int a, int b, int c) {\n"
"  long x = (long)a * (long)b + (long)c;\n"
"  if (x > 0x7FFFFFFF)\n"
"    x = 0x7FFFFFFF;\n"
"  else if (x < -0x7FFFFFFF-1)\n"
"    x = -0x7FFFFFFF-1;\n"
"  return (int)x;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE uint mad_sat(uint a, uint b, uint c) {\n"
"  ulong x = (ulong)a * (ulong)b + (ulong)c;\n"
"  if (x > 0xFFFFFFFFu)\n"
"    x = 0xFFFFFFFFu;\n"
"  return (uint)x;\n"
"}\n"
"\n"
"OVERLOADABLE long __gen_ocl_mad_sat(long a, long b, long c);\n"
"OVERLOADABLE ulong __gen_ocl_mad_sat(ulong a, ulong b, ulong c);\n"
"\n"
"INLINE_OVERLOADABLE long mad_sat(long a, long b, long c) {\n"
"  return __gen_ocl_mad_sat(a, b, c);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE ulong mad_sat(ulong a, ulong b, ulong c) {\n"
"  return __gen_ocl_mad_sat(a, b, c);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE uchar __rotate_left(uchar x, uchar y) { return (x << y) | (x >> (8 - y)); }\n"
"INLINE_OVERLOADABLE char __rotate_left(char x, char y) { return __rotate_left((uchar)x, (uchar)y); }\n"
"INLINE_OVERLOADABLE ushort __rotate_left(ushort x, ushort y) { return (x << y) | (x >> (16 - y)); }\n"
"INLINE_OVERLOADABLE short __rotate_left(short x, short y) { return __rotate_left((ushort)x, (ushort)y); }\n"
"INLINE_OVERLOADABLE uint __rotate_left(uint x, uint y) { return (x << y) | (x >> (32 - y)); }\n"
"INLINE_OVERLOADABLE int __rotate_left(int x, int y) { return __rotate_left((uint)x, (uint)y); }\n"
"INLINE_OVERLOADABLE ulong __rotate_left(ulong x, ulong y) { return (x << y) | (x >> (64 - y)); }\n"
"INLINE_OVERLOADABLE long __rotate_left(long x, long y) { return __rotate_left((ulong)x, (ulong)y); }\n"
"#define DEF(type, m) INLINE_OVERLOADABLE type rotate(type x, type y) { return __rotate_left(x, (type)(y & m)); }\n"
"DEF(char, 7)\n"
"DEF(uchar, 7)\n"
"DEF(short, 15)\n"
"DEF(ushort, 15)\n"
"DEF(int, 31)\n"
"DEF(uint, 31)\n"
"DEF(long, 63)\n"
"DEF(ulong, 63)\n"
"#undef DEF\n"
"\n"
"OVERLOADABLE short __gen_ocl_upsample(short hi, short lo);\n"
"OVERLOADABLE int __gen_ocl_upsample(int hi, int lo);\n"
"OVERLOADABLE long __gen_ocl_upsample(long hi, long lo);\n"
"INLINE_OVERLOADABLE short upsample(char hi, uchar lo) { return __gen_ocl_upsample((short)hi, (short)lo); }\n"
"INLINE_OVERLOADABLE ushort upsample(uchar hi, uchar lo) { return __gen_ocl_upsample((short)hi, (short)lo); }\n"
"INLINE_OVERLOADABLE int upsample(short hi, ushort lo) { return __gen_ocl_upsample((int)hi, (int)lo); }\n"
"INLINE_OVERLOADABLE uint upsample(ushort hi, ushort lo) { return __gen_ocl_upsample((int)hi, (int)lo); }\n"
"INLINE_OVERLOADABLE long upsample(int hi, uint lo) {\n"
"  return __gen_ocl_upsample((long)hi, (long)lo);\n"
"}\n"
"INLINE_OVERLOADABLE ulong upsample(uint hi, uint lo) {\n"
"  return __gen_ocl_upsample((long)hi, (long)lo);\n"
"}\n"
"\n"
"OVERLOADABLE uint __gen_ocl_hadd(uint x, uint y);\n"
"OVERLOADABLE uint __gen_ocl_rhadd(uint x, uint y);\n"
"#define DEC DEF(char); DEF(uchar); DEF(short); DEF(ushort)\n"
"#define DEF(type) INLINE_OVERLOADABLE type hadd(type x, type y) { return (x + y) >> 1; }\n"
"DEC\n"
"#undef DEF\n"
"#define DEF(type) INLINE_OVERLOADABLE type rhadd(type x, type y) { return (x + y + 1) >> 1; }\n"
"DEC\n"
"#undef DEF\n"
"#undef DEC\n"
"INLINE_OVERLOADABLE int hadd(int x, int y) {\n"
"  return (x < 0 && y > 0) || (x > 0 && y < 0) ?\n"
"         ((x + y) >> 1) :\n"
"         __gen_ocl_hadd((uint)x, (uint)y);\n"
"}\n"
"INLINE_OVERLOADABLE uint hadd(uint x, uint y) { return __gen_ocl_hadd(x, y); }\n"
"INLINE_OVERLOADABLE int rhadd(int x, int y) {\n"
"  return (x < 0 && y > 0) || (x > 0 && y < 0) ?\n"
"         ((x + y + 1) >> 1) :\n"
"         __gen_ocl_rhadd((uint)x, (uint)y);\n"
" }\n"
"INLINE_OVERLOADABLE uint rhadd(uint x, uint y) { return __gen_ocl_rhadd(x, y); }\n"
"OVERLOADABLE ulong __gen_ocl_hadd(ulong x, ulong y);\n"
"OVERLOADABLE ulong __gen_ocl_rhadd(ulong x, ulong y);\n"
"INLINE_OVERLOADABLE long hadd(long x, long y) {\n"
"  return (x < 0 && y > 0) || (x > 0 && y < 0) ?\n"
"         ((x + y) >> 1) :\n"
"         __gen_ocl_hadd((ulong)x, (ulong)y);\n"
"}\n"
"INLINE_OVERLOADABLE ulong hadd(ulong x, ulong y) {\n"
"  return __gen_ocl_hadd(x, y);\n"
"}\n"
"INLINE_OVERLOADABLE long rhadd(long x, long y) {\n"
"  return (x < 0 && y > 0) || (x > 0 && y < 0) ?\n"
"         ((x + y + 1) >> 1) :\n"
"         __gen_ocl_rhadd((ulong)x, (ulong)y);\n"
"}\n"
"INLINE_OVERLOADABLE ulong rhadd(ulong x, ulong y) {\n"
"  return __gen_ocl_rhadd(x, y);\n"
"}\n"
"\n"
"int __gen_ocl_abs(int x);\n"
"#define DEC(TYPE) INLINE_OVERLOADABLE u##TYPE abs(TYPE x) { return (u##TYPE) __gen_ocl_abs(x); }\n"
"DEC(int)\n"
"DEC(short)\n"
"DEC(char)\n"
"#undef DEC\n"
"INLINE_OVERLOADABLE ulong abs(long x) { return x < 0 ? -x : x; }\n"
"/* For unsigned types, do nothing. */\n"
"#define DEC(TYPE) INLINE_OVERLOADABLE TYPE abs(TYPE x) { return x; }\n"
"DEC(uint)\n"
"DEC(ushort)\n"
"DEC(uchar)\n"
"DEC(ulong)\n"
"#undef DEC\n"
"\n"
"/* Char and short type abs diff */\n"
"/* promote char and short to int and will be no module overflow */\n"
"#define DEC(TYPE, UTYPE) INLINE_OVERLOADABLE UTYPE abs_diff(TYPE x, TYPE y) \\\n"
"                         { return (UTYPE) (abs((int)x - (int)y)); }\n"
"DEC(char, uchar)\n"
"DEC(uchar, uchar)\n"
"DEC(short, ushort)\n"
"DEC(ushort, ushort)\n"
"#undef DEC\n"
"\n"
"INLINE_OVERLOADABLE uint abs_diff (uint x, uint y) {\n"
"    /* same signed will never overflow. */\n"
"    return y > x ? (y -x) : (x - y);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE uint abs_diff (int x, int y) {\n"
"    /* same signed will never module overflow. */\n"
"    if ((x >= 0 && y >= 0) || (x <= 0 && y <= 0))\n"
"        return abs(x - y);\n"
"\n"
"    return (abs(x) + abs(y));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE ulong abs_diff (long x, long y) {\n"
"  if ((x >= 0 && y >= 0) || (x <= 0 && y <= 0))\n"
"    return abs(x - y);\n"
"  return abs(x) + abs(y);\n"
"}\n"
"INLINE_OVERLOADABLE ulong abs_diff (ulong x, ulong y) {\n"
"  return y > x ? (y - x) : (x - y);\n"
"}\n"
"\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// SIMD level function\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"short __gen_ocl_simd_any(short);\n"
"short __gen_ocl_simd_all(short);\n"
"\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Work Items functions (see 6.11.1 of OCL 1.1 spec)\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"\n"
"PURE CONST uint __gen_ocl_get_work_dim(void);\n"
"INLINE uint get_work_dim(void) {\n"
"  return __gen_ocl_get_work_dim();\n"
"}\n"
"\n"
"#define DECL_INTERNAL_WORK_ITEM_FN(NAME) \\\n"
"PURE CONST unsigned int __gen_ocl_##NAME##0(void); \\\n"
"PURE CONST unsigned int __gen_ocl_##NAME##1(void); \\\n"
"PURE CONST unsigned int __gen_ocl_##NAME##2(void);\n"
"DECL_INTERNAL_WORK_ITEM_FN(get_group_id)\n"
"DECL_INTERNAL_WORK_ITEM_FN(get_local_id)\n"
"DECL_INTERNAL_WORK_ITEM_FN(get_local_size)\n"
"DECL_INTERNAL_WORK_ITEM_FN(get_global_size)\n"
"DECL_INTERNAL_WORK_ITEM_FN(get_global_offset)\n"
"DECL_INTERNAL_WORK_ITEM_FN(get_num_groups)\n"
"#undef DECL_INTERNAL_WORK_ITEM_FN\n"
"\n"
"#define DECL_PUBLIC_WORK_ITEM_FN(NAME, OTHER_RET)    \\\n"
"INLINE unsigned NAME(unsigned int dim) {             \\\n"
"  if (dim == 0) return __gen_ocl_##NAME##0();        \\\n"
"  else if (dim == 1) return __gen_ocl_##NAME##1();   \\\n"
"  else if (dim == 2) return __gen_ocl_##NAME##2();   \\\n"
"  else return OTHER_RET;                             \\\n"
"}\n"
"\n"
"DECL_PUBLIC_WORK_ITEM_FN(get_group_id, 0)\n"
"DECL_PUBLIC_WORK_ITEM_FN(get_local_id, 0)\n"
"DECL_PUBLIC_WORK_ITEM_FN(get_local_size, 1)\n"
"DECL_PUBLIC_WORK_ITEM_FN(get_global_size, 1)\n"
"DECL_PUBLIC_WORK_ITEM_FN(get_global_offset, 0)\n"
"DECL_PUBLIC_WORK_ITEM_FN(get_num_groups, 1)\n"
"#undef DECL_PUBLIC_WORK_ITEM_FN\n"
"\n"
"INLINE uint get_global_id(uint dim) {\n"
"  return get_local_id(dim) + get_local_size(dim) * get_group_id(dim) + get_global_offset(dim);\n"
"}\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Math Functions (see 6.11.2 of OCL 1.1 spec)\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"PURE CONST float __gen_ocl_fabs(float x);\n"
"PURE CONST float __gen_ocl_sin(float x);\n"
"PURE CONST float __gen_ocl_cos(float x);\n"
"PURE CONST float __gen_ocl_sqrt(float x);\n"
"PURE CONST float __gen_ocl_rsqrt(float x);\n"
"PURE CONST float __gen_ocl_log(float x);\n"
"PURE CONST float __gen_ocl_exp(float x);\n"
"PURE CONST float __gen_ocl_pow(float x, float y);\n"
"PURE CONST float __gen_ocl_rcp(float x);\n"
"PURE CONST float __gen_ocl_rndz(float x);\n"
"PURE CONST float __gen_ocl_rnde(float x);\n"
"PURE CONST float __gen_ocl_rndu(float x);\n"
"PURE CONST float __gen_ocl_rndd(float x);\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_floor(float x) { return __gen_ocl_rndd(x); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_copysign(float x, float y) {\n"
"  union { unsigned u; float f; } ux, uy;\n"
"  ux.f = x;\n"
"  uy.f = y;\n"
"  ux.u = (ux.u & 0x7fffffff) | (uy.u & 0x80000000u);\n"
"  return ux.f;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_log(float x) {\n"
"/*\n"
" *  Conversion to float by Ian Lance Taylor, Cygnus Support, ian@cygnus.com\n"
" * ====================================================\n"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\n"
" *\n"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\n"
" * Permission to use, copy, modify, and distribute this\n"
" * software is freely granted, provided that this notice\n"
" * is preserved.\n"
" * ====================================================\n"
" */\n"
"  union { unsigned int i; float f; } u;\n"
"  const float\n"
"  ln2_hi =   6.9313812256e-01,  /* 0x3f317180 */\n"
"  ln2_lo =   9.0580006145e-06,  /* 0x3717f7d1 */\n"
"  two25 =    3.355443200e+07, /* 0x4c000000 */\n"
"  Lg1 = 6.6666668653e-01, /* 3F2AAAAB */\n"
"  Lg2 = 4.0000000596e-01, /* 3ECCCCCD */\n"
"  Lg3 = 2.8571429849e-01, /* 3E924925 */\n"
"  Lg4 = 2.2222198546e-01, /* 3E638E29 */\n"
"  Lg5 = 1.8183572590e-01, /* 3E3A3325 */\n"
"  Lg6 = 1.5313838422e-01, /* 3E1CD04F */\n"
"  Lg7 = 1.4798198640e-01; /* 3E178897 */\n"
"\n"
"  const float zero   =  0.0;\n"
"  float hfsq,f,s,z,R,w,t1,t2,dk;\n"
"  int k,ix,i,j;\n"
"\n"
"  u.f = x;  ix = u.i;\n"
"  k=0;\n"
"  if (ix < 0x00800000) {      /* x < 2**-126  */\n"
"      if ((ix&0x7fffffff)==0)\n"
"    return -two25/zero;   /* log(+-0)=-inf */\n"
"      if (ix<0) return (x-x)/zero;  /* log(-#) = NaN */\n"
"      return -INFINITY;  /* Gen does not support subnormal number now */\n"
"      //k -= 25; x *= two25; /* subnormal number, scale up x */\n"
"      //u.f = x;  ix = u.i;\n"
"  }\n"
"  if (ix >= 0x7f800000) return x+x;\n"
"  k += (ix>>23)-127;\n"
"  ix &= 0x007fffff;\n"
"  i = (ix+(0x95f64<<3))&0x800000;\n"
"  u.i = ix|(i^0x3f800000); x = u.f;\n"
"  k += (i>>23);\n"
"  f = x-(float)1.0;\n"
"  if((0x007fffff&(15+ix))<16) { /* |f| < 2**-20 */\n"
"      if(f==zero) {\n"
"        if(k==0) return zero;\n"
"        else {\n"
"          dk=(float)k; return dk*ln2_hi+dk*ln2_lo;\n"
"        }\n"
"      }\n"
"      R = f*f*((float)0.5-(float)0.33333333333333333*f);\n"
"      if(k==0)\n"
"        return f-R;\n"
"      else {\n"
"        dk=(float)k;  return dk*ln2_hi-((R-dk*ln2_lo)-f);\n"
"      }\n"
"  }\n"
"  s = f/((float)2.0+f);\n"
"  dk = (float)k;\n"
"  z = s*s;\n"
"  i = ix-(0x6147a<<3);\n"
"  w = z*z;\n"
"  j = (0x6b851<<3)-ix;\n"
"  t1= w*(Lg2+w*(Lg4+w*Lg6));\n"
"  t2= z*(Lg1+w*(Lg3+w*(Lg5+w*Lg7)));\n"
"  i |= j;\n"
"  R = t2+t1;\n"
"  if(i>0) {\n"
"      hfsq=(float)0.5*f*f;\n"
"      if(k==0) return f-(hfsq-s*(hfsq+R)); else\n"
"         return dk*ln2_hi-((hfsq-(s*(hfsq+R)+dk*ln2_lo))-f);\n"
"  } else {\n"
"      if(k==0) return f-s*(f-R); else\n"
"         return dk*ln2_hi-((s*(f-R)-dk*ln2_lo)-f);\n"
"  }\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_log10(float x) {\n"
"/*\n"
" *  Conversion to float by Ian Lance Taylor, Cygnus Support, ian@cygnus.com\n"
" * ====================================================\n"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\n"
" *\n"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\n"
" * Permission to use, copy, modify, and distribute this\n"
" * software is freely granted, provided that this notice\n"
" * is preserved.\n"
" * ====================================================\n"
" */\n"
"  union {float f; unsigned i; }u;\n"
"  const float\n"
"  zero       = 0.0,\n"
"  two25      =  3.3554432000e+07, /* 0x4c000000 */\n"
"  ivln10     =  4.3429449201e-01, /* 0x3ede5bd9 */\n"
"  log10_2hi  =  3.0102920532e-01, /* 0x3e9a2080 */\n"
"  log10_2lo  =  7.9034151668e-07; /* 0x355427db */\n"
"\n"
"  float y,z;\n"
"  int i,k,hx;\n"
"\n"
"  u.f = x; hx = u.i;\n"
"  k=0;\n"
"  if (hx < 0x00800000) {                  /* x < 2**-126  */\n"
"    if ((hx&0x7fffffff)==0)\n"
"      return -two25/zero;             /* log(+-0)=-inf */\n"
"    if (hx<0) return NAN;        /* log(-#) = NaN */\n"
"    return -INFINITY;      /* Gen does not support subnormal now */\n"
"    //k -= 25; x *= two25; /* subnormal number, scale up x */\n"
"    //u.f = x; hx = u.i;\n"
"  }\n"
"  if (hx >= 0x7f800000) return x+x;\n"
"  k += (hx>>23)-127;\n"
"  i  = ((unsigned)k&0x80000000)>>31;\n"
"  hx = (hx&0x007fffff)|((0x7f-i)<<23);\n"
"  y  = (float)(k+i);\n"
"  u.i = hx; x = u.f;\n"
"  z  = y*log10_2lo + ivln10*__gen_ocl_internal_log(x);\n"
"  return  z+y*log10_2hi;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_log2(float x) {\n"
"/*\n"
" *  Conversion to float by Ian Lance Taylor, Cygnus Support, ian@cygnus.com\n"
" *  adapted for log2 by Ulrich Drepper <drepper@cygnus.com>\n"
" * ====================================================\n"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\n"
" *\n"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\n"
" * Permission to use, copy, modify, and distribute this\n"
" * software is freely granted, provided that this notice\n"
" * is preserved.\n"
" * ====================================================\n"
" */\n"
"  const float zero   =  0.0,\n"
"  ln2 = 0.69314718055994530942,\n"
"  two25 =    3.355443200e+07, /** 0x4c000000 */\n"
"  Lg1 = 6.6666668653e-01, /** 3F2AAAAB */\n"
"  Lg2 = 4.0000000596e-01, /** 3ECCCCCD */\n"
"  Lg3 = 2.8571429849e-01, /** 3E924925 */\n"
"  Lg4 = 2.2222198546e-01, /** 3E638E29 */\n"
"  Lg5 = 1.8183572590e-01, /** 3E3A3325 */\n"
"  Lg6 = 1.5313838422e-01, /** 3E1CD04F */\n"
"  Lg7 = 1.4798198640e-01; /** 3E178897 */\n"
"\n"
"  float hfsq,f,s,z,R,w,t1,t2,dk;\n"
"  int k,ix,i,j;\n"
"\n"
"  union {float f; int i; }u;//GET_FLOAT_WORD(ix,x);\n"
"  u.f = x; ix = u.i;\n"
"\n"
"  k=0;\n"
"  if (ix < 0x00800000) {           /** x < 2**-126  */\n"
"      if ((ix&0x7fffffff)==0)\n"
"      return -two25/(x-x);        /** log(+-0)=-inf */\n"
"\n"
"      if (ix<0) return (x-x)/(x-x);    /** log(-#) = NaN */\n"
"      return -INFINITY;\n"
"      k -= 25; x *= two25; /** subnormal number, scale up x */\n"
"      u.f = x; ix = u.i; //GET_FLOAT_WORD(ix,x);\n"
"  }\n"
"\n"
"  if (ix >= 0x7f800000) return x+x;\n"
"\n"
"  k += (ix>>23)-127;\n"
"  ix &= 0x007fffff;\n"
"  i = (ix+(0x95f64<<3))&0x800000;\n"
"\n"
"  u.i = ix|(i^0x3f800000); x = u.f;//SET_FLOAT_WORD(x,ix|(i^0x3f800000));    /** normalize x or x/2 */\n"
"  k += (i>>23);\n"
"  dk = (float)k;\n"
"  f = x-(float)1.0;\n"
"\n"
"  if((0x007fffff&(15+ix))<16) {    /** |f| < 2**-20 */\n"
"      if(f==zero) return dk;\n"
"\n"
"      R = f*f*((float)0.5-(float)0.33333333333333333*f);\n"
"      return dk-(R-f)/ln2;\n"
"  }\n"
"\n"
"  s = f/((float)2.0+f);\n"
"  z = s*s;\n"
"  i = ix-(0x6147a<<3);\n"
"  w = z*z;\n"
"  j = (0x6b851<<3)-ix;\n"
"  t1= w*(Lg2+w*(Lg4+w*Lg6));\n"
"  t2= z*(Lg1+w*(Lg3+w*(Lg5+w*Lg7)));\n"
"  i |= j;\n"
"  R = t2+t1;\n"
"\n"
"  if(i>0) {\n"
"      hfsq=(float)0.5*f*f;\n"
"      return dk-((hfsq-(s*(hfsq+R)))-f)/ln2;\n"
"  } else {\n"
"      return dk-((s*(f-R))-f)/ln2;\n"
"  }\n"
"}\n"
"\n"
"INLINE float __gen_ocl_scalbnf (float x, int n){\n"
"  /* copy from fdlibm */\n"
"  float two25 = 3.355443200e+07,	/* 0x4c000000 */\n"
"  twom25 = 2.9802322388e-08,	        /* 0x33000000 */\n"
"  huge = 1.0e+30,\n"
"  tiny = 1.0e-30;\n"
"  int k,ix;\n"
"  GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"  k = (ix&0x7f800000)>>23; /* extract exponent */\n"
"  if (k==0) {	/* 0 or subnormal x */\n"
"    if ((ix&0x7fffffff)==0) return x; /* +-0 */\n"
"    x *= two25;\n"
"    GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"    k = ((ix&0x7f800000)>>23) - 25;\n"
"  }\n"
"  if (k==0xff) return x+x;	/* NaN or Inf */\n"
"  if (n< -50000)\n"
"    return tiny*__gen_ocl_internal_copysign(tiny,x);	/*underflow*/\n"
"  if (n> 50000 || k+n > 0xfe)\n"
"    return huge*__gen_ocl_internal_copysign(huge,x); /* overflow  */\n"
"  /* Now k and n are bounded we know that k = k+n does not overflow. */\n"
"  k = k+n;\n"
"  if (k > 0) { /* normal result */\n"
"    GEN_OCL_SET_FLOAT_WORD(x,(ix&0x807fffff)|(k<<23));\n"
"    return x;\n"
"  }\n"
"  if (k <= -25)\n"
"    return tiny*__gen_ocl_internal_copysign(tiny,x);	/*underflow*/\n"
"  k += 25;				/* subnormal result */\n"
"  GEN_OCL_SET_FLOAT_WORD(x,(ix&0x807fffff)|(k<<23));\n"
"  return x*twom25;\n"
"}\n"
"\n"
"\n"
"\n"
"__constant const float PIo2[] = {\n"
"  1.5703125000e+00, /* 0x3fc90000 */\n"
"  4.5776367188e-04, /* 0x39f00000 */\n"
"  2.5987625122e-05, /* 0x37da0000 */\n"
"  7.5437128544e-08, /* 0x33a20000 */\n"
"  6.0026650317e-11, /* 0x2e840000 */\n"
"  7.3896444519e-13, /* 0x2b500000 */\n"
"  5.3845816694e-15, /* 0x27c20000 */\n"
"  5.6378512969e-18, /* 0x22d00000 */\n"
"  8.3009228831e-20, /* 0x1fc40000 */\n"
"  3.2756352257e-22, /* 0x1bc60000 */\n"
"  6.3331015649e-25, /* 0x17440000 */\n"
"};\n"
"\n"
"INLINE int __kernel_rem_pio2f(float *x, float *y, int e0, int nx, int prec, const __constant int *ipio2)\n"
"{\n"
"  /* copied from fdlibm */\n"
"const float\n"
"zero   = 0.0,\n"
"one    = 1.0,\n"
"two8   =  2.5600000000e+02, /* 0x43800000 */\n"
"twon8  =  3.9062500000e-03; /* 0x3b800000 */\n"
"\n"
"  int init_jk[3]; /* initial value for jk */\n"
"  int jz,jx,jv,jp,jk,carry,n,iq[20],i,j,k,m,q0,ih;\n"
"  float z,fw,f[20],fq[20],q[20];\n"
"  init_jk[0] = 4; init_jk[1] = 7; init_jk[2] = 9;\n"
"    /* initialize jk*/\n"
"  jk = init_jk[prec];\n"
"  jp = jk;\n"
"\n"
"    /* determine jx,jv,q0, note that 3>q0 */\n"
"  jx =  nx-1;\n"
"  jv = (e0-3)/8; if(jv<0) jv=0;\n"
"  q0 =  e0-8*(jv+1);\n"
"\n"
"    /* set up f[0] to f[jx+jk] where f[jx+jk] = ipio2[jv+jk] */\n"
"  j = jv-jx; m = jx+jk;\n"
"  for(i=0;i<=m;i++,j++) f[i] = (j<0)? zero : (float) ipio2[j];\n"
"\n"
"    /* compute q[0],q[1],...q[jk] */\n"
"  for (i=0;i<=jk;i++) {\n"
"      for(j=0,fw=0.0;j<=jx;j++) fw += x[j]*f[jx+i-j]; q[i] = fw;\n"
"  }\n"
"\n"
"  jz = jk;\n"
"recompute:\n"
"    /* distill q[] into iq[] reversingly */\n"
"  for(i=0,j=jz,z=q[jz];j>0;i++,j--) {\n"
"      fw    =  (float)((int)(twon8* z));\n"
"      iq[i] =  (int)(z-two8*fw);\n"
"      z     =  q[j-1]+fw;\n"
"  }\n"
"\n"
"    /* compute n */\n"
"  z  = __gen_ocl_scalbnf(z,q0);   /* actual value of z */\n"
"  z -= (float)8.0*__gen_ocl_internal_floor(z*(float)0.125); /* trim off integer >= 8 */\n"
"  n  = (int) z;\n"
"  z -= (float)n;\n"
"  ih = 0;\n"
"  if(q0>0) {  /* need iq[jz-1] to determine n */\n"
"      i  = (iq[jz-1]>>(8-q0)); n += i;\n"
"      iq[jz-1] -= i<<(8-q0);\n"
"      ih = iq[jz-1]>>(7-q0);\n"
"  }\n"
"  else if(q0==0) ih = iq[jz-1]>>8;\n"
"  else if(z>=(float)0.5) ih=2;\n"
"\n"
"  if(ih>0) {  /* q > 0.5 */\n"
"      n += 1; carry = 0;\n"
"      for(i=0;i<jz ;i++) {  /* compute 1-q */\n"
"    j = iq[i];\n"
"    if(carry==0) {\n"
"        if(j!=0) {\n"
"      carry = 1; iq[i] = 0x100- j;\n"
"        }\n"
"    } else  iq[i] = 0xff - j;\n"
"      }\n"
"      if(q0>0) {    /* rare case: chance is 1 in 12 */\n"
"          switch(q0) {\n"
"          case 1:\n"
"           iq[jz-1] &= 0x7f; break;\n"
"        case 2:\n"
"           iq[jz-1] &= 0x3f; break;\n"
"          }\n"
"      }\n"
"      if(ih==2) {\n"
"    z = one - z;\n"
"    if(carry!=0) z -= __gen_ocl_scalbnf(one,q0);\n"
"      }\n"
"  }\n"
"\n"
"    /* check if recomputation is needed */\n"
"  if(z==zero) {\n"
"      j = 0;\n"
"      for (i=jz-1;i>=jk;i--) j |= iq[i];\n"
"      if(j==0) { /* need recomputation */\n"
"    for(k=1;iq[jk-k]==0;k++);   /* k = no. of terms needed */\n"
"\n"
"    for(i=jz+1;i<=jz+k;i++) {   /* add q[jz+1] to q[jz+k] */\n"
"        f[jx+i] = (float) ipio2[jv+i];\n"
"        for(j=0,fw=0.0;j<=jx;j++) fw += x[j]*f[jx+i-j];\n"
"        q[i] = fw;\n"
"    }\n"
"    jz += k;\n"
"    goto recompute;\n"
"      }\n"
"  }\n"
"\n"
"    /* chop off zero terms */\n"
"  if(z==(float)0.0) {\n"
"      jz -= 1; q0 -= 8;\n"
"      while(iq[jz]==0) { jz--; q0-=8;}\n"
"  } else { /* break z into 8-bit if necessary */\n"
"      z = __gen_ocl_scalbnf(z,-q0);\n"
"      if(z>=two8) {\n"
"    fw = (float)((int)(twon8*z));\n"
"    iq[jz] = (int)(z-two8*fw);\n"
"    jz += 1; q0 += 8;\n"
"    iq[jz] = (int) fw;\n"
"      } else iq[jz] = (int) z ;\n"
"  }\n"
"\n"
"    /* convert integer \"bit\" chunk to floating-point value */\n"
"  fw = __gen_ocl_scalbnf(one,q0);\n"
"  for(i=jz;i>=0;i--) {\n"
"      q[i] = fw*(float)iq[i]; fw*=twon8;\n"
"  }\n"
"\n"
"    /* compute PIo2[0,...,jp]*q[jz,...,0] */\n"
"  for(i=jz;i>=0;i--) {\n"
"      for(fw=0.0,k=0;k<=jp&&k<=jz-i;k++) fw += PIo2[k]*q[i+k];\n"
"      fq[jz-i] = fw;\n"
"  }\n"
"\n"
"    /* compress fq[] into y[] */\n"
"  switch(prec) {\n"
"      case 0:\n"
"    fw = 0.0;\n"
"    for (i=jz;i>=0;i--) fw += fq[i];\n"
"    y[0] = (ih==0)? fw: -fw;\n"
"    break;\n"
"      case 1:\n"
"      case 2:\n"
"    fw = 0.0;\n"
"    for (i=jz;i>=0;i--) fw += fq[i];\n"
"    y[0] = (ih==0)? fw: -fw;\n"
"    fw = fq[0]-fw;\n"
"    for (i=1;i<=jz;i++) fw += fq[i];\n"
"    y[1] = (ih==0)? fw: -fw;\n"
"    break;\n"
"      case 3: /* painful */\n"
"    for (i=jz;i>0;i--) {\n"
"        fw      = fq[i-1]+fq[i];\n"
"        fq[i]  += fq[i-1]-fw;\n"
"        fq[i-1] = fw;\n"
"    }\n"
"    for (i=jz;i>1;i--) {\n"
"        fw      = fq[i-1]+fq[i];\n"
"        fq[i]  += fq[i-1]-fw;\n"
"        fq[i-1] = fw;\n"
"    }\n"
"    for (fw=0.0,i=jz;i>=2;i--) fw += fq[i];\n"
"    if(ih==0) {\n"
"        y[0] =  fq[0]; y[1] =  fq[1]; y[2] =  fw;\n"
"    } else {\n"
"        y[0] = -fq[0]; y[1] = -fq[1]; y[2] = -fw;\n"
"    }\n"
"  }\n"
"  return n&7;\n"
"\n"
"}\n"
"__constant const int npio2_hw[32] = {\n"
"0x3fc90f00, 0x40490f00, 0x4096cb00, 0x40c90f00, 0x40fb5300, 0x4116cb00,\n"
"0x412fed00, 0x41490f00, 0x41623100, 0x417b5300, 0x418a3a00, 0x4196cb00,\n"
"0x41a35c00, 0x41afed00, 0x41bc7e00, 0x41c90f00, 0x41d5a000, 0x41e23100,\n"
"0x41eec200, 0x41fb5300, 0x4203f200, 0x420a3a00, 0x42108300, 0x4216cb00,\n"
"0x421d1400, 0x42235c00, 0x4229a500, 0x422fed00, 0x42363600, 0x423c7e00,\n"
"0x4242c700, 0x42490f00\n"
"};\n"
"\n"
"__constant const int two_over_pi[22*9] = {\n"
"0xA2, 0xF9, 0x83, 0x6E, 0x4E, 0x44, 0x15, 0x29, 0xFC,\n"
"0x27, 0x57, 0xD1, 0xF5, 0x34, 0xDD, 0xC0, 0xDB, 0x62,\n"
"0x95, 0x99, 0x3C, 0x43, 0x90, 0x41, 0xFE, 0x51, 0x63,\n"
"0xAB, 0xDE, 0xBB, 0xC5, 0x61, 0xB7, 0x24, 0x6E, 0x3A,\n"
"0x42, 0x4D, 0xD2, 0xE0, 0x06, 0x49, 0x2E, 0xEA, 0x09,\n"
"0xD1, 0x92, 0x1C, 0xFE, 0x1D, 0xEB, 0x1C, 0xB1, 0x29,\n"
"0xA7, 0x3E, 0xE8, 0x82, 0x35, 0xF5, 0x2E, 0xBB, 0x44,\n"
"0x84, 0xE9, 0x9C, 0x70, 0x26, 0xB4, 0x5F, 0x7E, 0x41,\n"
"0x39, 0x91, 0xD6, 0x39, 0x83, 0x53, 0x39, 0xF4, 0x9C,\n"
"0x84, 0x5F, 0x8B, 0xBD, 0xF9, 0x28, 0x3B, 0x1F, 0xF8,\n"
"0x97, 0xFF, 0xDE, 0x05, 0x98, 0x0F, 0xEF, 0x2F, 0x11,\n"
"0x8B, 0x5A, 0x0A, 0x6D, 0x1F, 0x6D, 0x36, 0x7E, 0xCF,\n"
"0x27, 0xCB, 0x09, 0xB7, 0x4F, 0x46, 0x3F, 0x66, 0x9E,\n"
"0x5F, 0xEA, 0x2D, 0x75, 0x27, 0xBA, 0xC7, 0xEB, 0xE5,\n"
"0xF1, 0x7B, 0x3D, 0x07, 0x39, 0xF7, 0x8A, 0x52, 0x92,\n"
"0xEA, 0x6B, 0xFB, 0x5F, 0xB1, 0x1F, 0x8D, 0x5D, 0x08,\n"
"0x56, 0x03, 0x30, 0x46, 0xFC, 0x7B, 0x6B, 0xAB, 0xF0,\n"
"0xCF, 0xBC, 0x20, 0x9A, 0xF4, 0x36, 0x1D, 0xA9, 0xE3,\n"
"0x91, 0x61, 0x5E, 0xE6, 0x1B, 0x08, 0x65, 0x99, 0x85,\n"
"0x5F, 0x14, 0xA0, 0x68, 0x40, 0x8D, 0xFF, 0xD8, 0x80,\n"
"0x4D, 0x73, 0x27, 0x31, 0x06, 0x06, 0x15, 0x56, 0xCA,\n"
"0x73, 0xA8, 0xC9, 0x60, 0xE2, 0x7B, 0xC0, 0x8C, 0x6B,\n"
"};\n"
"\n"
"\n"
"\n"
"INLINE int __ieee754_rem_pio2f(float x, float *y) {\n"
"  /* copied from fdlibm */\n"
"  float z,w,t,r,fn;\n"
"  float tx[3];\n"
"\n"
"const float half_value = 5.0000000e-1;\n"
"const float zero =  0.0000000000;\n"
"const float two8 =  2.5600000000e+02;\n"
"const float invpio2 =  6.3661980629e-01;\n"
"const float pio2_1  =  1.5707855225e+00;\n"
"const float pio2_1t =  1.0804334124e-05;\n"
"const float pio2_2  =  1.0804273188e-05;\n"
"const float pio2_2t =  6.0770999344e-11;\n"
"const float pio2_3  =  6.0770943833e-11;\n"
"const float pio2_3t =  6.1232342629e-17;\n"
"  int e0,i,j,nx,n,ix,hx;\n"
"\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  ix = hx&0x7fffffff;\n"
"  if(ix<=0x3f490fd8)   /* |x| ~<= pi/4 , no need for reduction */\n"
"      {y[0] = x; y[1] = 0; return 0;}\n"
"  if(ix<0x4016cbe4) {  /* |x| < 3pi/4, special case with n=+-1 */\n"
"      if(hx>0) {\n"
"    z = x - pio2_1;\n"
"    if((ix&0xfffffff0)!=0x3fc90fd0) { /* 24+24 bit pi OK */\n"
"        y[0] = z - pio2_1t;\n"
"        y[1] = (z-y[0])-pio2_1t;\n"
"    } else {    /* near pi/2, use 24+24+24 bit pi */\n"
"        z -= pio2_2;\n"
"        y[0] = z - pio2_2t;\n"
"        y[1] = (z-y[0])-pio2_2t;\n"
"    }\n"
"    return 1;\n"
"      } else {  /* negative x */\n"
"    z = x + pio2_1;\n"
"    if((ix&0xfffffff0)!=0x3fc90fd0) { /* 24+24 bit pi OK */\n"
"        y[0] = z + pio2_1t;\n"
"        y[1] = (z-y[0])+pio2_1t;\n"
"    } else {    /* near pi/2, use 24+24+24 bit pi */\n"
"        z += pio2_2;\n"
"        y[0] = z + pio2_2t;\n"
"        y[1] = (z-y[0])+pio2_2t;\n"
"    }\n"
"    return -1;\n"
"      }\n"
"  }\n"
"  if(ix<=0x43490f80) { /* |x| ~<= 2^7*(pi/2), medium size */\n"
"      t  = __gen_ocl_fabs(x);\n"
"      n  = (int) (t*invpio2+half_value);\n"
"      fn = (float)n;\n"
"      r  = t-fn*pio2_1;\n"
"      w  = fn*pio2_1t;  /* 1st round good to 40 bit */\n"
"      if(n<32&&(ix&0xffffff00)!=npio2_hw[n-1]) {\n"
"    y[0] = r-w; /* quick check no cancellation */\n"
"      } else {\n"
"          uint high;\n"
"          j  = ix>>23;\n"
"          y[0] = r-w;\n"
"    GEN_OCL_GET_FLOAT_WORD(high,y[0]);\n"
"          i = j-((high>>23)&0xff);\n"
"          if(i>8) {  /* 2nd iteration needed, good to 57 */\n"
"        t  = r;\n"
"        w  = fn*pio2_2;\n"
"        r  = t-w;\n"
"        w  = fn*pio2_2t-((t-r)-w);\n"
"        y[0] = r-w;\n"
"        GEN_OCL_GET_FLOAT_WORD(high,y[0]);\n"
"        i = j-((high>>23)&0xff);\n"
"        if(i>25)  { /* 3rd iteration need, 74 bits acc */\n"
"          t  = r; /* will cover all possible cases */\n"
"          w  = fn*pio2_3;\n"
"          r  = t-w;\n"
"          w  = fn*pio2_3t-((t-r)-w);\n"
"          y[0] = r-w;\n"
"        }\n"
"    }\n"
"      }\n"
"      y[1] = (r-y[0])-w;\n"
"      if(hx<0)  {y[0] = -y[0]; y[1] = -y[1]; return -n;}\n"
"      else   return n;\n"
"  }\n"
"    /*\n"
"     * all other (large) arguments\n"
"     */\n"
"  if(ix>=0x7f800000) {    /* x is inf or NaN */\n"
"      y[0]=y[1]=x-x; return 0;\n"
"  }\n"
"    /* set z = scalbn(|x|,ilogb(x)-7) */\n"
"  e0  = (ix>>23)-134;   /* e0 = ilogb(z)-7; */\n"
"  GEN_OCL_SET_FLOAT_WORD(z, ix - ((int)(e0<<23)));\n"
"  for(i=0;i<2;i++) {\n"
"    tx[i] = (float)((int)(z));\n"
"    z     = (z-tx[i])*two8;\n"
"  }\n"
"  tx[2] = z;\n"
"  nx = 3;\n"
"  while(tx[nx-1]==zero) nx--; /* skip zero term */\n"
"  n  =  __kernel_rem_pio2f(tx,y,e0,nx,2,two_over_pi);\n"
"  if(hx<0) {y[0] = -y[0]; y[1] = -y[1]; return -n;}\n"
"  return n;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __kernel_sinf(float x, float y, int iy)\n"
"{\n"
"  /* copied from fdlibm */\n"
"const float\n"
"half_value =  5.0000000000e-01,/* 0x3f000000 */\n"
"S1  = -1.6666667163e-01, /* 0xbe2aaaab */\n"
"S2  =  8.3333337680e-03, /* 0x3c088889 */\n"
"S3  = -1.9841270114e-04, /* 0xb9500d01 */\n"
"S4  =  2.7557314297e-06, /* 0x3638ef1b */\n"
"S5  = -2.5050759689e-08, /* 0xb2d72f34 */\n"
"S6  =  1.5896910177e-10; /* 0x2f2ec9d3 */\n"
"  float z,r,v;\n"
"  int ix;\n"
"  GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"  ix &= 0x7fffffff;     /* high word of x */\n"
"  if(ix<0x32000000)     /* |x| < 2**-27 */\n"
"     {if((int)x==0) return x;}    /* generate inexact */\n"
"  z =  x*x;\n"
"  v =  z*x;\n"
"  r =  S2+z*(S3+z*(S4+z*(S5+z*S6)));\n"
"  if(iy==0) return x+v*(S1+z*r);\n"
"  else      return x-((z*(half_value*y-v*r)-y)-v*S1);\n"
"}\n"
"\n"
"INLINE  float __kernel_cosf(float x, float y)\n"
"{\n"
"  /* copied from fdlibm */\n"
"  const float\n"
"  one =  1.0000000000e+00, /* 0x3f800000 */\n"
"  C1  =  4.1666667908e-02, /* 0x3d2aaaab */\n"
"  C2  = -1.3888889225e-03, /* 0xbab60b61 */\n"
"  C3  =  2.4801587642e-05, /* 0x37d00d01 */\n"
"  C4  = -2.7557314297e-07, /* 0xb493f27c */\n"
"  C5  =  2.0875723372e-09, /* 0x310f74f6 */\n"
"  C6  = -1.1359647598e-11; /* 0xad47d74e */\n"
"  const float pio2_hi = 0x1.92p0, pio2_mid = 0x1.fb4p-12, pio2_low = 0x1.4442d2p-24;\n"
"  float a,hz,z,r,qx;\n"
"  int ix;\n"
"  GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"  ix &= 0x7fffffff;     /* ix = |x|'s high word*/\n"
"  if(ix<0x32000000) {     /* if x < 2**27 */\n"
"      if(((int)x)==0) return one;   /* generate inexact */\n"
"  }\n"
"\n"
"  if(x < 0.0f) { x= -x; y = -y; }\n"
"  if(ix > 0x3f490fdb) { /* |x|>pi/4*/\n"
"    return -__kernel_sinf(x-pio2_hi-pio2_mid-pio2_low, y, 1);\n"
"  }\n"
"  z  = x*x;\n"
"  r  = z*(C1+z*(C2+z*(C3+z*(C4+z*(C5+z*C6)))));\n"
"  if(ix < 0x3e99999a)       /* if |x| < 0.3 */\n"
"      return one - ((float)0.5*z - (z*r - x*y));\n"
"  else {\n"
"      GEN_OCL_SET_FLOAT_WORD(qx,ix-0x01000000); /* x/4 */\n"
"      hz = (float)0.5*z-qx;\n"
"      a  = one-qx;\n"
"      return a - (hz - (z*r-x*y));\n"
"  }\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE  float sin(float x) {\n"
"  /* copied from fdlibm */\n"
"  float y[2],z=0.0;\n"
"  int n, ix;\n"
"\n"
"  GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"\n"
"    /* |x| ~< pi/4 */\n"
"  ix &= 0x7fffffff;\n"
"  if(ix <= 0x3f490fd8) return __kernel_sinf(x,z,0);\n"
"\n"
"    /* sin(Inf or NaN) is NaN */\n"
"  else if (ix>=0x7f800000) return x-x;\n"
"\n"
"    /* argument reduction needed */\n"
"  else {\n"
"      n = __ieee754_rem_pio2f(x,y);\n"
"      switch(n&3) {\n"
"    case 0: return  __kernel_sinf(y[0],y[1],1);\n"
"    case 1: return  __kernel_cosf(y[0],y[1]);\n"
"    case 2: return -__kernel_sinf(y[0],y[1],1);\n"
"    default:\n"
"      return -__kernel_cosf(y[0],y[1]);\n"
"      }\n"
"  }\n"
"}\n"
"INLINE_OVERLOADABLE  float cos(float x) {\n"
"  /* copied from fdlibm */\n"
"  float y[2],z=0.0;\n"
"  int n, ix;\n"
"\n"
"  GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"\n"
"    /* |x| ~< pi/4 */\n"
"  ix &= 0x7fffffff;\n"
"  if(ix <= 0x3f490fd8) return __kernel_cosf(x,z);\n"
"\n"
"    /* cos(Inf or NaN) is NaN */\n"
"  else if (ix>=0x7f800000) return x-x;\n"
"\n"
"    /* argument reduction needed */\n"
"  else {\n"
"      n = __ieee754_rem_pio2f(x,y);\n"
"      switch(n&3) {\n"
"    case 0: return  __kernel_cosf(y[0],y[1]);\n"
"    case 1: return  -__kernel_sinf(y[0],y[1],1);\n"
"    case 2: return -__kernel_cosf(y[0],y[1]);\n"
"    default:\n"
"      return __kernel_sinf(y[0],y[1],1);\n"
"      }\n"
"  }\n"
"}\n"
"\n"
"INLINE float __kernel_tanf(float x, float y, int iy)\n"
"{\n"
"  /* copied from fdlibm */\n"
"        float z,r,v,w,s;\n"
"        int ix,hx;\n"
"        const float\n"
"        one   =  1.0000000000e+00, /* 0x3f800000 */\n"
"        pio4  =  7.8539812565e-01, /* 0x3f490fda */\n"
"        pio4lo=  3.7748947079e-08; /* 0x33222168 */\n"
"        float T[13];// =  {\n"
"         T[0] = 3.3333334327e-01; /* 0x3eaaaaab */\n"
"         T[1] = 1.3333334029e-01; /* 0x3e088889 */\n"
"         T[2] = 5.3968254477e-02; /* 0x3d5d0dd1 */\n"
"         T[3] = 2.1869488060e-02; /* 0x3cb327a4 */\n"
"         T[4] = 8.8632395491e-03; /* 0x3c11371f */\n"
"         T[5] = 3.5920790397e-03; /* 0x3b6b6916 */\n"
"         T[6] = 1.4562094584e-03; /* 0x3abede48 */\n"
"         T[7] = 5.8804126456e-04; /* 0x3a1a26c8 */\n"
"         T[8] = 2.4646313977e-04; /* 0x398137b9 */\n"
"         T[9] = 7.8179444245e-05; /* 0x38a3f445 */\n"
"         T[10] = 7.1407252108e-05; /* 0x3895c07a */\n"
"         T[11] = -1.8558637748e-05; /* 0xb79bae5f */\n"
"         T[12] = 2.5907305826e-05; /* 0x37d95384 */\n"
"\n"
"\n"
"        GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"        ix = hx&0x7fffffff;     /* high word of |x| */\n"
"        if(ix<0x31800000)                       /* x < 2**-28 */\n"
"            {if((int)x==0) {                    /* generate inexact */\n"
"                if((ix|(iy+1))==0) return one/__gen_ocl_fabs(x);\n"
"                else return (iy==1)? x: -one/x;\n"
"            }\n"
"            }\n"
"        if(ix>=0x3f2ca140) {                    /* |x|>=0.6744 */\n"
"            if(hx<0) {x = -x; y = -y;}\n"
"\n"
"\n"
"            z = pio4-x;\n"
"            w = pio4lo-y;\n"
"            x = z+w; y = 0.0;\n"
"        }\n"
"        z       =  x*x;\n"
"        w       =  z*z;\n"
"    /* Break x^5*(T[1]+x^2*T[2]+...) into\n"
"     *    x^5(T[1]+x^4*T[3]+...+x^20*T[11]) +\n"
"     *    x^5(x^2*(T[2]+x^4*T[4]+...+x^22*[T12]))\n"
"     */\n"
"        r = T[1]+w*(T[3]+w*(T[5]+w*(T[7]+w*(T[9]+w*T[11]))));\n"
"        v = z*(T[2]+w*(T[4]+w*(T[6]+w*(T[8]+w*(T[10]+w*T[12])))));\n"
"        s = z*x;\n"
"        r = y + z*(s*(r+v)+y);\n"
"        r += T[0]*s;\n"
"        w = x+r;\n"
"        if(ix>=0x3f2ca140) {\n"
"            v = (float)iy;\n"
"            return (float)(1-((hx>>30)&2))*(v-(float)2.0*(x-(w*w/(w+v)-r)));\n"
"        }\n"
"        if(iy==1) return w;\n"
"        else {          /* if allow error up to 2 ulp\n"
"                           simply return -1.0/(x+r) here */\n"
"     /*  compute -1.0/(x+r) accurately */\n"
"            float a,t;\n"
"            int i;\n"
"            z  = w;\n"
"            GEN_OCL_GET_FLOAT_WORD(i,z);\n"
"            GEN_OCL_SET_FLOAT_WORD(z,i&0xfffff000);\n"
"            v  = r-(z - x);     /* z+v = r+x */\n"
"            t = a  = -(float)1.0/w;     /* a = -1.0/w */\n"
"            GEN_OCL_GET_FLOAT_WORD(i,t);\n"
"            GEN_OCL_SET_FLOAT_WORD(t,i&0xfffff000);\n"
"            s  = (float)1.0+t*z;\n"
"            return t+a*(s+t*v);\n"
"        }\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float tan(float x)\n"
"{\n"
"  /* copied from fdlibm */\n"
"        const float pio2_hi = 0x1.92p-0, pio2_mid = 0x1.fb4p-12, pio2_low = 0x1.4442d2p-24;\n"
"        const float pio4  =  7.8539812565e-01;\n"
"        float y[2],z=0.0;\n"
"        int n, ix;\n"
"\n"
"        GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"\n"
"    /* |x| ~< pi/4 */\n"
"        ix &= 0x7fffffff;\n"
"        if(ix <= 0x3f490fda) return __kernel_tanf(x,z,1);\n"
"\n"
"    /* tan(Inf or NaN) is NaN */\n"
"        else if (ix>=0x7f800000) return x-x;            /* NaN */\n"
"\n"
"    /* argument reduction needed */\n"
"      else {\n"
"        n = __ieee754_rem_pio2f(x,y);\n"
"\n"
"        x = y[0];\n"
"        float m = y[1];\n"
"        int iy = 1-((n&1)<<1);\n"
"        GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"        float sign = 1.0f;\n"
"        if(ix < 0) {\n"
"          x = -x; m = -m;\n"
"          sign = -1.0f;\n"
"        }\n"
"\n"
"        if(x > pio4) {/* reduce x to less than pi/4 through (pi/2-x) */\n"
"          float t = __kernel_tanf(pio2_hi-x+pio2_mid+pio2_low, -m, 1);\n"
"          if(iy == -1) return sign*(-t); else return sign*1/t;\n"
"        } else\n"
"            return __kernel_tanf(y[0],y[1],1-((n&1)<<1)); /*   1 -- n even\n"
"                                                              -1 -- n odd */\n"
"      }\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float native_cos(float x) { return __gen_ocl_cos(x); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_cospi(float x) {\n"
"  int ix;\n"
"  if(isinf(x) || isnan(x)) { return NAN; }\n"
"  if(x < 0.0f) { x = -x; }\n"
"  GEN_OCL_GET_FLOAT_WORD(ix, x);\n"
"  if(x> 0x1.0p24) return 1.0f;\n"
"  float m = __gen_ocl_internal_floor(x);\n"
"  ix = (int)m;\n"
"  m = x-m;\n"
"  if((ix&0x1) != 0) m+=1.0f;\n"
"    ix = __gen_ocl_internal_floor(m*4.0f);\n"
"\n"
"  switch(ix) {\n"
"   case 0:\n"
"    return __kernel_cosf(m*M_PI_F, 0.0f);\n"
"   case 1:\n"
"   case 2:\n"
"    return __kernel_sinf((0.5f-m)*M_PI_F, 0.0f, 0);\n"
"   case 3:\n"
"   case 4:\n"
"    return -__kernel_cosf((m-1.0f)*M_PI_F, 0.0f);\n"
"   case 5:\n"
"   case 6:\n"
"    return __kernel_sinf((m-1.5f)*M_PI_F, 0.0f, 0);\n"
"   default:\n"
"    return __kernel_cosf((2.0f-m)*M_PI_F, 0.0f);\n"
"   }\n"
"}\n"
"INLINE_OVERLOADABLE float native_sin(float x) { return __gen_ocl_sin(x); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_sinpi(float x) {\n"
"  float sign = 1.0f;\n"
"  int ix;\n"
"  if(isinf(x)) return NAN;\n"
"  if(x < 0.0f) { x = -x; sign = -1.0f; }\n"
"  GEN_OCL_GET_FLOAT_WORD(ix, x);\n"
"  if(x> 0x1.0p24) return 0.0f;\n"
"  float m = __gen_ocl_internal_floor(x);\n"
"  ix = (int)m;\n"
"  m = x-m;\n"
"  if((ix&0x1) != 0) m+=1.0f;\n"
"    ix = __gen_ocl_internal_floor(m*4.0f);\n"
"\n"
"  switch(ix) {\n"
"   case 0:\n"
"    return sign*__kernel_sinf(m*M_PI_F, 0.0f, 0);\n"
"   case 1:\n"
"   case 2:\n"
"    return sign*__kernel_cosf((m-0.5f)*M_PI_F, 0.0f);\n"
"   case 3:\n"
"   case 4:\n"
"    return -sign*__kernel_sinf((m-1.0f)*M_PI_F, 0.0f, 0);\n"
"   case 5:\n"
"   case 6:\n"
"    return -sign*__kernel_cosf((m-1.5f)*M_PI_F, 0.0f);\n"
"   default:\n"
"    return -sign*__kernel_sinf((2.0f-m)*M_PI_F, 0.0f, 0);\n"
"   }\n"
"\n"
"}\n"
"INLINE_OVERLOADABLE float native_sqrt(float x) { return __gen_ocl_sqrt(x); }\n"
"INLINE_OVERLOADABLE float native_rsqrt(float x) { return __gen_ocl_rsqrt(x); }\n"
"INLINE_OVERLOADABLE float native_log2(float x) { return __gen_ocl_log(x); }\n"
"INLINE_OVERLOADABLE float native_log(float x) {\n"
"  return native_log2(x) * 0.6931472002f;\n"
"}\n"
"INLINE_OVERLOADABLE float tgamma(float x) {\n"
"/*\n"
" * ====================================================\n"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\n"
" *\n"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\n"
" * Permission to use, copy, modify, and distribute this\n"
" * software is freely granted, provided that this notice\n"
" * is preserved.\n"
" * ====================================================\n"
" */\n"
"  float pi = 3.1415927410e+00,\n"
"    a0 = 7.7215664089e-02,\n"
"    a1 = 3.2246702909e-01,\n"
"    a2 = 6.7352302372e-02,\n"
"    a3 = 2.0580807701e-02,\n"
"    a4 = 7.3855509982e-03,\n"
"    a5 = 2.8905137442e-03,\n"
"    a6 = 1.1927076848e-03,\n"
"    a7 = 5.1006977446e-04,\n"
"    a8 = 2.2086278477e-04,\n"
"    a9 = 1.0801156895e-04,\n"
"    a10 = 2.5214456400e-05,\n"
"    a11 = 4.4864096708e-05,\n"
"    tc = 1.4616321325e+00,\n"
"    tf = -1.2148628384e-01,\n"
"    tt = 6.6971006518e-09,\n"
"    t0 = 4.8383611441e-01,\n"
"    t1 = -1.4758771658e-01,\n"
"    t2 = 6.4624942839e-02,\n"
"    t3 = -3.2788541168e-02,\n"
"    t4 = 1.7970675603e-02,\n"
"    t5 = -1.0314224288e-02,\n"
"    t6 = 6.1005386524e-03,\n"
"    t7 = -3.6845202558e-03,\n"
"    t8 = 2.2596477065e-03,\n"
"    t9 = -1.4034647029e-03,\n"
"    t10 = 8.8108185446e-04,\n"
"    t11 = -5.3859531181e-04,\n"
"    t12 = 3.1563205994e-04,\n"
"    t13 = -3.1275415677e-04,\n"
"    t14 = 3.3552918467e-04,\n"
"    u0 = -7.7215664089e-02,\n"
"    u1 = 6.3282704353e-01,\n"
"    u2 = 1.4549225569e+00,\n"
"    u3 = 9.7771751881e-01,\n"
"    u4 = 2.2896373272e-01,\n"
"    u5 = 1.3381091878e-02,\n"
"    v1 = 2.4559779167e+00,\n"
"    v2 = 2.1284897327e+00,\n"
"    v3 = 7.6928514242e-01,\n"
"    v4 = 1.0422264785e-01,\n"
"    v5 = 3.2170924824e-03,\n"
"    s0 = -7.7215664089e-02,\n"
"    s1 = 2.1498242021e-01,\n"
"    s2 = 3.2577878237e-01,\n"
"    s3 = 1.4635047317e-01,\n"
"    s4 = 2.6642270386e-02,\n"
"    s5 = 1.8402845599e-03,\n"
"    s6 = 3.1947532989e-05,\n"
"    r1 = 1.3920053244e+00,\n"
"    r2 = 7.2193557024e-01,\n"
"    r3 = 1.7193385959e-01,\n"
"    r4 = 1.8645919859e-02,\n"
"    r5 = 7.7794247773e-04,\n"
"    r6 = 7.3266842264e-06,\n"
"    w0 = 4.1893854737e-01,\n"
"    w1 = 8.3333335817e-02,\n"
"    w2 = -2.7777778450e-03,\n"
"    w3 = 7.9365057172e-04,\n"
"    w4 = -5.9518753551e-04,\n"
"    w5 = 8.3633989561e-04,\n"
"    w6 = -1.6309292987e-03;\n"
"  float t, y, z, nadj, p, p1, p2, p3, q, r, w;\n"
"  int i, hx, ix;\n"
"  nadj = 0;\n"
"  hx = *(int *) (&x);\n"
"  ix = hx & 0x7fffffff;\n"
"  if (ix >= 0x7f800000)\n"
"    return x * x;\n"
"  if (ix == 0)\n"
"    return INFINITY;\n"
"  if (ix < 0x1c800000) {\n"
"    if (hx < 0) {\n"
"      return - native_log(-x);\n"
"    } else\n"
"      return - native_log(x);\n"
"  }\n"
"  if (hx < 0) {\n"
"    if (ix >= 0x4b000000)\n"
"      return INFINITY;\n"
"    t = __gen_ocl_internal_sinpi(x);\n"
"    if (__gen_ocl_fabs(t) < 1e-8f)\n"
"      return INFINITY;\n"
"    nadj = native_log(M_PI_F / __gen_ocl_fabs(t * x));\n"
"    x = -x;\n"
"  }\n"
"\n"
"  if (ix == 0x3f800000 || ix == 0x40000000)\n"
"    r = 0;\n"
"  else if (ix < 0x40000000) {\n"
"    if (ix <= 0x3f666666) {\n"
"      r = - native_log(x);\n"
"      if (ix >= 0x3f3b4a20) {\n"
"        y = 1 - x;\n"
"        i = 0;\n"
"      } else if (ix >= 0x3e6d3308) {\n"
"        y = x - (tc - 1);\n"
"        i = 1;\n"
"      } else {\n"
"        y = x;\n"
"        i = 2;\n"
"      }\n"
"    } else {\n"
"      r = 0;\n"
"      if (ix >= 0x3fdda618) {\n"
"        y = 2 - x;\n"
"        i = 0;\n"
"      } else if (ix >= 0x3F9da620) {\n"
"        y = x - tc;\n"
"        i = 1;\n"
"      } else {\n"
"        y = x - 1;\n"
"        i = 2;\n"
"      }\n"
"    }\n"
"    switch (i) {\n"
"    case 0:\n"
"      z = y * y;\n"
"      p1 = a0 + z * (a2 + z * (a4 + z * (a6 + z * (a8 + z * a10))));\n"
"      p2 = z * (a1 + z * (a3 + z * (a5 + z * (a7 + z * (a9 + z * a11)))));\n"
"      p = y * p1 + p2;\n"
"      r += (p - .5f * y);\n"
"      break;\n"
"    case 1:\n"
"      z = y * y;\n"
"      w = z * y;\n"
"      p1 = t0 + w * (t3 + w * (t6 + w * (t9 + w * t12)));\n"
"      p2 = t1 + w * (t4 + w * (t7 + w * (t10 + w * t13)));\n"
"      p3 = t2 + w * (t5 + w * (t8 + w * (t11 + w * t14)));\n"
"      p = z * p1 - (tt - w * (p2 + y * p3));\n"
"      r += (tf + p);\n"
"      break;\n"
"    case 2:\n"
"      p1 = y * (u0 + y * (u1 + y * (u2 + y * (u3 + y * (u4 + y * u5)))));\n"
"      p2 = 1 + y * (v1 + y * (v2 + y * (v3 + y * (v4 + y * v5))));\n"
"      r += (-.5f * y + p1 / p2);\n"
"    }\n"
"  } else if (ix < 0x41000000) {\n"
"    i = x;\n"
"    t = 0;\n"
"    y = x - i;\n"
"    p = y*(s0+y*(s1+y*(s2+y*(s3+y*(s4+y*(s5+y*s6))))));\n"
"    q = 1 + y * (r1 + y * (r2 + y * (r3 + y * (r4 + y * (r5 + y * r6)))));\n"
"    r = .5f * y + p / q;\n"
"    z = 1;\n"
"    switch (i) {\n"
"    case 7:\n"
"      z *= (y + 6.f);\n"
"    case 6:\n"
"      z *= (y + 5.f);\n"
"    case 5:\n"
"      z *= (y + 4.f);\n"
"    case 4:\n"
"      z *= (y + 3.f);\n"
"    case 3:\n"
"      z *= (y + 2.f);\n"
"      r += native_log(z);\n"
"      break;\n"
"    }\n"
"  } else if (ix < 0x5c800000) {\n"
"    t = native_log(x);\n"
"    z = 1 / x;\n"
"    y = z * z;\n"
"    w = w0 + z * (w1 + y * (w2 + y * (w3 + y * (w4 + y * (w5 + y * w6)))));\n"
"    r = (x - .5f) * (t - 1) + w;\n"
"  } else\n"
"    r = x * (native_log(x) - 1);\n"
"  if (hx < 0)\n"
"    r = nadj - r;\n"
"  return r;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float lgamma(float x) {\n"
"/*\n"
" * ====================================================\n"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\n"
" *\n"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\n"
" * Permission to use, copy, modify, and distribute this\n"
" * software is freely granted, provided that this notice\n"
" * is preserved.\n"
" * ====================================================\n"
" */\n"
"    const float\n"
"        zero=  0.,\n"
"        one =  1.0000000000e+00,\n"
"        pi  =  3.1415927410e+00,\n"
"        a0  =  7.7215664089e-02,\n"
"        a1  =  3.2246702909e-01,\n"
"        a2  =  6.7352302372e-02,\n"
"        a3  =  2.0580807701e-02,\n"
"        a4  =  7.3855509982e-03,\n"
"        a5  =  2.8905137442e-03,\n"
"        a6  =  1.1927076848e-03,\n"
"        a7  =  5.1006977446e-04,\n"
"        a8  =  2.2086278477e-04,\n"
"        a9  =  1.0801156895e-04,\n"
"        a10 =  2.5214456400e-05,\n"
"        a11 =  4.4864096708e-05,\n"
"        tc  =  1.4616321325e+00,\n"
"        tf  = -1.2148628384e-01,\n"
"        tt  =  6.6971006518e-09,\n"
"        t0  =  4.8383611441e-01,\n"
"        t1  = -1.4758771658e-01,\n"
"        t2  =  6.4624942839e-02,\n"
"        t3  = -3.2788541168e-02,\n"
"        t4  =  1.7970675603e-02,\n"
"        t5  = -1.0314224288e-02,\n"
"        t6  =  6.1005386524e-03,\n"
"        t7  = -3.6845202558e-03,\n"
"        t8  =  2.2596477065e-03,\n"
"        t9  = -1.4034647029e-03,\n"
"        t10 =  8.8108185446e-04,\n"
"        t11 = -5.3859531181e-04,\n"
"        t12 =  3.1563205994e-04,\n"
"        t13 = -3.1275415677e-04,\n"
"        t14 =  3.3552918467e-04,\n"
"        u0  = -7.7215664089e-02,\n"
"        u1  =  6.3282704353e-01,\n"
"        u2  =  1.4549225569e+00,\n"
"        u3  =  9.7771751881e-01,\n"
"        u4  =  2.2896373272e-01,\n"
"        u5  =  1.3381091878e-02,\n"
"        v1  =  2.4559779167e+00,\n"
"        v2  =  2.1284897327e+00,\n"
"        v3  =  7.6928514242e-01,\n"
"        v4  =  1.0422264785e-01,\n"
"        v5  =  3.2170924824e-03,\n"
"        s0  = -7.7215664089e-02,\n"
"        s1  =  2.1498242021e-01,\n"
"        s2  =  3.2577878237e-01,\n"
"        s3  =  1.4635047317e-01,\n"
"        s4  =  2.6642270386e-02,\n"
"        s5  =  1.8402845599e-03,\n"
"        s6  =  3.1947532989e-05,\n"
"        r1  =  1.3920053244e+00,\n"
"        r2  =  7.2193557024e-01,\n"
"        r3  =  1.7193385959e-01,\n"
"        r4  =  1.8645919859e-02,\n"
"        r5  =  7.7794247773e-04,\n"
"        r6  =  7.3266842264e-06,\n"
"        w0  =  4.1893854737e-01,\n"
"        w1  =  8.3333335817e-02,\n"
"        w2  = -2.7777778450e-03,\n"
"        w3  =  7.9365057172e-04,\n"
"        w4  = -5.9518753551e-04,\n"
"        w5  =  8.3633989561e-04,\n"
"        w6  = -1.6309292987e-03;\n"
"	float t, y, z, nadj, p, p1, p2, p3, q, r, w;\n"
"	int i, hx, ix;\n"
"	nadj = 0;\n"
"	hx = *(int *)&x;\n"
"	ix = hx & 0x7fffffff;\n"
"	if (ix >= 0x7f800000)\n"
"		return x * x;\n"
"	if (ix == 0)\n"
"		return ((x + one) / zero);\n"
"	if (ix < 0x1c800000) {\n"
"		if (hx < 0) {\n"
"			return -native_log(-x);\n"
"		} else\n"
"			return -native_log(x);\n"
"	}\n"
"	if (hx < 0) {\n"
"		if (ix >= 0x4b000000)\n"
"			return ((-x) / zero);\n"
"		t = __gen_ocl_internal_sinpi(x);\n"
"		if (t == zero)\n"
"			return ((-x) / zero);\n"
"		nadj = native_log(pi / __gen_ocl_fabs(t * x));\n"
"		x = -x;\n"
"	}\n"
"	if (ix == 0x3f800000 || ix == 0x40000000)\n"
"		r = 0;\n"
"	else if (ix < 0x40000000) {\n"
"		if (ix <= 0x3f666666) {\n"
"			r = -native_log(x);\n"
"			if (ix >= 0x3f3b4a20) {\n"
"				y = one - x;\n"
"				i = 0;\n"
"			} else if (ix >= 0x3e6d3308) {\n"
"				y = x - (tc - one);\n"
"				i = 1;\n"
"			} else {\n"
"				y = x;\n"
"				i = 2;\n"
"			}\n"
"		} else {\n"
"			r = zero;\n"
"			if (ix >= 0x3fdda618) {\n"
"				y = (float) 2.0 - x;\n"
"				i = 0;\n"
"			}\n"
"			else if (ix >= 0x3F9da620) {\n"
"				y = x - tc;\n"
"				i = 1;\n"
"			}\n"
"			else {\n"
"				y = x - one;\n"
"				i = 2;\n"
"			}\n"
"		}\n"
"		switch (i) {\n"
"		case 0:\n"
"			z = y * y;\n"
"			p1 = a0 + z * (a2 + z * (a4 + z * (a6 + z * (a8 + z * a10))));\n"
"			p2 = z * (a1 + z * (a3 + z * (a5 + z * (a7 + z * (a9 + z * a11)))));\n"
"			p = y * p1 + p2;\n"
"			r += (p - (float) 0.5 * y);\n"
"			break;\n"
"		case 1:\n"
"			z = y * y;\n"
"			w = z * y;\n"
"			p1 = t0 + w * (t3 + w * (t6 + w * (t9 + w * t12)));\n"
"			p2 = t1 + w * (t4 + w * (t7 + w * (t10 + w * t13)));\n"
"			p3 = t2 + w * (t5 + w * (t8 + w * (t11 + w * t14)));\n"
"			p = z * p1 - (tt - w * (p2 + y * p3));\n"
"			r += (tf + p);\n"
"			break;\n"
"		case 2:\n"
"			p1 = y * (u0 + y * (u1 + y * (u2 + y * (u3 + y * (u4 + y * u5)))));\n"
"			p2 = one + y * (v1 + y * (v2 + y * (v3 + y * (v4 + y * v5))));\n"
"			r += (-(float) 0.5 * y + p1 / p2);\n"
"		}\n"
"	} else if (ix < 0x41000000) {\n"
"		i = (int) x;\n"
"		t = zero;\n"
"		y = x - (float) i;\n"
"		p = y * (s0 + y * (s1 + y * (s2 + y * (s3 + y * (s4 + y * (s5 + y * s6))))));\n"
"		q = one + y * (r1 + y * (r2 + y * (r3 + y * (r4 + y * (r5 + y * r6)))));\n"
"		r = .5f * y + p / q;\n"
"		z = one;\n"
"		switch (i) {\n"
"		case 7:\n"
"			z *= (y + (float) 6.0);\n"
"		case 6:\n"
"			z *= (y + (float) 5.0);\n"
"		case 5:\n"
"			z *= (y + (float) 4.0);\n"
"		case 4:\n"
"			z *= (y + (float) 3.0);\n"
"		case 3:\n"
"			z *= (y + (float) 2.0);\n"
"			r += native_log(z);\n"
"			break;\n"
"		}\n"
"\n"
"	} else if (ix < 0x5c800000) {\n"
"		t = native_log(x);\n"
"		z = one / x;\n"
"		y = z * z;\n"
"		w = w0 + z * (w1 + y * (w2 + y * (w3 + y * (w4 + y * (w5 + y * w6)))));\n"
"		r = (x - .5f) * (t - one) + w;\n"
"	} else\n"
"		r = x * (native_log(x) - one);\n"
"	if (hx < 0)\n"
"		r = nadj - r;\n"
"	return r;\n"
"}\n"
"\n"
"/*\n"
" * ====================================================\n"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\n"
" *\n"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\n"
" * Permission to use, copy, modify, and distribute this\n"
" * software is freely granted, provided that this notice\n"
" * is preserved.\n"
" * ====================================================\n"
" */\n"
"#define BODY \\\n"
"    const float  \\\n"
"        zero=  0.,  \\\n"
"        one =  1.0000000000e+00,  \\\n"
"        pi  =  3.1415927410e+00,  \\\n"
"        a0  =  7.7215664089e-02,  \\\n"
"        a1  =  3.2246702909e-01,  \\\n"
"        a2  =  6.7352302372e-02,  \\\n"
"        a3  =  2.0580807701e-02,  \\\n"
"        a4  =  7.3855509982e-03,  \\\n"
"        a5  =  2.8905137442e-03,  \\\n"
"        a6  =  1.1927076848e-03,  \\\n"
"        a7  =  5.1006977446e-04,  \\\n"
"        a8  =  2.2086278477e-04,  \\\n"
"        a9  =  1.0801156895e-04,  \\\n"
"        a10 =  2.5214456400e-05,  \\\n"
"        a11 =  4.4864096708e-05,  \\\n"
"        tc  =  1.4616321325e+00,  \\\n"
"        tf  = -1.2148628384e-01,  \\\n"
"        tt  =  6.6971006518e-09,  \\\n"
"        t0  =  4.8383611441e-01,  \\\n"
"        t1  = -1.4758771658e-01,  \\\n"
"        t2  =  6.4624942839e-02,  \\\n"
"        t3  = -3.2788541168e-02,  \\\n"
"        t4  =  1.7970675603e-02,  \\\n"
"        t5  = -1.0314224288e-02,  \\\n"
"        t6  =  6.1005386524e-03,  \\\n"
"        t7  = -3.6845202558e-03,  \\\n"
"        t8  =  2.2596477065e-03,  \\\n"
"        t9  = -1.4034647029e-03,  \\\n"
"        t10 =  8.8108185446e-04,  \\\n"
"        t11 = -5.3859531181e-04,  \\\n"
"        t12 =  3.1563205994e-04,  \\\n"
"        t13 = -3.1275415677e-04,  \\\n"
"        t14 =  3.3552918467e-04,  \\\n"
"        u0  = -7.7215664089e-02,  \\\n"
"        u1  =  6.3282704353e-01,  \\\n"
"        u2  =  1.4549225569e+00,  \\\n"
"        u3  =  9.7771751881e-01,  \\\n"
"        u4  =  2.2896373272e-01,  \\\n"
"        u5  =  1.3381091878e-02,  \\\n"
"        v1  =  2.4559779167e+00,  \\\n"
"        v2  =  2.1284897327e+00,  \\\n"
"        v3  =  7.6928514242e-01,  \\\n"
"        v4  =  1.0422264785e-01,  \\\n"
"        v5  =  3.2170924824e-03,  \\\n"
"        s0  = -7.7215664089e-02,  \\\n"
"        s1  =  2.1498242021e-01,  \\\n"
"        s2  =  3.2577878237e-01,  \\\n"
"        s3  =  1.4635047317e-01,  \\\n"
"        s4  =  2.6642270386e-02,  \\\n"
"        s5  =  1.8402845599e-03,  \\\n"
"        s6  =  3.1947532989e-05,  \\\n"
"        r1  =  1.3920053244e+00,  \\\n"
"        r2  =  7.2193557024e-01,  \\\n"
"        r3  =  1.7193385959e-01,  \\\n"
"        r4  =  1.8645919859e-02,  \\\n"
"        r5  =  7.7794247773e-04,  \\\n"
"        r6  =  7.3266842264e-06,  \\\n"
"        w0  =  4.1893854737e-01,  \\\n"
"        w1  =  8.3333335817e-02,  \\\n"
"        w2  = -2.7777778450e-03,  \\\n"
"        w3  =  7.9365057172e-04,  \\\n"
"        w4  = -5.9518753551e-04,  \\\n"
"        w5  =  8.3633989561e-04,  \\\n"
"        w6  = -1.6309292987e-03;  \\\n"
"	float t, y, z, nadj, p, p1, p2, p3, q, r, w;  \\\n"
"	int i, hx, ix;  \\\n"
"	nadj = 0;  \\\n"
"	hx = *(int *)&x;  \\\n"
"	*signgamp = 1;  \\\n"
"	ix = hx & 0x7fffffff;  \\\n"
"	if (ix >= 0x7f800000)  \\\n"
"		return x * x;  \\\n"
"	if (ix == 0)  \\\n"
"		return ((x + one) / zero);  \\\n"
"	if (ix < 0x1c800000) {  \\\n"
"		if (hx < 0) {  \\\n"
"			*signgamp = -1;  \\\n"
"			return -native_log(-x);  \\\n"
"		} else  \\\n"
"			return -native_log(x);  \\\n"
"	}  \\\n"
"	if (hx < 0) {  \\\n"
"		if (ix >= 0x4b000000)  \\\n"
"			return ((-x) / zero);  \\\n"
"		t = __gen_ocl_internal_sinpi(x);  \\\n"
"		if (t == zero)  \\\n"
"			return ((-x) / zero);  \\\n"
"		nadj = native_log(pi / __gen_ocl_fabs(t * x));  \\\n"
"		if (t < zero)  \\\n"
"			*signgamp = -1;  \\\n"
"		x = -x;  \\\n"
"	}  \\\n"
"	if (ix == 0x3f800000 || ix == 0x40000000)  \\\n"
"		r = 0;  \\\n"
"	else if (ix < 0x40000000) {  \\\n"
"		if (ix <= 0x3f666666) {  \\\n"
"			r = -native_log(x);  \\\n"
"			if (ix >= 0x3f3b4a20) {  \\\n"
"				y = one - x;  \\\n"
"				i = 0;  \\\n"
"			} else if (ix >= 0x3e6d3308) {  \\\n"
"				y = x - (tc - one);  \\\n"
"				i = 1;  \\\n"
"			} else {  \\\n"
"				y = x;  \\\n"
"				i = 2;  \\\n"
"			}  \\\n"
"		} else {  \\\n"
"			r = zero;  \\\n"
"			if (ix >= 0x3fdda618) {  \\\n"
"				y = (float) 2.0 - x;  \\\n"
"				i = 0;  \\\n"
"			}  \\\n"
"			else if (ix >= 0x3F9da620) {  \\\n"
"				y = x - tc;  \\\n"
"				i = 1;  \\\n"
"			}  \\\n"
"			else {  \\\n"
"				y = x - one;  \\\n"
"				i = 2;  \\\n"
"			}  \\\n"
"		}  \\\n"
"		switch (i) {  \\\n"
"		case 0:  \\\n"
"			z = y * y;  \\\n"
"			p1 = a0 + z * (a2 + z * (a4 + z * (a6 + z * (a8 + z * a10))));  \\\n"
"			p2 = z * (a1 + z * (a3 + z * (a5 + z * (a7 + z * (a9 + z * a11)))));  \\\n"
"			p = y * p1 + p2;  \\\n"
"			r += (p - (float) 0.5 * y);  \\\n"
"			break;  \\\n"
"		case 1:  \\\n"
"			z = y * y;  \\\n"
"			w = z * y;  \\\n"
"			p1 = t0 + w * (t3 + w * (t6 + w * (t9 + w * t12)));  \\\n"
"			p2 = t1 + w * (t4 + w * (t7 + w * (t10 + w * t13)));  \\\n"
"			p3 = t2 + w * (t5 + w * (t8 + w * (t11 + w * t14)));  \\\n"
"			p = z * p1 - (tt - w * (p2 + y * p3));  \\\n"
"			r += (tf + p);  \\\n"
"			break;  \\\n"
"		case 2:  \\\n"
"			p1 = y * (u0 + y * (u1 + y * (u2 + y * (u3 + y * (u4 + y * u5)))));  \\\n"
"			p2 = one + y * (v1 + y * (v2 + y * (v3 + y * (v4 + y * v5))));  \\\n"
"			r += (-(float) 0.5 * y + p1 / p2);  \\\n"
"		}  \\\n"
"	} else if (ix < 0x41000000) {  \\\n"
"		i = (int) x;  \\\n"
"		t = zero;  \\\n"
"		y = x - (float) i;  \\\n"
"		p = y * (s0 + y * (s1 + y * (s2 + y * (s3 + y * (s4 + y * (s5 + y * s6))))));  \\\n"
"		q = one + y * (r1 + y * (r2 + y * (r3 + y * (r4 + y * (r5 + y * r6)))));  \\\n"
"		r = .5f * y + p / q;  \\\n"
"		z = one;  \\\n"
"		switch (i) {  \\\n"
"		case 7:  \\\n"
"			z *= (y + (float) 6.0);  \\\n"
"		case 6:  \\\n"
"			z *= (y + (float) 5.0);  \\\n"
"		case 5:  \\\n"
"			z *= (y + (float) 4.0);  \\\n"
"		case 4:  \\\n"
"			z *= (y + (float) 3.0);  \\\n"
"		case 3:  \\\n"
"			z *= (y + (float) 2.0);  \\\n"
"			r += native_log(z);  \\\n"
"			break;  \\\n"
"		}  \\\n"
"		  \\\n"
"	} else if (ix < 0x5c800000) {  \\\n"
"		t = native_log(x);  \\\n"
"		z = one / x;  \\\n"
"		y = z * z;  \\\n"
"		w = w0 + z * (w1 + y * (w2 + y * (w3 + y * (w4 + y * (w5 + y * w6)))));  \\\n"
"		r = (x - .5f) * (t - one) + w;  \\\n"
"	} else  \\\n"
"		r = x * (native_log(x) - one);  \\\n"
"	if (hx < 0)  \\\n"
"		r = nadj - r;  \\\n"
"	return r;\n"
"INLINE_OVERLOADABLE float lgamma_r(float x, global int *signgamp) { BODY; }\n"
"INLINE_OVERLOADABLE float lgamma_r(float x, local int *signgamp) { BODY; }\n"
"INLINE_OVERLOADABLE float lgamma_r(float x, private int *signgamp) { BODY; }\n"
"#undef BODY\n"
"\n"
"INLINE_OVERLOADABLE float native_log10(float x) {\n"
"  return native_log2(x) * 0.3010299956f;\n"
"}\n"
"INLINE_OVERLOADABLE float log1p(float x) {\n"
"/*\n"
" *  Conversion to float by Ian Lance Taylor, Cygnus Support, ian@cygnus.com\n"
" * ====================================================\n"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\n"
" *\n"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\n"
" * Permission to use, copy, modify, and distribute this\n"
" * software is freely granted, provided that this notice\n"
" * is preserved.\n"
" * ====================================================\n"
" */\n"
"  const float\n"
"  ln2_hi =   6.9313812256e-01,  /* 0x3f317180 */\n"
"  ln2_lo =   9.0580006145e-06,  /* 0x3717f7d1 */\n"
"  two25 =    3.355443200e+07, /* 0x4c000000 */\n"
"  Lp1 = 6.6666668653e-01, /* 3F2AAAAB */\n"
"  Lp2 = 4.0000000596e-01, /* 3ECCCCCD */\n"
"  Lp3 = 2.8571429849e-01, /* 3E924925 */\n"
"  Lp4 = 2.2222198546e-01, /* 3E638E29 */\n"
"  Lp5 = 1.8183572590e-01, /* 3E3A3325 */\n"
"  Lp6 = 1.5313838422e-01, /* 3E1CD04F */\n"
"  Lp7 = 1.4798198640e-01; /* 3E178897 */\n"
"  const float zero = 0.0;\n"
"  float hfsq,f,c,s,z,R,u;\n"
"  int k,hx,hu,ax;\n"
"  union {float f; unsigned i;} un;\n"
"  un.f = x;  hx = un.i;\n"
"  ax = hx&0x7fffffff;\n"
"\n"
"  k = 1;\n"
"  if (hx < 0x3ed413d7) {      /* x < 0.41422  */\n"
"      if(ax>=0x3f800000) {    /* x <= -1.0 */\n"
"    if(x==(float)-1.0) return -two25/zero; /* log1p(-1)=+inf */\n"
"    else return (x-x)/(x-x);  /* log1p(x<-1)=NaN */\n"
"      }\n"
"      if(ax<0x31000000) {     /* |x| < 2**-29 */\n"
"    if(two25+x>zero     /* raise inexact */\n"
"              &&ax<0x24800000)    /* |x| < 2**-54 */\n"
"        return x;\n"
"    else\n"
"        return x - x*x*(float)0.5;\n"
"      }\n"
"      if(hx>0||hx<=((int)0xbe95f61f)) {\n"
"    k=0;f=x;hu=1;}  /* -0.2929<x<0.41422 */\n"
"  }\n"
"  if (hx >= 0x7f800000) return x+x;\n"
"  if(k!=0) {\n"
"      if(hx<0x5a000000) {\n"
"    u  = (float)1.0+x;\n"
"\n"
"    un.f = u; hu = un.i;\n"
"          k  = (hu>>23)-127;\n"
"    /* correction term */\n"
"          c  = (k>0)? (float)1.0-(u-x):x-(u-(float)1.0);\n"
"    c /= u;\n"
"      } else {\n"
"    u  = x;\n"
"    un.f = u; hu = un.i;\n"
"          k  = (hu>>23)-127;\n"
"    c  = 0;\n"
"      }\n"
"      hu &= 0x007fffff;\n"
"      if(hu<0x3504f7) {\n"
"          un.i = hu|0x3f800000; u = un.f;/* normalize u */\n"
"      } else {\n"
"          k += 1;\n"
"          un.i = hu|0x3f000000; u = un.f;  /* normalize u/2 */\n"
"          hu = (0x00800000-hu)>>2;\n"
"      }\n"
"      f = u-(float)1.0;\n"
"  }\n"
"  hfsq=(float)0.5*f*f;\n"
"  if(hu==0) { /* |f| < 2**-20 */\n"
"      if(f==zero) { if(k==0) return zero;\n"
"      else {c += k*ln2_lo; return k*ln2_hi+c;} }\n"
"      R = hfsq*((float)1.0-(float)0.66666666666666666*f);\n"
"      if(k==0) return f-R; else\n"
"             return k*ln2_hi-((R-(k*ln2_lo+c))-f);\n"
"  }\n"
"  s = f/((float)2.0+f);\n"
"  z = s*s;\n"
"  R = z*(Lp1+z*(Lp2+z*(Lp3+z*(Lp4+z*(Lp5+z*(Lp6+z*Lp7))))));\n"
"  if(k==0) return f-(hfsq-s*(hfsq+R)); else\n"
"     return k*ln2_hi-((hfsq-(s*(hfsq+R)+(k*ln2_lo+c)))-f);\n"
"\n"
"}\n"
"INLINE_OVERLOADABLE float logb(float x) {\n"
"union {float f; unsigned i;} u;\n"
"  u.f = x;\n"
"  int e =  ((u.i & 0x7f800000) >> 23);\n"
"  if(e == 0) {\n"
"    /* sub normal or +/-0 */\n"
"    return -INFINITY;\n"
"  } else if(e == 0xff) {\n"
"    /* inf & nan */\n"
"    return x*x;\n"
"  } else {\n"
"    return (float)(e-127);\n"
"  }\n"
"}\n"
"#define FP_ILOGB0 (-0x7FFFFFFF-1)\n"
"#define FP_ILOGBNAN FP_ILOGB0\n"
"INLINE_OVERLOADABLE int ilogb(float x) {\n"
"  union { int i; float f; } u;\n"
"  if (isnan(x))\n"
"    return FP_ILOGBNAN;\n"
"  if (isinf(x))\n"
"    return 0x7FFFFFFF;\n"
"  u.f = x;\n"
"  u.i &= 0x7fffffff;\n"
"  if (u.i == 0)\n"
"    return FP_ILOGB0;\n"
"  if (u.i >= 0x800000)\n"
"    return (u.i >> 23) - 127;\n"
"  int r = -126;\n"
"  int a = u.i & 0x7FFFFF;\n"
"  while(a < 0x800000) {\n"
"    a <<= 1;\n"
"    r --;\n"
"  }\n"
"  return r;\n"
"}\n"
"INLINE_OVERLOADABLE float nan(uint code) {\n"
"  return NAN;\n"
"}\n"
"INLINE_OVERLOADABLE float native_powr(float x, float y) { return __gen_ocl_pow(x,y); }\n"
"INLINE_OVERLOADABLE float native_recip(float x) { return __gen_ocl_rcp(x); }\n"
"INLINE_OVERLOADABLE float native_tan(float x) {\n"
"  return native_sin(x) / native_cos(x);\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_tanpi(float x) {\n"
"  float sign = 1.0f;\n"
"  int ix;\n"
"  if(isinf(x)) return NAN;\n"
"  if(x < 0.0f) { x = -x; sign = -1.0f; }\n"
"  GEN_OCL_GET_FLOAT_WORD(ix, x);\n"
"  if(x> 0x1.0p24) return 0.0f;\n"
"  float m = __gen_ocl_internal_floor(x);\n"
"  ix = (int)m;\n"
"  m = x-m;\n"
"  int n = __gen_ocl_internal_floor(m*4.0f);\n"
"  if(m == 0.5f) {\n"
"    return (ix&0x1) == 0 ? sign*INFINITY : sign*-INFINITY;\n"
"  }\n"
"  if(m == 0.0f) {\n"
"    return (ix&0x1) == 0 ? 0.0f : -0.0f;\n"
"  }\n"
"\n"
"  switch(n) {\n"
"    case 0:\n"
"      return sign * __kernel_tanf(m*M_PI_F, 0.0f, 1);\n"
"    case 1:\n"
"      return sign * 1.0f/__kernel_tanf((0.5f-m)*M_PI_F, 0.0f, 1);\n"
"    case 2:\n"
"      return sign * 1.0f/__kernel_tanf((0.5f-m)*M_PI_F, 0.0f, 1);\n"
"    default:\n"
"      return sign * -1.0f*__kernel_tanf((1.0f-m)*M_PI_F, 0.0f, 1);\n"
"  }\n"
"}\n"
"INLINE_OVERLOADABLE float native_exp2(float x) { return __gen_ocl_exp(x); }\n"
"INLINE_OVERLOADABLE float native_exp(float x) { return __gen_ocl_exp(M_LOG2E_F*x); }\n"
"INLINE_OVERLOADABLE float native_exp10(float x) { return __gen_ocl_pow(10, x); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_cbrt(float x) {\n"
"  /* copied from fdlibm */\n"
"  const unsigned\n"
"  B1 = 709958130, /* B1 = (84+2/3-0.03306235651)*2**23 */\n"
"  B2 = 642849266; /* B2 = (76+2/3-0.03306235651)*2**23 */\n"
"\n"
"  const float\n"
"  C =  5.4285717010e-01, /* 19/35     = 0x3f0af8b0 */\n"
"  D = -7.0530611277e-01, /* -864/1225 = 0xbf348ef1 */\n"
"  E =  1.4142856598e+00, /* 99/70     = 0x3fb50750 */\n"
"  F =  1.6071428061e+00, /* 45/28     = 0x3fcdb6db */\n"
"  G =  3.5714286566e-01; /* 5/14      = 0x3eb6db6e */\n"
"\n"
"  float r,s,t, w;\n"
"  int hx;\n"
"  uint sign;\n"
"  uint high;\n"
"\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  sign=hx&0x80000000;     /* sign= sign(x) */\n"
"  hx  ^=sign;\n"
"  if(hx>=0x7f800000) return(x+x); /* cbrt(NaN,INF) is itself */\n"
"  if(hx==0)\n"
"      return(x);    /* cbrt(0) is itself */\n"
"\n"
"  GEN_OCL_SET_FLOAT_WORD(x,hx); /* x <- |x| */\n"
"    /* rough cbrt to 5 bits */\n"
"  if(hx<0x00800000)     /* subnormal number */\n"
"    {\n"
"    //SET_FLOAT_WORD(t,0x4b800000); /* set t= 2**24 */\n"
"     //t*=x; GET_FLOAT_WORD(high,t); SET_FLOAT_WORD(t,high/3+B2);\n"
"      t = (sign = 0) ? 0.0f : -0.0f;\n"
"      return t;\n"
"    }\n"
"  else\n"
"    GEN_OCL_SET_FLOAT_WORD(t,hx/3+B1);\n"
"\n"
"\n"
"    /* new cbrt to 23 bits */\n"
"  r=t*t/x;\n"
"  s=C+r*t;\n"
"  t*=G+F/(s+E+D/s);\n"
"    /* one step newton iteration to 53 bits with error less than 0.667 ulps */\n"
"  s=t*t;    /* t*t is exact */\n"
"  r=x/s;\n"
"  w=t+t;\n"
"  r=(r-t)/(w+r);  /* r-s is exact */\n"
"  t=t+t*r;\n"
"\n"
"    /* retore the sign bit */\n"
"  GEN_OCL_GET_FLOAT_WORD(high,t);\n"
"  GEN_OCL_SET_FLOAT_WORD(t,high|sign);\n"
"  return(t);\n"
"}\n"
"\n"
"#define BODY \\\n"
"  *cosval = cos(x); \\\n"
"  return sin(x);\n"
"INLINE_OVERLOADABLE float sincos(float x, global float *cosval) { BODY; }\n"
"INLINE_OVERLOADABLE float sincos(float x, local float *cosval) { BODY; }\n"
"INLINE_OVERLOADABLE float sincos(float x, private float *cosval) { BODY; }\n"
"#undef BODY\n"
"\n"
"INLINE float __gen_ocl_asin_util(float x) {\n"
"/*\n"
" * ====================================================\n"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\n"
" *\n"
" * Developed at SunSoft, a Sun Microsystems, Inc. business.\n"
" * Permission to use, copy, modify, and distribute this\n"
" * software is freely granted, provided that this notice\n"
" * is preserved.\n"
" * ====================================================\n"
" */\n"
"  float\n"
"  pS0 =  1.66666666666666657415e-01,\n"
"  pS1 = -3.25565818622400915405e-01,\n"
"  pS2 =  2.01212532134862925881e-01,\n"
"  pS3 = -4.00555345006794114027e-02,\n"
"  pS4 =  7.91534994289814532176e-04,\n"
"  pS5 =  3.47933107596021167570e-05,\n"
"  qS1 = -2.40339491173441421878e+00,\n"
"  qS2 =  2.02094576023350569471e+00,\n"
"  qS3 = -6.88283971605453293030e-01,\n"
"  qS4 =  7.70381505559019352791e-02;\n"
"\n"
"  float t = x*x;\n"
"  float p = t*(pS0+t*(pS1+t*(pS2+t*(pS3+t*(pS4+t*pS5)))));\n"
"  float q = 1.0+t*(qS1+t*(qS2+t*(qS3+t*qS4)));\n"
"  float w = p / q;\n"
"  return x + x*w;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_asin(float x) {\n"
"  uint ix;\n"
"  union { uint i; float f; } u;\n"
"  u.f = x;\n"
"  ix = u.i & 0x7fffffff;\n"
"  if(ix == 0x3f800000) {\n"
"    return x * M_PI_2_F;  /* asin(|1|)=+-pi/2 with inexact */\n"
"  }\n"
"  if(ix > 0x3f800000) {            /* |x|>= 1 */\n"
"    return  NAN;          /* asin(|x|>1) is NaN */\n"
"  }\n"
"\n"
"  if(ix < 0x32000000) {            /* if |x| < 2**-27 */\n"
"    if(HUGE_VALF + x > FLT_ONE) return x;   /* return x with inexact if x!=0*/\n"
"  }\n"
"\n"
"  if(x < -0.5) {\n"
"    return 2 * __gen_ocl_asin_util(native_sqrt((1+x) / 2)) - M_PI_2_F;\n"
"  } else if(x > 0.5) {\n"
"    return M_PI_2_F - 2 * __gen_ocl_asin_util(native_sqrt((1-x) / 2));\n"
"  } else {\n"
"    return __gen_ocl_asin_util(x);\n"
"  }\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_asinpi(float x) {\n"
"  return __gen_ocl_internal_asin(x) / M_PI_F;\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_acos(float x) {\n"
"  if(x > 0.5)\n"
"    return 2 * __gen_ocl_asin_util(native_sqrt((1-x)/2));\n"
"  else\n"
"    return M_PI_2_F - __gen_ocl_internal_asin(x);\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_acospi(float x) {\n"
"  return __gen_ocl_internal_acos(x) / M_PI_F;\n"
"}\n"
"__constant float atanhi[4] = {\n"
"  4.6364760399e-01, /* atan(0.5)hi 0x3eed6338 */\n"
"  7.8539812565e-01, /* atan(1.0)hi 0x3f490fda */\n"
"  9.8279368877e-01, /* atan(1.5)hi 0x3f7b985e */\n"
"  1.5707962513e+00, /* atan(inf)hi 0x3fc90fda */\n"
"};\n"
"__constant float atanlo[4] = {\n"
"  5.0121582440e-09, /* atan(0.5)lo 0x31ac3769 */\n"
"  3.7748947079e-08, /* atan(1.0)lo 0x33222168 */\n"
"  3.4473217170e-08, /* atan(1.5)lo 0x33140fb4 */\n"
"  7.5497894159e-08, /* atan(inf)lo 0x33a22168 */\n"
"};\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_atan(float x) {\n"
"  /* copied from fdlibm */\n"
"  float aT[11];\n"
"  aT[0] = 3.3333334327e-01; /* 0x3eaaaaaa */\n"
"  aT[1] =  -2.0000000298e-01; /* 0xbe4ccccd */\n"
"  aT[2] =   1.4285714924e-01; /* 0x3e124925 */\n"
"  aT[3] =  -1.1111110449e-01; /* 0xbde38e38 */\n"
"  aT[4] =   9.0908870101e-02; /* 0x3dba2e6e */\n"
"  aT[5] =  -7.6918758452e-02; /* 0xbd9d8795 */\n"
"  aT[6] =   6.6610731184e-02; /* 0x3d886b35 */\n"
"  aT[7] =  -5.8335702866e-02; /* 0xbd6ef16b */\n"
"  aT[8] =   4.9768779427e-02; /* 0x3d4bda59 */\n"
"  aT[9] =  -3.6531571299e-02; /* 0xbd15a221 */\n"
"  aT[10] =   1.6285819933e-02; /* 0x3c8569d7 */\n"
"  const float one = 1.0, huge = 1.0e30;\n"
"\n"
"  float w,s1,s2,z;\n"
"  int ix,hx,id;\n"
"\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  ix = hx&0x7fffffff;\n"
"  if(ix>=0x50800000) {  /* if |x| >= 2^34 */\n"
"      if(ix>0x7f800000)\n"
"    return x+x;   /* NaN */\n"
"      if(hx>0) return  atanhi[3]+atanlo[3];\n"
"      else     return -atanhi[3]-atanlo[3];\n"
"  } if (ix < 0x3ee00000) {  /* |x| < 0.4375 */\n"
"      if (ix < 0x31000000) {  /* |x| < 2^-29 */\n"
"    if(huge+x>one) return x;  /* raise inexact */\n"
"      }\n"
"      id = -1;\n"
"  } else {\n"
"  x = __gen_ocl_fabs(x);\n"
"  if (ix < 0x3f980000) {    /* |x| < 1.1875 */\n"
"      if (ix < 0x3f300000) {  /* 7/16 <=|x|<11/16 */\n"
"    id = 0; x = ((float)2.0*x-one)/((float)2.0+x);\n"
"      } else {      /* 11/16<=|x|< 19/16 */\n"
"    id = 1; x  = (x-one)/(x+one);\n"
"      }\n"
"  } else {\n"
"      if (ix < 0x401c0000) {  /* |x| < 2.4375 */\n"
"    id = 2; x  = (x-(float)1.5)/(one+(float)1.5*x);\n"
"      } else {      /* 2.4375 <= |x| < 2^66 */\n"
"    id = 3; x  = -(float)1.0/x;\n"
"      }\n"
"  }}\n"
"    /* end of argument reduction */\n"
"  z = x*x;\n"
"  w = z*z;\n"
"    /* break sum from i=0 to 10 aT[i]z**(i+1) into odd and even poly */\n"
"  s1 = z*(aT[0]+w*(aT[2]+w*(aT[4]+w*(aT[6]+w*(aT[8]+w*aT[10])))));\n"
"  s2 = w*(aT[1]+w*(aT[3]+w*(aT[5]+w*(aT[7]+w*aT[9]))));\n"
"  if (id<0) return x - x*(s1+s2);\n"
"  else {\n"
"      z = atanhi[id] - ((x*(s1+s2) - atanlo[id]) - x);\n"
"      return (hx<0)? -z:z;\n"
"  }\n"
"\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_atanpi(float x) {\n"
"  return __gen_ocl_internal_atan(x) / M_PI_F;\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_erf(float x) {\n"
"  return M_2_SQRTPI_F * (x - __gen_ocl_pow(x, 3) / 3 + __gen_ocl_pow(x, 5) / 10 - __gen_ocl_pow(x, 7) / 42 + __gen_ocl_pow(x, 9) / 216);\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_erfc(float x) {\n"
"  return 1 - __gen_ocl_internal_erf(x);\n"
"}\n"
"\n"
"// XXX work-around PTX profile\n"
"#define sqrt native_sqrt\n"
"INLINE_OVERLOADABLE float rsqrt(float x) { return native_rsqrt(x); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_atan2(float y, float x) {\n"
"  /* copied from fdlibm */\n"
"  float z;\n"
"  int k,m,hx,hy,ix,iy;\n"
"  const float\n"
"  tiny  = 1.0e-30,\n"
"  zero  = 0.0,\n"
"  pi_o_4  = 7.8539818525e-01, /* 0x3f490fdb */\n"
"  pi_o_2  = 1.5707963705e+00, /* 0x3fc90fdb */\n"
"  pi      = 3.1415927410e+00, /* 0x40490fdb */\n"
"  pi_lo   = -8.7422776573e-08; /* 0xb3bbbd2e */\n"
"\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  ix = hx&0x7fffffff;\n"
"  GEN_OCL_GET_FLOAT_WORD(hy,y);\n"
"  iy = hy&0x7fffffff;\n"
"\n"
"  if((ix>0x7f800000)||\n"
"     (iy>0x7f800000)) /* x or y is NaN */\n"
"     return x+y;\n"
"  if(hx==0x3f800000) return z=__gen_ocl_internal_atan(y);   /* x=1.0 */\n"
"  m = ((hy>>31)&1)|((hx>>30)&2);  /* 2*sign(x)+sign(y) */\n"
"\n"
"    /* when y = 0 */\n"
"  if(iy==0) {\n"
"      switch(m) {\n"
"    case 0:\n"
"    case 1: return y;   /* atan(+-0,+anything)=+-0 */\n"
"    case 2: return  pi+tiny;/* atan(+0,-anything) = pi */\n"
"    case 3: return -pi-tiny;/* atan(-0,-anything) =-pi */\n"
"      }\n"
"  }\n"
"    /* when x = 0 */\n"
"  if(ix==0) return (hy<0)?  -pi_o_2-tiny: pi_o_2+tiny;\n"
"\n"
"  /* both are denorms. Gen does not support denorm, so we convert to normal float number*/\n"
"  if(ix <= 0x7fffff && iy <= 0x7fffff) {\n"
"    x = (float)(ix) * (1.0f - ((hx>>30) & 0x2));\n"
"    y = (float)(iy) * (1.0f - ((hy>>30) & 0x2));\n"
"  }\n"
"\n"
"    /* when x is INF */\n"
"  if(ix==0x7f800000) {\n"
"      if(iy==0x7f800000) {\n"
"    switch(m) {\n"
"        case 0: return  pi_o_4+tiny;/* atan(+INF,+INF) */\n"
"        case 1: return -pi_o_4-tiny;/* atan(-INF,+INF) */\n"
"        case 2: return  (float)3.0*pi_o_4+tiny;/*atan(+INF,-INF)*/\n"
"        case 3: return (float)-3.0*pi_o_4-tiny;/*atan(-INF,-INF)*/\n"
"    }\n"
"      } else {\n"
"    switch(m) {\n"
"        case 0: return  zero  ; /* atan(+...,+INF) */\n"
"        case 1: return -zero  ; /* atan(-...,+INF) */\n"
"        case 2: return  pi+tiny  ;  /* atan(+...,-INF) */\n"
"        case 3: return -pi-tiny  ;  /* atan(-...,-INF) */\n"
"    }\n"
"      }\n"
"  }\n"
"    /* when y is INF */\n"
"  if(iy==0x7f800000) return (hy<0)? -pi_o_2-tiny: pi_o_2+tiny;\n"
"\n"
"    /* compute y/x */\n"
"  k = (iy-ix)>>23;\n"
"  if(k > 60) z=pi_o_2+(float)0.5*pi_lo;   /* |y/x| >  2**60 */\n"
"  else if(hx<0&&k<-60) z=0.0;   /* |y|/x < -2**60 */\n"
"  else z=__gen_ocl_internal_atan(__gen_ocl_fabs(y/x)); /* safe to do y/x */\n"
"  switch (m) {\n"
"      case 0: return       z  ; /* atan(+,+) */\n"
"      case 1: {\n"
"              uint zh;\n"
"          GEN_OCL_GET_FLOAT_WORD(zh,z);\n"
"          GEN_OCL_SET_FLOAT_WORD(z,zh ^ 0x80000000);\n"
"        }\n"
"        return       z  ; /* atan(-,+) */\n"
"      case 2: return  pi-(z-pi_lo);/* atan(+,-) */\n"
"      default: /* case 3 */\n"
"            return  (z-pi_lo)-pi;/* atan(-,-) */\n"
"  }\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_atan2pi(float y, float x) {\n"
"  uint ix = as_uint(x), iy = as_uint(y),\n"
"       pos_zero = 0, neg_zero = 0x80000000u,\n"
"       pos_inf = 0x7f800000, neg_inf = 0xff800000u;\n"
"  if(iy == pos_zero) {\n"
"    if(ix == pos_zero)\n"
"      return 0;\n"
"    if(ix == neg_zero)\n"
"      return 1;\n"
"    if(x < 0)\n"
"      return 1;\n"
"    if(x > 0)\n"
"      return 0;\n"
"  }\n"
"  if(iy == neg_zero) {\n"
"    if(ix == pos_zero)\n"
"      return -0.f;\n"
"    if(ix == neg_zero)\n"
"      return -1;\n"
"    if(x < 0)\n"
"      return -1;\n"
"    if(x > 0)\n"
"      return -0.f;\n"
"  }\n"
"  if((ix & 0x7fffffff) == 0) {\n"
"    if(y < 0)\n"
"      return -.5f;\n"
"    if(y > 0)\n"
"      return .5f;\n"
"  }\n"
"  if(ix == pos_inf) {\n"
"    if(y > 0 && iy != pos_inf)\n"
"      return 0;\n"
"    if(y < 0 && iy != neg_inf)\n"
"      return -0.f;\n"
"  }\n"
"  if(ix == neg_inf) {\n"
"    if(y > 0 && iy != pos_inf)\n"
"      return 1;\n"
"    if(y < 0 && iy != neg_inf)\n"
"      return -1;\n"
"  }\n"
"  if(iy == pos_inf) {\n"
"    if(ix == pos_inf)\n"
"      return 0.25f;\n"
"    if(ix == neg_inf)\n"
"      return 0.75f;\n"
"    if(x >= 0 || x <= 0)\n"
"      return 0.5f;\n"
"  }\n"
"  if(iy == neg_inf) {\n"
"    if(ix == pos_inf)\n"
"      return -0.25f;\n"
"    if(ix == neg_inf)\n"
"      return -0.75f;\n"
"    if(x >= 0 || x <= 0)\n"
"      return -0.5f;\n"
"  }\n"
"  return __gen_ocl_internal_atan2(y, x) / M_PI_F;\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fabs(float x)  { return __gen_ocl_fabs(x); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_trunc(float x) { return __gen_ocl_rndz(x); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_round(float x) {\n"
"  float y = __gen_ocl_rndz(x);\n"
"  if (__gen_ocl_fabs(x - y) >= 0.5f)\n"
"    y += __gen_ocl_internal_copysign(1.f, x);\n"
"  return y;\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_ceil(float x)  { return __gen_ocl_rndu(x); }\n"
"INLINE_OVERLOADABLE float powr(float x, float y) { return __gen_ocl_pow(x,y); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_rint(float x) {\n"
"  return __gen_ocl_rnde(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_exp(float x) {\n"
"  //use native instruction when it has enough precision\n"
"  if (x > -0x1.6p1 && x < 0x1.6p1)\n"
"  {\n"
"    return native_exp(x);\n"
"  }\n"
"\n"
"  float o_threshold = 8.8721679688e+01,  /* 0x42b17180 */\n"
"  u_threshold = -1.0397208405e+02,  /* 0xc2cff1b5 */\n"
"  twom100 = 7.8886090522e-31, 	 /* 2**-100=0x0d800000 */\n"
"  ivln2	 =	1.4426950216e+00; /* 0x3fb8aa3b =1/ln2 */\n"
"  float y,hi=0.0,lo=0.0,t;\n"
"  int k=0,xsb;\n"
"  unsigned hx;\n"
"  float ln2HI_0 = 6.9313812256e-01;	/* 0x3f317180 */\n"
"  float ln2HI_1 = -6.9313812256e-01;	/* 0xbf317180 */\n"
"  float ln2LO_0 = 9.0580006145e-06;  	/* 0x3717f7d1 */\n"
"  float ln2LO_1 = -9.0580006145e-06; /* 0xb717f7d1 */\n"
"  float half_0 = 0.5;\n"
"  float half_1 =	-0.5;\n"
"\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  xsb = (hx>>31)&1;		/* sign bit of x */\n"
"  hx &= 0x7fffffff;		/* high word of |x| */\n"
"\n"
"  /* filter out non-finite argument */\n"
"  if(hx >= 0x42b17218) {			/* if |x|>=88.721... */\n"
"    // native_exp already handled this\n"
"    return native_exp(x);\n"
"  }\n"
"\n"
"  /* argument reduction */\n"
"  if(hx > 0x3eb17218) {		/* if  |x| > 0.5 ln2 */\n"
"    if(hx < 0x3F851592) {	/* and |x| < 1.5 ln2 */\n"
"      hi = x-(xsb ==1 ? ln2HI_1 : ln2HI_0);\n"
"      lo= xsb == 1? ln2LO_1 : ln2LO_0;\n"
"      k = 1-xsb-xsb;\n"
"    } else {\n"
"      float tmp = xsb == 1 ? half_1 : half_0;\n"
"      k  = ivln2*x+tmp;\n"
"      t  = k;\n"
"      hi = x - t*ln2HI_0;	/* t*ln2HI is exact here */\n"
"      lo = t*ln2LO_0;\n"
"    }\n"
"    x  = hi - lo;\n"
"  }\n"
"\n"
"  y = native_exp(x);\n"
"  if(k >= -125) {\n"
"    unsigned hy;\n"
"    GEN_OCL_GET_FLOAT_WORD(hy,y);\n"
"    GEN_OCL_SET_FLOAT_WORD(y,hy+(k<<23));	/* add k to y's exponent */\n"
"    return y;\n"
"  } else {\n"
"    unsigned hy;\n"
"    GEN_OCL_GET_FLOAT_WORD(hy,y);\n"
"    GEN_OCL_SET_FLOAT_WORD(y,hy+((k+100)<<23)); /* add k to y's exponent */\n"
"    return y*twom100;\n"
"  }\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fmod (float x, float y) {\n"
"  //return x-y*__gen_ocl_rndz(x/y);\n"
"  float one = 1.0;\n"
"  float Zero[2];\n"
"  int n,hx,hy,hz,ix,iy,sx,i;\n"
"  Zero[0] = 0.0;\n"
"  Zero[1] = -0.0;\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  GEN_OCL_GET_FLOAT_WORD(hy,y);\n"
"  sx = hx&0x80000000;		/* sign of x */\n"
"  hx ^=sx;		/* |x| */\n"
"  hy &= 0x7fffffff;	/* |y| */\n"
"  /* purge off exception values */\n"
"  if(hy==0||(hx>=0x7f800000)||		/* y=0,or x not finite */\n"
"  (hy>0x7f800000))			/* or y is NaN */\n"
"    return (x*y)/(x*y);\n"
"  if(hx<hy) return x;			/* |x|<|y| return x */\n"
"  if(hx==hy)\n"
"    return Zero[(unsigned)sx>>31];	/* |x|=|y| return x*0*/\n"
"\n"
"  /* determine ix = ilogb(x) */\n"
"  if(hx<0x00800000) {	/* subnormal x */\n"
"    for (ix = -126,i=(hx<<8); i>0; i<<=1) ix -=1;\n"
"  } else ix = (hx>>23)-127;\n"
"\n"
"  /* determine iy = ilogb(y) */\n"
"  if(hy<0x00800000) {	/* subnormal y */\n"
"    for (iy = -126,i=(hy<<8); i>=0; i<<=1) iy -=1;\n"
"  } else iy = (hy>>23)-127;\n"
"\n"
"  /* set up {hx,lx}, {hy,ly} and align y to x */\n"
"  if(ix >= -126)\n"
"    hx = 0x00800000|(0x007fffff&hx);\n"
"  else {		/* subnormal x, shift x to normal */\n"
"    n = -126-ix;\n"
"    hx = hx<<n;\n"
"  }\n"
"  if(iy >= -126)\n"
"    hy = 0x00800000|(0x007fffff&hy);\n"
"  else {		/* subnormal y, shift y to normal */\n"
"    n = -126-iy;\n"
"    hy = hy<<n;\n"
"  }\n"
"  /* fix point fmod */\n"
"  n = ix - iy;\n"
"  while(n--) {\n"
"    hz=hx-hy;\n"
"    if(hz<0){hx = hx+hx;}\n"
"    else {\n"
"      if(hz==0)		/* return sign(x)*0 */\n"
"        return Zero[(unsigned)sx>>31];\n"
"      hx = hz+hz;\n"
"    }\n"
"  }\n"
"  hz=hx-hy;\n"
"  if(hz>=0) {hx=hz;}\n"
"\n"
"    /* convert back to floating value and restore the sign */\n"
"  if(hx==0)			/* return sign(x)*0 */\n"
"    return Zero[(unsigned)sx>>31];\n"
"  while(hx<0x00800000) {		/* normalize x */\n"
"    hx = hx+hx;\n"
"    iy -= 1;\n"
"  }\n"
"  if(iy>= -126) {		/* normalize output */\n"
"    hx = ((hx-0x00800000)|((iy+127)<<23));\n"
"	GEN_OCL_SET_FLOAT_WORD(x,hx|sx);\n"
"   } else {		/* subnormal output */\n"
"     n = -126 - iy;\n"
"     hx >>= n;\n"
"     GEN_OCL_SET_FLOAT_WORD(x,hx|sx);\n"
"     x *= one;		/* create necessary signal */\n"
"  }\n"
"  return x;		/* exact output */\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_expm1(float x) {\n"
"  //return __gen_ocl_pow(M_E_F, x) - 1;\n"
"  float	Q1 = -3.3333335072e-02, /* 0xbd088889 */\n"
"  ln2_hi = 6.9313812256e-01,	/* 0x3f317180 */\n"
"  ln2_lo = 9.0580006145e-06,	/* 0x3717f7d1 */\n"
"  Q2 = 1.5873016091e-03, /* 0x3ad00d01 */\n"
"  Q3 = -7.9365076090e-05, /* 0xb8a670cd */\n"
"  Q4 = 4.0082177293e-06, /* 0x36867e54 */\n"
"  Q5 = -2.0109921195e-07, /* 0xb457edbb */\n"
"  huge = 1.0e30,\n"
"  tiny = 1.0e-30,\n"
"  ivln2 = 1.4426950216e+00, /* 0x3fb8aa3b =1/ln2 */\n"
"  one	=  1.0,\n"
"  o_threshold=  8.8721679688e+01;  /* 0x42b17180 */\n"
"  float y,hi,lo,c,t,e,hxs,hfx,r1;\n"
"  int k,xsb;\n"
"  int hx;\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  xsb = hx&0x80000000;\n"
"  /* sign bit of x */\n"
"  //if(xsb==0)\n"
"  //y=x;\n"
"  //else\n"
"  //y= -x; /* y = |x| */\n"
"  y = __gen_ocl_internal_fabs(x);\n"
"  hx &= 0x7fffffff;		/* high word of |x| */\n"
"  /* filter out huge and non-finite argument */\n"
"  if(hx >= 0x4195b844) {			/* if |x|>=27*ln2 */\n"
"    if(hx >= 0x42b17218) {		/* if |x|>=88.721... */\n"
"      if(hx>0x7f800000)\n"
"        return x+x; 	 /* NaN */\n"
"      if(hx==0x7f800000)\n"
"        return (xsb==0)? x:-1.0;/* exp(+-inf)={inf,-1} */\n"
"      if(x > o_threshold)\n"
"        return huge*huge; /* overflow */\n"
"    }\n"
"    if(xsb!=0) { /* x < -27*ln2, return -1.0 with inexact */\n"
"      if(x+tiny<(float)0.0)	/* raise inexact */\n"
"        return tiny-one;	/* return -1 */\n"
"    }\n"
"  }\n"
"  /* argument reduction */\n"
"  if(hx > 0x3eb17218) {/* if  |x| > 0.5 ln2 */\n"
"    if(hx < 0x3F851592) {/* and |x| < 1.5 ln2 */\n"
"      if(xsb==0){\n"
"        hi = x - ln2_hi; lo = ln2_lo;  k =  1;\n"
"      }	else {\n"
"        hi = x + ln2_hi; lo = -ln2_lo;  k = -1;\n"
"      }\n"
"    } else {\n"
"      k  = ivln2*x+((xsb==0)?(float)0.5:(float)-0.5);\n"
"      t  = k;\n"
"      hi = x - t*ln2_hi;/* t*ln2_hi is exact here */\n"
"      lo = t*ln2_lo;\n"
"    }\n"
"    x  = hi - lo;\n"
"    c  = (hi-x)-lo;\n"
"  } else if(hx < 0x33000000) {	/* when |x|<2**-25, return x */\n"
"    //t = huge+x; /* return x with inexact flags when x!=0 */\n"
"    //return x - (t-(huge+x));\n"
"    return x;\n"
"  } else k = 0;\n"
"  /* x is now in primary range */\n"
"  hfx = (float)0.5*x;\n"
"  hxs = x*hfx;\n"
"  r1 = one+hxs*(Q1+hxs*(Q2+hxs*(Q3+hxs*(Q4+hxs*Q5))));\n"
"  t = (float)3.0-r1*hfx;\n"
"  e = hxs*((r1-t)/((float)6.0 - x*t));\n"
"  if(k==0)\n"
"    return x - (x*e-hxs);		/* c is 0 */\n"
"  else{\n"
"    e = (x*(e-c)-c);\n"
"    e -= hxs;\n"
"    if(k== -1)return (float)0.5*(x-e)-(float)0.5;\n"
"    if(k==1){\n"
"      if(x < (float)-0.25)\n"
"        return -(float)2.0*(e-(x+(float)0.5));\n"
"      else\n"
"        return  (one+(float)2.0*(x-e));\n"
"    }\n"
"    if (k <= -2 || k>56) {	 /* suffice to return exp(x)-1 */\n"
"      int i;\n"
"      y = one-(e-x);\n"
"      GEN_OCL_GET_FLOAT_WORD(i,y);\n"
"      GEN_OCL_SET_FLOAT_WORD(y,i+(k<<23));	/* add k to y's exponent */\n"
"      return y-one;\n"
"    }\n"
"    t = one;\n"
"    if(k<23) {\n"
"      int i;\n"
"      GEN_OCL_SET_FLOAT_WORD(t,0x3f800000 - (0x1000000>>k)); /* t=1-2^-k */\n"
"      y = t-(e-x);\n"
"      GEN_OCL_GET_FLOAT_WORD(i,y);\n"
"      GEN_OCL_SET_FLOAT_WORD(y,i+(k<<23));	/* add k to y's exponent */\n"
"    } else {\n"
"      int i;\n"
"      GEN_OCL_SET_FLOAT_WORD(t,((0x7f-k)<<23));	/* 2^-k */\n"
"      y = x-(e+t);\n"
"      y += one;\n"
"      GEN_OCL_GET_FLOAT_WORD(i,y);\n"
"      GEN_OCL_SET_FLOAT_WORD(y,i+(k<<23));	/* add k to y's exponent */\n"
"    }\n"
"  }\n"
"  return y;\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_acosh(float x) {\n"
"  //return native_log(x + native_sqrt(x + 1) * native_sqrt(x - 1));\n"
"  float one	= 1.0,\n"
"  ln2	= 6.9314718246e-01;/* 0x3f317218 */\n"
"  float t;\n"
"  int hx;\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  if(hx<0x3f800000) {	/* x < 1 */\n"
"    return (x-x)/(x-x);\n"
"  } else if(hx >=0x4d800000) {	/* x > 2**28 */\n"
"    if(hx >=0x7f800000) {/* x is inf of NaN */\n"
"      return x+x;\n"
"    } else\n"
"      return __gen_ocl_internal_log(x)+ln2;/* acosh(huge)=log(2x) */\n"
"  } else if (hx==0x3f800000) {\n"
"    return 0.0;			/* acosh(1) = 0 */\n"
"  } else if (hx > 0x40000000) {	/* 2**28 > x > 2 */\n"
"    t=x*x;\n"
"    return __gen_ocl_internal_log((float)2.0*x-one/(x+__gen_ocl_sqrt(t-one)));			\n"
"  } else {			/* 1<x<2 */\n"
"    t = x-one;\n"
"    return log1p(t+__gen_ocl_sqrt((float)2.0*t+t*t));\n"
"  }\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_asinh(float x){\n"
"  //return native_log(x + native_sqrt(x * x + 1));\n"
"  float one =  1.0000000000e+00, /* 0x3F800000 */\n"
"  ln2 =  6.9314718246e-01, /* 0x3f317218 */\n"
"  huge=  1.0000000000e+30;\n"
"  float w;\n"
"  int hx,ix;\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  ix = hx&0x7fffffff;\n"
"  if(ix< 0x38000000) {	/* |x|<2**-14 */\n"
"    if(huge+x>one) return x;	/* return x inexact except 0 */\n"
"  }\n"
"  if(ix>0x47000000) {/* |x| > 2**14 */\n"
"    if(ix>=0x7f800000) return x+x;/* x is inf or NaN */\n"
"    w = __gen_ocl_internal_log(__gen_ocl_internal_fabs(x))+ln2;\n"
"  } else {\n"
"    float xa = __gen_ocl_internal_fabs(x);\n"
"    if (ix>0x40000000) {/* 2**14 > |x| > 2.0 */\n"
"      w = __gen_ocl_internal_log(2.0f*xa+one/(__gen_ocl_sqrt(xa*xa+one)+xa));\n"
"    } else {		/* 2.0 > |x| > 2**-14 */\n"
"      float t = xa*xa;\n"
"      w =log1p(xa+t/(one+__gen_ocl_sqrt(one+t)));\n"
"    }\n"
"  }\n"
"  return __gen_ocl_internal_copysign(w, x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_sinh(float x){\n"
"  //return (1 - native_exp(-2 * x)) / (2 * native_exp(-x));\n"
"  float one = 1.0,\n"
"  shuge = 1.0e37;\n"
"  float t,w,h;\n"
"  int ix,jx;\n"
"  GEN_OCL_GET_FLOAT_WORD(jx,x);\n"
"  ix = jx&0x7fffffff;\n"
"  /* x is INF or NaN */\n"
"  if(ix>=0x7f800000) return x+x;\n"
"  h = 0.5;\n"
"  if (jx<0) h = -h;\n"
"  /* |x| in [0,22], return sign(x)*0.5*(E+E/(E+1))) */\n"
"  if (ix < 0x41b00000) {		/* |x|<22 */\n"
"    if (ix<0x31800000)	/* |x|<2**-28 */\n"
"      if(shuge+x>one) return x;/* sinh(tiny) = tiny with inexact */\n"
"    t = __gen_ocl_internal_expm1(__gen_ocl_internal_fabs(x));\n"
"    if(ix<0x3f800000) return h*((float)2.0*t-t*t/(t+one));\n"
"      return h*(t+t/(t+one));\n"
"  }\n"
"  /* |x| in [22, log(maxdouble)] return 0.5*exp(|x|) */\n"
"  if (ix < 0x42b17180)  return h*__gen_ocl_internal_exp(__gen_ocl_internal_fabs(x));\n"
"  /* |x| in [log(maxdouble), overflowthresold] */\n"
"  if (ix<=0x42b2d4fc) {\n"
"    w = __gen_ocl_internal_exp((float)0.5*__gen_ocl_internal_fabs(x));\n"
"    t = h*w;\n"
"    return t*w;\n"
"  }\n"
"  /* |x| > overflowthresold, sinh(x) overflow */\n"
"  return x*shuge;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_tanh(float x) {\n"
"  //float y = native_exp(-2 * x);\n"
"  //return (1 - y) / (1 + y);\n"
"  float one=1.0, two=2.0, tiny = 1.0e-30;\n"
"  float t,z;\n"
"  int jx,ix;\n"
"  GEN_OCL_GET_FLOAT_WORD(jx,x);\n"
"  ix = jx&0x7fffffff;\n"
"  /* x is INF or NaN */\n"
"  if(ix>=0x7f800000) {\n"
"    if (jx>=0)\n"
"      return one/x+one; /* tanh(+-inf)=+-1 */\n"
"    else\n"
"      return one/x-one; /* tanh(NaN) = NaN */\n"
"  }\n"
"\n"
"  if (ix < 0x41b00000) { /* |x|<22 */\n"
"    if (ix == 0)\n"
"      return x;		/* x == +-0 */\n"
"    if (ix<0x24000000) 	/* |x|<2**-55 */\n"
"      return x*(one+x);    	/* tanh(small) = small */\n"
"    if (ix>=0x3f800000) {	/* |x|>=1  */\n"
"      t = __gen_ocl_internal_expm1(two*__gen_ocl_internal_fabs(x));\n"
"      z = one - two/(t+two);\n"
"    } else {\n"
"      t = __gen_ocl_internal_expm1(-two*__gen_ocl_internal_fabs(x));\n"
"      z= -t/(t+two);\n"
"    }\n"
"  } else { /* |x| > 22, return +-1 */\n"
"    z = one - tiny;		/* raised inexact flag */\n"
"  }\n"
"  return (jx>=0)? z: -z;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_cosh(float x) {\n"
"  //return (1 + native_exp(-2 * x)) / (2 * native_exp(-x));\n"
"  float halF = 0.5,\n"
"  huge = 1.0e+30,\n"
"  tiny = 1.0e-30,\n"
"  one = 1.0;\n"
"  float t,w;\n"
"  int ix;\n"
"  GEN_OCL_GET_FLOAT_WORD(ix,x);\n"
"  ix &= 0x7fffffff;\n"
"  /* |x| in [0,22] */\n"
"  if (ix < 0x41b00000) {\n"
"    /* |x| in [0,0.5*ln2], return 1+expm1(|x|)^2/(2*exp(|x|)) */\n"
"    if(ix<0x3eb17218) {\n"
"      t = __gen_ocl_internal_expm1(__gen_ocl_fabs(x));\n"
"      w = one+t;\n"
"      if (ix<0x24000000) return w;	/* cosh(tiny) = 1 */\n"
"      return one+(t*t)/(w+w);\n"
"    }\n"
"    /* |x| in [0.5*ln2,22], return (exp(|x|)+1/exp(|x|)/2; */\n"
"    t = __gen_ocl_internal_exp(__gen_ocl_fabs(x));\n"
"    return halF*t+halF/t;\n"
"  }\n"
"  /* |x| in [22, log(maxdouble)] return half*exp(|x|) */\n"
"  if (ix < 0x42b17180)  return halF*__gen_ocl_internal_exp(__gen_ocl_fabs(x));\n"
"  /* |x| in [log(maxdouble), overflowthresold] */\n"
"  if (ix<=0x42b2d4fc) {\n"
"    w = __gen_ocl_internal_exp(halF*__gen_ocl_fabs(x));\n"
"    t = halF*w;\n"
"    return t*w;\n"
"  }\n"
"  /* x is INF or NaN */\n"
"  if(ix>=0x7f800000) return x*x;\n"
"  /* |x| > overflowthresold, cosh(x) overflow */\n"
"  return huge*huge;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_remainder(float x, float p){\n"
"  //return x-y*__gen_ocl_rnde(x/y);\n"
"  float zero = 0.0;\n"
"  int hx,hp;\n"
"  unsigned sx;\n"
"  float p_half;\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  GEN_OCL_GET_FLOAT_WORD(hp,p);\n"
"  sx = hx&0x80000000;\n"
"  hp &= 0x7fffffff;\n"
"  hx &= 0x7fffffff;\n"
"  /* purge off exception values */\n"
"  if(hp==0) return (x*p)/(x*p);	        /* p = 0 */\n"
"  if((hx>=0x7f800000)||               /* x not finite */\n"
"    ((hp>0x7f800000)))	               /* p is NaN */\n"
"    return (x*p)/(x*p);\n"
"  if (hp<=0x7effffff) x = __gen_ocl_internal_fmod(x,p+p); /* now x < 2p */\n"
"  if ((hx-hp)==0) return zero*x;\n"
"  x = __gen_ocl_fabs(x);\n"
"  p = __gen_ocl_fabs(p);\n"
"  if (hp<0x01000000) {\n"
"    if(x+x>p) {\n"
"      x-=p;\n"
"      if(x+x>=p) x -= p;\n"
"    }\n"
"  } else {\n"
"    p_half = (float)0.5*p;\n"
"    if(x>p_half) {\n"
"      x-=p;\n"
"      if(x>=p_half) x -= p;\n"
"    }\n"
"  }\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  GEN_OCL_SET_FLOAT_WORD(x,hx^sx);\n"
"  return x;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_ldexp(float x, int n) {\n"
"  if(!__ocl_finitef(x)||x==(float)0.0) return x;\n"
"  x = __gen_ocl_scalbnf(x,n);\n"
"  return x;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_atanh(float x) {\n"
"  //return 0.5f * native_sqrt((1 + x) / (1 - x));\n"
"  float xa = __gen_ocl_fabs (x);\n"
"  float t;\n"
"  if (isless (xa, 0.5f)){\n"
"    if (xa < 0x1.0p-28f) return x;\n"
"    t = xa + xa;\n"
"    t = 0.5f * log1p (t + t * xa / (1.0f - xa));\n"
"  } else if (isless (xa, 1.0f)){\n"
"    t = 0.5f * log1p ((xa + xa) / (1.0f - xa));\n"
"  } else{\n"
"    if (isgreater (xa, 1.0f)) return (x - x) / (x - x);\n"
"    return x / 0.0f;\n"
"  }\n"
"  return __gen_ocl_internal_copysign(t, x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_exp10(float x){\n"
"  float px, qx,ans;\n"
"  short n;\n"
"  int i;\n"
"  float*p;\n"
"  float MAXL10 = 38.230809449325611792;\n"
"  float LOG210 = 3.32192809488736234787e0;\n"
"  float LG102A = 3.00781250000000000000E-1;\n"
"  float LG102B = 2.48745663981195213739E-4;\n"
"  float P[6];\n"
"  P[0] = 2.063216740311022E-001;\n"
"  P[1] = 5.420251702225484E-001;\n"
"  P[2] = 1.171292686296281E+000;\n"
"  P[3] = 2.034649854009453E+000;\n"
"  P[4] = 2.650948748208892E+000;\n"
"  P[5] = 2.302585167056758E+000;\n"
"  if( isinf(x))\n"
"    return INFINITY;\n"
"\n"
"  if( x < -MAXL10 )return 0.0;\n"
"  /* The following is necessary because range reduction blows up: */\n"
"  if( x == 0 )return 1.0;\n"
"\n"
"  /* Express 10**x = 10**g 2**n\n"
"    *	 = 10**g 10**( n log10(2) )\n"
"    *	 = 10**( g + n log10(2) )\n"
"    */\n"
"  px = x * LOG210;\n"
"  qx = __gen_ocl_internal_floor( px + 0.5 );\n"
"  n = qx;\n"
"  x -= qx * LG102A;\n"
"  x -= qx * LG102B;\n"
"\n"
"  /* rational approximation for exponential\n"
"    * of the fractional part:\n"
"    * 10**x - 1  =  2x P(x**2)/( Q(x**2) - P(x**2) )\n"
"    */\n"
"  p = P;\n"
"  ans = *p++;\n"
"  i = 5;\n"
"  do{\n"
"    ans = ans * x  +  *p++;\n"
"  }\n"
"  while( --i );\n"
"  px = 1.0 + x * ans;\n"
"\n"
"  /* multiply by power of 2 */\n"
"  x = __gen_ocl_internal_ldexp( px, n );\n"
"  return x;\n"
"}\n"
"\n"
"// TODO use llvm intrinsics definitions\n"
"#define cospi __gen_ocl_internal_cospi\n"
"#define cosh __gen_ocl_internal_cosh\n"
"#define acos __gen_ocl_internal_acos\n"
"#define acospi __gen_ocl_internal_acospi\n"
"#define acosh __gen_ocl_internal_acosh\n"
"#define sinpi __gen_ocl_internal_sinpi\n"
"#define sinh __gen_ocl_internal_sinh\n"
"#define asin __gen_ocl_internal_asin\n"
"#define asinpi __gen_ocl_internal_asinpi\n"
"#define asinh __gen_ocl_internal_asinh\n"
"#define tanpi __gen_ocl_internal_tanpi\n"
"#define tanh __gen_ocl_internal_tanh\n"
"#define atan __gen_ocl_internal_atan\n"
"#define atan2 __gen_ocl_internal_atan2\n"
"#define atan2pi __gen_ocl_internal_atan2pi\n"
"#define atanpi __gen_ocl_internal_atanpi\n"
"#define atanh __gen_ocl_internal_atanh\n"
"#define pow powr\n"
"#define cbrt __gen_ocl_internal_cbrt\n"
"#define rint __gen_ocl_internal_rint\n"
"#define copysign __gen_ocl_internal_copysign\n"
"#define erf __gen_ocl_internal_erf\n"
"#define erfc __gen_ocl_internal_erfc\n"
"#define fmod __gen_ocl_internal_fmod\n"
"#define remainder __gen_ocl_internal_remainder\n"
"#define ldexp __gen_ocl_internal_ldexp\n"
"PURE CONST float __gen_ocl_mad(float a, float b, float c);\n"
"PURE CONST float __gen_ocl_fmax(float a, float b);\n"
"PURE CONST float __gen_ocl_fmin(float a, float b);\n"
"INLINE_OVERLOADABLE float mad(float a, float b, float c) {\n"
"  return __gen_ocl_mad(a, b, c);\n"
"}\n"
"\n"
"#define DEF(TYPE1, TYPE2) \\\n"
"  INLINE_OVERLOADABLE TYPE1 select(TYPE1 src0, TYPE1 src1, TYPE2 cond) { \\\n"
"    return cond ? src1 : src0; \\\n"
"  }\n"
"DEF(char, char)\n"
"DEF(char, uchar)\n"
"DEF(uchar, char)\n"
"DEF(uchar, uchar)\n"
"DEF(short, short)\n"
"DEF(short, ushort)\n"
"DEF(ushort, short)\n"
"DEF(ushort, ushort)\n"
"DEF(int, int)\n"
"DEF(int, uint)\n"
"DEF(uint, int)\n"
"DEF(uint, uint)\n"
"DEF(long, long)\n"
"DEF(long, ulong)\n"
"DEF(ulong, long)\n"
"DEF(ulong, ulong)\n"
"DEF(float, int)\n"
"DEF(float, uint)\n"
"#undef DEF\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Common Functions (see 6.11.4 of OCL 1.1 spec)\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"INLINE_OVERLOADABLE float step(float edge, float x) {\n"
"  return x < edge ? 0.0 : 1.0;\n"
"}\n"
"\n"
"#define DECL_MIN_MAX_CLAMP(TYPE) \\\n"
"INLINE_OVERLOADABLE TYPE max(TYPE a, TYPE b) { \\\n"
"  return a > b ? a : b; \\\n"
"} \\\n"
"INLINE_OVERLOADABLE TYPE min(TYPE a, TYPE b) { \\\n"
"  return a < b ? a : b; \\\n"
"} \\\n"
"INLINE_OVERLOADABLE TYPE clamp(TYPE v, TYPE l, TYPE u) { \\\n"
"  return max(min(v, u), l); \\\n"
"}\n"
"DECL_MIN_MAX_CLAMP(int)\n"
"DECL_MIN_MAX_CLAMP(short)\n"
"DECL_MIN_MAX_CLAMP(char)\n"
"DECL_MIN_MAX_CLAMP(uint)\n"
"DECL_MIN_MAX_CLAMP(unsigned short)\n"
"DECL_MIN_MAX_CLAMP(unsigned char)\n"
"DECL_MIN_MAX_CLAMP(long)\n"
"DECL_MIN_MAX_CLAMP(ulong)\n"
"#undef DECL_MIN_MAX_CLAMP\n"
"INLINE_OVERLOADABLE float max(float a, float b) {\n"
"  return __gen_ocl_fmax(a, b);\n"
"}\n"
"INLINE_OVERLOADABLE float min(float a, float b) {\n"
"  return __gen_ocl_fmin(a, b);\n"
"}\n"
"INLINE_OVERLOADABLE float clamp(float v, float l, float u) {\n"
"  return max(min(v, u), l);\n"
"}\n"
"\n"
"#define BODY \\\n"
"  if (isnan(x) || isinf(x)) { \\\n"
"    *exp = 0; \\\n"
"    return x; \\\n"
"  } \\\n"
"  uint u = as_uint(x); \\\n"
"  uint a = u & 0x7FFFFFFFu; \\\n"
"  if (a == 0) { \\\n"
"    *exp = 0; \\\n"
"    return x; \\\n"
"  } \\\n"
"  if (a >= 0x800000) { \\\n"
"    *exp = (a >> 23) - 126; \\\n"
"    return as_float((u & (0x807FFFFFu)) | 0x3F000000); \\\n"
"  } \\\n"
"  int e = -126; \\\n"
"  while (a < 0x400000) { \\\n"
"    e --; \\\n"
"    a <<= 1; \\\n"
"  } \\\n"
"  a <<= 1; \\\n"
"  *exp = e; \\\n"
"  return as_float((a & (0x807FFFFFu)) | (u & 0x80000000u) | 0x3F000000);\n"
"INLINE_OVERLOADABLE float frexp(float x, global int *exp) { BODY; }\n"
"INLINE_OVERLOADABLE float frexp(float x, local int *exp) { BODY; }\n"
"INLINE_OVERLOADABLE float frexp(float x, private int *exp) { BODY; }\n"
"#undef BODY\n"
"\n"
"INLINE_OVERLOADABLE float nextafter(float x, float y) {\n"
"  int hx, hy, ix, iy;\n"
"  hx = as_int(x);\n"
"  hy = as_int(y);\n"
"  ix = hx & 0x7fffffff;\n"
"  iy = hy & 0x7fffffff;\n"
"  if(ix>0x7f800000 || iy>0x7f800000)\n"
"    return x+y;\n"
"  if(hx == hy)\n"
"    return y;\n"
"  if(ix == 0) {\n"
"    if(iy == 0)\n"
"      return y;\n"
"    else\n"
"      return as_float((hy&0x80000000) | 1);\n"
"  }\n"
"  if(hx >= 0) {\n"
"    if(hx > hy) {\n"
"      hx -= 1;\n"
"    } else {\n"
"      hx += 1;\n"
"    }\n"
"  } else {\n"
"    if(hy >= 0 || hx > hy){\n"
"      hx -= 1;\n"
"    } else {\n"
"      hx += 1;\n"
"    }\n"
"  }\n"
"  return as_float(hx);\n"
"}\n"
"\n"
"#define BODY \\\n"
"  uint hx = as_uint(x), ix = hx & 0x7FFFFFFF; \\\n"
"  if (ix > 0x7F800000) { \\\n"
"    *i = nan(0u); \\\n"
"    return nan(0u); \\\n"
"  } \\\n"
"  if (ix == 0x7F800000) { \\\n"
"    *i = x; \\\n"
"    return as_float(hx & 0x80000000u); \\\n"
"  } \\\n"
"  *i = __gen_ocl_rndz(x); \\\n"
"  return x - *i;\n"
"INLINE_OVERLOADABLE float modf(float x, global float *i) { BODY; }\n"
"INLINE_OVERLOADABLE float modf(float x, local float *i) { BODY; }\n"
"INLINE_OVERLOADABLE float modf(float x, private float *i) { BODY; }\n"
"#undef BODY\n"
"INLINE_OVERLOADABLE float degrees(float radians) { return (180 / M_PI_F) * radians; }\n"
"INLINE_OVERLOADABLE float radians(float degrees) { return (M_PI_F / 180) * degrees; }\n"
"\n"
"INLINE_OVERLOADABLE float smoothstep(float e0, float e1, float x) {\n"
"  x = clamp((x - e0) / (e1 - e0), 0.f, 1.f);\n"
"  return x * x * (3 - 2 * x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float sign(float x) {\n"
"  if(x > 0)\n"
"    return 1;\n"
"  if(x < 0)\n"
"    return -1;\n"
"  if(x == -0.f)\n"
"    return -0.f;\n"
"  return 0.f;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fmax(float a, float b) { return max(a,b); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fmin(float a, float b) { return min(a,b); }\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_maxmag(float x, float y) {\n"
"  float a = __gen_ocl_fabs(x), b = __gen_ocl_fabs(y);\n"
"  return a > b ? x : b > a ? y : max(x, y);\n"
"}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_minmag(float x, float y) {\n"
"  float a = __gen_ocl_fabs(x), b = __gen_ocl_fabs(y);\n"
"  return a < b ? x : b < a ? y : min(x, y);\n"
"}\n"
"INLINE_OVERLOADABLE float mix(float x, float y, float a) { return x + (y-x)*a;}\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fdim(float x, float y) {\n"
"  if(isnan(x))\n"
"    return x;\n"
"  if(isnan(y))\n"
"    return y;\n"
"  return x > y ? (x - y) : +0.f;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_pow(float x, float y) {\n"
"  float z,ax,z_h,z_l,p_h,p_l;\n"
"  float y1,t1,t2,r,s,sn,t,u,v,w;\n"
"  int i,j,k,yisint,n;\n"
"  int hx,hy,ix,iy,is;\n"
"  float bp[2],dp_h[2],dp_l[2],\n"
"  zero    =  0.0,\n"
"  one	=  1.0,\n"
"  two	=  2.0,\n"
"  two24	=  16777216.0,	/* 0x4b800000 */\n"
"  huge	=  1.0e30,\n"
"  tiny    =  1.0e-30,\n"
"  /* poly coefs for (3/2)*(log(x)-2s-2/3*s**3 */\n"
"  L1  =  6.0000002384e-01, /* 0x3f19999a */\n"
"  L2  =  4.2857143283e-01, /* 0x3edb6db7 */\n"
"  L3  =  3.3333334327e-01, /* 0x3eaaaaab */\n"
"  L4  =  2.7272811532e-01, /* 0x3e8ba305 */\n"
"  L5  =  2.3066075146e-01, /* 0x3e6c3255 */\n"
"  L6  =  2.0697501302e-01, /* 0x3e53f142 */\n"
"  P1   =  1.6666667163e-01, /* 0x3e2aaaab */\n"
"  P2   = -2.7777778450e-03, /* 0xbb360b61 */\n"
"  P3   =  6.6137559770e-05, /* 0x388ab355 */\n"
"  P4   = -1.6533901999e-06, /* 0xb5ddea0e */\n"
"  P5   =  4.1381369442e-08, /* 0x3331bb4c */\n"
"  lg2  =  6.9314718246e-01, /* 0x3f317218 */\n"
"  lg2_h  =  6.93145752e-01, /* 0x3f317200 */\n"
"  lg2_l  =  1.42860654e-06, /* 0x35bfbe8c */\n"
"  ovt =  4.2995665694e-08, /* -(128-log2(ovfl+.5ulp)) */\n"
"  cp    =  9.6179670095e-01, /* 0x3f76384f =2/(3ln2) */\n"
"  cp_h  =  9.6179199219e-01, /* 0x3f763800 =head of cp */\n"
"  cp_l  =  4.7017383622e-06, /* 0x369dc3a0 =tail of cp_h */\n"
"  ivln2    =  1.4426950216e+00, /* 0x3fb8aa3b =1/ln2 */\n"
"  ivln2_h  =  1.4426879883e+00, /* 0x3fb8aa00 =16b 1/ln2*/\n"
"  ivln2_l  =  7.0526075433e-06; /* 0x36eca570 =1/ln2 tail*/\n"
"  bp[0] = 1.0,bp[1] = 1.5,\n"
"  dp_h[0] = 0.0,dp_h[1] = 5.84960938e-01,\n"
"  dp_l[0] = 0.0,dp_l[1] = 1.56322085e-06;\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);\n"
"  GEN_OCL_GET_FLOAT_WORD(hy,y);\n"
"  ix = hx&0x7fffffff;  iy = hy&0x7fffffff;\n"
"  if (ix < 0x00800000) {	   /* x < 2**-126  */\n"
"    ix = 0;/* Gen does not support subnormal number now */\n"
"  }\n"
"  if (iy < 0x00800000) {	  /* y < 2**-126  */\n"
"    iy = 0;/* Gen does not support subnormal number now */\n"
"  }\n"
"   /* y==zero: x**0 = 1 */\n"
"  if(iy==0) return one;\n"
"  if(hx==0x3f800000) return one;\n"
"  /* +-NaN return x+y */\n"
"  if(ix > 0x7f800000 || iy > 0x7f800000)\n"
"    return (x+0.0f)+y+(0.0f);\n"
"  /* determine if y is an odd int when x < 0\n"
"     * yisint = 0	... y is not an integer\n"
"     * yisint = 1	... y is an odd int\n"
"     * yisint = 2	... y is an even int\n"
"     */\n"
"  yisint  = 0;\n"
"  if(hx<0) {\n"
"    if(iy>=0x4b800000) yisint = 2; /* even integer y */\n"
"    else if(iy>=0x3f800000) {\n"
"      k = (iy>>23)-0x7f;	   /* exponent */\n"
"      j = iy>>(23-k);\n"
"      if((j<<(23-k))==iy) yisint = 2-(j&1);\n"
"    }\n"
"  }\n"
"  /* special value of y */\n"
"  if (iy==0x7f800000) {	/* y is +-inf */\n"
"    if (ix==0x3f800000)\n"
"      //return  y - y;	/* inf**+-1 is NaN */\n"
"      return one;\n"
"    else if (ix > 0x3f800000)/* (|x|>1)**+-inf = inf,0 */\n"
"      return (hy>=0)? y: zero;\n"
"    else			/* (|x|<1)**-,+inf = inf,0 */\n"
"      return (hy<0)?-y: zero;\n"
"  }\n"
"  if(iy==0x3f800000) {	/* y is  +-1 */\n"
"    if(hy<0) return one/x; else return x;\n"
"  }\n"
"  if(hy==0x40000000) return x*x; /* y is  2 */\n"
"  if(hy==0x3f000000) {	/* y is  0.5 */\n"
"    if(hx>=0)return __gen_ocl_sqrt(x);\n"
"  }\n"
"\n"
"  ax   = __gen_ocl_fabs(x);\n"
"    /* special value of x */\n"
"  if(ix==0x7f800000||ix==0||ix==0x3f800000){\n"
"    z = ax;			/*x is +-0,+-inf,+-1*/\n"
"    if(hy<0) z = one/z;	/* z = (1/|x|) */\n"
"    if(hx<0) {\n"
"      if(((ix-0x3f800000)|yisint)==0) {\n"
"        z = (z-z)/(z-z); /* (-1)**non-int is NaN */\n"
"      } else if(yisint==1)\n"
"        z = -z;		/* (x<0)**odd = -(|x|**odd) */\n"
"    }\n"
"    return z;\n"
"  }\n"
"  n = ((uint)hx>>31)-1;\n"
"\n"
"  /* (x<0)**(non-int) is NaN */\n"
"  if((n|yisint)==0) return (x-x)/(x-x);\n"
"\n"
"  sn = one; /* s (sign of result -ve**odd) = -1 else = 1 */\n"
"  if((n|(yisint-1))==0) sn = -one;/* (-ve)**(odd int) */\n"
"\n"
"  /* |y| is huge */\n"
"  if(iy>0x4d000000) { /* if |y| > 2**27 */\n"
"    /* over/underflow if x is not close to one */\n"
"    if(ix<0x3f7ffff8) return (hy<0)? sn*huge*huge:sn*tiny*tiny;\n"
"    if(ix>0x3f800007) return (hy>0)? sn*huge*huge:sn*tiny*tiny;\n"
"    /* now |1-x| is tiny <= 2**-20, suffice to compute\n"
"          log(x) by x-x^2/2+x^3/3-x^4/4 */\n"
"    t = ax-1;		/* t has 20 trailing zeros */\n"
"    w = (t*t)*((float)0.5-t*(0.333333333333f-t*0.25f));\n"
"    u = ivln2_h*t;	/* ivln2_h has 16 sig. bits */\n"
"    v = t*ivln2_l-w*ivln2;\n"
"    t1 = u+v;\n"
"    GEN_OCL_GET_FLOAT_WORD(is,t1);\n"
"    GEN_OCL_SET_FLOAT_WORD(t1,is&0xfffff000);\n"
"    t2 = v-(t1-u);\n"
"  } else {\n"
"    float s2,s_h,s_l,t_h,t_l;\n"
"    n = 0;\n"
"	/* take care subnormal number */\n"
"    //if(ix<0x00800000)\n"
"      //{ax *= two24; n -= 24; GEN_OCL_GET_FLOAT_WORD(ix,ax); }\n"
"    n  += ((ix)>>23)-0x7f;\n"
"    j  = ix&0x007fffff;\n"
"	/* determine interval */\n"
"    ix = j|0x3f800000;		/* normalize ix */\n"
"    if(j<=0x1cc471) k=0;	/* |x|<sqrt(3/2) */\n"
"    else if(j<0x5db3d7) k=1;	/* |x|<sqrt(3)   */\n"
"    else {k=0;n+=1;ix -= 0x00800000;}\n"
"    GEN_OCL_SET_FLOAT_WORD(ax,ix);\n"
"\n"
"	/* compute s = s_h+s_l = (x-1)/(x+1) or (x-1.5)/(x+1.5) */\n"
"    u = ax-bp[k];		/* bp[0]=1.0, bp[1]=1.5 */\n"
"    v = one/(ax+bp[k]);\n"
"    s = u*v;\n"
"    s_h = s;\n"
"    GEN_OCL_GET_FLOAT_WORD(is,s_h);\n"
"    GEN_OCL_SET_FLOAT_WORD(s_h,is&0xfffff000);\n"
"    /* t_h=ax+bp[k] High */\n"
"    is = ((ix>>1)&0xfffff000)|0x20000000;\n"
"    GEN_OCL_SET_FLOAT_WORD(t_h,is+0x00400000+(k<<21));\n"
"    t_l = ax - (t_h-bp[k]);\n"
"    s_l = v*((u-s_h*t_h)-s_h*t_l);\n"
"    /* compute log(ax) */\n"
"    s2 = s*s;\n"
"    r = s2*s2*(L1+s2*(L2+s2*(L3+s2*(L4+s2*(L5+s2*L6)))));\n"
"    r += s_l*(s_h+s);\n"
"    s2  = s_h*s_h;\n"
"    t_h = 3.0f+s2+r;\n"
"    GEN_OCL_GET_FLOAT_WORD(is,t_h);\n"
"    GEN_OCL_SET_FLOAT_WORD(t_h,is&0xfffff000);\n"
"    t_l = r-((t_h-3.0f)-s2);\n"
"    /* u+v = s*(1+...) */\n"
"    u = s_h*t_h;\n"
"    v = s_l*t_h+t_l*s;\n"
"    /* 2/(3log2)*(s+...) */\n"
"    p_h = u+v;\n"
"    GEN_OCL_GET_FLOAT_WORD(is,p_h);\n"
"    GEN_OCL_SET_FLOAT_WORD(p_h,is&0xfffff000);\n"
"    p_l = v-(p_h-u);\n"
"    z_h = cp_h*p_h;		/* cp_h+cp_l = 2/(3*log2) */\n"
"    z_l = cp_l*p_h+p_l*cp+dp_l[k];\n"
"    /* log2(ax) = (s+..)*2/(3*log2) = n + dp_h + z_h + z_l */\n"
"    t = (float)n;\n"
"    t1 = (((z_h+z_l)+dp_h[k])+t);\n"
"    GEN_OCL_GET_FLOAT_WORD(is,t1);\n"
"    GEN_OCL_SET_FLOAT_WORD(t1,is&0xfffff000);\n"
"    t2 = z_l-(((t1-t)-dp_h[k])-z_h);\n"
"  }\n"
"\n"
"  /* split up y into y1+y2 and compute (y1+y2)*(t1+t2) */\n"
"  GEN_OCL_GET_FLOAT_WORD(is,y);\n"
"  GEN_OCL_SET_FLOAT_WORD(y1,is&0xfffff000);\n"
"  p_l = (y-y1)*t1+y*t2;\n"
"  p_h = y1*t1;\n"
"  z = p_l+p_h;\n"
"  GEN_OCL_GET_FLOAT_WORD(j,z);\n"
"  if (j>0x43000000)				/* if z > 128 */\n"
"    return sn*huge*huge;			/* overflow */\n"
"  else if (j==0x43000000) {			/* if z == 128 */\n"
"    if(p_l+ovt>z-p_h) return sn*huge*huge;	/* overflow */\n"
"  }\n"
"  else if ((j&0x7fffffff)>0x43160000)		/* z <= -150 */\n"
"    return sn*tiny*tiny;			/* underflow */\n"
"  else if (j==0xc3160000){			/* z == -150 */\n"
"    if(p_l<=z-p_h) return sn*tiny*tiny;		/* underflow */\n"
"  }\n"
"\n"
"  /*\n"
"    * compute 2**(p_h+p_l)\n"
"    */\n"
"  i = j&0x7fffffff;\n"
"  k = (i>>23)-0x7f;\n"
"  n = 0;\n"
"  if(i>0x3f000000) {		/* if |z| > 0.5, set n = [z+0.5] */\n"
"    n = j+(0x00800000>>(k+1));\n"
"    k = ((n&0x7fffffff)>>23)-0x7f;	/* new k for n */\n"
"    GEN_OCL_SET_FLOAT_WORD(t,n&~(0x007fffff>>k));\n"
"    n = ((n&0x007fffff)|0x00800000)>>(23-k);\n"
"    if(j<0) n = -n;\n"
"    p_h -= t;\n"
"  }\n"
"  t = p_l+p_h;\n"
"  GEN_OCL_GET_FLOAT_WORD(is,t);\n"
"  GEN_OCL_SET_FLOAT_WORD(t,is&0xffff8000);\n"
"  u = t*lg2_h;\n"
"  v = (p_l-(t-p_h))*lg2+t*lg2_l;\n"
"  z = u+v;\n"
"  w = v-(z-u);\n"
"  t  = z*z;\n"
"  t1  = z - t*(P1+t*(P2+t*(P3+t*(P4+t*P5))));\n"
"  r  = (z*t1)/(t1-two)-(w+z*w);\n"
"  z  = one-(r-z);\n"
"  GEN_OCL_GET_FLOAT_WORD(j,z);\n"
"  j += (n<<23);\n"
"  if((j>>23)<=0) z = __gen_ocl_scalbnf(z,n);	/* subnormal output */\n"
"  else GEN_OCL_SET_FLOAT_WORD(z,j);\n"
"  return sn*z;\n"
"}\n"
"\n"
"\n"
"INLINE_OVERLOADABLE float hypot(float x, float y) {\n"
"  //return __gen_ocl_sqrt(x*x + y*y);\n"
"  float a,b,an,bn,cn;\n"
"  int e;\n"
"  if (isfinite (x) && isfinite (y)){      /* Determine absolute values.  */\n"
"  x = __gen_ocl_fabs (x);\n"
"  y = __gen_ocl_fabs (y);\n"
"  /* Find the bigger and the smaller one.  */\n"
"  a = max(x,y);\n"
"  b = min(x,y);\n"
"  /* Now 0 <= b <= a.  */\n"
"  /* Write a = an * 2^e, b = bn * 2^e with 0 <= bn <= an < 1.  */\n"
"  an = frexp (a, &e);\n"
"  bn = ldexp (b, - e);\n"
"  /* Through the normalization, no unneeded overflow or underflow will occur here.  */\n"
"  cn = __gen_ocl_sqrt (an * an + bn * bn);\n"
"  return ldexp (cn, e);\n"
"  }else{\n"
"    if (isinf (x) || isinf (y))  /* x or y is infinite.  Return +Infinity.  */    \n"
"      return INFINITY;\n"
"    else        /* x or y is NaN.  Return NaN.  */\n"
"      return x + y;\n"
"  }\n"
"}\n"
"\n"
"#define BODY \\\n"
"  if (isnan(x)) { \\\n"
"    *p = x; \\\n"
"    return x; \\\n"
"  } \\\n"
"  *p = __gen_ocl_internal_floor(x); \\\n"
"  if (isinf(x)) { \\\n"
"    return x > 0 ? +0. : -0.; \\\n"
"  } \\\n"
"  return __gen_ocl_internal_fmin(x - *p, 0x1.FFFFFep-1F);\n"
"INLINE_OVERLOADABLE float fract(float x, global float *p) { BODY; }\n"
"INLINE_OVERLOADABLE float fract(float x, local float *p) { BODY; }\n"
"INLINE_OVERLOADABLE float fract(float x, private float *p) { BODY; }\n"
"#undef BODY\n"
"\n"
"#define BODY \\\n"
"  float Zero[2]; \\\n"
"  int n,hx,hy,hz,ix,iy,sx,i,sy; \\\n"
"  uint q,sxy; \\\n"
"  Zero[0] = 0.0;Zero[1] = -0.0; \\\n"
"  GEN_OCL_GET_FLOAT_WORD(hx,x);GEN_OCL_GET_FLOAT_WORD(hy,y); \\\n"
"  sxy = (hx ^ hy) & 0x80000000;sx = hx&0x80000000;sy = hy&0x80000000; \\\n"
"  hx ^=sx; hy &= 0x7fffffff; \\\n"
"  if (hx < 0x00800000)hx = 0;if (hy < 0x00800000)hy = 0; \\\n"
"  if(hy==0||hx>=0x7f800000||hy>0x7f800000){ \\\n"
"    *quo = 0;return NAN; \\\n"
"  } \\\n"
"  if( hy == 0x7F800000 || hx == 0 ) { \\\n"
"    *quo = 0;return x; \\\n"
"  } \\\n"
"  if( hx == hy ) { \\\n"
"    *quo = (x == y) ? 1 : -1; \\\n"
"    return sx ? -0.0 : 0.0; \\\n"
"  } \\\n"
"  if(hx<hy) { \\\n"
"    q = 0; \\\n"
"    goto fixup; \\\n"
"  } else if(hx==hy) { \\\n"
"    *quo = (sxy ? -1 : 1); \\\n"
"    return Zero[(uint)sx>>31]; \\\n"
"  } \\\n"
"  ix = (hx>>23)-127; \\\n"
"  iy = (hy>>23)-127; \\\n"
"  hx = 0x00800000|(0x007fffff&hx); \\\n"
"  hy = 0x00800000|(0x007fffff&hy); \\\n"
"  n = ix - iy; \\\n"
"  q = 0; \\\n"
"  while(n--) { \\\n"
"    hz=hx-hy; \\\n"
"    if(hz<0) hx = hx << 1; \\\n"
"    else {hx = hz << 1; q++;} \\\n"
"    q <<= 1; \\\n"
"  } \\\n"
"  hz=hx-hy; \\\n"
"  if(hz>=0) {hx=hz;q++;} \\\n"
"  if(hx==0) { \\\n"
"    q &= 0x0000007f; \\\n"
"    *quo = (sxy ? -q : q); \\\n"
"    return Zero[(uint)sx>>31]; \\\n"
"  } \\\n"
"  while(hx<0x00800000) { \\\n"
"    hx <<= 1;iy -= 1; \\\n"
"  } \\\n"
"  if(iy>= -126) { \\\n"
"    hx = ((hx-0x00800000)|((iy+127)<<23)); \\\n"
"  } else {\\\n"
"    n = -126 - iy; \\\n"
"    hx >>= n; \\\n"
"  } \\\n"
"fixup: \\\n"
"  GEN_OCL_SET_FLOAT_WORD(x,hx); \\\n"
"  if(hx<0x00800000){ \\\n"
"    GEN_OCL_GET_FLOAT_WORD(hy,y); \\\n"
"    hy &= 0x7fffffff; \\\n"
"    if(hx+hx > hy ||(hx+hx==hy && (q & 1)))q++; \\\n"
"    x = 0; \\\n"
"  }else{ \\\n"
"    y = __gen_ocl_fabs(y); \\\n"
"    if (y < 0x1p-125f) { \\\n"
"      if (x+x>y || (x+x==y && (q & 1))) { \\\n"
"        q++;x-=y; \\\n"
"      } \\\n"
"    }else if (x>0.5f*y || (x==0.5f*y && (q & 1))) { \\\n"
"      q++;x-=y; \\\n"
"    } \\\n"
"    GEN_OCL_GET_FLOAT_WORD(hx,x);GEN_OCL_SET_FLOAT_WORD(x,hx^sx); \\\n"
"  } \\\n"
"  int sign = sx==sy?0:1; \\\n"
"  q &= 0x0000007f; \\\n"
"  *quo = (sign ? -q : q); \\\n"
"  return x;\n"
"\n"
"INLINE_OVERLOADABLE float remquo(float x, float y, global int *quo) {\n"
"	BODY;\n"
"}\n"
"INLINE_OVERLOADABLE float remquo(float x, float y, local int *quo) { BODY; }\n"
"INLINE_OVERLOADABLE float remquo(float x, float y, private int *quo) { BODY; }\n"
"#undef BODY\n"
"INLINE_OVERLOADABLE float native_divide(float x, float y) { return x/y; }\n"
"INLINE_OVERLOADABLE float pown(float x, int n) {\n"
"  if (x == 0 && n == 0)\n"
"    return 1;\n"
"  return powr(x, n);\n"
"}\n"
"INLINE_OVERLOADABLE float rootn(float x, int n) {\n"
"  float ax,re;\n"
"  int sign = 0;\n"
"  if( n == 0 )return NAN;\n"
"  //rootn ( x, n )  returns a NaN for x < 0 and n is even.\n"
"  if( x < 0 && 0 == (n&1) )\n"
"    return NAN;\n"
"  if( x == 0.0 ){\n"
"    switch( n & 0x80000001 ){\n"
"      //rootn ( +-0,  n ) is +0 for even n > 0.\n"
"      case 0:\n"
"        return 0.0f;\n"
"      //rootn ( +-0,  n ) is +-0 for odd n > 0.\n"
"      case 1:\n"
"        return x;\n"
"      //rootn ( +-0,  n ) is +inf for even n < 0.\n"
"      case 0x80000000:\n"
"        return INFINITY;\n"
"\n"
"      //rootn ( +-0,  n ) is +-inf for odd n < 0.\n"
"      case 0x80000001:\n"
"        return __gen_ocl_internal_copysign(INFINITY, x);\n"
"    }\n"
"  }\n"
"  ax = __gen_ocl_fabs(x);\n"
"  if(x <0.0f && (n&1))\n"
"    sign = 1;\n"
"  re = __gen_ocl_internal_pow(ax,1.f/n);\n"
"  if(sign)\n"
"    re = -re;\n"
"  return re;\n"
"}\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Geometric functions (see 6.11.5 of OCL 1.1 spec)\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"INLINE_OVERLOADABLE float dot(float p0, float p1) {\n"
"  return p0 * p1;\n"
"}\n"
"INLINE_OVERLOADABLE float dot(float2 p0, float2 p1) {\n"
"  return p0.x * p1.x + p0.y * p1.y;\n"
"}\n"
"INLINE_OVERLOADABLE float dot(float3 p0, float3 p1) {\n"
"  return p0.x * p1.x + p0.y * p1.y + p0.z * p1.z;\n"
"}\n"
"INLINE_OVERLOADABLE float dot(float4 p0, float4 p1) {\n"
"  return p0.x * p1.x + p0.y * p1.y + p0.z * p1.z + p0.w * p1.w;\n"
"}\n"
"INLINE_OVERLOADABLE float length(float x) { return __gen_ocl_fabs(x); }\n"
"#define BODY \\\n"
"  if(m == 0) \\\n"
"    return 0; \\\n"
"  if(isinf(m)) \\\n"
"    return INFINITY; \\\n"
"  if(m < 1) \\\n"
"    m = 1; \\\n"
"  x /= m; \\\n"
"  return m * sqrt(dot(x,x));\n"
"INLINE_OVERLOADABLE float length(float2 x) {\n"
"  float m = max(__gen_ocl_fabs(x.s0), __gen_ocl_fabs(x.s1));\n"
"  BODY;\n"
"}\n"
"INLINE_OVERLOADABLE float length(float3 x) {\n"
"  float m = max(__gen_ocl_fabs(x.s0), max(__gen_ocl_fabs(x.s1), __gen_ocl_fabs(x.s2)));\n"
"  BODY;\n"
"}\n"
"INLINE_OVERLOADABLE float length(float4 x) {\n"
"  float m = max(__gen_ocl_fabs(x.s0), max(__gen_ocl_fabs(x.s1), max(__gen_ocl_fabs(x.s2), __gen_ocl_fabs(x.s3))));\n"
"  BODY;\n"
"}\n"
"#undef BODY\n"
"INLINE_OVERLOADABLE float distance(float x, float y) { return length(x-y); }\n"
"INLINE_OVERLOADABLE float distance(float2 x, float2 y) { return length(x-y); }\n"
"INLINE_OVERLOADABLE float distance(float3 x, float3 y) { return length(x-y); }\n"
"INLINE_OVERLOADABLE float distance(float4 x, float4 y) { return length(x-y); }\n"
"INLINE_OVERLOADABLE float normalize(float x) {\n"
"  union { float f; unsigned u; } u;\n"
"  u.f = x;\n"
"  if(u.u == 0)\n"
"    return 0.f;\n"
"  if(isnan(x))\n"
"    return NAN;\n"
"  return u.u < 0x7fffffff ? 1.f : -1.f;\n"
"}\n"
"INLINE_OVERLOADABLE float2 normalize(float2 x) {\n"
"  float m = length(x);\n"
"  if(m == 0)\n"
"    return 0;\n"
"  return x / m;\n"
"}\n"
"INLINE_OVERLOADABLE float3 normalize(float3 x) {\n"
"  float m = length(x);\n"
"  if(m == 0)\n"
"    return 0;\n"
"  return x / m;\n"
"}\n"
"INLINE_OVERLOADABLE float4 normalize(float4 x) {\n"
"  float m = length(x);\n"
"  if(m == 0)\n"
"    return 0;\n"
"  return x / m;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float fast_length(float x) { return __gen_ocl_fabs(x); }\n"
"INLINE_OVERLOADABLE float fast_length(float2 x) { return sqrt(dot(x,x)); }\n"
"INLINE_OVERLOADABLE float fast_length(float3 x) { return sqrt(dot(x,x)); }\n"
"INLINE_OVERLOADABLE float fast_length(float4 x) { return sqrt(dot(x,x)); }\n"
"INLINE_OVERLOADABLE float fast_distance(float x, float y) { return length(x-y); }\n"
"INLINE_OVERLOADABLE float fast_distance(float2 x, float2 y) { return length(x-y); }\n"
"INLINE_OVERLOADABLE float fast_distance(float3 x, float3 y) { return length(x-y); }\n"
"INLINE_OVERLOADABLE float fast_distance(float4 x, float4 y) { return length(x-y); }\n"
"INLINE_OVERLOADABLE float fast_normalize(float x) { return x > 0 ? 1.f : (x < 0 ? -1.f : 0.f); }\n"
"INLINE_OVERLOADABLE float2 fast_normalize(float2 x) { return x * rsqrt(dot(x, x)); }\n"
"INLINE_OVERLOADABLE float3 fast_normalize(float3 x) { return x * rsqrt(dot(x, x)); }\n"
"INLINE_OVERLOADABLE float4 fast_normalize(float4 x) { return x * rsqrt(dot(x, x)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 cross(float3 v0, float3 v1) {\n"
"   return v0.yzx*v1.zxy-v0.zxy*v1.yzx;\n"
"}\n"
"INLINE_OVERLOADABLE float4 cross(float4 v0, float4 v1) {\n"
"   return (float4)(v0.yzx*v1.zxy-v0.zxy*v1.yzx, 0.f);\n"
"}\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Vector loads and stores\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"\n"
"// These loads and stores will use untyped reads and writes, so we can just\n"
"// cast to vector loads / stores. Not C99 compliant BTW due to aliasing issue.\n"
"// Well we do not care, we do not activate TBAA in the compiler\n"
"#define DECL_UNTYPED_RW_SPACE_N(TYPE, DIM, SPACE) \\\n"
"INLINE_OVERLOADABLE TYPE##DIM vload##DIM(size_t offset, const SPACE TYPE *p) { \\\n"
"  return *(SPACE TYPE##DIM *) (p + DIM * offset); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore##DIM(TYPE##DIM v, size_t offset, SPACE TYPE *p) { \\\n"
"  *(SPACE TYPE##DIM *) (p + DIM * offset) = v; \\\n"
"}\n"
"\n"
"#define DECL_UNTYPED_RD_SPACE_N(TYPE, DIM, SPACE) \\\n"
"INLINE_OVERLOADABLE TYPE##DIM vload##DIM(size_t offset, const SPACE TYPE *p) { \\\n"
"  return *(SPACE TYPE##DIM *) (p + DIM * offset); \\\n"
"}\n"
"\n"
"#define DECL_UNTYPED_V3_SPACE(TYPE, SPACE) \\\n"
"INLINE_OVERLOADABLE void vstore3(TYPE##3 v, size_t offset, SPACE TYPE *p) {\\\n"
"  *(p + 3 * offset) = v.s0; \\\n"
"  *(p + 3 * offset + 1) = v.s1; \\\n"
"  *(p + 3 * offset + 2) = v.s2; \\\n"
"} \\\n"
"INLINE_OVERLOADABLE TYPE##3 vload3(size_t offset, const SPACE TYPE *p) { \\\n"
"  return (TYPE##3)(*(p + 3 * offset), *(p+ 3 * offset + 1), *(p + 3 * offset + 2));\\\n"
"}\n"
"\n"
"#define DECL_UNTYPED_RDV3_SPACE(TYPE, SPACE) \\\n"
"INLINE_OVERLOADABLE TYPE##3 vload3(size_t offset, const SPACE TYPE *p) { \\\n"
"  return (TYPE##3)(*(p + 3 * offset), *(p+ 3 * offset + 1), *(p + 3 * offset + 2));\\\n"
"}\n"
"\n"
"#define DECL_UNTYPED_RW_ALL_SPACE(TYPE, SPACE) \\\n"
"  DECL_UNTYPED_RW_SPACE_N(TYPE, 2, SPACE) \\\n"
"  DECL_UNTYPED_V3_SPACE(TYPE, SPACE) \\\n"
"  DECL_UNTYPED_RW_SPACE_N(TYPE, 4, SPACE) \\\n"
"  DECL_UNTYPED_RW_SPACE_N(TYPE, 8, SPACE) \\\n"
"  DECL_UNTYPED_RW_SPACE_N(TYPE, 16, SPACE)\n"
"\n"
"#define DECL_UNTYPED_RD_ALL_SPACE(TYPE, SPACE) \\\n"
"  DECL_UNTYPED_RD_SPACE_N(TYPE, 2, SPACE) \\\n"
"  DECL_UNTYPED_RDV3_SPACE(TYPE, SPACE) \\\n"
"  DECL_UNTYPED_RD_SPACE_N(TYPE, 4, SPACE) \\\n"
"  DECL_UNTYPED_RD_SPACE_N(TYPE, 8, SPACE) \\\n"
"  DECL_UNTYPED_RD_SPACE_N(TYPE, 16, SPACE)\n"
"\n"
"#define DECL_UNTYPED_RW_ALL(TYPE) \\\n"
"  DECL_UNTYPED_RW_ALL_SPACE(TYPE, __global) \\\n"
"  DECL_UNTYPED_RW_ALL_SPACE(TYPE, __local) \\\n"
"  DECL_UNTYPED_RD_ALL_SPACE(TYPE, __constant) \\\n"
"  DECL_UNTYPED_RW_ALL_SPACE(TYPE, __private)\n"
"\n"
"#define DECL_BYTE_RD_SPACE(TYPE, SPACE) \\\n"
"INLINE_OVERLOADABLE TYPE##2 vload2(size_t offset, const SPACE TYPE *p) { \\\n"
"  return (TYPE##2)(*(p+2*offset), *(p+2*offset+1)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE TYPE##3 vload3(size_t offset, const SPACE TYPE *p) { \\\n"
"  return (TYPE##3)(*(p+3*offset), *(p+3*offset+1), *(p+3*offset+2)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE TYPE##4 vload4(size_t offset, const SPACE TYPE *p) { \\\n"
"  return (TYPE##4)(vload2(2*offset, p), vload2(2*offset, p+2)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE TYPE##8 vload8(size_t offset, const SPACE TYPE *p) { \\\n"
"  return (TYPE##8)(vload4(2*offset, p), vload4(2*offset, p+4)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE TYPE##16 vload16(size_t offset, const SPACE TYPE *p) { \\\n"
"  return (TYPE##16)(vload8(2*offset, p), vload8(2*offset, p+8)); \\\n"
"}\n"
"\n"
"#define DECL_BYTE_WR_SPACE(TYPE, SPACE) \\\n"
"INLINE_OVERLOADABLE void vstore2(TYPE##2 v, size_t offset, SPACE TYPE *p) {\\\n"
"  *(p + 2 * offset) = v.s0; \\\n"
"  *(p + 2 * offset + 1) = v.s1; \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore3(TYPE##3 v, size_t offset, SPACE TYPE *p) {\\\n"
"  *(p + 3 * offset) = v.s0; \\\n"
"  *(p + 3 * offset + 1) = v.s1; \\\n"
"  *(p + 3 * offset + 2) = v.s2; \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore4(TYPE##4 v, size_t offset, SPACE TYPE *p) { \\\n"
"  vstore2(v.lo, 2*offset, p); \\\n"
"  vstore2(v.hi, 2*offset, p+2); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore8(TYPE##8 v, size_t offset, SPACE TYPE *p) { \\\n"
"  vstore4(v.lo, 2*offset, p); \\\n"
"  vstore4(v.hi, 2*offset, p+4); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore16(TYPE##16 v, size_t offset, SPACE TYPE *p) { \\\n"
"  vstore8(v.lo, 2*offset, p); \\\n"
"  vstore8(v.hi, 2*offset, p+8); \\\n"
"}\n"
"\n"
"#define DECL_BYTE_RW_ALL(TYPE) \\\n"
"  DECL_BYTE_RD_SPACE(TYPE, __global) \\\n"
"  DECL_BYTE_RD_SPACE(TYPE, __local) \\\n"
"  DECL_BYTE_RD_SPACE(TYPE, __private) \\\n"
"  DECL_BYTE_RD_SPACE(TYPE, __constant) \\\n"
"  DECL_BYTE_WR_SPACE(TYPE, __global) \\\n"
"  DECL_BYTE_WR_SPACE(TYPE, __local) \\\n"
"  DECL_BYTE_WR_SPACE(TYPE, __private)\n"
"\n"
"DECL_BYTE_RW_ALL(char)\n"
"DECL_BYTE_RW_ALL(uchar)\n"
"DECL_BYTE_RW_ALL(short)\n"
"DECL_BYTE_RW_ALL(ushort)\n"
"DECL_UNTYPED_RW_ALL(int)\n"
"DECL_UNTYPED_RW_ALL(uint)\n"
"DECL_UNTYPED_RW_ALL(long)\n"
"DECL_UNTYPED_RW_ALL(ulong)\n"
"DECL_UNTYPED_RW_ALL(float)\n"
"DECL_UNTYPED_RW_ALL(double)\n"
"\n"
"#undef DECL_UNTYPED_RW_ALL\n"
"#undef DECL_UNTYPED_RW_ALL_SPACE\n"
"#undef DECL_UNTYPED_RD_ALL_SPACE\n"
"#undef DECL_UNTYPED_RW_SPACE_N\n"
"#undef DECL_UNTYPED_RD_SPACE_N\n"
"#undef DECL_UNTYPED_V3_SPACE\n"
"#undef DECL_UNTYPED_RDV3_SPACE\n"
"#undef DECL_BYTE_RD_SPACE\n"
"#undef DECL_BYTE_WR_SPACE\n"
"#undef DECL_BYTE_RW_ALL\n"
"\n"
"PURE CONST float __gen_ocl_f16to32(short h);\n"
"PURE CONST short __gen_ocl_f32to16(float f);\n"
"\n"
"INLINE_OVERLOADABLE short f32to16_rtp(float f) {\n"
"  short s = __gen_ocl_f32to16(f);\n"
"  float con = __gen_ocl_f16to32(s);\n"
"  //if(isinf(con)) return s;\n"
"  if (f > con)\n"
"    return s - signbit(f) * 2 + 1;\n"
"  else\n"
"    return s;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE short f32to16_rtn(float f) {\n"
"  short s = __gen_ocl_f32to16(f);\n"
"  float con = __gen_ocl_f16to32(s);\n"
"  //if(isinf(con)) return s;\n"
"  if (con > f)\n"
"    return s + signbit(f) * 2 - 1;\n"
"  else\n"
"    return s;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE short f32to16_rtz(float f) {\n"
"  short s = __gen_ocl_f32to16(f);\n"
"  float con = __gen_ocl_f16to32(s);\n"
"  //if(isinf(con)) return s;\n"
"  if (((con > f) && !signbit(f)) ||\n"
"      ((con < f) && signbit(f)))\n"
"    return s - 1;\n"
"  else\n"
"    return s;\n"
"}\n"
"\n"
"#define DECL_HALF_LD_SPACE(SPACE) \\\n"
"INLINE_OVERLOADABLE float vload_half(size_t offset, const SPACE half *p) { \\\n"
"  return __gen_ocl_f16to32(*(SPACE short *)(p + offset)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE float2 vload_half2(size_t offset, const SPACE half *p) { \\\n"
"  return (float2)(vload_half(offset*2, p), \\\n"
"                  vload_half(offset*2 + 1, p)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE float3 vload_half3(size_t offset, const SPACE half *p) { \\\n"
"  return (float3)(vload_half(offset*3, p), \\\n"
"                  vload_half(offset*3 + 1, p), \\\n"
"                  vload_half(offset*3 + 2, p)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE float3 vloada_half3(size_t offset, const SPACE half *p) { \\\n"
"  return (float3)(vload_half(offset*4, p), \\\n"
"                  vload_half(offset*4 + 1, p), \\\n"
"                  vload_half(offset*4 + 2, p)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE float4 vload_half4(size_t offset, const SPACE half *p) { \\\n"
"  return (float4)(vload_half2(offset*2, p), \\\n"
"                  vload_half2(offset*2 + 1, p)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE float8 vload_half8(size_t offset, const SPACE half *p) { \\\n"
"  return (float8)(vload_half4(offset*2, p), \\\n"
"                  vload_half4(offset*2 + 1, p)); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE float16 vload_half16(size_t offset, const SPACE half *p) { \\\n"
"  return (float16)(vload_half8(offset*2, p), \\\n"
"                   vload_half8(offset*2 + 1, p)); \\\n"
"}\n"
"\n"
"#define DECL_HALF_ST_SPACE_ROUND(SPACE, ROUND, FUNC) \\\n"
"INLINE_OVERLOADABLE void vstore_half##ROUND(float data, size_t offset, SPACE half *p) { \\\n"
"  *(SPACE short *)(p + offset) = FUNC(data); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstorea_half##ROUND(float data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half##ROUND(data, offset, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore_half2##ROUND(float2 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half##ROUND(data.lo, offset*2, p); \\\n"
"  vstore_half##ROUND(data.hi, offset*2 + 1, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstorea_half2##ROUND(float2 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half2##ROUND(data, offset, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore_half3##ROUND(float3 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half##ROUND(data.s0, offset*3, p); \\\n"
"  vstore_half##ROUND(data.s1, offset*3 + 1, p); \\\n"
"  vstore_half##ROUND(data.s2, offset*3 + 2, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstorea_half3##ROUND(float3 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half##ROUND(data.s0, offset*4, p); \\\n"
"  vstore_half##ROUND(data.s1, offset*4 + 1, p); \\\n"
"  vstore_half##ROUND(data.s2, offset*4 + 2, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore_half4##ROUND(float4 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half2##ROUND(data.lo, offset*2, p); \\\n"
"  vstore_half2##ROUND(data.hi, offset*2 + 1, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstorea_half4##ROUND(float4 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half4##ROUND(data, offset, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore_half8##ROUND(float8 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half4##ROUND(data.lo, offset*2, p); \\\n"
"  vstore_half4##ROUND(data.hi, offset*2 + 1, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstorea_half8##ROUND(float8 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half8##ROUND(data, offset, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstore_half16##ROUND(float16 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half8##ROUND(data.lo, offset*2, p); \\\n"
"  vstore_half8##ROUND(data.hi, offset*2 + 1, p); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE void vstorea_half16##ROUND(float16 data, size_t offset, SPACE half *p) { \\\n"
"  vstore_half16##ROUND(data, offset, p); \\\n"
"}\n"
"\n"
"#define DECL_HALF_ST_SPACE(SPACE) \\\n"
"  DECL_HALF_ST_SPACE_ROUND(SPACE,  , __gen_ocl_f32to16) \\\n"
"  DECL_HALF_ST_SPACE_ROUND(SPACE, _rte, __gen_ocl_f32to16) \\\n"
"  DECL_HALF_ST_SPACE_ROUND(SPACE, _rtz, f32to16_rtz) \\\n"
"  DECL_HALF_ST_SPACE_ROUND(SPACE, _rtp, f32to16_rtp) \\\n"
"  DECL_HALF_ST_SPACE_ROUND(SPACE, _rtn, f32to16_rtn) \\\n"
"\n"
"DECL_HALF_LD_SPACE(__global)\n"
"DECL_HALF_LD_SPACE(__local)\n"
"DECL_HALF_LD_SPACE(__constant)\n"
"DECL_HALF_LD_SPACE(__private)\n"
"\n"
"DECL_HALF_ST_SPACE(__global)\n"
"DECL_HALF_ST_SPACE(__local)\n"
"DECL_HALF_ST_SPACE(__private)\n"
"\n"
"//#undef DECL_UNTYPED_RW_ALL_SPACE\n"
"#undef DECL_HALF_LD_SPACE\n"
"#undef DECL_HALF_ST_SPACE\n"
"#undef DECL_HALF_ST_SPACE_ROUND\n"
"\n"
"#define vloada_half vload_half\n"
"#define vloada_half2 vload_half2\n"
"#define vloada_half4 vload_half4\n"
"#define vloada_half8 vload_half8\n"
"#define vloada_half16 vload_half16\n"
"\n"
"// XXX workaround ptx profile\n"
"#define fabs __gen_ocl_internal_fabs\n"
"#define trunc __gen_ocl_internal_trunc\n"
"#define round __gen_ocl_internal_round\n"
"#define floor __gen_ocl_internal_floor\n"
"#define ceil __gen_ocl_internal_ceil\n"
"#define log __gen_ocl_internal_log\n"
"#define log2 __gen_ocl_internal_log2\n"
"#define log10 __gen_ocl_internal_log10\n"
"#define exp __gen_ocl_internal_exp\n"
"#define exp2 native_exp2\n"
"#define exp10 __gen_ocl_internal_exp10\n"
"#define expm1 __gen_ocl_internal_expm1\n"
"#define fmin __gen_ocl_internal_fmin\n"
"#define fmax __gen_ocl_internal_fmax\n"
"#define fma mad\n"
"#define fdim __gen_ocl_internal_fdim\n"
"#define maxmag __gen_ocl_internal_maxmag\n"
"#define minmag __gen_ocl_internal_minmag\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Miscellaneous Vector Functions (see 6.11.12 of OCL 1.1 spec)\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"#define DEC2(TYPE, XTYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##2 shuffle(XTYPE x, MASKTYPE##2 mask) { \\\n"
"    TYPE##2 y; \\\n"
"    y.s0 = ((TYPE *) &x)[mask.s0 & (vec_step(x) - 1)]; \\\n"
"    y.s1 = ((TYPE *) &x)[mask.s1 & (vec_step(x) - 1)]; \\\n"
"    return y; \\\n"
"  }\n"
"\n"
"#define DEC4(TYPE, XTYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##4 shuffle(XTYPE x, MASKTYPE##4 mask) { \\\n"
"    TYPE##4 y; \\\n"
"    y.s0 = ((TYPE *) &x)[mask.s0 & (vec_step(x) - 1)]; \\\n"
"    y.s1 = ((TYPE *) &x)[mask.s1 & (vec_step(x) - 1)]; \\\n"
"    y.s2 = ((TYPE *) &x)[mask.s2 & (vec_step(x) - 1)]; \\\n"
"    y.s3 = ((TYPE *) &x)[mask.s3 & (vec_step(x) - 1)]; \\\n"
"    return y; \\\n"
"  }\n"
"\n"
"#define DEC8(TYPE, XTYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##8 shuffle(XTYPE x, MASKTYPE##8 mask) { \\\n"
"    TYPE##8 y; \\\n"
"    y.s0 = ((TYPE *) &x)[mask.s0 & (vec_step(x) - 1)]; \\\n"
"    y.s1 = ((TYPE *) &x)[mask.s1 & (vec_step(x) - 1)]; \\\n"
"    y.s2 = ((TYPE *) &x)[mask.s2 & (vec_step(x) - 1)]; \\\n"
"    y.s3 = ((TYPE *) &x)[mask.s3 & (vec_step(x) - 1)]; \\\n"
"    y.s4 = ((TYPE *) &x)[mask.s4 & (vec_step(x) - 1)]; \\\n"
"    y.s5 = ((TYPE *) &x)[mask.s5 & (vec_step(x) - 1)]; \\\n"
"    y.s6 = ((TYPE *) &x)[mask.s6 & (vec_step(x) - 1)]; \\\n"
"    y.s7 = ((TYPE *) &x)[mask.s7 & (vec_step(x) - 1)]; \\\n"
"    return y; \\\n"
"  }\n"
"\n"
"#define DEC16(TYPE, XTYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##16 shuffle(XTYPE x, MASKTYPE##16 mask) { \\\n"
"    TYPE##16 y; \\\n"
"    y.s0 = ((TYPE *) &x)[mask.s0 & (vec_step(x) - 1)]; \\\n"
"    y.s1 = ((TYPE *) &x)[mask.s1 & (vec_step(x) - 1)]; \\\n"
"    y.s2 = ((TYPE *) &x)[mask.s2 & (vec_step(x) - 1)]; \\\n"
"    y.s3 = ((TYPE *) &x)[mask.s3 & (vec_step(x) - 1)]; \\\n"
"    y.s4 = ((TYPE *) &x)[mask.s4 & (vec_step(x) - 1)]; \\\n"
"    y.s5 = ((TYPE *) &x)[mask.s5 & (vec_step(x) - 1)]; \\\n"
"    y.s6 = ((TYPE *) &x)[mask.s6 & (vec_step(x) - 1)]; \\\n"
"    y.s7 = ((TYPE *) &x)[mask.s7 & (vec_step(x) - 1)]; \\\n"
"    y.s8 = ((TYPE *) &x)[mask.s8 & (vec_step(x) - 1)]; \\\n"
"    y.s9 = ((TYPE *) &x)[mask.s9 & (vec_step(x) - 1)]; \\\n"
"    y.sa = ((TYPE *) &x)[mask.sa & (vec_step(x) - 1)]; \\\n"
"    y.sb = ((TYPE *) &x)[mask.sb & (vec_step(x) - 1)]; \\\n"
"    y.sc = ((TYPE *) &x)[mask.sc & (vec_step(x) - 1)]; \\\n"
"    y.sd = ((TYPE *) &x)[mask.sd & (vec_step(x) - 1)]; \\\n"
"    y.se = ((TYPE *) &x)[mask.se & (vec_step(x) - 1)]; \\\n"
"    y.sf = ((TYPE *) &x)[mask.sf & (vec_step(x) - 1)]; \\\n"
"    return y; \\\n"
"  }\n"
"\n"
"#define DEFMASK(TYPE, MASKTYPE) \\\n"
"  DEC2(TYPE, TYPE##2, MASKTYPE); DEC2(TYPE, TYPE##4, MASKTYPE); DEC2(TYPE, TYPE##8, MASKTYPE); DEC2(TYPE, TYPE##16, MASKTYPE) \\\n"
"  DEC4(TYPE, TYPE##2, MASKTYPE); DEC4(TYPE, TYPE##4, MASKTYPE); DEC4(TYPE, TYPE##8, MASKTYPE); DEC4(TYPE, TYPE##16, MASKTYPE) \\\n"
"  DEC8(TYPE, TYPE##2, MASKTYPE); DEC8(TYPE, TYPE##4, MASKTYPE); DEC8(TYPE, TYPE##8, MASKTYPE); DEC8(TYPE, TYPE##16, MASKTYPE) \\\n"
"  DEC16(TYPE, TYPE##2, MASKTYPE); DEC16(TYPE, TYPE##4, MASKTYPE); DEC16(TYPE, TYPE##8, MASKTYPE); DEC16(TYPE, TYPE##16, MASKTYPE)\n"
"\n"
"#define DEF(TYPE) \\\n"
"  DEFMASK(TYPE, uchar) \\\n"
"  DEFMASK(TYPE, ushort) \\\n"
"  DEFMASK(TYPE, uint) \\\n"
"  DEFMASK(TYPE, ulong)\n"
"\n"
"DEF(char)\n"
"DEF(uchar)\n"
"DEF(short)\n"
"DEF(ushort)\n"
"DEF(int)\n"
"DEF(uint)\n"
"DEF(float)\n"
"DEF(long)\n"
"DEF(ulong)\n"
"#undef DEF\n"
"#undef DEFMASK\n"
"#undef DEC2\n"
"#undef DEC4\n"
"#undef DEC8\n"
"#undef DEC16\n"
"\n"
"#define DEC2(TYPE, ARGTYPE, TEMPTYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##2 shuffle2(ARGTYPE x, ARGTYPE y, MASKTYPE##2 mask) { \\\n"
"    return shuffle((TEMPTYPE)(x, y), mask); \\\n"
"  }\n"
"\n"
"#define DEC2X(TYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##2 shuffle2(TYPE##16 x, TYPE##16 y, MASKTYPE##2 mask) { \\\n"
"    TYPE##2 z; \\\n"
"    z.s0 = mask.s0 < 16 ? ((TYPE *)&x)[mask.s0] : ((TYPE *)&y)[mask.s0 & 15]; \\\n"
"    z.s1 = mask.s1 < 16 ? ((TYPE *)&x)[mask.s1] : ((TYPE *)&y)[mask.s1 & 15]; \\\n"
"    return z; \\\n"
"  }\n"
"\n"
"#define DEC4(TYPE, ARGTYPE, TEMPTYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##4 shuffle2(ARGTYPE x, ARGTYPE y, MASKTYPE##4 mask) { \\\n"
"    return shuffle((TEMPTYPE)(x, y), mask); \\\n"
"  }\n"
"\n"
"#define DEC4X(TYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##4 shuffle2(TYPE##16 x, TYPE##16 y, MASKTYPE##4 mask) { \\\n"
"    TYPE##4 z; \\\n"
"    z.s0 = mask.s0 < 16 ? ((TYPE *)&x)[mask.s0] : ((TYPE *)&y)[mask.s0 & 15]; \\\n"
"    z.s1 = mask.s1 < 16 ? ((TYPE *)&x)[mask.s1] : ((TYPE *)&y)[mask.s1 & 15]; \\\n"
"    z.s2 = mask.s2 < 16 ? ((TYPE *)&x)[mask.s2] : ((TYPE *)&y)[mask.s2 & 15]; \\\n"
"    z.s3 = mask.s3 < 16 ? ((TYPE *)&x)[mask.s3] : ((TYPE *)&y)[mask.s3 & 15]; \\\n"
"    return z; \\\n"
"  }\n"
"\n"
"#define DEC8(TYPE, ARGTYPE, TEMPTYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##8 shuffle2(ARGTYPE x, ARGTYPE y, MASKTYPE##8 mask) { \\\n"
"    return shuffle((TEMPTYPE)(x, y), mask); \\\n"
"  }\n"
"\n"
"#define DEC8X(TYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##8 shuffle2(TYPE##16 x, TYPE##16 y, MASKTYPE##8 mask) { \\\n"
"    TYPE##8 z; \\\n"
"    z.s0 = mask.s0 < 16 ? ((TYPE *)&x)[mask.s0] : ((TYPE *)&y)[mask.s0 & 15]; \\\n"
"    z.s1 = mask.s1 < 16 ? ((TYPE *)&x)[mask.s1] : ((TYPE *)&y)[mask.s1 & 15]; \\\n"
"    z.s2 = mask.s2 < 16 ? ((TYPE *)&x)[mask.s2] : ((TYPE *)&y)[mask.s2 & 15]; \\\n"
"    z.s3 = mask.s3 < 16 ? ((TYPE *)&x)[mask.s3] : ((TYPE *)&y)[mask.s3 & 15]; \\\n"
"    z.s4 = mask.s4 < 16 ? ((TYPE *)&x)[mask.s4] : ((TYPE *)&y)[mask.s4 & 15]; \\\n"
"    z.s5 = mask.s5 < 16 ? ((TYPE *)&x)[mask.s5] : ((TYPE *)&y)[mask.s5 & 15]; \\\n"
"    z.s6 = mask.s6 < 16 ? ((TYPE *)&x)[mask.s6] : ((TYPE *)&y)[mask.s6 & 15]; \\\n"
"    z.s7 = mask.s7 < 16 ? ((TYPE *)&x)[mask.s7] : ((TYPE *)&y)[mask.s7 & 15]; \\\n"
"    return z; \\\n"
"  }\n"
"\n"
"#define DEC16(TYPE, ARGTYPE, TEMPTYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##16 shuffle2(ARGTYPE x, ARGTYPE y, MASKTYPE##16 mask) { \\\n"
"    return shuffle((TEMPTYPE)(x, y), mask); \\\n"
"  }\n"
"\n"
"#define DEC16X(TYPE, MASKTYPE) \\\n"
"  INLINE_OVERLOADABLE TYPE##16 shuffle2(TYPE##16 x, TYPE##16 y, MASKTYPE##16 mask) { \\\n"
"    TYPE##16 z; \\\n"
"    z.s0 = mask.s0 < 16 ? ((TYPE *)&x)[mask.s0] : ((TYPE *)&y)[mask.s0 & 15]; \\\n"
"    z.s1 = mask.s1 < 16 ? ((TYPE *)&x)[mask.s1] : ((TYPE *)&y)[mask.s1 & 15]; \\\n"
"    z.s2 = mask.s2 < 16 ? ((TYPE *)&x)[mask.s2] : ((TYPE *)&y)[mask.s2 & 15]; \\\n"
"    z.s3 = mask.s3 < 16 ? ((TYPE *)&x)[mask.s3] : ((TYPE *)&y)[mask.s3 & 15]; \\\n"
"    z.s4 = mask.s4 < 16 ? ((TYPE *)&x)[mask.s4] : ((TYPE *)&y)[mask.s4 & 15]; \\\n"
"    z.s5 = mask.s5 < 16 ? ((TYPE *)&x)[mask.s5] : ((TYPE *)&y)[mask.s5 & 15]; \\\n"
"    z.s6 = mask.s6 < 16 ? ((TYPE *)&x)[mask.s6] : ((TYPE *)&y)[mask.s6 & 15]; \\\n"
"    z.s7 = mask.s7 < 16 ? ((TYPE *)&x)[mask.s7] : ((TYPE *)&y)[mask.s7 & 15]; \\\n"
"    z.s8 = mask.s8 < 16 ? ((TYPE *)&x)[mask.s8] : ((TYPE *)&y)[mask.s8 & 15]; \\\n"
"    z.s9 = mask.s9 < 16 ? ((TYPE *)&x)[mask.s9] : ((TYPE *)&y)[mask.s9 & 15]; \\\n"
"    z.sa = mask.sa < 16 ? ((TYPE *)&x)[mask.sa] : ((TYPE *)&y)[mask.sa & 15]; \\\n"
"    z.sb = mask.sb < 16 ? ((TYPE *)&x)[mask.sb] : ((TYPE *)&y)[mask.sb & 15]; \\\n"
"    z.sc = mask.sc < 16 ? ((TYPE *)&x)[mask.sc] : ((TYPE *)&y)[mask.sc & 15]; \\\n"
"    z.sd = mask.sd < 16 ? ((TYPE *)&x)[mask.sd] : ((TYPE *)&y)[mask.sd & 15]; \\\n"
"    z.se = mask.se < 16 ? ((TYPE *)&x)[mask.se] : ((TYPE *)&y)[mask.se & 15]; \\\n"
"    z.sf = mask.sf < 16 ? ((TYPE *)&x)[mask.sf] : ((TYPE *)&y)[mask.sf & 15]; \\\n"
"    return z; \\\n"
"  }\n"
"\n"
"#define DEFMASK(TYPE, MASKTYPE) \\\n"
"  DEC2(TYPE, TYPE##2, TYPE##4, MASKTYPE) \\\n"
"  DEC2(TYPE, TYPE##4, TYPE##8, MASKTYPE) \\\n"
"  DEC2(TYPE, TYPE##8, TYPE##16, MASKTYPE) \\\n"
"  DEC2X(TYPE, MASKTYPE) \\\n"
"  DEC4(TYPE, TYPE##2, TYPE##4, MASKTYPE) \\\n"
"  DEC4(TYPE, TYPE##4, TYPE##8, MASKTYPE) \\\n"
"  DEC4(TYPE, TYPE##8, TYPE##16, MASKTYPE) \\\n"
"  DEC4X(TYPE, MASKTYPE) \\\n"
"  DEC8(TYPE, TYPE##2, TYPE##4, MASKTYPE) \\\n"
"  DEC8(TYPE, TYPE##4, TYPE##8, MASKTYPE) \\\n"
"  DEC8(TYPE, TYPE##8, TYPE##16, MASKTYPE) \\\n"
"  DEC8X(TYPE, MASKTYPE) \\\n"
"  DEC16(TYPE, TYPE##2, TYPE##4, MASKTYPE) \\\n"
"  DEC16(TYPE, TYPE##4, TYPE##8, MASKTYPE) \\\n"
"  DEC16(TYPE, TYPE##8, TYPE##16, MASKTYPE) \\\n"
"  DEC16X(TYPE, MASKTYPE)\n"
"\n"
"#define DEF(TYPE) \\\n"
"  DEFMASK(TYPE, uchar) \\\n"
"  DEFMASK(TYPE, ushort) \\\n"
"  DEFMASK(TYPE, uint) \\\n"
"  DEFMASK(TYPE, ulong)\n"
"\n"
"DEF(char)\n"
"DEF(uchar)\n"
"DEF(short)\n"
"DEF(ushort)\n"
"DEF(int)\n"
"DEF(uint)\n"
"DEF(float)\n"
"DEF(long)\n"
"DEF(ulong)\n"
"#undef DEF\n"
"#undef DEFMASK\n"
"#undef DEC2\n"
"#undef DEC2X\n"
"#undef DEC4\n"
"#undef DEC4X\n"
"#undef DEC8\n"
"#undef DEC8X\n"
"#undef DEC16\n"
"#undef DEC16X\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Synchronization functions\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"#define CLK_LOCAL_MEM_FENCE  (1 << 0)\n"
"#define CLK_GLOBAL_MEM_FENCE (1 << 1)\n"
"\n"
"void __gen_ocl_barrier_local(void);\n"
"void __gen_ocl_barrier_global(void);\n"
"void __gen_ocl_barrier_local_and_global(void);\n"
"\n"
"typedef uint cl_mem_fence_flags;\n"
"void barrier(cl_mem_fence_flags flags);\n"
"\n"
"INLINE void mem_fence(cl_mem_fence_flags flags) {\n"
"}\n"
"INLINE void read_mem_fence(cl_mem_fence_flags flags) {\n"
"}\n"
"INLINE void write_mem_fence(cl_mem_fence_flags flags) {\n"
"}\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Async Copies and prefetch\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"#define BODY(SRC_STRIDE, DST_STRIDE) \\\n"
"  uint size = get_local_size(2) * get_local_size(1) * get_local_size(0); \\\n"
"  uint count = num / size;  \\\n"
"  uint offset = get_local_id(2) * get_local_size(1) + get_local_id(1);  \\\n"
"  offset = offset * get_local_size(0) + get_local_id(0); \\\n"
"  for(uint i=0; i<count; i+=1) { \\\n"
"    *(dst + offset * DST_STRIDE) = *(src + offset * SRC_STRIDE); \\\n"
"    offset += size;                                 \\\n"
"  } \\\n"
"  if(offset < num) \\\n"
"    *(dst + offset * DST_STRIDE) = *(src + offset * SRC_STRIDE); \\\n"
"  return 0;\n"
"\n"
"#define DEFN(TYPE) \\\n"
"INLINE_OVERLOADABLE event_t async_work_group_copy (local TYPE *dst,  const global TYPE *src, \\\n"
"										    size_t num, event_t event) { \\\n"
"  BODY(1, 1); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE event_t async_work_group_copy (global TYPE *dst,  const local TYPE *src, \\\n"
"										    size_t num, event_t event) { \\\n"
"  BODY(1, 1); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE event_t async_work_group_strided_copy (local TYPE *dst,  const global TYPE *src, \\\n"
"										            size_t num, size_t src_stride, event_t event) { \\\n"
"  BODY(src_stride, 1); \\\n"
"} \\\n"
"INLINE_OVERLOADABLE event_t async_work_group_strided_copy (global TYPE *dst,  const local TYPE *src, \\\n"
"										            size_t num, size_t dst_stride, event_t event) { \\\n"
"  BODY(1, dst_stride); \\\n"
"}\n"
"#define DEF(TYPE) \\\n"
"  DEFN(TYPE); DEFN(TYPE##2); DEFN(TYPE##3); DEFN(TYPE##4); DEFN(TYPE##8); DEFN(TYPE##16);\n"
"DEF(char)\n"
"DEF(uchar)\n"
"DEF(short)\n"
"DEF(ushort)\n"
"DEF(int)\n"
"DEF(uint)\n"
"DEF(long)\n"
"DEF(ulong)\n"
"DEF(float)\n"
"DEF(double)\n"
"#undef BODY\n"
"#undef DEFN\n"
"#undef DEF\n"
"\n"
"INLINE void wait_group_events (int num_events, event_t *event_list) {\n"
"  barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);\n"
"}\n"
"\n"
"#define DEFN(TYPE) \\\n"
"INLINE_OVERLOADABLE void prefetch(const global TYPE *p, size_t num) { }\n"
"#define DEF(TYPE) \\\n"
"DEFN(TYPE); DEFN(TYPE##2); DEFN(TYPE##3); DEFN(TYPE##4); DEFN(TYPE##8); DEFN(TYPE##16)\n"
"DEF(char);\n"
"DEF(uchar);\n"
"DEF(short);\n"
"DEF(ushort);\n"
"DEF(int);\n"
"DEF(uint);\n"
"DEF(long);\n"
"DEF(ulong);\n"
"DEF(float);\n"
"#undef DEFN\n"
"#undef DEF\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Atomic functions\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"OVERLOADABLE uint __gen_ocl_atomic_add(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_add(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_sub(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_sub(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_and(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_and(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_or(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_or(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_xor(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_xor(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_xchg(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_xchg(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_inc(__global uint *p);\n"
"OVERLOADABLE uint __gen_ocl_atomic_inc(__local uint *p);\n"
"OVERLOADABLE uint __gen_ocl_atomic_dec(__global uint *p);\n"
"OVERLOADABLE uint __gen_ocl_atomic_dec(__local uint *p);\n"
"OVERLOADABLE uint __gen_ocl_atomic_cmpxchg(__global uint *p, uint cmp, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_cmpxchg(__local uint *p, uint cmp, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_imin(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_imin(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_imax(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_imax(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_umin(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_umin(__local uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_umax(__global uint *p, uint val);\n"
"OVERLOADABLE uint __gen_ocl_atomic_umax(__local uint *p, uint val);\n"
"\n"
"#define DECL_ATOMIC_OP_SPACE(NAME, TYPE, SPACE, PREFIX)                        \\\n"
"  INLINE_OVERLOADABLE TYPE atomic_##NAME (volatile SPACE TYPE *p, TYPE val) { \\\n"
"    return (TYPE)__gen_ocl_##PREFIX##NAME((SPACE uint *)p, val);            \\\n"
"  }\n"
"\n"
"#define DECL_ATOMIC_OP_TYPE(NAME, TYPE, PREFIX) \\\n"
"  DECL_ATOMIC_OP_SPACE(NAME, TYPE, __global, PREFIX) \\\n"
"  DECL_ATOMIC_OP_SPACE(NAME, TYPE, __local, PREFIX)\n"
"\n"
"#define DECL_ATOMIC_OP(NAME) \\\n"
"  DECL_ATOMIC_OP_TYPE(NAME, uint, atomic_)        \\\n"
"  DECL_ATOMIC_OP_TYPE(NAME, int, atomic_)\n"
"\n"
"DECL_ATOMIC_OP(add)\n"
"DECL_ATOMIC_OP(sub)\n"
"DECL_ATOMIC_OP(and)\n"
"DECL_ATOMIC_OP(or)\n"
"DECL_ATOMIC_OP(xor)\n"
"DECL_ATOMIC_OP(xchg)\n"
"DECL_ATOMIC_OP_TYPE(min, int, atomic_i)\n"
"DECL_ATOMIC_OP_TYPE(max, int, atomic_i)\n"
"DECL_ATOMIC_OP_TYPE(min, uint, atomic_u)\n"
"DECL_ATOMIC_OP_TYPE(max, uint, atomic_u)\n"
"\n"
"#undef DECL_ATOMIC_OP_SPACE\n"
"\n"
"#define DECL_ATOMIC_OP_SPACE(NAME, TYPE, SPACE, PREFIX)                        \\\n"
"  INLINE_OVERLOADABLE TYPE atomic_##NAME (volatile SPACE TYPE *p, TYPE val) { \\\n"
"    return as_float(__gen_ocl_##PREFIX##NAME((SPACE uint *)p, as_uint(val))); \\\n"
"  }\n"
"DECL_ATOMIC_OP_SPACE(xchg, float, __global, atomic_)\n"
"DECL_ATOMIC_OP_SPACE(xchg, float, __local, atomic_)\n"
"\n"
"#undef DECL_ATOMIC_OP\n"
"#undef DECL_ATOMIC_OP_TYPE\n"
"#undef DECL_ATOMIC_OP_SPACE\n"
"\n"
"#define DECL_ATOMIC_OP_SPACE(NAME, TYPE, SPACE) \\\n"
"  INLINE_OVERLOADABLE TYPE atomic_##NAME (volatile SPACE TYPE *p) { \\\n"
"    return (TYPE)__gen_ocl_atomic_##NAME((SPACE uint *)p); \\\n"
"  }\n"
"\n"
"#define DECL_ATOMIC_OP_TYPE(NAME, TYPE) \\\n"
"  DECL_ATOMIC_OP_SPACE(NAME, TYPE, __global) \\\n"
"  DECL_ATOMIC_OP_SPACE(NAME, TYPE, __local)\n"
"\n"
"#define DECL_ATOMIC_OP(NAME) \\\n"
"  DECL_ATOMIC_OP_TYPE(NAME, uint) \\\n"
"  DECL_ATOMIC_OP_TYPE(NAME, int)\n"
"\n"
"DECL_ATOMIC_OP(inc)\n"
"DECL_ATOMIC_OP(dec)\n"
"\n"
"#undef DECL_ATOMIC_OP\n"
"#undef DECL_ATOMIC_OP_TYPE\n"
"#undef DECL_ATOMIC_OP_SPACE\n"
"\n"
"#define DECL_ATOMIC_OP_SPACE(NAME, TYPE, SPACE)  \\\n"
"  INLINE_OVERLOADABLE TYPE atomic_##NAME (volatile SPACE TYPE *p, TYPE cmp, TYPE val) { \\\n"
"    return (TYPE)__gen_ocl_atomic_##NAME((SPACE uint *)p, (uint)cmp, (uint)val); \\\n"
"  }\n"
"\n"
"#define DECL_ATOMIC_OP_TYPE(NAME, TYPE) \\\n"
"  DECL_ATOMIC_OP_SPACE(NAME, TYPE, __global) \\\n"
"  DECL_ATOMIC_OP_SPACE(NAME, TYPE, __local)\n"
"\n"
"#define DECL_ATOMIC_OP(NAME) \\\n"
"  DECL_ATOMIC_OP_TYPE(NAME, uint) \\\n"
"  DECL_ATOMIC_OP_TYPE(NAME, int)\n"
"\n"
"DECL_ATOMIC_OP(cmpxchg)\n"
"\n"
"#undef DECL_ATOMIC_OP\n"
"#undef DECL_ATOMIC_OP_TYPE\n"
"#undef DECL_ATOMIC_OP_SPACE\n"
"\n"
"// XXX for conformance test\n"
"// The following atom_xxx api is on OpenCL spec 1.0.\n"
"// But the conformance test suite will test them anyway.\n"
"#define atom_add atomic_add\n"
"#define atom_sub atomic_sub\n"
"#define atom_and atomic_and\n"
"#define atom_or atomic_or\n"
"#define atom_xor atomic_xor\n"
"#define atom_xchg atomic_xchg\n"
"#define atom_min atomic_min\n"
"#define atom_max atomic_max\n"
"#define atom_inc atomic_inc\n"
"#define atom_dec atomic_dec\n"
"#define atom_cmpxchg atomic_cmpxchg\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Force the compilation to SIMD8 or SIMD16\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"\n"
"int __gen_ocl_force_simd8(void);\n"
"int __gen_ocl_force_simd16(void);\n"
"\n"
"#define NULL ((void*)0)\n"
"\n"
"// ##BEGIN_COMMON_DEFINES##\n"
"#ifndef __OCL_COMMON_DEFINES__\n"
"#define __OCL_COMMON_DEFINES__\n"
"//\n"
"// Common defines for Image intrinsics\n"
"// Channel order\n"
"#define CLK_HAS_ALPHA(color) (color == CLK_A || color == CLK_RA || color == CLK_RGBA || color == CLK_BGRA || color == CLK_ARGB)\n"
"enum {\n"
"  CLK_R = 0x10B0,\n"
"  CLK_A = 0x10B1,\n"
"  CLK_RG = 0x10B2,\n"
"  CLK_RA = 0x10B3,\n"
"  CLK_RGB = 0x10B4,\n"
"  CLK_RGBA = 0x10B5,\n"
"  CLK_BGRA = 0x10B6,\n"
"  CLK_ARGB = 0x10B7,\n"
"\n"
"#if (__NV_CL_C_VERSION == __NV_CL_C_VERSION_1_0)\n"
"  CLK_xRGB = 0x10B7,\n"
"#endif\n"
"\n"
"  CLK_INTENSITY = 0x10B8,\n"
"  CLK_LUMINANCE = 0x10B9\n"
"\n"
"#if (__NV_CL_C_VERSION >= __NV_CL_C_VERSION_1_1)\n"
"  ,\n"
"  CLK_Rx = 0x10BA,\n"
"  CLK_RGx = 0x10BB,\n"
"  CLK_RGBx = 0x10BC\n"
"#endif\n"
"};\n"
"\n"
"\n"
"typedef enum clk_channel_type {\n"
"  // valid formats for float return types\n"
"  CLK_SNORM_INT8 = 0x10D0,            // four channel RGBA unorm8\n"
"  CLK_SNORM_INT16 = 0x10D1,           // four channel RGBA unorm16\n"
"  CLK_UNORM_INT8 = 0x10D2,            // four channel RGBA unorm8\n"
"  CLK_UNORM_INT16 = 0x10D3,           // four channel RGBA unorm16\n"
"  CLK_HALF_FLOAT = 0x10DD,            // four channel RGBA half\n"
"  CLK_FLOAT = 0x10DE,                 // four channel RGBA float\n"
"\n"
"#if (__NV_CL_C_VERSION >= __NV_CL_C_VERSION_1_1)\n"
"  CLK_UNORM_SHORT_565 = 0x10D4,\n"
"  CLK_UNORM_SHORT_555 = 0x10D5,\n"
"  CLK_UNORM_INT_101010 = 0x10D6,\n"
"#endif\n"
"\n"
"  // valid only for integer return types\n"
"  CLK_SIGNED_INT8 =  0x10D7,\n"
"  CLK_SIGNED_INT16 = 0x10D8,\n"
"  CLK_SIGNED_INT32 = 0x10D9,\n"
"  CLK_UNSIGNED_INT8 = 0x10DA,\n"
"  CLK_UNSIGNED_INT16 = 0x10DB,\n"
"  CLK_UNSIGNED_INT32 = 0x10DC,\n"
"\n"
"  // CI SPI for CPU\n"
"  __CLK_UNORM_INT8888 ,         // four channel ARGB unorm8\n"
"  __CLK_UNORM_INT8888R,        // four channel BGRA unorm8\n"
"\n"
"  __CLK_VALID_IMAGE_TYPE_COUNT,\n"
"  __CLK_INVALID_IMAGE_TYPE = __CLK_VALID_IMAGE_TYPE_COUNT,\n"
"  __CLK_VALID_IMAGE_TYPE_MASK_BITS = 4,         // number of bits required to\n"
"                                                // represent any image type\n"
"  __CLK_VALID_IMAGE_TYPE_MASK = ( 1 << __CLK_VALID_IMAGE_TYPE_MASK_BITS ) - 1\n"
"}clk_channel_type;\n"
"\n"
"typedef enum clk_sampler_type {\n"
"    __CLK_ADDRESS_BASE             = 0,\n"
"    CLK_ADDRESS_NONE               = (0 << __CLK_ADDRESS_BASE),\n"
"    CLK_ADDRESS_CLAMP              = (1 << __CLK_ADDRESS_BASE),\n"
"    CLK_ADDRESS_CLAMP_TO_EDGE      = (2 << __CLK_ADDRESS_BASE),\n"
"    CLK_ADDRESS_REPEAT             = (3 << __CLK_ADDRESS_BASE),\n"
"    CLK_ADDRESS_MIRROR             = (4 << __CLK_ADDRESS_BASE),\n"
"\n"
"#if (__NV_CL_C_VERSION >= __NV_CL_C_VERSION_1_1)\n"
"    CLK_ADDRESS_MIRRORED_REPEAT    = CLK_ADDRESS_MIRROR,\n"
"#endif\n"
"    __CLK_ADDRESS_MASK             = (CLK_ADDRESS_NONE | CLK_ADDRESS_CLAMP |\n"
"                                     CLK_ADDRESS_CLAMP_TO_EDGE |\n"
"                                     CLK_ADDRESS_REPEAT | CLK_ADDRESS_MIRROR),\n"
"    __CLK_ADDRESS_BITS             = 3,        // number of bits required to\n"
"                                               // represent address info\n"
"\n"
"    __CLK_NORMALIZED_BASE          = __CLK_ADDRESS_BITS,\n"
"    CLK_NORMALIZED_COORDS_FALSE    = 0,\n"
"    CLK_NORMALIZED_COORDS_TRUE     = (1 << __CLK_NORMALIZED_BASE),\n"
"    __CLK_NORMALIZED_MASK          = (CLK_NORMALIZED_COORDS_FALSE |\n"
"                                      CLK_NORMALIZED_COORDS_TRUE),\n"
"    __CLK_NORMALIZED_BITS          = 1,        // number of bits required to\n"
"                                               // represent normalization\n"
"    __CLK_FILTER_BASE              = (__CLK_NORMALIZED_BASE +  __CLK_NORMALIZED_BITS),\n"
"    CLK_FILTER_NEAREST             = (0 << __CLK_FILTER_BASE),\n"
"    CLK_FILTER_LINEAR              = (1 << __CLK_FILTER_BASE),\n"
"    CLK_FILTER_ANISOTROPIC         = (2 << __CLK_FILTER_BASE),\n"
"    __CLK_FILTER_MASK              = (CLK_FILTER_NEAREST | CLK_FILTER_LINEAR |\n"
"                                     CLK_FILTER_ANISOTROPIC),\n"
"    __CLK_FILTER_BITS              = 2,        // number of bits required to\n"
"                                               // represent address info\n"
"\n"
"    __CLK_MIP_BASE                 = (__CLK_FILTER_BASE + __CLK_FILTER_BITS),\n"
"    CLK_MIP_NEAREST                = (0 << __CLK_MIP_BASE),\n"
"    CLK_MIP_LINEAR                 = (1 << __CLK_MIP_BASE),\n"
"    CLK_MIP_ANISOTROPIC            = (2 << __CLK_MIP_BASE),\n"
"    __CLK_MIP_MASK                 = (CLK_MIP_NEAREST | CLK_MIP_LINEAR |\n"
"                                     CLK_MIP_ANISOTROPIC),\n"
"    __CLK_MIP_BITS                 = 2,\n"
"\n"
"    __CLK_SAMPLER_BITS             = (__CLK_MIP_BASE + __CLK_MIP_BITS),\n"
"    __CLK_SAMPLER_MASK             = (__CLK_MIP_MASK | __CLK_FILTER_MASK |\n"
"                                      __CLK_NORMALIZED_MASK | __CLK_ADDRESS_MASK),\n"
"\n"
"    __CLK_SAMPLER_ARG_BASE         = (__CLK_MIP_BASE + __CLK_SAMPLER_BITS),\n"
"    __CLK_SAMPLER_ARG_BITS         = 8,\n"
"    __CLK_SAMPLER_ARG_MASK         = (((1 << __CLK_SAMPLER_ARG_BITS) - 1) << __CLK_SAMPLER_ARG_BASE),\n"
"    __CLK_SAMPLER_ARG_KEY_BIT      = (1 << (__CLK_SAMPLER_ARG_BASE + __CLK_SAMPLER_ARG_BITS)),\n"
"    __CLK_SAMPLER_ARG_KEY_BITS     = 1,\n"
"\n"
"} clk_sampler_type;\n"
"\n"
"// Memory synchronization\n"
"#define CLK_LOCAL_MEM_FENCE     (1 << 0)\n"
"#define CLK_GLOBAL_MEM_FENCE    (1 << 1)\n"
"\n"
"#endif   /* __OCL_COMMON_DEFINES__ */// ##END_COMMON_DEFINES##\n"
"\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"// Image access functions\n"
"/////////////////////////////////////////////////////////////////////////////\n"
"\n"
"// 1D read\n"
"OVERLOADABLE int4 __gen_ocl_read_imagei(uint surface_id, sampler_t sampler, float u, uint sampler_offset);\n"
"OVERLOADABLE int4 __gen_ocl_read_imagei(uint surface_id, sampler_t sampler, int u, uint sampler_offset);\n"
"OVERLOADABLE uint4 __gen_ocl_read_imageui(uint surface_id, sampler_t sampler, float u, uint sampler_offset);\n"
"OVERLOADABLE uint4 __gen_ocl_read_imageui(uint surface_id, sampler_t sampler, int u, uint sampler_offset);\n"
"OVERLOADABLE float4 __gen_ocl_read_imagef(uint surface_id, sampler_t sampler, float u, uint sampler_offset);\n"
"OVERLOADABLE float4 __gen_ocl_read_imagef(uint surface_id, sampler_t sampler, int u, uint sampler_offset);\n"
"\n"
"// 2D & 1D Array read\n"
"OVERLOADABLE int4 __gen_ocl_read_imagei(uint surface_id, sampler_t sampler, float u, float v, uint sampler_offset);\n"
"OVERLOADABLE int4 __gen_ocl_read_imagei(uint surface_id, sampler_t sampler, int u, int v, uint sampler_offset);\n"
"OVERLOADABLE uint4 __gen_ocl_read_imageui(uint surface_id, sampler_t sampler, float u, float v, uint sampler_offset);\n"
"OVERLOADABLE uint4 __gen_ocl_read_imageui(uint surface_id, sampler_t sampler, int u, int v, uint sampler_offset);\n"
"OVERLOADABLE float4 __gen_ocl_read_imagef(uint surface_id, sampler_t sampler, float u, float v, uint sampler_offset);\n"
"OVERLOADABLE float4 __gen_ocl_read_imagef(uint surface_id, sampler_t sampler, int u, int v, uint sampler_offset);\n"
"\n"
"// 3D & 2D Array read\n"
"OVERLOADABLE int4 __gen_ocl_read_imagei(uint surface_id, sampler_t sampler, float u, float v, float w, uint sampler_offset);\n"
"OVERLOADABLE int4 __gen_ocl_read_imagei(uint surface_id, sampler_t sampler, int u, int v, int w, uint sampler_offset);\n"
"OVERLOADABLE uint4 __gen_ocl_read_imageui(uint surface_id, sampler_t sampler, float u, float v, float w, uint sampler_offset);\n"
"OVERLOADABLE uint4 __gen_ocl_read_imageui(uint surface_id, sampler_t sampler, int u, int v, int w, uint sampler_offset);\n"
"OVERLOADABLE float4 __gen_ocl_read_imagef(uint surface_id, sampler_t sampler, float u, float v, float w, uint sampler_offset);\n"
"OVERLOADABLE float4 __gen_ocl_read_imagef(uint surface_id, sampler_t sampler, int u, int v, int w, uint sampler_offset);\n"
"\n"
"// 1D write\n"
"OVERLOADABLE void __gen_ocl_write_imagei(uint surface_id, int u, int4 color);\n"
"OVERLOADABLE void __gen_ocl_write_imageui(uint surface_id, int u, uint4 color);\n"
"OVERLOADABLE void __gen_ocl_write_imagef(uint surface_id, int u, float4 color);\n"
"\n"
"// 2D & 1D Array write\n"
"OVERLOADABLE void __gen_ocl_write_imagei(uint surface_id, int u, int v, int4 color);\n"
"OVERLOADABLE void __gen_ocl_write_imageui(uint surface_id, int u, int v, uint4 color);\n"
"OVERLOADABLE void __gen_ocl_write_imagef(uint surface_id, int u, int v, float4 color);\n"
"\n"
"// 3D & 2D Array write\n"
"OVERLOADABLE void __gen_ocl_write_imagei(uint surface_id, int u, int v, int w, int4 color);\n"
"OVERLOADABLE void __gen_ocl_write_imageui(uint surface_id, int u, int v, int w, uint4 color);\n"
"OVERLOADABLE void __gen_ocl_write_imagef(uint surface_id, int u, int v, int w, float4 color);\n"
"\n"
"int __gen_ocl_get_image_width(uint surface_id);\n"
"int __gen_ocl_get_image_height(uint surface_id);\n"
"int __gen_ocl_get_image_channel_data_type(uint surface_id);\n"
"int __gen_ocl_get_image_channel_order(uint surface_id);\n"
"int __gen_ocl_get_image_depth(uint surface_id);\n"
"/* The printf function. */\n"
"/* From LLVM 3.4, c string are all in constant address space */\n"
"#if 100*__clang_major__ + __clang_minor__ < 304\n"
"int __gen_ocl_printf_stub(const char * format, ...);\n"
"#else\n"
"int __gen_ocl_printf_stub(constant char * format, ...);\n"
"#endif\n"
"#define printf __gen_ocl_printf_stub\n"
"\n"
"// 2D 3D Image Common Macro\n"
"#ifdef GEN7_SAMPLER_CLAMP_BORDER_WORKAROUND\n"
"#define GEN_FIX_1 1\n"
"#else\n"
"#define GEN_FIX_1 0\n"
"#endif\n"
"\n"
"#define GET_IMAGE(cl_image, surface_id) \\\n"
"    uint surface_id = (uint)cl_image\n"
"INLINE_OVERLOADABLE float __gen_compute_array_index(const float index, image1d_array_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  float array_size = __gen_ocl_get_image_depth(surface_id);\n"
"  return clamp(rint(index), 0.f, array_size - 1.f);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_compute_array_index(float index, image2d_array_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  float array_size = __gen_ocl_get_image_depth(surface_id);\n"
"  return clamp(rint(index), 0.f, array_size - 1.f);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE int __gen_compute_array_index(int index, image1d_array_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  int array_size = __gen_ocl_get_image_depth(surface_id);\n"
"  return clamp(index, 0, array_size - 1);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE int __gen_compute_array_index(int index, image2d_array_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  int array_size = __gen_ocl_get_image_depth(surface_id);\n"
"  return clamp(index, 0, array_size - 1);\n"
"}\n"
"\n"
"#define DECL_READ_IMAGE0(int_clamping_fix,                                   \\\n"
"                        image_type, type, suffix, coord_type, n)             \\\n"
"  INLINE_OVERLOADABLE type read_image ##suffix(image_type cl_image,          \\\n"
"                                               const sampler_t sampler,      \\\n"
"                                               coord_type coord)             \\\n"
"  {                                                                          \\\n"
"    GET_IMAGE(cl_image, surface_id);                                         \\\n"
"    GET_IMAGE_ARRAY_SIZE(cl_image, coord, int, ai);                          \\\n"
"    if (int_clamping_fix &&                                                  \\\n"
"        ((sampler & __CLK_ADDRESS_MASK) == CLK_ADDRESS_CLAMP) &&             \\\n"
"        ((sampler & __CLK_FILTER_MASK) == CLK_FILTER_NEAREST))               \\\n"
"            return   __gen_ocl_read_image ##suffix(                          \\\n"
"                        EXPEND_READ_COORD(surface_id, sampler, coord));      \\\n"
"    return  __gen_ocl_read_image ##suffix(                                   \\\n"
"                    EXPEND_READ_COORDF(surface_id, sampler, coord), 0);      \\\n"
"  }\n"
"\n"
"#define DECL_READ_IMAGE1(float_coord_rounding_fix, int_clamping_fix,         \\\n"
"                        image_type, type, suffix, coord_type, n)             \\\n"
"  INLINE_OVERLOADABLE type read_image ##suffix(image_type cl_image,          \\\n"
"                                               const sampler_t sampler,      \\\n"
"                                               coord_type coord)             \\\n"
"  {                                                                          \\\n"
"    GET_IMAGE(cl_image, surface_id);                                         \\\n"
"    GET_IMAGE_ARRAY_SIZE(cl_image, coord, float, ai)                         \\\n"
"    coord_type tmpCoord = coord;                                             \\\n"
"    if (float_coord_rounding_fix | int_clamping_fix) {                       \\\n"
"      if (((sampler & __CLK_ADDRESS_MASK) == CLK_ADDRESS_CLAMP)              \\\n"
"          && ((sampler & __CLK_FILTER_MASK) == CLK_FILTER_NEAREST)) {        \\\n"
"        if (float_coord_rounding_fix                                         \\\n"
"            && ((sampler & CLK_NORMALIZED_COORDS_TRUE) == 0)) {              \\\n"
"          FIXUP_FLOAT_COORD(tmpCoord);                                       \\\n"
"        }                                                                    \\\n"
"        if (int_clamping_fix) {                                              \\\n"
"            coord_type intCoord;                                             \\\n"
"            if (sampler & CLK_NORMALIZED_COORDS_TRUE) {                      \\\n"
"              DENORMALIZE_COORD(surface_id, intCoord, tmpCoord);             \\\n"
"            } else                                                           \\\n"
"              intCoord = tmpCoord;                                           \\\n"
"            return   __gen_ocl_read_image ##suffix(                          \\\n"
"                       EXPEND_READ_COORDI(surface_id, sampler, intCoord));\\\n"
"       }                                                                     \\\n"
"      }                                                                      \\\n"
"    }                                                                        \\\n"
"    return  __gen_ocl_read_image ##suffix(                                   \\\n"
"                        EXPEND_READ_COORDF(surface_id, sampler, tmpCoord), 0);\\\n"
"  }\n"
"\n"
"#define DECL_READ_IMAGE_NOSAMPLER(image_type, type, suffix, coord_type, n)   \\\n"
"  INLINE_OVERLOADABLE type read_image ##suffix(image_type cl_image,          \\\n"
"                                               coord_type coord)             \\\n"
"  {                                                                          \\\n"
"    GET_IMAGE(cl_image, surface_id);                                         \\\n"
"    GET_IMAGE_ARRAY_SIZE(cl_image, coord, int, ai)                           \\\n"
"    return __gen_ocl_read_image ##suffix(                                    \\\n"
"           EXPEND_READ_COORDF(surface_id,                                    \\\n"
"                             CLK_NORMALIZED_COORDS_FALSE                     \\\n"
"                             | CLK_ADDRESS_NONE                              \\\n"
"                             | CLK_FILTER_NEAREST, (float)coord), 0);        \\\n"
"  }\n"
"\n"
"#define DECL_WRITE_IMAGE(image_type, type, suffix, coord_type) \\\n"
"  INLINE_OVERLOADABLE void write_image ##suffix(image_type cl_image, coord_type coord, type color)\\\n"
"  {\\\n"
"    GET_IMAGE(cl_image, surface_id);\\\n"
"    __gen_ocl_write_image ##suffix(EXPEND_WRITE_COORD(surface_id, coord, color));\\\n"
"  }\n"
"\n"
"#define DECL_IMAGE_INFO_COMMON(image_type)    \\\n"
"  INLINE_OVERLOADABLE  int get_image_channel_data_type(image_type image)\\\n"
"  { \\\n"
"    GET_IMAGE(image, surface_id);\\\n"
"    return __gen_ocl_get_image_channel_data_type(surface_id); \\\n"
"  }\\\n"
"  INLINE_OVERLOADABLE  int get_image_channel_order(image_type image)\\\n"
"  { \\\n"
"    GET_IMAGE(image, surface_id);\\\n"
"    return __gen_ocl_get_image_channel_order(surface_id); \\\n"
"  } \\\n"
"  INLINE_OVERLOADABLE int get_image_width(image_type image) \\\n"
"  { \\\n"
"    GET_IMAGE(image, surface_id); \\\n"
"    return __gen_ocl_get_image_width(surface_id);  \\\n"
"  }\n"
"\n"
"// 1D\n"
"#define DECL_IMAGE(int_clamping_fix, image_type, type, suffix)                       \\\n"
"  DECL_READ_IMAGE0(int_clamping_fix, image_type, type, suffix, int, 1)               \\\n"
"  DECL_READ_IMAGE1(GEN_FIX_1, int_clamping_fix, image_type, type, suffix, float, 1)  \\\n"
"  DECL_READ_IMAGE_NOSAMPLER(image_type, type, suffix, int, 1)                        \\\n"
"  DECL_WRITE_IMAGE(image_type, type, suffix, int)                                    \\\n"
"  DECL_WRITE_IMAGE(image_type, type, suffix, float)\n"
"\n"
"#define EXPEND_READ_COORD(id, sampler, coord) id, sampler, coord, 1\n"
"#define EXPEND_READ_COORDF(id, sampler, coord) id, sampler, (float)coord\n"
"#define EXPEND_READ_COORDI(id, sampler, coord) id, sampler, (int)(coord < 0 ? -1 : coord), 1\n"
"#define DENORMALIZE_COORD(id, dstCoord, srcCoord) dstCoord = srcCoord * __gen_ocl_get_image_width(id);\n"
"#define EXPEND_WRITE_COORD(id, coord, color) id, coord, color\n"
"#define GET_IMAGE_ARRAY_SIZE(a,b,c,d)\n"
"\n"
"#define FIXUP_FLOAT_COORD(tmpCoord)                            \\\n"
"  {                                                            \\\n"
"    if (tmpCoord < 0 && tmpCoord > -0x1p-20f)                  \\\n"
"      tmpCoord += -0x1p-9;                                     \\\n"
"  }\n"
"\n"
"DECL_IMAGE(GEN_FIX_1, image1d_t, int4, i)\n"
"DECL_IMAGE(GEN_FIX_1, image1d_t, uint4, ui)\n"
"DECL_IMAGE(0, image1d_t, float4, f)\n"
"DECL_IMAGE(GEN_FIX_1, image1d_buffer_t, int4, i)\n"
"DECL_IMAGE(GEN_FIX_1, image1d_buffer_t, uint4, ui)\n"
"DECL_IMAGE(0, image1d_buffer_t, float4, f)\n"
"\n"
"// 1D Info\n"
"DECL_IMAGE_INFO_COMMON(image1d_t)\n"
"DECL_IMAGE_INFO_COMMON(image1d_buffer_t)\n"
"\n"
"#undef EXPEND_READ_COORD\n"
"#undef EXPEND_READ_COORDF\n"
"#undef EXPEND_READ_COORDI\n"
"#undef DENORMALIZE_COORD\n"
"#undef EXPEND_WRITE_COORD\n"
"#undef FIXUP_FLOAT_COORD\n"
"#undef DECL_IMAGE\n"
"// End of 1D\n"
"\n"
"#define DECL_IMAGE(int_clamping_fix, image_type, type, suffix, n)                       \\\n"
"  DECL_READ_IMAGE0(int_clamping_fix, image_type, type, suffix, int ##n, n)              \\\n"
"  DECL_READ_IMAGE1(GEN_FIX_1, int_clamping_fix, image_type, type, suffix, float ##n, n) \\\n"
"  DECL_READ_IMAGE_NOSAMPLER(image_type, type, suffix, int ##n, n)                       \\\n"
"  DECL_WRITE_IMAGE(image_type, type, suffix, int ## n)                                  \\\n"
"  DECL_WRITE_IMAGE(image_type, type, suffix, float ## n)\n"
"// 2D\n"
"#define EXPEND_READ_COORD(id, sampler, coord) id, sampler, coord.s0, coord.s1, 1\n"
"#define EXPEND_READ_COORDF(id, sampler, coord) id, sampler, (float)coord.s0, (float)coord.s1\n"
"#define EXPEND_READ_COORDI(id, sampler, coord) id, sampler, (int)(coord.s0 < 0 ? -1 : coord.s0), \\\n"
"                                               (int)(coord.s1 < 0 ? -1 : coord.s1), 1\n"
"#define DENORMALIZE_COORD(id, dstCoord, srcCoord) dstCoord.x = srcCoord.x * __gen_ocl_get_image_width(id); \\\n"
"                                                  dstCoord.y = srcCoord.y * __gen_ocl_get_image_height(id);\n"
"#define EXPEND_WRITE_COORD(id, coord, color) id, coord.s0, coord.s1, color\n"
"\n"
"#define FIXUP_FLOAT_COORD(tmpCoord)                            \\\n"
"  {                                                            \\\n"
"    if (tmpCoord.s0 < 0 && tmpCoord.s0 > -0x1p-20f)            \\\n"
"      tmpCoord.s0 += -0x1p-9;                                  \\\n"
"    if (tmpCoord.s1 < 0 && tmpCoord.s1 > -0x1p-20f)            \\\n"
"      tmpCoord.s1 += -0x1p-9f;                                 \\\n"
"  }\n"
"\n"
"DECL_IMAGE(GEN_FIX_1, image2d_t, int4, i, 2)\n"
"DECL_IMAGE(GEN_FIX_1, image2d_t, uint4, ui, 2)\n"
"DECL_IMAGE(0, image2d_t, float4, f, 2)\n"
"\n"
"// 1D Array\n"
"#undef GET_IMAGE_ARRAY_SIZE\n"
"#undef EXPEND_READ_COORD\n"
"#undef EXPEND_READ_COORDF\n"
"#undef EXPEND_READ_COORDI\n"
"#undef DENORMALIZE_COORD\n"
"#undef EXPEND_WRITE_COORD\n"
"#undef FIXUP_FLOAT_COORD\n"
"\n"
"#define EXPEND_READ_COORD(id, sampler, coord) id, sampler, coord.s0, (int)0, ai, 2\n"
"#define EXPEND_READ_COORDF(id, sampler, coord) id, sampler, (float)coord.s0, (float)ai\n"
"#define EXPEND_READ_COORDI(id, sampler, coord) id, sampler, (int)(coord.s0 < 0 ? -1 : coord.s0), 0, (int)ai, 2\n"
"#define DENORMALIZE_COORD(id, dstCoord, srcCoord) dstCoord.x = srcCoord.x * __gen_ocl_get_image_width(id);\n"
"#define EXPEND_WRITE_COORD(id, coord, color) id, coord.s0, __gen_compute_array_index(coord.s1, cl_image), color\n"
"#define GET_IMAGE_ARRAY_SIZE(image, coord, coord_type, ai) \\\n"
"  coord_type ai = __gen_compute_array_index(coord.s1, image);\n"
"\n"
"#define FIXUP_FLOAT_COORD(tmpCoord)                            \\\n"
"  {                                                            \\\n"
"    if (tmpCoord.s0 < 0 && tmpCoord.s0 > -0x1p-20f)            \\\n"
"      tmpCoord.s0 += -0x1p-9;                                  \\\n"
"  }\n"
"\n"
"DECL_IMAGE(GEN_FIX_1, image1d_array_t, int4, i, 2)\n"
"DECL_IMAGE(GEN_FIX_1, image1d_array_t, uint4, ui, 2)\n"
"DECL_IMAGE(0, image1d_array_t, float4, f, 2)\n"
"\n"
"// 2D Info\n"
"DECL_IMAGE_INFO_COMMON(image2d_t)\n"
"INLINE_OVERLOADABLE int get_image_height(image2d_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  return __gen_ocl_get_image_height(surface_id);\n"
"}\n"
"INLINE_OVERLOADABLE int2 get_image_dim(image2d_t image)\n"
"{\n"
"  return (int2){get_image_width(image), get_image_height(image)};\n"
"}\n"
"\n"
"// 1D Array info\n"
"DECL_IMAGE_INFO_COMMON(image1d_array_t)\n"
"INLINE_OVERLOADABLE size_t get_image_array_size(image1d_array_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  return __gen_ocl_get_image_depth(surface_id);\n"
"}\n"
"\n"
"#undef EXPEND_READ_COORD\n"
"#undef EXPEND_READ_COORDI\n"
"#undef EXPEND_READ_COORDF\n"
"#undef DENORMALIZE_COORD\n"
"#undef EXPEND_WRITE_COORD\n"
"#undef FIXUP_FLOAT_COORD\n"
"#undef GET_IMAGE_ARRAY_SIZE\n"
"// End of 2D and 1D Array\n"
"\n"
"// 3D\n"
"#define EXPEND_READ_COORD(id, sampler, coord) id, sampler, coord.s0, coord.s1, coord.s2, 1\n"
"#define EXPEND_READ_COORDF(id, sampler, coord) id, sampler, (float)coord.s0, (float)coord.s1, (float)coord.s2\n"
"#define EXPEND_READ_COORDI(id, sampler, coord) id, sampler, (int) (coord.s0 < 0 ? -1 : coord.s0), \\\n"
"                                               (int)(coord.s1 < 0 ? -1 : coord.s1), (int)(coord.s2 < 0 ? -1 : coord.s2), 1\n"
"#define DENORMALIZE_COORD(id, dstCoord, srcCoord) dstCoord.x = srcCoord.x * __gen_ocl_get_image_width(id); \\\n"
"                                                  dstCoord.y = srcCoord.y * __gen_ocl_get_image_height(id); \\\n"
"                                                  dstCoord.z = srcCoord.z * __gen_ocl_get_image_depth(id);\n"
"#define EXPEND_WRITE_COORD(id, coord, color) id, coord.s0, coord.s1, coord.s2, color\n"
"\n"
"#define FIXUP_FLOAT_COORD(tmpCoord)                             \\\n"
"  {                                                             \\\n"
"    if (tmpCoord.s0 < 0 && tmpCoord.s0 > -0x1p-20)              \\\n"
"      tmpCoord.s0 += -0x1p-9;                                   \\\n"
"    if (tmpCoord.s1 < 0 && tmpCoord.s1 > -0x1p-20)              \\\n"
"      tmpCoord.s1 += -0x1p-9;                                   \\\n"
"    if (tmpCoord.s2 < 0 && tmpCoord.s2 > -0x1p-20)              \\\n"
"      tmpCoord.s2 += -0x1p-9;                                   \\\n"
"  }\n"
"#define GET_IMAGE_ARRAY_SIZE(a,b,c,d)\n"
"\n"
"DECL_IMAGE(GEN_FIX_1, image3d_t, int4, i, 4)\n"
"DECL_IMAGE(GEN_FIX_1, image3d_t, uint4, ui, 4)\n"
"DECL_IMAGE(0, image3d_t, float4, f, 4)\n"
"\n"
"DECL_IMAGE(GEN_FIX_1, image3d_t, int4, i, 3)\n"
"DECL_IMAGE(GEN_FIX_1, image3d_t, uint4, ui, 3)\n"
"DECL_IMAGE(0, image3d_t, float4, f, 3)\n"
"\n"
"#undef EXPEND_READ_COORD\n"
"#undef EXPEND_READ_COORDF\n"
"#undef EXPEND_READ_COORDI\n"
"#undef DENORMALIZE_COORD\n"
"#undef EXPEND_WRITE_COORD\n"
"#undef FIXUP_FLOAT_COORD\n"
"#undef GET_IMAGE_ARRAY_SIZE\n"
"\n"
"#define EXPEND_READ_COORD(id, sampler, coord) id, sampler, coord.s0, coord.s1, ai, 1\n"
"#define EXPEND_READ_COORDF(id, sampler, coord) id, sampler, (float)coord.s0, (float)coord.s1, (float)ai\n"
"#define EXPEND_READ_COORDI(id, sampler, coord) id, sampler, (int) (coord.s0 < 0 ? -1 : coord.s0), \\\n"
"                                               (int)(coord.s1 < 0 ? -1 : coord.s1), (int)ai, 1\n"
"#define DENORMALIZE_COORD(id, dstCoord, srcCoord) dstCoord.x = srcCoord.x * __gen_ocl_get_image_width(id); \\\n"
"                                                  dstCoord.y = srcCoord.y * __gen_ocl_get_image_height(id);\n"
"#define EXPEND_WRITE_COORD(id, coord, color) id, coord.s0, coord.s1, __gen_compute_array_index(coord.s2, cl_image), color\n"
"\n"
"#define FIXUP_FLOAT_COORD(tmpCoord)                             \\\n"
"  {                                                             \\\n"
"    if (tmpCoord.s0 < 0 && tmpCoord.s0 > -0x1p-20)              \\\n"
"      tmpCoord.s0 += -0x1p-9;                                   \\\n"
"    if (tmpCoord.s1 < 0 && tmpCoord.s1 > -0x1p-20)              \\\n"
"      tmpCoord.s1 += -0x1p-9;                                   \\\n"
"  }\n"
"#define GET_IMAGE_ARRAY_SIZE(image, coord, coord_type, ai) \\\n"
"  coord_type ai = __gen_compute_array_index(coord.s2, image);\n"
"\n"
"// 2D Array\n"
"DECL_IMAGE(GEN_FIX_1, image2d_array_t, int4, i, 4)\n"
"DECL_IMAGE(GEN_FIX_1, image2d_array_t, uint4, ui, 4)\n"
"DECL_IMAGE(0, image2d_array_t, float4, f, 4)\n"
"\n"
"DECL_IMAGE(GEN_FIX_1, image2d_array_t, int4, i, 3)\n"
"DECL_IMAGE(GEN_FIX_1, image2d_array_t, uint4, ui, 3)\n"
"DECL_IMAGE(0, image2d_array_t, float4, f, 3)\n"
"\n"
"// 3D Info\n"
"DECL_IMAGE_INFO_COMMON(image3d_t)\n"
"INLINE_OVERLOADABLE int get_image_height(image3d_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  return __gen_ocl_get_image_height(surface_id);\n"
"}\n"
"INLINE_OVERLOADABLE int get_image_depth(image3d_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  return __gen_ocl_get_image_depth(surface_id);\n"
"}\n"
"INLINE_OVERLOADABLE int4 get_image_dim(image3d_t image)\n"
"{\n"
"  return (int4){get_image_width(image), get_image_height(image), get_image_depth(image), 0};\n"
"}\n"
"\n"
"// 2D Array Info\n"
"DECL_IMAGE_INFO_COMMON(image2d_array_t)\n"
"INLINE_OVERLOADABLE int get_image_height(image2d_array_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  return __gen_ocl_get_image_height(surface_id);\n"
"}\n"
"INLINE_OVERLOADABLE int2 get_image_dim(image2d_array_t image)\n"
"{\n"
"  return (int2){get_image_width(image), get_image_height(image)};\n"
"}\n"
"INLINE_OVERLOADABLE size_t get_image_array_size(image2d_array_t image)\n"
"{\n"
"  GET_IMAGE(image, surface_id);\n"
"  return __gen_ocl_get_image_depth(surface_id);\n"
"}\n"
"\n"
"#undef EXPEND_READ_COORD\n"
"#undef EXPEND_READ_COORDF\n"
"#undef EXPEND_READ_COORDI\n"
"#undef DENORMALIZE_COORD\n"
"#undef EXPEND_WRITE_COORD\n"
"#undef FIXUP_FLOAT_COORD\n"
"#undef GET_IMAGE_ARRAY_SIZE\n"
"// End of 3D and 2D Array\n"
"\n"
"#undef DECL_IMAGE\n"
"#undef DECL_READ_IMAGE\n"
"#undef DECL_READ_IMAGE_NOSAMPLER\n"
"#undef DECL_WRITE_IMAGE\n"
"#undef GEN_FIX_1\n"
"// End of Image\n"
"\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_acosh (float x)\n"
"{\n"
"    return native_log(x + native_sqrt(x + 1) * native_sqrt(x - 1));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_asinh (float x)\n"
"{\n"
"    return native_log(x + native_sqrt(x * x + 1));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_atanh (float x)\n"
"{\n"
"    return 0.5f * native_log((1 + x) / (1 - x));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_cbrt (float x)\n"
"{\n"
"    return __gen_ocl_pow(x, 0.3333333333f);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_cos (float x)\n"
"{\n"
"    return native_cos(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_cosh (float x)\n"
"{\n"
"    return (1 + native_exp(-2 * x)) / (2 * native_exp(-x));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_cospi (float x)\n"
"{\n"
"    return __gen_ocl_cos(x * M_PI_F);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_exp (float x)\n"
"{\n"
"    return native_exp(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_exp10 (float x)\n"
"{\n"
"    return native_exp10(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_expm1 (float x)\n"
"{\n"
"    return __gen_ocl_pow(M_E_F, x) - 1;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_fmod (float x, float y)\n"
"{\n"
"    return x-y*__gen_ocl_rndz(x/y);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_hypot (float x, float y)\n"
"{\n"
"    return __gen_ocl_sqrt(x*x + y*y);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE int __gen_ocl_internal_fastpath_ilogb (float x)\n"
"{\n"
"    return __gen_ocl_rndd(native_log2(x));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_ldexp (float x, int n)\n"
"{\n"
"    return __gen_ocl_pow(2, n) * x;\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_log (float x)\n"
"{\n"
"    return native_log(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_log2 (float x)\n"
"{\n"
"    return native_log2(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_log10 (float x)\n"
"{\n"
"    return native_log10(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_log1p (float x)\n"
"{\n"
"    return native_log(x + 1);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_logb (float x)\n"
"{\n"
"    return __gen_ocl_rndd(native_log2(x));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_remainder (float x, float y)\n"
"{\n"
"    return x-y*__gen_ocl_rnde(x/y);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_rootn(float x, int n)\n"
"{\n"
"    return __gen_ocl_pow(x, 1.f / n);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_sin (float x)\n"
"{\n"
"    return native_sin(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_sincos (float x, __global float *cosval)\n"
"{\n"
"    *cosval = native_cos(x);\n"
"    return native_sin(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_sincos (float x, __local float *cosval)\n"
"{\n"
"    *cosval = native_cos(x);\n"
"    return native_sin(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_sincos (float x, __private float *cosval)\n"
"{\n"
"    *cosval = native_cos(x);\n"
"    return native_sin(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_sinh (float x)\n"
"{\n"
"    return (1 - native_exp(-2 * x)) / (2 * native_exp(-x));\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_sinpi (float x)\n"
"{\n"
"    return __gen_ocl_sin(x * M_PI_F);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_tan (float x)\n"
"{\n"
"    return native_tan(x);\n"
"}\n"
"\n"
"INLINE_OVERLOADABLE float __gen_ocl_internal_fastpath_tanh (float x)\n"
"{\n"
"    float y = native_exp(-2 * x);\n"
"    return (1 - y) / (1 + y);\n"
"}\n"
"\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : disable\n"
"\n"
"#undef DECL_IMAGE\n"
"#undef DECL_READ_IMAGE\n"
"#undef DECL_READ_IMAGE_NOSAMPLER\n"
"#undef DECL_WRITE_IMAGE\n"
"\n"
"#undef GET_IMAGE\n"
"// ##BEGIN_VECTOR##\n"
"//math builtin functions\n"
"//gentype acos (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 acos (float2 param0)\n"
"{return (float2)(acos(param0.s0), acos(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 acos (float3 param0)\n"
"{return (float3)(acos(param0.s0), acos(param0.s1),\n"
"                 acos(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 acos (float4 param0)\n"
"{return (float4)(acos(param0.s0), acos(param0.s1),\n"
"                 acos(param0.s2), acos(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 acos (float8 param0)\n"
"{return (float8)(acos(param0.s0), acos(param0.s1),\n"
"                 acos(param0.s2), acos(param0.s3),\n"
"                 acos(param0.s4), acos(param0.s5),\n"
"                 acos(param0.s6), acos(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 acos (float16 param0)\n"
"{return (float16)(acos(param0.s0), acos(param0.s1),\n"
"                  acos(param0.s2), acos(param0.s3),\n"
"                  acos(param0.s4), acos(param0.s5),\n"
"                  acos(param0.s6), acos(param0.s7),\n"
"                  acos(param0.s8), acos(param0.s9),\n"
"                  acos(param0.sa), acos(param0.sb),\n"
"                  acos(param0.sc), acos(param0.sd),\n"
"                  acos(param0.se), acos(param0.sf)); }\n"
"\n"
"\n"
"//gentype acosh (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 acosh (float2 param0)\n"
"{return (float2)(acosh(param0.s0), acosh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 acosh (float3 param0)\n"
"{return (float3)(acosh(param0.s0), acosh(param0.s1),\n"
"                 acosh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 acosh (float4 param0)\n"
"{return (float4)(acosh(param0.s0), acosh(param0.s1),\n"
"                 acosh(param0.s2), acosh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 acosh (float8 param0)\n"
"{return (float8)(acosh(param0.s0), acosh(param0.s1),\n"
"                 acosh(param0.s2), acosh(param0.s3),\n"
"                 acosh(param0.s4), acosh(param0.s5),\n"
"                 acosh(param0.s6), acosh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 acosh (float16 param0)\n"
"{return (float16)(acosh(param0.s0), acosh(param0.s1),\n"
"                  acosh(param0.s2), acosh(param0.s3),\n"
"                  acosh(param0.s4), acosh(param0.s5),\n"
"                  acosh(param0.s6), acosh(param0.s7),\n"
"                  acosh(param0.s8), acosh(param0.s9),\n"
"                  acosh(param0.sa), acosh(param0.sb),\n"
"                  acosh(param0.sc), acosh(param0.sd),\n"
"                  acosh(param0.se), acosh(param0.sf)); }\n"
"\n"
"\n"
"//gentype acospi (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 acospi (float2 param0)\n"
"{return (float2)(acospi(param0.s0), acospi(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 acospi (float3 param0)\n"
"{return (float3)(acospi(param0.s0), acospi(param0.s1),\n"
"                 acospi(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 acospi (float4 param0)\n"
"{return (float4)(acospi(param0.s0), acospi(param0.s1),\n"
"                 acospi(param0.s2), acospi(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 acospi (float8 param0)\n"
"{return (float8)(acospi(param0.s0), acospi(param0.s1),\n"
"                 acospi(param0.s2), acospi(param0.s3),\n"
"                 acospi(param0.s4), acospi(param0.s5),\n"
"                 acospi(param0.s6), acospi(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 acospi (float16 param0)\n"
"{return (float16)(acospi(param0.s0), acospi(param0.s1),\n"
"                  acospi(param0.s2), acospi(param0.s3),\n"
"                  acospi(param0.s4), acospi(param0.s5),\n"
"                  acospi(param0.s6), acospi(param0.s7),\n"
"                  acospi(param0.s8), acospi(param0.s9),\n"
"                  acospi(param0.sa), acospi(param0.sb),\n"
"                  acospi(param0.sc), acospi(param0.sd),\n"
"                  acospi(param0.se), acospi(param0.sf)); }\n"
"\n"
"\n"
"//gentype asin (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 asin (float2 param0)\n"
"{return (float2)(asin(param0.s0), asin(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 asin (float3 param0)\n"
"{return (float3)(asin(param0.s0), asin(param0.s1),\n"
"                 asin(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 asin (float4 param0)\n"
"{return (float4)(asin(param0.s0), asin(param0.s1),\n"
"                 asin(param0.s2), asin(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 asin (float8 param0)\n"
"{return (float8)(asin(param0.s0), asin(param0.s1),\n"
"                 asin(param0.s2), asin(param0.s3),\n"
"                 asin(param0.s4), asin(param0.s5),\n"
"                 asin(param0.s6), asin(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 asin (float16 param0)\n"
"{return (float16)(asin(param0.s0), asin(param0.s1),\n"
"                  asin(param0.s2), asin(param0.s3),\n"
"                  asin(param0.s4), asin(param0.s5),\n"
"                  asin(param0.s6), asin(param0.s7),\n"
"                  asin(param0.s8), asin(param0.s9),\n"
"                  asin(param0.sa), asin(param0.sb),\n"
"                  asin(param0.sc), asin(param0.sd),\n"
"                  asin(param0.se), asin(param0.sf)); }\n"
"\n"
"\n"
"//gentype asinh (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 asinh (float2 param0)\n"
"{return (float2)(asinh(param0.s0), asinh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 asinh (float3 param0)\n"
"{return (float3)(asinh(param0.s0), asinh(param0.s1),\n"
"                 asinh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 asinh (float4 param0)\n"
"{return (float4)(asinh(param0.s0), asinh(param0.s1),\n"
"                 asinh(param0.s2), asinh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 asinh (float8 param0)\n"
"{return (float8)(asinh(param0.s0), asinh(param0.s1),\n"
"                 asinh(param0.s2), asinh(param0.s3),\n"
"                 asinh(param0.s4), asinh(param0.s5),\n"
"                 asinh(param0.s6), asinh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 asinh (float16 param0)\n"
"{return (float16)(asinh(param0.s0), asinh(param0.s1),\n"
"                  asinh(param0.s2), asinh(param0.s3),\n"
"                  asinh(param0.s4), asinh(param0.s5),\n"
"                  asinh(param0.s6), asinh(param0.s7),\n"
"                  asinh(param0.s8), asinh(param0.s9),\n"
"                  asinh(param0.sa), asinh(param0.sb),\n"
"                  asinh(param0.sc), asinh(param0.sd),\n"
"                  asinh(param0.se), asinh(param0.sf)); }\n"
"\n"
"\n"
"//gentype asinpi (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 asinpi (float2 param0)\n"
"{return (float2)(asinpi(param0.s0), asinpi(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 asinpi (float3 param0)\n"
"{return (float3)(asinpi(param0.s0), asinpi(param0.s1),\n"
"                 asinpi(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 asinpi (float4 param0)\n"
"{return (float4)(asinpi(param0.s0), asinpi(param0.s1),\n"
"                 asinpi(param0.s2), asinpi(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 asinpi (float8 param0)\n"
"{return (float8)(asinpi(param0.s0), asinpi(param0.s1),\n"
"                 asinpi(param0.s2), asinpi(param0.s3),\n"
"                 asinpi(param0.s4), asinpi(param0.s5),\n"
"                 asinpi(param0.s6), asinpi(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 asinpi (float16 param0)\n"
"{return (float16)(asinpi(param0.s0), asinpi(param0.s1),\n"
"                  asinpi(param0.s2), asinpi(param0.s3),\n"
"                  asinpi(param0.s4), asinpi(param0.s5),\n"
"                  asinpi(param0.s6), asinpi(param0.s7),\n"
"                  asinpi(param0.s8), asinpi(param0.s9),\n"
"                  asinpi(param0.sa), asinpi(param0.sb),\n"
"                  asinpi(param0.sc), asinpi(param0.sd),\n"
"                  asinpi(param0.se), asinpi(param0.sf)); }\n"
"\n"
"\n"
"//gentype atan (gentype y_over_x)\n"
"\n"
"INLINE_OVERLOADABLE float2 atan (float2 param0)\n"
"{return (float2)(atan(param0.s0), atan(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 atan (float3 param0)\n"
"{return (float3)(atan(param0.s0), atan(param0.s1),\n"
"                 atan(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 atan (float4 param0)\n"
"{return (float4)(atan(param0.s0), atan(param0.s1),\n"
"                 atan(param0.s2), atan(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 atan (float8 param0)\n"
"{return (float8)(atan(param0.s0), atan(param0.s1),\n"
"                 atan(param0.s2), atan(param0.s3),\n"
"                 atan(param0.s4), atan(param0.s5),\n"
"                 atan(param0.s6), atan(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 atan (float16 param0)\n"
"{return (float16)(atan(param0.s0), atan(param0.s1),\n"
"                  atan(param0.s2), atan(param0.s3),\n"
"                  atan(param0.s4), atan(param0.s5),\n"
"                  atan(param0.s6), atan(param0.s7),\n"
"                  atan(param0.s8), atan(param0.s9),\n"
"                  atan(param0.sa), atan(param0.sb),\n"
"                  atan(param0.sc), atan(param0.sd),\n"
"                  atan(param0.se), atan(param0.sf)); }\n"
"\n"
"\n"
"//gentype atan2 (gentype y, gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 atan2 (float2 param0, float2 param1)\n"
"{return (float2)(atan2(param0.s0, param1.s0), atan2(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 atan2 (float3 param0, float3 param1)\n"
"{return (float3)(atan2(param0.s0, param1.s0), atan2(param0.s1, param1.s1),\n"
"                 atan2(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 atan2 (float4 param0, float4 param1)\n"
"{return (float4)(atan2(param0.s0, param1.s0), atan2(param0.s1, param1.s1),\n"
"                 atan2(param0.s2, param1.s2), atan2(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 atan2 (float8 param0, float8 param1)\n"
"{return (float8)(atan2(param0.s0, param1.s0), atan2(param0.s1, param1.s1),\n"
"                 atan2(param0.s2, param1.s2), atan2(param0.s3, param1.s3),\n"
"                 atan2(param0.s4, param1.s4), atan2(param0.s5, param1.s5),\n"
"                 atan2(param0.s6, param1.s6), atan2(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 atan2 (float16 param0, float16 param1)\n"
"{return (float16)(atan2(param0.s0, param1.s0), atan2(param0.s1, param1.s1),\n"
"                  atan2(param0.s2, param1.s2), atan2(param0.s3, param1.s3),\n"
"                  atan2(param0.s4, param1.s4), atan2(param0.s5, param1.s5),\n"
"                  atan2(param0.s6, param1.s6), atan2(param0.s7, param1.s7),\n"
"                  atan2(param0.s8, param1.s8), atan2(param0.s9, param1.s9),\n"
"                  atan2(param0.sa, param1.sa), atan2(param0.sb, param1.sb),\n"
"                  atan2(param0.sc, param1.sc), atan2(param0.sd, param1.sd),\n"
"                  atan2(param0.se, param1.se), atan2(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype atanh (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 atanh (float2 param0)\n"
"{return (float2)(atanh(param0.s0), atanh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 atanh (float3 param0)\n"
"{return (float3)(atanh(param0.s0), atanh(param0.s1),\n"
"                 atanh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 atanh (float4 param0)\n"
"{return (float4)(atanh(param0.s0), atanh(param0.s1),\n"
"                 atanh(param0.s2), atanh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 atanh (float8 param0)\n"
"{return (float8)(atanh(param0.s0), atanh(param0.s1),\n"
"                 atanh(param0.s2), atanh(param0.s3),\n"
"                 atanh(param0.s4), atanh(param0.s5),\n"
"                 atanh(param0.s6), atanh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 atanh (float16 param0)\n"
"{return (float16)(atanh(param0.s0), atanh(param0.s1),\n"
"                  atanh(param0.s2), atanh(param0.s3),\n"
"                  atanh(param0.s4), atanh(param0.s5),\n"
"                  atanh(param0.s6), atanh(param0.s7),\n"
"                  atanh(param0.s8), atanh(param0.s9),\n"
"                  atanh(param0.sa), atanh(param0.sb),\n"
"                  atanh(param0.sc), atanh(param0.sd),\n"
"                  atanh(param0.se), atanh(param0.sf)); }\n"
"\n"
"\n"
"//gentype atanpi (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 atanpi (float2 param0)\n"
"{return (float2)(atanpi(param0.s0), atanpi(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 atanpi (float3 param0)\n"
"{return (float3)(atanpi(param0.s0), atanpi(param0.s1),\n"
"                 atanpi(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 atanpi (float4 param0)\n"
"{return (float4)(atanpi(param0.s0), atanpi(param0.s1),\n"
"                 atanpi(param0.s2), atanpi(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 atanpi (float8 param0)\n"
"{return (float8)(atanpi(param0.s0), atanpi(param0.s1),\n"
"                 atanpi(param0.s2), atanpi(param0.s3),\n"
"                 atanpi(param0.s4), atanpi(param0.s5),\n"
"                 atanpi(param0.s6), atanpi(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 atanpi (float16 param0)\n"
"{return (float16)(atanpi(param0.s0), atanpi(param0.s1),\n"
"                  atanpi(param0.s2), atanpi(param0.s3),\n"
"                  atanpi(param0.s4), atanpi(param0.s5),\n"
"                  atanpi(param0.s6), atanpi(param0.s7),\n"
"                  atanpi(param0.s8), atanpi(param0.s9),\n"
"                  atanpi(param0.sa), atanpi(param0.sb),\n"
"                  atanpi(param0.sc), atanpi(param0.sd),\n"
"                  atanpi(param0.se), atanpi(param0.sf)); }\n"
"\n"
"\n"
"//gentype atan2pi (gentype y, gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 atan2pi (float2 param0, float2 param1)\n"
"{return (float2)(atan2pi(param0.s0, param1.s0), atan2pi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 atan2pi (float3 param0, float3 param1)\n"
"{return (float3)(atan2pi(param0.s0, param1.s0), atan2pi(param0.s1, param1.s1),\n"
"                 atan2pi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 atan2pi (float4 param0, float4 param1)\n"
"{return (float4)(atan2pi(param0.s0, param1.s0), atan2pi(param0.s1, param1.s1),\n"
"                 atan2pi(param0.s2, param1.s2), atan2pi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 atan2pi (float8 param0, float8 param1)\n"
"{return (float8)(atan2pi(param0.s0, param1.s0), atan2pi(param0.s1, param1.s1),\n"
"                 atan2pi(param0.s2, param1.s2), atan2pi(param0.s3, param1.s3),\n"
"                 atan2pi(param0.s4, param1.s4), atan2pi(param0.s5, param1.s5),\n"
"                 atan2pi(param0.s6, param1.s6), atan2pi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 atan2pi (float16 param0, float16 param1)\n"
"{return (float16)(atan2pi(param0.s0, param1.s0), atan2pi(param0.s1, param1.s1),\n"
"                  atan2pi(param0.s2, param1.s2), atan2pi(param0.s3, param1.s3),\n"
"                  atan2pi(param0.s4, param1.s4), atan2pi(param0.s5, param1.s5),\n"
"                  atan2pi(param0.s6, param1.s6), atan2pi(param0.s7, param1.s7),\n"
"                  atan2pi(param0.s8, param1.s8), atan2pi(param0.s9, param1.s9),\n"
"                  atan2pi(param0.sa, param1.sa), atan2pi(param0.sb, param1.sb),\n"
"                  atan2pi(param0.sc, param1.sc), atan2pi(param0.sd, param1.sd),\n"
"                  atan2pi(param0.se, param1.se), atan2pi(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype cbrt (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 cbrt (float2 param0)\n"
"{return (float2)(cbrt(param0.s0), cbrt(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 cbrt (float3 param0)\n"
"{return (float3)(cbrt(param0.s0), cbrt(param0.s1),\n"
"                 cbrt(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 cbrt (float4 param0)\n"
"{return (float4)(cbrt(param0.s0), cbrt(param0.s1),\n"
"                 cbrt(param0.s2), cbrt(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 cbrt (float8 param0)\n"
"{return (float8)(cbrt(param0.s0), cbrt(param0.s1),\n"
"                 cbrt(param0.s2), cbrt(param0.s3),\n"
"                 cbrt(param0.s4), cbrt(param0.s5),\n"
"                 cbrt(param0.s6), cbrt(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 cbrt (float16 param0)\n"
"{return (float16)(cbrt(param0.s0), cbrt(param0.s1),\n"
"                  cbrt(param0.s2), cbrt(param0.s3),\n"
"                  cbrt(param0.s4), cbrt(param0.s5),\n"
"                  cbrt(param0.s6), cbrt(param0.s7),\n"
"                  cbrt(param0.s8), cbrt(param0.s9),\n"
"                  cbrt(param0.sa), cbrt(param0.sb),\n"
"                  cbrt(param0.sc), cbrt(param0.sd),\n"
"                  cbrt(param0.se), cbrt(param0.sf)); }\n"
"\n"
"\n"
"//gentype ceil (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 ceil (float2 param0)\n"
"{return (float2)(ceil(param0.s0), ceil(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 ceil (float3 param0)\n"
"{return (float3)(ceil(param0.s0), ceil(param0.s1),\n"
"                 ceil(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 ceil (float4 param0)\n"
"{return (float4)(ceil(param0.s0), ceil(param0.s1),\n"
"                 ceil(param0.s2), ceil(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 ceil (float8 param0)\n"
"{return (float8)(ceil(param0.s0), ceil(param0.s1),\n"
"                 ceil(param0.s2), ceil(param0.s3),\n"
"                 ceil(param0.s4), ceil(param0.s5),\n"
"                 ceil(param0.s6), ceil(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 ceil (float16 param0)\n"
"{return (float16)(ceil(param0.s0), ceil(param0.s1),\n"
"                  ceil(param0.s2), ceil(param0.s3),\n"
"                  ceil(param0.s4), ceil(param0.s5),\n"
"                  ceil(param0.s6), ceil(param0.s7),\n"
"                  ceil(param0.s8), ceil(param0.s9),\n"
"                  ceil(param0.sa), ceil(param0.sb),\n"
"                  ceil(param0.sc), ceil(param0.sd),\n"
"                  ceil(param0.se), ceil(param0.sf)); }\n"
"\n"
"\n"
"//gentype copysign (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 copysign (float2 param0, float2 param1)\n"
"{return (float2)(copysign(param0.s0, param1.s0), copysign(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 copysign (float3 param0, float3 param1)\n"
"{return (float3)(copysign(param0.s0, param1.s0), copysign(param0.s1, param1.s1),\n"
"                 copysign(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 copysign (float4 param0, float4 param1)\n"
"{return (float4)(copysign(param0.s0, param1.s0), copysign(param0.s1, param1.s1),\n"
"                 copysign(param0.s2, param1.s2), copysign(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 copysign (float8 param0, float8 param1)\n"
"{return (float8)(copysign(param0.s0, param1.s0), copysign(param0.s1, param1.s1),\n"
"                 copysign(param0.s2, param1.s2), copysign(param0.s3, param1.s3),\n"
"                 copysign(param0.s4, param1.s4), copysign(param0.s5, param1.s5),\n"
"                 copysign(param0.s6, param1.s6), copysign(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 copysign (float16 param0, float16 param1)\n"
"{return (float16)(copysign(param0.s0, param1.s0), copysign(param0.s1, param1.s1),\n"
"                  copysign(param0.s2, param1.s2), copysign(param0.s3, param1.s3),\n"
"                  copysign(param0.s4, param1.s4), copysign(param0.s5, param1.s5),\n"
"                  copysign(param0.s6, param1.s6), copysign(param0.s7, param1.s7),\n"
"                  copysign(param0.s8, param1.s8), copysign(param0.s9, param1.s9),\n"
"                  copysign(param0.sa, param1.sa), copysign(param0.sb, param1.sb),\n"
"                  copysign(param0.sc, param1.sc), copysign(param0.sd, param1.sd),\n"
"                  copysign(param0.se, param1.se), copysign(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype cos (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 cos (float2 param0)\n"
"{return (float2)(cos(param0.s0), cos(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 cos (float3 param0)\n"
"{return (float3)(cos(param0.s0), cos(param0.s1),\n"
"                 cos(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 cos (float4 param0)\n"
"{return (float4)(cos(param0.s0), cos(param0.s1),\n"
"                 cos(param0.s2), cos(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 cos (float8 param0)\n"
"{return (float8)(cos(param0.s0), cos(param0.s1),\n"
"                 cos(param0.s2), cos(param0.s3),\n"
"                 cos(param0.s4), cos(param0.s5),\n"
"                 cos(param0.s6), cos(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 cos (float16 param0)\n"
"{return (float16)(cos(param0.s0), cos(param0.s1),\n"
"                  cos(param0.s2), cos(param0.s3),\n"
"                  cos(param0.s4), cos(param0.s5),\n"
"                  cos(param0.s6), cos(param0.s7),\n"
"                  cos(param0.s8), cos(param0.s9),\n"
"                  cos(param0.sa), cos(param0.sb),\n"
"                  cos(param0.sc), cos(param0.sd),\n"
"                  cos(param0.se), cos(param0.sf)); }\n"
"\n"
"\n"
"//gentype cosh (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 cosh (float2 param0)\n"
"{return (float2)(cosh(param0.s0), cosh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 cosh (float3 param0)\n"
"{return (float3)(cosh(param0.s0), cosh(param0.s1),\n"
"                 cosh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 cosh (float4 param0)\n"
"{return (float4)(cosh(param0.s0), cosh(param0.s1),\n"
"                 cosh(param0.s2), cosh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 cosh (float8 param0)\n"
"{return (float8)(cosh(param0.s0), cosh(param0.s1),\n"
"                 cosh(param0.s2), cosh(param0.s3),\n"
"                 cosh(param0.s4), cosh(param0.s5),\n"
"                 cosh(param0.s6), cosh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 cosh (float16 param0)\n"
"{return (float16)(cosh(param0.s0), cosh(param0.s1),\n"
"                  cosh(param0.s2), cosh(param0.s3),\n"
"                  cosh(param0.s4), cosh(param0.s5),\n"
"                  cosh(param0.s6), cosh(param0.s7),\n"
"                  cosh(param0.s8), cosh(param0.s9),\n"
"                  cosh(param0.sa), cosh(param0.sb),\n"
"                  cosh(param0.sc), cosh(param0.sd),\n"
"                  cosh(param0.se), cosh(param0.sf)); }\n"
"\n"
"\n"
"//gentype cospi (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 cospi (float2 param0)\n"
"{return (float2)(cospi(param0.s0), cospi(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 cospi (float3 param0)\n"
"{return (float3)(cospi(param0.s0), cospi(param0.s1),\n"
"                 cospi(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 cospi (float4 param0)\n"
"{return (float4)(cospi(param0.s0), cospi(param0.s1),\n"
"                 cospi(param0.s2), cospi(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 cospi (float8 param0)\n"
"{return (float8)(cospi(param0.s0), cospi(param0.s1),\n"
"                 cospi(param0.s2), cospi(param0.s3),\n"
"                 cospi(param0.s4), cospi(param0.s5),\n"
"                 cospi(param0.s6), cospi(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 cospi (float16 param0)\n"
"{return (float16)(cospi(param0.s0), cospi(param0.s1),\n"
"                  cospi(param0.s2), cospi(param0.s3),\n"
"                  cospi(param0.s4), cospi(param0.s5),\n"
"                  cospi(param0.s6), cospi(param0.s7),\n"
"                  cospi(param0.s8), cospi(param0.s9),\n"
"                  cospi(param0.sa), cospi(param0.sb),\n"
"                  cospi(param0.sc), cospi(param0.sd),\n"
"                  cospi(param0.se), cospi(param0.sf)); }\n"
"\n"
"\n"
"//gentype erfc (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 erfc (float2 param0)\n"
"{return (float2)(erfc(param0.s0), erfc(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 erfc (float3 param0)\n"
"{return (float3)(erfc(param0.s0), erfc(param0.s1),\n"
"                 erfc(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 erfc (float4 param0)\n"
"{return (float4)(erfc(param0.s0), erfc(param0.s1),\n"
"                 erfc(param0.s2), erfc(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 erfc (float8 param0)\n"
"{return (float8)(erfc(param0.s0), erfc(param0.s1),\n"
"                 erfc(param0.s2), erfc(param0.s3),\n"
"                 erfc(param0.s4), erfc(param0.s5),\n"
"                 erfc(param0.s6), erfc(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 erfc (float16 param0)\n"
"{return (float16)(erfc(param0.s0), erfc(param0.s1),\n"
"                  erfc(param0.s2), erfc(param0.s3),\n"
"                  erfc(param0.s4), erfc(param0.s5),\n"
"                  erfc(param0.s6), erfc(param0.s7),\n"
"                  erfc(param0.s8), erfc(param0.s9),\n"
"                  erfc(param0.sa), erfc(param0.sb),\n"
"                  erfc(param0.sc), erfc(param0.sd),\n"
"                  erfc(param0.se), erfc(param0.sf)); }\n"
"\n"
"\n"
"//gentype erf (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 erf (float2 param0)\n"
"{return (float2)(erf(param0.s0), erf(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 erf (float3 param0)\n"
"{return (float3)(erf(param0.s0), erf(param0.s1),\n"
"                 erf(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 erf (float4 param0)\n"
"{return (float4)(erf(param0.s0), erf(param0.s1),\n"
"                 erf(param0.s2), erf(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 erf (float8 param0)\n"
"{return (float8)(erf(param0.s0), erf(param0.s1),\n"
"                 erf(param0.s2), erf(param0.s3),\n"
"                 erf(param0.s4), erf(param0.s5),\n"
"                 erf(param0.s6), erf(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 erf (float16 param0)\n"
"{return (float16)(erf(param0.s0), erf(param0.s1),\n"
"                  erf(param0.s2), erf(param0.s3),\n"
"                  erf(param0.s4), erf(param0.s5),\n"
"                  erf(param0.s6), erf(param0.s7),\n"
"                  erf(param0.s8), erf(param0.s9),\n"
"                  erf(param0.sa), erf(param0.sb),\n"
"                  erf(param0.sc), erf(param0.sd),\n"
"                  erf(param0.se), erf(param0.sf)); }\n"
"\n"
"\n"
"//gentype exp (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 exp (float2 param0)\n"
"{return (float2)(exp(param0.s0), exp(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 exp (float3 param0)\n"
"{return (float3)(exp(param0.s0), exp(param0.s1),\n"
"                 exp(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 exp (float4 param0)\n"
"{return (float4)(exp(param0.s0), exp(param0.s1),\n"
"                 exp(param0.s2), exp(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 exp (float8 param0)\n"
"{return (float8)(exp(param0.s0), exp(param0.s1),\n"
"                 exp(param0.s2), exp(param0.s3),\n"
"                 exp(param0.s4), exp(param0.s5),\n"
"                 exp(param0.s6), exp(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 exp (float16 param0)\n"
"{return (float16)(exp(param0.s0), exp(param0.s1),\n"
"                  exp(param0.s2), exp(param0.s3),\n"
"                  exp(param0.s4), exp(param0.s5),\n"
"                  exp(param0.s6), exp(param0.s7),\n"
"                  exp(param0.s8), exp(param0.s9),\n"
"                  exp(param0.sa), exp(param0.sb),\n"
"                  exp(param0.sc), exp(param0.sd),\n"
"                  exp(param0.se), exp(param0.sf)); }\n"
"\n"
"\n"
"//gentype exp2 (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 exp2 (float2 param0)\n"
"{return (float2)(exp2(param0.s0), exp2(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 exp2 (float3 param0)\n"
"{return (float3)(exp2(param0.s0), exp2(param0.s1),\n"
"                 exp2(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 exp2 (float4 param0)\n"
"{return (float4)(exp2(param0.s0), exp2(param0.s1),\n"
"                 exp2(param0.s2), exp2(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 exp2 (float8 param0)\n"
"{return (float8)(exp2(param0.s0), exp2(param0.s1),\n"
"                 exp2(param0.s2), exp2(param0.s3),\n"
"                 exp2(param0.s4), exp2(param0.s5),\n"
"                 exp2(param0.s6), exp2(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 exp2 (float16 param0)\n"
"{return (float16)(exp2(param0.s0), exp2(param0.s1),\n"
"                  exp2(param0.s2), exp2(param0.s3),\n"
"                  exp2(param0.s4), exp2(param0.s5),\n"
"                  exp2(param0.s6), exp2(param0.s7),\n"
"                  exp2(param0.s8), exp2(param0.s9),\n"
"                  exp2(param0.sa), exp2(param0.sb),\n"
"                  exp2(param0.sc), exp2(param0.sd),\n"
"                  exp2(param0.se), exp2(param0.sf)); }\n"
"\n"
"\n"
"//gentype exp10 (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 exp10 (float2 param0)\n"
"{return (float2)(exp10(param0.s0), exp10(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 exp10 (float3 param0)\n"
"{return (float3)(exp10(param0.s0), exp10(param0.s1),\n"
"                 exp10(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 exp10 (float4 param0)\n"
"{return (float4)(exp10(param0.s0), exp10(param0.s1),\n"
"                 exp10(param0.s2), exp10(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 exp10 (float8 param0)\n"
"{return (float8)(exp10(param0.s0), exp10(param0.s1),\n"
"                 exp10(param0.s2), exp10(param0.s3),\n"
"                 exp10(param0.s4), exp10(param0.s5),\n"
"                 exp10(param0.s6), exp10(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 exp10 (float16 param0)\n"
"{return (float16)(exp10(param0.s0), exp10(param0.s1),\n"
"                  exp10(param0.s2), exp10(param0.s3),\n"
"                  exp10(param0.s4), exp10(param0.s5),\n"
"                  exp10(param0.s6), exp10(param0.s7),\n"
"                  exp10(param0.s8), exp10(param0.s9),\n"
"                  exp10(param0.sa), exp10(param0.sb),\n"
"                  exp10(param0.sc), exp10(param0.sd),\n"
"                  exp10(param0.se), exp10(param0.sf)); }\n"
"\n"
"\n"
"//gentype expm1 (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 expm1 (float2 param0)\n"
"{return (float2)(expm1(param0.s0), expm1(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 expm1 (float3 param0)\n"
"{return (float3)(expm1(param0.s0), expm1(param0.s1),\n"
"                 expm1(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 expm1 (float4 param0)\n"
"{return (float4)(expm1(param0.s0), expm1(param0.s1),\n"
"                 expm1(param0.s2), expm1(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 expm1 (float8 param0)\n"
"{return (float8)(expm1(param0.s0), expm1(param0.s1),\n"
"                 expm1(param0.s2), expm1(param0.s3),\n"
"                 expm1(param0.s4), expm1(param0.s5),\n"
"                 expm1(param0.s6), expm1(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 expm1 (float16 param0)\n"
"{return (float16)(expm1(param0.s0), expm1(param0.s1),\n"
"                  expm1(param0.s2), expm1(param0.s3),\n"
"                  expm1(param0.s4), expm1(param0.s5),\n"
"                  expm1(param0.s6), expm1(param0.s7),\n"
"                  expm1(param0.s8), expm1(param0.s9),\n"
"                  expm1(param0.sa), expm1(param0.sb),\n"
"                  expm1(param0.sc), expm1(param0.sd),\n"
"                  expm1(param0.se), expm1(param0.sf)); }\n"
"\n"
"\n"
"//gentype fabs (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 fabs (float2 param0)\n"
"{return (float2)(fabs(param0.s0), fabs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fabs (float3 param0)\n"
"{return (float3)(fabs(param0.s0), fabs(param0.s1),\n"
"                 fabs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fabs (float4 param0)\n"
"{return (float4)(fabs(param0.s0), fabs(param0.s1),\n"
"                 fabs(param0.s2), fabs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fabs (float8 param0)\n"
"{return (float8)(fabs(param0.s0), fabs(param0.s1),\n"
"                 fabs(param0.s2), fabs(param0.s3),\n"
"                 fabs(param0.s4), fabs(param0.s5),\n"
"                 fabs(param0.s6), fabs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fabs (float16 param0)\n"
"{return (float16)(fabs(param0.s0), fabs(param0.s1),\n"
"                  fabs(param0.s2), fabs(param0.s3),\n"
"                  fabs(param0.s4), fabs(param0.s5),\n"
"                  fabs(param0.s6), fabs(param0.s7),\n"
"                  fabs(param0.s8), fabs(param0.s9),\n"
"                  fabs(param0.sa), fabs(param0.sb),\n"
"                  fabs(param0.sc), fabs(param0.sd),\n"
"                  fabs(param0.se), fabs(param0.sf)); }\n"
"\n"
"\n"
"//gentype fdim (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 fdim (float2 param0, float2 param1)\n"
"{return (float2)(fdim(param0.s0, param1.s0), fdim(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fdim (float3 param0, float3 param1)\n"
"{return (float3)(fdim(param0.s0, param1.s0), fdim(param0.s1, param1.s1),\n"
"                 fdim(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fdim (float4 param0, float4 param1)\n"
"{return (float4)(fdim(param0.s0, param1.s0), fdim(param0.s1, param1.s1),\n"
"                 fdim(param0.s2, param1.s2), fdim(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fdim (float8 param0, float8 param1)\n"
"{return (float8)(fdim(param0.s0, param1.s0), fdim(param0.s1, param1.s1),\n"
"                 fdim(param0.s2, param1.s2), fdim(param0.s3, param1.s3),\n"
"                 fdim(param0.s4, param1.s4), fdim(param0.s5, param1.s5),\n"
"                 fdim(param0.s6, param1.s6), fdim(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fdim (float16 param0, float16 param1)\n"
"{return (float16)(fdim(param0.s0, param1.s0), fdim(param0.s1, param1.s1),\n"
"                  fdim(param0.s2, param1.s2), fdim(param0.s3, param1.s3),\n"
"                  fdim(param0.s4, param1.s4), fdim(param0.s5, param1.s5),\n"
"                  fdim(param0.s6, param1.s6), fdim(param0.s7, param1.s7),\n"
"                  fdim(param0.s8, param1.s8), fdim(param0.s9, param1.s9),\n"
"                  fdim(param0.sa, param1.sa), fdim(param0.sb, param1.sb),\n"
"                  fdim(param0.sc, param1.sc), fdim(param0.sd, param1.sd),\n"
"                  fdim(param0.se, param1.se), fdim(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype floor (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 floor (float2 param0)\n"
"{return (float2)(floor(param0.s0), floor(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 floor (float3 param0)\n"
"{return (float3)(floor(param0.s0), floor(param0.s1),\n"
"                 floor(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 floor (float4 param0)\n"
"{return (float4)(floor(param0.s0), floor(param0.s1),\n"
"                 floor(param0.s2), floor(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 floor (float8 param0)\n"
"{return (float8)(floor(param0.s0), floor(param0.s1),\n"
"                 floor(param0.s2), floor(param0.s3),\n"
"                 floor(param0.s4), floor(param0.s5),\n"
"                 floor(param0.s6), floor(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 floor (float16 param0)\n"
"{return (float16)(floor(param0.s0), floor(param0.s1),\n"
"                  floor(param0.s2), floor(param0.s3),\n"
"                  floor(param0.s4), floor(param0.s5),\n"
"                  floor(param0.s6), floor(param0.s7),\n"
"                  floor(param0.s8), floor(param0.s9),\n"
"                  floor(param0.sa), floor(param0.sb),\n"
"                  floor(param0.sc), floor(param0.sd),\n"
"                  floor(param0.se), floor(param0.sf)); }\n"
"\n"
"\n"
"//gentype fmax (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 fmax (float2 param0, float2 param1)\n"
"{return (float2)(fmax(param0.s0, param1.s0), fmax(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fmax (float3 param0, float3 param1)\n"
"{return (float3)(fmax(param0.s0, param1.s0), fmax(param0.s1, param1.s1),\n"
"                 fmax(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fmax (float4 param0, float4 param1)\n"
"{return (float4)(fmax(param0.s0, param1.s0), fmax(param0.s1, param1.s1),\n"
"                 fmax(param0.s2, param1.s2), fmax(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fmax (float8 param0, float8 param1)\n"
"{return (float8)(fmax(param0.s0, param1.s0), fmax(param0.s1, param1.s1),\n"
"                 fmax(param0.s2, param1.s2), fmax(param0.s3, param1.s3),\n"
"                 fmax(param0.s4, param1.s4), fmax(param0.s5, param1.s5),\n"
"                 fmax(param0.s6, param1.s6), fmax(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fmax (float16 param0, float16 param1)\n"
"{return (float16)(fmax(param0.s0, param1.s0), fmax(param0.s1, param1.s1),\n"
"                  fmax(param0.s2, param1.s2), fmax(param0.s3, param1.s3),\n"
"                  fmax(param0.s4, param1.s4), fmax(param0.s5, param1.s5),\n"
"                  fmax(param0.s6, param1.s6), fmax(param0.s7, param1.s7),\n"
"                  fmax(param0.s8, param1.s8), fmax(param0.s9, param1.s9),\n"
"                  fmax(param0.sa, param1.sa), fmax(param0.sb, param1.sb),\n"
"                  fmax(param0.sc, param1.sc), fmax(param0.sd, param1.sd),\n"
"                  fmax(param0.se, param1.se), fmax(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentypef fmax (gentypef x, float y)\n"
"\n"
"INLINE_OVERLOADABLE float2 fmax (float2 param0, float param1)\n"
"{return (float2)(fmax(param0.s0, param1), fmax(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fmax (float3 param0, float param1)\n"
"{return (float3)(fmax(param0.s0, param1), fmax(param0.s1, param1),\n"
"                 fmax(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fmax (float4 param0, float param1)\n"
"{return (float4)(fmax(param0.s0, param1), fmax(param0.s1, param1),\n"
"                 fmax(param0.s2, param1), fmax(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fmax (float8 param0, float param1)\n"
"{return (float8)(fmax(param0.s0, param1), fmax(param0.s1, param1),\n"
"                 fmax(param0.s2, param1), fmax(param0.s3, param1),\n"
"                 fmax(param0.s4, param1), fmax(param0.s5, param1),\n"
"                 fmax(param0.s6, param1), fmax(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fmax (float16 param0, float param1)\n"
"{return (float16)(fmax(param0.s0, param1), fmax(param0.s1, param1),\n"
"                  fmax(param0.s2, param1), fmax(param0.s3, param1),\n"
"                  fmax(param0.s4, param1), fmax(param0.s5, param1),\n"
"                  fmax(param0.s6, param1), fmax(param0.s7, param1),\n"
"                  fmax(param0.s8, param1), fmax(param0.s9, param1),\n"
"                  fmax(param0.sa, param1), fmax(param0.sb, param1),\n"
"                  fmax(param0.sc, param1), fmax(param0.sd, param1),\n"
"                  fmax(param0.se, param1), fmax(param0.sf, param1)); }\n"
"\n"
"\n"
"//gentyped fmax (gentyped x, double y)\n"
"\n"
"\n"
"//gentype fmin (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 fmin (float2 param0, float2 param1)\n"
"{return (float2)(fmin(param0.s0, param1.s0), fmin(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fmin (float3 param0, float3 param1)\n"
"{return (float3)(fmin(param0.s0, param1.s0), fmin(param0.s1, param1.s1),\n"
"                 fmin(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fmin (float4 param0, float4 param1)\n"
"{return (float4)(fmin(param0.s0, param1.s0), fmin(param0.s1, param1.s1),\n"
"                 fmin(param0.s2, param1.s2), fmin(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fmin (float8 param0, float8 param1)\n"
"{return (float8)(fmin(param0.s0, param1.s0), fmin(param0.s1, param1.s1),\n"
"                 fmin(param0.s2, param1.s2), fmin(param0.s3, param1.s3),\n"
"                 fmin(param0.s4, param1.s4), fmin(param0.s5, param1.s5),\n"
"                 fmin(param0.s6, param1.s6), fmin(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fmin (float16 param0, float16 param1)\n"
"{return (float16)(fmin(param0.s0, param1.s0), fmin(param0.s1, param1.s1),\n"
"                  fmin(param0.s2, param1.s2), fmin(param0.s3, param1.s3),\n"
"                  fmin(param0.s4, param1.s4), fmin(param0.s5, param1.s5),\n"
"                  fmin(param0.s6, param1.s6), fmin(param0.s7, param1.s7),\n"
"                  fmin(param0.s8, param1.s8), fmin(param0.s9, param1.s9),\n"
"                  fmin(param0.sa, param1.sa), fmin(param0.sb, param1.sb),\n"
"                  fmin(param0.sc, param1.sc), fmin(param0.sd, param1.sd),\n"
"                  fmin(param0.se, param1.se), fmin(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentypef fmin (gentypef x, float y)\n"
"\n"
"INLINE_OVERLOADABLE float2 fmin (float2 param0, float param1)\n"
"{return (float2)(fmin(param0.s0, param1), fmin(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fmin (float3 param0, float param1)\n"
"{return (float3)(fmin(param0.s0, param1), fmin(param0.s1, param1),\n"
"                 fmin(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fmin (float4 param0, float param1)\n"
"{return (float4)(fmin(param0.s0, param1), fmin(param0.s1, param1),\n"
"                 fmin(param0.s2, param1), fmin(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fmin (float8 param0, float param1)\n"
"{return (float8)(fmin(param0.s0, param1), fmin(param0.s1, param1),\n"
"                 fmin(param0.s2, param1), fmin(param0.s3, param1),\n"
"                 fmin(param0.s4, param1), fmin(param0.s5, param1),\n"
"                 fmin(param0.s6, param1), fmin(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fmin (float16 param0, float param1)\n"
"{return (float16)(fmin(param0.s0, param1), fmin(param0.s1, param1),\n"
"                  fmin(param0.s2, param1), fmin(param0.s3, param1),\n"
"                  fmin(param0.s4, param1), fmin(param0.s5, param1),\n"
"                  fmin(param0.s6, param1), fmin(param0.s7, param1),\n"
"                  fmin(param0.s8, param1), fmin(param0.s9, param1),\n"
"                  fmin(param0.sa, param1), fmin(param0.sb, param1),\n"
"                  fmin(param0.sc, param1), fmin(param0.sd, param1),\n"
"                  fmin(param0.se, param1), fmin(param0.sf, param1)); }\n"
"\n"
"\n"
"//gentyped fmin (gentyped x, double y)\n"
"\n"
"\n"
"//gentype fmod (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 fmod (float2 param0, float2 param1)\n"
"{return (float2)(fmod(param0.s0, param1.s0), fmod(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fmod (float3 param0, float3 param1)\n"
"{return (float3)(fmod(param0.s0, param1.s0), fmod(param0.s1, param1.s1),\n"
"                 fmod(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fmod (float4 param0, float4 param1)\n"
"{return (float4)(fmod(param0.s0, param1.s0), fmod(param0.s1, param1.s1),\n"
"                 fmod(param0.s2, param1.s2), fmod(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fmod (float8 param0, float8 param1)\n"
"{return (float8)(fmod(param0.s0, param1.s0), fmod(param0.s1, param1.s1),\n"
"                 fmod(param0.s2, param1.s2), fmod(param0.s3, param1.s3),\n"
"                 fmod(param0.s4, param1.s4), fmod(param0.s5, param1.s5),\n"
"                 fmod(param0.s6, param1.s6), fmod(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fmod (float16 param0, float16 param1)\n"
"{return (float16)(fmod(param0.s0, param1.s0), fmod(param0.s1, param1.s1),\n"
"                  fmod(param0.s2, param1.s2), fmod(param0.s3, param1.s3),\n"
"                  fmod(param0.s4, param1.s4), fmod(param0.s5, param1.s5),\n"
"                  fmod(param0.s6, param1.s6), fmod(param0.s7, param1.s7),\n"
"                  fmod(param0.s8, param1.s8), fmod(param0.s9, param1.s9),\n"
"                  fmod(param0.sa, param1.sa), fmod(param0.sb, param1.sb),\n"
"                  fmod(param0.sc, param1.sc), fmod(param0.sd, param1.sd),\n"
"                  fmod(param0.se, param1.se), fmod(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype fract (gentype x, __global gentype *iptr)\n"
"\n"
"INLINE_OVERLOADABLE float2 fract (float2 param0, __global float2 *param1)\n"
"{return (float2)(fract(param0.s0, (__global  float *)param1 +  0), fract(param0.s1, (__global  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fract (float3 param0, __global float3 *param1)\n"
"{return (float3)(fract(param0.s0, (__global  float *)param1 +  0), fract(param0.s1, (__global  float *)param1 +  1),\n"
"                 fract(param0.s2, (__global  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fract (float4 param0, __global float4 *param1)\n"
"{return (float4)(fract(param0.s0, (__global  float *)param1 +  0), fract(param0.s1, (__global  float *)param1 +  1),\n"
"                 fract(param0.s2, (__global  float *)param1 +  2), fract(param0.s3, (__global  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fract (float8 param0, __global float8 *param1)\n"
"{return (float8)(fract(param0.s0, (__global  float *)param1 +  0), fract(param0.s1, (__global  float *)param1 +  1),\n"
"                 fract(param0.s2, (__global  float *)param1 +  2), fract(param0.s3, (__global  float *)param1 +  3),\n"
"                 fract(param0.s4, (__global  float *)param1 +  4), fract(param0.s5, (__global  float *)param1 +  5),\n"
"                 fract(param0.s6, (__global  float *)param1 +  6), fract(param0.s7, (__global  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fract (float16 param0, __global float16 *param1)\n"
"{return (float16)(fract(param0.s0, (__global  float *)param1 +  0), fract(param0.s1, (__global  float *)param1 +  1),\n"
"                  fract(param0.s2, (__global  float *)param1 +  2), fract(param0.s3, (__global  float *)param1 +  3),\n"
"                  fract(param0.s4, (__global  float *)param1 +  4), fract(param0.s5, (__global  float *)param1 +  5),\n"
"                  fract(param0.s6, (__global  float *)param1 +  6), fract(param0.s7, (__global  float *)param1 +  7),\n"
"                  fract(param0.s8, (__global  float *)param1 +  8), fract(param0.s9, (__global  float *)param1 +  9),\n"
"                  fract(param0.sa, (__global  float *)param1 + 10), fract(param0.sb, (__global  float *)param1 + 11),\n"
"                  fract(param0.sc, (__global  float *)param1 + 12), fract(param0.sd, (__global  float *)param1 + 13),\n"
"                  fract(param0.se, (__global  float *)param1 + 14), fract(param0.sf, (__global  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype fract (gentype x, __local gentype *iptr)\n"
"\n"
"INLINE_OVERLOADABLE float2 fract (float2 param0, __local float2 *param1)\n"
"{return (float2)(fract(param0.s0, (__local  float *)param1 +  0), fract(param0.s1, (__local  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fract (float3 param0, __local float3 *param1)\n"
"{return (float3)(fract(param0.s0, (__local  float *)param1 +  0), fract(param0.s1, (__local  float *)param1 +  1),\n"
"                 fract(param0.s2, (__local  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fract (float4 param0, __local float4 *param1)\n"
"{return (float4)(fract(param0.s0, (__local  float *)param1 +  0), fract(param0.s1, (__local  float *)param1 +  1),\n"
"                 fract(param0.s2, (__local  float *)param1 +  2), fract(param0.s3, (__local  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fract (float8 param0, __local float8 *param1)\n"
"{return (float8)(fract(param0.s0, (__local  float *)param1 +  0), fract(param0.s1, (__local  float *)param1 +  1),\n"
"                 fract(param0.s2, (__local  float *)param1 +  2), fract(param0.s3, (__local  float *)param1 +  3),\n"
"                 fract(param0.s4, (__local  float *)param1 +  4), fract(param0.s5, (__local  float *)param1 +  5),\n"
"                 fract(param0.s6, (__local  float *)param1 +  6), fract(param0.s7, (__local  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fract (float16 param0, __local float16 *param1)\n"
"{return (float16)(fract(param0.s0, (__local  float *)param1 +  0), fract(param0.s1, (__local  float *)param1 +  1),\n"
"                  fract(param0.s2, (__local  float *)param1 +  2), fract(param0.s3, (__local  float *)param1 +  3),\n"
"                  fract(param0.s4, (__local  float *)param1 +  4), fract(param0.s5, (__local  float *)param1 +  5),\n"
"                  fract(param0.s6, (__local  float *)param1 +  6), fract(param0.s7, (__local  float *)param1 +  7),\n"
"                  fract(param0.s8, (__local  float *)param1 +  8), fract(param0.s9, (__local  float *)param1 +  9),\n"
"                  fract(param0.sa, (__local  float *)param1 + 10), fract(param0.sb, (__local  float *)param1 + 11),\n"
"                  fract(param0.sc, (__local  float *)param1 + 12), fract(param0.sd, (__local  float *)param1 + 13),\n"
"                  fract(param0.se, (__local  float *)param1 + 14), fract(param0.sf, (__local  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype fract (gentype x, __private gentype *iptr)\n"
"\n"
"INLINE_OVERLOADABLE float2 fract (float2 param0, __private float2 *param1)\n"
"{return (float2)(fract(param0.s0, (__private  float *)param1 +  0), fract(param0.s1, (__private  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 fract (float3 param0, __private float3 *param1)\n"
"{return (float3)(fract(param0.s0, (__private  float *)param1 +  0), fract(param0.s1, (__private  float *)param1 +  1),\n"
"                 fract(param0.s2, (__private  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 fract (float4 param0, __private float4 *param1)\n"
"{return (float4)(fract(param0.s0, (__private  float *)param1 +  0), fract(param0.s1, (__private  float *)param1 +  1),\n"
"                 fract(param0.s2, (__private  float *)param1 +  2), fract(param0.s3, (__private  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 fract (float8 param0, __private float8 *param1)\n"
"{return (float8)(fract(param0.s0, (__private  float *)param1 +  0), fract(param0.s1, (__private  float *)param1 +  1),\n"
"                 fract(param0.s2, (__private  float *)param1 +  2), fract(param0.s3, (__private  float *)param1 +  3),\n"
"                 fract(param0.s4, (__private  float *)param1 +  4), fract(param0.s5, (__private  float *)param1 +  5),\n"
"                 fract(param0.s6, (__private  float *)param1 +  6), fract(param0.s7, (__private  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 fract (float16 param0, __private float16 *param1)\n"
"{return (float16)(fract(param0.s0, (__private  float *)param1 +  0), fract(param0.s1, (__private  float *)param1 +  1),\n"
"                  fract(param0.s2, (__private  float *)param1 +  2), fract(param0.s3, (__private  float *)param1 +  3),\n"
"                  fract(param0.s4, (__private  float *)param1 +  4), fract(param0.s5, (__private  float *)param1 +  5),\n"
"                  fract(param0.s6, (__private  float *)param1 +  6), fract(param0.s7, (__private  float *)param1 +  7),\n"
"                  fract(param0.s8, (__private  float *)param1 +  8), fract(param0.s9, (__private  float *)param1 +  9),\n"
"                  fract(param0.sa, (__private  float *)param1 + 10), fract(param0.sb, (__private  float *)param1 + 11),\n"
"                  fract(param0.sc, (__private  float *)param1 + 12), fract(param0.sd, (__private  float *)param1 + 13),\n"
"                  fract(param0.se, (__private  float *)param1 + 14), fract(param0.sf, (__private  float *)param1 + 15)); }\n"
"\n"
"\n"
"//floatn frexp (floatn x, __global intn *exp)\n"
"\n"
"INLINE_OVERLOADABLE float2 frexp (float2 param0, __global int2 *param1)\n"
"{return (float2)(frexp(param0.s0, (__global  int *)param1 +  0), frexp(param0.s1, (__global  int *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 frexp (float3 param0, __global int3 *param1)\n"
"{return (float3)(frexp(param0.s0, (__global  int *)param1 +  0), frexp(param0.s1, (__global  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__global  int *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 frexp (float4 param0, __global int4 *param1)\n"
"{return (float4)(frexp(param0.s0, (__global  int *)param1 +  0), frexp(param0.s1, (__global  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__global  int *)param1 +  2), frexp(param0.s3, (__global  int *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 frexp (float8 param0, __global int8 *param1)\n"
"{return (float8)(frexp(param0.s0, (__global  int *)param1 +  0), frexp(param0.s1, (__global  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__global  int *)param1 +  2), frexp(param0.s3, (__global  int *)param1 +  3),\n"
"                 frexp(param0.s4, (__global  int *)param1 +  4), frexp(param0.s5, (__global  int *)param1 +  5),\n"
"                 frexp(param0.s6, (__global  int *)param1 +  6), frexp(param0.s7, (__global  int *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 frexp (float16 param0, __global int16 *param1)\n"
"{return (float16)(frexp(param0.s0, (__global  int *)param1 +  0), frexp(param0.s1, (__global  int *)param1 +  1),\n"
"                  frexp(param0.s2, (__global  int *)param1 +  2), frexp(param0.s3, (__global  int *)param1 +  3),\n"
"                  frexp(param0.s4, (__global  int *)param1 +  4), frexp(param0.s5, (__global  int *)param1 +  5),\n"
"                  frexp(param0.s6, (__global  int *)param1 +  6), frexp(param0.s7, (__global  int *)param1 +  7),\n"
"                  frexp(param0.s8, (__global  int *)param1 +  8), frexp(param0.s9, (__global  int *)param1 +  9),\n"
"                  frexp(param0.sa, (__global  int *)param1 + 10), frexp(param0.sb, (__global  int *)param1 + 11),\n"
"                  frexp(param0.sc, (__global  int *)param1 + 12), frexp(param0.sd, (__global  int *)param1 + 13),\n"
"                  frexp(param0.se, (__global  int *)param1 + 14), frexp(param0.sf, (__global  int *)param1 + 15)); }\n"
"\n"
"\n"
"//floatn frexp (floatn x, __local intn *exp)\n"
"\n"
"INLINE_OVERLOADABLE float2 frexp (float2 param0, __local int2 *param1)\n"
"{return (float2)(frexp(param0.s0, (__local  int *)param1 +  0), frexp(param0.s1, (__local  int *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 frexp (float3 param0, __local int3 *param1)\n"
"{return (float3)(frexp(param0.s0, (__local  int *)param1 +  0), frexp(param0.s1, (__local  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__local  int *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 frexp (float4 param0, __local int4 *param1)\n"
"{return (float4)(frexp(param0.s0, (__local  int *)param1 +  0), frexp(param0.s1, (__local  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__local  int *)param1 +  2), frexp(param0.s3, (__local  int *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 frexp (float8 param0, __local int8 *param1)\n"
"{return (float8)(frexp(param0.s0, (__local  int *)param1 +  0), frexp(param0.s1, (__local  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__local  int *)param1 +  2), frexp(param0.s3, (__local  int *)param1 +  3),\n"
"                 frexp(param0.s4, (__local  int *)param1 +  4), frexp(param0.s5, (__local  int *)param1 +  5),\n"
"                 frexp(param0.s6, (__local  int *)param1 +  6), frexp(param0.s7, (__local  int *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 frexp (float16 param0, __local int16 *param1)\n"
"{return (float16)(frexp(param0.s0, (__local  int *)param1 +  0), frexp(param0.s1, (__local  int *)param1 +  1),\n"
"                  frexp(param0.s2, (__local  int *)param1 +  2), frexp(param0.s3, (__local  int *)param1 +  3),\n"
"                  frexp(param0.s4, (__local  int *)param1 +  4), frexp(param0.s5, (__local  int *)param1 +  5),\n"
"                  frexp(param0.s6, (__local  int *)param1 +  6), frexp(param0.s7, (__local  int *)param1 +  7),\n"
"                  frexp(param0.s8, (__local  int *)param1 +  8), frexp(param0.s9, (__local  int *)param1 +  9),\n"
"                  frexp(param0.sa, (__local  int *)param1 + 10), frexp(param0.sb, (__local  int *)param1 + 11),\n"
"                  frexp(param0.sc, (__local  int *)param1 + 12), frexp(param0.sd, (__local  int *)param1 + 13),\n"
"                  frexp(param0.se, (__local  int *)param1 + 14), frexp(param0.sf, (__local  int *)param1 + 15)); }\n"
"\n"
"\n"
"//floatn frexp (floatn x, __private intn *exp)\n"
"\n"
"INLINE_OVERLOADABLE float2 frexp (float2 param0, __private int2 *param1)\n"
"{return (float2)(frexp(param0.s0, (__private  int *)param1 +  0), frexp(param0.s1, (__private  int *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 frexp (float3 param0, __private int3 *param1)\n"
"{return (float3)(frexp(param0.s0, (__private  int *)param1 +  0), frexp(param0.s1, (__private  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__private  int *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 frexp (float4 param0, __private int4 *param1)\n"
"{return (float4)(frexp(param0.s0, (__private  int *)param1 +  0), frexp(param0.s1, (__private  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__private  int *)param1 +  2), frexp(param0.s3, (__private  int *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 frexp (float8 param0, __private int8 *param1)\n"
"{return (float8)(frexp(param0.s0, (__private  int *)param1 +  0), frexp(param0.s1, (__private  int *)param1 +  1),\n"
"                 frexp(param0.s2, (__private  int *)param1 +  2), frexp(param0.s3, (__private  int *)param1 +  3),\n"
"                 frexp(param0.s4, (__private  int *)param1 +  4), frexp(param0.s5, (__private  int *)param1 +  5),\n"
"                 frexp(param0.s6, (__private  int *)param1 +  6), frexp(param0.s7, (__private  int *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 frexp (float16 param0, __private int16 *param1)\n"
"{return (float16)(frexp(param0.s0, (__private  int *)param1 +  0), frexp(param0.s1, (__private  int *)param1 +  1),\n"
"                  frexp(param0.s2, (__private  int *)param1 +  2), frexp(param0.s3, (__private  int *)param1 +  3),\n"
"                  frexp(param0.s4, (__private  int *)param1 +  4), frexp(param0.s5, (__private  int *)param1 +  5),\n"
"                  frexp(param0.s6, (__private  int *)param1 +  6), frexp(param0.s7, (__private  int *)param1 +  7),\n"
"                  frexp(param0.s8, (__private  int *)param1 +  8), frexp(param0.s9, (__private  int *)param1 +  9),\n"
"                  frexp(param0.sa, (__private  int *)param1 + 10), frexp(param0.sb, (__private  int *)param1 + 11),\n"
"                  frexp(param0.sc, (__private  int *)param1 + 12), frexp(param0.sd, (__private  int *)param1 + 13),\n"
"                  frexp(param0.se, (__private  int *)param1 + 14), frexp(param0.sf, (__private  int *)param1 + 15)); }\n"
"\n"
"\n"
"//float frexp (float x, __global int *exp)\n"
"\n"
"\n"
"//float frexp (float x, __local int *exp)\n"
"\n"
"\n"
"//float frexp (float x, __private int *exp)\n"
"\n"
"\n"
"//doublen frexp (doublen x, __global intn *exp)\n"
"\n"
"\n"
"//doublen frexp (doublen x, __local intn *exp)\n"
"\n"
"\n"
"//doublen frexp (doublen x, __private intn *exp)\n"
"\n"
"\n"
"//double frexp (double x, __global int *exp)\n"
"\n"
"\n"
"//double frexp (double x, __local int *exp)\n"
"\n"
"\n"
"//double frexp (double x, __private int *exp)\n"
"\n"
"\n"
"//gentype hypot (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 hypot (float2 param0, float2 param1)\n"
"{return (float2)(hypot(param0.s0, param1.s0), hypot(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 hypot (float3 param0, float3 param1)\n"
"{return (float3)(hypot(param0.s0, param1.s0), hypot(param0.s1, param1.s1),\n"
"                 hypot(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 hypot (float4 param0, float4 param1)\n"
"{return (float4)(hypot(param0.s0, param1.s0), hypot(param0.s1, param1.s1),\n"
"                 hypot(param0.s2, param1.s2), hypot(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 hypot (float8 param0, float8 param1)\n"
"{return (float8)(hypot(param0.s0, param1.s0), hypot(param0.s1, param1.s1),\n"
"                 hypot(param0.s2, param1.s2), hypot(param0.s3, param1.s3),\n"
"                 hypot(param0.s4, param1.s4), hypot(param0.s5, param1.s5),\n"
"                 hypot(param0.s6, param1.s6), hypot(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 hypot (float16 param0, float16 param1)\n"
"{return (float16)(hypot(param0.s0, param1.s0), hypot(param0.s1, param1.s1),\n"
"                  hypot(param0.s2, param1.s2), hypot(param0.s3, param1.s3),\n"
"                  hypot(param0.s4, param1.s4), hypot(param0.s5, param1.s5),\n"
"                  hypot(param0.s6, param1.s6), hypot(param0.s7, param1.s7),\n"
"                  hypot(param0.s8, param1.s8), hypot(param0.s9, param1.s9),\n"
"                  hypot(param0.sa, param1.sa), hypot(param0.sb, param1.sb),\n"
"                  hypot(param0.sc, param1.sc), hypot(param0.sd, param1.sd),\n"
"                  hypot(param0.se, param1.se), hypot(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//intn ilogb (floatn x)\n"
"\n"
"INLINE_OVERLOADABLE int2 ilogb (float2 param0)\n"
"{return (int2)(ilogb(param0.s0), ilogb(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 ilogb (float3 param0)\n"
"{return (int3)(ilogb(param0.s0), ilogb(param0.s1),\n"
"               ilogb(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 ilogb (float4 param0)\n"
"{return (int4)(ilogb(param0.s0), ilogb(param0.s1),\n"
"               ilogb(param0.s2), ilogb(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 ilogb (float8 param0)\n"
"{return (int8)(ilogb(param0.s0), ilogb(param0.s1),\n"
"               ilogb(param0.s2), ilogb(param0.s3),\n"
"               ilogb(param0.s4), ilogb(param0.s5),\n"
"               ilogb(param0.s6), ilogb(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 ilogb (float16 param0)\n"
"{return (int16)(ilogb(param0.s0), ilogb(param0.s1),\n"
"                ilogb(param0.s2), ilogb(param0.s3),\n"
"                ilogb(param0.s4), ilogb(param0.s5),\n"
"                ilogb(param0.s6), ilogb(param0.s7),\n"
"                ilogb(param0.s8), ilogb(param0.s9),\n"
"                ilogb(param0.sa), ilogb(param0.sb),\n"
"                ilogb(param0.sc), ilogb(param0.sd),\n"
"                ilogb(param0.se), ilogb(param0.sf)); }\n"
"\n"
"\n"
"//int ilogb (float x)\n"
"\n"
"\n"
"//intn ilogb (doublen x)\n"
"\n"
"\n"
"//int ilogb (double x)\n"
"\n"
"\n"
"//floatn ldexp (floatn x, intn k)\n"
"\n"
"INLINE_OVERLOADABLE float2 ldexp (float2 param0, int2 param1)\n"
"{return (float2)(ldexp(param0.s0, param1.s0), ldexp(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 ldexp (float3 param0, int3 param1)\n"
"{return (float3)(ldexp(param0.s0, param1.s0), ldexp(param0.s1, param1.s1),\n"
"                 ldexp(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 ldexp (float4 param0, int4 param1)\n"
"{return (float4)(ldexp(param0.s0, param1.s0), ldexp(param0.s1, param1.s1),\n"
"                 ldexp(param0.s2, param1.s2), ldexp(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 ldexp (float8 param0, int8 param1)\n"
"{return (float8)(ldexp(param0.s0, param1.s0), ldexp(param0.s1, param1.s1),\n"
"                 ldexp(param0.s2, param1.s2), ldexp(param0.s3, param1.s3),\n"
"                 ldexp(param0.s4, param1.s4), ldexp(param0.s5, param1.s5),\n"
"                 ldexp(param0.s6, param1.s6), ldexp(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 ldexp (float16 param0, int16 param1)\n"
"{return (float16)(ldexp(param0.s0, param1.s0), ldexp(param0.s1, param1.s1),\n"
"                  ldexp(param0.s2, param1.s2), ldexp(param0.s3, param1.s3),\n"
"                  ldexp(param0.s4, param1.s4), ldexp(param0.s5, param1.s5),\n"
"                  ldexp(param0.s6, param1.s6), ldexp(param0.s7, param1.s7),\n"
"                  ldexp(param0.s8, param1.s8), ldexp(param0.s9, param1.s9),\n"
"                  ldexp(param0.sa, param1.sa), ldexp(param0.sb, param1.sb),\n"
"                  ldexp(param0.sc, param1.sc), ldexp(param0.sd, param1.sd),\n"
"                  ldexp(param0.se, param1.se), ldexp(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//floatn ldexp (floatn x, int k)\n"
"\n"
"INLINE_OVERLOADABLE float2 ldexp (float2 param0, int param1)\n"
"{return (float2)(ldexp(param0.s0, param1), ldexp(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 ldexp (float3 param0, int param1)\n"
"{return (float3)(ldexp(param0.s0, param1), ldexp(param0.s1, param1),\n"
"                 ldexp(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 ldexp (float4 param0, int param1)\n"
"{return (float4)(ldexp(param0.s0, param1), ldexp(param0.s1, param1),\n"
"                 ldexp(param0.s2, param1), ldexp(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 ldexp (float8 param0, int param1)\n"
"{return (float8)(ldexp(param0.s0, param1), ldexp(param0.s1, param1),\n"
"                 ldexp(param0.s2, param1), ldexp(param0.s3, param1),\n"
"                 ldexp(param0.s4, param1), ldexp(param0.s5, param1),\n"
"                 ldexp(param0.s6, param1), ldexp(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 ldexp (float16 param0, int param1)\n"
"{return (float16)(ldexp(param0.s0, param1), ldexp(param0.s1, param1),\n"
"                  ldexp(param0.s2, param1), ldexp(param0.s3, param1),\n"
"                  ldexp(param0.s4, param1), ldexp(param0.s5, param1),\n"
"                  ldexp(param0.s6, param1), ldexp(param0.s7, param1),\n"
"                  ldexp(param0.s8, param1), ldexp(param0.s9, param1),\n"
"                  ldexp(param0.sa, param1), ldexp(param0.sb, param1),\n"
"                  ldexp(param0.sc, param1), ldexp(param0.sd, param1),\n"
"                  ldexp(param0.se, param1), ldexp(param0.sf, param1)); }\n"
"\n"
"\n"
"//float ldexp (float x, int k)\n"
"\n"
"\n"
"//doublen ldexp (doublen x, intn k)\n"
"\n"
"\n"
"//doublen ldexp (doublen x, int k)\n"
"\n"
"\n"
"//double ldexp (double x, int k)\n"
"\n"
"\n"
"//gentype lgamma (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 lgamma (float2 param0)\n"
"{return (float2)(lgamma(param0.s0), lgamma(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 lgamma (float3 param0)\n"
"{return (float3)(lgamma(param0.s0), lgamma(param0.s1),\n"
"                 lgamma(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 lgamma (float4 param0)\n"
"{return (float4)(lgamma(param0.s0), lgamma(param0.s1),\n"
"                 lgamma(param0.s2), lgamma(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 lgamma (float8 param0)\n"
"{return (float8)(lgamma(param0.s0), lgamma(param0.s1),\n"
"                 lgamma(param0.s2), lgamma(param0.s3),\n"
"                 lgamma(param0.s4), lgamma(param0.s5),\n"
"                 lgamma(param0.s6), lgamma(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 lgamma (float16 param0)\n"
"{return (float16)(lgamma(param0.s0), lgamma(param0.s1),\n"
"                  lgamma(param0.s2), lgamma(param0.s3),\n"
"                  lgamma(param0.s4), lgamma(param0.s5),\n"
"                  lgamma(param0.s6), lgamma(param0.s7),\n"
"                  lgamma(param0.s8), lgamma(param0.s9),\n"
"                  lgamma(param0.sa), lgamma(param0.sb),\n"
"                  lgamma(param0.sc), lgamma(param0.sd),\n"
"                  lgamma(param0.se), lgamma(param0.sf)); }\n"
"\n"
"\n"
"//floatn lgamma_r (floatn x, __global intn *signp)\n"
"\n"
"INLINE_OVERLOADABLE float2 lgamma_r (float2 param0, __global int2 *param1)\n"
"{return (float2)(lgamma_r(param0.s0, (__global  int *)param1 +  0), lgamma_r(param0.s1, (__global  int *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 lgamma_r (float3 param0, __global int3 *param1)\n"
"{return (float3)(lgamma_r(param0.s0, (__global  int *)param1 +  0), lgamma_r(param0.s1, (__global  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__global  int *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 lgamma_r (float4 param0, __global int4 *param1)\n"
"{return (float4)(lgamma_r(param0.s0, (__global  int *)param1 +  0), lgamma_r(param0.s1, (__global  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__global  int *)param1 +  2), lgamma_r(param0.s3, (__global  int *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 lgamma_r (float8 param0, __global int8 *param1)\n"
"{return (float8)(lgamma_r(param0.s0, (__global  int *)param1 +  0), lgamma_r(param0.s1, (__global  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__global  int *)param1 +  2), lgamma_r(param0.s3, (__global  int *)param1 +  3),\n"
"                 lgamma_r(param0.s4, (__global  int *)param1 +  4), lgamma_r(param0.s5, (__global  int *)param1 +  5),\n"
"                 lgamma_r(param0.s6, (__global  int *)param1 +  6), lgamma_r(param0.s7, (__global  int *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 lgamma_r (float16 param0, __global int16 *param1)\n"
"{return (float16)(lgamma_r(param0.s0, (__global  int *)param1 +  0), lgamma_r(param0.s1, (__global  int *)param1 +  1),\n"
"                  lgamma_r(param0.s2, (__global  int *)param1 +  2), lgamma_r(param0.s3, (__global  int *)param1 +  3),\n"
"                  lgamma_r(param0.s4, (__global  int *)param1 +  4), lgamma_r(param0.s5, (__global  int *)param1 +  5),\n"
"                  lgamma_r(param0.s6, (__global  int *)param1 +  6), lgamma_r(param0.s7, (__global  int *)param1 +  7),\n"
"                  lgamma_r(param0.s8, (__global  int *)param1 +  8), lgamma_r(param0.s9, (__global  int *)param1 +  9),\n"
"                  lgamma_r(param0.sa, (__global  int *)param1 + 10), lgamma_r(param0.sb, (__global  int *)param1 + 11),\n"
"                  lgamma_r(param0.sc, (__global  int *)param1 + 12), lgamma_r(param0.sd, (__global  int *)param1 + 13),\n"
"                  lgamma_r(param0.se, (__global  int *)param1 + 14), lgamma_r(param0.sf, (__global  int *)param1 + 15)); }\n"
"\n"
"\n"
"//floatn lgamma_r (floatn x, __local intn *signp)\n"
"\n"
"INLINE_OVERLOADABLE float2 lgamma_r (float2 param0, __local int2 *param1)\n"
"{return (float2)(lgamma_r(param0.s0, (__local  int *)param1 +  0), lgamma_r(param0.s1, (__local  int *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 lgamma_r (float3 param0, __local int3 *param1)\n"
"{return (float3)(lgamma_r(param0.s0, (__local  int *)param1 +  0), lgamma_r(param0.s1, (__local  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__local  int *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 lgamma_r (float4 param0, __local int4 *param1)\n"
"{return (float4)(lgamma_r(param0.s0, (__local  int *)param1 +  0), lgamma_r(param0.s1, (__local  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__local  int *)param1 +  2), lgamma_r(param0.s3, (__local  int *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 lgamma_r (float8 param0, __local int8 *param1)\n"
"{return (float8)(lgamma_r(param0.s0, (__local  int *)param1 +  0), lgamma_r(param0.s1, (__local  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__local  int *)param1 +  2), lgamma_r(param0.s3, (__local  int *)param1 +  3),\n"
"                 lgamma_r(param0.s4, (__local  int *)param1 +  4), lgamma_r(param0.s5, (__local  int *)param1 +  5),\n"
"                 lgamma_r(param0.s6, (__local  int *)param1 +  6), lgamma_r(param0.s7, (__local  int *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 lgamma_r (float16 param0, __local int16 *param1)\n"
"{return (float16)(lgamma_r(param0.s0, (__local  int *)param1 +  0), lgamma_r(param0.s1, (__local  int *)param1 +  1),\n"
"                  lgamma_r(param0.s2, (__local  int *)param1 +  2), lgamma_r(param0.s3, (__local  int *)param1 +  3),\n"
"                  lgamma_r(param0.s4, (__local  int *)param1 +  4), lgamma_r(param0.s5, (__local  int *)param1 +  5),\n"
"                  lgamma_r(param0.s6, (__local  int *)param1 +  6), lgamma_r(param0.s7, (__local  int *)param1 +  7),\n"
"                  lgamma_r(param0.s8, (__local  int *)param1 +  8), lgamma_r(param0.s9, (__local  int *)param1 +  9),\n"
"                  lgamma_r(param0.sa, (__local  int *)param1 + 10), lgamma_r(param0.sb, (__local  int *)param1 + 11),\n"
"                  lgamma_r(param0.sc, (__local  int *)param1 + 12), lgamma_r(param0.sd, (__local  int *)param1 + 13),\n"
"                  lgamma_r(param0.se, (__local  int *)param1 + 14), lgamma_r(param0.sf, (__local  int *)param1 + 15)); }\n"
"\n"
"\n"
"//floatn lgamma_r (floatn x, __private intn *signp)\n"
"\n"
"INLINE_OVERLOADABLE float2 lgamma_r (float2 param0, __private int2 *param1)\n"
"{return (float2)(lgamma_r(param0.s0, (__private  int *)param1 +  0), lgamma_r(param0.s1, (__private  int *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 lgamma_r (float3 param0, __private int3 *param1)\n"
"{return (float3)(lgamma_r(param0.s0, (__private  int *)param1 +  0), lgamma_r(param0.s1, (__private  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__private  int *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 lgamma_r (float4 param0, __private int4 *param1)\n"
"{return (float4)(lgamma_r(param0.s0, (__private  int *)param1 +  0), lgamma_r(param0.s1, (__private  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__private  int *)param1 +  2), lgamma_r(param0.s3, (__private  int *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 lgamma_r (float8 param0, __private int8 *param1)\n"
"{return (float8)(lgamma_r(param0.s0, (__private  int *)param1 +  0), lgamma_r(param0.s1, (__private  int *)param1 +  1),\n"
"                 lgamma_r(param0.s2, (__private  int *)param1 +  2), lgamma_r(param0.s3, (__private  int *)param1 +  3),\n"
"                 lgamma_r(param0.s4, (__private  int *)param1 +  4), lgamma_r(param0.s5, (__private  int *)param1 +  5),\n"
"                 lgamma_r(param0.s6, (__private  int *)param1 +  6), lgamma_r(param0.s7, (__private  int *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 lgamma_r (float16 param0, __private int16 *param1)\n"
"{return (float16)(lgamma_r(param0.s0, (__private  int *)param1 +  0), lgamma_r(param0.s1, (__private  int *)param1 +  1),\n"
"                  lgamma_r(param0.s2, (__private  int *)param1 +  2), lgamma_r(param0.s3, (__private  int *)param1 +  3),\n"
"                  lgamma_r(param0.s4, (__private  int *)param1 +  4), lgamma_r(param0.s5, (__private  int *)param1 +  5),\n"
"                  lgamma_r(param0.s6, (__private  int *)param1 +  6), lgamma_r(param0.s7, (__private  int *)param1 +  7),\n"
"                  lgamma_r(param0.s8, (__private  int *)param1 +  8), lgamma_r(param0.s9, (__private  int *)param1 +  9),\n"
"                  lgamma_r(param0.sa, (__private  int *)param1 + 10), lgamma_r(param0.sb, (__private  int *)param1 + 11),\n"
"                  lgamma_r(param0.sc, (__private  int *)param1 + 12), lgamma_r(param0.sd, (__private  int *)param1 + 13),\n"
"                  lgamma_r(param0.se, (__private  int *)param1 + 14), lgamma_r(param0.sf, (__private  int *)param1 + 15)); }\n"
"\n"
"\n"
"//float lgamma_r (float x, __global int *signp)\n"
"\n"
"\n"
"//float lgamma_r (float x, __local int *signp)\n"
"\n"
"\n"
"//float lgamma_r (float x,   __private int *signp)\n"
"\n"
"\n"
"//gentype log (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 log (float2 param0)\n"
"{return (float2)(log(param0.s0), log(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 log (float3 param0)\n"
"{return (float3)(log(param0.s0), log(param0.s1),\n"
"                 log(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 log (float4 param0)\n"
"{return (float4)(log(param0.s0), log(param0.s1),\n"
"                 log(param0.s2), log(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 log (float8 param0)\n"
"{return (float8)(log(param0.s0), log(param0.s1),\n"
"                 log(param0.s2), log(param0.s3),\n"
"                 log(param0.s4), log(param0.s5),\n"
"                 log(param0.s6), log(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 log (float16 param0)\n"
"{return (float16)(log(param0.s0), log(param0.s1),\n"
"                  log(param0.s2), log(param0.s3),\n"
"                  log(param0.s4), log(param0.s5),\n"
"                  log(param0.s6), log(param0.s7),\n"
"                  log(param0.s8), log(param0.s9),\n"
"                  log(param0.sa), log(param0.sb),\n"
"                  log(param0.sc), log(param0.sd),\n"
"                  log(param0.se), log(param0.sf)); }\n"
"\n"
"\n"
"//gentype log2 (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 log2 (float2 param0)\n"
"{return (float2)(log2(param0.s0), log2(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 log2 (float3 param0)\n"
"{return (float3)(log2(param0.s0), log2(param0.s1),\n"
"                 log2(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 log2 (float4 param0)\n"
"{return (float4)(log2(param0.s0), log2(param0.s1),\n"
"                 log2(param0.s2), log2(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 log2 (float8 param0)\n"
"{return (float8)(log2(param0.s0), log2(param0.s1),\n"
"                 log2(param0.s2), log2(param0.s3),\n"
"                 log2(param0.s4), log2(param0.s5),\n"
"                 log2(param0.s6), log2(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 log2 (float16 param0)\n"
"{return (float16)(log2(param0.s0), log2(param0.s1),\n"
"                  log2(param0.s2), log2(param0.s3),\n"
"                  log2(param0.s4), log2(param0.s5),\n"
"                  log2(param0.s6), log2(param0.s7),\n"
"                  log2(param0.s8), log2(param0.s9),\n"
"                  log2(param0.sa), log2(param0.sb),\n"
"                  log2(param0.sc), log2(param0.sd),\n"
"                  log2(param0.se), log2(param0.sf)); }\n"
"\n"
"\n"
"//gentype log10 (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 log10 (float2 param0)\n"
"{return (float2)(log10(param0.s0), log10(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 log10 (float3 param0)\n"
"{return (float3)(log10(param0.s0), log10(param0.s1),\n"
"                 log10(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 log10 (float4 param0)\n"
"{return (float4)(log10(param0.s0), log10(param0.s1),\n"
"                 log10(param0.s2), log10(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 log10 (float8 param0)\n"
"{return (float8)(log10(param0.s0), log10(param0.s1),\n"
"                 log10(param0.s2), log10(param0.s3),\n"
"                 log10(param0.s4), log10(param0.s5),\n"
"                 log10(param0.s6), log10(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 log10 (float16 param0)\n"
"{return (float16)(log10(param0.s0), log10(param0.s1),\n"
"                  log10(param0.s2), log10(param0.s3),\n"
"                  log10(param0.s4), log10(param0.s5),\n"
"                  log10(param0.s6), log10(param0.s7),\n"
"                  log10(param0.s8), log10(param0.s9),\n"
"                  log10(param0.sa), log10(param0.sb),\n"
"                  log10(param0.sc), log10(param0.sd),\n"
"                  log10(param0.se), log10(param0.sf)); }\n"
"\n"
"\n"
"//gentype log1p (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 log1p (float2 param0)\n"
"{return (float2)(log1p(param0.s0), log1p(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 log1p (float3 param0)\n"
"{return (float3)(log1p(param0.s0), log1p(param0.s1),\n"
"                 log1p(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 log1p (float4 param0)\n"
"{return (float4)(log1p(param0.s0), log1p(param0.s1),\n"
"                 log1p(param0.s2), log1p(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 log1p (float8 param0)\n"
"{return (float8)(log1p(param0.s0), log1p(param0.s1),\n"
"                 log1p(param0.s2), log1p(param0.s3),\n"
"                 log1p(param0.s4), log1p(param0.s5),\n"
"                 log1p(param0.s6), log1p(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 log1p (float16 param0)\n"
"{return (float16)(log1p(param0.s0), log1p(param0.s1),\n"
"                  log1p(param0.s2), log1p(param0.s3),\n"
"                  log1p(param0.s4), log1p(param0.s5),\n"
"                  log1p(param0.s6), log1p(param0.s7),\n"
"                  log1p(param0.s8), log1p(param0.s9),\n"
"                  log1p(param0.sa), log1p(param0.sb),\n"
"                  log1p(param0.sc), log1p(param0.sd),\n"
"                  log1p(param0.se), log1p(param0.sf)); }\n"
"\n"
"\n"
"//gentype logb (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 logb (float2 param0)\n"
"{return (float2)(logb(param0.s0), logb(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 logb (float3 param0)\n"
"{return (float3)(logb(param0.s0), logb(param0.s1),\n"
"                 logb(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 logb (float4 param0)\n"
"{return (float4)(logb(param0.s0), logb(param0.s1),\n"
"                 logb(param0.s2), logb(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 logb (float8 param0)\n"
"{return (float8)(logb(param0.s0), logb(param0.s1),\n"
"                 logb(param0.s2), logb(param0.s3),\n"
"                 logb(param0.s4), logb(param0.s5),\n"
"                 logb(param0.s6), logb(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 logb (float16 param0)\n"
"{return (float16)(logb(param0.s0), logb(param0.s1),\n"
"                  logb(param0.s2), logb(param0.s3),\n"
"                  logb(param0.s4), logb(param0.s5),\n"
"                  logb(param0.s6), logb(param0.s7),\n"
"                  logb(param0.s8), logb(param0.s9),\n"
"                  logb(param0.sa), logb(param0.sb),\n"
"                  logb(param0.sc), logb(param0.sd),\n"
"                  logb(param0.se), logb(param0.sf)); }\n"
"\n"
"\n"
"//gentype mad (gentype a, gentype b, gentype c)\n"
"\n"
"INLINE_OVERLOADABLE float2 mad (float2 param0, float2 param1, float2 param2)\n"
"{return (float2)(mad(param0.s0, param1.s0, param2.s0), mad(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 mad (float3 param0, float3 param1, float3 param2)\n"
"{return (float3)(mad(param0.s0, param1.s0, param2.s0), mad(param0.s1, param1.s1, param2.s1),\n"
"                 mad(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 mad (float4 param0, float4 param1, float4 param2)\n"
"{return (float4)(mad(param0.s0, param1.s0, param2.s0), mad(param0.s1, param1.s1, param2.s1),\n"
"                 mad(param0.s2, param1.s2, param2.s2), mad(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 mad (float8 param0, float8 param1, float8 param2)\n"
"{return (float8)(mad(param0.s0, param1.s0, param2.s0), mad(param0.s1, param1.s1, param2.s1),\n"
"                 mad(param0.s2, param1.s2, param2.s2), mad(param0.s3, param1.s3, param2.s3),\n"
"                 mad(param0.s4, param1.s4, param2.s4), mad(param0.s5, param1.s5, param2.s5),\n"
"                 mad(param0.s6, param1.s6, param2.s6), mad(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 mad (float16 param0, float16 param1, float16 param2)\n"
"{return (float16)(mad(param0.s0, param1.s0, param2.s0), mad(param0.s1, param1.s1, param2.s1),\n"
"                  mad(param0.s2, param1.s2, param2.s2), mad(param0.s3, param1.s3, param2.s3),\n"
"                  mad(param0.s4, param1.s4, param2.s4), mad(param0.s5, param1.s5, param2.s5),\n"
"                  mad(param0.s6, param1.s6, param2.s6), mad(param0.s7, param1.s7, param2.s7),\n"
"                  mad(param0.s8, param1.s8, param2.s8), mad(param0.s9, param1.s9, param2.s9),\n"
"                  mad(param0.sa, param1.sa, param2.sa), mad(param0.sb, param1.sb, param2.sb),\n"
"                  mad(param0.sc, param1.sc, param2.sc), mad(param0.sd, param1.sd, param2.sd),\n"
"                  mad(param0.se, param1.se, param2.se), mad(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentype maxmag (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 maxmag (float2 param0, float2 param1)\n"
"{return (float2)(maxmag(param0.s0, param1.s0), maxmag(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 maxmag (float3 param0, float3 param1)\n"
"{return (float3)(maxmag(param0.s0, param1.s0), maxmag(param0.s1, param1.s1),\n"
"                 maxmag(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 maxmag (float4 param0, float4 param1)\n"
"{return (float4)(maxmag(param0.s0, param1.s0), maxmag(param0.s1, param1.s1),\n"
"                 maxmag(param0.s2, param1.s2), maxmag(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 maxmag (float8 param0, float8 param1)\n"
"{return (float8)(maxmag(param0.s0, param1.s0), maxmag(param0.s1, param1.s1),\n"
"                 maxmag(param0.s2, param1.s2), maxmag(param0.s3, param1.s3),\n"
"                 maxmag(param0.s4, param1.s4), maxmag(param0.s5, param1.s5),\n"
"                 maxmag(param0.s6, param1.s6), maxmag(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 maxmag (float16 param0, float16 param1)\n"
"{return (float16)(maxmag(param0.s0, param1.s0), maxmag(param0.s1, param1.s1),\n"
"                  maxmag(param0.s2, param1.s2), maxmag(param0.s3, param1.s3),\n"
"                  maxmag(param0.s4, param1.s4), maxmag(param0.s5, param1.s5),\n"
"                  maxmag(param0.s6, param1.s6), maxmag(param0.s7, param1.s7),\n"
"                  maxmag(param0.s8, param1.s8), maxmag(param0.s9, param1.s9),\n"
"                  maxmag(param0.sa, param1.sa), maxmag(param0.sb, param1.sb),\n"
"                  maxmag(param0.sc, param1.sc), maxmag(param0.sd, param1.sd),\n"
"                  maxmag(param0.se, param1.se), maxmag(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype minmag (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 minmag (float2 param0, float2 param1)\n"
"{return (float2)(minmag(param0.s0, param1.s0), minmag(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 minmag (float3 param0, float3 param1)\n"
"{return (float3)(minmag(param0.s0, param1.s0), minmag(param0.s1, param1.s1),\n"
"                 minmag(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 minmag (float4 param0, float4 param1)\n"
"{return (float4)(minmag(param0.s0, param1.s0), minmag(param0.s1, param1.s1),\n"
"                 minmag(param0.s2, param1.s2), minmag(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 minmag (float8 param0, float8 param1)\n"
"{return (float8)(minmag(param0.s0, param1.s0), minmag(param0.s1, param1.s1),\n"
"                 minmag(param0.s2, param1.s2), minmag(param0.s3, param1.s3),\n"
"                 minmag(param0.s4, param1.s4), minmag(param0.s5, param1.s5),\n"
"                 minmag(param0.s6, param1.s6), minmag(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 minmag (float16 param0, float16 param1)\n"
"{return (float16)(minmag(param0.s0, param1.s0), minmag(param0.s1, param1.s1),\n"
"                  minmag(param0.s2, param1.s2), minmag(param0.s3, param1.s3),\n"
"                  minmag(param0.s4, param1.s4), minmag(param0.s5, param1.s5),\n"
"                  minmag(param0.s6, param1.s6), minmag(param0.s7, param1.s7),\n"
"                  minmag(param0.s8, param1.s8), minmag(param0.s9, param1.s9),\n"
"                  minmag(param0.sa, param1.sa), minmag(param0.sb, param1.sb),\n"
"                  minmag(param0.sc, param1.sc), minmag(param0.sd, param1.sd),\n"
"                  minmag(param0.se, param1.se), minmag(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype modf (gentype x, __global gentype *iptr)\n"
"\n"
"INLINE_OVERLOADABLE float2 modf (float2 param0, __global float2 *param1)\n"
"{return (float2)(modf(param0.s0, (__global  float *)param1 +  0), modf(param0.s1, (__global  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 modf (float3 param0, __global float3 *param1)\n"
"{return (float3)(modf(param0.s0, (__global  float *)param1 +  0), modf(param0.s1, (__global  float *)param1 +  1),\n"
"                 modf(param0.s2, (__global  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 modf (float4 param0, __global float4 *param1)\n"
"{return (float4)(modf(param0.s0, (__global  float *)param1 +  0), modf(param0.s1, (__global  float *)param1 +  1),\n"
"                 modf(param0.s2, (__global  float *)param1 +  2), modf(param0.s3, (__global  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 modf (float8 param0, __global float8 *param1)\n"
"{return (float8)(modf(param0.s0, (__global  float *)param1 +  0), modf(param0.s1, (__global  float *)param1 +  1),\n"
"                 modf(param0.s2, (__global  float *)param1 +  2), modf(param0.s3, (__global  float *)param1 +  3),\n"
"                 modf(param0.s4, (__global  float *)param1 +  4), modf(param0.s5, (__global  float *)param1 +  5),\n"
"                 modf(param0.s6, (__global  float *)param1 +  6), modf(param0.s7, (__global  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 modf (float16 param0, __global float16 *param1)\n"
"{return (float16)(modf(param0.s0, (__global  float *)param1 +  0), modf(param0.s1, (__global  float *)param1 +  1),\n"
"                  modf(param0.s2, (__global  float *)param1 +  2), modf(param0.s3, (__global  float *)param1 +  3),\n"
"                  modf(param0.s4, (__global  float *)param1 +  4), modf(param0.s5, (__global  float *)param1 +  5),\n"
"                  modf(param0.s6, (__global  float *)param1 +  6), modf(param0.s7, (__global  float *)param1 +  7),\n"
"                  modf(param0.s8, (__global  float *)param1 +  8), modf(param0.s9, (__global  float *)param1 +  9),\n"
"                  modf(param0.sa, (__global  float *)param1 + 10), modf(param0.sb, (__global  float *)param1 + 11),\n"
"                  modf(param0.sc, (__global  float *)param1 + 12), modf(param0.sd, (__global  float *)param1 + 13),\n"
"                  modf(param0.se, (__global  float *)param1 + 14), modf(param0.sf, (__global  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype modf (gentype x, __local gentype *iptr)\n"
"\n"
"INLINE_OVERLOADABLE float2 modf (float2 param0, __local float2 *param1)\n"
"{return (float2)(modf(param0.s0, (__local  float *)param1 +  0), modf(param0.s1, (__local  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 modf (float3 param0, __local float3 *param1)\n"
"{return (float3)(modf(param0.s0, (__local  float *)param1 +  0), modf(param0.s1, (__local  float *)param1 +  1),\n"
"                 modf(param0.s2, (__local  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 modf (float4 param0, __local float4 *param1)\n"
"{return (float4)(modf(param0.s0, (__local  float *)param1 +  0), modf(param0.s1, (__local  float *)param1 +  1),\n"
"                 modf(param0.s2, (__local  float *)param1 +  2), modf(param0.s3, (__local  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 modf (float8 param0, __local float8 *param1)\n"
"{return (float8)(modf(param0.s0, (__local  float *)param1 +  0), modf(param0.s1, (__local  float *)param1 +  1),\n"
"                 modf(param0.s2, (__local  float *)param1 +  2), modf(param0.s3, (__local  float *)param1 +  3),\n"
"                 modf(param0.s4, (__local  float *)param1 +  4), modf(param0.s5, (__local  float *)param1 +  5),\n"
"                 modf(param0.s6, (__local  float *)param1 +  6), modf(param0.s7, (__local  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 modf (float16 param0, __local float16 *param1)\n"
"{return (float16)(modf(param0.s0, (__local  float *)param1 +  0), modf(param0.s1, (__local  float *)param1 +  1),\n"
"                  modf(param0.s2, (__local  float *)param1 +  2), modf(param0.s3, (__local  float *)param1 +  3),\n"
"                  modf(param0.s4, (__local  float *)param1 +  4), modf(param0.s5, (__local  float *)param1 +  5),\n"
"                  modf(param0.s6, (__local  float *)param1 +  6), modf(param0.s7, (__local  float *)param1 +  7),\n"
"                  modf(param0.s8, (__local  float *)param1 +  8), modf(param0.s9, (__local  float *)param1 +  9),\n"
"                  modf(param0.sa, (__local  float *)param1 + 10), modf(param0.sb, (__local  float *)param1 + 11),\n"
"                  modf(param0.sc, (__local  float *)param1 + 12), modf(param0.sd, (__local  float *)param1 + 13),\n"
"                  modf(param0.se, (__local  float *)param1 + 14), modf(param0.sf, (__local  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype modf (gentype x, __private gentype *iptr)\n"
"\n"
"INLINE_OVERLOADABLE float2 modf (float2 param0, __private float2 *param1)\n"
"{return (float2)(modf(param0.s0, (__private  float *)param1 +  0), modf(param0.s1, (__private  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 modf (float3 param0, __private float3 *param1)\n"
"{return (float3)(modf(param0.s0, (__private  float *)param1 +  0), modf(param0.s1, (__private  float *)param1 +  1),\n"
"                 modf(param0.s2, (__private  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 modf (float4 param0, __private float4 *param1)\n"
"{return (float4)(modf(param0.s0, (__private  float *)param1 +  0), modf(param0.s1, (__private  float *)param1 +  1),\n"
"                 modf(param0.s2, (__private  float *)param1 +  2), modf(param0.s3, (__private  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 modf (float8 param0, __private float8 *param1)\n"
"{return (float8)(modf(param0.s0, (__private  float *)param1 +  0), modf(param0.s1, (__private  float *)param1 +  1),\n"
"                 modf(param0.s2, (__private  float *)param1 +  2), modf(param0.s3, (__private  float *)param1 +  3),\n"
"                 modf(param0.s4, (__private  float *)param1 +  4), modf(param0.s5, (__private  float *)param1 +  5),\n"
"                 modf(param0.s6, (__private  float *)param1 +  6), modf(param0.s7, (__private  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 modf (float16 param0, __private float16 *param1)\n"
"{return (float16)(modf(param0.s0, (__private  float *)param1 +  0), modf(param0.s1, (__private  float *)param1 +  1),\n"
"                  modf(param0.s2, (__private  float *)param1 +  2), modf(param0.s3, (__private  float *)param1 +  3),\n"
"                  modf(param0.s4, (__private  float *)param1 +  4), modf(param0.s5, (__private  float *)param1 +  5),\n"
"                  modf(param0.s6, (__private  float *)param1 +  6), modf(param0.s7, (__private  float *)param1 +  7),\n"
"                  modf(param0.s8, (__private  float *)param1 +  8), modf(param0.s9, (__private  float *)param1 +  9),\n"
"                  modf(param0.sa, (__private  float *)param1 + 10), modf(param0.sb, (__private  float *)param1 + 11),\n"
"                  modf(param0.sc, (__private  float *)param1 + 12), modf(param0.sd, (__private  float *)param1 + 13),\n"
"                  modf(param0.se, (__private  float *)param1 + 14), modf(param0.sf, (__private  float *)param1 + 15)); }\n"
"\n"
"\n"
"//floatn nan (uintn nancode)\n"
"\n"
"INLINE_OVERLOADABLE float2 nan (uint2 param0)\n"
"{return (float2)(nan(param0.s0), nan(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 nan (uint3 param0)\n"
"{return (float3)(nan(param0.s0), nan(param0.s1),\n"
"                 nan(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 nan (uint4 param0)\n"
"{return (float4)(nan(param0.s0), nan(param0.s1),\n"
"                 nan(param0.s2), nan(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 nan (uint8 param0)\n"
"{return (float8)(nan(param0.s0), nan(param0.s1),\n"
"                 nan(param0.s2), nan(param0.s3),\n"
"                 nan(param0.s4), nan(param0.s5),\n"
"                 nan(param0.s6), nan(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 nan (uint16 param0)\n"
"{return (float16)(nan(param0.s0), nan(param0.s1),\n"
"                  nan(param0.s2), nan(param0.s3),\n"
"                  nan(param0.s4), nan(param0.s5),\n"
"                  nan(param0.s6), nan(param0.s7),\n"
"                  nan(param0.s8), nan(param0.s9),\n"
"                  nan(param0.sa), nan(param0.sb),\n"
"                  nan(param0.sc), nan(param0.sd),\n"
"                  nan(param0.se), nan(param0.sf)); }\n"
"\n"
"\n"
"//float nan (uint nancode)\n"
"\n"
"\n"
"//doublen nan (ulongn nancode)\n"
"\n"
"\n"
"//double nan (ulong nancode)\n"
"\n"
"\n"
"//gentype nextafter (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 nextafter (float2 param0, float2 param1)\n"
"{return (float2)(nextafter(param0.s0, param1.s0), nextafter(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 nextafter (float3 param0, float3 param1)\n"
"{return (float3)(nextafter(param0.s0, param1.s0), nextafter(param0.s1, param1.s1),\n"
"                 nextafter(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 nextafter (float4 param0, float4 param1)\n"
"{return (float4)(nextafter(param0.s0, param1.s0), nextafter(param0.s1, param1.s1),\n"
"                 nextafter(param0.s2, param1.s2), nextafter(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 nextafter (float8 param0, float8 param1)\n"
"{return (float8)(nextafter(param0.s0, param1.s0), nextafter(param0.s1, param1.s1),\n"
"                 nextafter(param0.s2, param1.s2), nextafter(param0.s3, param1.s3),\n"
"                 nextafter(param0.s4, param1.s4), nextafter(param0.s5, param1.s5),\n"
"                 nextafter(param0.s6, param1.s6), nextafter(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 nextafter (float16 param0, float16 param1)\n"
"{return (float16)(nextafter(param0.s0, param1.s0), nextafter(param0.s1, param1.s1),\n"
"                  nextafter(param0.s2, param1.s2), nextafter(param0.s3, param1.s3),\n"
"                  nextafter(param0.s4, param1.s4), nextafter(param0.s5, param1.s5),\n"
"                  nextafter(param0.s6, param1.s6), nextafter(param0.s7, param1.s7),\n"
"                  nextafter(param0.s8, param1.s8), nextafter(param0.s9, param1.s9),\n"
"                  nextafter(param0.sa, param1.sa), nextafter(param0.sb, param1.sb),\n"
"                  nextafter(param0.sc, param1.sc), nextafter(param0.sd, param1.sd),\n"
"                  nextafter(param0.se, param1.se), nextafter(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype pow (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 pow (float2 param0, float2 param1)\n"
"{return (float2)(pow(param0.s0, param1.s0), pow(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 pow (float3 param0, float3 param1)\n"
"{return (float3)(pow(param0.s0, param1.s0), pow(param0.s1, param1.s1),\n"
"                 pow(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 pow (float4 param0, float4 param1)\n"
"{return (float4)(pow(param0.s0, param1.s0), pow(param0.s1, param1.s1),\n"
"                 pow(param0.s2, param1.s2), pow(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 pow (float8 param0, float8 param1)\n"
"{return (float8)(pow(param0.s0, param1.s0), pow(param0.s1, param1.s1),\n"
"                 pow(param0.s2, param1.s2), pow(param0.s3, param1.s3),\n"
"                 pow(param0.s4, param1.s4), pow(param0.s5, param1.s5),\n"
"                 pow(param0.s6, param1.s6), pow(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 pow (float16 param0, float16 param1)\n"
"{return (float16)(pow(param0.s0, param1.s0), pow(param0.s1, param1.s1),\n"
"                  pow(param0.s2, param1.s2), pow(param0.s3, param1.s3),\n"
"                  pow(param0.s4, param1.s4), pow(param0.s5, param1.s5),\n"
"                  pow(param0.s6, param1.s6), pow(param0.s7, param1.s7),\n"
"                  pow(param0.s8, param1.s8), pow(param0.s9, param1.s9),\n"
"                  pow(param0.sa, param1.sa), pow(param0.sb, param1.sb),\n"
"                  pow(param0.sc, param1.sc), pow(param0.sd, param1.sd),\n"
"                  pow(param0.se, param1.se), pow(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//floatn pown (floatn x, intn y)\n"
"\n"
"INLINE_OVERLOADABLE float2 pown (float2 param0, int2 param1)\n"
"{return (float2)(pown(param0.s0, param1.s0), pown(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 pown (float3 param0, int3 param1)\n"
"{return (float3)(pown(param0.s0, param1.s0), pown(param0.s1, param1.s1),\n"
"                 pown(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 pown (float4 param0, int4 param1)\n"
"{return (float4)(pown(param0.s0, param1.s0), pown(param0.s1, param1.s1),\n"
"                 pown(param0.s2, param1.s2), pown(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 pown (float8 param0, int8 param1)\n"
"{return (float8)(pown(param0.s0, param1.s0), pown(param0.s1, param1.s1),\n"
"                 pown(param0.s2, param1.s2), pown(param0.s3, param1.s3),\n"
"                 pown(param0.s4, param1.s4), pown(param0.s5, param1.s5),\n"
"                 pown(param0.s6, param1.s6), pown(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 pown (float16 param0, int16 param1)\n"
"{return (float16)(pown(param0.s0, param1.s0), pown(param0.s1, param1.s1),\n"
"                  pown(param0.s2, param1.s2), pown(param0.s3, param1.s3),\n"
"                  pown(param0.s4, param1.s4), pown(param0.s5, param1.s5),\n"
"                  pown(param0.s6, param1.s6), pown(param0.s7, param1.s7),\n"
"                  pown(param0.s8, param1.s8), pown(param0.s9, param1.s9),\n"
"                  pown(param0.sa, param1.sa), pown(param0.sb, param1.sb),\n"
"                  pown(param0.sc, param1.sc), pown(param0.sd, param1.sd),\n"
"                  pown(param0.se, param1.se), pown(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//float pown (float x, int y)\n"
"\n"
"\n"
"//doublen pown (doublen x, intn y)\n"
"\n"
"\n"
"//double pown (double x, int y)\n"
"\n"
"\n"
"//gentype remainder (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 remainder (float2 param0, float2 param1)\n"
"{return (float2)(remainder(param0.s0, param1.s0), remainder(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 remainder (float3 param0, float3 param1)\n"
"{return (float3)(remainder(param0.s0, param1.s0), remainder(param0.s1, param1.s1),\n"
"                 remainder(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 remainder (float4 param0, float4 param1)\n"
"{return (float4)(remainder(param0.s0, param1.s0), remainder(param0.s1, param1.s1),\n"
"                 remainder(param0.s2, param1.s2), remainder(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 remainder (float8 param0, float8 param1)\n"
"{return (float8)(remainder(param0.s0, param1.s0), remainder(param0.s1, param1.s1),\n"
"                 remainder(param0.s2, param1.s2), remainder(param0.s3, param1.s3),\n"
"                 remainder(param0.s4, param1.s4), remainder(param0.s5, param1.s5),\n"
"                 remainder(param0.s6, param1.s6), remainder(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 remainder (float16 param0, float16 param1)\n"
"{return (float16)(remainder(param0.s0, param1.s0), remainder(param0.s1, param1.s1),\n"
"                  remainder(param0.s2, param1.s2), remainder(param0.s3, param1.s3),\n"
"                  remainder(param0.s4, param1.s4), remainder(param0.s5, param1.s5),\n"
"                  remainder(param0.s6, param1.s6), remainder(param0.s7, param1.s7),\n"
"                  remainder(param0.s8, param1.s8), remainder(param0.s9, param1.s9),\n"
"                  remainder(param0.sa, param1.sa), remainder(param0.sb, param1.sb),\n"
"                  remainder(param0.sc, param1.sc), remainder(param0.sd, param1.sd),\n"
"                  remainder(param0.se, param1.se), remainder(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//floatn remquo (floatn x, floatn y, __global intn *quo)\n"
"\n"
"INLINE_OVERLOADABLE float2 remquo (float2 param0, float2 param1, __global int2 *param2)\n"
"{return (float2)(remquo(param0.s0, param1.s0, (__global  int *)param2 +  0), remquo(param0.s1, param1.s1, (__global  int *)param2 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 remquo (float3 param0, float3 param1, __global int3 *param2)\n"
"{return (float3)(remquo(param0.s0, param1.s0, (__global  int *)param2 +  0), remquo(param0.s1, param1.s1, (__global  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__global  int *)param2 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 remquo (float4 param0, float4 param1, __global int4 *param2)\n"
"{return (float4)(remquo(param0.s0, param1.s0, (__global  int *)param2 +  0), remquo(param0.s1, param1.s1, (__global  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__global  int *)param2 +  2), remquo(param0.s3, param1.s3, (__global  int *)param2 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 remquo (float8 param0, float8 param1, __global int8 *param2)\n"
"{return (float8)(remquo(param0.s0, param1.s0, (__global  int *)param2 +  0), remquo(param0.s1, param1.s1, (__global  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__global  int *)param2 +  2), remquo(param0.s3, param1.s3, (__global  int *)param2 +  3),\n"
"                 remquo(param0.s4, param1.s4, (__global  int *)param2 +  4), remquo(param0.s5, param1.s5, (__global  int *)param2 +  5),\n"
"                 remquo(param0.s6, param1.s6, (__global  int *)param2 +  6), remquo(param0.s7, param1.s7, (__global  int *)param2 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 remquo (float16 param0, float16 param1, __global int16 *param2)\n"
"{return (float16)(remquo(param0.s0, param1.s0, (__global  int *)param2 +  0), remquo(param0.s1, param1.s1, (__global  int *)param2 +  1),\n"
"                  remquo(param0.s2, param1.s2, (__global  int *)param2 +  2), remquo(param0.s3, param1.s3, (__global  int *)param2 +  3),\n"
"                  remquo(param0.s4, param1.s4, (__global  int *)param2 +  4), remquo(param0.s5, param1.s5, (__global  int *)param2 +  5),\n"
"                  remquo(param0.s6, param1.s6, (__global  int *)param2 +  6), remquo(param0.s7, param1.s7, (__global  int *)param2 +  7),\n"
"                  remquo(param0.s8, param1.s8, (__global  int *)param2 +  8), remquo(param0.s9, param1.s9, (__global  int *)param2 +  9),\n"
"                  remquo(param0.sa, param1.sa, (__global  int *)param2 + 10), remquo(param0.sb, param1.sb, (__global  int *)param2 + 11),\n"
"                  remquo(param0.sc, param1.sc, (__global  int *)param2 + 12), remquo(param0.sd, param1.sd, (__global  int *)param2 + 13),\n"
"                  remquo(param0.se, param1.se, (__global  int *)param2 + 14), remquo(param0.sf, param1.sf, (__global  int *)param2 + 15)); }\n"
"\n"
"\n"
"//floatn remquo (floatn x, floatn y, __local intn *quo)\n"
"\n"
"INLINE_OVERLOADABLE float2 remquo (float2 param0, float2 param1, __local int2 *param2)\n"
"{return (float2)(remquo(param0.s0, param1.s0, (__local  int *)param2 +  0), remquo(param0.s1, param1.s1, (__local  int *)param2 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 remquo (float3 param0, float3 param1, __local int3 *param2)\n"
"{return (float3)(remquo(param0.s0, param1.s0, (__local  int *)param2 +  0), remquo(param0.s1, param1.s1, (__local  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__local  int *)param2 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 remquo (float4 param0, float4 param1, __local int4 *param2)\n"
"{return (float4)(remquo(param0.s0, param1.s0, (__local  int *)param2 +  0), remquo(param0.s1, param1.s1, (__local  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__local  int *)param2 +  2), remquo(param0.s3, param1.s3, (__local  int *)param2 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 remquo (float8 param0, float8 param1, __local int8 *param2)\n"
"{return (float8)(remquo(param0.s0, param1.s0, (__local  int *)param2 +  0), remquo(param0.s1, param1.s1, (__local  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__local  int *)param2 +  2), remquo(param0.s3, param1.s3, (__local  int *)param2 +  3),\n"
"                 remquo(param0.s4, param1.s4, (__local  int *)param2 +  4), remquo(param0.s5, param1.s5, (__local  int *)param2 +  5),\n"
"                 remquo(param0.s6, param1.s6, (__local  int *)param2 +  6), remquo(param0.s7, param1.s7, (__local  int *)param2 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 remquo (float16 param0, float16 param1, __local int16 *param2)\n"
"{return (float16)(remquo(param0.s0, param1.s0, (__local  int *)param2 +  0), remquo(param0.s1, param1.s1, (__local  int *)param2 +  1),\n"
"                  remquo(param0.s2, param1.s2, (__local  int *)param2 +  2), remquo(param0.s3, param1.s3, (__local  int *)param2 +  3),\n"
"                  remquo(param0.s4, param1.s4, (__local  int *)param2 +  4), remquo(param0.s5, param1.s5, (__local  int *)param2 +  5),\n"
"                  remquo(param0.s6, param1.s6, (__local  int *)param2 +  6), remquo(param0.s7, param1.s7, (__local  int *)param2 +  7),\n"
"                  remquo(param0.s8, param1.s8, (__local  int *)param2 +  8), remquo(param0.s9, param1.s9, (__local  int *)param2 +  9),\n"
"                  remquo(param0.sa, param1.sa, (__local  int *)param2 + 10), remquo(param0.sb, param1.sb, (__local  int *)param2 + 11),\n"
"                  remquo(param0.sc, param1.sc, (__local  int *)param2 + 12), remquo(param0.sd, param1.sd, (__local  int *)param2 + 13),\n"
"                  remquo(param0.se, param1.se, (__local  int *)param2 + 14), remquo(param0.sf, param1.sf, (__local  int *)param2 + 15)); }\n"
"\n"
"\n"
"//floatn remquo (floatn x, floatn y, __private intn *quo)\n"
"\n"
"INLINE_OVERLOADABLE float2 remquo (float2 param0, float2 param1, __private int2 *param2)\n"
"{return (float2)(remquo(param0.s0, param1.s0, (__private  int *)param2 +  0), remquo(param0.s1, param1.s1, (__private  int *)param2 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 remquo (float3 param0, float3 param1, __private int3 *param2)\n"
"{return (float3)(remquo(param0.s0, param1.s0, (__private  int *)param2 +  0), remquo(param0.s1, param1.s1, (__private  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__private  int *)param2 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 remquo (float4 param0, float4 param1, __private int4 *param2)\n"
"{return (float4)(remquo(param0.s0, param1.s0, (__private  int *)param2 +  0), remquo(param0.s1, param1.s1, (__private  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__private  int *)param2 +  2), remquo(param0.s3, param1.s3, (__private  int *)param2 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 remquo (float8 param0, float8 param1, __private int8 *param2)\n"
"{return (float8)(remquo(param0.s0, param1.s0, (__private  int *)param2 +  0), remquo(param0.s1, param1.s1, (__private  int *)param2 +  1),\n"
"                 remquo(param0.s2, param1.s2, (__private  int *)param2 +  2), remquo(param0.s3, param1.s3, (__private  int *)param2 +  3),\n"
"                 remquo(param0.s4, param1.s4, (__private  int *)param2 +  4), remquo(param0.s5, param1.s5, (__private  int *)param2 +  5),\n"
"                 remquo(param0.s6, param1.s6, (__private  int *)param2 +  6), remquo(param0.s7, param1.s7, (__private  int *)param2 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 remquo (float16 param0, float16 param1, __private int16 *param2)\n"
"{return (float16)(remquo(param0.s0, param1.s0, (__private  int *)param2 +  0), remquo(param0.s1, param1.s1, (__private  int *)param2 +  1),\n"
"                  remquo(param0.s2, param1.s2, (__private  int *)param2 +  2), remquo(param0.s3, param1.s3, (__private  int *)param2 +  3),\n"
"                  remquo(param0.s4, param1.s4, (__private  int *)param2 +  4), remquo(param0.s5, param1.s5, (__private  int *)param2 +  5),\n"
"                  remquo(param0.s6, param1.s6, (__private  int *)param2 +  6), remquo(param0.s7, param1.s7, (__private  int *)param2 +  7),\n"
"                  remquo(param0.s8, param1.s8, (__private  int *)param2 +  8), remquo(param0.s9, param1.s9, (__private  int *)param2 +  9),\n"
"                  remquo(param0.sa, param1.sa, (__private  int *)param2 + 10), remquo(param0.sb, param1.sb, (__private  int *)param2 + 11),\n"
"                  remquo(param0.sc, param1.sc, (__private  int *)param2 + 12), remquo(param0.sd, param1.sd, (__private  int *)param2 + 13),\n"
"                  remquo(param0.se, param1.se, (__private  int *)param2 + 14), remquo(param0.sf, param1.sf, (__private  int *)param2 + 15)); }\n"
"\n"
"\n"
"//float remquo (float x, float y, __global int *quo)\n"
"\n"
"\n"
"//float remquo (float x, float y, __local int *quo)\n"
"\n"
"\n"
"//float remquo (float x, float y, __private int *quo)\n"
"\n"
"\n"
"//doublen remquo (doublen x, doublen y, __global intn *quo)\n"
"\n"
"\n"
"//doublen remquo (doublen x, doublen y, __local intn *quo)\n"
"\n"
"\n"
"//doublen remquo (doublen x, doublen y, __private intn *quo)\n"
"\n"
"\n"
"//double remquo (double x, double y, __global int *quo)\n"
"\n"
"\n"
"//double remquo (double x, double y, __local int *quo)\n"
"\n"
"\n"
"//double remquo (double x, double y, __private int *quo)\n"
"\n"
"\n"
"//gentype rint (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 rint (float2 param0)\n"
"{return (float2)(rint(param0.s0), rint(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 rint (float3 param0)\n"
"{return (float3)(rint(param0.s0), rint(param0.s1),\n"
"                 rint(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 rint (float4 param0)\n"
"{return (float4)(rint(param0.s0), rint(param0.s1),\n"
"                 rint(param0.s2), rint(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 rint (float8 param0)\n"
"{return (float8)(rint(param0.s0), rint(param0.s1),\n"
"                 rint(param0.s2), rint(param0.s3),\n"
"                 rint(param0.s4), rint(param0.s5),\n"
"                 rint(param0.s6), rint(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 rint (float16 param0)\n"
"{return (float16)(rint(param0.s0), rint(param0.s1),\n"
"                  rint(param0.s2), rint(param0.s3),\n"
"                  rint(param0.s4), rint(param0.s5),\n"
"                  rint(param0.s6), rint(param0.s7),\n"
"                  rint(param0.s8), rint(param0.s9),\n"
"                  rint(param0.sa), rint(param0.sb),\n"
"                  rint(param0.sc), rint(param0.sd),\n"
"                  rint(param0.se), rint(param0.sf)); }\n"
"\n"
"\n"
"//floatn rootn (floatn x, intn y)\n"
"\n"
"INLINE_OVERLOADABLE float2 rootn (float2 param0, int2 param1)\n"
"{return (float2)(rootn(param0.s0, param1.s0), rootn(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 rootn (float3 param0, int3 param1)\n"
"{return (float3)(rootn(param0.s0, param1.s0), rootn(param0.s1, param1.s1),\n"
"                 rootn(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 rootn (float4 param0, int4 param1)\n"
"{return (float4)(rootn(param0.s0, param1.s0), rootn(param0.s1, param1.s1),\n"
"                 rootn(param0.s2, param1.s2), rootn(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 rootn (float8 param0, int8 param1)\n"
"{return (float8)(rootn(param0.s0, param1.s0), rootn(param0.s1, param1.s1),\n"
"                 rootn(param0.s2, param1.s2), rootn(param0.s3, param1.s3),\n"
"                 rootn(param0.s4, param1.s4), rootn(param0.s5, param1.s5),\n"
"                 rootn(param0.s6, param1.s6), rootn(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 rootn (float16 param0, int16 param1)\n"
"{return (float16)(rootn(param0.s0, param1.s0), rootn(param0.s1, param1.s1),\n"
"                  rootn(param0.s2, param1.s2), rootn(param0.s3, param1.s3),\n"
"                  rootn(param0.s4, param1.s4), rootn(param0.s5, param1.s5),\n"
"                  rootn(param0.s6, param1.s6), rootn(param0.s7, param1.s7),\n"
"                  rootn(param0.s8, param1.s8), rootn(param0.s9, param1.s9),\n"
"                  rootn(param0.sa, param1.sa), rootn(param0.sb, param1.sb),\n"
"                  rootn(param0.sc, param1.sc), rootn(param0.sd, param1.sd),\n"
"                  rootn(param0.se, param1.se), rootn(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//doublen rootn (doublen x, intn y)\n"
"\n"
"\n"
"//doublen rootn (double x, int y)\n"
"\n"
"\n"
"//gentype round (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 round (float2 param0)\n"
"{return (float2)(round(param0.s0), round(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 round (float3 param0)\n"
"{return (float3)(round(param0.s0), round(param0.s1),\n"
"                 round(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 round (float4 param0)\n"
"{return (float4)(round(param0.s0), round(param0.s1),\n"
"                 round(param0.s2), round(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 round (float8 param0)\n"
"{return (float8)(round(param0.s0), round(param0.s1),\n"
"                 round(param0.s2), round(param0.s3),\n"
"                 round(param0.s4), round(param0.s5),\n"
"                 round(param0.s6), round(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 round (float16 param0)\n"
"{return (float16)(round(param0.s0), round(param0.s1),\n"
"                  round(param0.s2), round(param0.s3),\n"
"                  round(param0.s4), round(param0.s5),\n"
"                  round(param0.s6), round(param0.s7),\n"
"                  round(param0.s8), round(param0.s9),\n"
"                  round(param0.sa), round(param0.sb),\n"
"                  round(param0.sc), round(param0.sd),\n"
"                  round(param0.se), round(param0.sf)); }\n"
"\n"
"\n"
"//gentype rsqrt (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 rsqrt (float2 param0)\n"
"{return (float2)(rsqrt(param0.s0), rsqrt(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 rsqrt (float3 param0)\n"
"{return (float3)(rsqrt(param0.s0), rsqrt(param0.s1),\n"
"                 rsqrt(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 rsqrt (float4 param0)\n"
"{return (float4)(rsqrt(param0.s0), rsqrt(param0.s1),\n"
"                 rsqrt(param0.s2), rsqrt(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 rsqrt (float8 param0)\n"
"{return (float8)(rsqrt(param0.s0), rsqrt(param0.s1),\n"
"                 rsqrt(param0.s2), rsqrt(param0.s3),\n"
"                 rsqrt(param0.s4), rsqrt(param0.s5),\n"
"                 rsqrt(param0.s6), rsqrt(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 rsqrt (float16 param0)\n"
"{return (float16)(rsqrt(param0.s0), rsqrt(param0.s1),\n"
"                  rsqrt(param0.s2), rsqrt(param0.s3),\n"
"                  rsqrt(param0.s4), rsqrt(param0.s5),\n"
"                  rsqrt(param0.s6), rsqrt(param0.s7),\n"
"                  rsqrt(param0.s8), rsqrt(param0.s9),\n"
"                  rsqrt(param0.sa), rsqrt(param0.sb),\n"
"                  rsqrt(param0.sc), rsqrt(param0.sd),\n"
"                  rsqrt(param0.se), rsqrt(param0.sf)); }\n"
"\n"
"\n"
"//gentype sin (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 sin (float2 param0)\n"
"{return (float2)(sin(param0.s0), sin(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 sin (float3 param0)\n"
"{return (float3)(sin(param0.s0), sin(param0.s1),\n"
"                 sin(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 sin (float4 param0)\n"
"{return (float4)(sin(param0.s0), sin(param0.s1),\n"
"                 sin(param0.s2), sin(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 sin (float8 param0)\n"
"{return (float8)(sin(param0.s0), sin(param0.s1),\n"
"                 sin(param0.s2), sin(param0.s3),\n"
"                 sin(param0.s4), sin(param0.s5),\n"
"                 sin(param0.s6), sin(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 sin (float16 param0)\n"
"{return (float16)(sin(param0.s0), sin(param0.s1),\n"
"                  sin(param0.s2), sin(param0.s3),\n"
"                  sin(param0.s4), sin(param0.s5),\n"
"                  sin(param0.s6), sin(param0.s7),\n"
"                  sin(param0.s8), sin(param0.s9),\n"
"                  sin(param0.sa), sin(param0.sb),\n"
"                  sin(param0.sc), sin(param0.sd),\n"
"                  sin(param0.se), sin(param0.sf)); }\n"
"\n"
"\n"
"//gentype sincos (gentype x, __global gentype *cosval)\n"
"\n"
"INLINE_OVERLOADABLE float2 sincos (float2 param0, __global float2 *param1)\n"
"{return (float2)(sincos(param0.s0, (__global  float *)param1 +  0), sincos(param0.s1, (__global  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 sincos (float3 param0, __global float3 *param1)\n"
"{return (float3)(sincos(param0.s0, (__global  float *)param1 +  0), sincos(param0.s1, (__global  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__global  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 sincos (float4 param0, __global float4 *param1)\n"
"{return (float4)(sincos(param0.s0, (__global  float *)param1 +  0), sincos(param0.s1, (__global  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__global  float *)param1 +  2), sincos(param0.s3, (__global  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 sincos (float8 param0, __global float8 *param1)\n"
"{return (float8)(sincos(param0.s0, (__global  float *)param1 +  0), sincos(param0.s1, (__global  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__global  float *)param1 +  2), sincos(param0.s3, (__global  float *)param1 +  3),\n"
"                 sincos(param0.s4, (__global  float *)param1 +  4), sincos(param0.s5, (__global  float *)param1 +  5),\n"
"                 sincos(param0.s6, (__global  float *)param1 +  6), sincos(param0.s7, (__global  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 sincos (float16 param0, __global float16 *param1)\n"
"{return (float16)(sincos(param0.s0, (__global  float *)param1 +  0), sincos(param0.s1, (__global  float *)param1 +  1),\n"
"                  sincos(param0.s2, (__global  float *)param1 +  2), sincos(param0.s3, (__global  float *)param1 +  3),\n"
"                  sincos(param0.s4, (__global  float *)param1 +  4), sincos(param0.s5, (__global  float *)param1 +  5),\n"
"                  sincos(param0.s6, (__global  float *)param1 +  6), sincos(param0.s7, (__global  float *)param1 +  7),\n"
"                  sincos(param0.s8, (__global  float *)param1 +  8), sincos(param0.s9, (__global  float *)param1 +  9),\n"
"                  sincos(param0.sa, (__global  float *)param1 + 10), sincos(param0.sb, (__global  float *)param1 + 11),\n"
"                  sincos(param0.sc, (__global  float *)param1 + 12), sincos(param0.sd, (__global  float *)param1 + 13),\n"
"                  sincos(param0.se, (__global  float *)param1 + 14), sincos(param0.sf, (__global  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype sincos (gentype x, __local gentype *cosval)\n"
"\n"
"INLINE_OVERLOADABLE float2 sincos (float2 param0, __local float2 *param1)\n"
"{return (float2)(sincos(param0.s0, (__local  float *)param1 +  0), sincos(param0.s1, (__local  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 sincos (float3 param0, __local float3 *param1)\n"
"{return (float3)(sincos(param0.s0, (__local  float *)param1 +  0), sincos(param0.s1, (__local  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__local  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 sincos (float4 param0, __local float4 *param1)\n"
"{return (float4)(sincos(param0.s0, (__local  float *)param1 +  0), sincos(param0.s1, (__local  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__local  float *)param1 +  2), sincos(param0.s3, (__local  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 sincos (float8 param0, __local float8 *param1)\n"
"{return (float8)(sincos(param0.s0, (__local  float *)param1 +  0), sincos(param0.s1, (__local  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__local  float *)param1 +  2), sincos(param0.s3, (__local  float *)param1 +  3),\n"
"                 sincos(param0.s4, (__local  float *)param1 +  4), sincos(param0.s5, (__local  float *)param1 +  5),\n"
"                 sincos(param0.s6, (__local  float *)param1 +  6), sincos(param0.s7, (__local  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 sincos (float16 param0, __local float16 *param1)\n"
"{return (float16)(sincos(param0.s0, (__local  float *)param1 +  0), sincos(param0.s1, (__local  float *)param1 +  1),\n"
"                  sincos(param0.s2, (__local  float *)param1 +  2), sincos(param0.s3, (__local  float *)param1 +  3),\n"
"                  sincos(param0.s4, (__local  float *)param1 +  4), sincos(param0.s5, (__local  float *)param1 +  5),\n"
"                  sincos(param0.s6, (__local  float *)param1 +  6), sincos(param0.s7, (__local  float *)param1 +  7),\n"
"                  sincos(param0.s8, (__local  float *)param1 +  8), sincos(param0.s9, (__local  float *)param1 +  9),\n"
"                  sincos(param0.sa, (__local  float *)param1 + 10), sincos(param0.sb, (__local  float *)param1 + 11),\n"
"                  sincos(param0.sc, (__local  float *)param1 + 12), sincos(param0.sd, (__local  float *)param1 + 13),\n"
"                  sincos(param0.se, (__local  float *)param1 + 14), sincos(param0.sf, (__local  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype sincos (gentype x, __private gentype *cosval)\n"
"\n"
"INLINE_OVERLOADABLE float2 sincos (float2 param0, __private float2 *param1)\n"
"{return (float2)(sincos(param0.s0, (__private  float *)param1 +  0), sincos(param0.s1, (__private  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 sincos (float3 param0, __private float3 *param1)\n"
"{return (float3)(sincos(param0.s0, (__private  float *)param1 +  0), sincos(param0.s1, (__private  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__private  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 sincos (float4 param0, __private float4 *param1)\n"
"{return (float4)(sincos(param0.s0, (__private  float *)param1 +  0), sincos(param0.s1, (__private  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__private  float *)param1 +  2), sincos(param0.s3, (__private  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 sincos (float8 param0, __private float8 *param1)\n"
"{return (float8)(sincos(param0.s0, (__private  float *)param1 +  0), sincos(param0.s1, (__private  float *)param1 +  1),\n"
"                 sincos(param0.s2, (__private  float *)param1 +  2), sincos(param0.s3, (__private  float *)param1 +  3),\n"
"                 sincos(param0.s4, (__private  float *)param1 +  4), sincos(param0.s5, (__private  float *)param1 +  5),\n"
"                 sincos(param0.s6, (__private  float *)param1 +  6), sincos(param0.s7, (__private  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 sincos (float16 param0, __private float16 *param1)\n"
"{return (float16)(sincos(param0.s0, (__private  float *)param1 +  0), sincos(param0.s1, (__private  float *)param1 +  1),\n"
"                  sincos(param0.s2, (__private  float *)param1 +  2), sincos(param0.s3, (__private  float *)param1 +  3),\n"
"                  sincos(param0.s4, (__private  float *)param1 +  4), sincos(param0.s5, (__private  float *)param1 +  5),\n"
"                  sincos(param0.s6, (__private  float *)param1 +  6), sincos(param0.s7, (__private  float *)param1 +  7),\n"
"                  sincos(param0.s8, (__private  float *)param1 +  8), sincos(param0.s9, (__private  float *)param1 +  9),\n"
"                  sincos(param0.sa, (__private  float *)param1 + 10), sincos(param0.sb, (__private  float *)param1 + 11),\n"
"                  sincos(param0.sc, (__private  float *)param1 + 12), sincos(param0.sd, (__private  float *)param1 + 13),\n"
"                  sincos(param0.se, (__private  float *)param1 + 14), sincos(param0.sf, (__private  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype sinh (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 sinh (float2 param0)\n"
"{return (float2)(sinh(param0.s0), sinh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 sinh (float3 param0)\n"
"{return (float3)(sinh(param0.s0), sinh(param0.s1),\n"
"                 sinh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 sinh (float4 param0)\n"
"{return (float4)(sinh(param0.s0), sinh(param0.s1),\n"
"                 sinh(param0.s2), sinh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 sinh (float8 param0)\n"
"{return (float8)(sinh(param0.s0), sinh(param0.s1),\n"
"                 sinh(param0.s2), sinh(param0.s3),\n"
"                 sinh(param0.s4), sinh(param0.s5),\n"
"                 sinh(param0.s6), sinh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 sinh (float16 param0)\n"
"{return (float16)(sinh(param0.s0), sinh(param0.s1),\n"
"                  sinh(param0.s2), sinh(param0.s3),\n"
"                  sinh(param0.s4), sinh(param0.s5),\n"
"                  sinh(param0.s6), sinh(param0.s7),\n"
"                  sinh(param0.s8), sinh(param0.s9),\n"
"                  sinh(param0.sa), sinh(param0.sb),\n"
"                  sinh(param0.sc), sinh(param0.sd),\n"
"                  sinh(param0.se), sinh(param0.sf)); }\n"
"\n"
"\n"
"//gentype sinpi (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 sinpi (float2 param0)\n"
"{return (float2)(sinpi(param0.s0), sinpi(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 sinpi (float3 param0)\n"
"{return (float3)(sinpi(param0.s0), sinpi(param0.s1),\n"
"                 sinpi(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 sinpi (float4 param0)\n"
"{return (float4)(sinpi(param0.s0), sinpi(param0.s1),\n"
"                 sinpi(param0.s2), sinpi(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 sinpi (float8 param0)\n"
"{return (float8)(sinpi(param0.s0), sinpi(param0.s1),\n"
"                 sinpi(param0.s2), sinpi(param0.s3),\n"
"                 sinpi(param0.s4), sinpi(param0.s5),\n"
"                 sinpi(param0.s6), sinpi(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 sinpi (float16 param0)\n"
"{return (float16)(sinpi(param0.s0), sinpi(param0.s1),\n"
"                  sinpi(param0.s2), sinpi(param0.s3),\n"
"                  sinpi(param0.s4), sinpi(param0.s5),\n"
"                  sinpi(param0.s6), sinpi(param0.s7),\n"
"                  sinpi(param0.s8), sinpi(param0.s9),\n"
"                  sinpi(param0.sa), sinpi(param0.sb),\n"
"                  sinpi(param0.sc), sinpi(param0.sd),\n"
"                  sinpi(param0.se), sinpi(param0.sf)); }\n"
"\n"
"\n"
"//gentype sqrt (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 sqrt (float2 param0)\n"
"{return (float2)(sqrt(param0.s0), sqrt(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 sqrt (float3 param0)\n"
"{return (float3)(sqrt(param0.s0), sqrt(param0.s1),\n"
"                 sqrt(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 sqrt (float4 param0)\n"
"{return (float4)(sqrt(param0.s0), sqrt(param0.s1),\n"
"                 sqrt(param0.s2), sqrt(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 sqrt (float8 param0)\n"
"{return (float8)(sqrt(param0.s0), sqrt(param0.s1),\n"
"                 sqrt(param0.s2), sqrt(param0.s3),\n"
"                 sqrt(param0.s4), sqrt(param0.s5),\n"
"                 sqrt(param0.s6), sqrt(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 sqrt (float16 param0)\n"
"{return (float16)(sqrt(param0.s0), sqrt(param0.s1),\n"
"                  sqrt(param0.s2), sqrt(param0.s3),\n"
"                  sqrt(param0.s4), sqrt(param0.s5),\n"
"                  sqrt(param0.s6), sqrt(param0.s7),\n"
"                  sqrt(param0.s8), sqrt(param0.s9),\n"
"                  sqrt(param0.sa), sqrt(param0.sb),\n"
"                  sqrt(param0.sc), sqrt(param0.sd),\n"
"                  sqrt(param0.se), sqrt(param0.sf)); }\n"
"\n"
"\n"
"//gentype tan (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 tan (float2 param0)\n"
"{return (float2)(tan(param0.s0), tan(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 tan (float3 param0)\n"
"{return (float3)(tan(param0.s0), tan(param0.s1),\n"
"                 tan(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 tan (float4 param0)\n"
"{return (float4)(tan(param0.s0), tan(param0.s1),\n"
"                 tan(param0.s2), tan(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 tan (float8 param0)\n"
"{return (float8)(tan(param0.s0), tan(param0.s1),\n"
"                 tan(param0.s2), tan(param0.s3),\n"
"                 tan(param0.s4), tan(param0.s5),\n"
"                 tan(param0.s6), tan(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 tan (float16 param0)\n"
"{return (float16)(tan(param0.s0), tan(param0.s1),\n"
"                  tan(param0.s2), tan(param0.s3),\n"
"                  tan(param0.s4), tan(param0.s5),\n"
"                  tan(param0.s6), tan(param0.s7),\n"
"                  tan(param0.s8), tan(param0.s9),\n"
"                  tan(param0.sa), tan(param0.sb),\n"
"                  tan(param0.sc), tan(param0.sd),\n"
"                  tan(param0.se), tan(param0.sf)); }\n"
"\n"
"\n"
"//gentype tanh (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 tanh (float2 param0)\n"
"{return (float2)(tanh(param0.s0), tanh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 tanh (float3 param0)\n"
"{return (float3)(tanh(param0.s0), tanh(param0.s1),\n"
"                 tanh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 tanh (float4 param0)\n"
"{return (float4)(tanh(param0.s0), tanh(param0.s1),\n"
"                 tanh(param0.s2), tanh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 tanh (float8 param0)\n"
"{return (float8)(tanh(param0.s0), tanh(param0.s1),\n"
"                 tanh(param0.s2), tanh(param0.s3),\n"
"                 tanh(param0.s4), tanh(param0.s5),\n"
"                 tanh(param0.s6), tanh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 tanh (float16 param0)\n"
"{return (float16)(tanh(param0.s0), tanh(param0.s1),\n"
"                  tanh(param0.s2), tanh(param0.s3),\n"
"                  tanh(param0.s4), tanh(param0.s5),\n"
"                  tanh(param0.s6), tanh(param0.s7),\n"
"                  tanh(param0.s8), tanh(param0.s9),\n"
"                  tanh(param0.sa), tanh(param0.sb),\n"
"                  tanh(param0.sc), tanh(param0.sd),\n"
"                  tanh(param0.se), tanh(param0.sf)); }\n"
"\n"
"\n"
"//gentype tanpi (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 tanpi (float2 param0)\n"
"{return (float2)(tanpi(param0.s0), tanpi(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 tanpi (float3 param0)\n"
"{return (float3)(tanpi(param0.s0), tanpi(param0.s1),\n"
"                 tanpi(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 tanpi (float4 param0)\n"
"{return (float4)(tanpi(param0.s0), tanpi(param0.s1),\n"
"                 tanpi(param0.s2), tanpi(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 tanpi (float8 param0)\n"
"{return (float8)(tanpi(param0.s0), tanpi(param0.s1),\n"
"                 tanpi(param0.s2), tanpi(param0.s3),\n"
"                 tanpi(param0.s4), tanpi(param0.s5),\n"
"                 tanpi(param0.s6), tanpi(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 tanpi (float16 param0)\n"
"{return (float16)(tanpi(param0.s0), tanpi(param0.s1),\n"
"                  tanpi(param0.s2), tanpi(param0.s3),\n"
"                  tanpi(param0.s4), tanpi(param0.s5),\n"
"                  tanpi(param0.s6), tanpi(param0.s7),\n"
"                  tanpi(param0.s8), tanpi(param0.s9),\n"
"                  tanpi(param0.sa), tanpi(param0.sb),\n"
"                  tanpi(param0.sc), tanpi(param0.sd),\n"
"                  tanpi(param0.se), tanpi(param0.sf)); }\n"
"\n"
"\n"
"//gentype tgamma (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 tgamma (float2 param0)\n"
"{return (float2)(tgamma(param0.s0), tgamma(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 tgamma (float3 param0)\n"
"{return (float3)(tgamma(param0.s0), tgamma(param0.s1),\n"
"                 tgamma(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 tgamma (float4 param0)\n"
"{return (float4)(tgamma(param0.s0), tgamma(param0.s1),\n"
"                 tgamma(param0.s2), tgamma(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 tgamma (float8 param0)\n"
"{return (float8)(tgamma(param0.s0), tgamma(param0.s1),\n"
"                 tgamma(param0.s2), tgamma(param0.s3),\n"
"                 tgamma(param0.s4), tgamma(param0.s5),\n"
"                 tgamma(param0.s6), tgamma(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 tgamma (float16 param0)\n"
"{return (float16)(tgamma(param0.s0), tgamma(param0.s1),\n"
"                  tgamma(param0.s2), tgamma(param0.s3),\n"
"                  tgamma(param0.s4), tgamma(param0.s5),\n"
"                  tgamma(param0.s6), tgamma(param0.s7),\n"
"                  tgamma(param0.s8), tgamma(param0.s9),\n"
"                  tgamma(param0.sa), tgamma(param0.sb),\n"
"                  tgamma(param0.sc), tgamma(param0.sd),\n"
"                  tgamma(param0.se), tgamma(param0.sf)); }\n"
"\n"
"\n"
"//gentype trunc (gentype)\n"
"\n"
"INLINE_OVERLOADABLE float2 trunc (float2 param0)\n"
"{return (float2)(trunc(param0.s0), trunc(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 trunc (float3 param0)\n"
"{return (float3)(trunc(param0.s0), trunc(param0.s1),\n"
"                 trunc(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 trunc (float4 param0)\n"
"{return (float4)(trunc(param0.s0), trunc(param0.s1),\n"
"                 trunc(param0.s2), trunc(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 trunc (float8 param0)\n"
"{return (float8)(trunc(param0.s0), trunc(param0.s1),\n"
"                 trunc(param0.s2), trunc(param0.s3),\n"
"                 trunc(param0.s4), trunc(param0.s5),\n"
"                 trunc(param0.s6), trunc(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 trunc (float16 param0)\n"
"{return (float16)(trunc(param0.s0), trunc(param0.s1),\n"
"                  trunc(param0.s2), trunc(param0.s3),\n"
"                  trunc(param0.s4), trunc(param0.s5),\n"
"                  trunc(param0.s6), trunc(param0.s7),\n"
"                  trunc(param0.s8), trunc(param0.s9),\n"
"                  trunc(param0.sa), trunc(param0.sb),\n"
"                  trunc(param0.sc), trunc(param0.sd),\n"
"                  trunc(param0.se), trunc(param0.sf)); }\n"
"\n"
"\n"
"//math function fast path builtin functions\n"
"//gentype __gen_ocl_internal_fastpath_acosh (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_acosh (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_acosh(param0.s0), __gen_ocl_internal_fastpath_acosh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_acosh (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_acosh(param0.s0), __gen_ocl_internal_fastpath_acosh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_acosh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_acosh (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_acosh(param0.s0), __gen_ocl_internal_fastpath_acosh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_acosh(param0.s2), __gen_ocl_internal_fastpath_acosh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_acosh (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_acosh(param0.s0), __gen_ocl_internal_fastpath_acosh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_acosh(param0.s2), __gen_ocl_internal_fastpath_acosh(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_acosh(param0.s4), __gen_ocl_internal_fastpath_acosh(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_acosh(param0.s6), __gen_ocl_internal_fastpath_acosh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_acosh (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_acosh(param0.s0), __gen_ocl_internal_fastpath_acosh(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_acosh(param0.s2), __gen_ocl_internal_fastpath_acosh(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_acosh(param0.s4), __gen_ocl_internal_fastpath_acosh(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_acosh(param0.s6), __gen_ocl_internal_fastpath_acosh(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_acosh(param0.s8), __gen_ocl_internal_fastpath_acosh(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_acosh(param0.sa), __gen_ocl_internal_fastpath_acosh(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_acosh(param0.sc), __gen_ocl_internal_fastpath_acosh(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_acosh(param0.se), __gen_ocl_internal_fastpath_acosh(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_asinh (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_asinh (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_asinh(param0.s0), __gen_ocl_internal_fastpath_asinh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_asinh (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_asinh(param0.s0), __gen_ocl_internal_fastpath_asinh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_asinh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_asinh (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_asinh(param0.s0), __gen_ocl_internal_fastpath_asinh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_asinh(param0.s2), __gen_ocl_internal_fastpath_asinh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_asinh (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_asinh(param0.s0), __gen_ocl_internal_fastpath_asinh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_asinh(param0.s2), __gen_ocl_internal_fastpath_asinh(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_asinh(param0.s4), __gen_ocl_internal_fastpath_asinh(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_asinh(param0.s6), __gen_ocl_internal_fastpath_asinh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_asinh (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_asinh(param0.s0), __gen_ocl_internal_fastpath_asinh(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_asinh(param0.s2), __gen_ocl_internal_fastpath_asinh(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_asinh(param0.s4), __gen_ocl_internal_fastpath_asinh(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_asinh(param0.s6), __gen_ocl_internal_fastpath_asinh(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_asinh(param0.s8), __gen_ocl_internal_fastpath_asinh(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_asinh(param0.sa), __gen_ocl_internal_fastpath_asinh(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_asinh(param0.sc), __gen_ocl_internal_fastpath_asinh(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_asinh(param0.se), __gen_ocl_internal_fastpath_asinh(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_atanh (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_atanh (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_atanh(param0.s0), __gen_ocl_internal_fastpath_atanh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_atanh (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_atanh(param0.s0), __gen_ocl_internal_fastpath_atanh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_atanh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_atanh (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_atanh(param0.s0), __gen_ocl_internal_fastpath_atanh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_atanh(param0.s2), __gen_ocl_internal_fastpath_atanh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_atanh (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_atanh(param0.s0), __gen_ocl_internal_fastpath_atanh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_atanh(param0.s2), __gen_ocl_internal_fastpath_atanh(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_atanh(param0.s4), __gen_ocl_internal_fastpath_atanh(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_atanh(param0.s6), __gen_ocl_internal_fastpath_atanh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_atanh (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_atanh(param0.s0), __gen_ocl_internal_fastpath_atanh(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_atanh(param0.s2), __gen_ocl_internal_fastpath_atanh(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_atanh(param0.s4), __gen_ocl_internal_fastpath_atanh(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_atanh(param0.s6), __gen_ocl_internal_fastpath_atanh(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_atanh(param0.s8), __gen_ocl_internal_fastpath_atanh(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_atanh(param0.sa), __gen_ocl_internal_fastpath_atanh(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_atanh(param0.sc), __gen_ocl_internal_fastpath_atanh(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_atanh(param0.se), __gen_ocl_internal_fastpath_atanh(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_cbrt (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_cbrt (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_cbrt(param0.s0), __gen_ocl_internal_fastpath_cbrt(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_cbrt (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_cbrt(param0.s0), __gen_ocl_internal_fastpath_cbrt(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cbrt(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_cbrt (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_cbrt(param0.s0), __gen_ocl_internal_fastpath_cbrt(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cbrt(param0.s2), __gen_ocl_internal_fastpath_cbrt(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_cbrt (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_cbrt(param0.s0), __gen_ocl_internal_fastpath_cbrt(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cbrt(param0.s2), __gen_ocl_internal_fastpath_cbrt(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_cbrt(param0.s4), __gen_ocl_internal_fastpath_cbrt(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_cbrt(param0.s6), __gen_ocl_internal_fastpath_cbrt(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_cbrt (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_cbrt(param0.s0), __gen_ocl_internal_fastpath_cbrt(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_cbrt(param0.s2), __gen_ocl_internal_fastpath_cbrt(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_cbrt(param0.s4), __gen_ocl_internal_fastpath_cbrt(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_cbrt(param0.s6), __gen_ocl_internal_fastpath_cbrt(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_cbrt(param0.s8), __gen_ocl_internal_fastpath_cbrt(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_cbrt(param0.sa), __gen_ocl_internal_fastpath_cbrt(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_cbrt(param0.sc), __gen_ocl_internal_fastpath_cbrt(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_cbrt(param0.se), __gen_ocl_internal_fastpath_cbrt(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_cos (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_cos (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_cos(param0.s0), __gen_ocl_internal_fastpath_cos(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_cos (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_cos(param0.s0), __gen_ocl_internal_fastpath_cos(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cos(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_cos (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_cos(param0.s0), __gen_ocl_internal_fastpath_cos(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cos(param0.s2), __gen_ocl_internal_fastpath_cos(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_cos (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_cos(param0.s0), __gen_ocl_internal_fastpath_cos(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cos(param0.s2), __gen_ocl_internal_fastpath_cos(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_cos(param0.s4), __gen_ocl_internal_fastpath_cos(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_cos(param0.s6), __gen_ocl_internal_fastpath_cos(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_cos (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_cos(param0.s0), __gen_ocl_internal_fastpath_cos(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_cos(param0.s2), __gen_ocl_internal_fastpath_cos(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_cos(param0.s4), __gen_ocl_internal_fastpath_cos(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_cos(param0.s6), __gen_ocl_internal_fastpath_cos(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_cos(param0.s8), __gen_ocl_internal_fastpath_cos(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_cos(param0.sa), __gen_ocl_internal_fastpath_cos(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_cos(param0.sc), __gen_ocl_internal_fastpath_cos(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_cos(param0.se), __gen_ocl_internal_fastpath_cos(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_cosh (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_cosh (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_cosh(param0.s0), __gen_ocl_internal_fastpath_cosh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_cosh (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_cosh(param0.s0), __gen_ocl_internal_fastpath_cosh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cosh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_cosh (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_cosh(param0.s0), __gen_ocl_internal_fastpath_cosh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cosh(param0.s2), __gen_ocl_internal_fastpath_cosh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_cosh (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_cosh(param0.s0), __gen_ocl_internal_fastpath_cosh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cosh(param0.s2), __gen_ocl_internal_fastpath_cosh(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_cosh(param0.s4), __gen_ocl_internal_fastpath_cosh(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_cosh(param0.s6), __gen_ocl_internal_fastpath_cosh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_cosh (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_cosh(param0.s0), __gen_ocl_internal_fastpath_cosh(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_cosh(param0.s2), __gen_ocl_internal_fastpath_cosh(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_cosh(param0.s4), __gen_ocl_internal_fastpath_cosh(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_cosh(param0.s6), __gen_ocl_internal_fastpath_cosh(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_cosh(param0.s8), __gen_ocl_internal_fastpath_cosh(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_cosh(param0.sa), __gen_ocl_internal_fastpath_cosh(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_cosh(param0.sc), __gen_ocl_internal_fastpath_cosh(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_cosh(param0.se), __gen_ocl_internal_fastpath_cosh(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_cospi (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_cospi (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_cospi(param0.s0), __gen_ocl_internal_fastpath_cospi(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_cospi (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_cospi(param0.s0), __gen_ocl_internal_fastpath_cospi(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cospi(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_cospi (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_cospi(param0.s0), __gen_ocl_internal_fastpath_cospi(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cospi(param0.s2), __gen_ocl_internal_fastpath_cospi(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_cospi (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_cospi(param0.s0), __gen_ocl_internal_fastpath_cospi(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_cospi(param0.s2), __gen_ocl_internal_fastpath_cospi(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_cospi(param0.s4), __gen_ocl_internal_fastpath_cospi(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_cospi(param0.s6), __gen_ocl_internal_fastpath_cospi(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_cospi (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_cospi(param0.s0), __gen_ocl_internal_fastpath_cospi(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_cospi(param0.s2), __gen_ocl_internal_fastpath_cospi(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_cospi(param0.s4), __gen_ocl_internal_fastpath_cospi(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_cospi(param0.s6), __gen_ocl_internal_fastpath_cospi(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_cospi(param0.s8), __gen_ocl_internal_fastpath_cospi(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_cospi(param0.sa), __gen_ocl_internal_fastpath_cospi(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_cospi(param0.sc), __gen_ocl_internal_fastpath_cospi(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_cospi(param0.se), __gen_ocl_internal_fastpath_cospi(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_exp (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_exp (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_exp(param0.s0), __gen_ocl_internal_fastpath_exp(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_exp (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_exp(param0.s0), __gen_ocl_internal_fastpath_exp(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_exp(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_exp (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_exp(param0.s0), __gen_ocl_internal_fastpath_exp(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_exp(param0.s2), __gen_ocl_internal_fastpath_exp(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_exp (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_exp(param0.s0), __gen_ocl_internal_fastpath_exp(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_exp(param0.s2), __gen_ocl_internal_fastpath_exp(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_exp(param0.s4), __gen_ocl_internal_fastpath_exp(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_exp(param0.s6), __gen_ocl_internal_fastpath_exp(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_exp (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_exp(param0.s0), __gen_ocl_internal_fastpath_exp(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_exp(param0.s2), __gen_ocl_internal_fastpath_exp(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_exp(param0.s4), __gen_ocl_internal_fastpath_exp(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_exp(param0.s6), __gen_ocl_internal_fastpath_exp(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_exp(param0.s8), __gen_ocl_internal_fastpath_exp(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_exp(param0.sa), __gen_ocl_internal_fastpath_exp(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_exp(param0.sc), __gen_ocl_internal_fastpath_exp(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_exp(param0.se), __gen_ocl_internal_fastpath_exp(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_exp10 (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_exp10 (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_exp10(param0.s0), __gen_ocl_internal_fastpath_exp10(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_exp10 (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_exp10(param0.s0), __gen_ocl_internal_fastpath_exp10(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_exp10(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_exp10 (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_exp10(param0.s0), __gen_ocl_internal_fastpath_exp10(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_exp10(param0.s2), __gen_ocl_internal_fastpath_exp10(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_exp10 (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_exp10(param0.s0), __gen_ocl_internal_fastpath_exp10(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_exp10(param0.s2), __gen_ocl_internal_fastpath_exp10(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_exp10(param0.s4), __gen_ocl_internal_fastpath_exp10(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_exp10(param0.s6), __gen_ocl_internal_fastpath_exp10(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_exp10 (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_exp10(param0.s0), __gen_ocl_internal_fastpath_exp10(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_exp10(param0.s2), __gen_ocl_internal_fastpath_exp10(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_exp10(param0.s4), __gen_ocl_internal_fastpath_exp10(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_exp10(param0.s6), __gen_ocl_internal_fastpath_exp10(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_exp10(param0.s8), __gen_ocl_internal_fastpath_exp10(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_exp10(param0.sa), __gen_ocl_internal_fastpath_exp10(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_exp10(param0.sc), __gen_ocl_internal_fastpath_exp10(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_exp10(param0.se), __gen_ocl_internal_fastpath_exp10(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_expm1 (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_expm1 (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_expm1(param0.s0), __gen_ocl_internal_fastpath_expm1(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_expm1 (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_expm1(param0.s0), __gen_ocl_internal_fastpath_expm1(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_expm1(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_expm1 (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_expm1(param0.s0), __gen_ocl_internal_fastpath_expm1(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_expm1(param0.s2), __gen_ocl_internal_fastpath_expm1(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_expm1 (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_expm1(param0.s0), __gen_ocl_internal_fastpath_expm1(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_expm1(param0.s2), __gen_ocl_internal_fastpath_expm1(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_expm1(param0.s4), __gen_ocl_internal_fastpath_expm1(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_expm1(param0.s6), __gen_ocl_internal_fastpath_expm1(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_expm1 (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_expm1(param0.s0), __gen_ocl_internal_fastpath_expm1(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_expm1(param0.s2), __gen_ocl_internal_fastpath_expm1(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_expm1(param0.s4), __gen_ocl_internal_fastpath_expm1(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_expm1(param0.s6), __gen_ocl_internal_fastpath_expm1(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_expm1(param0.s8), __gen_ocl_internal_fastpath_expm1(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_expm1(param0.sa), __gen_ocl_internal_fastpath_expm1(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_expm1(param0.sc), __gen_ocl_internal_fastpath_expm1(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_expm1(param0.se), __gen_ocl_internal_fastpath_expm1(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_fmod (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_fmod (float2 param0, float2 param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_fmod(param0.s0, param1.s0), __gen_ocl_internal_fastpath_fmod(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_fmod (float3 param0, float3 param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_fmod(param0.s0, param1.s0), __gen_ocl_internal_fastpath_fmod(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_fmod(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_fmod (float4 param0, float4 param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_fmod(param0.s0, param1.s0), __gen_ocl_internal_fastpath_fmod(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_fmod(param0.s2, param1.s2), __gen_ocl_internal_fastpath_fmod(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_fmod (float8 param0, float8 param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_fmod(param0.s0, param1.s0), __gen_ocl_internal_fastpath_fmod(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_fmod(param0.s2, param1.s2), __gen_ocl_internal_fastpath_fmod(param0.s3, param1.s3),\n"
"                 __gen_ocl_internal_fastpath_fmod(param0.s4, param1.s4), __gen_ocl_internal_fastpath_fmod(param0.s5, param1.s5),\n"
"                 __gen_ocl_internal_fastpath_fmod(param0.s6, param1.s6), __gen_ocl_internal_fastpath_fmod(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_fmod (float16 param0, float16 param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_fmod(param0.s0, param1.s0), __gen_ocl_internal_fastpath_fmod(param0.s1, param1.s1),\n"
"                  __gen_ocl_internal_fastpath_fmod(param0.s2, param1.s2), __gen_ocl_internal_fastpath_fmod(param0.s3, param1.s3),\n"
"                  __gen_ocl_internal_fastpath_fmod(param0.s4, param1.s4), __gen_ocl_internal_fastpath_fmod(param0.s5, param1.s5),\n"
"                  __gen_ocl_internal_fastpath_fmod(param0.s6, param1.s6), __gen_ocl_internal_fastpath_fmod(param0.s7, param1.s7),\n"
"                  __gen_ocl_internal_fastpath_fmod(param0.s8, param1.s8), __gen_ocl_internal_fastpath_fmod(param0.s9, param1.s9),\n"
"                  __gen_ocl_internal_fastpath_fmod(param0.sa, param1.sa), __gen_ocl_internal_fastpath_fmod(param0.sb, param1.sb),\n"
"                  __gen_ocl_internal_fastpath_fmod(param0.sc, param1.sc), __gen_ocl_internal_fastpath_fmod(param0.sd, param1.sd),\n"
"                  __gen_ocl_internal_fastpath_fmod(param0.se, param1.se), __gen_ocl_internal_fastpath_fmod(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_hypot (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_hypot (float2 param0, float2 param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_hypot(param0.s0, param1.s0), __gen_ocl_internal_fastpath_hypot(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_hypot (float3 param0, float3 param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_hypot(param0.s0, param1.s0), __gen_ocl_internal_fastpath_hypot(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_hypot(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_hypot (float4 param0, float4 param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_hypot(param0.s0, param1.s0), __gen_ocl_internal_fastpath_hypot(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_hypot(param0.s2, param1.s2), __gen_ocl_internal_fastpath_hypot(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_hypot (float8 param0, float8 param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_hypot(param0.s0, param1.s0), __gen_ocl_internal_fastpath_hypot(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_hypot(param0.s2, param1.s2), __gen_ocl_internal_fastpath_hypot(param0.s3, param1.s3),\n"
"                 __gen_ocl_internal_fastpath_hypot(param0.s4, param1.s4), __gen_ocl_internal_fastpath_hypot(param0.s5, param1.s5),\n"
"                 __gen_ocl_internal_fastpath_hypot(param0.s6, param1.s6), __gen_ocl_internal_fastpath_hypot(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_hypot (float16 param0, float16 param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_hypot(param0.s0, param1.s0), __gen_ocl_internal_fastpath_hypot(param0.s1, param1.s1),\n"
"                  __gen_ocl_internal_fastpath_hypot(param0.s2, param1.s2), __gen_ocl_internal_fastpath_hypot(param0.s3, param1.s3),\n"
"                  __gen_ocl_internal_fastpath_hypot(param0.s4, param1.s4), __gen_ocl_internal_fastpath_hypot(param0.s5, param1.s5),\n"
"                  __gen_ocl_internal_fastpath_hypot(param0.s6, param1.s6), __gen_ocl_internal_fastpath_hypot(param0.s7, param1.s7),\n"
"                  __gen_ocl_internal_fastpath_hypot(param0.s8, param1.s8), __gen_ocl_internal_fastpath_hypot(param0.s9, param1.s9),\n"
"                  __gen_ocl_internal_fastpath_hypot(param0.sa, param1.sa), __gen_ocl_internal_fastpath_hypot(param0.sb, param1.sb),\n"
"                  __gen_ocl_internal_fastpath_hypot(param0.sc, param1.sc), __gen_ocl_internal_fastpath_hypot(param0.sd, param1.sd),\n"
"                  __gen_ocl_internal_fastpath_hypot(param0.se, param1.se), __gen_ocl_internal_fastpath_hypot(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//intn __gen_ocl_internal_fastpath_ilogb (floatn x)\n"
"\n"
"INLINE_OVERLOADABLE int2 __gen_ocl_internal_fastpath_ilogb (float2 param0)\n"
"{return (int2)(__gen_ocl_internal_fastpath_ilogb(param0.s0), __gen_ocl_internal_fastpath_ilogb(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 __gen_ocl_internal_fastpath_ilogb (float3 param0)\n"
"{return (int3)(__gen_ocl_internal_fastpath_ilogb(param0.s0), __gen_ocl_internal_fastpath_ilogb(param0.s1),\n"
"               __gen_ocl_internal_fastpath_ilogb(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 __gen_ocl_internal_fastpath_ilogb (float4 param0)\n"
"{return (int4)(__gen_ocl_internal_fastpath_ilogb(param0.s0), __gen_ocl_internal_fastpath_ilogb(param0.s1),\n"
"               __gen_ocl_internal_fastpath_ilogb(param0.s2), __gen_ocl_internal_fastpath_ilogb(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 __gen_ocl_internal_fastpath_ilogb (float8 param0)\n"
"{return (int8)(__gen_ocl_internal_fastpath_ilogb(param0.s0), __gen_ocl_internal_fastpath_ilogb(param0.s1),\n"
"               __gen_ocl_internal_fastpath_ilogb(param0.s2), __gen_ocl_internal_fastpath_ilogb(param0.s3),\n"
"               __gen_ocl_internal_fastpath_ilogb(param0.s4), __gen_ocl_internal_fastpath_ilogb(param0.s5),\n"
"               __gen_ocl_internal_fastpath_ilogb(param0.s6), __gen_ocl_internal_fastpath_ilogb(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 __gen_ocl_internal_fastpath_ilogb (float16 param0)\n"
"{return (int16)(__gen_ocl_internal_fastpath_ilogb(param0.s0), __gen_ocl_internal_fastpath_ilogb(param0.s1),\n"
"                __gen_ocl_internal_fastpath_ilogb(param0.s2), __gen_ocl_internal_fastpath_ilogb(param0.s3),\n"
"                __gen_ocl_internal_fastpath_ilogb(param0.s4), __gen_ocl_internal_fastpath_ilogb(param0.s5),\n"
"                __gen_ocl_internal_fastpath_ilogb(param0.s6), __gen_ocl_internal_fastpath_ilogb(param0.s7),\n"
"                __gen_ocl_internal_fastpath_ilogb(param0.s8), __gen_ocl_internal_fastpath_ilogb(param0.s9),\n"
"                __gen_ocl_internal_fastpath_ilogb(param0.sa), __gen_ocl_internal_fastpath_ilogb(param0.sb),\n"
"                __gen_ocl_internal_fastpath_ilogb(param0.sc), __gen_ocl_internal_fastpath_ilogb(param0.sd),\n"
"                __gen_ocl_internal_fastpath_ilogb(param0.se), __gen_ocl_internal_fastpath_ilogb(param0.sf)); }\n"
"\n"
"\n"
"//int __gen_ocl_internal_fastpath_ilogb (float x)\n"
"\n"
"\n"
"//intn __gen_ocl_internal_fastpath_ilogb (doublen x)\n"
"\n"
"\n"
"//int __gen_ocl_internal_fastpath_ilogb (double x)\n"
"\n"
"\n"
"//floatn __gen_ocl_internal_fastpath_ldexp (floatn x, intn k)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_ldexp (float2 param0, int2 param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1.s0), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_ldexp (float3 param0, int3 param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1.s0), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_ldexp (float4 param0, int4 param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1.s0), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s2, param1.s2), __gen_ocl_internal_fastpath_ldexp(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_ldexp (float8 param0, int8 param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1.s0), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s2, param1.s2), __gen_ocl_internal_fastpath_ldexp(param0.s3, param1.s3),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s4, param1.s4), __gen_ocl_internal_fastpath_ldexp(param0.s5, param1.s5),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s6, param1.s6), __gen_ocl_internal_fastpath_ldexp(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_ldexp (float16 param0, int16 param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1.s0), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1.s1),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.s2, param1.s2), __gen_ocl_internal_fastpath_ldexp(param0.s3, param1.s3),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.s4, param1.s4), __gen_ocl_internal_fastpath_ldexp(param0.s5, param1.s5),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.s6, param1.s6), __gen_ocl_internal_fastpath_ldexp(param0.s7, param1.s7),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.s8, param1.s8), __gen_ocl_internal_fastpath_ldexp(param0.s9, param1.s9),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.sa, param1.sa), __gen_ocl_internal_fastpath_ldexp(param0.sb, param1.sb),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.sc, param1.sc), __gen_ocl_internal_fastpath_ldexp(param0.sd, param1.sd),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.se, param1.se), __gen_ocl_internal_fastpath_ldexp(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//floatn __gen_ocl_internal_fastpath_ldexp (floatn x, int k)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_ldexp (float2 param0, int param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_ldexp (float3 param0, int param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_ldexp (float4 param0, int param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s2, param1), __gen_ocl_internal_fastpath_ldexp(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_ldexp (float8 param0, int param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s2, param1), __gen_ocl_internal_fastpath_ldexp(param0.s3, param1),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s4, param1), __gen_ocl_internal_fastpath_ldexp(param0.s5, param1),\n"
"                 __gen_ocl_internal_fastpath_ldexp(param0.s6, param1), __gen_ocl_internal_fastpath_ldexp(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_ldexp (float16 param0, int param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_ldexp(param0.s0, param1), __gen_ocl_internal_fastpath_ldexp(param0.s1, param1),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.s2, param1), __gen_ocl_internal_fastpath_ldexp(param0.s3, param1),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.s4, param1), __gen_ocl_internal_fastpath_ldexp(param0.s5, param1),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.s6, param1), __gen_ocl_internal_fastpath_ldexp(param0.s7, param1),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.s8, param1), __gen_ocl_internal_fastpath_ldexp(param0.s9, param1),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.sa, param1), __gen_ocl_internal_fastpath_ldexp(param0.sb, param1),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.sc, param1), __gen_ocl_internal_fastpath_ldexp(param0.sd, param1),\n"
"                  __gen_ocl_internal_fastpath_ldexp(param0.se, param1), __gen_ocl_internal_fastpath_ldexp(param0.sf, param1)); }\n"
"\n"
"\n"
"//float __gen_ocl_internal_fastpath_ldexp (float x, int k)\n"
"\n"
"\n"
"//doublen __gen_ocl_internal_fastpath_ldexp (doublen x, intn k)\n"
"\n"
"\n"
"//doublen __gen_ocl_internal_fastpath_ldexp (doublen x, int k)\n"
"\n"
"\n"
"//double __gen_ocl_internal_fastpath_ldexp (double x, int k)\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_log (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_log (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_log(param0.s0), __gen_ocl_internal_fastpath_log(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_log (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_log(param0.s0), __gen_ocl_internal_fastpath_log(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_log (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_log(param0.s0), __gen_ocl_internal_fastpath_log(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log(param0.s2), __gen_ocl_internal_fastpath_log(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_log (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_log(param0.s0), __gen_ocl_internal_fastpath_log(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log(param0.s2), __gen_ocl_internal_fastpath_log(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_log(param0.s4), __gen_ocl_internal_fastpath_log(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_log(param0.s6), __gen_ocl_internal_fastpath_log(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_log (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_log(param0.s0), __gen_ocl_internal_fastpath_log(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_log(param0.s2), __gen_ocl_internal_fastpath_log(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_log(param0.s4), __gen_ocl_internal_fastpath_log(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_log(param0.s6), __gen_ocl_internal_fastpath_log(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_log(param0.s8), __gen_ocl_internal_fastpath_log(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_log(param0.sa), __gen_ocl_internal_fastpath_log(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_log(param0.sc), __gen_ocl_internal_fastpath_log(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_log(param0.se), __gen_ocl_internal_fastpath_log(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_log2 (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_log2 (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_log2(param0.s0), __gen_ocl_internal_fastpath_log2(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_log2 (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_log2(param0.s0), __gen_ocl_internal_fastpath_log2(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log2(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_log2 (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_log2(param0.s0), __gen_ocl_internal_fastpath_log2(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log2(param0.s2), __gen_ocl_internal_fastpath_log2(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_log2 (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_log2(param0.s0), __gen_ocl_internal_fastpath_log2(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log2(param0.s2), __gen_ocl_internal_fastpath_log2(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_log2(param0.s4), __gen_ocl_internal_fastpath_log2(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_log2(param0.s6), __gen_ocl_internal_fastpath_log2(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_log2 (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_log2(param0.s0), __gen_ocl_internal_fastpath_log2(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_log2(param0.s2), __gen_ocl_internal_fastpath_log2(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_log2(param0.s4), __gen_ocl_internal_fastpath_log2(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_log2(param0.s6), __gen_ocl_internal_fastpath_log2(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_log2(param0.s8), __gen_ocl_internal_fastpath_log2(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_log2(param0.sa), __gen_ocl_internal_fastpath_log2(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_log2(param0.sc), __gen_ocl_internal_fastpath_log2(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_log2(param0.se), __gen_ocl_internal_fastpath_log2(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_log10 (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_log10 (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_log10(param0.s0), __gen_ocl_internal_fastpath_log10(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_log10 (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_log10(param0.s0), __gen_ocl_internal_fastpath_log10(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log10(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_log10 (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_log10(param0.s0), __gen_ocl_internal_fastpath_log10(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log10(param0.s2), __gen_ocl_internal_fastpath_log10(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_log10 (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_log10(param0.s0), __gen_ocl_internal_fastpath_log10(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log10(param0.s2), __gen_ocl_internal_fastpath_log10(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_log10(param0.s4), __gen_ocl_internal_fastpath_log10(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_log10(param0.s6), __gen_ocl_internal_fastpath_log10(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_log10 (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_log10(param0.s0), __gen_ocl_internal_fastpath_log10(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_log10(param0.s2), __gen_ocl_internal_fastpath_log10(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_log10(param0.s4), __gen_ocl_internal_fastpath_log10(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_log10(param0.s6), __gen_ocl_internal_fastpath_log10(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_log10(param0.s8), __gen_ocl_internal_fastpath_log10(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_log10(param0.sa), __gen_ocl_internal_fastpath_log10(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_log10(param0.sc), __gen_ocl_internal_fastpath_log10(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_log10(param0.se), __gen_ocl_internal_fastpath_log10(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_log1p (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_log1p (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_log1p(param0.s0), __gen_ocl_internal_fastpath_log1p(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_log1p (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_log1p(param0.s0), __gen_ocl_internal_fastpath_log1p(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log1p(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_log1p (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_log1p(param0.s0), __gen_ocl_internal_fastpath_log1p(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log1p(param0.s2), __gen_ocl_internal_fastpath_log1p(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_log1p (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_log1p(param0.s0), __gen_ocl_internal_fastpath_log1p(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_log1p(param0.s2), __gen_ocl_internal_fastpath_log1p(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_log1p(param0.s4), __gen_ocl_internal_fastpath_log1p(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_log1p(param0.s6), __gen_ocl_internal_fastpath_log1p(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_log1p (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_log1p(param0.s0), __gen_ocl_internal_fastpath_log1p(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_log1p(param0.s2), __gen_ocl_internal_fastpath_log1p(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_log1p(param0.s4), __gen_ocl_internal_fastpath_log1p(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_log1p(param0.s6), __gen_ocl_internal_fastpath_log1p(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_log1p(param0.s8), __gen_ocl_internal_fastpath_log1p(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_log1p(param0.sa), __gen_ocl_internal_fastpath_log1p(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_log1p(param0.sc), __gen_ocl_internal_fastpath_log1p(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_log1p(param0.se), __gen_ocl_internal_fastpath_log1p(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_logb (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_logb (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_logb(param0.s0), __gen_ocl_internal_fastpath_logb(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_logb (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_logb(param0.s0), __gen_ocl_internal_fastpath_logb(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_logb(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_logb (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_logb(param0.s0), __gen_ocl_internal_fastpath_logb(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_logb(param0.s2), __gen_ocl_internal_fastpath_logb(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_logb (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_logb(param0.s0), __gen_ocl_internal_fastpath_logb(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_logb(param0.s2), __gen_ocl_internal_fastpath_logb(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_logb(param0.s4), __gen_ocl_internal_fastpath_logb(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_logb(param0.s6), __gen_ocl_internal_fastpath_logb(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_logb (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_logb(param0.s0), __gen_ocl_internal_fastpath_logb(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_logb(param0.s2), __gen_ocl_internal_fastpath_logb(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_logb(param0.s4), __gen_ocl_internal_fastpath_logb(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_logb(param0.s6), __gen_ocl_internal_fastpath_logb(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_logb(param0.s8), __gen_ocl_internal_fastpath_logb(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_logb(param0.sa), __gen_ocl_internal_fastpath_logb(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_logb(param0.sc), __gen_ocl_internal_fastpath_logb(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_logb(param0.se), __gen_ocl_internal_fastpath_logb(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_remainder (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_remainder (float2 param0, float2 param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_remainder(param0.s0, param1.s0), __gen_ocl_internal_fastpath_remainder(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_remainder (float3 param0, float3 param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_remainder(param0.s0, param1.s0), __gen_ocl_internal_fastpath_remainder(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_remainder(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_remainder (float4 param0, float4 param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_remainder(param0.s0, param1.s0), __gen_ocl_internal_fastpath_remainder(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_remainder(param0.s2, param1.s2), __gen_ocl_internal_fastpath_remainder(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_remainder (float8 param0, float8 param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_remainder(param0.s0, param1.s0), __gen_ocl_internal_fastpath_remainder(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_remainder(param0.s2, param1.s2), __gen_ocl_internal_fastpath_remainder(param0.s3, param1.s3),\n"
"                 __gen_ocl_internal_fastpath_remainder(param0.s4, param1.s4), __gen_ocl_internal_fastpath_remainder(param0.s5, param1.s5),\n"
"                 __gen_ocl_internal_fastpath_remainder(param0.s6, param1.s6), __gen_ocl_internal_fastpath_remainder(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_remainder (float16 param0, float16 param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_remainder(param0.s0, param1.s0), __gen_ocl_internal_fastpath_remainder(param0.s1, param1.s1),\n"
"                  __gen_ocl_internal_fastpath_remainder(param0.s2, param1.s2), __gen_ocl_internal_fastpath_remainder(param0.s3, param1.s3),\n"
"                  __gen_ocl_internal_fastpath_remainder(param0.s4, param1.s4), __gen_ocl_internal_fastpath_remainder(param0.s5, param1.s5),\n"
"                  __gen_ocl_internal_fastpath_remainder(param0.s6, param1.s6), __gen_ocl_internal_fastpath_remainder(param0.s7, param1.s7),\n"
"                  __gen_ocl_internal_fastpath_remainder(param0.s8, param1.s8), __gen_ocl_internal_fastpath_remainder(param0.s9, param1.s9),\n"
"                  __gen_ocl_internal_fastpath_remainder(param0.sa, param1.sa), __gen_ocl_internal_fastpath_remainder(param0.sb, param1.sb),\n"
"                  __gen_ocl_internal_fastpath_remainder(param0.sc, param1.sc), __gen_ocl_internal_fastpath_remainder(param0.sd, param1.sd),\n"
"                  __gen_ocl_internal_fastpath_remainder(param0.se, param1.se), __gen_ocl_internal_fastpath_remainder(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//floatn __gen_ocl_internal_fastpath_rootn (floatn x, intn k)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_rootn (float2 param0, int2 param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_rootn(param0.s0, param1.s0), __gen_ocl_internal_fastpath_rootn(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_rootn (float3 param0, int3 param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_rootn(param0.s0, param1.s0), __gen_ocl_internal_fastpath_rootn(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_rootn(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_rootn (float4 param0, int4 param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_rootn(param0.s0, param1.s0), __gen_ocl_internal_fastpath_rootn(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_rootn(param0.s2, param1.s2), __gen_ocl_internal_fastpath_rootn(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_rootn (float8 param0, int8 param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_rootn(param0.s0, param1.s0), __gen_ocl_internal_fastpath_rootn(param0.s1, param1.s1),\n"
"                 __gen_ocl_internal_fastpath_rootn(param0.s2, param1.s2), __gen_ocl_internal_fastpath_rootn(param0.s3, param1.s3),\n"
"                 __gen_ocl_internal_fastpath_rootn(param0.s4, param1.s4), __gen_ocl_internal_fastpath_rootn(param0.s5, param1.s5),\n"
"                 __gen_ocl_internal_fastpath_rootn(param0.s6, param1.s6), __gen_ocl_internal_fastpath_rootn(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_rootn (float16 param0, int16 param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_rootn(param0.s0, param1.s0), __gen_ocl_internal_fastpath_rootn(param0.s1, param1.s1),\n"
"                  __gen_ocl_internal_fastpath_rootn(param0.s2, param1.s2), __gen_ocl_internal_fastpath_rootn(param0.s3, param1.s3),\n"
"                  __gen_ocl_internal_fastpath_rootn(param0.s4, param1.s4), __gen_ocl_internal_fastpath_rootn(param0.s5, param1.s5),\n"
"                  __gen_ocl_internal_fastpath_rootn(param0.s6, param1.s6), __gen_ocl_internal_fastpath_rootn(param0.s7, param1.s7),\n"
"                  __gen_ocl_internal_fastpath_rootn(param0.s8, param1.s8), __gen_ocl_internal_fastpath_rootn(param0.s9, param1.s9),\n"
"                  __gen_ocl_internal_fastpath_rootn(param0.sa, param1.sa), __gen_ocl_internal_fastpath_rootn(param0.sb, param1.sb),\n"
"                  __gen_ocl_internal_fastpath_rootn(param0.sc, param1.sc), __gen_ocl_internal_fastpath_rootn(param0.sd, param1.sd),\n"
"                  __gen_ocl_internal_fastpath_rootn(param0.se, param1.se), __gen_ocl_internal_fastpath_rootn(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_sin (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_sin (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_sin(param0.s0), __gen_ocl_internal_fastpath_sin(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_sin (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_sin(param0.s0), __gen_ocl_internal_fastpath_sin(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sin(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_sin (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_sin(param0.s0), __gen_ocl_internal_fastpath_sin(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sin(param0.s2), __gen_ocl_internal_fastpath_sin(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_sin (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_sin(param0.s0), __gen_ocl_internal_fastpath_sin(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sin(param0.s2), __gen_ocl_internal_fastpath_sin(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_sin(param0.s4), __gen_ocl_internal_fastpath_sin(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_sin(param0.s6), __gen_ocl_internal_fastpath_sin(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_sin (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_sin(param0.s0), __gen_ocl_internal_fastpath_sin(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_sin(param0.s2), __gen_ocl_internal_fastpath_sin(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_sin(param0.s4), __gen_ocl_internal_fastpath_sin(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_sin(param0.s6), __gen_ocl_internal_fastpath_sin(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_sin(param0.s8), __gen_ocl_internal_fastpath_sin(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_sin(param0.sa), __gen_ocl_internal_fastpath_sin(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_sin(param0.sc), __gen_ocl_internal_fastpath_sin(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_sin(param0.se), __gen_ocl_internal_fastpath_sin(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_sincos (gentype x, __global gentype *cosval)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_sincos (float2 param0, __global float2 *param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__global  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__global  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_sincos (float3 param0, __global float3 *param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__global  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__global  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__global  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_sincos (float4 param0, __global float4 *param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__global  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__global  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__global  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__global  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_sincos (float8 param0, __global float8 *param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__global  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__global  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__global  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__global  float *)param1 +  3),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s4, (__global  float *)param1 +  4), __gen_ocl_internal_fastpath_sincos(param0.s5, (__global  float *)param1 +  5),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s6, (__global  float *)param1 +  6), __gen_ocl_internal_fastpath_sincos(param0.s7, (__global  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_sincos (float16 param0, __global float16 *param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__global  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__global  float *)param1 +  1),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s2, (__global  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__global  float *)param1 +  3),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s4, (__global  float *)param1 +  4), __gen_ocl_internal_fastpath_sincos(param0.s5, (__global  float *)param1 +  5),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s6, (__global  float *)param1 +  6), __gen_ocl_internal_fastpath_sincos(param0.s7, (__global  float *)param1 +  7),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s8, (__global  float *)param1 +  8), __gen_ocl_internal_fastpath_sincos(param0.s9, (__global  float *)param1 +  9),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.sa, (__global  float *)param1 + 10), __gen_ocl_internal_fastpath_sincos(param0.sb, (__global  float *)param1 + 11),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.sc, (__global  float *)param1 + 12), __gen_ocl_internal_fastpath_sincos(param0.sd, (__global  float *)param1 + 13),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.se, (__global  float *)param1 + 14), __gen_ocl_internal_fastpath_sincos(param0.sf, (__global  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_sincos (gentype x, __local gentype *cosval)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_sincos (float2 param0, __local float2 *param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__local  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__local  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_sincos (float3 param0, __local float3 *param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__local  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__local  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__local  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_sincos (float4 param0, __local float4 *param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__local  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__local  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__local  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__local  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_sincos (float8 param0, __local float8 *param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__local  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__local  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__local  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__local  float *)param1 +  3),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s4, (__local  float *)param1 +  4), __gen_ocl_internal_fastpath_sincos(param0.s5, (__local  float *)param1 +  5),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s6, (__local  float *)param1 +  6), __gen_ocl_internal_fastpath_sincos(param0.s7, (__local  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_sincos (float16 param0, __local float16 *param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__local  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__local  float *)param1 +  1),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s2, (__local  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__local  float *)param1 +  3),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s4, (__local  float *)param1 +  4), __gen_ocl_internal_fastpath_sincos(param0.s5, (__local  float *)param1 +  5),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s6, (__local  float *)param1 +  6), __gen_ocl_internal_fastpath_sincos(param0.s7, (__local  float *)param1 +  7),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s8, (__local  float *)param1 +  8), __gen_ocl_internal_fastpath_sincos(param0.s9, (__local  float *)param1 +  9),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.sa, (__local  float *)param1 + 10), __gen_ocl_internal_fastpath_sincos(param0.sb, (__local  float *)param1 + 11),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.sc, (__local  float *)param1 + 12), __gen_ocl_internal_fastpath_sincos(param0.sd, (__local  float *)param1 + 13),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.se, (__local  float *)param1 + 14), __gen_ocl_internal_fastpath_sincos(param0.sf, (__local  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_sincos (gentype x, __private gentype *cosval)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_sincos (float2 param0, __private float2 *param1)\n"
"{return (float2)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__private  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__private  float *)param1 +  1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_sincos (float3 param0, __private float3 *param1)\n"
"{return (float3)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__private  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__private  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__private  float *)param1 +  2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_sincos (float4 param0, __private float4 *param1)\n"
"{return (float4)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__private  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__private  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__private  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__private  float *)param1 +  3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_sincos (float8 param0, __private float8 *param1)\n"
"{return (float8)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__private  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__private  float *)param1 +  1),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s2, (__private  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__private  float *)param1 +  3),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s4, (__private  float *)param1 +  4), __gen_ocl_internal_fastpath_sincos(param0.s5, (__private  float *)param1 +  5),\n"
"                 __gen_ocl_internal_fastpath_sincos(param0.s6, (__private  float *)param1 +  6), __gen_ocl_internal_fastpath_sincos(param0.s7, (__private  float *)param1 +  7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_sincos (float16 param0, __private float16 *param1)\n"
"{return (float16)(__gen_ocl_internal_fastpath_sincos(param0.s0, (__private  float *)param1 +  0), __gen_ocl_internal_fastpath_sincos(param0.s1, (__private  float *)param1 +  1),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s2, (__private  float *)param1 +  2), __gen_ocl_internal_fastpath_sincos(param0.s3, (__private  float *)param1 +  3),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s4, (__private  float *)param1 +  4), __gen_ocl_internal_fastpath_sincos(param0.s5, (__private  float *)param1 +  5),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s6, (__private  float *)param1 +  6), __gen_ocl_internal_fastpath_sincos(param0.s7, (__private  float *)param1 +  7),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.s8, (__private  float *)param1 +  8), __gen_ocl_internal_fastpath_sincos(param0.s9, (__private  float *)param1 +  9),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.sa, (__private  float *)param1 + 10), __gen_ocl_internal_fastpath_sincos(param0.sb, (__private  float *)param1 + 11),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.sc, (__private  float *)param1 + 12), __gen_ocl_internal_fastpath_sincos(param0.sd, (__private  float *)param1 + 13),\n"
"                  __gen_ocl_internal_fastpath_sincos(param0.se, (__private  float *)param1 + 14), __gen_ocl_internal_fastpath_sincos(param0.sf, (__private  float *)param1 + 15)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_sinh (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_sinh (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_sinh(param0.s0), __gen_ocl_internal_fastpath_sinh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_sinh (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_sinh(param0.s0), __gen_ocl_internal_fastpath_sinh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sinh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_sinh (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_sinh(param0.s0), __gen_ocl_internal_fastpath_sinh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sinh(param0.s2), __gen_ocl_internal_fastpath_sinh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_sinh (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_sinh(param0.s0), __gen_ocl_internal_fastpath_sinh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sinh(param0.s2), __gen_ocl_internal_fastpath_sinh(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_sinh(param0.s4), __gen_ocl_internal_fastpath_sinh(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_sinh(param0.s6), __gen_ocl_internal_fastpath_sinh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_sinh (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_sinh(param0.s0), __gen_ocl_internal_fastpath_sinh(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_sinh(param0.s2), __gen_ocl_internal_fastpath_sinh(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_sinh(param0.s4), __gen_ocl_internal_fastpath_sinh(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_sinh(param0.s6), __gen_ocl_internal_fastpath_sinh(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_sinh(param0.s8), __gen_ocl_internal_fastpath_sinh(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_sinh(param0.sa), __gen_ocl_internal_fastpath_sinh(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_sinh(param0.sc), __gen_ocl_internal_fastpath_sinh(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_sinh(param0.se), __gen_ocl_internal_fastpath_sinh(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_sinpi (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_sinpi (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_sinpi(param0.s0), __gen_ocl_internal_fastpath_sinpi(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_sinpi (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_sinpi(param0.s0), __gen_ocl_internal_fastpath_sinpi(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sinpi(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_sinpi (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_sinpi(param0.s0), __gen_ocl_internal_fastpath_sinpi(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sinpi(param0.s2), __gen_ocl_internal_fastpath_sinpi(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_sinpi (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_sinpi(param0.s0), __gen_ocl_internal_fastpath_sinpi(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_sinpi(param0.s2), __gen_ocl_internal_fastpath_sinpi(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_sinpi(param0.s4), __gen_ocl_internal_fastpath_sinpi(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_sinpi(param0.s6), __gen_ocl_internal_fastpath_sinpi(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_sinpi (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_sinpi(param0.s0), __gen_ocl_internal_fastpath_sinpi(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_sinpi(param0.s2), __gen_ocl_internal_fastpath_sinpi(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_sinpi(param0.s4), __gen_ocl_internal_fastpath_sinpi(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_sinpi(param0.s6), __gen_ocl_internal_fastpath_sinpi(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_sinpi(param0.s8), __gen_ocl_internal_fastpath_sinpi(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_sinpi(param0.sa), __gen_ocl_internal_fastpath_sinpi(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_sinpi(param0.sc), __gen_ocl_internal_fastpath_sinpi(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_sinpi(param0.se), __gen_ocl_internal_fastpath_sinpi(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_tan (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_tan (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_tan(param0.s0), __gen_ocl_internal_fastpath_tan(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_tan (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_tan(param0.s0), __gen_ocl_internal_fastpath_tan(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_tan(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_tan (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_tan(param0.s0), __gen_ocl_internal_fastpath_tan(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_tan(param0.s2), __gen_ocl_internal_fastpath_tan(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_tan (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_tan(param0.s0), __gen_ocl_internal_fastpath_tan(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_tan(param0.s2), __gen_ocl_internal_fastpath_tan(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_tan(param0.s4), __gen_ocl_internal_fastpath_tan(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_tan(param0.s6), __gen_ocl_internal_fastpath_tan(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_tan (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_tan(param0.s0), __gen_ocl_internal_fastpath_tan(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_tan(param0.s2), __gen_ocl_internal_fastpath_tan(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_tan(param0.s4), __gen_ocl_internal_fastpath_tan(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_tan(param0.s6), __gen_ocl_internal_fastpath_tan(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_tan(param0.s8), __gen_ocl_internal_fastpath_tan(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_tan(param0.sa), __gen_ocl_internal_fastpath_tan(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_tan(param0.sc), __gen_ocl_internal_fastpath_tan(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_tan(param0.se), __gen_ocl_internal_fastpath_tan(param0.sf)); }\n"
"\n"
"\n"
"//gentype __gen_ocl_internal_fastpath_tanh (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 __gen_ocl_internal_fastpath_tanh (float2 param0)\n"
"{return (float2)(__gen_ocl_internal_fastpath_tanh(param0.s0), __gen_ocl_internal_fastpath_tanh(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 __gen_ocl_internal_fastpath_tanh (float3 param0)\n"
"{return (float3)(__gen_ocl_internal_fastpath_tanh(param0.s0), __gen_ocl_internal_fastpath_tanh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_tanh(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 __gen_ocl_internal_fastpath_tanh (float4 param0)\n"
"{return (float4)(__gen_ocl_internal_fastpath_tanh(param0.s0), __gen_ocl_internal_fastpath_tanh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_tanh(param0.s2), __gen_ocl_internal_fastpath_tanh(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 __gen_ocl_internal_fastpath_tanh (float8 param0)\n"
"{return (float8)(__gen_ocl_internal_fastpath_tanh(param0.s0), __gen_ocl_internal_fastpath_tanh(param0.s1),\n"
"                 __gen_ocl_internal_fastpath_tanh(param0.s2), __gen_ocl_internal_fastpath_tanh(param0.s3),\n"
"                 __gen_ocl_internal_fastpath_tanh(param0.s4), __gen_ocl_internal_fastpath_tanh(param0.s5),\n"
"                 __gen_ocl_internal_fastpath_tanh(param0.s6), __gen_ocl_internal_fastpath_tanh(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 __gen_ocl_internal_fastpath_tanh (float16 param0)\n"
"{return (float16)(__gen_ocl_internal_fastpath_tanh(param0.s0), __gen_ocl_internal_fastpath_tanh(param0.s1),\n"
"                  __gen_ocl_internal_fastpath_tanh(param0.s2), __gen_ocl_internal_fastpath_tanh(param0.s3),\n"
"                  __gen_ocl_internal_fastpath_tanh(param0.s4), __gen_ocl_internal_fastpath_tanh(param0.s5),\n"
"                  __gen_ocl_internal_fastpath_tanh(param0.s6), __gen_ocl_internal_fastpath_tanh(param0.s7),\n"
"                  __gen_ocl_internal_fastpath_tanh(param0.s8), __gen_ocl_internal_fastpath_tanh(param0.s9),\n"
"                  __gen_ocl_internal_fastpath_tanh(param0.sa), __gen_ocl_internal_fastpath_tanh(param0.sb),\n"
"                  __gen_ocl_internal_fastpath_tanh(param0.sc), __gen_ocl_internal_fastpath_tanh(param0.sd),\n"
"                  __gen_ocl_internal_fastpath_tanh(param0.se), __gen_ocl_internal_fastpath_tanh(param0.sf)); }\n"
"\n"
"\n"
"//half_native_math builtin functions\n"
"//gentype native_cos (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_cos (float2 param0)\n"
"{return (float2)(native_cos(param0.s0), native_cos(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_cos (float3 param0)\n"
"{return (float3)(native_cos(param0.s0), native_cos(param0.s1),\n"
"                 native_cos(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_cos (float4 param0)\n"
"{return (float4)(native_cos(param0.s0), native_cos(param0.s1),\n"
"                 native_cos(param0.s2), native_cos(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_cos (float8 param0)\n"
"{return (float8)(native_cos(param0.s0), native_cos(param0.s1),\n"
"                 native_cos(param0.s2), native_cos(param0.s3),\n"
"                 native_cos(param0.s4), native_cos(param0.s5),\n"
"                 native_cos(param0.s6), native_cos(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_cos (float16 param0)\n"
"{return (float16)(native_cos(param0.s0), native_cos(param0.s1),\n"
"                  native_cos(param0.s2), native_cos(param0.s3),\n"
"                  native_cos(param0.s4), native_cos(param0.s5),\n"
"                  native_cos(param0.s6), native_cos(param0.s7),\n"
"                  native_cos(param0.s8), native_cos(param0.s9),\n"
"                  native_cos(param0.sa), native_cos(param0.sb),\n"
"                  native_cos(param0.sc), native_cos(param0.sd),\n"
"                  native_cos(param0.se), native_cos(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_divide (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_divide (float2 param0, float2 param1)\n"
"{return (float2)(native_divide(param0.s0, param1.s0), native_divide(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_divide (float3 param0, float3 param1)\n"
"{return (float3)(native_divide(param0.s0, param1.s0), native_divide(param0.s1, param1.s1),\n"
"                 native_divide(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_divide (float4 param0, float4 param1)\n"
"{return (float4)(native_divide(param0.s0, param1.s0), native_divide(param0.s1, param1.s1),\n"
"                 native_divide(param0.s2, param1.s2), native_divide(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_divide (float8 param0, float8 param1)\n"
"{return (float8)(native_divide(param0.s0, param1.s0), native_divide(param0.s1, param1.s1),\n"
"                 native_divide(param0.s2, param1.s2), native_divide(param0.s3, param1.s3),\n"
"                 native_divide(param0.s4, param1.s4), native_divide(param0.s5, param1.s5),\n"
"                 native_divide(param0.s6, param1.s6), native_divide(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_divide (float16 param0, float16 param1)\n"
"{return (float16)(native_divide(param0.s0, param1.s0), native_divide(param0.s1, param1.s1),\n"
"                  native_divide(param0.s2, param1.s2), native_divide(param0.s3, param1.s3),\n"
"                  native_divide(param0.s4, param1.s4), native_divide(param0.s5, param1.s5),\n"
"                  native_divide(param0.s6, param1.s6), native_divide(param0.s7, param1.s7),\n"
"                  native_divide(param0.s8, param1.s8), native_divide(param0.s9, param1.s9),\n"
"                  native_divide(param0.sa, param1.sa), native_divide(param0.sb, param1.sb),\n"
"                  native_divide(param0.sc, param1.sc), native_divide(param0.sd, param1.sd),\n"
"                  native_divide(param0.se, param1.se), native_divide(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype native_exp (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_exp (float2 param0)\n"
"{return (float2)(native_exp(param0.s0), native_exp(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_exp (float3 param0)\n"
"{return (float3)(native_exp(param0.s0), native_exp(param0.s1),\n"
"                 native_exp(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_exp (float4 param0)\n"
"{return (float4)(native_exp(param0.s0), native_exp(param0.s1),\n"
"                 native_exp(param0.s2), native_exp(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_exp (float8 param0)\n"
"{return (float8)(native_exp(param0.s0), native_exp(param0.s1),\n"
"                 native_exp(param0.s2), native_exp(param0.s3),\n"
"                 native_exp(param0.s4), native_exp(param0.s5),\n"
"                 native_exp(param0.s6), native_exp(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_exp (float16 param0)\n"
"{return (float16)(native_exp(param0.s0), native_exp(param0.s1),\n"
"                  native_exp(param0.s2), native_exp(param0.s3),\n"
"                  native_exp(param0.s4), native_exp(param0.s5),\n"
"                  native_exp(param0.s6), native_exp(param0.s7),\n"
"                  native_exp(param0.s8), native_exp(param0.s9),\n"
"                  native_exp(param0.sa), native_exp(param0.sb),\n"
"                  native_exp(param0.sc), native_exp(param0.sd),\n"
"                  native_exp(param0.se), native_exp(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_exp10 (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_exp10 (float2 param0)\n"
"{return (float2)(native_exp10(param0.s0), native_exp10(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_exp10 (float3 param0)\n"
"{return (float3)(native_exp10(param0.s0), native_exp10(param0.s1),\n"
"                 native_exp10(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_exp10 (float4 param0)\n"
"{return (float4)(native_exp10(param0.s0), native_exp10(param0.s1),\n"
"                 native_exp10(param0.s2), native_exp10(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_exp10 (float8 param0)\n"
"{return (float8)(native_exp10(param0.s0), native_exp10(param0.s1),\n"
"                 native_exp10(param0.s2), native_exp10(param0.s3),\n"
"                 native_exp10(param0.s4), native_exp10(param0.s5),\n"
"                 native_exp10(param0.s6), native_exp10(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_exp10 (float16 param0)\n"
"{return (float16)(native_exp10(param0.s0), native_exp10(param0.s1),\n"
"                  native_exp10(param0.s2), native_exp10(param0.s3),\n"
"                  native_exp10(param0.s4), native_exp10(param0.s5),\n"
"                  native_exp10(param0.s6), native_exp10(param0.s7),\n"
"                  native_exp10(param0.s8), native_exp10(param0.s9),\n"
"                  native_exp10(param0.sa), native_exp10(param0.sb),\n"
"                  native_exp10(param0.sc), native_exp10(param0.sd),\n"
"                  native_exp10(param0.se), native_exp10(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_log (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_log (float2 param0)\n"
"{return (float2)(native_log(param0.s0), native_log(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_log (float3 param0)\n"
"{return (float3)(native_log(param0.s0), native_log(param0.s1),\n"
"                 native_log(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_log (float4 param0)\n"
"{return (float4)(native_log(param0.s0), native_log(param0.s1),\n"
"                 native_log(param0.s2), native_log(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_log (float8 param0)\n"
"{return (float8)(native_log(param0.s0), native_log(param0.s1),\n"
"                 native_log(param0.s2), native_log(param0.s3),\n"
"                 native_log(param0.s4), native_log(param0.s5),\n"
"                 native_log(param0.s6), native_log(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_log (float16 param0)\n"
"{return (float16)(native_log(param0.s0), native_log(param0.s1),\n"
"                  native_log(param0.s2), native_log(param0.s3),\n"
"                  native_log(param0.s4), native_log(param0.s5),\n"
"                  native_log(param0.s6), native_log(param0.s7),\n"
"                  native_log(param0.s8), native_log(param0.s9),\n"
"                  native_log(param0.sa), native_log(param0.sb),\n"
"                  native_log(param0.sc), native_log(param0.sd),\n"
"                  native_log(param0.se), native_log(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_log2 (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_log2 (float2 param0)\n"
"{return (float2)(native_log2(param0.s0), native_log2(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_log2 (float3 param0)\n"
"{return (float3)(native_log2(param0.s0), native_log2(param0.s1),\n"
"                 native_log2(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_log2 (float4 param0)\n"
"{return (float4)(native_log2(param0.s0), native_log2(param0.s1),\n"
"                 native_log2(param0.s2), native_log2(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_log2 (float8 param0)\n"
"{return (float8)(native_log2(param0.s0), native_log2(param0.s1),\n"
"                 native_log2(param0.s2), native_log2(param0.s3),\n"
"                 native_log2(param0.s4), native_log2(param0.s5),\n"
"                 native_log2(param0.s6), native_log2(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_log2 (float16 param0)\n"
"{return (float16)(native_log2(param0.s0), native_log2(param0.s1),\n"
"                  native_log2(param0.s2), native_log2(param0.s3),\n"
"                  native_log2(param0.s4), native_log2(param0.s5),\n"
"                  native_log2(param0.s6), native_log2(param0.s7),\n"
"                  native_log2(param0.s8), native_log2(param0.s9),\n"
"                  native_log2(param0.sa), native_log2(param0.sb),\n"
"                  native_log2(param0.sc), native_log2(param0.sd),\n"
"                  native_log2(param0.se), native_log2(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_log10 (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_log10 (float2 param0)\n"
"{return (float2)(native_log10(param0.s0), native_log10(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_log10 (float3 param0)\n"
"{return (float3)(native_log10(param0.s0), native_log10(param0.s1),\n"
"                 native_log10(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_log10 (float4 param0)\n"
"{return (float4)(native_log10(param0.s0), native_log10(param0.s1),\n"
"                 native_log10(param0.s2), native_log10(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_log10 (float8 param0)\n"
"{return (float8)(native_log10(param0.s0), native_log10(param0.s1),\n"
"                 native_log10(param0.s2), native_log10(param0.s3),\n"
"                 native_log10(param0.s4), native_log10(param0.s5),\n"
"                 native_log10(param0.s6), native_log10(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_log10 (float16 param0)\n"
"{return (float16)(native_log10(param0.s0), native_log10(param0.s1),\n"
"                  native_log10(param0.s2), native_log10(param0.s3),\n"
"                  native_log10(param0.s4), native_log10(param0.s5),\n"
"                  native_log10(param0.s6), native_log10(param0.s7),\n"
"                  native_log10(param0.s8), native_log10(param0.s9),\n"
"                  native_log10(param0.sa), native_log10(param0.sb),\n"
"                  native_log10(param0.sc), native_log10(param0.sd),\n"
"                  native_log10(param0.se), native_log10(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_powr (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_powr (float2 param0, float2 param1)\n"
"{return (float2)(native_powr(param0.s0, param1.s0), native_powr(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_powr (float3 param0, float3 param1)\n"
"{return (float3)(native_powr(param0.s0, param1.s0), native_powr(param0.s1, param1.s1),\n"
"                 native_powr(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_powr (float4 param0, float4 param1)\n"
"{return (float4)(native_powr(param0.s0, param1.s0), native_powr(param0.s1, param1.s1),\n"
"                 native_powr(param0.s2, param1.s2), native_powr(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_powr (float8 param0, float8 param1)\n"
"{return (float8)(native_powr(param0.s0, param1.s0), native_powr(param0.s1, param1.s1),\n"
"                 native_powr(param0.s2, param1.s2), native_powr(param0.s3, param1.s3),\n"
"                 native_powr(param0.s4, param1.s4), native_powr(param0.s5, param1.s5),\n"
"                 native_powr(param0.s6, param1.s6), native_powr(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_powr (float16 param0, float16 param1)\n"
"{return (float16)(native_powr(param0.s0, param1.s0), native_powr(param0.s1, param1.s1),\n"
"                  native_powr(param0.s2, param1.s2), native_powr(param0.s3, param1.s3),\n"
"                  native_powr(param0.s4, param1.s4), native_powr(param0.s5, param1.s5),\n"
"                  native_powr(param0.s6, param1.s6), native_powr(param0.s7, param1.s7),\n"
"                  native_powr(param0.s8, param1.s8), native_powr(param0.s9, param1.s9),\n"
"                  native_powr(param0.sa, param1.sa), native_powr(param0.sb, param1.sb),\n"
"                  native_powr(param0.sc, param1.sc), native_powr(param0.sd, param1.sd),\n"
"                  native_powr(param0.se, param1.se), native_powr(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype native_recip (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_recip (float2 param0)\n"
"{return (float2)(native_recip(param0.s0), native_recip(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_recip (float3 param0)\n"
"{return (float3)(native_recip(param0.s0), native_recip(param0.s1),\n"
"                 native_recip(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_recip (float4 param0)\n"
"{return (float4)(native_recip(param0.s0), native_recip(param0.s1),\n"
"                 native_recip(param0.s2), native_recip(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_recip (float8 param0)\n"
"{return (float8)(native_recip(param0.s0), native_recip(param0.s1),\n"
"                 native_recip(param0.s2), native_recip(param0.s3),\n"
"                 native_recip(param0.s4), native_recip(param0.s5),\n"
"                 native_recip(param0.s6), native_recip(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_recip (float16 param0)\n"
"{return (float16)(native_recip(param0.s0), native_recip(param0.s1),\n"
"                  native_recip(param0.s2), native_recip(param0.s3),\n"
"                  native_recip(param0.s4), native_recip(param0.s5),\n"
"                  native_recip(param0.s6), native_recip(param0.s7),\n"
"                  native_recip(param0.s8), native_recip(param0.s9),\n"
"                  native_recip(param0.sa), native_recip(param0.sb),\n"
"                  native_recip(param0.sc), native_recip(param0.sd),\n"
"                  native_recip(param0.se), native_recip(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_rsqrt (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_rsqrt (float2 param0)\n"
"{return (float2)(native_rsqrt(param0.s0), native_rsqrt(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_rsqrt (float3 param0)\n"
"{return (float3)(native_rsqrt(param0.s0), native_rsqrt(param0.s1),\n"
"                 native_rsqrt(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_rsqrt (float4 param0)\n"
"{return (float4)(native_rsqrt(param0.s0), native_rsqrt(param0.s1),\n"
"                 native_rsqrt(param0.s2), native_rsqrt(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_rsqrt (float8 param0)\n"
"{return (float8)(native_rsqrt(param0.s0), native_rsqrt(param0.s1),\n"
"                 native_rsqrt(param0.s2), native_rsqrt(param0.s3),\n"
"                 native_rsqrt(param0.s4), native_rsqrt(param0.s5),\n"
"                 native_rsqrt(param0.s6), native_rsqrt(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_rsqrt (float16 param0)\n"
"{return (float16)(native_rsqrt(param0.s0), native_rsqrt(param0.s1),\n"
"                  native_rsqrt(param0.s2), native_rsqrt(param0.s3),\n"
"                  native_rsqrt(param0.s4), native_rsqrt(param0.s5),\n"
"                  native_rsqrt(param0.s6), native_rsqrt(param0.s7),\n"
"                  native_rsqrt(param0.s8), native_rsqrt(param0.s9),\n"
"                  native_rsqrt(param0.sa), native_rsqrt(param0.sb),\n"
"                  native_rsqrt(param0.sc), native_rsqrt(param0.sd),\n"
"                  native_rsqrt(param0.se), native_rsqrt(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_sin (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_sin (float2 param0)\n"
"{return (float2)(native_sin(param0.s0), native_sin(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_sin (float3 param0)\n"
"{return (float3)(native_sin(param0.s0), native_sin(param0.s1),\n"
"                 native_sin(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_sin (float4 param0)\n"
"{return (float4)(native_sin(param0.s0), native_sin(param0.s1),\n"
"                 native_sin(param0.s2), native_sin(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_sin (float8 param0)\n"
"{return (float8)(native_sin(param0.s0), native_sin(param0.s1),\n"
"                 native_sin(param0.s2), native_sin(param0.s3),\n"
"                 native_sin(param0.s4), native_sin(param0.s5),\n"
"                 native_sin(param0.s6), native_sin(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_sin (float16 param0)\n"
"{return (float16)(native_sin(param0.s0), native_sin(param0.s1),\n"
"                  native_sin(param0.s2), native_sin(param0.s3),\n"
"                  native_sin(param0.s4), native_sin(param0.s5),\n"
"                  native_sin(param0.s6), native_sin(param0.s7),\n"
"                  native_sin(param0.s8), native_sin(param0.s9),\n"
"                  native_sin(param0.sa), native_sin(param0.sb),\n"
"                  native_sin(param0.sc), native_sin(param0.sd),\n"
"                  native_sin(param0.se), native_sin(param0.sf)); }\n"
"\n"
"\n"
"//gentype native_tan (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 native_tan (float2 param0)\n"
"{return (float2)(native_tan(param0.s0), native_tan(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 native_tan (float3 param0)\n"
"{return (float3)(native_tan(param0.s0), native_tan(param0.s1),\n"
"                 native_tan(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 native_tan (float4 param0)\n"
"{return (float4)(native_tan(param0.s0), native_tan(param0.s1),\n"
"                 native_tan(param0.s2), native_tan(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 native_tan (float8 param0)\n"
"{return (float8)(native_tan(param0.s0), native_tan(param0.s1),\n"
"                 native_tan(param0.s2), native_tan(param0.s3),\n"
"                 native_tan(param0.s4), native_tan(param0.s5),\n"
"                 native_tan(param0.s6), native_tan(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 native_tan (float16 param0)\n"
"{return (float16)(native_tan(param0.s0), native_tan(param0.s1),\n"
"                  native_tan(param0.s2), native_tan(param0.s3),\n"
"                  native_tan(param0.s4), native_tan(param0.s5),\n"
"                  native_tan(param0.s6), native_tan(param0.s7),\n"
"                  native_tan(param0.s8), native_tan(param0.s9),\n"
"                  native_tan(param0.sa), native_tan(param0.sb),\n"
"                  native_tan(param0.sc), native_tan(param0.sd),\n"
"                  native_tan(param0.se), native_tan(param0.sf)); }\n"
"\n"
"\n"
"//integer builtin functions\n"
"//ugentype abs (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE uchar2 abs (char2 param0)\n"
"{return (uchar2)(abs(param0.s0), abs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 abs (char3 param0)\n"
"{return (uchar3)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 abs (char4 param0)\n"
"{return (uchar4)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 abs (char8 param0)\n"
"{return (uchar8)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3),\n"
"                 abs(param0.s4), abs(param0.s5),\n"
"                 abs(param0.s6), abs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 abs (char16 param0)\n"
"{return (uchar16)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2), abs(param0.s3),\n"
"                  abs(param0.s4), abs(param0.s5),\n"
"                  abs(param0.s6), abs(param0.s7),\n"
"                  abs(param0.s8), abs(param0.s9),\n"
"                  abs(param0.sa), abs(param0.sb),\n"
"                  abs(param0.sc), abs(param0.sd),\n"
"                  abs(param0.se), abs(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 abs (short2 param0)\n"
"{return (ushort2)(abs(param0.s0), abs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 abs (short3 param0)\n"
"{return (ushort3)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 abs (short4 param0)\n"
"{return (ushort4)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2), abs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 abs (short8 param0)\n"
"{return (ushort8)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2), abs(param0.s3),\n"
"                  abs(param0.s4), abs(param0.s5),\n"
"                  abs(param0.s6), abs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 abs (short16 param0)\n"
"{return (ushort16)(abs(param0.s0), abs(param0.s1),\n"
"                   abs(param0.s2), abs(param0.s3),\n"
"                   abs(param0.s4), abs(param0.s5),\n"
"                   abs(param0.s6), abs(param0.s7),\n"
"                   abs(param0.s8), abs(param0.s9),\n"
"                   abs(param0.sa), abs(param0.sb),\n"
"                   abs(param0.sc), abs(param0.sd),\n"
"                   abs(param0.se), abs(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 abs (int2 param0)\n"
"{return (uint2)(abs(param0.s0), abs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 abs (int3 param0)\n"
"{return (uint3)(abs(param0.s0), abs(param0.s1),\n"
"                abs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 abs (int4 param0)\n"
"{return (uint4)(abs(param0.s0), abs(param0.s1),\n"
"                abs(param0.s2), abs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 abs (int8 param0)\n"
"{return (uint8)(abs(param0.s0), abs(param0.s1),\n"
"                abs(param0.s2), abs(param0.s3),\n"
"                abs(param0.s4), abs(param0.s5),\n"
"                abs(param0.s6), abs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 abs (int16 param0)\n"
"{return (uint16)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3),\n"
"                 abs(param0.s4), abs(param0.s5),\n"
"                 abs(param0.s6), abs(param0.s7),\n"
"                 abs(param0.s8), abs(param0.s9),\n"
"                 abs(param0.sa), abs(param0.sb),\n"
"                 abs(param0.sc), abs(param0.sd),\n"
"                 abs(param0.se), abs(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 abs (long2 param0)\n"
"{return (ulong2)(abs(param0.s0), abs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 abs (long3 param0)\n"
"{return (ulong3)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 abs (long4 param0)\n"
"{return (ulong4)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 abs (long8 param0)\n"
"{return (ulong8)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3),\n"
"                 abs(param0.s4), abs(param0.s5),\n"
"                 abs(param0.s6), abs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 abs (long16 param0)\n"
"{return (ulong16)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2), abs(param0.s3),\n"
"                  abs(param0.s4), abs(param0.s5),\n"
"                  abs(param0.s6), abs(param0.s7),\n"
"                  abs(param0.s8), abs(param0.s9),\n"
"                  abs(param0.sa), abs(param0.sb),\n"
"                  abs(param0.sc), abs(param0.sd),\n"
"                  abs(param0.se), abs(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 abs (uchar2 param0)\n"
"{return (uchar2)(abs(param0.s0), abs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 abs (uchar3 param0)\n"
"{return (uchar3)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 abs (uchar4 param0)\n"
"{return (uchar4)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 abs (uchar8 param0)\n"
"{return (uchar8)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3),\n"
"                 abs(param0.s4), abs(param0.s5),\n"
"                 abs(param0.s6), abs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 abs (uchar16 param0)\n"
"{return (uchar16)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2), abs(param0.s3),\n"
"                  abs(param0.s4), abs(param0.s5),\n"
"                  abs(param0.s6), abs(param0.s7),\n"
"                  abs(param0.s8), abs(param0.s9),\n"
"                  abs(param0.sa), abs(param0.sb),\n"
"                  abs(param0.sc), abs(param0.sd),\n"
"                  abs(param0.se), abs(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 abs (ushort2 param0)\n"
"{return (ushort2)(abs(param0.s0), abs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 abs (ushort3 param0)\n"
"{return (ushort3)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 abs (ushort4 param0)\n"
"{return (ushort4)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2), abs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 abs (ushort8 param0)\n"
"{return (ushort8)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2), abs(param0.s3),\n"
"                  abs(param0.s4), abs(param0.s5),\n"
"                  abs(param0.s6), abs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 abs (ushort16 param0)\n"
"{return (ushort16)(abs(param0.s0), abs(param0.s1),\n"
"                   abs(param0.s2), abs(param0.s3),\n"
"                   abs(param0.s4), abs(param0.s5),\n"
"                   abs(param0.s6), abs(param0.s7),\n"
"                   abs(param0.s8), abs(param0.s9),\n"
"                   abs(param0.sa), abs(param0.sb),\n"
"                   abs(param0.sc), abs(param0.sd),\n"
"                   abs(param0.se), abs(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 abs (uint2 param0)\n"
"{return (uint2)(abs(param0.s0), abs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 abs (uint3 param0)\n"
"{return (uint3)(abs(param0.s0), abs(param0.s1),\n"
"                abs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 abs (uint4 param0)\n"
"{return (uint4)(abs(param0.s0), abs(param0.s1),\n"
"                abs(param0.s2), abs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 abs (uint8 param0)\n"
"{return (uint8)(abs(param0.s0), abs(param0.s1),\n"
"                abs(param0.s2), abs(param0.s3),\n"
"                abs(param0.s4), abs(param0.s5),\n"
"                abs(param0.s6), abs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 abs (uint16 param0)\n"
"{return (uint16)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3),\n"
"                 abs(param0.s4), abs(param0.s5),\n"
"                 abs(param0.s6), abs(param0.s7),\n"
"                 abs(param0.s8), abs(param0.s9),\n"
"                 abs(param0.sa), abs(param0.sb),\n"
"                 abs(param0.sc), abs(param0.sd),\n"
"                 abs(param0.se), abs(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 abs (ulong2 param0)\n"
"{return (ulong2)(abs(param0.s0), abs(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 abs (ulong3 param0)\n"
"{return (ulong3)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 abs (ulong4 param0)\n"
"{return (ulong4)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 abs (ulong8 param0)\n"
"{return (ulong8)(abs(param0.s0), abs(param0.s1),\n"
"                 abs(param0.s2), abs(param0.s3),\n"
"                 abs(param0.s4), abs(param0.s5),\n"
"                 abs(param0.s6), abs(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 abs (ulong16 param0)\n"
"{return (ulong16)(abs(param0.s0), abs(param0.s1),\n"
"                  abs(param0.s2), abs(param0.s3),\n"
"                  abs(param0.s4), abs(param0.s5),\n"
"                  abs(param0.s6), abs(param0.s7),\n"
"                  abs(param0.s8), abs(param0.s9),\n"
"                  abs(param0.sa), abs(param0.sb),\n"
"                  abs(param0.sc), abs(param0.sd),\n"
"                  abs(param0.se), abs(param0.sf)); }\n"
"\n"
"\n"
"//ugentype abs_diff (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE uchar2 abs_diff (char2 param0, char2 param1)\n"
"{return (uchar2)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 abs_diff (char3 param0, char3 param1)\n"
"{return (uchar3)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 abs_diff (char4 param0, char4 param1)\n"
"{return (uchar4)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 abs_diff (char8 param0, char8 param1)\n"
"{return (uchar8)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                 abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                 abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 abs_diff (char16 param0, char16 param1)\n"
"{return (uchar16)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                  abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                  abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7),\n"
"                  abs_diff(param0.s8, param1.s8), abs_diff(param0.s9, param1.s9),\n"
"                  abs_diff(param0.sa, param1.sa), abs_diff(param0.sb, param1.sb),\n"
"                  abs_diff(param0.sc, param1.sc), abs_diff(param0.sd, param1.sd),\n"
"                  abs_diff(param0.se, param1.se), abs_diff(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 abs_diff (short2 param0, short2 param1)\n"
"{return (ushort2)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 abs_diff (short3 param0, short3 param1)\n"
"{return (ushort3)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 abs_diff (short4 param0, short4 param1)\n"
"{return (ushort4)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 abs_diff (short8 param0, short8 param1)\n"
"{return (ushort8)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                  abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                  abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 abs_diff (short16 param0, short16 param1)\n"
"{return (ushort16)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                   abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                   abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                   abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7),\n"
"                   abs_diff(param0.s8, param1.s8), abs_diff(param0.s9, param1.s9),\n"
"                   abs_diff(param0.sa, param1.sa), abs_diff(param0.sb, param1.sb),\n"
"                   abs_diff(param0.sc, param1.sc), abs_diff(param0.sd, param1.sd),\n"
"                   abs_diff(param0.se, param1.se), abs_diff(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 abs_diff (int2 param0, int2 param1)\n"
"{return (uint2)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 abs_diff (int3 param0, int3 param1)\n"
"{return (uint3)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                abs_diff(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 abs_diff (int4 param0, int4 param1)\n"
"{return (uint4)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 abs_diff (int8 param0, int8 param1)\n"
"{return (uint8)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 abs_diff (int16 param0, int16 param1)\n"
"{return (uint16)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                 abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                 abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7),\n"
"                 abs_diff(param0.s8, param1.s8), abs_diff(param0.s9, param1.s9),\n"
"                 abs_diff(param0.sa, param1.sa), abs_diff(param0.sb, param1.sb),\n"
"                 abs_diff(param0.sc, param1.sc), abs_diff(param0.sd, param1.sd),\n"
"                 abs_diff(param0.se, param1.se), abs_diff(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 abs_diff (long2 param0, long2 param1)\n"
"{return (ulong2)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 abs_diff (long3 param0, long3 param1)\n"
"{return (ulong3)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 abs_diff (long4 param0, long4 param1)\n"
"{return (ulong4)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 abs_diff (long8 param0, long8 param1)\n"
"{return (ulong8)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                 abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                 abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 abs_diff (long16 param0, long16 param1)\n"
"{return (ulong16)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                  abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                  abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7),\n"
"                  abs_diff(param0.s8, param1.s8), abs_diff(param0.s9, param1.s9),\n"
"                  abs_diff(param0.sa, param1.sa), abs_diff(param0.sb, param1.sb),\n"
"                  abs_diff(param0.sc, param1.sc), abs_diff(param0.sd, param1.sd),\n"
"                  abs_diff(param0.se, param1.se), abs_diff(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 abs_diff (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 abs_diff (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 abs_diff (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 abs_diff (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                 abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                 abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 abs_diff (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                  abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                  abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7),\n"
"                  abs_diff(param0.s8, param1.s8), abs_diff(param0.s9, param1.s9),\n"
"                  abs_diff(param0.sa, param1.sa), abs_diff(param0.sb, param1.sb),\n"
"                  abs_diff(param0.sc, param1.sc), abs_diff(param0.sd, param1.sd),\n"
"                  abs_diff(param0.se, param1.se), abs_diff(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 abs_diff (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 abs_diff (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 abs_diff (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 abs_diff (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                  abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                  abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 abs_diff (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                   abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                   abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                   abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7),\n"
"                   abs_diff(param0.s8, param1.s8), abs_diff(param0.s9, param1.s9),\n"
"                   abs_diff(param0.sa, param1.sa), abs_diff(param0.sb, param1.sb),\n"
"                   abs_diff(param0.sc, param1.sc), abs_diff(param0.sd, param1.sd),\n"
"                   abs_diff(param0.se, param1.se), abs_diff(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 abs_diff (uint2 param0, uint2 param1)\n"
"{return (uint2)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 abs_diff (uint3 param0, uint3 param1)\n"
"{return (uint3)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                abs_diff(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 abs_diff (uint4 param0, uint4 param1)\n"
"{return (uint4)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 abs_diff (uint8 param0, uint8 param1)\n"
"{return (uint8)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 abs_diff (uint16 param0, uint16 param1)\n"
"{return (uint16)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                 abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                 abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7),\n"
"                 abs_diff(param0.s8, param1.s8), abs_diff(param0.s9, param1.s9),\n"
"                 abs_diff(param0.sa, param1.sa), abs_diff(param0.sb, param1.sb),\n"
"                 abs_diff(param0.sc, param1.sc), abs_diff(param0.sd, param1.sd),\n"
"                 abs_diff(param0.se, param1.se), abs_diff(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 abs_diff (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 abs_diff (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 abs_diff (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 abs_diff (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                 abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                 abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                 abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 abs_diff (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(abs_diff(param0.s0, param1.s0), abs_diff(param0.s1, param1.s1),\n"
"                  abs_diff(param0.s2, param1.s2), abs_diff(param0.s3, param1.s3),\n"
"                  abs_diff(param0.s4, param1.s4), abs_diff(param0.s5, param1.s5),\n"
"                  abs_diff(param0.s6, param1.s6), abs_diff(param0.s7, param1.s7),\n"
"                  abs_diff(param0.s8, param1.s8), abs_diff(param0.s9, param1.s9),\n"
"                  abs_diff(param0.sa, param1.sa), abs_diff(param0.sb, param1.sb),\n"
"                  abs_diff(param0.sc, param1.sc), abs_diff(param0.sd, param1.sd),\n"
"                  abs_diff(param0.se, param1.se), abs_diff(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype add_sat (gentype x,  gentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 add_sat (char2 param0, char2 param1)\n"
"{return (char2)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 add_sat (char3 param0, char3 param1)\n"
"{return (char3)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 add_sat (char4 param0, char4 param1)\n"
"{return (char4)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 add_sat (char8 param0, char8 param1)\n"
"{return (char8)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 add_sat (char16 param0, char16 param1)\n"
"{return (char16)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                 add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                 add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7),\n"
"                 add_sat(param0.s8, param1.s8), add_sat(param0.s9, param1.s9),\n"
"                 add_sat(param0.sa, param1.sa), add_sat(param0.sb, param1.sb),\n"
"                 add_sat(param0.sc, param1.sc), add_sat(param0.sd, param1.sd),\n"
"                 add_sat(param0.se, param1.se), add_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 add_sat (short2 param0, short2 param1)\n"
"{return (short2)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 add_sat (short3 param0, short3 param1)\n"
"{return (short3)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 add_sat (short4 param0, short4 param1)\n"
"{return (short4)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 add_sat (short8 param0, short8 param1)\n"
"{return (short8)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                 add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                 add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 add_sat (short16 param0, short16 param1)\n"
"{return (short16)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                  add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                  add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                  add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7),\n"
"                  add_sat(param0.s8, param1.s8), add_sat(param0.s9, param1.s9),\n"
"                  add_sat(param0.sa, param1.sa), add_sat(param0.sb, param1.sb),\n"
"                  add_sat(param0.sc, param1.sc), add_sat(param0.sd, param1.sd),\n"
"                  add_sat(param0.se, param1.se), add_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 add_sat (int2 param0, int2 param1)\n"
"{return (int2)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 add_sat (int3 param0, int3 param1)\n"
"{return (int3)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"               add_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 add_sat (int4 param0, int4 param1)\n"
"{return (int4)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"               add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 add_sat (int8 param0, int8 param1)\n"
"{return (int8)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"               add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"               add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"               add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 add_sat (int16 param0, int16 param1)\n"
"{return (int16)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7),\n"
"                add_sat(param0.s8, param1.s8), add_sat(param0.s9, param1.s9),\n"
"                add_sat(param0.sa, param1.sa), add_sat(param0.sb, param1.sb),\n"
"                add_sat(param0.sc, param1.sc), add_sat(param0.sd, param1.sd),\n"
"                add_sat(param0.se, param1.se), add_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 add_sat (long2 param0, long2 param1)\n"
"{return (long2)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 add_sat (long3 param0, long3 param1)\n"
"{return (long3)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 add_sat (long4 param0, long4 param1)\n"
"{return (long4)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 add_sat (long8 param0, long8 param1)\n"
"{return (long8)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 add_sat (long16 param0, long16 param1)\n"
"{return (long16)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                 add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                 add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7),\n"
"                 add_sat(param0.s8, param1.s8), add_sat(param0.s9, param1.s9),\n"
"                 add_sat(param0.sa, param1.sa), add_sat(param0.sb, param1.sb),\n"
"                 add_sat(param0.sc, param1.sc), add_sat(param0.sd, param1.sd),\n"
"                 add_sat(param0.se, param1.se), add_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 add_sat (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 add_sat (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 add_sat (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 add_sat (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                 add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                 add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 add_sat (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                  add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                  add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                  add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7),\n"
"                  add_sat(param0.s8, param1.s8), add_sat(param0.s9, param1.s9),\n"
"                  add_sat(param0.sa, param1.sa), add_sat(param0.sb, param1.sb),\n"
"                  add_sat(param0.sc, param1.sc), add_sat(param0.sd, param1.sd),\n"
"                  add_sat(param0.se, param1.se), add_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 add_sat (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 add_sat (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                  add_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 add_sat (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                  add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 add_sat (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                  add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                  add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                  add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 add_sat (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                   add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                   add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                   add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7),\n"
"                   add_sat(param0.s8, param1.s8), add_sat(param0.s9, param1.s9),\n"
"                   add_sat(param0.sa, param1.sa), add_sat(param0.sb, param1.sb),\n"
"                   add_sat(param0.sc, param1.sc), add_sat(param0.sd, param1.sd),\n"
"                   add_sat(param0.se, param1.se), add_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 add_sat (uint2 param0, uint2 param1)\n"
"{return (uint2)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 add_sat (uint3 param0, uint3 param1)\n"
"{return (uint3)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 add_sat (uint4 param0, uint4 param1)\n"
"{return (uint4)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 add_sat (uint8 param0, uint8 param1)\n"
"{return (uint8)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 add_sat (uint16 param0, uint16 param1)\n"
"{return (uint16)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                 add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                 add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7),\n"
"                 add_sat(param0.s8, param1.s8), add_sat(param0.s9, param1.s9),\n"
"                 add_sat(param0.sa, param1.sa), add_sat(param0.sb, param1.sb),\n"
"                 add_sat(param0.sc, param1.sc), add_sat(param0.sd, param1.sd),\n"
"                 add_sat(param0.se, param1.se), add_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 add_sat (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 add_sat (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 add_sat (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 add_sat (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                 add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                 add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                 add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 add_sat (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(add_sat(param0.s0, param1.s0), add_sat(param0.s1, param1.s1),\n"
"                  add_sat(param0.s2, param1.s2), add_sat(param0.s3, param1.s3),\n"
"                  add_sat(param0.s4, param1.s4), add_sat(param0.s5, param1.s5),\n"
"                  add_sat(param0.s6, param1.s6), add_sat(param0.s7, param1.s7),\n"
"                  add_sat(param0.s8, param1.s8), add_sat(param0.s9, param1.s9),\n"
"                  add_sat(param0.sa, param1.sa), add_sat(param0.sb, param1.sb),\n"
"                  add_sat(param0.sc, param1.sc), add_sat(param0.sd, param1.sd),\n"
"                  add_sat(param0.se, param1.se), add_sat(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype hadd (gentype x,  gentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 hadd (char2 param0, char2 param1)\n"
"{return (char2)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 hadd (char3 param0, char3 param1)\n"
"{return (char3)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 hadd (char4 param0, char4 param1)\n"
"{return (char4)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 hadd (char8 param0, char8 param1)\n"
"{return (char8)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 hadd (char16 param0, char16 param1)\n"
"{return (char16)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                 hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                 hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7),\n"
"                 hadd(param0.s8, param1.s8), hadd(param0.s9, param1.s9),\n"
"                 hadd(param0.sa, param1.sa), hadd(param0.sb, param1.sb),\n"
"                 hadd(param0.sc, param1.sc), hadd(param0.sd, param1.sd),\n"
"                 hadd(param0.se, param1.se), hadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 hadd (short2 param0, short2 param1)\n"
"{return (short2)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 hadd (short3 param0, short3 param1)\n"
"{return (short3)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 hadd (short4 param0, short4 param1)\n"
"{return (short4)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 hadd (short8 param0, short8 param1)\n"
"{return (short8)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                 hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                 hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 hadd (short16 param0, short16 param1)\n"
"{return (short16)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                  hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                  hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                  hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7),\n"
"                  hadd(param0.s8, param1.s8), hadd(param0.s9, param1.s9),\n"
"                  hadd(param0.sa, param1.sa), hadd(param0.sb, param1.sb),\n"
"                  hadd(param0.sc, param1.sc), hadd(param0.sd, param1.sd),\n"
"                  hadd(param0.se, param1.se), hadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 hadd (int2 param0, int2 param1)\n"
"{return (int2)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 hadd (int3 param0, int3 param1)\n"
"{return (int3)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"               hadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 hadd (int4 param0, int4 param1)\n"
"{return (int4)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"               hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 hadd (int8 param0, int8 param1)\n"
"{return (int8)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"               hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"               hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"               hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 hadd (int16 param0, int16 param1)\n"
"{return (int16)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7),\n"
"                hadd(param0.s8, param1.s8), hadd(param0.s9, param1.s9),\n"
"                hadd(param0.sa, param1.sa), hadd(param0.sb, param1.sb),\n"
"                hadd(param0.sc, param1.sc), hadd(param0.sd, param1.sd),\n"
"                hadd(param0.se, param1.se), hadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 hadd (long2 param0, long2 param1)\n"
"{return (long2)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 hadd (long3 param0, long3 param1)\n"
"{return (long3)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 hadd (long4 param0, long4 param1)\n"
"{return (long4)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 hadd (long8 param0, long8 param1)\n"
"{return (long8)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 hadd (long16 param0, long16 param1)\n"
"{return (long16)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                 hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                 hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7),\n"
"                 hadd(param0.s8, param1.s8), hadd(param0.s9, param1.s9),\n"
"                 hadd(param0.sa, param1.sa), hadd(param0.sb, param1.sb),\n"
"                 hadd(param0.sc, param1.sc), hadd(param0.sd, param1.sd),\n"
"                 hadd(param0.se, param1.se), hadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 hadd (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 hadd (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 hadd (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 hadd (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                 hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                 hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 hadd (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                  hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                  hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                  hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7),\n"
"                  hadd(param0.s8, param1.s8), hadd(param0.s9, param1.s9),\n"
"                  hadd(param0.sa, param1.sa), hadd(param0.sb, param1.sb),\n"
"                  hadd(param0.sc, param1.sc), hadd(param0.sd, param1.sd),\n"
"                  hadd(param0.se, param1.se), hadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 hadd (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 hadd (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                  hadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 hadd (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                  hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 hadd (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                  hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                  hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                  hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 hadd (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                   hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                   hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                   hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7),\n"
"                   hadd(param0.s8, param1.s8), hadd(param0.s9, param1.s9),\n"
"                   hadd(param0.sa, param1.sa), hadd(param0.sb, param1.sb),\n"
"                   hadd(param0.sc, param1.sc), hadd(param0.sd, param1.sd),\n"
"                   hadd(param0.se, param1.se), hadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 hadd (uint2 param0, uint2 param1)\n"
"{return (uint2)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 hadd (uint3 param0, uint3 param1)\n"
"{return (uint3)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 hadd (uint4 param0, uint4 param1)\n"
"{return (uint4)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 hadd (uint8 param0, uint8 param1)\n"
"{return (uint8)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 hadd (uint16 param0, uint16 param1)\n"
"{return (uint16)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                 hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                 hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7),\n"
"                 hadd(param0.s8, param1.s8), hadd(param0.s9, param1.s9),\n"
"                 hadd(param0.sa, param1.sa), hadd(param0.sb, param1.sb),\n"
"                 hadd(param0.sc, param1.sc), hadd(param0.sd, param1.sd),\n"
"                 hadd(param0.se, param1.se), hadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 hadd (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 hadd (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 hadd (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 hadd (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                 hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                 hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                 hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 hadd (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(hadd(param0.s0, param1.s0), hadd(param0.s1, param1.s1),\n"
"                  hadd(param0.s2, param1.s2), hadd(param0.s3, param1.s3),\n"
"                  hadd(param0.s4, param1.s4), hadd(param0.s5, param1.s5),\n"
"                  hadd(param0.s6, param1.s6), hadd(param0.s7, param1.s7),\n"
"                  hadd(param0.s8, param1.s8), hadd(param0.s9, param1.s9),\n"
"                  hadd(param0.sa, param1.sa), hadd(param0.sb, param1.sb),\n"
"                  hadd(param0.sc, param1.sc), hadd(param0.sd, param1.sd),\n"
"                  hadd(param0.se, param1.se), hadd(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype rhadd (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 rhadd (char2 param0, char2 param1)\n"
"{return (char2)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 rhadd (char3 param0, char3 param1)\n"
"{return (char3)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 rhadd (char4 param0, char4 param1)\n"
"{return (char4)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 rhadd (char8 param0, char8 param1)\n"
"{return (char8)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 rhadd (char16 param0, char16 param1)\n"
"{return (char16)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                 rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                 rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7),\n"
"                 rhadd(param0.s8, param1.s8), rhadd(param0.s9, param1.s9),\n"
"                 rhadd(param0.sa, param1.sa), rhadd(param0.sb, param1.sb),\n"
"                 rhadd(param0.sc, param1.sc), rhadd(param0.sd, param1.sd),\n"
"                 rhadd(param0.se, param1.se), rhadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 rhadd (short2 param0, short2 param1)\n"
"{return (short2)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 rhadd (short3 param0, short3 param1)\n"
"{return (short3)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 rhadd (short4 param0, short4 param1)\n"
"{return (short4)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 rhadd (short8 param0, short8 param1)\n"
"{return (short8)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                 rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                 rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 rhadd (short16 param0, short16 param1)\n"
"{return (short16)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                  rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                  rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                  rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7),\n"
"                  rhadd(param0.s8, param1.s8), rhadd(param0.s9, param1.s9),\n"
"                  rhadd(param0.sa, param1.sa), rhadd(param0.sb, param1.sb),\n"
"                  rhadd(param0.sc, param1.sc), rhadd(param0.sd, param1.sd),\n"
"                  rhadd(param0.se, param1.se), rhadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 rhadd (int2 param0, int2 param1)\n"
"{return (int2)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 rhadd (int3 param0, int3 param1)\n"
"{return (int3)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"               rhadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 rhadd (int4 param0, int4 param1)\n"
"{return (int4)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"               rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 rhadd (int8 param0, int8 param1)\n"
"{return (int8)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"               rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"               rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"               rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 rhadd (int16 param0, int16 param1)\n"
"{return (int16)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7),\n"
"                rhadd(param0.s8, param1.s8), rhadd(param0.s9, param1.s9),\n"
"                rhadd(param0.sa, param1.sa), rhadd(param0.sb, param1.sb),\n"
"                rhadd(param0.sc, param1.sc), rhadd(param0.sd, param1.sd),\n"
"                rhadd(param0.se, param1.se), rhadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 rhadd (long2 param0, long2 param1)\n"
"{return (long2)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 rhadd (long3 param0, long3 param1)\n"
"{return (long3)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 rhadd (long4 param0, long4 param1)\n"
"{return (long4)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 rhadd (long8 param0, long8 param1)\n"
"{return (long8)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 rhadd (long16 param0, long16 param1)\n"
"{return (long16)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                 rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                 rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7),\n"
"                 rhadd(param0.s8, param1.s8), rhadd(param0.s9, param1.s9),\n"
"                 rhadd(param0.sa, param1.sa), rhadd(param0.sb, param1.sb),\n"
"                 rhadd(param0.sc, param1.sc), rhadd(param0.sd, param1.sd),\n"
"                 rhadd(param0.se, param1.se), rhadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 rhadd (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 rhadd (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 rhadd (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 rhadd (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                 rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                 rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 rhadd (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                  rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                  rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                  rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7),\n"
"                  rhadd(param0.s8, param1.s8), rhadd(param0.s9, param1.s9),\n"
"                  rhadd(param0.sa, param1.sa), rhadd(param0.sb, param1.sb),\n"
"                  rhadd(param0.sc, param1.sc), rhadd(param0.sd, param1.sd),\n"
"                  rhadd(param0.se, param1.se), rhadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 rhadd (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 rhadd (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                  rhadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 rhadd (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                  rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 rhadd (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                  rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                  rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                  rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 rhadd (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                   rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                   rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                   rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7),\n"
"                   rhadd(param0.s8, param1.s8), rhadd(param0.s9, param1.s9),\n"
"                   rhadd(param0.sa, param1.sa), rhadd(param0.sb, param1.sb),\n"
"                   rhadd(param0.sc, param1.sc), rhadd(param0.sd, param1.sd),\n"
"                   rhadd(param0.se, param1.se), rhadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 rhadd (uint2 param0, uint2 param1)\n"
"{return (uint2)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 rhadd (uint3 param0, uint3 param1)\n"
"{return (uint3)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 rhadd (uint4 param0, uint4 param1)\n"
"{return (uint4)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 rhadd (uint8 param0, uint8 param1)\n"
"{return (uint8)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 rhadd (uint16 param0, uint16 param1)\n"
"{return (uint16)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                 rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                 rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7),\n"
"                 rhadd(param0.s8, param1.s8), rhadd(param0.s9, param1.s9),\n"
"                 rhadd(param0.sa, param1.sa), rhadd(param0.sb, param1.sb),\n"
"                 rhadd(param0.sc, param1.sc), rhadd(param0.sd, param1.sd),\n"
"                 rhadd(param0.se, param1.se), rhadd(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 rhadd (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 rhadd (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 rhadd (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 rhadd (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                 rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                 rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                 rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 rhadd (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(rhadd(param0.s0, param1.s0), rhadd(param0.s1, param1.s1),\n"
"                  rhadd(param0.s2, param1.s2), rhadd(param0.s3, param1.s3),\n"
"                  rhadd(param0.s4, param1.s4), rhadd(param0.s5, param1.s5),\n"
"                  rhadd(param0.s6, param1.s6), rhadd(param0.s7, param1.s7),\n"
"                  rhadd(param0.s8, param1.s8), rhadd(param0.s9, param1.s9),\n"
"                  rhadd(param0.sa, param1.sa), rhadd(param0.sb, param1.sb),\n"
"                  rhadd(param0.sc, param1.sc), rhadd(param0.sd, param1.sd),\n"
"                  rhadd(param0.se, param1.se), rhadd(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype clamp (gentype x, gentype minval, gentype maxval)\n"
"\n"
"INLINE_OVERLOADABLE char2 clamp (char2 param0, char2 param1, char2 param2)\n"
"{return (char2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 clamp (char3 param0, char3 param1, char3 param2)\n"
"{return (char3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 clamp (char4 param0, char4 param1, char4 param2)\n"
"{return (char4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 clamp (char8 param0, char8 param1, char8 param2)\n"
"{return (char8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 clamp (char16 param0, char16 param1, char16 param2)\n"
"{return (char16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                 clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                 clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                 clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                 clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                 clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                 clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 clamp (short2 param0, short2 param1, short2 param2)\n"
"{return (short2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 clamp (short3 param0, short3 param1, short3 param2)\n"
"{return (short3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 clamp (short4 param0, short4 param1, short4 param2)\n"
"{return (short4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 clamp (short8 param0, short8 param1, short8 param2)\n"
"{return (short8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                 clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                 clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 clamp (short16 param0, short16 param1, short16 param2)\n"
"{return (short16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                  clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                  clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                  clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                  clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                  clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                  clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                  clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 clamp (int2 param0, int2 param1, int2 param2)\n"
"{return (int2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 clamp (int3 param0, int3 param1, int3 param2)\n"
"{return (int3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"               clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 clamp (int4 param0, int4 param1, int4 param2)\n"
"{return (int4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"               clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 clamp (int8 param0, int8 param1, int8 param2)\n"
"{return (int8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"               clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"               clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"               clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 clamp (int16 param0, int16 param1, int16 param2)\n"
"{return (int16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 clamp (long2 param0, long2 param1, long2 param2)\n"
"{return (long2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 clamp (long3 param0, long3 param1, long3 param2)\n"
"{return (long3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 clamp (long4 param0, long4 param1, long4 param2)\n"
"{return (long4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 clamp (long8 param0, long8 param1, long8 param2)\n"
"{return (long8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 clamp (long16 param0, long16 param1, long16 param2)\n"
"{return (long16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                 clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                 clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                 clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                 clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                 clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                 clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 clamp (uchar2 param0, uchar2 param1, uchar2 param2)\n"
"{return (uchar2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 clamp (uchar3 param0, uchar3 param1, uchar3 param2)\n"
"{return (uchar3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 clamp (uchar4 param0, uchar4 param1, uchar4 param2)\n"
"{return (uchar4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 clamp (uchar8 param0, uchar8 param1, uchar8 param2)\n"
"{return (uchar8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                 clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                 clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 clamp (uchar16 param0, uchar16 param1, uchar16 param2)\n"
"{return (uchar16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                  clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                  clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                  clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                  clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                  clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                  clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                  clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 clamp (ushort2 param0, ushort2 param1, ushort2 param2)\n"
"{return (ushort2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 clamp (ushort3 param0, ushort3 param1, ushort3 param2)\n"
"{return (ushort3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                  clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 clamp (ushort4 param0, ushort4 param1, ushort4 param2)\n"
"{return (ushort4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                  clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 clamp (ushort8 param0, ushort8 param1, ushort8 param2)\n"
"{return (ushort8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                  clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                  clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                  clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 clamp (ushort16 param0, ushort16 param1, ushort16 param2)\n"
"{return (ushort16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                   clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                   clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                   clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                   clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                   clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                   clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                   clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 clamp (uint2 param0, uint2 param1, uint2 param2)\n"
"{return (uint2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 clamp (uint3 param0, uint3 param1, uint3 param2)\n"
"{return (uint3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 clamp (uint4 param0, uint4 param1, uint4 param2)\n"
"{return (uint4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 clamp (uint8 param0, uint8 param1, uint8 param2)\n"
"{return (uint8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 clamp (uint16 param0, uint16 param1, uint16 param2)\n"
"{return (uint16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                 clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                 clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                 clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                 clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                 clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                 clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 clamp (ulong2 param0, ulong2 param1, ulong2 param2)\n"
"{return (ulong2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 clamp (ulong3 param0, ulong3 param1, ulong3 param2)\n"
"{return (ulong3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 clamp (ulong4 param0, ulong4 param1, ulong4 param2)\n"
"{return (ulong4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 clamp (ulong8 param0, ulong8 param1, ulong8 param2)\n"
"{return (ulong8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                 clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                 clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 clamp (ulong16 param0, ulong16 param1, ulong16 param2)\n"
"{return (ulong16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                  clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                  clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                  clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                  clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                  clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                  clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                  clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentype clamp (gentype x, sgentype minval, sgentype maxval)\n"
"\n"
"INLINE_OVERLOADABLE char2 clamp (char2 param0, char param1, char param2)\n"
"{return (char2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 clamp (char3 param0, char param1, char param2)\n"
"{return (char3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 clamp (char4 param0, char param1, char param2)\n"
"{return (char4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 clamp (char8 param0, char param1, char param2)\n"
"{return (char8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 clamp (char16 param0, char param1, char param2)\n"
"{return (char16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                 clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                 clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                 clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                 clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                 clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                 clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 clamp (short2 param0, short param1, short param2)\n"
"{return (short2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 clamp (short3 param0, short param1, short param2)\n"
"{return (short3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 clamp (short4 param0, short param1, short param2)\n"
"{return (short4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 clamp (short8 param0, short param1, short param2)\n"
"{return (short8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                 clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                 clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 clamp (short16 param0, short param1, short param2)\n"
"{return (short16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                  clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                  clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                  clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                  clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                  clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                  clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                  clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 clamp (int2 param0, int param1, int param2)\n"
"{return (int2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 clamp (int3 param0, int param1, int param2)\n"
"{return (int3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"               clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 clamp (int4 param0, int param1, int param2)\n"
"{return (int4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"               clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 clamp (int8 param0, int param1, int param2)\n"
"{return (int8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"               clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"               clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"               clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 clamp (int16 param0, int param1, int param2)\n"
"{return (int16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 clamp (long2 param0, long param1, long param2)\n"
"{return (long2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 clamp (long3 param0, long param1, long param2)\n"
"{return (long3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 clamp (long4 param0, long param1, long param2)\n"
"{return (long4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 clamp (long8 param0, long param1, long param2)\n"
"{return (long8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 clamp (long16 param0, long param1, long param2)\n"
"{return (long16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                 clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                 clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                 clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                 clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                 clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                 clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 clamp (uchar2 param0, uchar param1, uchar param2)\n"
"{return (uchar2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 clamp (uchar3 param0, uchar param1, uchar param2)\n"
"{return (uchar3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 clamp (uchar4 param0, uchar param1, uchar param2)\n"
"{return (uchar4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 clamp (uchar8 param0, uchar param1, uchar param2)\n"
"{return (uchar8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                 clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                 clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 clamp (uchar16 param0, uchar param1, uchar param2)\n"
"{return (uchar16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                  clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                  clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                  clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                  clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                  clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                  clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                  clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 clamp (ushort2 param0, ushort param1, ushort param2)\n"
"{return (ushort2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 clamp (ushort3 param0, ushort param1, ushort param2)\n"
"{return (ushort3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                  clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 clamp (ushort4 param0, ushort param1, ushort param2)\n"
"{return (ushort4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                  clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 clamp (ushort8 param0, ushort param1, ushort param2)\n"
"{return (ushort8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                  clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                  clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                  clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 clamp (ushort16 param0, ushort param1, ushort param2)\n"
"{return (ushort16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                   clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                   clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                   clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                   clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                   clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                   clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                   clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 clamp (uint2 param0, uint param1, uint param2)\n"
"{return (uint2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 clamp (uint3 param0, uint param1, uint param2)\n"
"{return (uint3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 clamp (uint4 param0, uint param1, uint param2)\n"
"{return (uint4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 clamp (uint8 param0, uint param1, uint param2)\n"
"{return (uint8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 clamp (uint16 param0, uint param1, uint param2)\n"
"{return (uint16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                 clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                 clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                 clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                 clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                 clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                 clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 clamp (ulong2 param0, ulong param1, ulong param2)\n"
"{return (ulong2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 clamp (ulong3 param0, ulong param1, ulong param2)\n"
"{return (ulong3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 clamp (ulong4 param0, ulong param1, ulong param2)\n"
"{return (ulong4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 clamp (ulong8 param0, ulong param1, ulong param2)\n"
"{return (ulong8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                 clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                 clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 clamp (ulong16 param0, ulong param1, ulong param2)\n"
"{return (ulong16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                  clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                  clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                  clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                  clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                  clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                  clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                  clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"\n"
"//gentype clz (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE char2 clz (char2 param0)\n"
"{return (char2)(clz(param0.s0), clz(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 clz (char3 param0)\n"
"{return (char3)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 clz (char4 param0)\n"
"{return (char4)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2), clz(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 clz (char8 param0)\n"
"{return (char8)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2), clz(param0.s3),\n"
"                clz(param0.s4), clz(param0.s5),\n"
"                clz(param0.s6), clz(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 clz (char16 param0)\n"
"{return (char16)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3),\n"
"                 clz(param0.s4), clz(param0.s5),\n"
"                 clz(param0.s6), clz(param0.s7),\n"
"                 clz(param0.s8), clz(param0.s9),\n"
"                 clz(param0.sa), clz(param0.sb),\n"
"                 clz(param0.sc), clz(param0.sd),\n"
"                 clz(param0.se), clz(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 clz (short2 param0)\n"
"{return (short2)(clz(param0.s0), clz(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 clz (short3 param0)\n"
"{return (short3)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 clz (short4 param0)\n"
"{return (short4)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 clz (short8 param0)\n"
"{return (short8)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3),\n"
"                 clz(param0.s4), clz(param0.s5),\n"
"                 clz(param0.s6), clz(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 clz (short16 param0)\n"
"{return (short16)(clz(param0.s0), clz(param0.s1),\n"
"                  clz(param0.s2), clz(param0.s3),\n"
"                  clz(param0.s4), clz(param0.s5),\n"
"                  clz(param0.s6), clz(param0.s7),\n"
"                  clz(param0.s8), clz(param0.s9),\n"
"                  clz(param0.sa), clz(param0.sb),\n"
"                  clz(param0.sc), clz(param0.sd),\n"
"                  clz(param0.se), clz(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 clz (int2 param0)\n"
"{return (int2)(clz(param0.s0), clz(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 clz (int3 param0)\n"
"{return (int3)(clz(param0.s0), clz(param0.s1),\n"
"               clz(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 clz (int4 param0)\n"
"{return (int4)(clz(param0.s0), clz(param0.s1),\n"
"               clz(param0.s2), clz(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 clz (int8 param0)\n"
"{return (int8)(clz(param0.s0), clz(param0.s1),\n"
"               clz(param0.s2), clz(param0.s3),\n"
"               clz(param0.s4), clz(param0.s5),\n"
"               clz(param0.s6), clz(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 clz (int16 param0)\n"
"{return (int16)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2), clz(param0.s3),\n"
"                clz(param0.s4), clz(param0.s5),\n"
"                clz(param0.s6), clz(param0.s7),\n"
"                clz(param0.s8), clz(param0.s9),\n"
"                clz(param0.sa), clz(param0.sb),\n"
"                clz(param0.sc), clz(param0.sd),\n"
"                clz(param0.se), clz(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 clz (long2 param0)\n"
"{return (long2)(clz(param0.s0), clz(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 clz (long3 param0)\n"
"{return (long3)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 clz (long4 param0)\n"
"{return (long4)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2), clz(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 clz (long8 param0)\n"
"{return (long8)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2), clz(param0.s3),\n"
"                clz(param0.s4), clz(param0.s5),\n"
"                clz(param0.s6), clz(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 clz (long16 param0)\n"
"{return (long16)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3),\n"
"                 clz(param0.s4), clz(param0.s5),\n"
"                 clz(param0.s6), clz(param0.s7),\n"
"                 clz(param0.s8), clz(param0.s9),\n"
"                 clz(param0.sa), clz(param0.sb),\n"
"                 clz(param0.sc), clz(param0.sd),\n"
"                 clz(param0.se), clz(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 clz (uchar2 param0)\n"
"{return (uchar2)(clz(param0.s0), clz(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 clz (uchar3 param0)\n"
"{return (uchar3)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 clz (uchar4 param0)\n"
"{return (uchar4)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 clz (uchar8 param0)\n"
"{return (uchar8)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3),\n"
"                 clz(param0.s4), clz(param0.s5),\n"
"                 clz(param0.s6), clz(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 clz (uchar16 param0)\n"
"{return (uchar16)(clz(param0.s0), clz(param0.s1),\n"
"                  clz(param0.s2), clz(param0.s3),\n"
"                  clz(param0.s4), clz(param0.s5),\n"
"                  clz(param0.s6), clz(param0.s7),\n"
"                  clz(param0.s8), clz(param0.s9),\n"
"                  clz(param0.sa), clz(param0.sb),\n"
"                  clz(param0.sc), clz(param0.sd),\n"
"                  clz(param0.se), clz(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 clz (ushort2 param0)\n"
"{return (ushort2)(clz(param0.s0), clz(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 clz (ushort3 param0)\n"
"{return (ushort3)(clz(param0.s0), clz(param0.s1),\n"
"                  clz(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 clz (ushort4 param0)\n"
"{return (ushort4)(clz(param0.s0), clz(param0.s1),\n"
"                  clz(param0.s2), clz(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 clz (ushort8 param0)\n"
"{return (ushort8)(clz(param0.s0), clz(param0.s1),\n"
"                  clz(param0.s2), clz(param0.s3),\n"
"                  clz(param0.s4), clz(param0.s5),\n"
"                  clz(param0.s6), clz(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 clz (ushort16 param0)\n"
"{return (ushort16)(clz(param0.s0), clz(param0.s1),\n"
"                   clz(param0.s2), clz(param0.s3),\n"
"                   clz(param0.s4), clz(param0.s5),\n"
"                   clz(param0.s6), clz(param0.s7),\n"
"                   clz(param0.s8), clz(param0.s9),\n"
"                   clz(param0.sa), clz(param0.sb),\n"
"                   clz(param0.sc), clz(param0.sd),\n"
"                   clz(param0.se), clz(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 clz (uint2 param0)\n"
"{return (uint2)(clz(param0.s0), clz(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 clz (uint3 param0)\n"
"{return (uint3)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 clz (uint4 param0)\n"
"{return (uint4)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2), clz(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 clz (uint8 param0)\n"
"{return (uint8)(clz(param0.s0), clz(param0.s1),\n"
"                clz(param0.s2), clz(param0.s3),\n"
"                clz(param0.s4), clz(param0.s5),\n"
"                clz(param0.s6), clz(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 clz (uint16 param0)\n"
"{return (uint16)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3),\n"
"                 clz(param0.s4), clz(param0.s5),\n"
"                 clz(param0.s6), clz(param0.s7),\n"
"                 clz(param0.s8), clz(param0.s9),\n"
"                 clz(param0.sa), clz(param0.sb),\n"
"                 clz(param0.sc), clz(param0.sd),\n"
"                 clz(param0.se), clz(param0.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 clz (ulong2 param0)\n"
"{return (ulong2)(clz(param0.s0), clz(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 clz (ulong3 param0)\n"
"{return (ulong3)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 clz (ulong4 param0)\n"
"{return (ulong4)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 clz (ulong8 param0)\n"
"{return (ulong8)(clz(param0.s0), clz(param0.s1),\n"
"                 clz(param0.s2), clz(param0.s3),\n"
"                 clz(param0.s4), clz(param0.s5),\n"
"                 clz(param0.s6), clz(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 clz (ulong16 param0)\n"
"{return (ulong16)(clz(param0.s0), clz(param0.s1),\n"
"                  clz(param0.s2), clz(param0.s3),\n"
"                  clz(param0.s4), clz(param0.s5),\n"
"                  clz(param0.s6), clz(param0.s7),\n"
"                  clz(param0.s8), clz(param0.s9),\n"
"                  clz(param0.sa), clz(param0.sb),\n"
"                  clz(param0.sc), clz(param0.sd),\n"
"                  clz(param0.se), clz(param0.sf)); }\n"
"\n"
"\n"
"//gentype mad_hi (gentype a, gentype b, gentype c)\n"
"\n"
"INLINE_OVERLOADABLE char2 mad_hi (char2 param0, char2 param1, char2 param2)\n"
"{return (char2)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 mad_hi (char3 param0, char3 param1, char3 param2)\n"
"{return (char3)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 mad_hi (char4 param0, char4 param1, char4 param2)\n"
"{return (char4)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 mad_hi (char8 param0, char8 param1, char8 param2)\n"
"{return (char8)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 mad_hi (char16 param0, char16 param1, char16 param2)\n"
"{return (char16)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                 mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                 mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7),\n"
"                 mad_hi(param0.s8, param1.s8, param2.s8), mad_hi(param0.s9, param1.s9, param2.s9),\n"
"                 mad_hi(param0.sa, param1.sa, param2.sa), mad_hi(param0.sb, param1.sb, param2.sb),\n"
"                 mad_hi(param0.sc, param1.sc, param2.sc), mad_hi(param0.sd, param1.sd, param2.sd),\n"
"                 mad_hi(param0.se, param1.se, param2.se), mad_hi(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 mad_hi (short2 param0, short2 param1, short2 param2)\n"
"{return (short2)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 mad_hi (short3 param0, short3 param1, short3 param2)\n"
"{return (short3)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 mad_hi (short4 param0, short4 param1, short4 param2)\n"
"{return (short4)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 mad_hi (short8 param0, short8 param1, short8 param2)\n"
"{return (short8)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                 mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                 mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 mad_hi (short16 param0, short16 param1, short16 param2)\n"
"{return (short16)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                  mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                  mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                  mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7),\n"
"                  mad_hi(param0.s8, param1.s8, param2.s8), mad_hi(param0.s9, param1.s9, param2.s9),\n"
"                  mad_hi(param0.sa, param1.sa, param2.sa), mad_hi(param0.sb, param1.sb, param2.sb),\n"
"                  mad_hi(param0.sc, param1.sc, param2.sc), mad_hi(param0.sd, param1.sd, param2.sd),\n"
"                  mad_hi(param0.se, param1.se, param2.se), mad_hi(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 mad_hi (int2 param0, int2 param1, int2 param2)\n"
"{return (int2)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 mad_hi (int3 param0, int3 param1, int3 param2)\n"
"{return (int3)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"               mad_hi(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 mad_hi (int4 param0, int4 param1, int4 param2)\n"
"{return (int4)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"               mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 mad_hi (int8 param0, int8 param1, int8 param2)\n"
"{return (int8)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"               mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"               mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"               mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 mad_hi (int16 param0, int16 param1, int16 param2)\n"
"{return (int16)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7),\n"
"                mad_hi(param0.s8, param1.s8, param2.s8), mad_hi(param0.s9, param1.s9, param2.s9),\n"
"                mad_hi(param0.sa, param1.sa, param2.sa), mad_hi(param0.sb, param1.sb, param2.sb),\n"
"                mad_hi(param0.sc, param1.sc, param2.sc), mad_hi(param0.sd, param1.sd, param2.sd),\n"
"                mad_hi(param0.se, param1.se, param2.se), mad_hi(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 mad_hi (long2 param0, long2 param1, long2 param2)\n"
"{return (long2)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 mad_hi (long3 param0, long3 param1, long3 param2)\n"
"{return (long3)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 mad_hi (long4 param0, long4 param1, long4 param2)\n"
"{return (long4)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 mad_hi (long8 param0, long8 param1, long8 param2)\n"
"{return (long8)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 mad_hi (long16 param0, long16 param1, long16 param2)\n"
"{return (long16)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                 mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                 mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7),\n"
"                 mad_hi(param0.s8, param1.s8, param2.s8), mad_hi(param0.s9, param1.s9, param2.s9),\n"
"                 mad_hi(param0.sa, param1.sa, param2.sa), mad_hi(param0.sb, param1.sb, param2.sb),\n"
"                 mad_hi(param0.sc, param1.sc, param2.sc), mad_hi(param0.sd, param1.sd, param2.sd),\n"
"                 mad_hi(param0.se, param1.se, param2.se), mad_hi(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 mad_hi (uchar2 param0, uchar2 param1, uchar2 param2)\n"
"{return (uchar2)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 mad_hi (uchar3 param0, uchar3 param1, uchar3 param2)\n"
"{return (uchar3)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 mad_hi (uchar4 param0, uchar4 param1, uchar4 param2)\n"
"{return (uchar4)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 mad_hi (uchar8 param0, uchar8 param1, uchar8 param2)\n"
"{return (uchar8)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                 mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                 mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 mad_hi (uchar16 param0, uchar16 param1, uchar16 param2)\n"
"{return (uchar16)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                  mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                  mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                  mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7),\n"
"                  mad_hi(param0.s8, param1.s8, param2.s8), mad_hi(param0.s9, param1.s9, param2.s9),\n"
"                  mad_hi(param0.sa, param1.sa, param2.sa), mad_hi(param0.sb, param1.sb, param2.sb),\n"
"                  mad_hi(param0.sc, param1.sc, param2.sc), mad_hi(param0.sd, param1.sd, param2.sd),\n"
"                  mad_hi(param0.se, param1.se, param2.se), mad_hi(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 mad_hi (ushort2 param0, ushort2 param1, ushort2 param2)\n"
"{return (ushort2)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 mad_hi (ushort3 param0, ushort3 param1, ushort3 param2)\n"
"{return (ushort3)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                  mad_hi(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 mad_hi (ushort4 param0, ushort4 param1, ushort4 param2)\n"
"{return (ushort4)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                  mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 mad_hi (ushort8 param0, ushort8 param1, ushort8 param2)\n"
"{return (ushort8)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                  mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                  mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                  mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 mad_hi (ushort16 param0, ushort16 param1, ushort16 param2)\n"
"{return (ushort16)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                   mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                   mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                   mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7),\n"
"                   mad_hi(param0.s8, param1.s8, param2.s8), mad_hi(param0.s9, param1.s9, param2.s9),\n"
"                   mad_hi(param0.sa, param1.sa, param2.sa), mad_hi(param0.sb, param1.sb, param2.sb),\n"
"                   mad_hi(param0.sc, param1.sc, param2.sc), mad_hi(param0.sd, param1.sd, param2.sd),\n"
"                   mad_hi(param0.se, param1.se, param2.se), mad_hi(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 mad_hi (uint2 param0, uint2 param1, uint2 param2)\n"
"{return (uint2)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 mad_hi (uint3 param0, uint3 param1, uint3 param2)\n"
"{return (uint3)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 mad_hi (uint4 param0, uint4 param1, uint4 param2)\n"
"{return (uint4)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 mad_hi (uint8 param0, uint8 param1, uint8 param2)\n"
"{return (uint8)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 mad_hi (uint16 param0, uint16 param1, uint16 param2)\n"
"{return (uint16)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                 mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                 mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7),\n"
"                 mad_hi(param0.s8, param1.s8, param2.s8), mad_hi(param0.s9, param1.s9, param2.s9),\n"
"                 mad_hi(param0.sa, param1.sa, param2.sa), mad_hi(param0.sb, param1.sb, param2.sb),\n"
"                 mad_hi(param0.sc, param1.sc, param2.sc), mad_hi(param0.sd, param1.sd, param2.sd),\n"
"                 mad_hi(param0.se, param1.se, param2.se), mad_hi(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 mad_hi (ulong2 param0, ulong2 param1, ulong2 param2)\n"
"{return (ulong2)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 mad_hi (ulong3 param0, ulong3 param1, ulong3 param2)\n"
"{return (ulong3)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 mad_hi (ulong4 param0, ulong4 param1, ulong4 param2)\n"
"{return (ulong4)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 mad_hi (ulong8 param0, ulong8 param1, ulong8 param2)\n"
"{return (ulong8)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                 mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                 mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                 mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 mad_hi (ulong16 param0, ulong16 param1, ulong16 param2)\n"
"{return (ulong16)(mad_hi(param0.s0, param1.s0, param2.s0), mad_hi(param0.s1, param1.s1, param2.s1),\n"
"                  mad_hi(param0.s2, param1.s2, param2.s2), mad_hi(param0.s3, param1.s3, param2.s3),\n"
"                  mad_hi(param0.s4, param1.s4, param2.s4), mad_hi(param0.s5, param1.s5, param2.s5),\n"
"                  mad_hi(param0.s6, param1.s6, param2.s6), mad_hi(param0.s7, param1.s7, param2.s7),\n"
"                  mad_hi(param0.s8, param1.s8, param2.s8), mad_hi(param0.s9, param1.s9, param2.s9),\n"
"                  mad_hi(param0.sa, param1.sa, param2.sa), mad_hi(param0.sb, param1.sb, param2.sb),\n"
"                  mad_hi(param0.sc, param1.sc, param2.sc), mad_hi(param0.sd, param1.sd, param2.sd),\n"
"                  mad_hi(param0.se, param1.se, param2.se), mad_hi(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentype mad_sat (gentype a, gentype b, gentype c)\n"
"\n"
"INLINE_OVERLOADABLE char2 mad_sat (char2 param0, char2 param1, char2 param2)\n"
"{return (char2)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 mad_sat (char3 param0, char3 param1, char3 param2)\n"
"{return (char3)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 mad_sat (char4 param0, char4 param1, char4 param2)\n"
"{return (char4)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 mad_sat (char8 param0, char8 param1, char8 param2)\n"
"{return (char8)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 mad_sat (char16 param0, char16 param1, char16 param2)\n"
"{return (char16)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                 mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                 mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7),\n"
"                 mad_sat(param0.s8, param1.s8, param2.s8), mad_sat(param0.s9, param1.s9, param2.s9),\n"
"                 mad_sat(param0.sa, param1.sa, param2.sa), mad_sat(param0.sb, param1.sb, param2.sb),\n"
"                 mad_sat(param0.sc, param1.sc, param2.sc), mad_sat(param0.sd, param1.sd, param2.sd),\n"
"                 mad_sat(param0.se, param1.se, param2.se), mad_sat(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 mad_sat (short2 param0, short2 param1, short2 param2)\n"
"{return (short2)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 mad_sat (short3 param0, short3 param1, short3 param2)\n"
"{return (short3)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 mad_sat (short4 param0, short4 param1, short4 param2)\n"
"{return (short4)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 mad_sat (short8 param0, short8 param1, short8 param2)\n"
"{return (short8)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                 mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                 mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 mad_sat (short16 param0, short16 param1, short16 param2)\n"
"{return (short16)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                  mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                  mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                  mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7),\n"
"                  mad_sat(param0.s8, param1.s8, param2.s8), mad_sat(param0.s9, param1.s9, param2.s9),\n"
"                  mad_sat(param0.sa, param1.sa, param2.sa), mad_sat(param0.sb, param1.sb, param2.sb),\n"
"                  mad_sat(param0.sc, param1.sc, param2.sc), mad_sat(param0.sd, param1.sd, param2.sd),\n"
"                  mad_sat(param0.se, param1.se, param2.se), mad_sat(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 mad_sat (int2 param0, int2 param1, int2 param2)\n"
"{return (int2)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 mad_sat (int3 param0, int3 param1, int3 param2)\n"
"{return (int3)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"               mad_sat(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 mad_sat (int4 param0, int4 param1, int4 param2)\n"
"{return (int4)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"               mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 mad_sat (int8 param0, int8 param1, int8 param2)\n"
"{return (int8)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"               mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"               mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"               mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 mad_sat (int16 param0, int16 param1, int16 param2)\n"
"{return (int16)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7),\n"
"                mad_sat(param0.s8, param1.s8, param2.s8), mad_sat(param0.s9, param1.s9, param2.s9),\n"
"                mad_sat(param0.sa, param1.sa, param2.sa), mad_sat(param0.sb, param1.sb, param2.sb),\n"
"                mad_sat(param0.sc, param1.sc, param2.sc), mad_sat(param0.sd, param1.sd, param2.sd),\n"
"                mad_sat(param0.se, param1.se, param2.se), mad_sat(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 mad_sat (long2 param0, long2 param1, long2 param2)\n"
"{return (long2)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 mad_sat (long3 param0, long3 param1, long3 param2)\n"
"{return (long3)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 mad_sat (long4 param0, long4 param1, long4 param2)\n"
"{return (long4)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 mad_sat (long8 param0, long8 param1, long8 param2)\n"
"{return (long8)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 mad_sat (long16 param0, long16 param1, long16 param2)\n"
"{return (long16)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                 mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                 mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7),\n"
"                 mad_sat(param0.s8, param1.s8, param2.s8), mad_sat(param0.s9, param1.s9, param2.s9),\n"
"                 mad_sat(param0.sa, param1.sa, param2.sa), mad_sat(param0.sb, param1.sb, param2.sb),\n"
"                 mad_sat(param0.sc, param1.sc, param2.sc), mad_sat(param0.sd, param1.sd, param2.sd),\n"
"                 mad_sat(param0.se, param1.se, param2.se), mad_sat(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 mad_sat (uchar2 param0, uchar2 param1, uchar2 param2)\n"
"{return (uchar2)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 mad_sat (uchar3 param0, uchar3 param1, uchar3 param2)\n"
"{return (uchar3)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 mad_sat (uchar4 param0, uchar4 param1, uchar4 param2)\n"
"{return (uchar4)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 mad_sat (uchar8 param0, uchar8 param1, uchar8 param2)\n"
"{return (uchar8)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                 mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                 mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 mad_sat (uchar16 param0, uchar16 param1, uchar16 param2)\n"
"{return (uchar16)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                  mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                  mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                  mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7),\n"
"                  mad_sat(param0.s8, param1.s8, param2.s8), mad_sat(param0.s9, param1.s9, param2.s9),\n"
"                  mad_sat(param0.sa, param1.sa, param2.sa), mad_sat(param0.sb, param1.sb, param2.sb),\n"
"                  mad_sat(param0.sc, param1.sc, param2.sc), mad_sat(param0.sd, param1.sd, param2.sd),\n"
"                  mad_sat(param0.se, param1.se, param2.se), mad_sat(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 mad_sat (ushort2 param0, ushort2 param1, ushort2 param2)\n"
"{return (ushort2)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 mad_sat (ushort3 param0, ushort3 param1, ushort3 param2)\n"
"{return (ushort3)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                  mad_sat(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 mad_sat (ushort4 param0, ushort4 param1, ushort4 param2)\n"
"{return (ushort4)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                  mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 mad_sat (ushort8 param0, ushort8 param1, ushort8 param2)\n"
"{return (ushort8)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                  mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                  mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                  mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 mad_sat (ushort16 param0, ushort16 param1, ushort16 param2)\n"
"{return (ushort16)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                   mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                   mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                   mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7),\n"
"                   mad_sat(param0.s8, param1.s8, param2.s8), mad_sat(param0.s9, param1.s9, param2.s9),\n"
"                   mad_sat(param0.sa, param1.sa, param2.sa), mad_sat(param0.sb, param1.sb, param2.sb),\n"
"                   mad_sat(param0.sc, param1.sc, param2.sc), mad_sat(param0.sd, param1.sd, param2.sd),\n"
"                   mad_sat(param0.se, param1.se, param2.se), mad_sat(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 mad_sat (uint2 param0, uint2 param1, uint2 param2)\n"
"{return (uint2)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 mad_sat (uint3 param0, uint3 param1, uint3 param2)\n"
"{return (uint3)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 mad_sat (uint4 param0, uint4 param1, uint4 param2)\n"
"{return (uint4)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 mad_sat (uint8 param0, uint8 param1, uint8 param2)\n"
"{return (uint8)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 mad_sat (uint16 param0, uint16 param1, uint16 param2)\n"
"{return (uint16)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                 mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                 mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7),\n"
"                 mad_sat(param0.s8, param1.s8, param2.s8), mad_sat(param0.s9, param1.s9, param2.s9),\n"
"                 mad_sat(param0.sa, param1.sa, param2.sa), mad_sat(param0.sb, param1.sb, param2.sb),\n"
"                 mad_sat(param0.sc, param1.sc, param2.sc), mad_sat(param0.sd, param1.sd, param2.sd),\n"
"                 mad_sat(param0.se, param1.se, param2.se), mad_sat(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 mad_sat (ulong2 param0, ulong2 param1, ulong2 param2)\n"
"{return (ulong2)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 mad_sat (ulong3 param0, ulong3 param1, ulong3 param2)\n"
"{return (ulong3)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 mad_sat (ulong4 param0, ulong4 param1, ulong4 param2)\n"
"{return (ulong4)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 mad_sat (ulong8 param0, ulong8 param1, ulong8 param2)\n"
"{return (ulong8)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                 mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                 mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                 mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 mad_sat (ulong16 param0, ulong16 param1, ulong16 param2)\n"
"{return (ulong16)(mad_sat(param0.s0, param1.s0, param2.s0), mad_sat(param0.s1, param1.s1, param2.s1),\n"
"                  mad_sat(param0.s2, param1.s2, param2.s2), mad_sat(param0.s3, param1.s3, param2.s3),\n"
"                  mad_sat(param0.s4, param1.s4, param2.s4), mad_sat(param0.s5, param1.s5, param2.s5),\n"
"                  mad_sat(param0.s6, param1.s6, param2.s6), mad_sat(param0.s7, param1.s7, param2.s7),\n"
"                  mad_sat(param0.s8, param1.s8, param2.s8), mad_sat(param0.s9, param1.s9, param2.s9),\n"
"                  mad_sat(param0.sa, param1.sa, param2.sa), mad_sat(param0.sb, param1.sb, param2.sb),\n"
"                  mad_sat(param0.sc, param1.sc, param2.sc), mad_sat(param0.sd, param1.sd, param2.sd),\n"
"                  mad_sat(param0.se, param1.se, param2.se), mad_sat(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentype max (gentype x,  gentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 max (char2 param0, char2 param1)\n"
"{return (char2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 max (char3 param0, char3 param1)\n"
"{return (char3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 max (char4 param0, char4 param1)\n"
"{return (char4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 max (char8 param0, char8 param1)\n"
"{return (char8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 max (char16 param0, char16 param1)\n"
"{return (char16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                 max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                 max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                 max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                 max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                 max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                 max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 max (short2 param0, short2 param1)\n"
"{return (short2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 max (short3 param0, short3 param1)\n"
"{return (short3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 max (short4 param0, short4 param1)\n"
"{return (short4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 max (short8 param0, short8 param1)\n"
"{return (short8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                 max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                 max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 max (short16 param0, short16 param1)\n"
"{return (short16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                  max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                  max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                  max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                  max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                  max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                  max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                  max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 max (int2 param0, int2 param1)\n"
"{return (int2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 max (int3 param0, int3 param1)\n"
"{return (int3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"               max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 max (int4 param0, int4 param1)\n"
"{return (int4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"               max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 max (int8 param0, int8 param1)\n"
"{return (int8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"               max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"               max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"               max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 max (int16 param0, int16 param1)\n"
"{return (int16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 max (long2 param0, long2 param1)\n"
"{return (long2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 max (long3 param0, long3 param1)\n"
"{return (long3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 max (long4 param0, long4 param1)\n"
"{return (long4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 max (long8 param0, long8 param1)\n"
"{return (long8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 max (long16 param0, long16 param1)\n"
"{return (long16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                 max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                 max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                 max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                 max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                 max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                 max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 max (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 max (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 max (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 max (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                 max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                 max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 max (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                  max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                  max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                  max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                  max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                  max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                  max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                  max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 max (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 max (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                  max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 max (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                  max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 max (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                  max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                  max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                  max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 max (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                   max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                   max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                   max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                   max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                   max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                   max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                   max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 max (uint2 param0, uint2 param1)\n"
"{return (uint2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 max (uint3 param0, uint3 param1)\n"
"{return (uint3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 max (uint4 param0, uint4 param1)\n"
"{return (uint4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 max (uint8 param0, uint8 param1)\n"
"{return (uint8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 max (uint16 param0, uint16 param1)\n"
"{return (uint16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                 max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                 max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                 max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                 max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                 max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                 max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 max (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 max (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 max (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 max (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                 max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                 max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 max (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                  max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                  max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                  max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                  max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                  max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                  max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                  max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype max (gentype x,  sgentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 max (char2 param0, char param1)\n"
"{return (char2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 max (char3 param0, char param1)\n"
"{return (char3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 max (char4 param0, char param1)\n"
"{return (char4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 max (char8 param0, char param1)\n"
"{return (char8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1), max(param0.s3, param1),\n"
"                max(param0.s4, param1), max(param0.s5, param1),\n"
"                max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 max (char16 param0, char param1)\n"
"{return (char16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1),\n"
"                 max(param0.s4, param1), max(param0.s5, param1),\n"
"                 max(param0.s6, param1), max(param0.s7, param1),\n"
"                 max(param0.s8, param1), max(param0.s9, param1),\n"
"                 max(param0.sa, param1), max(param0.sb, param1),\n"
"                 max(param0.sc, param1), max(param0.sd, param1),\n"
"                 max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 max (short2 param0, short param1)\n"
"{return (short2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 max (short3 param0, short param1)\n"
"{return (short3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 max (short4 param0, short param1)\n"
"{return (short4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 max (short8 param0, short param1)\n"
"{return (short8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1),\n"
"                 max(param0.s4, param1), max(param0.s5, param1),\n"
"                 max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 max (short16 param0, short param1)\n"
"{return (short16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                  max(param0.s2, param1), max(param0.s3, param1),\n"
"                  max(param0.s4, param1), max(param0.s5, param1),\n"
"                  max(param0.s6, param1), max(param0.s7, param1),\n"
"                  max(param0.s8, param1), max(param0.s9, param1),\n"
"                  max(param0.sa, param1), max(param0.sb, param1),\n"
"                  max(param0.sc, param1), max(param0.sd, param1),\n"
"                  max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 max (int2 param0, int param1)\n"
"{return (int2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 max (int3 param0, int param1)\n"
"{return (int3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"               max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 max (int4 param0, int param1)\n"
"{return (int4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"               max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 max (int8 param0, int param1)\n"
"{return (int8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"               max(param0.s2, param1), max(param0.s3, param1),\n"
"               max(param0.s4, param1), max(param0.s5, param1),\n"
"               max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 max (int16 param0, int param1)\n"
"{return (int16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1), max(param0.s3, param1),\n"
"                max(param0.s4, param1), max(param0.s5, param1),\n"
"                max(param0.s6, param1), max(param0.s7, param1),\n"
"                max(param0.s8, param1), max(param0.s9, param1),\n"
"                max(param0.sa, param1), max(param0.sb, param1),\n"
"                max(param0.sc, param1), max(param0.sd, param1),\n"
"                max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 max (long2 param0, long param1)\n"
"{return (long2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 max (long3 param0, long param1)\n"
"{return (long3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 max (long4 param0, long param1)\n"
"{return (long4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 max (long8 param0, long param1)\n"
"{return (long8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1), max(param0.s3, param1),\n"
"                max(param0.s4, param1), max(param0.s5, param1),\n"
"                max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 max (long16 param0, long param1)\n"
"{return (long16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1),\n"
"                 max(param0.s4, param1), max(param0.s5, param1),\n"
"                 max(param0.s6, param1), max(param0.s7, param1),\n"
"                 max(param0.s8, param1), max(param0.s9, param1),\n"
"                 max(param0.sa, param1), max(param0.sb, param1),\n"
"                 max(param0.sc, param1), max(param0.sd, param1),\n"
"                 max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 max (uchar2 param0, uchar param1)\n"
"{return (uchar2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 max (uchar3 param0, uchar param1)\n"
"{return (uchar3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 max (uchar4 param0, uchar param1)\n"
"{return (uchar4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 max (uchar8 param0, uchar param1)\n"
"{return (uchar8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1),\n"
"                 max(param0.s4, param1), max(param0.s5, param1),\n"
"                 max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 max (uchar16 param0, uchar param1)\n"
"{return (uchar16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                  max(param0.s2, param1), max(param0.s3, param1),\n"
"                  max(param0.s4, param1), max(param0.s5, param1),\n"
"                  max(param0.s6, param1), max(param0.s7, param1),\n"
"                  max(param0.s8, param1), max(param0.s9, param1),\n"
"                  max(param0.sa, param1), max(param0.sb, param1),\n"
"                  max(param0.sc, param1), max(param0.sd, param1),\n"
"                  max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 max (ushort2 param0, ushort param1)\n"
"{return (ushort2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 max (ushort3 param0, ushort param1)\n"
"{return (ushort3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                  max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 max (ushort4 param0, ushort param1)\n"
"{return (ushort4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                  max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 max (ushort8 param0, ushort param1)\n"
"{return (ushort8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                  max(param0.s2, param1), max(param0.s3, param1),\n"
"                  max(param0.s4, param1), max(param0.s5, param1),\n"
"                  max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 max (ushort16 param0, ushort param1)\n"
"{return (ushort16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                   max(param0.s2, param1), max(param0.s3, param1),\n"
"                   max(param0.s4, param1), max(param0.s5, param1),\n"
"                   max(param0.s6, param1), max(param0.s7, param1),\n"
"                   max(param0.s8, param1), max(param0.s9, param1),\n"
"                   max(param0.sa, param1), max(param0.sb, param1),\n"
"                   max(param0.sc, param1), max(param0.sd, param1),\n"
"                   max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 max (uint2 param0, uint param1)\n"
"{return (uint2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 max (uint3 param0, uint param1)\n"
"{return (uint3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 max (uint4 param0, uint param1)\n"
"{return (uint4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 max (uint8 param0, uint param1)\n"
"{return (uint8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                max(param0.s2, param1), max(param0.s3, param1),\n"
"                max(param0.s4, param1), max(param0.s5, param1),\n"
"                max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 max (uint16 param0, uint param1)\n"
"{return (uint16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1),\n"
"                 max(param0.s4, param1), max(param0.s5, param1),\n"
"                 max(param0.s6, param1), max(param0.s7, param1),\n"
"                 max(param0.s8, param1), max(param0.s9, param1),\n"
"                 max(param0.sa, param1), max(param0.sb, param1),\n"
"                 max(param0.sc, param1), max(param0.sd, param1),\n"
"                 max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 max (ulong2 param0, ulong param1)\n"
"{return (ulong2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 max (ulong3 param0, ulong param1)\n"
"{return (ulong3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 max (ulong4 param0, ulong param1)\n"
"{return (ulong4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 max (ulong8 param0, ulong param1)\n"
"{return (ulong8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1),\n"
"                 max(param0.s4, param1), max(param0.s5, param1),\n"
"                 max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 max (ulong16 param0, ulong param1)\n"
"{return (ulong16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                  max(param0.s2, param1), max(param0.s3, param1),\n"
"                  max(param0.s4, param1), max(param0.s5, param1),\n"
"                  max(param0.s6, param1), max(param0.s7, param1),\n"
"                  max(param0.s8, param1), max(param0.s9, param1),\n"
"                  max(param0.sa, param1), max(param0.sb, param1),\n"
"                  max(param0.sc, param1), max(param0.sd, param1),\n"
"                  max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"\n"
"//gentype min (gentype x,  gentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 min (char2 param0, char2 param1)\n"
"{return (char2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 min (char3 param0, char3 param1)\n"
"{return (char3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 min (char4 param0, char4 param1)\n"
"{return (char4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 min (char8 param0, char8 param1)\n"
"{return (char8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 min (char16 param0, char16 param1)\n"
"{return (char16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                 min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                 min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                 min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                 min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                 min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                 min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 min (short2 param0, short2 param1)\n"
"{return (short2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 min (short3 param0, short3 param1)\n"
"{return (short3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 min (short4 param0, short4 param1)\n"
"{return (short4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 min (short8 param0, short8 param1)\n"
"{return (short8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                 min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                 min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 min (short16 param0, short16 param1)\n"
"{return (short16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                  min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                  min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                  min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                  min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                  min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                  min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                  min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 min (int2 param0, int2 param1)\n"
"{return (int2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 min (int3 param0, int3 param1)\n"
"{return (int3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"               min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 min (int4 param0, int4 param1)\n"
"{return (int4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"               min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 min (int8 param0, int8 param1)\n"
"{return (int8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"               min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"               min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"               min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 min (int16 param0, int16 param1)\n"
"{return (int16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 min (long2 param0, long2 param1)\n"
"{return (long2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 min (long3 param0, long3 param1)\n"
"{return (long3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 min (long4 param0, long4 param1)\n"
"{return (long4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 min (long8 param0, long8 param1)\n"
"{return (long8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 min (long16 param0, long16 param1)\n"
"{return (long16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                 min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                 min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                 min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                 min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                 min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                 min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 min (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 min (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 min (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 min (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                 min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                 min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 min (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                  min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                  min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                  min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                  min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                  min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                  min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                  min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 min (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 min (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                  min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 min (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                  min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 min (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                  min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                  min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                  min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 min (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                   min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                   min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                   min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                   min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                   min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                   min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                   min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 min (uint2 param0, uint2 param1)\n"
"{return (uint2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 min (uint3 param0, uint3 param1)\n"
"{return (uint3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 min (uint4 param0, uint4 param1)\n"
"{return (uint4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 min (uint8 param0, uint8 param1)\n"
"{return (uint8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 min (uint16 param0, uint16 param1)\n"
"{return (uint16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                 min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                 min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                 min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                 min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                 min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                 min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 min (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 min (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 min (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 min (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                 min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                 min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 min (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                  min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                  min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                  min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                  min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                  min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                  min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                  min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype min (gentype x,  sgentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 min (char2 param0, char param1)\n"
"{return (char2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 min (char3 param0, char param1)\n"
"{return (char3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 min (char4 param0, char param1)\n"
"{return (char4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 min (char8 param0, char param1)\n"
"{return (char8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1), min(param0.s3, param1),\n"
"                min(param0.s4, param1), min(param0.s5, param1),\n"
"                min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 min (char16 param0, char param1)\n"
"{return (char16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1),\n"
"                 min(param0.s4, param1), min(param0.s5, param1),\n"
"                 min(param0.s6, param1), min(param0.s7, param1),\n"
"                 min(param0.s8, param1), min(param0.s9, param1),\n"
"                 min(param0.sa, param1), min(param0.sb, param1),\n"
"                 min(param0.sc, param1), min(param0.sd, param1),\n"
"                 min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 min (short2 param0, short param1)\n"
"{return (short2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 min (short3 param0, short param1)\n"
"{return (short3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 min (short4 param0, short param1)\n"
"{return (short4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 min (short8 param0, short param1)\n"
"{return (short8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1),\n"
"                 min(param0.s4, param1), min(param0.s5, param1),\n"
"                 min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 min (short16 param0, short param1)\n"
"{return (short16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                  min(param0.s2, param1), min(param0.s3, param1),\n"
"                  min(param0.s4, param1), min(param0.s5, param1),\n"
"                  min(param0.s6, param1), min(param0.s7, param1),\n"
"                  min(param0.s8, param1), min(param0.s9, param1),\n"
"                  min(param0.sa, param1), min(param0.sb, param1),\n"
"                  min(param0.sc, param1), min(param0.sd, param1),\n"
"                  min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 min (int2 param0, int param1)\n"
"{return (int2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 min (int3 param0, int param1)\n"
"{return (int3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"               min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 min (int4 param0, int param1)\n"
"{return (int4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"               min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 min (int8 param0, int param1)\n"
"{return (int8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"               min(param0.s2, param1), min(param0.s3, param1),\n"
"               min(param0.s4, param1), min(param0.s5, param1),\n"
"               min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 min (int16 param0, int param1)\n"
"{return (int16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1), min(param0.s3, param1),\n"
"                min(param0.s4, param1), min(param0.s5, param1),\n"
"                min(param0.s6, param1), min(param0.s7, param1),\n"
"                min(param0.s8, param1), min(param0.s9, param1),\n"
"                min(param0.sa, param1), min(param0.sb, param1),\n"
"                min(param0.sc, param1), min(param0.sd, param1),\n"
"                min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 min (long2 param0, long param1)\n"
"{return (long2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 min (long3 param0, long param1)\n"
"{return (long3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 min (long4 param0, long param1)\n"
"{return (long4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 min (long8 param0, long param1)\n"
"{return (long8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1), min(param0.s3, param1),\n"
"                min(param0.s4, param1), min(param0.s5, param1),\n"
"                min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 min (long16 param0, long param1)\n"
"{return (long16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1),\n"
"                 min(param0.s4, param1), min(param0.s5, param1),\n"
"                 min(param0.s6, param1), min(param0.s7, param1),\n"
"                 min(param0.s8, param1), min(param0.s9, param1),\n"
"                 min(param0.sa, param1), min(param0.sb, param1),\n"
"                 min(param0.sc, param1), min(param0.sd, param1),\n"
"                 min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 min (uchar2 param0, uchar param1)\n"
"{return (uchar2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 min (uchar3 param0, uchar param1)\n"
"{return (uchar3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 min (uchar4 param0, uchar param1)\n"
"{return (uchar4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 min (uchar8 param0, uchar param1)\n"
"{return (uchar8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1),\n"
"                 min(param0.s4, param1), min(param0.s5, param1),\n"
"                 min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 min (uchar16 param0, uchar param1)\n"
"{return (uchar16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                  min(param0.s2, param1), min(param0.s3, param1),\n"
"                  min(param0.s4, param1), min(param0.s5, param1),\n"
"                  min(param0.s6, param1), min(param0.s7, param1),\n"
"                  min(param0.s8, param1), min(param0.s9, param1),\n"
"                  min(param0.sa, param1), min(param0.sb, param1),\n"
"                  min(param0.sc, param1), min(param0.sd, param1),\n"
"                  min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 min (ushort2 param0, ushort param1)\n"
"{return (ushort2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 min (ushort3 param0, ushort param1)\n"
"{return (ushort3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                  min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 min (ushort4 param0, ushort param1)\n"
"{return (ushort4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                  min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 min (ushort8 param0, ushort param1)\n"
"{return (ushort8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                  min(param0.s2, param1), min(param0.s3, param1),\n"
"                  min(param0.s4, param1), min(param0.s5, param1),\n"
"                  min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 min (ushort16 param0, ushort param1)\n"
"{return (ushort16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                   min(param0.s2, param1), min(param0.s3, param1),\n"
"                   min(param0.s4, param1), min(param0.s5, param1),\n"
"                   min(param0.s6, param1), min(param0.s7, param1),\n"
"                   min(param0.s8, param1), min(param0.s9, param1),\n"
"                   min(param0.sa, param1), min(param0.sb, param1),\n"
"                   min(param0.sc, param1), min(param0.sd, param1),\n"
"                   min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 min (uint2 param0, uint param1)\n"
"{return (uint2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 min (uint3 param0, uint param1)\n"
"{return (uint3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 min (uint4 param0, uint param1)\n"
"{return (uint4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 min (uint8 param0, uint param1)\n"
"{return (uint8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                min(param0.s2, param1), min(param0.s3, param1),\n"
"                min(param0.s4, param1), min(param0.s5, param1),\n"
"                min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 min (uint16 param0, uint param1)\n"
"{return (uint16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1),\n"
"                 min(param0.s4, param1), min(param0.s5, param1),\n"
"                 min(param0.s6, param1), min(param0.s7, param1),\n"
"                 min(param0.s8, param1), min(param0.s9, param1),\n"
"                 min(param0.sa, param1), min(param0.sb, param1),\n"
"                 min(param0.sc, param1), min(param0.sd, param1),\n"
"                 min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 min (ulong2 param0, ulong param1)\n"
"{return (ulong2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 min (ulong3 param0, ulong param1)\n"
"{return (ulong3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 min (ulong4 param0, ulong param1)\n"
"{return (ulong4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 min (ulong8 param0, ulong param1)\n"
"{return (ulong8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1),\n"
"                 min(param0.s4, param1), min(param0.s5, param1),\n"
"                 min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 min (ulong16 param0, ulong param1)\n"
"{return (ulong16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                  min(param0.s2, param1), min(param0.s3, param1),\n"
"                  min(param0.s4, param1), min(param0.s5, param1),\n"
"                  min(param0.s6, param1), min(param0.s7, param1),\n"
"                  min(param0.s8, param1), min(param0.s9, param1),\n"
"                  min(param0.sa, param1), min(param0.sb, param1),\n"
"                  min(param0.sc, param1), min(param0.sd, param1),\n"
"                  min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"\n"
"//gentype mul_hi (gentype x,  gentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 mul_hi (char2 param0, char2 param1)\n"
"{return (char2)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 mul_hi (char3 param0, char3 param1)\n"
"{return (char3)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 mul_hi (char4 param0, char4 param1)\n"
"{return (char4)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 mul_hi (char8 param0, char8 param1)\n"
"{return (char8)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 mul_hi (char16 param0, char16 param1)\n"
"{return (char16)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                 mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                 mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7),\n"
"                 mul_hi(param0.s8, param1.s8), mul_hi(param0.s9, param1.s9),\n"
"                 mul_hi(param0.sa, param1.sa), mul_hi(param0.sb, param1.sb),\n"
"                 mul_hi(param0.sc, param1.sc), mul_hi(param0.sd, param1.sd),\n"
"                 mul_hi(param0.se, param1.se), mul_hi(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 mul_hi (short2 param0, short2 param1)\n"
"{return (short2)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 mul_hi (short3 param0, short3 param1)\n"
"{return (short3)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 mul_hi (short4 param0, short4 param1)\n"
"{return (short4)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 mul_hi (short8 param0, short8 param1)\n"
"{return (short8)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                 mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                 mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 mul_hi (short16 param0, short16 param1)\n"
"{return (short16)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                  mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                  mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                  mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7),\n"
"                  mul_hi(param0.s8, param1.s8), mul_hi(param0.s9, param1.s9),\n"
"                  mul_hi(param0.sa, param1.sa), mul_hi(param0.sb, param1.sb),\n"
"                  mul_hi(param0.sc, param1.sc), mul_hi(param0.sd, param1.sd),\n"
"                  mul_hi(param0.se, param1.se), mul_hi(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 mul_hi (int2 param0, int2 param1)\n"
"{return (int2)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 mul_hi (int3 param0, int3 param1)\n"
"{return (int3)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"               mul_hi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 mul_hi (int4 param0, int4 param1)\n"
"{return (int4)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"               mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 mul_hi (int8 param0, int8 param1)\n"
"{return (int8)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"               mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"               mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"               mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 mul_hi (int16 param0, int16 param1)\n"
"{return (int16)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7),\n"
"                mul_hi(param0.s8, param1.s8), mul_hi(param0.s9, param1.s9),\n"
"                mul_hi(param0.sa, param1.sa), mul_hi(param0.sb, param1.sb),\n"
"                mul_hi(param0.sc, param1.sc), mul_hi(param0.sd, param1.sd),\n"
"                mul_hi(param0.se, param1.se), mul_hi(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 mul_hi (long2 param0, long2 param1)\n"
"{return (long2)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 mul_hi (long3 param0, long3 param1)\n"
"{return (long3)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 mul_hi (long4 param0, long4 param1)\n"
"{return (long4)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 mul_hi (long8 param0, long8 param1)\n"
"{return (long8)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 mul_hi (long16 param0, long16 param1)\n"
"{return (long16)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                 mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                 mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7),\n"
"                 mul_hi(param0.s8, param1.s8), mul_hi(param0.s9, param1.s9),\n"
"                 mul_hi(param0.sa, param1.sa), mul_hi(param0.sb, param1.sb),\n"
"                 mul_hi(param0.sc, param1.sc), mul_hi(param0.sd, param1.sd),\n"
"                 mul_hi(param0.se, param1.se), mul_hi(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 mul_hi (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 mul_hi (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 mul_hi (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 mul_hi (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                 mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                 mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 mul_hi (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                  mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                  mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                  mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7),\n"
"                  mul_hi(param0.s8, param1.s8), mul_hi(param0.s9, param1.s9),\n"
"                  mul_hi(param0.sa, param1.sa), mul_hi(param0.sb, param1.sb),\n"
"                  mul_hi(param0.sc, param1.sc), mul_hi(param0.sd, param1.sd),\n"
"                  mul_hi(param0.se, param1.se), mul_hi(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 mul_hi (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 mul_hi (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                  mul_hi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 mul_hi (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                  mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 mul_hi (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                  mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                  mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                  mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 mul_hi (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                   mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                   mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                   mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7),\n"
"                   mul_hi(param0.s8, param1.s8), mul_hi(param0.s9, param1.s9),\n"
"                   mul_hi(param0.sa, param1.sa), mul_hi(param0.sb, param1.sb),\n"
"                   mul_hi(param0.sc, param1.sc), mul_hi(param0.sd, param1.sd),\n"
"                   mul_hi(param0.se, param1.se), mul_hi(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 mul_hi (uint2 param0, uint2 param1)\n"
"{return (uint2)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 mul_hi (uint3 param0, uint3 param1)\n"
"{return (uint3)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 mul_hi (uint4 param0, uint4 param1)\n"
"{return (uint4)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 mul_hi (uint8 param0, uint8 param1)\n"
"{return (uint8)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 mul_hi (uint16 param0, uint16 param1)\n"
"{return (uint16)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                 mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                 mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7),\n"
"                 mul_hi(param0.s8, param1.s8), mul_hi(param0.s9, param1.s9),\n"
"                 mul_hi(param0.sa, param1.sa), mul_hi(param0.sb, param1.sb),\n"
"                 mul_hi(param0.sc, param1.sc), mul_hi(param0.sd, param1.sd),\n"
"                 mul_hi(param0.se, param1.se), mul_hi(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 mul_hi (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 mul_hi (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 mul_hi (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 mul_hi (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                 mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                 mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                 mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 mul_hi (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(mul_hi(param0.s0, param1.s0), mul_hi(param0.s1, param1.s1),\n"
"                  mul_hi(param0.s2, param1.s2), mul_hi(param0.s3, param1.s3),\n"
"                  mul_hi(param0.s4, param1.s4), mul_hi(param0.s5, param1.s5),\n"
"                  mul_hi(param0.s6, param1.s6), mul_hi(param0.s7, param1.s7),\n"
"                  mul_hi(param0.s8, param1.s8), mul_hi(param0.s9, param1.s9),\n"
"                  mul_hi(param0.sa, param1.sa), mul_hi(param0.sb, param1.sb),\n"
"                  mul_hi(param0.sc, param1.sc), mul_hi(param0.sd, param1.sd),\n"
"                  mul_hi(param0.se, param1.se), mul_hi(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype rotate (gentype v,  gentype i)\n"
"\n"
"INLINE_OVERLOADABLE char2 rotate (char2 param0, char2 param1)\n"
"{return (char2)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 rotate (char3 param0, char3 param1)\n"
"{return (char3)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 rotate (char4 param0, char4 param1)\n"
"{return (char4)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 rotate (char8 param0, char8 param1)\n"
"{return (char8)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 rotate (char16 param0, char16 param1)\n"
"{return (char16)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                 rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                 rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7),\n"
"                 rotate(param0.s8, param1.s8), rotate(param0.s9, param1.s9),\n"
"                 rotate(param0.sa, param1.sa), rotate(param0.sb, param1.sb),\n"
"                 rotate(param0.sc, param1.sc), rotate(param0.sd, param1.sd),\n"
"                 rotate(param0.se, param1.se), rotate(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 rotate (short2 param0, short2 param1)\n"
"{return (short2)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 rotate (short3 param0, short3 param1)\n"
"{return (short3)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 rotate (short4 param0, short4 param1)\n"
"{return (short4)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 rotate (short8 param0, short8 param1)\n"
"{return (short8)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                 rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                 rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 rotate (short16 param0, short16 param1)\n"
"{return (short16)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                  rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                  rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                  rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7),\n"
"                  rotate(param0.s8, param1.s8), rotate(param0.s9, param1.s9),\n"
"                  rotate(param0.sa, param1.sa), rotate(param0.sb, param1.sb),\n"
"                  rotate(param0.sc, param1.sc), rotate(param0.sd, param1.sd),\n"
"                  rotate(param0.se, param1.se), rotate(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 rotate (int2 param0, int2 param1)\n"
"{return (int2)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 rotate (int3 param0, int3 param1)\n"
"{return (int3)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"               rotate(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 rotate (int4 param0, int4 param1)\n"
"{return (int4)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"               rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 rotate (int8 param0, int8 param1)\n"
"{return (int8)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"               rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"               rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"               rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 rotate (int16 param0, int16 param1)\n"
"{return (int16)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7),\n"
"                rotate(param0.s8, param1.s8), rotate(param0.s9, param1.s9),\n"
"                rotate(param0.sa, param1.sa), rotate(param0.sb, param1.sb),\n"
"                rotate(param0.sc, param1.sc), rotate(param0.sd, param1.sd),\n"
"                rotate(param0.se, param1.se), rotate(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 rotate (long2 param0, long2 param1)\n"
"{return (long2)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 rotate (long3 param0, long3 param1)\n"
"{return (long3)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 rotate (long4 param0, long4 param1)\n"
"{return (long4)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 rotate (long8 param0, long8 param1)\n"
"{return (long8)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 rotate (long16 param0, long16 param1)\n"
"{return (long16)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                 rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                 rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7),\n"
"                 rotate(param0.s8, param1.s8), rotate(param0.s9, param1.s9),\n"
"                 rotate(param0.sa, param1.sa), rotate(param0.sb, param1.sb),\n"
"                 rotate(param0.sc, param1.sc), rotate(param0.sd, param1.sd),\n"
"                 rotate(param0.se, param1.se), rotate(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 rotate (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 rotate (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 rotate (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 rotate (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                 rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                 rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 rotate (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                  rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                  rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                  rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7),\n"
"                  rotate(param0.s8, param1.s8), rotate(param0.s9, param1.s9),\n"
"                  rotate(param0.sa, param1.sa), rotate(param0.sb, param1.sb),\n"
"                  rotate(param0.sc, param1.sc), rotate(param0.sd, param1.sd),\n"
"                  rotate(param0.se, param1.se), rotate(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 rotate (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 rotate (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                  rotate(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 rotate (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                  rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 rotate (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                  rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                  rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                  rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 rotate (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                   rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                   rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                   rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7),\n"
"                   rotate(param0.s8, param1.s8), rotate(param0.s9, param1.s9),\n"
"                   rotate(param0.sa, param1.sa), rotate(param0.sb, param1.sb),\n"
"                   rotate(param0.sc, param1.sc), rotate(param0.sd, param1.sd),\n"
"                   rotate(param0.se, param1.se), rotate(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 rotate (uint2 param0, uint2 param1)\n"
"{return (uint2)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 rotate (uint3 param0, uint3 param1)\n"
"{return (uint3)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 rotate (uint4 param0, uint4 param1)\n"
"{return (uint4)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 rotate (uint8 param0, uint8 param1)\n"
"{return (uint8)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 rotate (uint16 param0, uint16 param1)\n"
"{return (uint16)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                 rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                 rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7),\n"
"                 rotate(param0.s8, param1.s8), rotate(param0.s9, param1.s9),\n"
"                 rotate(param0.sa, param1.sa), rotate(param0.sb, param1.sb),\n"
"                 rotate(param0.sc, param1.sc), rotate(param0.sd, param1.sd),\n"
"                 rotate(param0.se, param1.se), rotate(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 rotate (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 rotate (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 rotate (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 rotate (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                 rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                 rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                 rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 rotate (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(rotate(param0.s0, param1.s0), rotate(param0.s1, param1.s1),\n"
"                  rotate(param0.s2, param1.s2), rotate(param0.s3, param1.s3),\n"
"                  rotate(param0.s4, param1.s4), rotate(param0.s5, param1.s5),\n"
"                  rotate(param0.s6, param1.s6), rotate(param0.s7, param1.s7),\n"
"                  rotate(param0.s8, param1.s8), rotate(param0.s9, param1.s9),\n"
"                  rotate(param0.sa, param1.sa), rotate(param0.sb, param1.sb),\n"
"                  rotate(param0.sc, param1.sc), rotate(param0.sd, param1.sd),\n"
"                  rotate(param0.se, param1.se), rotate(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentype sub_sat (gentype x,  gentype y)\n"
"\n"
"INLINE_OVERLOADABLE char2 sub_sat (char2 param0, char2 param1)\n"
"{return (char2)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 sub_sat (char3 param0, char3 param1)\n"
"{return (char3)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 sub_sat (char4 param0, char4 param1)\n"
"{return (char4)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 sub_sat (char8 param0, char8 param1)\n"
"{return (char8)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 sub_sat (char16 param0, char16 param1)\n"
"{return (char16)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                 sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                 sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7),\n"
"                 sub_sat(param0.s8, param1.s8), sub_sat(param0.s9, param1.s9),\n"
"                 sub_sat(param0.sa, param1.sa), sub_sat(param0.sb, param1.sb),\n"
"                 sub_sat(param0.sc, param1.sc), sub_sat(param0.sd, param1.sd),\n"
"                 sub_sat(param0.se, param1.se), sub_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 sub_sat (short2 param0, short2 param1)\n"
"{return (short2)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 sub_sat (short3 param0, short3 param1)\n"
"{return (short3)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 sub_sat (short4 param0, short4 param1)\n"
"{return (short4)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 sub_sat (short8 param0, short8 param1)\n"
"{return (short8)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                 sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                 sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 sub_sat (short16 param0, short16 param1)\n"
"{return (short16)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                  sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                  sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                  sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7),\n"
"                  sub_sat(param0.s8, param1.s8), sub_sat(param0.s9, param1.s9),\n"
"                  sub_sat(param0.sa, param1.sa), sub_sat(param0.sb, param1.sb),\n"
"                  sub_sat(param0.sc, param1.sc), sub_sat(param0.sd, param1.sd),\n"
"                  sub_sat(param0.se, param1.se), sub_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 sub_sat (int2 param0, int2 param1)\n"
"{return (int2)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 sub_sat (int3 param0, int3 param1)\n"
"{return (int3)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"               sub_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 sub_sat (int4 param0, int4 param1)\n"
"{return (int4)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"               sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 sub_sat (int8 param0, int8 param1)\n"
"{return (int8)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"               sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"               sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"               sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 sub_sat (int16 param0, int16 param1)\n"
"{return (int16)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7),\n"
"                sub_sat(param0.s8, param1.s8), sub_sat(param0.s9, param1.s9),\n"
"                sub_sat(param0.sa, param1.sa), sub_sat(param0.sb, param1.sb),\n"
"                sub_sat(param0.sc, param1.sc), sub_sat(param0.sd, param1.sd),\n"
"                sub_sat(param0.se, param1.se), sub_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 sub_sat (long2 param0, long2 param1)\n"
"{return (long2)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 sub_sat (long3 param0, long3 param1)\n"
"{return (long3)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 sub_sat (long4 param0, long4 param1)\n"
"{return (long4)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 sub_sat (long8 param0, long8 param1)\n"
"{return (long8)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 sub_sat (long16 param0, long16 param1)\n"
"{return (long16)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                 sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                 sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7),\n"
"                 sub_sat(param0.s8, param1.s8), sub_sat(param0.s9, param1.s9),\n"
"                 sub_sat(param0.sa, param1.sa), sub_sat(param0.sb, param1.sb),\n"
"                 sub_sat(param0.sc, param1.sc), sub_sat(param0.sd, param1.sd),\n"
"                 sub_sat(param0.se, param1.se), sub_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 sub_sat (uchar2 param0, uchar2 param1)\n"
"{return (uchar2)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 sub_sat (uchar3 param0, uchar3 param1)\n"
"{return (uchar3)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 sub_sat (uchar4 param0, uchar4 param1)\n"
"{return (uchar4)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 sub_sat (uchar8 param0, uchar8 param1)\n"
"{return (uchar8)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                 sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                 sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 sub_sat (uchar16 param0, uchar16 param1)\n"
"{return (uchar16)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                  sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                  sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                  sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7),\n"
"                  sub_sat(param0.s8, param1.s8), sub_sat(param0.s9, param1.s9),\n"
"                  sub_sat(param0.sa, param1.sa), sub_sat(param0.sb, param1.sb),\n"
"                  sub_sat(param0.sc, param1.sc), sub_sat(param0.sd, param1.sd),\n"
"                  sub_sat(param0.se, param1.se), sub_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 sub_sat (ushort2 param0, ushort2 param1)\n"
"{return (ushort2)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 sub_sat (ushort3 param0, ushort3 param1)\n"
"{return (ushort3)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                  sub_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 sub_sat (ushort4 param0, ushort4 param1)\n"
"{return (ushort4)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                  sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 sub_sat (ushort8 param0, ushort8 param1)\n"
"{return (ushort8)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                  sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                  sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                  sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 sub_sat (ushort16 param0, ushort16 param1)\n"
"{return (ushort16)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                   sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                   sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                   sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7),\n"
"                   sub_sat(param0.s8, param1.s8), sub_sat(param0.s9, param1.s9),\n"
"                   sub_sat(param0.sa, param1.sa), sub_sat(param0.sb, param1.sb),\n"
"                   sub_sat(param0.sc, param1.sc), sub_sat(param0.sd, param1.sd),\n"
"                   sub_sat(param0.se, param1.se), sub_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 sub_sat (uint2 param0, uint2 param1)\n"
"{return (uint2)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 sub_sat (uint3 param0, uint3 param1)\n"
"{return (uint3)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 sub_sat (uint4 param0, uint4 param1)\n"
"{return (uint4)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 sub_sat (uint8 param0, uint8 param1)\n"
"{return (uint8)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 sub_sat (uint16 param0, uint16 param1)\n"
"{return (uint16)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                 sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                 sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7),\n"
"                 sub_sat(param0.s8, param1.s8), sub_sat(param0.s9, param1.s9),\n"
"                 sub_sat(param0.sa, param1.sa), sub_sat(param0.sb, param1.sb),\n"
"                 sub_sat(param0.sc, param1.sc), sub_sat(param0.sd, param1.sd),\n"
"                 sub_sat(param0.se, param1.se), sub_sat(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 sub_sat (ulong2 param0, ulong2 param1)\n"
"{return (ulong2)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 sub_sat (ulong3 param0, ulong3 param1)\n"
"{return (ulong3)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 sub_sat (ulong4 param0, ulong4 param1)\n"
"{return (ulong4)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 sub_sat (ulong8 param0, ulong8 param1)\n"
"{return (ulong8)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                 sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                 sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                 sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 sub_sat (ulong16 param0, ulong16 param1)\n"
"{return (ulong16)(sub_sat(param0.s0, param1.s0), sub_sat(param0.s1, param1.s1),\n"
"                  sub_sat(param0.s2, param1.s2), sub_sat(param0.s3, param1.s3),\n"
"                  sub_sat(param0.s4, param1.s4), sub_sat(param0.s5, param1.s5),\n"
"                  sub_sat(param0.s6, param1.s6), sub_sat(param0.s7, param1.s7),\n"
"                  sub_sat(param0.s8, param1.s8), sub_sat(param0.s9, param1.s9),\n"
"                  sub_sat(param0.sa, param1.sa), sub_sat(param0.sb, param1.sb),\n"
"                  sub_sat(param0.sc, param1.sc), sub_sat(param0.sd, param1.sd),\n"
"                  sub_sat(param0.se, param1.se), sub_sat(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//shortn upsample (charn hi, ucharn lo)\n"
"\n"
"INLINE_OVERLOADABLE short2 upsample (char2 param0, uchar2 param1)\n"
"{return (short2)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 upsample (char3 param0, uchar3 param1)\n"
"{return (short3)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                 upsample(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 upsample (char4 param0, uchar4 param1)\n"
"{return (short4)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                 upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 upsample (char8 param0, uchar8 param1)\n"
"{return (short8)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                 upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                 upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                 upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 upsample (char16 param0, uchar16 param1)\n"
"{return (short16)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                  upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                  upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                  upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7),\n"
"                  upsample(param0.s8, param1.s8), upsample(param0.s9, param1.s9),\n"
"                  upsample(param0.sa, param1.sa), upsample(param0.sb, param1.sb),\n"
"                  upsample(param0.sc, param1.sc), upsample(param0.sd, param1.sd),\n"
"                  upsample(param0.se, param1.se), upsample(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//ushortn upsample (ucharn hi, ucharn lo)\n"
"\n"
"INLINE_OVERLOADABLE ushort2 upsample (uchar2 param0, uchar2 param1)\n"
"{return (ushort2)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 upsample (uchar3 param0, uchar3 param1)\n"
"{return (ushort3)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                  upsample(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 upsample (uchar4 param0, uchar4 param1)\n"
"{return (ushort4)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                  upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 upsample (uchar8 param0, uchar8 param1)\n"
"{return (ushort8)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                  upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                  upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                  upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 upsample (uchar16 param0, uchar16 param1)\n"
"{return (ushort16)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                   upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                   upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                   upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7),\n"
"                   upsample(param0.s8, param1.s8), upsample(param0.s9, param1.s9),\n"
"                   upsample(param0.sa, param1.sa), upsample(param0.sb, param1.sb),\n"
"                   upsample(param0.sc, param1.sc), upsample(param0.sd, param1.sd),\n"
"                   upsample(param0.se, param1.se), upsample(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//intn upsample (shortn hi, ushortn lo)\n"
"\n"
"INLINE_OVERLOADABLE int2 upsample (short2 param0, ushort2 param1)\n"
"{return (int2)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 upsample (short3 param0, ushort3 param1)\n"
"{return (int3)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"               upsample(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 upsample (short4 param0, ushort4 param1)\n"
"{return (int4)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"               upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 upsample (short8 param0, ushort8 param1)\n"
"{return (int8)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"               upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"               upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"               upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 upsample (short16 param0, ushort16 param1)\n"
"{return (int16)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7),\n"
"                upsample(param0.s8, param1.s8), upsample(param0.s9, param1.s9),\n"
"                upsample(param0.sa, param1.sa), upsample(param0.sb, param1.sb),\n"
"                upsample(param0.sc, param1.sc), upsample(param0.sd, param1.sd),\n"
"                upsample(param0.se, param1.se), upsample(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//uintn upsample (ushortn hi, ushortn lo)\n"
"\n"
"INLINE_OVERLOADABLE uint2 upsample (ushort2 param0, ushort2 param1)\n"
"{return (uint2)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 upsample (ushort3 param0, ushort3 param1)\n"
"{return (uint3)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                upsample(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 upsample (ushort4 param0, ushort4 param1)\n"
"{return (uint4)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 upsample (ushort8 param0, ushort8 param1)\n"
"{return (uint8)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 upsample (ushort16 param0, ushort16 param1)\n"
"{return (uint16)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                 upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                 upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                 upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7),\n"
"                 upsample(param0.s8, param1.s8), upsample(param0.s9, param1.s9),\n"
"                 upsample(param0.sa, param1.sa), upsample(param0.sb, param1.sb),\n"
"                 upsample(param0.sc, param1.sc), upsample(param0.sd, param1.sd),\n"
"                 upsample(param0.se, param1.se), upsample(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn upsample (intn hi, uintn lo)\n"
"\n"
"INLINE_OVERLOADABLE long2 upsample (int2 param0, uint2 param1)\n"
"{return (long2)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 upsample (int3 param0, uint3 param1)\n"
"{return (long3)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                upsample(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 upsample (int4 param0, uint4 param1)\n"
"{return (long4)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 upsample (int8 param0, uint8 param1)\n"
"{return (long8)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 upsample (int16 param0, uint16 param1)\n"
"{return (long16)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                 upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                 upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                 upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7),\n"
"                 upsample(param0.s8, param1.s8), upsample(param0.s9, param1.s9),\n"
"                 upsample(param0.sa, param1.sa), upsample(param0.sb, param1.sb),\n"
"                 upsample(param0.sc, param1.sc), upsample(param0.sd, param1.sd),\n"
"                 upsample(param0.se, param1.se), upsample(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//ulongn upsample (uintn hi, uintn lo)\n"
"\n"
"INLINE_OVERLOADABLE ulong2 upsample (uint2 param0, uint2 param1)\n"
"{return (ulong2)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 upsample (uint3 param0, uint3 param1)\n"
"{return (ulong3)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                 upsample(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 upsample (uint4 param0, uint4 param1)\n"
"{return (ulong4)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                 upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 upsample (uint8 param0, uint8 param1)\n"
"{return (ulong8)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                 upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                 upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                 upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 upsample (uint16 param0, uint16 param1)\n"
"{return (ulong16)(upsample(param0.s0, param1.s0), upsample(param0.s1, param1.s1),\n"
"                  upsample(param0.s2, param1.s2), upsample(param0.s3, param1.s3),\n"
"                  upsample(param0.s4, param1.s4), upsample(param0.s5, param1.s5),\n"
"                  upsample(param0.s6, param1.s6), upsample(param0.s7, param1.s7),\n"
"                  upsample(param0.s8, param1.s8), upsample(param0.s9, param1.s9),\n"
"                  upsample(param0.sa, param1.sa), upsample(param0.sb, param1.sb),\n"
"                  upsample(param0.sc, param1.sc), upsample(param0.sd, param1.sd),\n"
"                  upsample(param0.se, param1.se), upsample(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//fast_integer builtin functions\n"
"//gentype mad24 (gentype x, gentype y, gentype z)\n"
"\n"
"INLINE_OVERLOADABLE uint2 mad24 (uint2 param0, uint2 param1, uint2 param2)\n"
"{return (uint2)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 mad24 (uint3 param0, uint3 param1, uint3 param2)\n"
"{return (uint3)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1),\n"
"                mad24(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 mad24 (uint4 param0, uint4 param1, uint4 param2)\n"
"{return (uint4)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1),\n"
"                mad24(param0.s2, param1.s2, param2.s2), mad24(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 mad24 (uint8 param0, uint8 param1, uint8 param2)\n"
"{return (uint8)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1),\n"
"                mad24(param0.s2, param1.s2, param2.s2), mad24(param0.s3, param1.s3, param2.s3),\n"
"                mad24(param0.s4, param1.s4, param2.s4), mad24(param0.s5, param1.s5, param2.s5),\n"
"                mad24(param0.s6, param1.s6, param2.s6), mad24(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 mad24 (uint16 param0, uint16 param1, uint16 param2)\n"
"{return (uint16)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1),\n"
"                 mad24(param0.s2, param1.s2, param2.s2), mad24(param0.s3, param1.s3, param2.s3),\n"
"                 mad24(param0.s4, param1.s4, param2.s4), mad24(param0.s5, param1.s5, param2.s5),\n"
"                 mad24(param0.s6, param1.s6, param2.s6), mad24(param0.s7, param1.s7, param2.s7),\n"
"                 mad24(param0.s8, param1.s8, param2.s8), mad24(param0.s9, param1.s9, param2.s9),\n"
"                 mad24(param0.sa, param1.sa, param2.sa), mad24(param0.sb, param1.sb, param2.sb),\n"
"                 mad24(param0.sc, param1.sc, param2.sc), mad24(param0.sd, param1.sd, param2.sd),\n"
"                 mad24(param0.se, param1.se, param2.se), mad24(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 mad24 (int2 param0, int2 param1, int2 param2)\n"
"{return (int2)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 mad24 (int3 param0, int3 param1, int3 param2)\n"
"{return (int3)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1),\n"
"               mad24(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 mad24 (int4 param0, int4 param1, int4 param2)\n"
"{return (int4)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1),\n"
"               mad24(param0.s2, param1.s2, param2.s2), mad24(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 mad24 (int8 param0, int8 param1, int8 param2)\n"
"{return (int8)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1),\n"
"               mad24(param0.s2, param1.s2, param2.s2), mad24(param0.s3, param1.s3, param2.s3),\n"
"               mad24(param0.s4, param1.s4, param2.s4), mad24(param0.s5, param1.s5, param2.s5),\n"
"               mad24(param0.s6, param1.s6, param2.s6), mad24(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 mad24 (int16 param0, int16 param1, int16 param2)\n"
"{return (int16)(mad24(param0.s0, param1.s0, param2.s0), mad24(param0.s1, param1.s1, param2.s1),\n"
"                mad24(param0.s2, param1.s2, param2.s2), mad24(param0.s3, param1.s3, param2.s3),\n"
"                mad24(param0.s4, param1.s4, param2.s4), mad24(param0.s5, param1.s5, param2.s5),\n"
"                mad24(param0.s6, param1.s6, param2.s6), mad24(param0.s7, param1.s7, param2.s7),\n"
"                mad24(param0.s8, param1.s8, param2.s8), mad24(param0.s9, param1.s9, param2.s9),\n"
"                mad24(param0.sa, param1.sa, param2.sa), mad24(param0.sb, param1.sb, param2.sb),\n"
"                mad24(param0.sc, param1.sc, param2.sc), mad24(param0.sd, param1.sd, param2.sd),\n"
"                mad24(param0.se, param1.se, param2.se), mad24(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentype mul24 (gentype x, gentype y)\n"
"\n"
"INLINE_OVERLOADABLE uint2 mul24 (uint2 param0, uint2 param1)\n"
"{return (uint2)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 mul24 (uint3 param0, uint3 param1)\n"
"{return (uint3)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1),\n"
"                mul24(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 mul24 (uint4 param0, uint4 param1)\n"
"{return (uint4)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1),\n"
"                mul24(param0.s2, param1.s2), mul24(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 mul24 (uint8 param0, uint8 param1)\n"
"{return (uint8)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1),\n"
"                mul24(param0.s2, param1.s2), mul24(param0.s3, param1.s3),\n"
"                mul24(param0.s4, param1.s4), mul24(param0.s5, param1.s5),\n"
"                mul24(param0.s6, param1.s6), mul24(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 mul24 (uint16 param0, uint16 param1)\n"
"{return (uint16)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1),\n"
"                 mul24(param0.s2, param1.s2), mul24(param0.s3, param1.s3),\n"
"                 mul24(param0.s4, param1.s4), mul24(param0.s5, param1.s5),\n"
"                 mul24(param0.s6, param1.s6), mul24(param0.s7, param1.s7),\n"
"                 mul24(param0.s8, param1.s8), mul24(param0.s9, param1.s9),\n"
"                 mul24(param0.sa, param1.sa), mul24(param0.sb, param1.sb),\n"
"                 mul24(param0.sc, param1.sc), mul24(param0.sd, param1.sd),\n"
"                 mul24(param0.se, param1.se), mul24(param0.sf, param1.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 mul24 (int2 param0, int2 param1)\n"
"{return (int2)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 mul24 (int3 param0, int3 param1)\n"
"{return (int3)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1),\n"
"               mul24(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 mul24 (int4 param0, int4 param1)\n"
"{return (int4)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1),\n"
"               mul24(param0.s2, param1.s2), mul24(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 mul24 (int8 param0, int8 param1)\n"
"{return (int8)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1),\n"
"               mul24(param0.s2, param1.s2), mul24(param0.s3, param1.s3),\n"
"               mul24(param0.s4, param1.s4), mul24(param0.s5, param1.s5),\n"
"               mul24(param0.s6, param1.s6), mul24(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 mul24 (int16 param0, int16 param1)\n"
"{return (int16)(mul24(param0.s0, param1.s0), mul24(param0.s1, param1.s1),\n"
"                mul24(param0.s2, param1.s2), mul24(param0.s3, param1.s3),\n"
"                mul24(param0.s4, param1.s4), mul24(param0.s5, param1.s5),\n"
"                mul24(param0.s6, param1.s6), mul24(param0.s7, param1.s7),\n"
"                mul24(param0.s8, param1.s8), mul24(param0.s9, param1.s9),\n"
"                mul24(param0.sa, param1.sa), mul24(param0.sb, param1.sb),\n"
"                mul24(param0.sc, param1.sc), mul24(param0.sd, param1.sd),\n"
"                mul24(param0.se, param1.se), mul24(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//common builtin functions\n"
"//gentype clamp (gentype x, gentype minval, gentype maxval)\n"
"\n"
"INLINE_OVERLOADABLE float2 clamp (float2 param0, float2 param1, float2 param2)\n"
"{return (float2)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 clamp (float3 param0, float3 param1, float3 param2)\n"
"{return (float3)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 clamp (float4 param0, float4 param1, float4 param2)\n"
"{return (float4)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 clamp (float8 param0, float8 param1, float8 param2)\n"
"{return (float8)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                 clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                 clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                 clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 clamp (float16 param0, float16 param1, float16 param2)\n"
"{return (float16)(clamp(param0.s0, param1.s0, param2.s0), clamp(param0.s1, param1.s1, param2.s1),\n"
"                  clamp(param0.s2, param1.s2, param2.s2), clamp(param0.s3, param1.s3, param2.s3),\n"
"                  clamp(param0.s4, param1.s4, param2.s4), clamp(param0.s5, param1.s5, param2.s5),\n"
"                  clamp(param0.s6, param1.s6, param2.s6), clamp(param0.s7, param1.s7, param2.s7),\n"
"                  clamp(param0.s8, param1.s8, param2.s8), clamp(param0.s9, param1.s9, param2.s9),\n"
"                  clamp(param0.sa, param1.sa, param2.sa), clamp(param0.sb, param1.sb, param2.sb),\n"
"                  clamp(param0.sc, param1.sc, param2.sc), clamp(param0.sd, param1.sd, param2.sd),\n"
"                  clamp(param0.se, param1.se, param2.se), clamp(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentypef clamp (gentypef x, float minval, float maxval)\n"
"\n"
"INLINE_OVERLOADABLE float2 clamp (float2 param0, float param1, float param2)\n"
"{return (float2)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 clamp (float3 param0, float param1, float param2)\n"
"{return (float3)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 clamp (float4 param0, float param1, float param2)\n"
"{return (float4)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 clamp (float8 param0, float param1, float param2)\n"
"{return (float8)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                 clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                 clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                 clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 clamp (float16 param0, float param1, float param2)\n"
"{return (float16)(clamp(param0.s0, param1, param2), clamp(param0.s1, param1, param2),\n"
"                  clamp(param0.s2, param1, param2), clamp(param0.s3, param1, param2),\n"
"                  clamp(param0.s4, param1, param2), clamp(param0.s5, param1, param2),\n"
"                  clamp(param0.s6, param1, param2), clamp(param0.s7, param1, param2),\n"
"                  clamp(param0.s8, param1, param2), clamp(param0.s9, param1, param2),\n"
"                  clamp(param0.sa, param1, param2), clamp(param0.sb, param1, param2),\n"
"                  clamp(param0.sc, param1, param2), clamp(param0.sd, param1, param2),\n"
"                  clamp(param0.se, param1, param2), clamp(param0.sf, param1, param2)); }\n"
"\n"
"\n"
"//gentyped clamp (gentyped x, double minval, double maxval)\n"
"\n"
"\n"
"//gentype degrees (gentype radians)\n"
"\n"
"INLINE_OVERLOADABLE float2 degrees (float2 param0)\n"
"{return (float2)(degrees(param0.s0), degrees(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 degrees (float3 param0)\n"
"{return (float3)(degrees(param0.s0), degrees(param0.s1),\n"
"                 degrees(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 degrees (float4 param0)\n"
"{return (float4)(degrees(param0.s0), degrees(param0.s1),\n"
"                 degrees(param0.s2), degrees(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 degrees (float8 param0)\n"
"{return (float8)(degrees(param0.s0), degrees(param0.s1),\n"
"                 degrees(param0.s2), degrees(param0.s3),\n"
"                 degrees(param0.s4), degrees(param0.s5),\n"
"                 degrees(param0.s6), degrees(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 degrees (float16 param0)\n"
"{return (float16)(degrees(param0.s0), degrees(param0.s1),\n"
"                  degrees(param0.s2), degrees(param0.s3),\n"
"                  degrees(param0.s4), degrees(param0.s5),\n"
"                  degrees(param0.s6), degrees(param0.s7),\n"
"                  degrees(param0.s8), degrees(param0.s9),\n"
"                  degrees(param0.sa), degrees(param0.sb),\n"
"                  degrees(param0.sc), degrees(param0.sd),\n"
"                  degrees(param0.se), degrees(param0.sf)); }\n"
"\n"
"\n"
"//gentype max (gentype x,  gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 max (float2 param0, float2 param1)\n"
"{return (float2)(max(param0.s0, param1.s0), max(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 max (float3 param0, float3 param1)\n"
"{return (float3)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 max (float4 param0, float4 param1)\n"
"{return (float4)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 max (float8 param0, float8 param1)\n"
"{return (float8)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                 max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                 max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                 max(param0.s6, param1.s6), max(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 max (float16 param0, float16 param1)\n"
"{return (float16)(max(param0.s0, param1.s0), max(param0.s1, param1.s1),\n"
"                  max(param0.s2, param1.s2), max(param0.s3, param1.s3),\n"
"                  max(param0.s4, param1.s4), max(param0.s5, param1.s5),\n"
"                  max(param0.s6, param1.s6), max(param0.s7, param1.s7),\n"
"                  max(param0.s8, param1.s8), max(param0.s9, param1.s9),\n"
"                  max(param0.sa, param1.sa), max(param0.sb, param1.sb),\n"
"                  max(param0.sc, param1.sc), max(param0.sd, param1.sd),\n"
"                  max(param0.se, param1.se), max(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentypef max (gentypef x, float y)\n"
"\n"
"INLINE_OVERLOADABLE float2 max (float2 param0, float param1)\n"
"{return (float2)(max(param0.s0, param1), max(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 max (float3 param0, float param1)\n"
"{return (float3)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 max (float4 param0, float param1)\n"
"{return (float4)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 max (float8 param0, float param1)\n"
"{return (float8)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                 max(param0.s2, param1), max(param0.s3, param1),\n"
"                 max(param0.s4, param1), max(param0.s5, param1),\n"
"                 max(param0.s6, param1), max(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 max (float16 param0, float param1)\n"
"{return (float16)(max(param0.s0, param1), max(param0.s1, param1),\n"
"                  max(param0.s2, param1), max(param0.s3, param1),\n"
"                  max(param0.s4, param1), max(param0.s5, param1),\n"
"                  max(param0.s6, param1), max(param0.s7, param1),\n"
"                  max(param0.s8, param1), max(param0.s9, param1),\n"
"                  max(param0.sa, param1), max(param0.sb, param1),\n"
"                  max(param0.sc, param1), max(param0.sd, param1),\n"
"                  max(param0.se, param1), max(param0.sf, param1)); }\n"
"\n"
"\n"
"//gentyped max (gentyped x, double y)\n"
"\n"
"\n"
"//gentype min (gentype x,  gentype y)\n"
"\n"
"INLINE_OVERLOADABLE float2 min (float2 param0, float2 param1)\n"
"{return (float2)(min(param0.s0, param1.s0), min(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 min (float3 param0, float3 param1)\n"
"{return (float3)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 min (float4 param0, float4 param1)\n"
"{return (float4)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 min (float8 param0, float8 param1)\n"
"{return (float8)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                 min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                 min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                 min(param0.s6, param1.s6), min(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 min (float16 param0, float16 param1)\n"
"{return (float16)(min(param0.s0, param1.s0), min(param0.s1, param1.s1),\n"
"                  min(param0.s2, param1.s2), min(param0.s3, param1.s3),\n"
"                  min(param0.s4, param1.s4), min(param0.s5, param1.s5),\n"
"                  min(param0.s6, param1.s6), min(param0.s7, param1.s7),\n"
"                  min(param0.s8, param1.s8), min(param0.s9, param1.s9),\n"
"                  min(param0.sa, param1.sa), min(param0.sb, param1.sb),\n"
"                  min(param0.sc, param1.sc), min(param0.sd, param1.sd),\n"
"                  min(param0.se, param1.se), min(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentypef min (gentypef x,  float y)\n"
"\n"
"INLINE_OVERLOADABLE float2 min (float2 param0, float param1)\n"
"{return (float2)(min(param0.s0, param1), min(param0.s1, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 min (float3 param0, float param1)\n"
"{return (float3)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 min (float4 param0, float param1)\n"
"{return (float4)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 min (float8 param0, float param1)\n"
"{return (float8)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                 min(param0.s2, param1), min(param0.s3, param1),\n"
"                 min(param0.s4, param1), min(param0.s5, param1),\n"
"                 min(param0.s6, param1), min(param0.s7, param1)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 min (float16 param0, float param1)\n"
"{return (float16)(min(param0.s0, param1), min(param0.s1, param1),\n"
"                  min(param0.s2, param1), min(param0.s3, param1),\n"
"                  min(param0.s4, param1), min(param0.s5, param1),\n"
"                  min(param0.s6, param1), min(param0.s7, param1),\n"
"                  min(param0.s8, param1), min(param0.s9, param1),\n"
"                  min(param0.sa, param1), min(param0.sb, param1),\n"
"                  min(param0.sc, param1), min(param0.sd, param1),\n"
"                  min(param0.se, param1), min(param0.sf, param1)); }\n"
"\n"
"\n"
"//gentyped min (gentyped x,  double y)\n"
"\n"
"\n"
"//gentype mix (gentype x, gentype y, gentype a)\n"
"\n"
"INLINE_OVERLOADABLE float2 mix (float2 param0, float2 param1, float2 param2)\n"
"{return (float2)(mix(param0.s0, param1.s0, param2.s0), mix(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 mix (float3 param0, float3 param1, float3 param2)\n"
"{return (float3)(mix(param0.s0, param1.s0, param2.s0), mix(param0.s1, param1.s1, param2.s1),\n"
"                 mix(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 mix (float4 param0, float4 param1, float4 param2)\n"
"{return (float4)(mix(param0.s0, param1.s0, param2.s0), mix(param0.s1, param1.s1, param2.s1),\n"
"                 mix(param0.s2, param1.s2, param2.s2), mix(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 mix (float8 param0, float8 param1, float8 param2)\n"
"{return (float8)(mix(param0.s0, param1.s0, param2.s0), mix(param0.s1, param1.s1, param2.s1),\n"
"                 mix(param0.s2, param1.s2, param2.s2), mix(param0.s3, param1.s3, param2.s3),\n"
"                 mix(param0.s4, param1.s4, param2.s4), mix(param0.s5, param1.s5, param2.s5),\n"
"                 mix(param0.s6, param1.s6, param2.s6), mix(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 mix (float16 param0, float16 param1, float16 param2)\n"
"{return (float16)(mix(param0.s0, param1.s0, param2.s0), mix(param0.s1, param1.s1, param2.s1),\n"
"                  mix(param0.s2, param1.s2, param2.s2), mix(param0.s3, param1.s3, param2.s3),\n"
"                  mix(param0.s4, param1.s4, param2.s4), mix(param0.s5, param1.s5, param2.s5),\n"
"                  mix(param0.s6, param1.s6, param2.s6), mix(param0.s7, param1.s7, param2.s7),\n"
"                  mix(param0.s8, param1.s8, param2.s8), mix(param0.s9, param1.s9, param2.s9),\n"
"                  mix(param0.sa, param1.sa, param2.sa), mix(param0.sb, param1.sb, param2.sb),\n"
"                  mix(param0.sc, param1.sc, param2.sc), mix(param0.sd, param1.sd, param2.sd),\n"
"                  mix(param0.se, param1.se, param2.se), mix(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentypef mix (gentypef x, gentypef y, float a)\n"
"\n"
"INLINE_OVERLOADABLE float2 mix (float2 param0, float2 param1, float param2)\n"
"{return (float2)(mix(param0.s0, param1.s0, param2), mix(param0.s1, param1.s1, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 mix (float3 param0, float3 param1, float param2)\n"
"{return (float3)(mix(param0.s0, param1.s0, param2), mix(param0.s1, param1.s1, param2),\n"
"                 mix(param0.s2, param1.s2, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 mix (float4 param0, float4 param1, float param2)\n"
"{return (float4)(mix(param0.s0, param1.s0, param2), mix(param0.s1, param1.s1, param2),\n"
"                 mix(param0.s2, param1.s2, param2), mix(param0.s3, param1.s3, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 mix (float8 param0, float8 param1, float param2)\n"
"{return (float8)(mix(param0.s0, param1.s0, param2), mix(param0.s1, param1.s1, param2),\n"
"                 mix(param0.s2, param1.s2, param2), mix(param0.s3, param1.s3, param2),\n"
"                 mix(param0.s4, param1.s4, param2), mix(param0.s5, param1.s5, param2),\n"
"                 mix(param0.s6, param1.s6, param2), mix(param0.s7, param1.s7, param2)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 mix (float16 param0, float16 param1, float param2)\n"
"{return (float16)(mix(param0.s0, param1.s0, param2), mix(param0.s1, param1.s1, param2),\n"
"                  mix(param0.s2, param1.s2, param2), mix(param0.s3, param1.s3, param2),\n"
"                  mix(param0.s4, param1.s4, param2), mix(param0.s5, param1.s5, param2),\n"
"                  mix(param0.s6, param1.s6, param2), mix(param0.s7, param1.s7, param2),\n"
"                  mix(param0.s8, param1.s8, param2), mix(param0.s9, param1.s9, param2),\n"
"                  mix(param0.sa, param1.sa, param2), mix(param0.sb, param1.sb, param2),\n"
"                  mix(param0.sc, param1.sc, param2), mix(param0.sd, param1.sd, param2),\n"
"                  mix(param0.se, param1.se, param2), mix(param0.sf, param1.sf, param2)); }\n"
"\n"
"\n"
"//gentyped mix (gentyped x, gentyped y, double a)\n"
"\n"
"\n"
"//gentype radians (gentype degrees)\n"
"\n"
"INLINE_OVERLOADABLE float2 radians (float2 param0)\n"
"{return (float2)(radians(param0.s0), radians(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 radians (float3 param0)\n"
"{return (float3)(radians(param0.s0), radians(param0.s1),\n"
"                 radians(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 radians (float4 param0)\n"
"{return (float4)(radians(param0.s0), radians(param0.s1),\n"
"                 radians(param0.s2), radians(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 radians (float8 param0)\n"
"{return (float8)(radians(param0.s0), radians(param0.s1),\n"
"                 radians(param0.s2), radians(param0.s3),\n"
"                 radians(param0.s4), radians(param0.s5),\n"
"                 radians(param0.s6), radians(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 radians (float16 param0)\n"
"{return (float16)(radians(param0.s0), radians(param0.s1),\n"
"                  radians(param0.s2), radians(param0.s3),\n"
"                  radians(param0.s4), radians(param0.s5),\n"
"                  radians(param0.s6), radians(param0.s7),\n"
"                  radians(param0.s8), radians(param0.s9),\n"
"                  radians(param0.sa), radians(param0.sb),\n"
"                  radians(param0.sc), radians(param0.sd),\n"
"                  radians(param0.se), radians(param0.sf)); }\n"
"\n"
"\n"
"//gentype step (gentype edge, gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 step (float2 param0, float2 param1)\n"
"{return (float2)(step(param0.s0, param1.s0), step(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 step (float3 param0, float3 param1)\n"
"{return (float3)(step(param0.s0, param1.s0), step(param0.s1, param1.s1),\n"
"                 step(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 step (float4 param0, float4 param1)\n"
"{return (float4)(step(param0.s0, param1.s0), step(param0.s1, param1.s1),\n"
"                 step(param0.s2, param1.s2), step(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 step (float8 param0, float8 param1)\n"
"{return (float8)(step(param0.s0, param1.s0), step(param0.s1, param1.s1),\n"
"                 step(param0.s2, param1.s2), step(param0.s3, param1.s3),\n"
"                 step(param0.s4, param1.s4), step(param0.s5, param1.s5),\n"
"                 step(param0.s6, param1.s6), step(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 step (float16 param0, float16 param1)\n"
"{return (float16)(step(param0.s0, param1.s0), step(param0.s1, param1.s1),\n"
"                  step(param0.s2, param1.s2), step(param0.s3, param1.s3),\n"
"                  step(param0.s4, param1.s4), step(param0.s5, param1.s5),\n"
"                  step(param0.s6, param1.s6), step(param0.s7, param1.s7),\n"
"                  step(param0.s8, param1.s8), step(param0.s9, param1.s9),\n"
"                  step(param0.sa, param1.sa), step(param0.sb, param1.sb),\n"
"                  step(param0.sc, param1.sc), step(param0.sd, param1.sd),\n"
"                  step(param0.se, param1.se), step(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//gentypef step (float edge, gentypef x)\n"
"\n"
"INLINE_OVERLOADABLE float2 step (float param0, float2 param1)\n"
"{return (float2)(step(param0, param1.s0), step(param0, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 step (float param0, float3 param1)\n"
"{return (float3)(step(param0, param1.s0), step(param0, param1.s1),\n"
"                 step(param0, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 step (float param0, float4 param1)\n"
"{return (float4)(step(param0, param1.s0), step(param0, param1.s1),\n"
"                 step(param0, param1.s2), step(param0, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 step (float param0, float8 param1)\n"
"{return (float8)(step(param0, param1.s0), step(param0, param1.s1),\n"
"                 step(param0, param1.s2), step(param0, param1.s3),\n"
"                 step(param0, param1.s4), step(param0, param1.s5),\n"
"                 step(param0, param1.s6), step(param0, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 step (float param0, float16 param1)\n"
"{return (float16)(step(param0, param1.s0), step(param0, param1.s1),\n"
"                  step(param0, param1.s2), step(param0, param1.s3),\n"
"                  step(param0, param1.s4), step(param0, param1.s5),\n"
"                  step(param0, param1.s6), step(param0, param1.s7),\n"
"                  step(param0, param1.s8), step(param0, param1.s9),\n"
"                  step(param0, param1.sa), step(param0, param1.sb),\n"
"                  step(param0, param1.sc), step(param0, param1.sd),\n"
"                  step(param0, param1.se), step(param0, param1.sf)); }\n"
"\n"
"\n"
"//gentyped step (double edge, gentyped x)\n"
"\n"
"\n"
"//gentype smoothstep (gentype edge0, gentype edge1, gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 smoothstep (float2 param0, float2 param1, float2 param2)\n"
"{return (float2)(smoothstep(param0.s0, param1.s0, param2.s0), smoothstep(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 smoothstep (float3 param0, float3 param1, float3 param2)\n"
"{return (float3)(smoothstep(param0.s0, param1.s0, param2.s0), smoothstep(param0.s1, param1.s1, param2.s1),\n"
"                 smoothstep(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 smoothstep (float4 param0, float4 param1, float4 param2)\n"
"{return (float4)(smoothstep(param0.s0, param1.s0, param2.s0), smoothstep(param0.s1, param1.s1, param2.s1),\n"
"                 smoothstep(param0.s2, param1.s2, param2.s2), smoothstep(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 smoothstep (float8 param0, float8 param1, float8 param2)\n"
"{return (float8)(smoothstep(param0.s0, param1.s0, param2.s0), smoothstep(param0.s1, param1.s1, param2.s1),\n"
"                 smoothstep(param0.s2, param1.s2, param2.s2), smoothstep(param0.s3, param1.s3, param2.s3),\n"
"                 smoothstep(param0.s4, param1.s4, param2.s4), smoothstep(param0.s5, param1.s5, param2.s5),\n"
"                 smoothstep(param0.s6, param1.s6, param2.s6), smoothstep(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 smoothstep (float16 param0, float16 param1, float16 param2)\n"
"{return (float16)(smoothstep(param0.s0, param1.s0, param2.s0), smoothstep(param0.s1, param1.s1, param2.s1),\n"
"                  smoothstep(param0.s2, param1.s2, param2.s2), smoothstep(param0.s3, param1.s3, param2.s3),\n"
"                  smoothstep(param0.s4, param1.s4, param2.s4), smoothstep(param0.s5, param1.s5, param2.s5),\n"
"                  smoothstep(param0.s6, param1.s6, param2.s6), smoothstep(param0.s7, param1.s7, param2.s7),\n"
"                  smoothstep(param0.s8, param1.s8, param2.s8), smoothstep(param0.s9, param1.s9, param2.s9),\n"
"                  smoothstep(param0.sa, param1.sa, param2.sa), smoothstep(param0.sb, param1.sb, param2.sb),\n"
"                  smoothstep(param0.sc, param1.sc, param2.sc), smoothstep(param0.sd, param1.sd, param2.sd),\n"
"                  smoothstep(param0.se, param1.se, param2.se), smoothstep(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentypef smoothstep (float edge0, float edge1, gentypef x)\n"
"\n"
"INLINE_OVERLOADABLE float2 smoothstep (float param0, float param1, float2 param2)\n"
"{return (float2)(smoothstep(param0, param1, param2.s0), smoothstep(param0, param1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 smoothstep (float param0, float param1, float3 param2)\n"
"{return (float3)(smoothstep(param0, param1, param2.s0), smoothstep(param0, param1, param2.s1),\n"
"                 smoothstep(param0, param1, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 smoothstep (float param0, float param1, float4 param2)\n"
"{return (float4)(smoothstep(param0, param1, param2.s0), smoothstep(param0, param1, param2.s1),\n"
"                 smoothstep(param0, param1, param2.s2), smoothstep(param0, param1, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 smoothstep (float param0, float param1, float8 param2)\n"
"{return (float8)(smoothstep(param0, param1, param2.s0), smoothstep(param0, param1, param2.s1),\n"
"                 smoothstep(param0, param1, param2.s2), smoothstep(param0, param1, param2.s3),\n"
"                 smoothstep(param0, param1, param2.s4), smoothstep(param0, param1, param2.s5),\n"
"                 smoothstep(param0, param1, param2.s6), smoothstep(param0, param1, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 smoothstep (float param0, float param1, float16 param2)\n"
"{return (float16)(smoothstep(param0, param1, param2.s0), smoothstep(param0, param1, param2.s1),\n"
"                  smoothstep(param0, param1, param2.s2), smoothstep(param0, param1, param2.s3),\n"
"                  smoothstep(param0, param1, param2.s4), smoothstep(param0, param1, param2.s5),\n"
"                  smoothstep(param0, param1, param2.s6), smoothstep(param0, param1, param2.s7),\n"
"                  smoothstep(param0, param1, param2.s8), smoothstep(param0, param1, param2.s9),\n"
"                  smoothstep(param0, param1, param2.sa), smoothstep(param0, param1, param2.sb),\n"
"                  smoothstep(param0, param1, param2.sc), smoothstep(param0, param1, param2.sd),\n"
"                  smoothstep(param0, param1, param2.se), smoothstep(param0, param1, param2.sf)); }\n"
"\n"
"\n"
"//gentyped smoothstep (double edge0, double edge1, gentyped x)\n"
"\n"
"\n"
"//gentype sign (gentype x)\n"
"\n"
"INLINE_OVERLOADABLE float2 sign (float2 param0)\n"
"{return (float2)(sign(param0.s0), sign(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 sign (float3 param0)\n"
"{return (float3)(sign(param0.s0), sign(param0.s1),\n"
"                 sign(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 sign (float4 param0)\n"
"{return (float4)(sign(param0.s0), sign(param0.s1),\n"
"                 sign(param0.s2), sign(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 sign (float8 param0)\n"
"{return (float8)(sign(param0.s0), sign(param0.s1),\n"
"                 sign(param0.s2), sign(param0.s3),\n"
"                 sign(param0.s4), sign(param0.s5),\n"
"                 sign(param0.s6), sign(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 sign (float16 param0)\n"
"{return (float16)(sign(param0.s0), sign(param0.s1),\n"
"                  sign(param0.s2), sign(param0.s3),\n"
"                  sign(param0.s4), sign(param0.s5),\n"
"                  sign(param0.s6), sign(param0.s7),\n"
"                  sign(param0.s8), sign(param0.s9),\n"
"                  sign(param0.sa), sign(param0.sb),\n"
"                  sign(param0.sc), sign(param0.sd),\n"
"                  sign(param0.se), sign(param0.sf)); }\n"
"\n"
"\n"
"//relational builtin functions\n"
"//intn isequal (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 isequal (float2 param0, float2 param1)\n"
"{return (int2)(-isequal(param0.s0, param1.s0), -isequal(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isequal (float3 param0, float3 param1)\n"
"{return (int3)(-isequal(param0.s0, param1.s0), -isequal(param0.s1, param1.s1),\n"
"               -isequal(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isequal (float4 param0, float4 param1)\n"
"{return (int4)(-isequal(param0.s0, param1.s0), -isequal(param0.s1, param1.s1),\n"
"               -isequal(param0.s2, param1.s2), -isequal(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isequal (float8 param0, float8 param1)\n"
"{return (int8)(-isequal(param0.s0, param1.s0), -isequal(param0.s1, param1.s1),\n"
"               -isequal(param0.s2, param1.s2), -isequal(param0.s3, param1.s3),\n"
"               -isequal(param0.s4, param1.s4), -isequal(param0.s5, param1.s5),\n"
"               -isequal(param0.s6, param1.s6), -isequal(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isequal (float16 param0, float16 param1)\n"
"{return (int16)(-isequal(param0.s0, param1.s0), -isequal(param0.s1, param1.s1),\n"
"                -isequal(param0.s2, param1.s2), -isequal(param0.s3, param1.s3),\n"
"                -isequal(param0.s4, param1.s4), -isequal(param0.s5, param1.s5),\n"
"                -isequal(param0.s6, param1.s6), -isequal(param0.s7, param1.s7),\n"
"                -isequal(param0.s8, param1.s8), -isequal(param0.s9, param1.s9),\n"
"                -isequal(param0.sa, param1.sa), -isequal(param0.sb, param1.sb),\n"
"                -isequal(param0.sc, param1.sc), -isequal(param0.sd, param1.sd),\n"
"                -isequal(param0.se, param1.se), -isequal(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn isequal (doublen x, doublen y)\n"
"\n"
"\n"
"//intn isnotequal (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 isnotequal (float2 param0, float2 param1)\n"
"{return (int2)(-isnotequal(param0.s0, param1.s0), -isnotequal(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isnotequal (float3 param0, float3 param1)\n"
"{return (int3)(-isnotequal(param0.s0, param1.s0), -isnotequal(param0.s1, param1.s1),\n"
"               -isnotequal(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isnotequal (float4 param0, float4 param1)\n"
"{return (int4)(-isnotequal(param0.s0, param1.s0), -isnotequal(param0.s1, param1.s1),\n"
"               -isnotequal(param0.s2, param1.s2), -isnotequal(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isnotequal (float8 param0, float8 param1)\n"
"{return (int8)(-isnotequal(param0.s0, param1.s0), -isnotequal(param0.s1, param1.s1),\n"
"               -isnotequal(param0.s2, param1.s2), -isnotequal(param0.s3, param1.s3),\n"
"               -isnotequal(param0.s4, param1.s4), -isnotequal(param0.s5, param1.s5),\n"
"               -isnotequal(param0.s6, param1.s6), -isnotequal(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isnotequal (float16 param0, float16 param1)\n"
"{return (int16)(-isnotequal(param0.s0, param1.s0), -isnotequal(param0.s1, param1.s1),\n"
"                -isnotequal(param0.s2, param1.s2), -isnotequal(param0.s3, param1.s3),\n"
"                -isnotequal(param0.s4, param1.s4), -isnotequal(param0.s5, param1.s5),\n"
"                -isnotequal(param0.s6, param1.s6), -isnotequal(param0.s7, param1.s7),\n"
"                -isnotequal(param0.s8, param1.s8), -isnotequal(param0.s9, param1.s9),\n"
"                -isnotequal(param0.sa, param1.sa), -isnotequal(param0.sb, param1.sb),\n"
"                -isnotequal(param0.sc, param1.sc), -isnotequal(param0.sd, param1.sd),\n"
"                -isnotequal(param0.se, param1.se), -isnotequal(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn isnotequal (doublen x, doublen y)\n"
"\n"
"\n"
"//intn isgreater (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 isgreater (float2 param0, float2 param1)\n"
"{return (int2)(-isgreater(param0.s0, param1.s0), -isgreater(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isgreater (float3 param0, float3 param1)\n"
"{return (int3)(-isgreater(param0.s0, param1.s0), -isgreater(param0.s1, param1.s1),\n"
"               -isgreater(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isgreater (float4 param0, float4 param1)\n"
"{return (int4)(-isgreater(param0.s0, param1.s0), -isgreater(param0.s1, param1.s1),\n"
"               -isgreater(param0.s2, param1.s2), -isgreater(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isgreater (float8 param0, float8 param1)\n"
"{return (int8)(-isgreater(param0.s0, param1.s0), -isgreater(param0.s1, param1.s1),\n"
"               -isgreater(param0.s2, param1.s2), -isgreater(param0.s3, param1.s3),\n"
"               -isgreater(param0.s4, param1.s4), -isgreater(param0.s5, param1.s5),\n"
"               -isgreater(param0.s6, param1.s6), -isgreater(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isgreater (float16 param0, float16 param1)\n"
"{return (int16)(-isgreater(param0.s0, param1.s0), -isgreater(param0.s1, param1.s1),\n"
"                -isgreater(param0.s2, param1.s2), -isgreater(param0.s3, param1.s3),\n"
"                -isgreater(param0.s4, param1.s4), -isgreater(param0.s5, param1.s5),\n"
"                -isgreater(param0.s6, param1.s6), -isgreater(param0.s7, param1.s7),\n"
"                -isgreater(param0.s8, param1.s8), -isgreater(param0.s9, param1.s9),\n"
"                -isgreater(param0.sa, param1.sa), -isgreater(param0.sb, param1.sb),\n"
"                -isgreater(param0.sc, param1.sc), -isgreater(param0.sd, param1.sd),\n"
"                -isgreater(param0.se, param1.se), -isgreater(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn isgreater (doublen x, doublen y)\n"
"\n"
"\n"
"//intn isgreaterequal (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 isgreaterequal (float2 param0, float2 param1)\n"
"{return (int2)(-isgreaterequal(param0.s0, param1.s0), -isgreaterequal(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isgreaterequal (float3 param0, float3 param1)\n"
"{return (int3)(-isgreaterequal(param0.s0, param1.s0), -isgreaterequal(param0.s1, param1.s1),\n"
"               -isgreaterequal(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isgreaterequal (float4 param0, float4 param1)\n"
"{return (int4)(-isgreaterequal(param0.s0, param1.s0), -isgreaterequal(param0.s1, param1.s1),\n"
"               -isgreaterequal(param0.s2, param1.s2), -isgreaterequal(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isgreaterequal (float8 param0, float8 param1)\n"
"{return (int8)(-isgreaterequal(param0.s0, param1.s0), -isgreaterequal(param0.s1, param1.s1),\n"
"               -isgreaterequal(param0.s2, param1.s2), -isgreaterequal(param0.s3, param1.s3),\n"
"               -isgreaterequal(param0.s4, param1.s4), -isgreaterequal(param0.s5, param1.s5),\n"
"               -isgreaterequal(param0.s6, param1.s6), -isgreaterequal(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isgreaterequal (float16 param0, float16 param1)\n"
"{return (int16)(-isgreaterequal(param0.s0, param1.s0), -isgreaterequal(param0.s1, param1.s1),\n"
"                -isgreaterequal(param0.s2, param1.s2), -isgreaterequal(param0.s3, param1.s3),\n"
"                -isgreaterequal(param0.s4, param1.s4), -isgreaterequal(param0.s5, param1.s5),\n"
"                -isgreaterequal(param0.s6, param1.s6), -isgreaterequal(param0.s7, param1.s7),\n"
"                -isgreaterequal(param0.s8, param1.s8), -isgreaterequal(param0.s9, param1.s9),\n"
"                -isgreaterequal(param0.sa, param1.sa), -isgreaterequal(param0.sb, param1.sb),\n"
"                -isgreaterequal(param0.sc, param1.sc), -isgreaterequal(param0.sd, param1.sd),\n"
"                -isgreaterequal(param0.se, param1.se), -isgreaterequal(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn isgreaterequal (doublen x, doublen y)\n"
"\n"
"\n"
"//intn isless (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 isless (float2 param0, float2 param1)\n"
"{return (int2)(-isless(param0.s0, param1.s0), -isless(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isless (float3 param0, float3 param1)\n"
"{return (int3)(-isless(param0.s0, param1.s0), -isless(param0.s1, param1.s1),\n"
"               -isless(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isless (float4 param0, float4 param1)\n"
"{return (int4)(-isless(param0.s0, param1.s0), -isless(param0.s1, param1.s1),\n"
"               -isless(param0.s2, param1.s2), -isless(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isless (float8 param0, float8 param1)\n"
"{return (int8)(-isless(param0.s0, param1.s0), -isless(param0.s1, param1.s1),\n"
"               -isless(param0.s2, param1.s2), -isless(param0.s3, param1.s3),\n"
"               -isless(param0.s4, param1.s4), -isless(param0.s5, param1.s5),\n"
"               -isless(param0.s6, param1.s6), -isless(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isless (float16 param0, float16 param1)\n"
"{return (int16)(-isless(param0.s0, param1.s0), -isless(param0.s1, param1.s1),\n"
"                -isless(param0.s2, param1.s2), -isless(param0.s3, param1.s3),\n"
"                -isless(param0.s4, param1.s4), -isless(param0.s5, param1.s5),\n"
"                -isless(param0.s6, param1.s6), -isless(param0.s7, param1.s7),\n"
"                -isless(param0.s8, param1.s8), -isless(param0.s9, param1.s9),\n"
"                -isless(param0.sa, param1.sa), -isless(param0.sb, param1.sb),\n"
"                -isless(param0.sc, param1.sc), -isless(param0.sd, param1.sd),\n"
"                -isless(param0.se, param1.se), -isless(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn isless (doublen x, doublen y)\n"
"\n"
"\n"
"//intn islessequal (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 islessequal (float2 param0, float2 param1)\n"
"{return (int2)(-islessequal(param0.s0, param1.s0), -islessequal(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 islessequal (float3 param0, float3 param1)\n"
"{return (int3)(-islessequal(param0.s0, param1.s0), -islessequal(param0.s1, param1.s1),\n"
"               -islessequal(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 islessequal (float4 param0, float4 param1)\n"
"{return (int4)(-islessequal(param0.s0, param1.s0), -islessequal(param0.s1, param1.s1),\n"
"               -islessequal(param0.s2, param1.s2), -islessequal(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 islessequal (float8 param0, float8 param1)\n"
"{return (int8)(-islessequal(param0.s0, param1.s0), -islessequal(param0.s1, param1.s1),\n"
"               -islessequal(param0.s2, param1.s2), -islessequal(param0.s3, param1.s3),\n"
"               -islessequal(param0.s4, param1.s4), -islessequal(param0.s5, param1.s5),\n"
"               -islessequal(param0.s6, param1.s6), -islessequal(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 islessequal (float16 param0, float16 param1)\n"
"{return (int16)(-islessequal(param0.s0, param1.s0), -islessequal(param0.s1, param1.s1),\n"
"                -islessequal(param0.s2, param1.s2), -islessequal(param0.s3, param1.s3),\n"
"                -islessequal(param0.s4, param1.s4), -islessequal(param0.s5, param1.s5),\n"
"                -islessequal(param0.s6, param1.s6), -islessequal(param0.s7, param1.s7),\n"
"                -islessequal(param0.s8, param1.s8), -islessequal(param0.s9, param1.s9),\n"
"                -islessequal(param0.sa, param1.sa), -islessequal(param0.sb, param1.sb),\n"
"                -islessequal(param0.sc, param1.sc), -islessequal(param0.sd, param1.sd),\n"
"                -islessequal(param0.se, param1.se), -islessequal(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn islessequal (doublen x, doublen y)\n"
"\n"
"\n"
"//intn islessgreater (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 islessgreater (float2 param0, float2 param1)\n"
"{return (int2)(-islessgreater(param0.s0, param1.s0), -islessgreater(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 islessgreater (float3 param0, float3 param1)\n"
"{return (int3)(-islessgreater(param0.s0, param1.s0), -islessgreater(param0.s1, param1.s1),\n"
"               -islessgreater(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 islessgreater (float4 param0, float4 param1)\n"
"{return (int4)(-islessgreater(param0.s0, param1.s0), -islessgreater(param0.s1, param1.s1),\n"
"               -islessgreater(param0.s2, param1.s2), -islessgreater(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 islessgreater (float8 param0, float8 param1)\n"
"{return (int8)(-islessgreater(param0.s0, param1.s0), -islessgreater(param0.s1, param1.s1),\n"
"               -islessgreater(param0.s2, param1.s2), -islessgreater(param0.s3, param1.s3),\n"
"               -islessgreater(param0.s4, param1.s4), -islessgreater(param0.s5, param1.s5),\n"
"               -islessgreater(param0.s6, param1.s6), -islessgreater(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 islessgreater (float16 param0, float16 param1)\n"
"{return (int16)(-islessgreater(param0.s0, param1.s0), -islessgreater(param0.s1, param1.s1),\n"
"                -islessgreater(param0.s2, param1.s2), -islessgreater(param0.s3, param1.s3),\n"
"                -islessgreater(param0.s4, param1.s4), -islessgreater(param0.s5, param1.s5),\n"
"                -islessgreater(param0.s6, param1.s6), -islessgreater(param0.s7, param1.s7),\n"
"                -islessgreater(param0.s8, param1.s8), -islessgreater(param0.s9, param1.s9),\n"
"                -islessgreater(param0.sa, param1.sa), -islessgreater(param0.sb, param1.sb),\n"
"                -islessgreater(param0.sc, param1.sc), -islessgreater(param0.sd, param1.sd),\n"
"                -islessgreater(param0.se, param1.se), -islessgreater(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn islessgreater (doublen x, doublen y)\n"
"\n"
"\n"
"//intn isfinite (floatn\n"
"\n"
"INLINE_OVERLOADABLE int2 isfinite (float2 param0)\n"
"{return (int2)(-isfinite(param0.s0), -isfinite(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isfinite (float3 param0)\n"
"{return (int3)(-isfinite(param0.s0), -isfinite(param0.s1),\n"
"               -isfinite(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isfinite (float4 param0)\n"
"{return (int4)(-isfinite(param0.s0), -isfinite(param0.s1),\n"
"               -isfinite(param0.s2), -isfinite(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isfinite (float8 param0)\n"
"{return (int8)(-isfinite(param0.s0), -isfinite(param0.s1),\n"
"               -isfinite(param0.s2), -isfinite(param0.s3),\n"
"               -isfinite(param0.s4), -isfinite(param0.s5),\n"
"               -isfinite(param0.s6), -isfinite(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isfinite (float16 param0)\n"
"{return (int16)(-isfinite(param0.s0), -isfinite(param0.s1),\n"
"                -isfinite(param0.s2), -isfinite(param0.s3),\n"
"                -isfinite(param0.s4), -isfinite(param0.s5),\n"
"                -isfinite(param0.s6), -isfinite(param0.s7),\n"
"                -isfinite(param0.s8), -isfinite(param0.s9),\n"
"                -isfinite(param0.sa), -isfinite(param0.sb),\n"
"                -isfinite(param0.sc), -isfinite(param0.sd),\n"
"                -isfinite(param0.se), -isfinite(param0.sf)); }\n"
"\n"
"\n"
"//longn isfinite (doublen)\n"
"\n"
"\n"
"//intn isinf (floatn)\n"
"\n"
"INLINE_OVERLOADABLE int2 isinf (float2 param0)\n"
"{return (int2)(-isinf(param0.s0), -isinf(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isinf (float3 param0)\n"
"{return (int3)(-isinf(param0.s0), -isinf(param0.s1),\n"
"               -isinf(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isinf (float4 param0)\n"
"{return (int4)(-isinf(param0.s0), -isinf(param0.s1),\n"
"               -isinf(param0.s2), -isinf(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isinf (float8 param0)\n"
"{return (int8)(-isinf(param0.s0), -isinf(param0.s1),\n"
"               -isinf(param0.s2), -isinf(param0.s3),\n"
"               -isinf(param0.s4), -isinf(param0.s5),\n"
"               -isinf(param0.s6), -isinf(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isinf (float16 param0)\n"
"{return (int16)(-isinf(param0.s0), -isinf(param0.s1),\n"
"                -isinf(param0.s2), -isinf(param0.s3),\n"
"                -isinf(param0.s4), -isinf(param0.s5),\n"
"                -isinf(param0.s6), -isinf(param0.s7),\n"
"                -isinf(param0.s8), -isinf(param0.s9),\n"
"                -isinf(param0.sa), -isinf(param0.sb),\n"
"                -isinf(param0.sc), -isinf(param0.sd),\n"
"                -isinf(param0.se), -isinf(param0.sf)); }\n"
"\n"
"\n"
"//longn isinf (doublen)\n"
"\n"
"\n"
"//intn isnan (floatn)\n"
"\n"
"INLINE_OVERLOADABLE int2 isnan (float2 param0)\n"
"{return (int2)(-isnan(param0.s0), -isnan(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isnan (float3 param0)\n"
"{return (int3)(-isnan(param0.s0), -isnan(param0.s1),\n"
"               -isnan(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isnan (float4 param0)\n"
"{return (int4)(-isnan(param0.s0), -isnan(param0.s1),\n"
"               -isnan(param0.s2), -isnan(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isnan (float8 param0)\n"
"{return (int8)(-isnan(param0.s0), -isnan(param0.s1),\n"
"               -isnan(param0.s2), -isnan(param0.s3),\n"
"               -isnan(param0.s4), -isnan(param0.s5),\n"
"               -isnan(param0.s6), -isnan(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isnan (float16 param0)\n"
"{return (int16)(-isnan(param0.s0), -isnan(param0.s1),\n"
"                -isnan(param0.s2), -isnan(param0.s3),\n"
"                -isnan(param0.s4), -isnan(param0.s5),\n"
"                -isnan(param0.s6), -isnan(param0.s7),\n"
"                -isnan(param0.s8), -isnan(param0.s9),\n"
"                -isnan(param0.sa), -isnan(param0.sb),\n"
"                -isnan(param0.sc), -isnan(param0.sd),\n"
"                -isnan(param0.se), -isnan(param0.sf)); }\n"
"\n"
"\n"
"//longn isnan (doublen)\n"
"\n"
"\n"
"//intn isnormal (floatn)\n"
"\n"
"INLINE_OVERLOADABLE int2 isnormal (float2 param0)\n"
"{return (int2)(-isnormal(param0.s0), -isnormal(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isnormal (float3 param0)\n"
"{return (int3)(-isnormal(param0.s0), -isnormal(param0.s1),\n"
"               -isnormal(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isnormal (float4 param0)\n"
"{return (int4)(-isnormal(param0.s0), -isnormal(param0.s1),\n"
"               -isnormal(param0.s2), -isnormal(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isnormal (float8 param0)\n"
"{return (int8)(-isnormal(param0.s0), -isnormal(param0.s1),\n"
"               -isnormal(param0.s2), -isnormal(param0.s3),\n"
"               -isnormal(param0.s4), -isnormal(param0.s5),\n"
"               -isnormal(param0.s6), -isnormal(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isnormal (float16 param0)\n"
"{return (int16)(-isnormal(param0.s0), -isnormal(param0.s1),\n"
"                -isnormal(param0.s2), -isnormal(param0.s3),\n"
"                -isnormal(param0.s4), -isnormal(param0.s5),\n"
"                -isnormal(param0.s6), -isnormal(param0.s7),\n"
"                -isnormal(param0.s8), -isnormal(param0.s9),\n"
"                -isnormal(param0.sa), -isnormal(param0.sb),\n"
"                -isnormal(param0.sc), -isnormal(param0.sd),\n"
"                -isnormal(param0.se), -isnormal(param0.sf)); }\n"
"\n"
"\n"
"//longn isnormal (doublen)\n"
"\n"
"\n"
"//intn isordered (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 isordered (float2 param0, float2 param1)\n"
"{return (int2)(-isordered(param0.s0, param1.s0), -isordered(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isordered (float3 param0, float3 param1)\n"
"{return (int3)(-isordered(param0.s0, param1.s0), -isordered(param0.s1, param1.s1),\n"
"               -isordered(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isordered (float4 param0, float4 param1)\n"
"{return (int4)(-isordered(param0.s0, param1.s0), -isordered(param0.s1, param1.s1),\n"
"               -isordered(param0.s2, param1.s2), -isordered(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isordered (float8 param0, float8 param1)\n"
"{return (int8)(-isordered(param0.s0, param1.s0), -isordered(param0.s1, param1.s1),\n"
"               -isordered(param0.s2, param1.s2), -isordered(param0.s3, param1.s3),\n"
"               -isordered(param0.s4, param1.s4), -isordered(param0.s5, param1.s5),\n"
"               -isordered(param0.s6, param1.s6), -isordered(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isordered (float16 param0, float16 param1)\n"
"{return (int16)(-isordered(param0.s0, param1.s0), -isordered(param0.s1, param1.s1),\n"
"                -isordered(param0.s2, param1.s2), -isordered(param0.s3, param1.s3),\n"
"                -isordered(param0.s4, param1.s4), -isordered(param0.s5, param1.s5),\n"
"                -isordered(param0.s6, param1.s6), -isordered(param0.s7, param1.s7),\n"
"                -isordered(param0.s8, param1.s8), -isordered(param0.s9, param1.s9),\n"
"                -isordered(param0.sa, param1.sa), -isordered(param0.sb, param1.sb),\n"
"                -isordered(param0.sc, param1.sc), -isordered(param0.sd, param1.sd),\n"
"                -isordered(param0.se, param1.se), -isordered(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn isordered (doublen x, doublen y)\n"
"\n"
"\n"
"//intn isunordered (floatn x, floatn y)\n"
"\n"
"INLINE_OVERLOADABLE int2 isunordered (float2 param0, float2 param1)\n"
"{return (int2)(-isunordered(param0.s0, param1.s0), -isunordered(param0.s1, param1.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 isunordered (float3 param0, float3 param1)\n"
"{return (int3)(-isunordered(param0.s0, param1.s0), -isunordered(param0.s1, param1.s1),\n"
"               -isunordered(param0.s2, param1.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 isunordered (float4 param0, float4 param1)\n"
"{return (int4)(-isunordered(param0.s0, param1.s0), -isunordered(param0.s1, param1.s1),\n"
"               -isunordered(param0.s2, param1.s2), -isunordered(param0.s3, param1.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 isunordered (float8 param0, float8 param1)\n"
"{return (int8)(-isunordered(param0.s0, param1.s0), -isunordered(param0.s1, param1.s1),\n"
"               -isunordered(param0.s2, param1.s2), -isunordered(param0.s3, param1.s3),\n"
"               -isunordered(param0.s4, param1.s4), -isunordered(param0.s5, param1.s5),\n"
"               -isunordered(param0.s6, param1.s6), -isunordered(param0.s7, param1.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 isunordered (float16 param0, float16 param1)\n"
"{return (int16)(-isunordered(param0.s0, param1.s0), -isunordered(param0.s1, param1.s1),\n"
"                -isunordered(param0.s2, param1.s2), -isunordered(param0.s3, param1.s3),\n"
"                -isunordered(param0.s4, param1.s4), -isunordered(param0.s5, param1.s5),\n"
"                -isunordered(param0.s6, param1.s6), -isunordered(param0.s7, param1.s7),\n"
"                -isunordered(param0.s8, param1.s8), -isunordered(param0.s9, param1.s9),\n"
"                -isunordered(param0.sa, param1.sa), -isunordered(param0.sb, param1.sb),\n"
"                -isunordered(param0.sc, param1.sc), -isunordered(param0.sd, param1.sd),\n"
"                -isunordered(param0.se, param1.se), -isunordered(param0.sf, param1.sf)); }\n"
"\n"
"\n"
"//longn isunordered (doublen x, doublen y)\n"
"\n"
"\n"
"//intn signbit (floatn)\n"
"\n"
"INLINE_OVERLOADABLE int2 signbit (float2 param0)\n"
"{return (int2)(-signbit(param0.s0), -signbit(param0.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 signbit (float3 param0)\n"
"{return (int3)(-signbit(param0.s0), -signbit(param0.s1),\n"
"               -signbit(param0.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 signbit (float4 param0)\n"
"{return (int4)(-signbit(param0.s0), -signbit(param0.s1),\n"
"               -signbit(param0.s2), -signbit(param0.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 signbit (float8 param0)\n"
"{return (int8)(-signbit(param0.s0), -signbit(param0.s1),\n"
"               -signbit(param0.s2), -signbit(param0.s3),\n"
"               -signbit(param0.s4), -signbit(param0.s5),\n"
"               -signbit(param0.s6), -signbit(param0.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 signbit (float16 param0)\n"
"{return (int16)(-signbit(param0.s0), -signbit(param0.s1),\n"
"                -signbit(param0.s2), -signbit(param0.s3),\n"
"                -signbit(param0.s4), -signbit(param0.s5),\n"
"                -signbit(param0.s6), -signbit(param0.s7),\n"
"                -signbit(param0.s8), -signbit(param0.s9),\n"
"                -signbit(param0.sa), -signbit(param0.sb),\n"
"                -signbit(param0.sc), -signbit(param0.sd),\n"
"                -signbit(param0.se), -signbit(param0.sf)); }\n"
"\n"
"\n"
"//longn signbit (doublen)\n"
"\n"
"\n"
"//int any (igentype x)\n"
"\n"
"\n"
"//int all (igentype x)\n"
"\n"
"\n"
"//gentype bitselect (gentype a, gentype b, gentype c)\n"
"\n"
"INLINE_OVERLOADABLE char2 bitselect (char2 param0, char2 param1, char2 param2)\n"
"{return (char2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE char3 bitselect (char3 param0, char3 param1, char3 param2)\n"
"{return (char3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE char4 bitselect (char4 param0, char4 param1, char4 param2)\n"
"{return (char4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE char8 bitselect (char8 param0, char8 param1, char8 param2)\n"
"{return (char8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE char16 bitselect (char16 param0, char16 param1, char16 param2)\n"
"{return (char16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                 bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                 bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                 bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                 bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                 bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                 bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE short2 bitselect (short2 param0, short2 param1, short2 param2)\n"
"{return (short2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE short3 bitselect (short3 param0, short3 param1, short3 param2)\n"
"{return (short3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE short4 bitselect (short4 param0, short4 param1, short4 param2)\n"
"{return (short4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE short8 bitselect (short8 param0, short8 param1, short8 param2)\n"
"{return (short8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                 bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                 bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE short16 bitselect (short16 param0, short16 param1, short16 param2)\n"
"{return (short16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                  bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                  bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                  bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                  bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                  bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                  bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                  bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE int2 bitselect (int2 param0, int2 param1, int2 param2)\n"
"{return (int2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE int3 bitselect (int3 param0, int3 param1, int3 param2)\n"
"{return (int3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"               bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE int4 bitselect (int4 param0, int4 param1, int4 param2)\n"
"{return (int4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"               bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE int8 bitselect (int8 param0, int8 param1, int8 param2)\n"
"{return (int8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"               bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"               bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"               bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE int16 bitselect (int16 param0, int16 param1, int16 param2)\n"
"{return (int16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE long2 bitselect (long2 param0, long2 param1, long2 param2)\n"
"{return (long2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE long3 bitselect (long3 param0, long3 param1, long3 param2)\n"
"{return (long3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE long4 bitselect (long4 param0, long4 param1, long4 param2)\n"
"{return (long4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE long8 bitselect (long8 param0, long8 param1, long8 param2)\n"
"{return (long8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE long16 bitselect (long16 param0, long16 param1, long16 param2)\n"
"{return (long16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                 bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                 bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                 bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                 bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                 bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                 bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 bitselect (uchar2 param0, uchar2 param1, uchar2 param2)\n"
"{return (uchar2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 bitselect (uchar3 param0, uchar3 param1, uchar3 param2)\n"
"{return (uchar3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 bitselect (uchar4 param0, uchar4 param1, uchar4 param2)\n"
"{return (uchar4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 bitselect (uchar8 param0, uchar8 param1, uchar8 param2)\n"
"{return (uchar8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                 bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                 bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 bitselect (uchar16 param0, uchar16 param1, uchar16 param2)\n"
"{return (uchar16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                  bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                  bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                  bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                  bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                  bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                  bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                  bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 bitselect (ushort2 param0, ushort2 param1, ushort2 param2)\n"
"{return (ushort2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 bitselect (ushort3 param0, ushort3 param1, ushort3 param2)\n"
"{return (ushort3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                  bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 bitselect (ushort4 param0, ushort4 param1, ushort4 param2)\n"
"{return (ushort4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                  bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 bitselect (ushort8 param0, ushort8 param1, ushort8 param2)\n"
"{return (ushort8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                  bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                  bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                  bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 bitselect (ushort16 param0, ushort16 param1, ushort16 param2)\n"
"{return (ushort16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                   bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                   bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                   bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                   bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                   bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                   bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                   bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 bitselect (uint2 param0, uint2 param1, uint2 param2)\n"
"{return (uint2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 bitselect (uint3 param0, uint3 param1, uint3 param2)\n"
"{return (uint3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 bitselect (uint4 param0, uint4 param1, uint4 param2)\n"
"{return (uint4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 bitselect (uint8 param0, uint8 param1, uint8 param2)\n"
"{return (uint8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 bitselect (uint16 param0, uint16 param1, uint16 param2)\n"
"{return (uint16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                 bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                 bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                 bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                 bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                 bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                 bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 bitselect (ulong2 param0, ulong2 param1, ulong2 param2)\n"
"{return (ulong2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 bitselect (ulong3 param0, ulong3 param1, ulong3 param2)\n"
"{return (ulong3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 bitselect (ulong4 param0, ulong4 param1, ulong4 param2)\n"
"{return (ulong4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 bitselect (ulong8 param0, ulong8 param1, ulong8 param2)\n"
"{return (ulong8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                 bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                 bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 bitselect (ulong16 param0, ulong16 param1, ulong16 param2)\n"
"{return (ulong16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                  bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                  bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                  bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                  bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                  bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                  bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                  bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"INLINE_OVERLOADABLE float2 bitselect (float2 param0, float2 param1, float2 param2)\n"
"{return (float2)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1)); }\n"
"\n"
"INLINE_OVERLOADABLE float3 bitselect (float3 param0, float3 param1, float3 param2)\n"
"{return (float3)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2)); }\n"
"\n"
"INLINE_OVERLOADABLE float4 bitselect (float4 param0, float4 param1, float4 param2)\n"
"{return (float4)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3)); }\n"
"\n"
"INLINE_OVERLOADABLE float8 bitselect (float8 param0, float8 param1, float8 param2)\n"
"{return (float8)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                 bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                 bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                 bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7)); }\n"
"\n"
"INLINE_OVERLOADABLE float16 bitselect (float16 param0, float16 param1, float16 param2)\n"
"{return (float16)(bitselect(param0.s0, param1.s0, param2.s0), bitselect(param0.s1, param1.s1, param2.s1),\n"
"                  bitselect(param0.s2, param1.s2, param2.s2), bitselect(param0.s3, param1.s3, param2.s3),\n"
"                  bitselect(param0.s4, param1.s4, param2.s4), bitselect(param0.s5, param1.s5, param2.s5),\n"
"                  bitselect(param0.s6, param1.s6, param2.s6), bitselect(param0.s7, param1.s7, param2.s7),\n"
"                  bitselect(param0.s8, param1.s8, param2.s8), bitselect(param0.s9, param1.s9, param2.s9),\n"
"                  bitselect(param0.sa, param1.sa, param2.sa), bitselect(param0.sb, param1.sb, param2.sb),\n"
"                  bitselect(param0.sc, param1.sc, param2.sc), bitselect(param0.sd, param1.sd, param2.sd),\n"
"                  bitselect(param0.se, param1.se, param2.se), bitselect(param0.sf, param1.sf, param2.sf)); }\n"
"\n"
"\n"
"//gentype select (gentype a, gentype b, igentype c)\n"
"\n"
"INLINE_OVERLOADABLE char2 select (char2 param0, char2 param1, char2 param2)\n"
"{return (char2)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE char3 select (char3 param0, char3 param1, char3 param2)\n"
"{return (char3)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (char)(param2.s2 & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE char4 select (char4 param0, char4 param1, char4 param2)\n"
"{return (char4)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (char)(param2.s2 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s3, param1.s3, (char)(param2.s3 & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE char8 select (char8 param0, char8 param1, char8 param2)\n"
"{return (char8)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (char)(param2.s2 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s3, param1.s3, (char)(param2.s3 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                select(param0.s4, param1.s4, (char)(param2.s4 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s5, param1.s5, (char)(param2.s5 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                select(param0.s6, param1.s6, (char)(param2.s6 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s7, param1.s7, (char)(param2.s7 & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE char16 select (char16 param0, char16 param1, char16 param2)\n"
"{return (char16)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (char)(param2.s2 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s3, param1.s3, (char)(param2.s3 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (char)(param2.s4 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s5, param1.s5, (char)(param2.s5 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (char)(param2.s6 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s7, param1.s7, (char)(param2.s7 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s8, param1.s8, (char)(param2.s8 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s9, param1.s9, (char)(param2.s9 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.sa, param1.sa, (char)(param2.sa & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.sb, param1.sb, (char)(param2.sb & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.sc, param1.sc, (char)(param2.sc & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.sd, param1.sd, (char)(param2.sd & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.se, param1.se, (char)(param2.se & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.sf, param1.sf, (char)(param2.sf & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short2 select (short2 param0, short2 param1, short2 param2)\n"
"{return (short2)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short3 select (short3 param0, short3 param1, short3 param2)\n"
"{return (short3)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (short)(param2.s2 & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short4 select (short4 param0, short4 param1, short4 param2)\n"
"{return (short4)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (short)(param2.s2 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s3, param1.s3, (short)(param2.s3 & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short8 select (short8 param0, short8 param1, short8 param2)\n"
"{return (short8)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (short)(param2.s2 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s3, param1.s3, (short)(param2.s3 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (short)(param2.s4 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s5, param1.s5, (short)(param2.s5 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (short)(param2.s6 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s7, param1.s7, (short)(param2.s7 & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short16 select (short16 param0, short16 param1, short16 param2)\n"
"{return (short16)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (short)(param2.s2 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s3, param1.s3, (short)(param2.s3 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (short)(param2.s4 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s5, param1.s5, (short)(param2.s5 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (short)(param2.s6 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s7, param1.s7, (short)(param2.s7 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s8, param1.s8, (short)(param2.s8 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s9, param1.s9, (short)(param2.s9 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.sa, param1.sa, (short)(param2.sa & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.sb, param1.sb, (short)(param2.sb & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.sc, param1.sc, (short)(param2.sc & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.sd, param1.sd, (short)(param2.sd & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.se, param1.se, (short)(param2.se & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.sf, param1.sf, (short)(param2.sf & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int2 select (int2 param0, int2 param1, int2 param2)\n"
"{return (int2)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int3 select (int3 param0, int3 param1, int3 param2)\n"
"{return (int3)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"               select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int4 select (int4 param0, int4 param1, int4 param2)\n"
"{return (int4)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"               select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int8 select (int8 param0, int8 param1, int8 param2)\n"
"{return (int8)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"               select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"               select(param0.s4, param1.s4, (int)(param2.s4 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s5, param1.s5, (int)(param2.s5 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"               select(param0.s6, param1.s6, (int)(param2.s6 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s7, param1.s7, (int)(param2.s7 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int16 select (int16 param0, int16 param1, int16 param2)\n"
"{return (int16)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s4, param1.s4, (int)(param2.s4 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s5, param1.s5, (int)(param2.s5 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s6, param1.s6, (int)(param2.s6 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s7, param1.s7, (int)(param2.s7 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s8, param1.s8, (int)(param2.s8 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s9, param1.s9, (int)(param2.s9 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.sa, param1.sa, (int)(param2.sa & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sb, param1.sb, (int)(param2.sb & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.sc, param1.sc, (int)(param2.sc & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sd, param1.sd, (int)(param2.sd & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.se, param1.se, (int)(param2.se & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sf, param1.sf, (int)(param2.sf & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long2 select (long2 param0, long2 param1, long2 param2)\n"
"{return (long2)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long3 select (long3 param0, long3 param1, long3 param2)\n"
"{return (long3)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (long)(param2.s2 & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long4 select (long4 param0, long4 param1, long4 param2)\n"
"{return (long4)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (long)(param2.s2 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s3, param1.s3, (long)(param2.s3 & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long8 select (long8 param0, long8 param1, long8 param2)\n"
"{return (long8)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (long)(param2.s2 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s3, param1.s3, (long)(param2.s3 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                select(param0.s4, param1.s4, (long)(param2.s4 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s5, param1.s5, (long)(param2.s5 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                select(param0.s6, param1.s6, (long)(param2.s6 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s7, param1.s7, (long)(param2.s7 & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long16 select (long16 param0, long16 param1, long16 param2)\n"
"{return (long16)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (long)(param2.s2 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s3, param1.s3, (long)(param2.s3 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (long)(param2.s4 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s5, param1.s5, (long)(param2.s5 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (long)(param2.s6 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s7, param1.s7, (long)(param2.s7 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s8, param1.s8, (long)(param2.s8 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s9, param1.s9, (long)(param2.s9 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.sa, param1.sa, (long)(param2.sa & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.sb, param1.sb, (long)(param2.sb & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.sc, param1.sc, (long)(param2.sc & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.sd, param1.sd, (long)(param2.sd & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.se, param1.se, (long)(param2.se & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.sf, param1.sf, (long)(param2.sf & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 select (uchar2 param0, uchar2 param1, char2 param2)\n"
"{return (uchar2)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 select (uchar3 param0, uchar3 param1, char3 param2)\n"
"{return (uchar3)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (char)(param2.s2 & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 select (uchar4 param0, uchar4 param1, char4 param2)\n"
"{return (uchar4)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (char)(param2.s2 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s3, param1.s3, (char)(param2.s3 & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 select (uchar8 param0, uchar8 param1, char8 param2)\n"
"{return (uchar8)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (char)(param2.s2 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s3, param1.s3, (char)(param2.s3 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (char)(param2.s4 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s5, param1.s5, (char)(param2.s5 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (char)(param2.s6 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s7, param1.s7, (char)(param2.s7 & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 select (uchar16 param0, uchar16 param1, char16 param2)\n"
"{return (uchar16)(select(param0.s0, param1.s0, (char)(param2.s0 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s1, param1.s1, (char)(param2.s1 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (char)(param2.s2 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s3, param1.s3, (char)(param2.s3 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (char)(param2.s4 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s5, param1.s5, (char)(param2.s5 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (char)(param2.s6 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s7, param1.s7, (char)(param2.s7 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                  select(param0.s8, param1.s8, (char)(param2.s8 & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.s9, param1.s9, (char)(param2.s9 & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                  select(param0.sa, param1.sa, (char)(param2.sa & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.sb, param1.sb, (char)(param2.sb & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                  select(param0.sc, param1.sc, (char)(param2.sc & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.sd, param1.sd, (char)(param2.sd & ((char)1 << (sizeof(char)*8 - 1)))),\n"
"                  select(param0.se, param1.se, (char)(param2.se & ((char)1 << (sizeof(char)*8 - 1)))), select(param0.sf, param1.sf, (char)(param2.sf & ((char)1 << (sizeof(char)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 select (ushort2 param0, ushort2 param1, short2 param2)\n"
"{return (ushort2)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 select (ushort3 param0, ushort3 param1, short3 param2)\n"
"{return (ushort3)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (short)(param2.s2 & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 select (ushort4 param0, ushort4 param1, short4 param2)\n"
"{return (ushort4)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (short)(param2.s2 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s3, param1.s3, (short)(param2.s3 & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 select (ushort8 param0, ushort8 param1, short8 param2)\n"
"{return (ushort8)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (short)(param2.s2 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s3, param1.s3, (short)(param2.s3 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (short)(param2.s4 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s5, param1.s5, (short)(param2.s5 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (short)(param2.s6 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s7, param1.s7, (short)(param2.s7 & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 select (ushort16 param0, ushort16 param1, short16 param2)\n"
"{return (ushort16)(select(param0.s0, param1.s0, (short)(param2.s0 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s1, param1.s1, (short)(param2.s1 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                   select(param0.s2, param1.s2, (short)(param2.s2 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s3, param1.s3, (short)(param2.s3 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                   select(param0.s4, param1.s4, (short)(param2.s4 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s5, param1.s5, (short)(param2.s5 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                   select(param0.s6, param1.s6, (short)(param2.s6 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s7, param1.s7, (short)(param2.s7 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                   select(param0.s8, param1.s8, (short)(param2.s8 & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.s9, param1.s9, (short)(param2.s9 & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                   select(param0.sa, param1.sa, (short)(param2.sa & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.sb, param1.sb, (short)(param2.sb & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                   select(param0.sc, param1.sc, (short)(param2.sc & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.sd, param1.sd, (short)(param2.sd & ((short)1 << (sizeof(short)*8 - 1)))),\n"
"                   select(param0.se, param1.se, (short)(param2.se & ((short)1 << (sizeof(short)*8 - 1)))), select(param0.sf, param1.sf, (short)(param2.sf & ((short)1 << (sizeof(short)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 select (uint2 param0, uint2 param1, int2 param2)\n"
"{return (uint2)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 select (uint3 param0, uint3 param1, int3 param2)\n"
"{return (uint3)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 select (uint4 param0, uint4 param1, int4 param2)\n"
"{return (uint4)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 select (uint8 param0, uint8 param1, int8 param2)\n"
"{return (uint8)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s4, param1.s4, (int)(param2.s4 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s5, param1.s5, (int)(param2.s5 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                select(param0.s6, param1.s6, (int)(param2.s6 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s7, param1.s7, (int)(param2.s7 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 select (uint16 param0, uint16 param1, int16 param2)\n"
"{return (uint16)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (int)(param2.s4 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s5, param1.s5, (int)(param2.s5 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (int)(param2.s6 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s7, param1.s7, (int)(param2.s7 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s8, param1.s8, (int)(param2.s8 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s9, param1.s9, (int)(param2.s9 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.sa, param1.sa, (int)(param2.sa & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sb, param1.sb, (int)(param2.sb & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.sc, param1.sc, (int)(param2.sc & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sd, param1.sd, (int)(param2.sd & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.se, param1.se, (int)(param2.se & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sf, param1.sf, (int)(param2.sf & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 select (ulong2 param0, ulong2 param1, long2 param2)\n"
"{return (ulong2)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 select (ulong3 param0, ulong3 param1, long3 param2)\n"
"{return (ulong3)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (long)(param2.s2 & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 select (ulong4 param0, ulong4 param1, long4 param2)\n"
"{return (ulong4)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (long)(param2.s2 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s3, param1.s3, (long)(param2.s3 & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 select (ulong8 param0, ulong8 param1, long8 param2)\n"
"{return (ulong8)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (long)(param2.s2 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s3, param1.s3, (long)(param2.s3 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (long)(param2.s4 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s5, param1.s5, (long)(param2.s5 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (long)(param2.s6 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s7, param1.s7, (long)(param2.s7 & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 select (ulong16 param0, ulong16 param1, long16 param2)\n"
"{return (ulong16)(select(param0.s0, param1.s0, (long)(param2.s0 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s1, param1.s1, (long)(param2.s1 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (long)(param2.s2 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s3, param1.s3, (long)(param2.s3 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (long)(param2.s4 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s5, param1.s5, (long)(param2.s5 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (long)(param2.s6 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s7, param1.s7, (long)(param2.s7 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                  select(param0.s8, param1.s8, (long)(param2.s8 & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.s9, param1.s9, (long)(param2.s9 & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                  select(param0.sa, param1.sa, (long)(param2.sa & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.sb, param1.sb, (long)(param2.sb & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                  select(param0.sc, param1.sc, (long)(param2.sc & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.sd, param1.sd, (long)(param2.sd & ((long)1 << (sizeof(long)*8 - 1)))),\n"
"                  select(param0.se, param1.se, (long)(param2.se & ((long)1 << (sizeof(long)*8 - 1)))), select(param0.sf, param1.sf, (long)(param2.sf & ((long)1 << (sizeof(long)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float2 select (float2 param0, float2 param1, int2 param2)\n"
"{return (float2)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float3 select (float3 param0, float3 param1, int3 param2)\n"
"{return (float3)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float4 select (float4 param0, float4 param1, int4 param2)\n"
"{return (float4)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float8 select (float8 param0, float8 param1, int8 param2)\n"
"{return (float8)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (int)(param2.s4 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s5, param1.s5, (int)(param2.s5 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (int)(param2.s6 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s7, param1.s7, (int)(param2.s7 & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float16 select (float16 param0, float16 param1, int16 param2)\n"
"{return (float16)(select(param0.s0, param1.s0, (int)(param2.s0 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s1, param1.s1, (int)(param2.s1 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (int)(param2.s2 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s3, param1.s3, (int)(param2.s3 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (int)(param2.s4 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s5, param1.s5, (int)(param2.s5 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (int)(param2.s6 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s7, param1.s7, (int)(param2.s7 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                  select(param0.s8, param1.s8, (int)(param2.s8 & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.s9, param1.s9, (int)(param2.s9 & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                  select(param0.sa, param1.sa, (int)(param2.sa & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sb, param1.sb, (int)(param2.sb & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                  select(param0.sc, param1.sc, (int)(param2.sc & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sd, param1.sd, (int)(param2.sd & ((int)1 << (sizeof(int)*8 - 1)))),\n"
"                  select(param0.se, param1.se, (int)(param2.se & ((int)1 << (sizeof(int)*8 - 1)))), select(param0.sf, param1.sf, (int)(param2.sf & ((int)1 << (sizeof(int)*8 - 1))))); }\n"
"\n"
"\n"
"//gentype select (gentype a, gentype b, ugentype c)\n"
"\n"
"INLINE_OVERLOADABLE char2 select (char2 param0, char2 param1, uchar2 param2)\n"
"{return (char2)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE char3 select (char3 param0, char3 param1, uchar3 param2)\n"
"{return (char3)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (uchar)(param2.s2 & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE char4 select (char4 param0, char4 param1, uchar4 param2)\n"
"{return (char4)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (uchar)(param2.s2 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s3, param1.s3, (uchar)(param2.s3 & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE char8 select (char8 param0, char8 param1, uchar8 param2)\n"
"{return (char8)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (uchar)(param2.s2 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s3, param1.s3, (uchar)(param2.s3 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                select(param0.s4, param1.s4, (uchar)(param2.s4 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s5, param1.s5, (uchar)(param2.s5 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                select(param0.s6, param1.s6, (uchar)(param2.s6 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s7, param1.s7, (uchar)(param2.s7 & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE char16 select (char16 param0, char16 param1, uchar16 param2)\n"
"{return (char16)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (uchar)(param2.s2 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s3, param1.s3, (uchar)(param2.s3 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (uchar)(param2.s4 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s5, param1.s5, (uchar)(param2.s5 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (uchar)(param2.s6 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s7, param1.s7, (uchar)(param2.s7 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s8, param1.s8, (uchar)(param2.s8 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s9, param1.s9, (uchar)(param2.s9 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.sa, param1.sa, (uchar)(param2.sa & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.sb, param1.sb, (uchar)(param2.sb & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.sc, param1.sc, (uchar)(param2.sc & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.sd, param1.sd, (uchar)(param2.sd & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.se, param1.se, (uchar)(param2.se & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.sf, param1.sf, (uchar)(param2.sf & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short2 select (short2 param0, short2 param1, ushort2 param2)\n"
"{return (short2)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short3 select (short3 param0, short3 param1, ushort3 param2)\n"
"{return (short3)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (ushort)(param2.s2 & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short4 select (short4 param0, short4 param1, ushort4 param2)\n"
"{return (short4)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (ushort)(param2.s2 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s3, param1.s3, (ushort)(param2.s3 & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short8 select (short8 param0, short8 param1, ushort8 param2)\n"
"{return (short8)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (ushort)(param2.s2 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s3, param1.s3, (ushort)(param2.s3 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (ushort)(param2.s4 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s5, param1.s5, (ushort)(param2.s5 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (ushort)(param2.s6 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s7, param1.s7, (ushort)(param2.s7 & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE short16 select (short16 param0, short16 param1, ushort16 param2)\n"
"{return (short16)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (ushort)(param2.s2 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s3, param1.s3, (ushort)(param2.s3 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (ushort)(param2.s4 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s5, param1.s5, (ushort)(param2.s5 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (ushort)(param2.s6 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s7, param1.s7, (ushort)(param2.s7 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s8, param1.s8, (ushort)(param2.s8 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s9, param1.s9, (ushort)(param2.s9 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.sa, param1.sa, (ushort)(param2.sa & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.sb, param1.sb, (ushort)(param2.sb & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.sc, param1.sc, (ushort)(param2.sc & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.sd, param1.sd, (ushort)(param2.sd & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.se, param1.se, (ushort)(param2.se & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.sf, param1.sf, (ushort)(param2.sf & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int2 select (int2 param0, int2 param1, uint2 param2)\n"
"{return (int2)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int3 select (int3 param0, int3 param1, uint3 param2)\n"
"{return (int3)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"               select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int4 select (int4 param0, int4 param1, uint4 param2)\n"
"{return (int4)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"               select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int8 select (int8 param0, int8 param1, uint8 param2)\n"
"{return (int8)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"               select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"               select(param0.s4, param1.s4, (uint)(param2.s4 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s5, param1.s5, (uint)(param2.s5 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"               select(param0.s6, param1.s6, (uint)(param2.s6 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s7, param1.s7, (uint)(param2.s7 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE int16 select (int16 param0, int16 param1, uint16 param2)\n"
"{return (int16)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s4, param1.s4, (uint)(param2.s4 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s5, param1.s5, (uint)(param2.s5 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s6, param1.s6, (uint)(param2.s6 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s7, param1.s7, (uint)(param2.s7 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s8, param1.s8, (uint)(param2.s8 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s9, param1.s9, (uint)(param2.s9 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.sa, param1.sa, (uint)(param2.sa & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sb, param1.sb, (uint)(param2.sb & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.sc, param1.sc, (uint)(param2.sc & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sd, param1.sd, (uint)(param2.sd & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.se, param1.se, (uint)(param2.se & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sf, param1.sf, (uint)(param2.sf & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long2 select (long2 param0, long2 param1, ulong2 param2)\n"
"{return (long2)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long3 select (long3 param0, long3 param1, ulong3 param2)\n"
"{return (long3)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (ulong)(param2.s2 & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long4 select (long4 param0, long4 param1, ulong4 param2)\n"
"{return (long4)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (ulong)(param2.s2 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s3, param1.s3, (ulong)(param2.s3 & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long8 select (long8 param0, long8 param1, ulong8 param2)\n"
"{return (long8)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (ulong)(param2.s2 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s3, param1.s3, (ulong)(param2.s3 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                select(param0.s4, param1.s4, (ulong)(param2.s4 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s5, param1.s5, (ulong)(param2.s5 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                select(param0.s6, param1.s6, (ulong)(param2.s6 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s7, param1.s7, (ulong)(param2.s7 & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE long16 select (long16 param0, long16 param1, ulong16 param2)\n"
"{return (long16)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (ulong)(param2.s2 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s3, param1.s3, (ulong)(param2.s3 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (ulong)(param2.s4 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s5, param1.s5, (ulong)(param2.s5 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (ulong)(param2.s6 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s7, param1.s7, (ulong)(param2.s7 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s8, param1.s8, (ulong)(param2.s8 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s9, param1.s9, (ulong)(param2.s9 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.sa, param1.sa, (ulong)(param2.sa & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.sb, param1.sb, (ulong)(param2.sb & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.sc, param1.sc, (ulong)(param2.sc & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.sd, param1.sd, (ulong)(param2.sd & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.se, param1.se, (ulong)(param2.se & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.sf, param1.sf, (ulong)(param2.sf & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar2 select (uchar2 param0, uchar2 param1, uchar2 param2)\n"
"{return (uchar2)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar3 select (uchar3 param0, uchar3 param1, uchar3 param2)\n"
"{return (uchar3)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (uchar)(param2.s2 & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar4 select (uchar4 param0, uchar4 param1, uchar4 param2)\n"
"{return (uchar4)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (uchar)(param2.s2 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s3, param1.s3, (uchar)(param2.s3 & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar8 select (uchar8 param0, uchar8 param1, uchar8 param2)\n"
"{return (uchar8)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (uchar)(param2.s2 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s3, param1.s3, (uchar)(param2.s3 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (uchar)(param2.s4 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s5, param1.s5, (uchar)(param2.s5 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (uchar)(param2.s6 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s7, param1.s7, (uchar)(param2.s7 & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uchar16 select (uchar16 param0, uchar16 param1, uchar16 param2)\n"
"{return (uchar16)(select(param0.s0, param1.s0, (uchar)(param2.s0 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s1, param1.s1, (uchar)(param2.s1 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (uchar)(param2.s2 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s3, param1.s3, (uchar)(param2.s3 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (uchar)(param2.s4 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s5, param1.s5, (uchar)(param2.s5 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (uchar)(param2.s6 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s7, param1.s7, (uchar)(param2.s7 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                  select(param0.s8, param1.s8, (uchar)(param2.s8 & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.s9, param1.s9, (uchar)(param2.s9 & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                  select(param0.sa, param1.sa, (uchar)(param2.sa & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.sb, param1.sb, (uchar)(param2.sb & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                  select(param0.sc, param1.sc, (uchar)(param2.sc & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.sd, param1.sd, (uchar)(param2.sd & ((uchar)1 << (sizeof(uchar)*8 - 1)))),\n"
"                  select(param0.se, param1.se, (uchar)(param2.se & ((uchar)1 << (sizeof(uchar)*8 - 1)))), select(param0.sf, param1.sf, (uchar)(param2.sf & ((uchar)1 << (sizeof(uchar)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort2 select (ushort2 param0, ushort2 param1, ushort2 param2)\n"
"{return (ushort2)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort3 select (ushort3 param0, ushort3 param1, ushort3 param2)\n"
"{return (ushort3)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (ushort)(param2.s2 & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort4 select (ushort4 param0, ushort4 param1, ushort4 param2)\n"
"{return (ushort4)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (ushort)(param2.s2 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s3, param1.s3, (ushort)(param2.s3 & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort8 select (ushort8 param0, ushort8 param1, ushort8 param2)\n"
"{return (ushort8)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (ushort)(param2.s2 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s3, param1.s3, (ushort)(param2.s3 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (ushort)(param2.s4 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s5, param1.s5, (ushort)(param2.s5 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (ushort)(param2.s6 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s7, param1.s7, (ushort)(param2.s7 & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ushort16 select (ushort16 param0, ushort16 param1, ushort16 param2)\n"
"{return (ushort16)(select(param0.s0, param1.s0, (ushort)(param2.s0 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s1, param1.s1, (ushort)(param2.s1 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                   select(param0.s2, param1.s2, (ushort)(param2.s2 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s3, param1.s3, (ushort)(param2.s3 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                   select(param0.s4, param1.s4, (ushort)(param2.s4 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s5, param1.s5, (ushort)(param2.s5 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                   select(param0.s6, param1.s6, (ushort)(param2.s6 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s7, param1.s7, (ushort)(param2.s7 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                   select(param0.s8, param1.s8, (ushort)(param2.s8 & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.s9, param1.s9, (ushort)(param2.s9 & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                   select(param0.sa, param1.sa, (ushort)(param2.sa & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.sb, param1.sb, (ushort)(param2.sb & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                   select(param0.sc, param1.sc, (ushort)(param2.sc & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.sd, param1.sd, (ushort)(param2.sd & ((ushort)1 << (sizeof(ushort)*8 - 1)))),\n"
"                   select(param0.se, param1.se, (ushort)(param2.se & ((ushort)1 << (sizeof(ushort)*8 - 1)))), select(param0.sf, param1.sf, (ushort)(param2.sf & ((ushort)1 << (sizeof(ushort)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint2 select (uint2 param0, uint2 param1, uint2 param2)\n"
"{return (uint2)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint3 select (uint3 param0, uint3 param1, uint3 param2)\n"
"{return (uint3)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint4 select (uint4 param0, uint4 param1, uint4 param2)\n"
"{return (uint4)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint8 select (uint8 param0, uint8 param1, uint8 param2)\n"
"{return (uint8)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s4, param1.s4, (uint)(param2.s4 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s5, param1.s5, (uint)(param2.s5 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                select(param0.s6, param1.s6, (uint)(param2.s6 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s7, param1.s7, (uint)(param2.s7 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE uint16 select (uint16 param0, uint16 param1, uint16 param2)\n"
"{return (uint16)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (uint)(param2.s4 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s5, param1.s5, (uint)(param2.s5 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (uint)(param2.s6 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s7, param1.s7, (uint)(param2.s7 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s8, param1.s8, (uint)(param2.s8 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s9, param1.s9, (uint)(param2.s9 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.sa, param1.sa, (uint)(param2.sa & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sb, param1.sb, (uint)(param2.sb & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.sc, param1.sc, (uint)(param2.sc & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sd, param1.sd, (uint)(param2.sd & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.se, param1.se, (uint)(param2.se & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sf, param1.sf, (uint)(param2.sf & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong2 select (ulong2 param0, ulong2 param1, ulong2 param2)\n"
"{return (ulong2)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong3 select (ulong3 param0, ulong3 param1, ulong3 param2)\n"
"{return (ulong3)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (ulong)(param2.s2 & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong4 select (ulong4 param0, ulong4 param1, ulong4 param2)\n"
"{return (ulong4)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (ulong)(param2.s2 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s3, param1.s3, (ulong)(param2.s3 & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong8 select (ulong8 param0, ulong8 param1, ulong8 param2)\n"
"{return (ulong8)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (ulong)(param2.s2 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s3, param1.s3, (ulong)(param2.s3 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (ulong)(param2.s4 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s5, param1.s5, (ulong)(param2.s5 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (ulong)(param2.s6 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s7, param1.s7, (ulong)(param2.s7 & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE ulong16 select (ulong16 param0, ulong16 param1, ulong16 param2)\n"
"{return (ulong16)(select(param0.s0, param1.s0, (ulong)(param2.s0 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s1, param1.s1, (ulong)(param2.s1 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (ulong)(param2.s2 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s3, param1.s3, (ulong)(param2.s3 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (ulong)(param2.s4 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s5, param1.s5, (ulong)(param2.s5 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (ulong)(param2.s6 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s7, param1.s7, (ulong)(param2.s7 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                  select(param0.s8, param1.s8, (ulong)(param2.s8 & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.s9, param1.s9, (ulong)(param2.s9 & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                  select(param0.sa, param1.sa, (ulong)(param2.sa & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.sb, param1.sb, (ulong)(param2.sb & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                  select(param0.sc, param1.sc, (ulong)(param2.sc & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.sd, param1.sd, (ulong)(param2.sd & ((ulong)1 << (sizeof(ulong)*8 - 1)))),\n"
"                  select(param0.se, param1.se, (ulong)(param2.se & ((ulong)1 << (sizeof(ulong)*8 - 1)))), select(param0.sf, param1.sf, (ulong)(param2.sf & ((ulong)1 << (sizeof(ulong)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float2 select (float2 param0, float2 param1, uint2 param2)\n"
"{return (float2)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float3 select (float3 param0, float3 param1, uint3 param2)\n"
"{return (float3)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float4 select (float4 param0, float4 param1, uint4 param2)\n"
"{return (float4)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float8 select (float8 param0, float8 param1, uint8 param2)\n"
"{return (float8)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s4, param1.s4, (uint)(param2.s4 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s5, param1.s5, (uint)(param2.s5 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                 select(param0.s6, param1.s6, (uint)(param2.s6 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s7, param1.s7, (uint)(param2.s7 & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"INLINE_OVERLOADABLE float16 select (float16 param0, float16 param1, uint16 param2)\n"
"{return (float16)(select(param0.s0, param1.s0, (uint)(param2.s0 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s1, param1.s1, (uint)(param2.s1 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                  select(param0.s2, param1.s2, (uint)(param2.s2 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s3, param1.s3, (uint)(param2.s3 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                  select(param0.s4, param1.s4, (uint)(param2.s4 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s5, param1.s5, (uint)(param2.s5 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                  select(param0.s6, param1.s6, (uint)(param2.s6 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s7, param1.s7, (uint)(param2.s7 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                  select(param0.s8, param1.s8, (uint)(param2.s8 & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.s9, param1.s9, (uint)(param2.s9 & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                  select(param0.sa, param1.sa, (uint)(param2.sa & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sb, param1.sb, (uint)(param2.sb & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                  select(param0.sc, param1.sc, (uint)(param2.sc & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sd, param1.sd, (uint)(param2.sd & ((uint)1 << (sizeof(uint)*8 - 1)))),\n"
"                  select(param0.se, param1.se, (uint)(param2.se & ((uint)1 << (sizeof(uint)*8 - 1)))), select(param0.sf, param1.sf, (uint)(param2.sf & ((uint)1 << (sizeof(uint)*8 - 1))))); }\n"
"\n"
"\n"
"// ##END_VECTOR##\n"
"\n"
"#undef INLINE_OVERLOADABLE\n"
"#undef PURE\n"
"#undef CONST\n"
"#undef OVERLOADABLE\n"
"#undef INLINE\n"
"\n"
"#endif /* __GEN_OCL_STDLIB_H__ */\n"
;
}

